/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ve=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/base/common/types","vs/base/common/errors","vs/nls","vs/nls!vs/server/node/server.main","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/base/common/strings","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/base/node/pfs","vs/base/common/uuid","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/base/common/map","vs/base/common/process","vs/platform/telemetry/common/telemetry","fs","os","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensions/common/extensions","vs/platform/userDataProfile/common/userDataProfile","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/base/parts/ipc/common/ipc","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/performance","vs/editor/common/core/range","vs/base/common/marshalling","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/iterator","vs/base/common/mime","vs/base/common/processes","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/platform/remote/common/remoteHosts","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/common/functional","vs/base/common/json","vs/base/common/glob","vs/base/common/uriIpc","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/decorators","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/themables","path","net","vs/editor/common/core/position","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/common/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","crypto","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminal","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/server/node/extensionHostConnection","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/node/extpath","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/loggerService","vs/platform/markers/common/markers","vs/platform/credentials/node/credentialsMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteAgentEnvironmentImpl","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/node/remoteExtensionHostAgentCli","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","https","http","yauzl","yazl","zlib","vs/server/node/server.main"],be=function(ae){for(var e=[],E=0,k=ae.length;E<k;E++)e[E]=ve[ae[E]];return e};define(ve[140],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class E{static get(){const l=new Map,I=new Map,C=new Map,P=new Map;function w(g,f){g.has(f.detail)||g.set(f.detail,-f.timestamp)}function y(g,f){const p=g.get(f.detail);!p||p>=0||g.set(f.detail,p+f.timestamp)}let T=[];typeof ae.getStats=="function"&&(T=ae.getStats().slice(0).sort((g,f)=>g.timestamp-f.timestamp));for(const g of T)switch(g.type){case 10:w(l,g);break;case 11:case 12:y(l,g);break;case 21:w(I,g);break;case 22:y(I,g);break;case 33:w(C,g);break;case 34:y(C,g);break;case 31:w(P,g);break;case 32:y(P,g);break}let S=0;C.forEach(g=>S+=g);function b(g){const f=[];return g.forEach((p,u)=>f.push([u,p])),f}return{amdLoad:b(l),amdInvoke:b(I),nodeRequire:b(C),nodeEval:b(P),nodeRequireTotal:S}}static toMarkdownTable(l,I){let C="";const P=[];return l.forEach((w,y)=>{P[y]=w.length}),I.forEach(w=>{w.forEach((y,T)=>{typeof y>"u"&&(y=w[T]="-");const S=y.toString().length;P[T]=Math.max(S,P[T])})}),l.forEach((w,y)=>{C+=`| ${w+" ".repeat(P[y]-w.toString().length)} `}),C+=`|
`,l.forEach((w,y)=>{C+=`| ${"-".repeat(P[y])} `}),C+=`|
`,I.forEach(w=>{w.forEach((y,T)=>{typeof y<"u"&&(C+=`| ${y+" ".repeat(P[T]-y.toString().length)} `)}),C+=`|
`}),C}}e.LoaderStats=E}),define(ve[85],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(C){return(P,w,y)=>{let T=null,S=null;if(typeof y.value=="function"?(T="value",S=y.value):typeof y.get=="function"&&(T="get",S=y.get),!S)throw new Error("not supported");y[T]=C(S,w)}}function k(C,P,w){let y=null,T=null;if(typeof w.value=="function"?(y="value",T=w.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(y="get",T=w.get),!T)throw new Error("not supported");const S=`$memoize$${P}`;w[y]=function(...b){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,b)}),this[S]}}e.memoize=k;function l(C,P,w){return E((y,T)=>{const S=`$debounce$${T}`,b=`$debounce$result$${T}`;return function(...g){this[b]||(this[b]=w?w():void 0),clearTimeout(this[S]),P&&(this[b]=P(this[b],...g),g=[this[b]]),this[S]=setTimeout(()=>{y.apply(this,g),this[b]=w?w():void 0},C)}})}e.debounce=l;function I(C,P,w){return E((y,T)=>{const S=`$throttle$timer$${T}`,b=`$throttle$result$${T}`,g=`$throttle$lastRun$${T}`,f=`$throttle$pending$${T}`;return function(...p){if(this[b]||(this[b]=w?w():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),P&&(this[b]=P(this[b],...p)),this[f])return;const u=this[g]+C;u<=Date.now()?(this[g]=Date.now(),y.apply(this,[this[b]]),this[b]=w?w():void 0):(this[f]=!0,this[S]=setTimeout(()=>{this[f]=!1,this[g]=Date.now(),y.apply(this,[this[b]]),this[b]=w?w():void 0},u-Date.now()))}})}e.throttle=I}),define(ve[9],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?D.isErrorNoTelemetry(r)?new D(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(n=>{n(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.ErrorHandler=E,e.errorHandler=new E;function k(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=k;function l(t){if(!t||typeof t!="object")return!1;const r=t;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function I(t){y(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=I;function C(t){y(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=C;function P(t){if(t instanceof Error){const{name:r,message:n}=t,i=t.stacktrace||t.stack;return{$isError:!0,name:r,message:n,stack:i,noTelemetry:D.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const w="Canceled";function y(t){return t instanceof T?!0:t instanceof Error&&t.name===w&&t.message===w}e.isCancellationError=y;class T extends Error{constructor(){super(w),this.name=this.message}}e.CancellationError=T;function S(){const t=new Error(w);return t.name=t.message,t}e.canceled=S;function b(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=b;function g(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=g;function f(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function p(t){const r=new Error(`${t} has been disposed`);return r.name="DISPOSED",r}e.disposed=p;function u(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=u;class h extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=h;class v extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=v;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class D extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof D)return r;const n=new D;return n.message=r.message,n.stack=r.stack,n}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=D;class A extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,A.prototype);debugger}}e.BugIndicatingError=A}),define(ve[18],be([1,0,9]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function k(W,K=0){return W[W.length-(1+K)]}e.tail=k;function l(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=l;function I(W,K,Z=(V,Q)=>V===Q){if(W===K)return!0;if(!W||!K||W.length!==K.length)return!1;for(let V=0,Q=W.length;V<Q;V++)if(!Z(W[V],K[V]))return!1;return!0}e.equals=I;function C(W,K){const Z=W.length-1;K<Z&&(W[K]=W[Z]),W.pop()}e.removeFastWithoutKeepingOrder=C;function P(W,K,Z){return w(W.length,V=>Z(W[V],K))}e.binarySearch=P;function w(W,K){let Z=0,V=W-1;for(;Z<=V;){const Q=(Z+V)/2|0,G=K(Q);if(G<0)Z=Q+1;else if(G>0)V=Q-1;else return Q}return-(Z+1)}e.binarySearch2=w;function y(W,K){let Z=0,V=W.length;if(V===0)return 0;for(;Z<V;){const Q=Math.floor((Z+V)/2);K(W[Q])?V=Q:Z=Q+1}return Z}e.findFirstInSorted=y;function T(W,K,Z){if(W=W|0,W>=K.length)throw new TypeError("invalid index");const V=K[Math.floor(K.length*Math.random())],Q=[],G=[],X=[];for(const ce of K){const pe=Z(ce,V);pe<0?Q.push(ce):pe>0?G.push(ce):X.push(ce)}return W<Q.length?T(W,Q,Z):W<Q.length+X.length?X[0]:T(W-(Q.length+X.length),G,Z)}e.quickSelect=T;function S(W,K){const Z=[];let V;for(const Q of W.slice(0).sort(K))!V||K(V[0],Q)!==0?(V=[Q],Z.push(V)):V.push(Q);return Z}e.groupBy=S;function b(W,K,Z){const V=[];function Q(ce,pe,Pe){if(pe===0&&Pe.length===0)return;const Ae=V[V.length-1];Ae&&Ae.start+Ae.deleteCount===ce?(Ae.deleteCount+=pe,Ae.toInsert.push(...Pe)):V.push({start:ce,deleteCount:pe,toInsert:Pe})}let G=0,X=0;for(;;){if(G===W.length){Q(G,0,K.slice(X));break}if(X===K.length){Q(G,W.length-G,[]);break}const ce=W[G],pe=K[X],Pe=Z(ce,pe);Pe===0?(G+=1,X+=1):Pe<0?(Q(G,1,[]),G+=1):Pe>0&&(Q(G,0,[pe]),X+=1)}return V}e.sortedDiff=b;function g(W,K,Z){const V=b(W,K,Z),Q=[],G=[];for(const X of V)Q.push(...W.slice(X.start,X.start+X.deleteCount)),G.push(...X.toInsert);return{removed:Q,added:G}}e.delta=g;function f(W,K,Z){if(Z===0)return[];const V=W.slice(0,Z).sort(K);return u(W,K,V,Z,W.length),V}e.top=f;function p(W,K,Z,V,Q){return Z===0?Promise.resolve([]):new Promise((G,X)=>{(async()=>{const ce=W.length,pe=W.slice(0,Z).sort(K);for(let Pe=Z,Ae=Math.min(Z+V,ce);Pe<ce;Pe=Ae,Ae=Math.min(Ae+V,ce)){if(Pe>Z&&await new Promise(Fe=>setTimeout(Fe)),Q&&Q.isCancellationRequested)throw new E.CancellationError;u(W,K,pe,Pe,Ae)}return pe})().then(G,X)})}e.topAsync=p;function u(W,K,Z,V,Q){for(const G=Z.length;V<Q;V++){const X=W[V];if(K(X,Z[G-1])<0){Z.pop();const ce=y(Z,pe=>K(X,pe)<0);Z.splice(ce,0,X)}}}function h(W){return W.filter(K=>!!K)}e.coalesce=h;function v(W){let K=0;for(let Z=0;Z<W.length;Z++)W[Z]&&(W[K]=W[Z],K+=1);W.length=K}e.coalesceInPlace=v;function d(W,K,Z){W.splice(Z,0,W.splice(K,1)[0])}e.move=d;function D(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=D;function A(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=A;function t(W,K=Z=>Z){const Z=new Set;return W.filter(V=>{const Q=K(V);return Z.has(Q)?!1:(Z.add(Q),!0)})}e.distinct=t;function r(W){const K=new Set;return Z=>{const V=W(Z);return K.has(V)?!1:(K.add(V),!0)}}e.uniqueFilter=r;function n(W,K){const Z=i(W,K);if(Z!==-1)return W[Z]}e.findLast=n;function i(W,K){for(let Z=W.length-1;Z>=0;Z--){const V=W[Z];if(K(V))return Z}return-1}e.lastIndex=i;function o(W,K){return W.length>0?W[0]:K}e.firstOrDefault=o;function c(W,K){return W.length>0?W[W.length-1]:K}e.lastOrDefault=c;function a(W,K,Z=(V,Q)=>V===Q){let V=0;for(let Q=0,G=Math.min(W.length,K.length);Q<G&&Z(W[Q],K[Q]);Q++)V++;return V}e.commonPrefixLength=a;function s(W){return[].concat(...W)}e.flatten=s;function m(W,K){let Z=typeof K=="number"?W:0;typeof K=="number"?Z=W:(Z=0,K=W);const V=[];if(Z<=K)for(let Q=Z;Q<K;Q++)V.push(Q);else for(let Q=Z;Q>K;Q--)V.push(Q);return V}e.range=m;function R(W,K,Z){return W.reduce((V,Q)=>(V[K(Q)]=Z?Z(Q):Q,V),Object.create(null))}e.index=R;function L(W,K){return W.push(K),()=>$(W,K)}e.insert=L;function $(W,K){const Z=W.indexOf(K);if(Z>-1)return W.splice(Z,1),K}e.remove=$;function ie(W,K,Z){const V=W.slice(0,K),Q=W.slice(K);return V.concat(Z,Q)}e.arrayInsert=ie;function ne(W,K){let Z;if(typeof K=="number"){let V=K;Z=()=>{const Q=Math.sin(V++)*179426549;return Q-Math.floor(Q)}}else Z=Math.random;for(let V=W.length-1;V>0;V-=1){const Q=Math.floor(Z()*(V+1)),G=W[V];W[V]=W[Q],W[Q]=G}}e.shuffle=ne;function F(W,K){const Z=W.indexOf(K);Z>-1&&(W.splice(Z,1),W.unshift(K))}e.pushToStart=F;function _(W,K){const Z=W.indexOf(K);Z>-1&&(W.splice(Z,1),W.push(K))}e.pushToEnd=_;function z(W,K){for(const Z of K)W.push(Z)}e.pushMany=z;function x(W,K){return Array.isArray(W)?W.map(K):K(W)}e.mapArrayOrNot=x;function le(W){return Array.isArray(W)?W:[W]}e.asArray=le;function Ee(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=Ee;function Y(W,K){for(const Z of W){const V=K(Z);if(V!==void 0)return V}}e.mapFind=Y;function H(W,K,Z){const V=te(W,K),Q=W.length,G=Z.length;W.length=Q+G;for(let X=Q-1;X>=V;X--)W[X+G]=W[X];for(let X=0;X<G;X++)W[X+V]=Z[X]}e.insertInto=H;function U(W,K,Z,V){const Q=te(W,K),G=W.splice(Q,Z);return H(W,Q,V),G}e.splice=U;function te(W,K){return K<0?Math.max(K+W.length,0):Math.min(K,W.length)}var re;(function(W){function K(Q){return Q<0}W.isLessThan=K;function Z(Q){return Q>0}W.isGreaterThan=Z;function V(Q){return Q===0}W.isNeitherLessOrGreaterThan=V,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(re=e.CompareResult||(e.CompareResult={}));function de(W,K){return(Z,V)=>K(W(Z),W(V))}e.compareBy=de;function oe(...W){return(K,Z)=>{for(const V of W){const Q=V(K,Z);if(!re.isNeitherLessOrGreaterThan(Q))return Q}return re.neitherLessOrGreaterThan}}e.tieBreakComparators=oe;const j=(W,K)=>W-K;e.numberComparator=j;function N(W,K){if(W.length===0)return;let Z=W[0];for(let V=1;V<W.length;V++){const Q=W[V];K(Q,Z)>0&&(Z=Q)}return Z}e.findMaxBy=N;function M(W,K){if(W.length===0)return;let Z=W[0];for(let V=1;V<W.length;V++){const Q=W[V];K(Q,Z)>=0&&(Z=Q)}return Z}e.findLastMaxBy=M;function q(W,K){return N(W,(Z,V)=>-K(Z,V))}e.findMinBy=q;class ee{constructor(K){this.f=K,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(K){let Z=this.c;for(;Z<this.f.length&&K(this.f[Z]);)Z++;const V=Z===this.c?null:this.f.slice(this.c,Z);return this.c=Z,V}takeFromEndWhile(K){let Z=this.d;for(;Z>=0&&K(this.f[Z]);)Z--;const V=Z===this.d?null:this.f.slice(Z+1,this.d+1);return this.d=Z,V}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const K=this.f[this.c];return this.c++,K}removeLast(){const K=this.f[this.d];return this.d--,K}takeCount(K){const Z=this.f.slice(this.c,this.c+K);return this.c+=K,Z}}e.ArrayQueue=ee;class fe{constructor(K){this.iterate=K}forEach(K){this.iterate(Z=>(K(Z),!0))}toArray(){const K=[];return this.iterate(Z=>(K.push(Z),!0)),K}filter(K){return new fe(Z=>this.iterate(V=>K(V)?Z(V):!0))}map(K){return new fe(Z=>this.iterate(V=>Z(K(V))))}some(K){let Z=!1;return this.iterate(V=>(Z=K(V),!Z)),Z}findFirst(K){let Z;return this.iterate(V=>K(V)?(Z=V,!1):!0),Z}findLast(K){let Z;return this.iterate(V=>(K(V)&&(Z=V),!0)),Z}findLastMaxBy(K){let Z,V=!0;return this.iterate(Q=>((V||re.isGreaterThan(K(Q,Z)))&&(V=!1,Z=Q),!0)),Z}}fe.empty=new fe(W=>{}),e.CallbackIterable=fe}),define(ve[86],be([1,0,9]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function k(w,y){if(!w)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=k;function l(w,y="Unreachable"){throw new Error(y)}e.assertNever=l;function I(w){if(!w)throw new E.BugIndicatingError("Assertion Failed")}e.assert=I;function C(w){if(!w()){debugger;w(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=C;function P(w,y){let T=0;for(;T<w.length-1;){const S=w[T],b=w[T+1];if(!y(S,b))return!1;T++}return!0}e.checkAdjacentItems=P}),define(ve[69],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(k){const l=this;let I=!1,C;return function(){return I||(I=!0,C=k.apply(l,arguments)),C}}e.once=E}),define(ve[55],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(k){function l(D){return D&&typeof D=="object"&&typeof D[Symbol.iterator]=="function"}k.is=l;const I=Object.freeze([]);function C(){return I}k.empty=C;function*P(D){yield D}k.single=P;function w(D){return l(D)?D:P(D)}k.wrap=w;function y(D){return D||I}k.from=y;function T(D){return!D||D[Symbol.iterator]().next().done===!0}k.isEmpty=T;function S(D){return D[Symbol.iterator]().next().value}k.first=S;function b(D,A){for(const t of D)if(A(t))return!0;return!1}k.some=b;function g(D,A){for(const t of D)if(A(t))return t}k.find=g;function*f(D,A){for(const t of D)A(t)&&(yield t)}k.filter=f;function*p(D,A){let t=0;for(const r of D)yield A(r,t++)}k.map=p;function*u(...D){for(const A of D)for(const t of A)yield t}k.concat=u;function h(D,A,t){let r=t;for(const n of D)r=A(r,n);return r}k.reduce=h;function*v(D,A,t=D.length){for(A<0&&(A+=D.length),t<0?t+=D.length:t>D.length&&(t=D.length);A<t;A++)yield D[A]}k.slice=v;function d(D,A=Number.POSITIVE_INFINITY){const t=[];if(A===0)return[t,D];const r=D[Symbol.iterator]();for(let n=0;n<A;n++){const i=r.next();if(i.done)return[t,k.empty()];t.push(i.value)}return[t,{[Symbol.iterator](){return r}}]}k.consume=d})(E=e.Iterable||(e.Iterable={}))}),define(ve[70],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I=e.ParseOptions||(e.ParseOptions={}));function C(t,r=!1){let n=0;const i=t.length;let o="",c=0,a=16,s=0;function m(_){let z=0,x=0;for(;z<_;){const le=t.charCodeAt(n);if(le>=48&&le<=57)x=x*16+le-48;else if(le>=65&&le<=70)x=x*16+le-65+10;else if(le>=97&&le<=102)x=x*16+le-97+10;else break;n++,z++}return z<_&&(x=-1),x}function R(_){n=_,o="",c=0,a=16,s=0}function L(){const _=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&y(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&y(t.charCodeAt(n)))for(n++;n<t.length&&y(t.charCodeAt(n));)n++;else return s=3,t.substring(_,n);let z=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&y(t.charCodeAt(n))){for(n++;n<t.length&&y(t.charCodeAt(n));)n++;z=n}else s=3;return t.substring(_,z)}function $(){let _="",z=n;for(;;){if(n>=i){_+=t.substring(z,n),s=2;break}const x=t.charCodeAt(n);if(x===34){_+=t.substring(z,n),n++;break}if(x===92){if(_+=t.substring(z,n),n++,n>=i){s=2;break}switch(t.charCodeAt(n++)){case 34:_+='"';break;case 92:_+="\\";break;case 47:_+="/";break;case 98:_+="\b";break;case 102:_+="\f";break;case 110:_+=`
`;break;case 114:_+="\r";break;case 116:_+="	";break;case 117:{const Ee=m(4);Ee>=0?_+=String.fromCharCode(Ee):s=4;break}default:s=5}z=n;continue}if(x>=0&&x<=31)if(w(x)){_+=t.substring(z,n),s=2;break}else s=6;n++}return _}function ie(){if(o="",s=0,c=n,n>=i)return c=i,a=17;let _=t.charCodeAt(n);if(P(_)){do n++,o+=String.fromCharCode(_),_=t.charCodeAt(n);while(P(_));return a=15}if(w(_))return n++,o+=String.fromCharCode(_),_===13&&t.charCodeAt(n)===10&&(n++,o+=`
`),a=14;switch(_){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,o=$(),a=10;case 47:{const z=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<i&&!w(t.charCodeAt(n));)n++;return o=t.substring(z,n),a=12}if(t.charCodeAt(n+1)===42){n+=2;const x=i-1;let le=!1;for(;n<x;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,le=!0;break}n++}return le||(n++,s=1),o=t.substring(z,n),a=13}return o+=String.fromCharCode(_),n++,a=16}case 45:if(o+=String.fromCharCode(_),n++,n===i||!y(t.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=L(),a=11;default:for(;n<i&&ne(_);)n++,_=t.charCodeAt(n);if(c!==n){switch(o=t.substring(c,n),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(_),n++,a=16}}function ne(_){if(P(_)||w(_))return!1;switch(_){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let _;do _=ie();while(_>=12&&_<=15);return _}return{setPosition:R,getPosition:()=>n,scan:r?F:ie,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>s}}e.createScanner=C;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function w(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var T;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(T||(T={}));function S(t,r){const n=[],i=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function s(m,R,L,$){c.value=m,c.offset=R,c.length=L,c.type=$,c.colonOffset=void 0,o=c}try{d(t,{onObjectBegin:(m,R)=>{if(r<=m)throw i;o=void 0,a=r>m,n.push("")},onObjectProperty:(m,R,L)=>{if(r<R||(s(m,R,L,"property"),n[n.length-1]=m,r<=R+L))throw i},onObjectEnd:(m,R)=>{if(r<=m)throw i;o=void 0,n.pop()},onArrayBegin:(m,R)=>{if(r<=m)throw i;o=void 0,n.push(0)},onArrayEnd:(m,R)=>{if(r<=m)throw i;o=void 0,n.pop()},onLiteralValue:(m,R,L)=>{if(r<R||(s(m,R,L,A(m)),r<=R+L))throw i},onSeparator:(m,R,L)=>{if(r<=R)throw i;if(m===":"&&o&&o.type==="property")o.colonOffset=R,a=!1,o=void 0;else if(m===","){const $=n[n.length-1];typeof $=="number"?n[n.length-1]=$+1:(a=!0,n[n.length-1]=""),o=void 0}}})}catch(m){if(m!==i)throw m}return{path:n,previousNode:o,isAtPropertyKey:a,matches:m=>{let R=0;for(let L=0;R<m.length&&L<n.length;L++)if(m[R]===n[L]||m[R]==="*")R++;else if(m[R]!=="**")return!1;return R===m.length}}}e.getLocation=S;function b(t,r=[],n=I.DEFAULT){let i=null,o=[];const c=[];function a(m){Array.isArray(o)?o.push(m):i!==null&&(o[i]=m)}return d(t,{onObjectBegin:()=>{const m={};a(m),c.push(o),o=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const m=[];a(m),c.push(o),o=m,i=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:a,onError:(m,R,L)=>{r.push({error:m,offset:R,length:L})}},n),o[0]}e.parse=b;function g(t,r=[],n=I.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(m){i.type==="property"&&(i.length=m-i.offset,i=i.parent)}function c(m){return i.children.push(m),m}d(t,{onObjectBegin:m=>{i=c({type:"object",offset:m,length:-1,parent:i,children:[]})},onObjectProperty:(m,R,L)=>{i=c({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:m,offset:R,length:L,parent:i})},onObjectEnd:(m,R)=>{i.length=m+R-i.offset,i=i.parent,o(m+R)},onArrayBegin:(m,R)=>{i=c({type:"array",offset:m,length:-1,parent:i,children:[]})},onArrayEnd:(m,R)=>{i.length=m+R-i.offset,i=i.parent,o(m+R)},onLiteralValue:(m,R,L)=>{c({type:A(m),offset:R,length:L,parent:i,value:m}),o(R+L)},onSeparator:(m,R,L)=>{i.type==="property"&&(m===":"?i.colonOffset=R:m===","&&o(R))},onError:(m,R,L)=>{r.push({error:m,offset:R,length:L})}},n);const s=i.children[0];return s&&delete s.parent,s}e.parseTree=g;function f(t,r){if(!t)return;let n=t;for(const i of r)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const c of n.children)if(Array.isArray(c.children)&&c.children[0].value===i){n=c.children[1],o=!0;break}if(!o)return}else{const o=i;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.findNodeAtLocation=f;function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}e.getNodePath=p;function u(t){switch(t.type){case"array":return t.children.map(u);case"object":{const r=Object.create(null);for(const n of t.children){const i=n.children[1];i&&(r[n.children[0].value]=u(i))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=u;function h(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}e.contains=h;function v(t,r,n=!1){if(h(t,r,n)){const i=t.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=r;o++){const c=v(i[o],r,n);if(c)return c}return t}}e.findNodeAtOffset=v;function d(t,r,n=I.DEFAULT){const i=C(t,!1);function o(de){return de?()=>de(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(de){return de?oe=>de(oe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=o(r.onObjectBegin),s=c(r.onObjectProperty),m=o(r.onObjectEnd),R=o(r.onArrayBegin),L=o(r.onArrayEnd),$=c(r.onLiteralValue),ie=c(r.onSeparator),ne=o(r.onComment),F=c(r.onError),_=n&&n.disallowComments,z=n&&n.allowTrailingComma;function x(){for(;;){const de=i.scan();switch(i.getTokenError()){case 4:le(14);break;case 5:le(15);break;case 3:le(13);break;case 1:_||le(11);break;case 2:le(12);break;case 6:le(16);break}switch(de){case 12:case 13:_?le(10):ne();break;case 16:le(1);break;case 15:case 14:break;default:return de}}}function le(de,oe=[],j=[]){if(F(de),oe.length+j.length>0){let N=i.getToken();for(;N!==17;){if(oe.indexOf(N)!==-1){x();break}else if(j.indexOf(N)!==-1)break;N=x()}}}function Ee(de){const oe=i.getTokenValue();return de?$(oe):s(oe),x(),!0}function Y(){switch(i.getToken()){case 11:{let de=0;try{de=JSON.parse(i.getTokenValue()),typeof de!="number"&&(le(2),de=0)}catch{le(2)}$(de);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return x(),!0}function H(){return i.getToken()!==10?(le(3,[],[2,5]),!1):(Ee(!1),i.getToken()===6?(ie(":"),x(),re()||le(4,[],[2,5])):le(5,[],[2,5]),!0)}function U(){a(),x();let de=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(de||le(4,[],[]),ie(","),x(),i.getToken()===2&&z)break}else de&&le(6,[],[]);H()||le(4,[],[2,5]),de=!0}return m(),i.getToken()!==2?le(7,[2],[]):x(),!0}function te(){R(),x();let de=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(de||le(4,[],[]),ie(","),x(),i.getToken()===4&&z)break}else de&&le(6,[],[]);re()||le(4,[],[4,5]),de=!0}return L(),i.getToken()!==4?le(8,[4],[]):x(),!0}function re(){switch(i.getToken()){case 3:return te();case 1:return U();case 10:return Ee(!0);default:return Y()}}return x(),i.getToken()===17?n.allowEmptyContent?!0:(le(4,[],[]),!1):re()?(i.getToken()!==17&&le(9,[],[]),!0):(le(4,[],[]),!1)}e.visit=d;function D(t,r){const n=C(t),i=[];let o,c=0,a;do switch(a=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:c!==a&&i.push(t.substring(c,a)),r!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,r)),c=n.getPosition();break}while(o!==17);return i.join("")}e.stripComments=D;function A(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=A}),define(ve[141],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=E}),define(ve[2],be([1,0,69,55]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let I=null;function C(c){I=c}if(e.setDisposableTracker=C,l){const c="__is_disposable_tracked__";C(new class{trackDisposable(a){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[c]||console.log(s)},3e3)}setParent(a,s){if(a&&a!==v.None)try{a[c]=!0}catch{}}markAsDisposed(a){if(a&&a!==v.None)try{a[c]=!0}catch{}}markAsSingleton(a){}})}function P(c){return I?.trackDisposable(c),c}function w(c){I?.markAsDisposed(c)}function y(c,a){I?.setParent(c,a)}function T(c,a){if(!!I)for(const s of c)I.setParent(s,a)}function S(c){return I?.markAsSingleton(c),c}e.markAsSingleton=S;function b(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=b;function g(c){if(k.Iterable.is(c)){const a=[];for(const s of c)if(s)try{s.dispose()}catch(m){a.push(m)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(c)?[]:c}else if(c)return c.dispose(),c}e.dispose=g;function f(c){for(const a of c)b(a)&&a.dispose();return[]}e.disposeIfDisposable=f;function p(...c){const a=u(()=>g(c));return T(c,a),a}e.combinedDisposable=p;function u(c){const a=P({dispose:(0,E.once)(()=>{w(a),c()})});return a}e.toDisposable=u;class h{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(w(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{g(this.c)}finally{this.c.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return y(a,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(a),a}}h.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=h;class v{constructor(){this.q=new h,P(this),y(this.q,this)}dispose(){w(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}v.None=Object.freeze({dispose(){}}),e.Disposable=v;class d{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&y(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&y(a,null),a}}e.MutableDisposable=d;class D{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=D;class A{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let s=a;return this.unset=()=>s=void 0,this.isset=()=>s!==void 0,this.dispose=()=>{s&&(s(),s=void 0,w(this))},this}}e.SafeDisposable=A;class t{constructor(){this.a=new Map}acquire(a,...s){let m=this.a.get(a);m||(m={counter:0,object:this.b(a,...s)},this.a.set(a,m));const{object:R}=m,L=(0,E.once)(()=>{--m.counter===0&&(this.c(a,m.object),this.a.delete(a))});return m.counter++,{object:R,dispose:L}}}e.ReferenceCollection=t;class r{constructor(a){this.a=a}async acquire(a,...s){const m=this.a.acquire(a,...s);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(R){throw m.dispose(),R}}}e.AsyncReferenceCollection=r;class n{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=n;function i(c){const a=new h;try{c(a)}finally{a.dispose()}}e.disposeOnReturn=i;class o{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get(a){return this.a.get(a)}set(a,s,m=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),m||this.a.get(a)?.dispose(),this.a.set(a,s)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(ve[87],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(I){this.element=I,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class k{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let I=this.a;for(;I!==E.Undefined;){const C=I.next;I.prev=E.Undefined,I.next=E.Undefined,I=C}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,C){const P=new E(I);if(this.a===E.Undefined)this.a=P,this.b=P;else if(C){const y=this.b;this.b=P,P.prev=y,y.next=P}else{const y=this.a;this.a=P,P.next=y,y.prev=P}this.c+=1;let w=!1;return()=>{w||(w=!0,this.e(P))}}shift(){if(this.a!==E.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==E.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==E.Undefined&&I.next!==E.Undefined){const C=I.prev;C.next=I.next,I.next.prev=C}else I.prev===E.Undefined&&I.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):I.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):I.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==E.Undefined;)yield I.element,I=I.next}}e.LinkedList=k}),define(ve[27],be([1,0]),function(ae,e){"use strict";var E,k,l;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function I(f,p,u){let h=f.get(p);return h===void 0&&(h=u,f.set(p,h)),h}e.getOrSet=I;function C(f){const p=[];return f.forEach((u,h)=>{p.push(`${h} => ${u}`)}),`Map(${f.size}) {${p.join(", ")}}`}e.mapToString=C;function P(f){const p=[];return f.forEach(u=>{p.push(u)}),`Set(${f.size}) {${p.join(", ")}}`}e.setToString=P;class w{constructor(p,u){this.uri=p,this.value=u}}class y{constructor(p,u){this[E]="ResourceMap",p instanceof y?(this.b=new Map(p.b),this.c=u??y.a):(this.b=new Map,this.c=p??y.a)}set(p,u){return this.b.set(this.c(p),new w(p,u)),this}get(p){return this.b.get(this.c(p))?.value}has(p){return this.b.has(this.c(p))}get size(){return this.b.size}clear(){this.b.clear()}delete(p){return this.b.delete(this.c(p))}forEach(p,u){typeof u<"u"&&(p=p.bind(u));for(const[h,v]of this.b)p(v.value,v.uri,this)}*values(){for(const p of this.b.values())yield p.value}*keys(){for(const p of this.b.values())yield p.uri}*entries(){for(const p of this.b.values())yield[p.uri,p.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,p]of this.b)yield[p.uri,p.value]}}y.a=f=>f.toString(),e.ResourceMap=y;class T{constructor(p,u){this[k]="ResourceSet",!p||typeof p=="function"?this.a=new y(p):(this.a=new y(u),p.forEach(this.add,this))}get size(){return this.a.size}add(p){return this.a.set(p,p),this}clear(){this.a.clear()}delete(p){return this.a.delete(p)}forEach(p,u){this.a.forEach((h,v)=>p.call(u,v,v,this))}has(p){return this.a.has(p)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=T;var S;(function(f){f[f.None=0]="None",f[f.AsOld=1]="AsOld",f[f.AsNew=2]="AsNew"})(S=e.Touch||(e.Touch={}));class b{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(p){return this.a.has(p)}get(p,u=0){const h=this.a.get(p);if(!!h)return u!==0&&this.j(h,u),h.value}set(p,u,h=0){let v=this.a.get(p);if(v)v.value=u,h!==0&&this.j(v,h);else{switch(v={key:p,value:u,next:void 0,previous:void 0},h){case 0:this.h(v);break;case 1:this.g(v);break;case 2:this.h(v);break;default:this.h(v);break}this.a.set(p,v),this.d++}return this}delete(p){return!!this.remove(p)}remove(p){const u=this.a.get(p);if(!!u)return this.a.delete(p),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const p=this.b;return this.a.delete(p.key),this.i(p),this.d--,p.value}forEach(p,u){const h=this.e;let v=this.b;for(;v;){if(u?p.bind(u)(v.value,v.key,this):p(v.value,v.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");v=v.next}}keys(){const p=this,u=this.e;let h=this.b;const v={[Symbol.iterator](){return v},next(){if(p.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:h.key,done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return v}values(){const p=this,u=this.e;let h=this.b;const v={[Symbol.iterator](){return v},next(){if(p.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:h.value,done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return v}entries(){const p=this,u=this.e;let h=this.b;const v={[Symbol.iterator](){return v},next(){if(p.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const d={value:[h.key,h.value],done:!1};return h=h.next,d}else return{value:void 0,done:!0}}};return v}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(p){if(p>=this.size)return;if(p===0){this.clear();return}let u=this.b,h=this.size;for(;u&&h>p;)this.a.delete(u.key),u=u.next,h--;this.b=u,this.d=h,u&&(u.previous=void 0),this.e++}g(p){if(!this.b&&!this.c)this.c=p;else if(this.b)p.next=this.b,this.b.previous=p;else throw new Error("Invalid list");this.b=p,this.e++}h(p){if(!this.b&&!this.c)this.b=p;else if(this.c)p.previous=this.c,this.c.next=p;else throw new Error("Invalid list");this.c=p,this.e++}i(p){if(p===this.b&&p===this.c)this.b=void 0,this.c=void 0;else if(p===this.b){if(!p.next)throw new Error("Invalid list");p.next.previous=void 0,this.b=p.next}else if(p===this.c){if(!p.previous)throw new Error("Invalid list");p.previous.next=void 0,this.c=p.previous}else{const u=p.next,h=p.previous;if(!u||!h)throw new Error("Invalid list");u.previous=h,h.next=u}p.next=void 0,p.previous=void 0,this.e++}j(p,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(p===this.b)return;const h=p.next,v=p.previous;p===this.c?(v.next=void 0,this.c=v):(h.previous=v,v.next=h),p.previous=void 0,p.next=this.b,this.b.previous=p,this.b=p,this.e++}else if(u===2){if(p===this.c)return;const h=p.next,v=p.previous;p===this.b?(h.previous=void 0,this.b=h):(h.previous=v,v.next=h),p.next=void 0,p.previous=this.c,this.c.next=p,this.c=p,this.e++}}}toJSON(){const p=[];return this.forEach((u,h)=>{p.push([h,u])}),p}fromJSON(p){this.clear();for(const[u,h]of p)this.set(u,h)}}e.LinkedMap=b;class g extends b{constructor(p,u=1){super(),this.k=p,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(p){this.k=p,this.m()}get ratio(){return this.l}set ratio(p){this.l=Math.min(Math.max(0,p),1),this.m()}get(p,u=2){return super.get(p,u)}peek(p){return super.get(p,0)}set(p,u){return super.set(p,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=g}),function(ae,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ve[142],be([0]),e):(ae=typeof globalThis<"u"?globalThis:ae||self,e(ae.marked={}))}(this,function(ae){"use strict";function e(W,K){for(var Z=0;Z<K.length;Z++){var V=K[Z];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(W,V.key,V)}}function E(W,K,Z){return K&&e(W.prototype,K),Z&&e(W,Z),Object.defineProperty(W,"prototype",{writable:!1}),W}function k(W,K){if(!!W){if(typeof W=="string")return l(W,K);var Z=Object.prototype.toString.call(W).slice(8,-1);if(Z==="Object"&&W.constructor&&(Z=W.constructor.name),Z==="Map"||Z==="Set")return Array.from(W);if(Z==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Z))return l(W,K)}}function l(W,K){(K==null||K>W.length)&&(K=W.length);for(var Z=0,V=new Array(K);Z<K;Z++)V[Z]=W[Z];return V}function I(W,K){var Z=typeof Symbol<"u"&&W[Symbol.iterator]||W["@@iterator"];if(Z)return(Z=Z.call(W)).next.bind(Z);if(Array.isArray(W)||(Z=k(W))||K&&W&&typeof W.length=="number"){Z&&(W=Z);var V=0;return function(){return V>=W.length?{done:!0}:{done:!1,value:W[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ae.defaults=C();function P(W){ae.defaults=W}var w=/[&<>"']/,y=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,b={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(K){return b[K]};function f(W,K){if(K){if(w.test(W))return W.replace(y,g)}else if(T.test(W))return W.replace(S,g);return W}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(W){return W.replace(p,function(K,Z){return Z=Z.toLowerCase(),Z==="colon"?":":Z.charAt(0)==="#"?Z.charAt(1)==="x"?String.fromCharCode(parseInt(Z.substring(2),16)):String.fromCharCode(+Z.substring(1)):""})}var h=/(^|[^\[])\^/g;function v(W,K){W=typeof W=="string"?W:W.source,K=K||"";var Z={replace:function(Q,G){return G=G.source||G,G=G.replace(h,"$1"),W=W.replace(Q,G),Z},getRegex:function(){return new RegExp(W,K)}};return Z}var d=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function A(W,K,Z){if(W){var V;try{V=decodeURIComponent(u(Z)).replace(d,"").toLowerCase()}catch{return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}K&&!D.test(Z)&&(Z=o(K,Z));try{Z=encodeURI(Z).replace(/%25/g,"%")}catch{return null}return Z}var t={},r=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(W,K){t[" "+W]||(r.test(W)?t[" "+W]=W+"/":t[" "+W]=m(W,"/",!0)),W=t[" "+W];var Z=W.indexOf(":")===-1;return K.substring(0,2)==="//"?Z?K:W.replace(n,"$1")+K:K.charAt(0)==="/"?Z?K:W.replace(i,"$1")+K:W+K}var c={exec:function(){}};function a(W){for(var K=1,Z,V;K<arguments.length;K++){Z=arguments[K];for(V in Z)Object.prototype.hasOwnProperty.call(Z,V)&&(W[V]=Z[V])}return W}function s(W,K){var Z=W.replace(/\|/g,function(G,X,ce){for(var pe=!1,Pe=X;--Pe>=0&&ce[Pe]==="\\";)pe=!pe;return pe?"|":" |"}),V=Z.split(/ \|/),Q=0;if(V[0].trim()||V.shift(),V.length>0&&!V[V.length-1].trim()&&V.pop(),V.length>K)V.splice(K);else for(;V.length<K;)V.push("");for(;Q<V.length;Q++)V[Q]=V[Q].trim().replace(/\\\|/g,"|");return V}function m(W,K,Z){var V=W.length;if(V===0)return"";for(var Q=0;Q<V;){var G=W.charAt(V-Q-1);if(G===K&&!Z)Q++;else if(G!==K&&Z)Q++;else break}return W.slice(0,V-Q)}function R(W,K){if(W.indexOf(K[1])===-1)return-1;for(var Z=W.length,V=0,Q=0;Q<Z;Q++)if(W[Q]==="\\")Q++;else if(W[Q]===K[0])V++;else if(W[Q]===K[1]&&(V--,V<0))return Q;return-1}function L(W){W&&W.sanitize&&!W.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function $(W,K){if(K<1)return"";for(var Z="";K>1;)K&1&&(Z+=W),K>>=1,W+=W;return Z+W}function ie(W,K,Z,V){var Q=K.href,G=K.title?f(K.title):null,X=W[1].replace(/\\([\[\]])/g,"$1");if(W[0].charAt(0)!=="!"){V.state.inLink=!0;var ce={type:"link",raw:Z,href:Q,title:G,text:X,tokens:V.inlineTokens(X)};return V.state.inLink=!1,ce}return{type:"image",raw:Z,href:Q,title:G,text:f(X)}}function ne(W,K){var Z=W.match(/^(\s+)(?:```)/);if(Z===null)return K;var V=Z[1];return K.split(`
`).map(function(Q){var G=Q.match(/^\s+/);if(G===null)return Q;var X=G[0];return X.length>=V.length?Q.slice(V.length):Q}).join(`
`)}var F=function(){function W(Z){this.options=Z||ae.defaults}var K=W.prototype;return K.space=function(V){var Q=this.rules.block.newline.exec(V);if(Q&&Q[0].length>0)return{type:"space",raw:Q[0]}},K.code=function(V){var Q=this.rules.block.code.exec(V);if(Q){var G=Q[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Q[0],codeBlockStyle:"indented",text:this.options.pedantic?G:m(G,`
`)}}},K.fences=function(V){var Q=this.rules.block.fences.exec(V);if(Q){var G=Q[0],X=ne(G,Q[3]||"");return{type:"code",raw:G,lang:Q[2]?Q[2].trim():Q[2],text:X}}},K.heading=function(V){var Q=this.rules.block.heading.exec(V);if(Q){var G=Q[2].trim();if(/#$/.test(G)){var X=m(G,"#");(this.options.pedantic||!X||/ $/.test(X))&&(G=X.trim())}return{type:"heading",raw:Q[0],depth:Q[1].length,text:G,tokens:this.lexer.inline(G)}}},K.hr=function(V){var Q=this.rules.block.hr.exec(V);if(Q)return{type:"hr",raw:Q[0]}},K.blockquote=function(V){var Q=this.rules.block.blockquote.exec(V);if(Q){var G=Q[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Q[0],tokens:this.lexer.blockTokens(G,[]),text:G}}},K.list=function(V){var Q=this.rules.block.list.exec(V);if(Q){var G,X,ce,pe,Pe,Ae,Fe,$e,me,we,ye,Me,je=Q[1].trim(),Ye=je.length>1,He={type:"list",raw:"",ordered:Ye,start:Ye?+je.slice(0,-1):"",loose:!1,items:[]};je=Ye?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=Ye?je:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");V&&(Me=!1,!(!(Q=Ke.exec(V))||this.rules.block.hr.test(V)));){if(G=Q[0],V=V.substring(G.length),$e=Q[2].split(`
`,1)[0],me=V.split(`
`,1)[0],this.options.pedantic?(pe=2,ye=$e.trimLeft()):(pe=Q[2].search(/[^ ]/),pe=pe>4?1:pe,ye=$e.slice(pe),pe+=Q[1].length),Ae=!1,!$e&&/^ *$/.test(me)&&(G+=me+`
`,V=V.substring(me.length+1),Me=!0),!Me)for(var Je=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,pe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),xe=new RegExp("^ {0,"+Math.min(3,pe-1)+"}(?:```|~~~)"),Ge=new RegExp("^ {0,"+Math.min(3,pe-1)+"}#");V&&(we=V.split(`
`,1)[0],$e=we,this.options.pedantic&&($e=$e.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(xe.test($e)||Ge.test($e)||Je.test($e)||nt.test(V)));){if($e.search(/[^ ]/)>=pe||!$e.trim())ye+=`
`+$e.slice(pe);else if(!Ae)ye+=`
`+$e;else break;!Ae&&!$e.trim()&&(Ae=!0),G+=we+`
`,V=V.substring(we.length+1)}He.loose||(Fe?He.loose=!0:/\n *\n *$/.test(G)&&(Fe=!0)),this.options.gfm&&(X=/^\[[ xX]\] /.exec(ye),X&&(ce=X[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:G,task:!!X,checked:ce,loose:!1,text:ye}),He.raw+=G}He.items[He.items.length-1].raw=G.trimRight(),He.items[He.items.length-1].text=ye.trimRight(),He.raw=He.raw.trimRight();var et=He.items.length;for(Pe=0;Pe<et;Pe++){this.lexer.state.top=!1,He.items[Pe].tokens=this.lexer.blockTokens(He.items[Pe].text,[]);var ue=He.items[Pe].tokens.filter(function(Ce){return Ce.type==="space"}),Ie=ue.every(function(Ce){for(var Le=Ce.raw.split(""),Ne=0,ze=I(Le),Ve;!(Ve=ze()).done;){var Xe=Ve.value;if(Xe===`
`&&(Ne+=1),Ne>1)return!0}return!1});!He.loose&&ue.length&&Ie&&(He.loose=!0,He.items[Pe].loose=!0)}return He}},K.html=function(V){var Q=this.rules.block.html.exec(V);if(Q){var G={type:"html",raw:Q[0],pre:!this.options.sanitizer&&(Q[1]==="pre"||Q[1]==="script"||Q[1]==="style"),text:Q[0]};if(this.options.sanitize){var X=this.options.sanitizer?this.options.sanitizer(Q[0]):f(Q[0]);G.type="paragraph",G.text=X,G.tokens=this.lexer.inline(X)}return G}},K.def=function(V){var Q=this.rules.block.def.exec(V);if(Q){Q[3]&&(Q[3]=Q[3].substring(1,Q[3].length-1));var G=Q[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:G,raw:Q[0],href:Q[2],title:Q[3]}}},K.table=function(V){var Q=this.rules.block.table.exec(V);if(Q){var G={type:"table",header:s(Q[1]).map(function(Fe){return{text:Fe}}),align:Q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Q[3]&&Q[3].trim()?Q[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(G.header.length===G.align.length){G.raw=Q[0];var X=G.align.length,ce,pe,Pe,Ae;for(ce=0;ce<X;ce++)/^ *-+: *$/.test(G.align[ce])?G.align[ce]="right":/^ *:-+: *$/.test(G.align[ce])?G.align[ce]="center":/^ *:-+ *$/.test(G.align[ce])?G.align[ce]="left":G.align[ce]=null;for(X=G.rows.length,ce=0;ce<X;ce++)G.rows[ce]=s(G.rows[ce],G.header.length).map(function(Fe){return{text:Fe}});for(X=G.header.length,pe=0;pe<X;pe++)G.header[pe].tokens=this.lexer.inline(G.header[pe].text);for(X=G.rows.length,pe=0;pe<X;pe++)for(Ae=G.rows[pe],Pe=0;Pe<Ae.length;Pe++)Ae[Pe].tokens=this.lexer.inline(Ae[Pe].text);return G}}},K.lheading=function(V){var Q=this.rules.block.lheading.exec(V);if(Q)return{type:"heading",raw:Q[0],depth:Q[2].charAt(0)==="="?1:2,text:Q[1],tokens:this.lexer.inline(Q[1])}},K.paragraph=function(V){var Q=this.rules.block.paragraph.exec(V);if(Q){var G=Q[1].charAt(Q[1].length-1)===`
`?Q[1].slice(0,-1):Q[1];return{type:"paragraph",raw:Q[0],text:G,tokens:this.lexer.inline(G)}}},K.text=function(V){var Q=this.rules.block.text.exec(V);if(Q)return{type:"text",raw:Q[0],text:Q[0],tokens:this.lexer.inline(Q[0])}},K.escape=function(V){var Q=this.rules.inline.escape.exec(V);if(Q)return{type:"escape",raw:Q[0],text:f(Q[1])}},K.tag=function(V){var Q=this.rules.inline.tag.exec(V);if(Q)return!this.lexer.state.inLink&&/^<a /i.test(Q[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Q[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Q[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Q[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Q[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):f(Q[0]):Q[0]}},K.link=function(V){var Q=this.rules.inline.link.exec(V);if(Q){var G=Q[2].trim();if(!this.options.pedantic&&/^</.test(G)){if(!/>$/.test(G))return;var X=m(G.slice(0,-1),"\\");if((G.length-X.length)%2===0)return}else{var ce=R(Q[2],"()");if(ce>-1){var pe=Q[0].indexOf("!")===0?5:4,Pe=pe+Q[1].length+ce;Q[2]=Q[2].substring(0,ce),Q[0]=Q[0].substring(0,Pe).trim(),Q[3]=""}}var Ae=Q[2],Fe="";if(this.options.pedantic){var $e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ae);$e&&(Ae=$e[1],Fe=$e[3])}else Fe=Q[3]?Q[3].slice(1,-1):"";return Ae=Ae.trim(),/^</.test(Ae)&&(this.options.pedantic&&!/>$/.test(G)?Ae=Ae.slice(1):Ae=Ae.slice(1,-1)),ie(Q,{href:Ae&&Ae.replace(this.rules.inline._escapes,"$1"),title:Fe&&Fe.replace(this.rules.inline._escapes,"$1")},Q[0],this.lexer)}},K.reflink=function(V,Q){var G;if((G=this.rules.inline.reflink.exec(V))||(G=this.rules.inline.nolink.exec(V))){var X=(G[2]||G[1]).replace(/\s+/g," ");if(X=Q[X.toLowerCase()],!X||!X.href){var ce=G[0].charAt(0);return{type:"text",raw:ce,text:ce}}return ie(G,X,G[0],this.lexer)}},K.emStrong=function(V,Q,G){G===void 0&&(G="");var X=this.rules.inline.emStrong.lDelim.exec(V);if(!!X&&!(X[3]&&G.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ce=X[1]||X[2]||"";if(!ce||ce&&(G===""||this.rules.inline.punctuation.exec(G))){var pe=X[0].length-1,Pe,Ae,Fe=pe,$e=0,me=X[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,Q=Q.slice(-1*V.length+pe);(X=me.exec(Q))!=null;)if(Pe=X[1]||X[2]||X[3]||X[4]||X[5]||X[6],!!Pe){if(Ae=Pe.length,X[3]||X[4]){Fe+=Ae;continue}else if((X[5]||X[6])&&pe%3&&!((pe+Ae)%3)){$e+=Ae;continue}if(Fe-=Ae,!(Fe>0)){if(Ae=Math.min(Ae,Ae+Fe+$e),Math.min(pe,Ae)%2){var we=V.slice(1,pe+X.index+Ae);return{type:"em",raw:V.slice(0,pe+X.index+Ae+1),text:we,tokens:this.lexer.inlineTokens(we)}}var ye=V.slice(2,pe+X.index+Ae-1);return{type:"strong",raw:V.slice(0,pe+X.index+Ae+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},K.codespan=function(V){var Q=this.rules.inline.code.exec(V);if(Q){var G=Q[2].replace(/\n/g," "),X=/[^ ]/.test(G),ce=/^ /.test(G)&&/ $/.test(G);return X&&ce&&(G=G.substring(1,G.length-1)),G=f(G,!0),{type:"codespan",raw:Q[0],text:G}}},K.br=function(V){var Q=this.rules.inline.br.exec(V);if(Q)return{type:"br",raw:Q[0]}},K.del=function(V){var Q=this.rules.inline.del.exec(V);if(Q)return{type:"del",raw:Q[0],text:Q[2],tokens:this.lexer.inlineTokens(Q[2])}},K.autolink=function(V,Q){var G=this.rules.inline.autolink.exec(V);if(G){var X,ce;return G[2]==="@"?(X=f(this.options.mangle?Q(G[1]):G[1]),ce="mailto:"+X):(X=f(G[1]),ce=X),{type:"link",raw:G[0],text:X,href:ce,tokens:[{type:"text",raw:X,text:X}]}}},K.url=function(V,Q){var G;if(G=this.rules.inline.url.exec(V)){var X,ce;if(G[2]==="@")X=f(this.options.mangle?Q(G[0]):G[0]),ce="mailto:"+X;else{var pe;do pe=G[0],G[0]=this.rules.inline._backpedal.exec(G[0])[0];while(pe!==G[0]);X=f(G[0]),G[1]==="www."?ce="http://"+X:ce=X}return{type:"link",raw:G[0],text:X,href:ce,tokens:[{type:"text",raw:X,text:X}]}}},K.inlineText=function(V,Q){var G=this.rules.inline.text.exec(V);if(G){var X;return this.lexer.state.inRawBlock?X=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):f(G[0]):G[0]:X=f(this.options.smartypants?Q(G[0]):G[0]),{type:"text",raw:G[0],text:X}}},W}(),_={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:c,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};_._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,_._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,_.def=v(_.def).replace("label",_._label).replace("title",_._title).getRegex(),_.bullet=/(?:[*+-]|\d{1,9}[.)])/,_.listItemStart=v(/^( *)(bull) */).replace("bull",_.bullet).getRegex(),_.list=v(_.list).replace(/bull/g,_.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+_.def.source+")").getRegex(),_._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",_._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,_.html=v(_.html,"i").replace("comment",_._comment).replace("tag",_._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),_.paragraph=v(_._paragraph).replace("hr",_.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",_._tag).getRegex(),_.blockquote=v(_.blockquote).replace("paragraph",_.paragraph).getRegex(),_.normal=a({},_),_.gfm=a({},_.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),_.gfm.table=v(_.gfm.table).replace("hr",_.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",_._tag).getRegex(),_.gfm.paragraph=v(_._paragraph).replace("hr",_.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",_.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",_._tag).getRegex(),_.pedantic=a({},_.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",_._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:c,paragraph:v(_.normal._paragraph).replace("hr",_.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",_.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:c,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:c,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=v(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=v(_._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=v(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=v(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=v(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=v(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=v(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=v(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=v(z.reflink).replace("label",z._label).replace("ref",_._label).getRegex(),z.nolink=v(z.nolink).replace("ref",_._label).getRegex(),z.reflinkSearch=v(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=a({},z),z.pedantic=a({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=a({},z.normal,{escape:v(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=v(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=a({},z.gfm,{br:v(z.br).replace("{2,}","*").getRegex(),text:v(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function x(W){return W.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function le(W){var K="",Z,V,Q=W.length;for(Z=0;Z<Q;Z++)V=W.charCodeAt(Z),Math.random()>.5&&(V="x"+V.toString(16)),K+="&#"+V+";";return K}var Ee=function(){function W(Z){this.tokens=[],this.tokens.links=Object.create(null),this.options=Z||ae.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var V={block:_.normal,inline:z.normal};this.options.pedantic?(V.block=_.pedantic,V.inline=z.pedantic):this.options.gfm&&(V.block=_.gfm,this.options.breaks?V.inline=z.breaks:V.inline=z.gfm),this.tokenizer.rules=V}W.lex=function(V,Q){var G=new W(Q);return G.lex(V)},W.lexInline=function(V,Q){var G=new W(Q);return G.inlineTokens(V)};var K=W.prototype;return K.lex=function(V){V=V.replace(/\r\n|\r/g,`
`),this.blockTokens(V,this.tokens);for(var Q;Q=this.inlineQueue.shift();)this.inlineTokens(Q.src,Q.tokens);return this.tokens},K.blockTokens=function(V,Q){var G=this;Q===void 0&&(Q=[]),this.options.pedantic?V=V.replace(/\t/g,"    ").replace(/^ +$/gm,""):V=V.replace(/^( *)(\t+)/gm,function(Fe,$e,me){return $e+"    ".repeat(me.length)});for(var X,ce,pe,Pe;V;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Fe){return(X=Fe.call({lexer:G},V,Q))?(V=V.substring(X.raw.length),Q.push(X),!0):!1}))){if(X=this.tokenizer.space(V)){V=V.substring(X.raw.length),X.raw.length===1&&Q.length>0?Q[Q.length-1].raw+=`
`:Q.push(X);continue}if(X=this.tokenizer.code(V)){V=V.substring(X.raw.length),ce=Q[Q.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+X.raw,ce.text+=`
`+X.text,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):Q.push(X);continue}if(X=this.tokenizer.fences(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.heading(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.hr(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.blockquote(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.list(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.html(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.def(V)){V=V.substring(X.raw.length),ce=Q[Q.length-1],ce&&(ce.type==="paragraph"||ce.type==="text")?(ce.raw+=`
`+X.raw,ce.text+=`
`+X.raw,this.inlineQueue[this.inlineQueue.length-1].src=ce.text):this.tokens.links[X.tag]||(this.tokens.links[X.tag]={href:X.href,title:X.title});continue}if(X=this.tokenizer.table(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.lheading(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(pe=V,this.options.extensions&&this.options.extensions.startBlock&&function(){var Fe=1/0,$e=V.slice(1),me=void 0;G.options.extensions.startBlock.forEach(function(we){me=we.call({lexer:this},$e),typeof me=="number"&&me>=0&&(Fe=Math.min(Fe,me))}),Fe<1/0&&Fe>=0&&(pe=V.substring(0,Fe+1))}(),this.state.top&&(X=this.tokenizer.paragraph(pe))){ce=Q[Q.length-1],Pe&&ce.type==="paragraph"?(ce.raw+=`
`+X.raw,ce.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):Q.push(X),Pe=pe.length!==V.length,V=V.substring(X.raw.length);continue}if(X=this.tokenizer.text(V)){V=V.substring(X.raw.length),ce=Q[Q.length-1],ce&&ce.type==="text"?(ce.raw+=`
`+X.raw,ce.text+=`
`+X.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ce.text):Q.push(X);continue}if(V){var Ae="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return this.state.top=!0,Q},K.inline=function(V,Q){return Q===void 0&&(Q=[]),this.inlineQueue.push({src:V,tokens:Q}),Q},K.inlineTokens=function(V,Q){var G=this;Q===void 0&&(Q=[]);var X,ce,pe,Pe=V,Ae,Fe,$e;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(Ae=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)me.includes(Ae[0].slice(Ae[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ae.index)+"["+$("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ae=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"["+$("a",Ae[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ae=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ae.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;)if(Fe||($e=""),Fe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(X=ye.call({lexer:G},V,Q))?(V=V.substring(X.raw.length),Q.push(X),!0):!1}))){if(X=this.tokenizer.escape(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.tag(V)){V=V.substring(X.raw.length),ce=Q[Q.length-1],ce&&X.type==="text"&&ce.type==="text"?(ce.raw+=X.raw,ce.text+=X.text):Q.push(X);continue}if(X=this.tokenizer.link(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(X.raw.length),ce=Q[Q.length-1],ce&&X.type==="text"&&ce.type==="text"?(ce.raw+=X.raw,ce.text+=X.text):Q.push(X);continue}if(X=this.tokenizer.emStrong(V,Pe,$e)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.codespan(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.br(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.del(V)){V=V.substring(X.raw.length),Q.push(X);continue}if(X=this.tokenizer.autolink(V,le)){V=V.substring(X.raw.length),Q.push(X);continue}if(!this.state.inLink&&(X=this.tokenizer.url(V,le))){V=V.substring(X.raw.length),Q.push(X);continue}if(pe=V,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Me=V.slice(1),je=void 0;G.options.extensions.startInline.forEach(function(Ye){je=Ye.call({lexer:this},Me),typeof je=="number"&&je>=0&&(ye=Math.min(ye,je))}),ye<1/0&&ye>=0&&(pe=V.substring(0,ye+1))}(),X=this.tokenizer.inlineText(pe,x)){V=V.substring(X.raw.length),X.raw.slice(-1)!=="_"&&($e=X.raw.slice(-1)),Fe=!0,ce=Q[Q.length-1],ce&&ce.type==="text"?(ce.raw+=X.raw,ce.text+=X.text):Q.push(X);continue}if(V){var we="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return Q},E(W,null,[{key:"rules",get:function(){return{block:_,inline:z}}}]),W}(),Y=function(){function W(Z){this.options=Z||ae.defaults}var K=W.prototype;return K.code=function(V,Q,G){var X=(Q||"").match(/\S*/)[0];if(this.options.highlight){var ce=this.options.highlight(V,X);ce!=null&&ce!==V&&(G=!0,V=ce)}return V=V.replace(/\n$/,"")+`
`,X?'<pre><code class="'+this.options.langPrefix+f(X,!0)+'">'+(G?V:f(V,!0))+`</code></pre>
`:"<pre><code>"+(G?V:f(V,!0))+`</code></pre>
`},K.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},K.html=function(V){return V},K.heading=function(V,Q,G,X){if(this.options.headerIds){var ce=this.options.headerPrefix+X.slug(G);return"<h"+Q+' id="'+ce+'">'+V+"</h"+Q+`>
`}return"<h"+Q+">"+V+"</h"+Q+`>
`},K.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},K.list=function(V,Q,G){var X=Q?"ol":"ul",ce=Q&&G!==1?' start="'+G+'"':"";return"<"+X+ce+`>
`+V+"</"+X+`>
`},K.listitem=function(V){return"<li>"+V+`</li>
`},K.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},K.paragraph=function(V){return"<p>"+V+`</p>
`},K.table=function(V,Q){return Q&&(Q="<tbody>"+Q+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+Q+`</table>
`},K.tablerow=function(V){return`<tr>
`+V+`</tr>
`},K.tablecell=function(V,Q){var G=Q.header?"th":"td",X=Q.align?"<"+G+' align="'+Q.align+'">':"<"+G+">";return X+V+("</"+G+`>
`)},K.strong=function(V){return"<strong>"+V+"</strong>"},K.em=function(V){return"<em>"+V+"</em>"},K.codespan=function(V){return"<code>"+V+"</code>"},K.br=function(){return this.options.xhtml?"<br/>":"<br>"},K.del=function(V){return"<del>"+V+"</del>"},K.link=function(V,Q,G){if(V=A(this.options.sanitize,this.options.baseUrl,V),V===null)return G;var X='<a href="'+f(V)+'"';return Q&&(X+=' title="'+Q+'"'),X+=">"+G+"</a>",X},K.image=function(V,Q,G){if(V=A(this.options.sanitize,this.options.baseUrl,V),V===null)return G;var X='<img src="'+V+'" alt="'+G+'"';return Q&&(X+=' title="'+Q+'"'),X+=this.options.xhtml?"/>":">",X},K.text=function(V){return V},W}(),H=function(){function W(){}var K=W.prototype;return K.strong=function(V){return V},K.em=function(V){return V},K.codespan=function(V){return V},K.del=function(V){return V},K.html=function(V){return V},K.text=function(V){return V},K.link=function(V,Q,G){return""+G},K.image=function(V,Q,G){return""+G},K.br=function(){return""},W}(),U=function(){function W(){this.seen={}}var K=W.prototype;return K.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},K.getNextSafeSlug=function(V,Q){var G=V,X=0;if(this.seen.hasOwnProperty(G)){X=this.seen[V];do X++,G=V+"-"+X;while(this.seen.hasOwnProperty(G))}return Q||(this.seen[V]=X,this.seen[G]=0),G},K.slug=function(V,Q){Q===void 0&&(Q={});var G=this.serialize(V);return this.getNextSafeSlug(G,Q.dryrun)},W}(),te=function(){function W(Z){this.options=Z||ae.defaults,this.options.renderer=this.options.renderer||new Y,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new H,this.slugger=new U}W.parse=function(V,Q){var G=new W(Q);return G.parse(V)},W.parseInline=function(V,Q){var G=new W(Q);return G.parseInline(V)};var K=W.prototype;return K.parse=function(V,Q){Q===void 0&&(Q=!0);var G="",X,ce,pe,Pe,Ae,Fe,$e,me,we,ye,Me,je,Ye,He,Ke,Je,nt,xe,Ge,et=V.length;for(X=0;X<et;X++){if(ye=V[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(Ge=this.options.extensions.renderers[ye.type].call({parser:this},ye),Ge!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){G+=Ge||"";continue}switch(ye.type){case"space":continue;case"hr":{G+=this.renderer.hr();continue}case"heading":{G+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,u(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{G+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(me="",$e="",Pe=ye.header.length,ce=0;ce<Pe;ce++)$e+=this.renderer.tablecell(this.parseInline(ye.header[ce].tokens),{header:!0,align:ye.align[ce]});for(me+=this.renderer.tablerow($e),we="",Pe=ye.rows.length,ce=0;ce<Pe;ce++){for(Fe=ye.rows[ce],$e="",Ae=Fe.length,pe=0;pe<Ae;pe++)$e+=this.renderer.tablecell(this.parseInline(Fe[pe].tokens),{header:!1,align:ye.align[pe]});we+=this.renderer.tablerow($e)}G+=this.renderer.table(me,we);continue}case"blockquote":{we=this.parse(ye.tokens),G+=this.renderer.blockquote(we);continue}case"list":{for(Me=ye.ordered,je=ye.start,Ye=ye.loose,Pe=ye.items.length,we="",ce=0;ce<Pe;ce++)Ke=ye.items[ce],Je=Ke.checked,nt=Ke.task,He="",Ke.task&&(xe=this.renderer.checkbox(Je),Ye?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=xe+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=xe+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:xe}):He+=xe),He+=this.parse(Ke.tokens,Ye),we+=this.renderer.listitem(He,nt,Je);G+=this.renderer.list(we,Me,je);continue}case"html":{G+=this.renderer.html(ye.text);continue}case"paragraph":{G+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(we=ye.tokens?this.parseInline(ye.tokens):ye.text;X+1<et&&V[X+1].type==="text";)ye=V[++X],we+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);G+=Q?this.renderer.paragraph(we):we;continue}default:{var ue='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(ue);return}else throw new Error(ue)}}}return G},K.parseInline=function(V,Q){Q=Q||this.renderer;var G="",X,ce,pe,Pe=V.length;for(X=0;X<Pe;X++){if(ce=V[X],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ce.type]&&(pe=this.options.extensions.renderers[ce.type].call({parser:this},ce),pe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ce.type))){G+=pe||"";continue}switch(ce.type){case"escape":{G+=Q.text(ce.text);break}case"html":{G+=Q.html(ce.text);break}case"link":{G+=Q.link(ce.href,ce.title,this.parseInline(ce.tokens,Q));break}case"image":{G+=Q.image(ce.href,ce.title,ce.text);break}case"strong":{G+=Q.strong(this.parseInline(ce.tokens,Q));break}case"em":{G+=Q.em(this.parseInline(ce.tokens,Q));break}case"codespan":{G+=Q.codespan(ce.text);break}case"br":{G+=Q.br();break}case"del":{G+=Q.del(this.parseInline(ce.tokens,Q));break}case"text":{G+=Q.text(ce.text);break}default:{var Ae='Token with "'+ce.type+'" type was not found.';if(this.options.silent){console.error(Ae);return}else throw new Error(Ae)}}}return G},W}();function re(W,K,Z){if(typeof W>"u"||W===null)throw new Error("marked(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");if(typeof K=="function"&&(Z=K,K=null),K=a({},re.defaults,K||{}),L(K),Z){var V=K.highlight,Q;try{Q=Ee.lex(W,K)}catch(Pe){return Z(Pe)}var G=function(Ae){var Fe;if(!Ae)try{K.walkTokens&&re.walkTokens(Q,K.walkTokens),Fe=te.parse(Q,K)}catch($e){Ae=$e}return K.highlight=V,Ae?Z(Ae):Z(null,Fe)};if(!V||V.length<3||(delete K.highlight,!Q.length))return G();var X=0;re.walkTokens(Q,function(Pe){Pe.type==="code"&&(X++,setTimeout(function(){V(Pe.text,Pe.lang,function(Ae,Fe){if(Ae)return G(Ae);Fe!=null&&Fe!==Pe.text&&(Pe.text=Fe,Pe.escaped=!0),X--,X===0&&G()})},0))}),X===0&&G();return}function ce(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,K.silent)return"<p>An error occurred:</p><pre>"+f(Pe.message+"",!0)+"</pre>";throw Pe}try{var pe=Ee.lex(W,K);if(K.walkTokens){if(K.async)return Promise.all(re.walkTokens(pe,K.walkTokens)).then(function(){return te.parse(pe,K)}).catch(ce);re.walkTokens(pe,K.walkTokens)}return te.parse(pe,K)}catch(Pe){ce(Pe)}}re.options=re.setOptions=function(W){return a(re.defaults,W),P(re.defaults),re},re.getDefaults=C,re.defaults=ae.defaults,re.use=function(){for(var W=arguments.length,K=new Array(W),Z=0;Z<W;Z++)K[Z]=arguments[Z];var V=a.apply(void 0,[{}].concat(K)),Q=re.defaults.extensions||{renderers:{},childTokens:{}},G;K.forEach(function(X){if(X.extensions&&(G=!0,X.extensions.forEach(function(pe){if(!pe.name)throw new Error("extension name required");if(pe.renderer){var Pe=Q.renderers?Q.renderers[pe.name]:null;Pe?Q.renderers[pe.name]=function(){for(var Ae=arguments.length,Fe=new Array(Ae),$e=0;$e<Ae;$e++)Fe[$e]=arguments[$e];var me=pe.renderer.apply(this,Fe);return me===!1&&(me=Pe.apply(this,Fe)),me}:Q.renderers[pe.name]=pe.renderer}if(pe.tokenizer){if(!pe.level||pe.level!=="block"&&pe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Q[pe.level]?Q[pe.level].unshift(pe.tokenizer):Q[pe.level]=[pe.tokenizer],pe.start&&(pe.level==="block"?Q.startBlock?Q.startBlock.push(pe.start):Q.startBlock=[pe.start]:pe.level==="inline"&&(Q.startInline?Q.startInline.push(pe.start):Q.startInline=[pe.start]))}pe.childTokens&&(Q.childTokens[pe.name]=pe.childTokens)})),X.renderer&&function(){var pe=re.defaults.renderer||new Y,Pe=function($e){var me=pe[$e];pe[$e]=function(){for(var we=arguments.length,ye=new Array(we),Me=0;Me<we;Me++)ye[Me]=arguments[Me];var je=X.renderer[$e].apply(pe,ye);return je===!1&&(je=me.apply(pe,ye)),je}};for(var Ae in X.renderer)Pe(Ae);V.renderer=pe}(),X.tokenizer&&function(){var pe=re.defaults.tokenizer||new F,Pe=function($e){var me=pe[$e];pe[$e]=function(){for(var we=arguments.length,ye=new Array(we),Me=0;Me<we;Me++)ye[Me]=arguments[Me];var je=X.tokenizer[$e].apply(pe,ye);return je===!1&&(je=me.apply(pe,ye)),je}};for(var Ae in X.tokenizer)Pe(Ae);V.tokenizer=pe}(),X.walkTokens){var ce=re.defaults.walkTokens;V.walkTokens=function(pe){var Pe=[];return Pe.push(X.walkTokens.call(this,pe)),ce&&(Pe=Pe.concat(ce.call(this,pe))),Pe}}G&&(V.extensions=Q),re.setOptions(V)})},re.walkTokens=function(W,K){for(var Z=[],V=function(){var ce=G.value;switch(Z=Z.concat(K.call(re,ce)),ce.type){case"table":{for(var pe=I(ce.header),Pe;!(Pe=pe()).done;){var Ae=Pe.value;Z=Z.concat(re.walkTokens(Ae.tokens,K))}for(var Fe=I(ce.rows),$e;!($e=Fe()).done;)for(var me=$e.value,we=I(me),ye;!(ye=we()).done;){var Me=ye.value;Z=Z.concat(re.walkTokens(Me.tokens,K))}break}case"list":{Z=Z.concat(re.walkTokens(ce.items,K));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[ce.type]?re.defaults.extensions.childTokens[ce.type].forEach(function(je){Z=Z.concat(re.walkTokens(ce[je],K))}):ce.tokens&&(Z=Z.concat(re.walkTokens(ce.tokens,K)))}},Q=I(W),G;!(G=Q()).done;)V();return Z},re.parseInline=function(W,K){if(typeof W>"u"||W===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof W!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(W)+", string expected");K=a({},re.defaults,K||{}),L(K);try{var Z=Ee.lexInline(W,K);return K.walkTokens&&re.walkTokens(Z,K.walkTokens),te.parseInline(Z,K)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,K.silent)return"<p>An error occurred:</p><pre>"+f(V.message+"",!0)+"</pre>";throw V}},re.Parser=te,re.parser=te.parse,re.Renderer=Y,re.TextRenderer=H,re.Lexer=Ee,re.lexer=Ee.lex,re.Tokenizer=F,re.Slugger=U,re.parse=re;var de=re.options,oe=re.setOptions,j=re.use,N=re.walkTokens,M=re.parseInline,q=re,ee=te.parse,fe=Ee.lex;ae.Lexer=Ee,ae.Parser=te,ae.Renderer=Y,ae.Slugger=U,ae.TextRenderer=H,ae.Tokenizer=F,ae.getDefaults=C,ae.lexer=fe,ae.marked=re,ae.options=de,ae.parse=q,ae.parseInline=M,ae.parser=ee,ae.setOptions=oe,ae.use=j,ae.walkTokens=N,Object.defineProperty(ae,"__esModule",{value:!0})}),define(ve[88],be([1,0,27]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const k=new E.LRUCache(1e4);function l(y){return w(y,"NFC",k)}e.normalizeNFC=l;const I=new E.LRUCache(1e4);function C(y){return w(y,"NFD",I)}e.normalizeNFD=C;const P=/[^\u0000-\u0080]/;function w(y,T,S){if(!y)return y;const b=S.get(y);if(b)return b;let g;return P.test(y)?g=y.normalize(T):g=y,S.set(y,g),g}e.removeAccents=function(){const y=/[\u0300-\u036f]/g;return function(T){return C(T).replace(y,"")}}()}),define(ve[143],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(P,w,y){return Math.min(Math.max(P,w),y)}e.clamp=E;function k(P,w){return(w+P%w)%w}e.rot=k;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class I{constructor(){this.a=1,this.b=0}update(w){return this.b=this.b+(w-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=I;class C{constructor(w){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(w),this.c.fill(0,0,w)}update(w){const y=this.c[this.d];return this.c[this.d]=w,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=w,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=C}),function(){function ae(l){const I=[];typeof l=="number"&&I.push("code/timeOrigin",l);function C(w){I.push(w,Date.now())}function P(){const w=[];for(let y=0;y<I.length;y+=2)w.push({name:I[y],startTime:I[y+1]});return w}return{mark:C,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const C of performance.getEntriesByType("mark"))I.push({name:C.name,startTime:Math.round(l+C.startTime)});return I}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function E(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=E(k))}(),function(ae,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var k in E)(typeof exports=="object"?exports:ae)[k]=E[k]}}(typeof self<"u"?self:this,function(){return function(ae){var e={};function E(k){if(e[k])return e[k].exports;var l=e[k]={i:k,l:!1,exports:{}};return ae[k].call(l.exports,l,l.exports,E),l.l=!0,l.exports}return E.m=ae,E.c=e,E.d=function(k,l,I){E.o(k,l)||Object.defineProperty(k,l,{enumerable:!0,get:I})},E.r=function(k){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},E.t=function(k,l){if(1&l&&(k=E(k)),8&l||4&l&&typeof k=="object"&&k&&k.__esModule)return k;var I=Object.create(null);if(E.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:k}),2&l&&typeof k!="string")for(var C in k)E.d(I,C,function(P){return k[P]}.bind(null,C));return I},E.n=function(k){var l=k&&k.__esModule?function(){return k.default}:function(){return k};return E.d(l,"a",l),l},E.o=function(k,l){return Object.prototype.hasOwnProperty.call(k,l)},E.p="",E(E.s=0)}([function(ae,e,E){(function(k){var l;e=ae.exports=j,l=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,C=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],w=e.src=[],y=0,T=y++;w[T]="0|[1-9]\\d*";var S=y++;w[S]="[0-9]+";var b=y++;w[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=y++;w[g]="("+w[T]+")\\.("+w[T]+")\\.("+w[T]+")";var f=y++;w[f]="("+w[S]+")\\.("+w[S]+")\\.("+w[S]+")";var p=y++;w[p]="(?:"+w[T]+"|"+w[b]+")";var u=y++;w[u]="(?:"+w[S]+"|"+w[b]+")";var h=y++;w[h]="(?:-("+w[p]+"(?:\\."+w[p]+")*))";var v=y++;w[v]="(?:-?("+w[u]+"(?:\\."+w[u]+")*))";var d=y++;w[d]="[0-9A-Za-z-]+";var D=y++;w[D]="(?:\\+("+w[d]+"(?:\\."+w[d]+")*))";var A=y++,t="v?"+w[g]+w[h]+"?"+w[D]+"?";w[A]="^"+t+"$";var r="[v=\\s]*"+w[f]+w[v]+"?"+w[D]+"?",n=y++;w[n]="^"+r+"$";var i=y++;w[i]="((?:<|>)?=?)";var o=y++;w[o]=w[S]+"|x|X|\\*";var c=y++;w[c]=w[T]+"|x|X|\\*";var a=y++;w[a]="[v=\\s]*("+w[c]+")(?:\\.("+w[c]+")(?:\\.("+w[c]+")(?:"+w[h]+")?"+w[D]+"?)?)?";var s=y++;w[s]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[v]+")?"+w[D]+"?)?)?";var m=y++;w[m]="^"+w[i]+"\\s*"+w[a]+"$";var R=y++;w[R]="^"+w[i]+"\\s*"+w[s]+"$";var L=y++;w[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var $=y++;w[$]="(?:~>?)";var ie=y++;w[ie]="(\\s*)"+w[$]+"\\s+",P[ie]=new RegExp(w[ie],"g");var ne=y++;w[ne]="^"+w[$]+w[a]+"$";var F=y++;w[F]="^"+w[$]+w[s]+"$";var _=y++;w[_]="(?:\\^)";var z=y++;w[z]="(\\s*)"+w[_]+"\\s+",P[z]=new RegExp(w[z],"g");var x=y++;w[x]="^"+w[_]+w[a]+"$";var le=y++;w[le]="^"+w[_]+w[s]+"$";var Ee=y++;w[Ee]="^"+w[i]+"\\s*("+r+")$|^$";var Y=y++;w[Y]="^"+w[i]+"\\s*("+t+")$|^$";var H=y++;w[H]="(\\s*)"+w[i]+"\\s*("+r+"|"+w[a]+")",P[H]=new RegExp(w[H],"g");var U=y++;w[U]="^\\s*("+w[a]+")\\s+-\\s+("+w[a]+")\\s*$";var te=y++;w[te]="^\\s*("+w[s]+")\\s+-\\s+("+w[s]+")\\s*$";var re=y++;w[re]="(<|>)?=?\\s*\\*";for(var de=0;de<35;de++)l(de,w[de]),P[de]||(P[de]=new RegExp(w[de]));function oe(me,we){if(me instanceof j)return me;if(typeof me!="string"||me.length>I||!(we?P[n]:P[A]).test(me))return null;try{return new j(me,we)}catch{return null}}function j(me,we){if(me instanceof j){if(me.loose===we)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof j))return new j(me,we);l("SemVer",me,we),this.loose=we;var ye=me.trim().match(we?P[n]:P[A]);if(!ye)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>C||this.major<0)throw new TypeError("Invalid major version");if(this.minor>C||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>C||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var je=+Me;if(je>=0&&je<C)return je}return Me}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=oe,e.valid=function(me,we){var ye=oe(me,we);return ye?ye.version:null},e.clean=function(me,we){var ye=oe(me.trim().replace(/^[=v]+/,""),we);return ye?ye.version:null},e.SemVer=j,j.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},j.prototype.toString=function(){return this.version},j.prototype.compare=function(me){return l("SemVer.compare",this.version,this.loose,me),me instanceof j||(me=new j(me,this.loose)),this.compareMain(me)||this.comparePre(me)},j.prototype.compareMain=function(me){return me instanceof j||(me=new j(me,this.loose)),M(this.major,me.major)||M(this.minor,me.minor)||M(this.patch,me.patch)},j.prototype.comparePre=function(me){if(me instanceof j||(me=new j(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var we=0;do{var ye=this.prerelease[we],Me=me.prerelease[we];if(l("prerelease compare",we,ye,Me),ye===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(ye===void 0)return-1;if(ye!==Me)return M(ye,Me)}while(++we)},j.prototype.inc=function(me,we){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",we);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",we);break;case"prepatch":this.prerelease.length=0,this.inc("patch",we),this.inc("pre",we);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",we),this.inc("pre",we);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}we&&(this.prerelease[0]===we?isNaN(this.prerelease[1])&&(this.prerelease=[we,0]):this.prerelease=[we,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,we,ye,Me){typeof ye=="string"&&(Me=ye,ye=void 0);try{return new j(me,ye).inc(we,Me).version}catch{return null}},e.diff=function(me,we){if(W(me,we))return null;var ye=oe(me),Me=oe(we);if(ye.prerelease.length||Me.prerelease.length){for(var je in ye)if((je==="major"||je==="minor"||je==="patch")&&ye[je]!==Me[je])return"pre"+je;return"prerelease"}for(var je in ye)if((je==="major"||je==="minor"||je==="patch")&&ye[je]!==Me[je])return je},e.compareIdentifiers=M;var N=/^[0-9]+$/;function M(me,we){var ye=N.test(me),Me=N.test(we);return ye&&Me&&(me=+me,we=+we),ye&&!Me?-1:Me&&!ye?1:me<we?-1:me>we?1:0}function q(me,we,ye){return new j(me,ye).compare(new j(we,ye))}function ee(me,we,ye){return q(me,we,ye)>0}function fe(me,we,ye){return q(me,we,ye)<0}function W(me,we,ye){return q(me,we,ye)===0}function K(me,we,ye){return q(me,we,ye)!==0}function Z(me,we,ye){return q(me,we,ye)>=0}function V(me,we,ye){return q(me,we,ye)<=0}function Q(me,we,ye,Me){var je;switch(we){case"===":typeof me=="object"&&(me=me.version),typeof ye=="object"&&(ye=ye.version),je=me===ye;break;case"!==":typeof me=="object"&&(me=me.version),typeof ye=="object"&&(ye=ye.version),je=me!==ye;break;case"":case"=":case"==":je=W(me,ye,Me);break;case"!=":je=K(me,ye,Me);break;case">":je=ee(me,ye,Me);break;case">=":je=Z(me,ye,Me);break;case"<":je=fe(me,ye,Me);break;case"<=":je=V(me,ye,Me);break;default:throw new TypeError("Invalid operator: "+we)}return je}function G(me,we){if(me instanceof G){if(me.loose===we)return me;me=me.value}if(!(this instanceof G))return new G(me,we);l("comparator",me,we),this.loose=we,this.parse(me),this.semver===X?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(me,we){return M(we,me)},e.major=function(me,we){return new j(me,we).major},e.minor=function(me,we){return new j(me,we).minor},e.patch=function(me,we){return new j(me,we).patch},e.compare=q,e.compareLoose=function(me,we){return q(me,we,!0)},e.rcompare=function(me,we,ye){return q(we,me,ye)},e.sort=function(me,we){return me.sort(function(ye,Me){return e.compare(ye,Me,we)})},e.rsort=function(me,we){return me.sort(function(ye,Me){return e.rcompare(ye,Me,we)})},e.gt=ee,e.lt=fe,e.eq=W,e.neq=K,e.gte=Z,e.lte=V,e.cmp=Q,e.Comparator=G;var X={};function ce(me,we){if(me instanceof ce)return me.loose===we?me:new ce(me.raw,we);if(me instanceof G)return new ce(me.value,we);if(!(this instanceof ce))return new ce(me,we);if(this.loose=we,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function pe(me){return!me||me.toLowerCase()==="x"||me==="*"}function Pe(me,we,ye,Me,je,Ye,He,Ke,Je,nt,xe,Ge,et){return((we=pe(ye)?"":pe(Me)?">="+ye+".0.0":pe(je)?">="+ye+"."+Me+".0":">="+we)+" "+(Ke=pe(Je)?"":pe(nt)?"<"+(+Je+1)+".0.0":pe(xe)?"<"+Je+"."+(+nt+1)+".0":Ge?"<="+Je+"."+nt+"."+xe+"-"+Ge:"<="+Ke)).trim()}function Ae(me,we){for(var ye=0;ye<me.length;ye++)if(!me[ye].test(we))return!1;if(we.prerelease.length){for(ye=0;ye<me.length;ye++)if(l(me[ye].semver),me[ye].semver!==X&&me[ye].semver.prerelease.length>0){var Me=me[ye].semver;if(Me.major===we.major&&Me.minor===we.minor&&Me.patch===we.patch)return!0}return!1}return!0}function Fe(me,we,ye){try{we=new ce(we,ye)}catch{return!1}return we.test(me)}function $e(me,we,ye,Me){var je,Ye,He,Ke,Je;switch(me=new j(me,Me),we=new ce(we,Me),ye){case">":je=ee,Ye=V,He=fe,Ke=">",Je=">=";break;case"<":je=fe,Ye=Z,He=ee,Ke="<",Je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Fe(me,we,Me))return!1;for(var nt=0;nt<we.set.length;++nt){var xe=we.set[nt],Ge=null,et=null;if(xe.forEach(function(ue){ue.semver===X&&(ue=new G(">=0.0.0")),Ge=Ge||ue,et=et||ue,je(ue.semver,Ge.semver,Me)?Ge=ue:He(ue.semver,et.semver,Me)&&(et=ue)}),Ge.operator===Ke||Ge.operator===Je||(!et.operator||et.operator===Ke)&&Ye(me,et.semver)||et.operator===Je&&He(me,et.semver))return!1}return!0}G.prototype.parse=function(me){var we=this.loose?P[Ee]:P[Y],ye=me.match(we);if(!ye)throw new TypeError("Invalid comparator: "+me);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new j(ye[2],this.loose):this.semver=X},G.prototype.toString=function(){return this.value},G.prototype.test=function(me){return l("Comparator.test",me,this.loose),this.semver===X||(typeof me=="string"&&(me=new j(me,this.loose)),Q(me,this.operator,this.semver,this.loose))},G.prototype.intersects=function(me,we){if(!(me instanceof G))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new ce(me.value,we),Fe(this.value,ye,we);if(me.operator==="")return ye=new ce(this.value,we),Fe(me.semver,ye,we);var Me=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),Ye=this.semver.version===me.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Ke=Q(this.semver,"<",me.semver,we)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),Je=Q(this.semver,">",me.semver,we)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return Me||je||Ye&&He||Ke||Je},e.Range=ce,ce.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},ce.prototype.toString=function(){return this.range},ce.prototype.parseRange=function(me){var we=this.loose;me=me.trim(),l("range",me,we);var ye=we?P[te]:P[U];me=me.replace(ye,Pe),l("hyphen replace",me),me=me.replace(P[H],"$1$2$3"),l("comparator trim",me,P[H]),me=(me=(me=me.replace(P[ie],"$1~")).replace(P[z],"$1^")).split(/\s+/).join(" ");var Me=we?P[Ee]:P[Y],je=me.split(" ").map(function(Ye){return function(He,Ke){return l("comp",He),He=function(Je,nt){return Je.trim().split(/\s+/).map(function(xe){return function(Ge,et){l("caret",Ge,et);var ue=et?P[le]:P[x];return Ge.replace(ue,function(Ie,Ce,Le,Ne,ze){var Ve;return l("caret",Ge,Ie,Ce,Le,Ne,ze),pe(Ce)?Ve="":pe(Le)?Ve=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":pe(Ne)?Ve=Ce==="0"?">="+Ce+"."+Le+".0 <"+Ce+"."+(+Le+1)+".0":">="+Ce+"."+Le+".0 <"+(+Ce+1)+".0.0":ze?(l("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ve=Ce==="0"?Le==="0"?">="+Ce+"."+Le+"."+Ne+ze+" <"+Ce+"."+Le+"."+(+Ne+1):">="+Ce+"."+Le+"."+Ne+ze+" <"+Ce+"."+(+Le+1)+".0":">="+Ce+"."+Le+"."+Ne+ze+" <"+(+Ce+1)+".0.0"):(l("no pr"),Ve=Ce==="0"?Le==="0"?">="+Ce+"."+Le+"."+Ne+" <"+Ce+"."+Le+"."+(+Ne+1):">="+Ce+"."+Le+"."+Ne+" <"+Ce+"."+(+Le+1)+".0":">="+Ce+"."+Le+"."+Ne+" <"+(+Ce+1)+".0.0"),l("caret return",Ve),Ve})}(xe,nt)}).join(" ")}(He,Ke),l("caret",He),He=function(Je,nt){return Je.trim().split(/\s+/).map(function(xe){return function(Ge,et){var ue=et?P[F]:P[ne];return Ge.replace(ue,function(Ie,Ce,Le,Ne,ze){var Ve;return l("tilde",Ge,Ie,Ce,Le,Ne,ze),pe(Ce)?Ve="":pe(Le)?Ve=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":pe(Ne)?Ve=">="+Ce+"."+Le+".0 <"+Ce+"."+(+Le+1)+".0":ze?(l("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Ve=">="+Ce+"."+Le+"."+Ne+ze+" <"+Ce+"."+(+Le+1)+".0"):Ve=">="+Ce+"."+Le+"."+Ne+" <"+Ce+"."+(+Le+1)+".0",l("tilde return",Ve),Ve})}(xe,nt)}).join(" ")}(He,Ke),l("tildes",He),He=function(Je,nt){return l("replaceXRanges",Je,nt),Je.split(/\s+/).map(function(xe){return function(Ge,et){Ge=Ge.trim();var ue=et?P[R]:P[m];return Ge.replace(ue,function(Ie,Ce,Le,Ne,ze,Ve){l("xRange",Ge,Ie,Ce,Le,Ne,ze,Ve);var Xe=pe(Le),st=Xe||pe(Ne),Ze=st||pe(ze);return Ce==="="&&Ze&&(Ce=""),Xe?Ie=Ce===">"||Ce==="<"?"<0.0.0":"*":Ce&&Ze?(st&&(Ne=0),Ze&&(ze=0),Ce===">"?(Ce=">=",st?(Le=+Le+1,Ne=0,ze=0):Ze&&(Ne=+Ne+1,ze=0)):Ce==="<="&&(Ce="<",st?Le=+Le+1:Ne=+Ne+1),Ie=Ce+Le+"."+Ne+"."+ze):st?Ie=">="+Le+".0.0 <"+(+Le+1)+".0.0":Ze&&(Ie=">="+Le+"."+Ne+".0 <"+Le+"."+(+Ne+1)+".0"),l("xRange return",Ie),Ie})}(xe,nt)}).join(" ")}(He,Ke),l("xrange",He),He=function(Je,nt){return l("replaceStars",Je,nt),Je.trim().replace(P[re],"")}(He,Ke),l("stars",He),He}(Ye,we)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Ye){return!!Ye.match(Me)})),je=je.map(function(Ye){return new G(Ye,we)})},ce.prototype.intersects=function(me,we){if(!(me instanceof ce))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Me){return me.set.some(function(je){return je.every(function(Ye){return Me.intersects(Ye,we)})})})})},e.toComparators=function(me,we){return new ce(me,we).set.map(function(ye){return ye.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},ce.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new j(me,this.loose));for(var we=0;we<this.set.length;we++)if(Ae(this.set[we],me))return!0;return!1},e.satisfies=Fe,e.maxSatisfying=function(me,we,ye){var Me=null,je=null;try{var Ye=new ce(we,ye)}catch{return null}return me.forEach(function(He){Ye.test(He)&&(Me&&je.compare(He)!==-1||(je=new j(Me=He,ye)))}),Me},e.minSatisfying=function(me,we,ye){var Me=null,je=null;try{var Ye=new ce(we,ye)}catch{return null}return me.forEach(function(He){Ye.test(He)&&(Me&&je.compare(He)!==1||(je=new j(Me=He,ye)))}),Me},e.validRange=function(me,we){try{return new ce(me,we).range||"*"}catch{return null}},e.ltr=function(me,we,ye){return $e(me,we,"<",ye)},e.gtr=function(me,we,ye){return $e(me,we,">",ye)},e.outside=$e,e.prerelease=function(me,we){var ye=oe(me,we);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(me,we,ye){return me=new ce(me,ye),we=new ce(we,ye),me.intersects(we)},e.coerce=function(me){if(me instanceof j)return me;if(typeof me!="string")return null;var we=me.match(P[L]);return we==null?null:oe((we[1]||"0")+"."+(we[2]||"0")+"."+(we[3]||"0"))}}).call(this,E(1))},function(ae,e){var E,k,l=ae.exports={};function I(){throw new Error("setTimeout has not been defined")}function C(){throw new Error("clearTimeout has not been defined")}function P(u){if(E===setTimeout)return setTimeout(u,0);if((E===I||!E)&&setTimeout)return E=setTimeout,setTimeout(u,0);try{return E(u,0)}catch{try{return E.call(null,u,0)}catch{return E.call(this,u,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:I}catch{E=I}try{k=typeof clearTimeout=="function"?clearTimeout:C}catch{k=C}})();var w,y=[],T=!1,S=-1;function b(){T&&w&&(T=!1,w.length?y=w.concat(y):S=-1,y.length&&g())}function g(){if(!T){var u=P(b);T=!0;for(var h=y.length;h;){for(w=y,y=[];++S<h;)w&&w[S].run();S=-1,h=y.length}w=null,T=!1,function(v){if(k===clearTimeout)return clearTimeout(v);if((k===C||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(v);try{k(v)}catch{try{return k.call(null,v)}catch{return k.call(this,v)}}}(u)}}function f(u,h){this.fun=u,this.array=h}function p(){}l.nextTick=function(u){var h=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)h[v-1]=arguments[v];y.push(new f(u,h)),y.length!==1||T||P(g)},f.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=p,l.addListener=p,l.once=p,l.off=p,l.removeListener=p,l.removeAllListeners=p,l.emit=p,l.prependListener=p,l.prependOnceListener=p,l.listeners=function(u){return[]},l.binding=function(u){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(u){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(ve[144],be([1,0]),function(ae,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class k{constructor(P,w,y){this.level=P,this.key=w,this.value=y,this.forward=[]}}const l=void 0;class I{constructor(P,w=2**16){this.comparator=P,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new k(this.c,l,l)}get size(){return this.f}clear(){this.e=new k(this.c,l,l)}has(P){return Boolean(I.g(this,P,this.comparator))}get(P){return I.g(this,P,this.comparator)?.value}set(P,w){return I.h(this,P,w,this.comparator)&&(this.f+=1),this}delete(P){const w=I.k(this,P,this.comparator);return w&&(this.f-=1),w}forEach(P,w){let y=this.e.forward[0];for(;y;)P.call(w,y.value,y.key,this),y=y.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",w=this.e.forward[0];for(;w;)P+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return P}static g(P,w,y){let T=P.e;for(let S=P.d-1;S>=0;S--)for(;T.forward[S]&&y(T.forward[S].key,w)<0;)T=T.forward[S];if(T=T.forward[0],T&&y(T.key,w)===0)return T}static h(P,w,y,T){const S=[];let b=P.e;for(let g=P.d-1;g>=0;g--){for(;b.forward[g]&&T(b.forward[g].key,w)<0;)b=b.forward[g];S[g]=b}if(b=b.forward[0],b&&T(b.key,w)===0)return b.value=y,!1;{const g=I.j(P);if(g>P.d){for(let f=P.d;f<g;f++)S[f]=P.e;P.d=g}b=new k(g,w,y);for(let f=0;f<g;f++)b.forward[f]=S[f].forward[f],S[f].forward[f]=b;return!0}}static j(P,w=.5){let y=1;for(;Math.random()<w&&y<P.c;)y+=1;return y}static k(P,w,y){const T=[];let S=P.e;for(let b=P.d-1;b>=0;b--){for(;S.forward[b]&&y(S.forward[b].key,w)<0;)S=S.forward[b];T[b]=S}if(S=S.forward[0],!S||y(S.key,w)!==0)return!1;for(let b=0;b<P.d&&T[b].forward[b]===S;b++)T[b].forward[b]=S.forward[b];for(;P.d>0&&P.e.forward[P.d-1]===l;)P.d-=1;return!0}}e.SkipList=I}),define(ve[44],be([1,0,9,2]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(D){const A=D;return A?typeof A.read=="function":!1}e.isReadable=l;function I(D){const A=D;return A?[A.on,A.pause,A.resume,A.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=I;function C(D){const A=D;return A?I(A.stream)&&Array.isArray(A.buffer)&&typeof A.ended=="boolean":!1}e.isReadableBufferedStream=C;function P(D,A){return new w(D,A)}e.newWriteableStream=P;class w{constructor(A,t){this.e=A,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(A){if(!this.a.destroyed){if(this.a.flowing)this.g(A);else if(this.b.data.push(A),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(A){this.a.destroyed||(this.a.flowing?this.h(A):this.b.error.push(A))}end(A){this.a.destroyed||(typeof A<"u"&&this.write(A),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(A){this.c.data.slice(0).forEach(t=>t(A))}h(A){this.c.error.length===0?(0,E.onUnexpectedError)(A):this.c.error.slice(0).forEach(t=>t(A))}i(){this.c.end.slice(0).forEach(A=>A())}on(A,t){if(!this.a.destroyed)switch(A){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(A,t){if(this.a.destroyed)return;let r;switch(A){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const n=r.indexOf(t);n>=0&&r.splice(n,1)}}j(){if(this.b.data.length>0){const A=this.e(this.b.data);this.g(A),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const A of this.b.error)this.h(A);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(D,A){const t=[];let r;for(;(r=D.read())!==null;)t.push(r);return A(t)}e.consumeReadable=y;function T(D,A,t){const r=[];let n;for(;(n=D.read())!==null&&r.length<t;)r.push(n);return n===null&&r.length>0?A(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const i=n;return n=void 0,i}return D.read()}}}e.peekReadable=T;function S(D,A){return new Promise((t,r)=>{const n=[];b(D,{onData:i=>{A&&n.push(i)},onError:i=>{A?r(i):t(void 0)},onEnd:()=>{t(A?A(n):void 0)}})})}e.consumeStream=S;function b(D,A){let t=!1;return D.on("error",r=>{t||A.onError(r)}),D.on("end",()=>{t||A.onEnd()}),D.on("data",r=>{t||A.onData(r)}),(0,k.toDisposable)(()=>t=!0)}e.listenStream=b;function g(D,A){return new Promise((t,r)=>{const n=new k.DisposableStore,i=[],o=s=>{if(i.push(s),i.length>A)return n.dispose(),D.pause(),t({stream:D,buffer:i,ended:!1})},c=s=>r(s),a=()=>t({stream:D,buffer:i,ended:!0});n.add((0,k.toDisposable)(()=>D.removeListener("error",c))),D.on("error",c),n.add((0,k.toDisposable)(()=>D.removeListener("end",a))),D.on("end",a),n.add((0,k.toDisposable)(()=>D.removeListener("data",o))),D.on("data",o)})}e.peekStream=g;function f(D,A){const t=P(A);return t.end(D),t}e.toStream=f;function p(){const D=P(()=>{throw new Error("not supported")});return D.end(),D}e.emptyStream=p;function u(D){let A=!1;return{read:()=>A?null:(A=!0,D)}}e.toReadable=u;function h(D,A,t){const r=P(t);return b(D,{onData:n=>r.write(A.data(n)),onError:n=>r.error(A.error?A.error(n):n),onEnd:()=>r.end()}),r}e.transform=h;function v(D,A,t){let r=!1;return{read:()=>{const n=A.read();return r?n:(r=!0,n!==null?t([D,n]):D)}}}e.prefixedReadable=v;function d(D,A,t){let r=!1;const n=P(t);return b(A,{onData:i=>r?n.write(i):(r=!0,n.write(t([D,i]))),onError:i=>n.error(i),onEnd:()=>{r||(r=!0,n.write(D)),n.end()}}),n}e.prefixedStream=d}),define(ve[15],be([1,0,44]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer<"u";let l,I;class C{static alloc(s){return k?new C(Buffer.allocUnsafe(s)):new C(new Uint8Array(s))}static wrap(s){return k&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new C(s)}static fromString(s,m){return!(m?.dontUseNodeBuffer||!1)&&k?new C(Buffer.from(s)):(l||(l=new TextEncoder),new C(l.encode(s)))}static fromByteArray(s){const m=C.alloc(s.length);for(let R=0,L=s.length;R<L;R++)m.buffer[R]=s[R];return m}static concat(s,m){if(typeof m>"u"){m=0;for(let $=0,ie=s.length;$<ie;$++)m+=s[$].byteLength}const R=C.alloc(m);let L=0;for(let $=0,ie=s.length;$<ie;$++){const ne=s[$];R.set(ne,L),L+=ne.byteLength}return R}constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}clone(){const s=C.alloc(this.byteLength);return s.set(this),s}toString(){return k?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(s,m){return new C(this.buffer.subarray(s,m))}set(s,m){if(s instanceof C)this.buffer.set(s.buffer,m);else if(s instanceof Uint8Array)this.buffer.set(s,m);else if(s instanceof ArrayBuffer)this.buffer.set(new Uint8Array(s),m);else if(ArrayBuffer.isView(s))this.buffer.set(new Uint8Array(s.buffer,s.byteOffset,s.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(s){return y(this.buffer,s)}writeUInt32BE(s,m){T(this.buffer,s,m)}readUInt32LE(s){return S(this.buffer,s)}writeUInt32LE(s,m){b(this.buffer,s,m)}readUInt8(s){return g(this.buffer,s)}writeUInt8(s,m){f(this.buffer,s,m)}}e.VSBuffer=C;function P(a,s){return a[s+0]<<0>>>0|a[s+1]<<8>>>0}e.readUInt16LE=P;function w(a,s,m){a[m+0]=s&255,s=s>>>8,a[m+1]=s&255}e.writeUInt16LE=w;function y(a,s){return a[s]*2**24+a[s+1]*2**16+a[s+2]*2**8+a[s+3]}e.readUInt32BE=y;function T(a,s,m){a[m+3]=s,s=s>>>8,a[m+2]=s,s=s>>>8,a[m+1]=s,s=s>>>8,a[m]=s}e.writeUInt32BE=T;function S(a,s){return a[s+0]<<0>>>0|a[s+1]<<8>>>0|a[s+2]<<16>>>0|a[s+3]<<24>>>0}e.readUInt32LE=S;function b(a,s,m){a[m+0]=s&255,s=s>>>8,a[m+1]=s&255,s=s>>>8,a[m+2]=s&255,s=s>>>8,a[m+3]=s&255}e.writeUInt32LE=b;function g(a,s){return a[s]}e.readUInt8=g;function f(a,s,m){a[m]=s}e.writeUInt8=f;function p(a){return E.consumeReadable(a,s=>C.concat(s))}e.readableToBuffer=p;function u(a){return E.toReadable(a)}e.bufferToReadable=u;function h(a){return E.consumeStream(a,s=>C.concat(s))}e.streamToBuffer=h;async function v(a){return a.ended?C.concat(a.buffer):C.concat([...a.buffer,await h(a.stream)])}e.bufferedStreamToBuffer=v;function d(a){return E.toStream(a,s=>C.concat(s))}e.bufferToStream=d;function D(a){return E.transform(a,{data:s=>typeof s=="string"?C.fromString(s):C.wrap(s)},s=>C.concat(s))}e.streamToBufferReadableStream=D;function A(a){return E.newWriteableStream(s=>C.concat(s),a)}e.newWriteableBufferStream=A;function t(a,s){return E.prefixedReadable(a,s,m=>C.concat(m))}e.prefixedBufferReadable=t;function r(a,s){return E.prefixedStream(a,s,m=>C.concat(m))}e.prefixedBufferStream=r;function n(a){let s=0,m=0,R=0;const L=new Uint8Array(Math.floor(a.length/4*3)),$=ne=>{switch(m){case 3:L[R++]=s|ne,m=0;break;case 2:L[R++]=s|ne>>>2,s=ne<<6,m=3;break;case 1:L[R++]=s|ne>>>4,s=ne<<4,m=2;break;default:s=ne<<2,m=1}};for(let ne=0;ne<a.length;ne++){const F=a.charCodeAt(ne);if(F>=65&&F<=90)$(F-65);else if(F>=97&&F<=122)$(F-97+26);else if(F>=48&&F<=57)$(F-48+52);else if(F===43||F===45)$(62);else if(F===47||F===95)$(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${a[ne]}`)}}const ie=R;for(;m>0;)$(0);return C.wrap(L).slice(0,ie)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},s=!0,m=!1){const R=m?o:i;let L="";const $=a.byteLength%3;let ie=0;for(;ie<a.byteLength-$;ie+=3){const ne=a[ie+0],F=a[ie+1],_=a[ie+2];L+=R[ne>>>2],L+=R[(ne<<4|F>>>4)&63],L+=R[(F<<2|_>>>6)&63],L+=R[_&63]}if($===1){const ne=a[ie+0];L+=R[ne>>>2],L+=R[ne<<4&63],s&&(L+="==")}else if($===2){const ne=a[ie+0],F=a[ie+1];L+=R[ne>>>2],L+=R[(ne<<4|F>>>4)&63],L+=R[F<<2&63],s&&(L+="=")}return L}e.encodeBase64=c}),define(ve[145],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ve[8],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(r){return typeof r=="string"}e.isString=E;function k(r){return Array.isArray(r)&&r.every(n=>E(n))}e.isStringArray=k;function l(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=l;function I(r){const n=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof n}e.isTypedArray=I;function C(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=C;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function w(r){return r===!0||r===!1}e.isBoolean=w;function y(r){return typeof r>"u"}e.isUndefined=y;function T(r){return!S(r)}e.isDefined=T;function S(r){return y(r)||r===null}e.isUndefinedOrNull=S;function b(r,n){if(!r)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.assertType=b;function g(r){if(S(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=g;function f(...r){const n=[];for(let i=0;i<r.length;i++){const o=r[i];if(S(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(o)}return n}e.assertAllDefined=f;const p=Object.prototype.hasOwnProperty;function u(r){if(!l(r))return!1;for(const n in r)if(p.call(r,n))return!1;return!0}e.isEmptyObject=u;function h(r){return typeof r=="function"}e.isFunction=h;function v(...r){return r.length>0&&r.every(h)}e.areFunctions=v;function d(r,n){const i=Math.min(r.length,n.length);for(let o=0;o<i;o++)D(r[o],n[o])}e.validateConstraints=d;function D(r,n){if(E(n)){if(typeof r!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(h(n)){try{if(r instanceof n)return}catch{}if(!S(r)&&r.constructor===n||n.length===1&&n.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=D;function A(r){return r===null?void 0:r}e.withNullAsUndefined=A;function t(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=t}),define(ve[45],be([1,0,8]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const k=Object.create(null);function l(P,w){if((0,E.isString)(w)){const y=k[w];if(y===void 0)throw new Error(`${P} references an unknown codicon: ${w}`);w=y}return k[P]=w,{id:P}}function I(){return k}e.getCodiconFontCharacters=I;function C(){return Object.values(e.Codicon)}e.getAllCodicons=C,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(ve[23],be([1,0,8]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const v=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([d,D])=>{v[d]=D&&typeof D=="object"?k(D):D}),v}e.deepClone=k;function l(h){if(!h||typeof h!="object")return h;const v=[h];for(;v.length>0;){const d=v.shift();Object.freeze(d);for(const D in d)if(I.call(d,D)){const A=d[D];typeof A=="object"&&!Object.isFrozen(A)&&!(0,E.isTypedArray)(A)&&v.push(A)}}return h}e.deepFreeze=l;const I=Object.prototype.hasOwnProperty;function C(h,v){return P(h,v,new Set)}e.cloneAndChange=C;function P(h,v,d){if((0,E.isUndefinedOrNull)(h))return h;const D=v(h);if(typeof D<"u")return D;if(Array.isArray(h)){const A=[];for(const t of h)A.push(P(t,v,d));return A}if((0,E.isObject)(h)){if(d.has(h))throw new Error("Cannot clone recursive data-structure");d.add(h);const A={};for(const t in h)I.call(h,t)&&(A[t]=P(h[t],v,d));return d.delete(h),A}return h}function w(h,v,d=!0){return(0,E.isObject)(h)?((0,E.isObject)(v)&&Object.keys(v).forEach(D=>{D in h?d&&((0,E.isObject)(h[D])&&(0,E.isObject)(v[D])?w(h[D],v[D],d):h[D]=v[D]):h[D]=v[D]}),h):v}e.mixin=w;function y(h,v){if(h===v)return!0;if(h==null||v===null||v===void 0||typeof h!=typeof v||typeof h!="object"||Array.isArray(h)!==Array.isArray(v))return!1;let d,D;if(Array.isArray(h)){if(h.length!==v.length)return!1;for(d=0;d<h.length;d++)if(!y(h[d],v[d]))return!1}else{const A=[];for(D in h)A.push(D);A.sort();const t=[];for(D in v)t.push(D);if(t.sort(),!y(A,t))return!1;for(d=0;d<A.length;d++)if(!y(h[A[d]],v[A[d]]))return!1}return!0}e.equals=y;function T(h){const v=new Set;return JSON.stringify(h,(d,D)=>{if((0,E.isObject)(D)||Array.isArray(D)){if(v.has(D))return"[Circular]";v.add(D)}return D})}e.safeStringify=T;function S(h,v){const d=Object.create(null);return!h||!v||Object.keys(v).forEach(A=>{const t=h[A],r=v[A];y(t,r)||(d[A]=r)}),d}e.distinct=S;function b(h,v){const d=v.toLowerCase(),D=Object.keys(h).find(A=>A.toLowerCase()===d);return D?h[D]:h[v]}e.getCaseInsensitive=b;function g(h,v){const d=Object.create(null);for(const[D,A]of Object.entries(h))v(D,A)&&(d[D]=A);return d}e.filter=g;function f(h){let v=[],d=Object.getPrototypeOf(h);for(;Object.prototype!==d;)v=v.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return v}e.getAllPropertyNames=f;function p(h){const v=[];for(const d of f(h))typeof h[d]=="function"&&v.push(d);return v}e.getAllMethodNames=p;function u(h,v){const d=A=>function(){const t=Array.prototype.slice.call(arguments,0);return v(A,t)},D={};for(const A of h)D[A]=d(A);return D}e.createProxyObject=u}),define(ve[89],be([1,0,45]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var k;(function(C){function P(w){return w&&typeof w=="object"&&typeof w.id=="string"}C.isThemeColor=P})(k=e.ThemeColor||(e.ThemeColor={}));function l(C){return{id:C}}e.themeColorFromId=l;var I;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function w(v){const d=P.exec(v.id);if(!d)return w(E.Codicon.error);const[,D,A]=d,t=["codicon","codicon-"+D];return A&&t.push("codicon-modifier-"+A.substring(1)),t}C.asClassNameArray=w;function y(v){return w(v).join(" ")}C.asClassName=y;function T(v){return"."+w(v).join(".")}C.asCSSSelector=T;function S(v){return v&&typeof v=="object"&&typeof v.id=="string"&&(typeof v.color>"u"||k.isThemeColor(v.color))}C.isThemeIcon=S;const b=new RegExp(`^\\$\\((${C.iconNameExpression}(?:${C.iconModifierExpression})?)\\)$`);function g(v){const d=b.exec(v);if(!d)return;const[,D]=d;return{id:D}}C.fromString=g;function f(v){return{id:v}}C.fromId=f;function p(v,d){let D=v.id;const A=D.lastIndexOf("~");return A!==-1&&(D=D.substring(0,A)),d&&(D=`${D}~${d}`),{id:D}}C.modify=p;function u(v){const d=v.id.lastIndexOf("~");if(d!==-1)return v.id.substring(d+1)}C.getModifier=u;function h(v,d){return v.id===d.id&&v.color?.id===d.color?.id}C.isEqual=h})(I=e.ThemeIcon||(e.ThemeIcon={}))}),define(ve[22],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(l){return E.test(l)}e.isUUID=k,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(P){for(let w=0;w<P.length;w++)P[w]=Math.floor(Math.random()*256);return P};const I=new Uint8Array(16),C=[];for(let P=0;P<256;P++)C.push(P.toString(16).padStart(2,"0"));return function(){l(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let w=0,y="";return y+=C[I[w++]],y+=C[I[w++]],y+=C[I[w++]],y+=C[I[w++]],y+="-",y+=C[I[w++]],y+=C[I[w++]],y+="-",y+=C[I[w++]],y+=C[I[w++]],y+="-",y+=C[I[w++]],y+=C[I[w++]],y+="-",y+=C[I[w++]],y+=C[I[w++]],y+=C[I[w++]],y+=C[I[w++]],y+=C[I[w++]],y+=C[I[w++]],y}}()}),define(ve[146],be([1,0,18,22]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function l(P){return{id:(0,k.generateUuid)(),asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.createStringDataTransferItem=l;function I(P,w,y){return{id:(0,k.generateUuid)(),asString:async()=>"",asFile:()=>({name:P,uri:w,data:y}),value:void 0}}e.createFileDataTransferItem=I;class C{constructor(){this.a=new Map}get size(){return this.a.size}has(w){return this.a.has(this.b(w))}get(w){return this.a.get(this.b(w))?.[0]}append(w,y){const T=this.a.get(w);T?T.push(y):this.a.set(this.b(w),[y])}replace(w,y){this.a.set(this.b(w),[y])}delete(w){this.a.delete(this.b(w))}*entries(){for(const[w,y]of this.a.entries())for(const T of y)yield[w,T]}values(){return Array.from(this.a.values()).flat()}forEach(w){for(const[y,T]of this.entries())w(T,y)}b(w){return w.toLowerCase()}}e.VSDataTransfer=C,e.UriList=Object.freeze({create:P=>(0,E.distinct)(P.map(w=>w.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.UriList.split(P).filter(w=>!w.startsWith("#"))})}),function(){"use strict";function ae(e,E,k){function l(g){return new Promise(f=>E.exists(g,f))}function I(g){return new Promise((f,p)=>{const u=new Date;E.utimes(g,u,u,h=>h?p(h):f())})}function C(g){return new Promise((f,p)=>E.mkdir(g,{recursive:!0},u=>u&&u.code!=="EEXIST"?p(u):f(g)))}function P(g){return new Promise((f,p)=>E.rm(g,{recursive:!0,force:!0,maxRetries:3},u=>u?p(u):f()))}function w(g){return new Promise((f,p)=>E.readFile(g,"utf8",(u,h)=>u?p(u):f(h)))}function y(g,f){return new Promise((p,u)=>E.writeFile(g,f,"utf8",h=>h?u(h):p()))}async function T(g){const f=e.join(g,"languagepacks.json");try{return JSON.parse(await w(f))}catch{}}function S(g,f){try{for(;f;){if(g[f])return f;{const p=f.lastIndexOf("-");if(p>0)f=f.substring(0,p);else return}}}catch(p){console.error("Resolving language pack configuration failed.",p)}}function b(g,f,p,u){if(u==="pseudo")return Promise.resolve({locale:u,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:u,availableLanguages:{}});if(u&&(u==="en"||u==="en-us"))return Promise.resolve({locale:u,availableLanguages:{}});const h=u;k.mark("code/willGenerateNls");const v=function(d){return k.mark("code/didGenerateNls"),Promise.resolve({locale:d,availableLanguages:{}})};try{return g?T(f).then(d=>{if(!d||(u=S(d,u),!u))return v(h);const D=d[u];let A;return!D||typeof D.hash!="string"||!D.translations||typeof(A=D.translations.vscode)!="string"?v(h):l(A).then(t=>{if(!t)return v(h);const r=D.hash+"."+u,n=e.join(f,"clp",r),i=e.join(n,g),o=e.join(n,"tcf.json"),c=e.join(n,"corrupted.info"),a={locale:h,availableLanguages:{"*":u},_languagePackId:r,_translationsConfigFile:o,_cacheRoot:n,_resolvedLanguagePackCoreLocation:i,_corruptedFile:c};return l(c).then(s=>{let m;return s?m=P(n):m=Promise.resolve(void 0),m.then(()=>l(i).then(R=>R?(I(i).catch(()=>{}),k.mark("code/didGenerateNls"),a):C(i).then(()=>Promise.all([w(p),w(A)])).then(L=>{const $=JSON.parse(L[0]),ie=JSON.parse(L[1]).contents,ne=Object.keys($.bundles),F=[];for(const _ of ne){const z=$.bundles[_],x=Object.create(null);for(const le of z){const Ee=$.keys[le],Y=$.messages[le],H=ie[le];let U;if(H){U=[];for(let te=0;te<Ee.length;te++){const re=Ee[te],de=typeof re=="string"?re:re.key;let oe=H[de];oe===void 0&&(oe=Y[te]),U.push(oe)}}else U=Y;x[le]=U}F.push(y(e.join(i,_.replace(/\//g,"!")+".nls.json"),JSON.stringify(x)))}return F.push(y(o,JSON.stringify(D.translations))),Promise.all(F)}).then(()=>(k.mark("code/didGenerateNls"),a)).catch(L=>(console.error("Generating translation files failed.",L),v(u)))))})})}):v(h)}catch(d){return console.error("Generating translation files failed.",d),v(u)}}return{getNLSConfiguration:b}}if(typeof define=="function")define(ve[147],be([90,30,46]),function(e,E,k){return ae(e,E,k)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("fs"),k=require("../common/performance");module.exports=ae(e,E,k)}else throw new Error("Unknown context")}(),define(ve[148],be([1,0,31]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function l(C){const P=C.replace(/\-/g,":").toLowerCase();return!k.has(P)}function I(){const C=(0,E.networkInterfaces)();for(const P in C){const w=C[P];if(w){for(const{mac:y}of w)if(l(y))return y}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=I}),define(ve[149],be([1,0,91]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function k(P,w,y,T=1){let S=!1;return new Promise(b=>{const g=setTimeout(()=>{if(!S)return S=!0,b(0)},y);l(P,w,T,f=>{if(!S)return S=!0,clearTimeout(g),b(f)})})}e.findFreePort=k;function l(P,w,y,T){if(w===0)return T(0);const S=new E.Socket;S.once("connect",()=>(C(S),l(P+y,w-1,y,T))),S.once("data",()=>{}),S.once("error",b=>(C(S),b.code!=="ECONNREFUSED"?l(P+y,w-1,y,T):T(P))),S.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(P,w,y,T="127.0.0.1"){let S=!1,b,g=1;const f=E.createServer({pauseOnConnect:!0});function p(u,h){S||(S=!0,f.removeAllListeners(),f.close(),b&&clearTimeout(b),h(u))}return new Promise(u=>{b=setTimeout(()=>{p(0,u)},y),f.on("listening",()=>{p(P,u)}),f.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&g<w?(P++,g++,f.listen(P,T)):p(0,u)}),f.on("close",()=>{p(0,u)}),f.listen(P,T)})}e.findFreePortFaster=I;function C(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(w){console.error(w)}}}),define(ve[92],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(l,I){this.lineNumber=l,this.column=I}with(l=this.lineNumber,I=this.column){return l===this.lineNumber&&I===this.column?this:new E(l,I)}delta(l=0,I=0){return this.with(this.lineNumber+l,this.column+I)}equals(l){return E.equals(this,l)}static equals(l,I){return!l&&!I?!0:!!l&&!!I&&l.lineNumber===I.lineNumber&&l.column===I.column}isBefore(l){return E.isBefore(this,l)}static isBefore(l,I){return l.lineNumber<I.lineNumber?!0:I.lineNumber<l.lineNumber?!1:l.column<I.column}isBeforeOrEqual(l){return E.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,I){return l.lineNumber<I.lineNumber?!0:I.lineNumber<l.lineNumber?!1:l.column<=I.column}static compare(l,I){const C=l.lineNumber|0,P=I.lineNumber|0;if(C===P){const w=l.column|0,y=I.column|0;return w-y}return C-P}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new E(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.Position=E}),define(ve[47],be([1,0,92]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class k{constructor(I,C,P,w){I>P||I===P&&C>w?(this.startLineNumber=P,this.startColumn=w,this.endLineNumber=I,this.endColumn=C):(this.startLineNumber=I,this.startColumn=C,this.endLineNumber=P,this.endColumn=w)}isEmpty(){return k.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return k.containsPosition(this,I)}static containsPosition(I,C){return!(C.lineNumber<I.startLineNumber||C.lineNumber>I.endLineNumber||C.lineNumber===I.startLineNumber&&C.column<I.startColumn||C.lineNumber===I.endLineNumber&&C.column>I.endColumn)}static strictContainsPosition(I,C){return!(C.lineNumber<I.startLineNumber||C.lineNumber>I.endLineNumber||C.lineNumber===I.startLineNumber&&C.column<=I.startColumn||C.lineNumber===I.endLineNumber&&C.column>=I.endColumn)}containsRange(I){return k.containsRange(this,I)}static containsRange(I,C){return!(C.startLineNumber<I.startLineNumber||C.endLineNumber<I.startLineNumber||C.startLineNumber>I.endLineNumber||C.endLineNumber>I.endLineNumber||C.startLineNumber===I.startLineNumber&&C.startColumn<I.startColumn||C.endLineNumber===I.endLineNumber&&C.endColumn>I.endColumn)}strictContainsRange(I){return k.strictContainsRange(this,I)}static strictContainsRange(I,C){return!(C.startLineNumber<I.startLineNumber||C.endLineNumber<I.startLineNumber||C.startLineNumber>I.endLineNumber||C.endLineNumber>I.endLineNumber||C.startLineNumber===I.startLineNumber&&C.startColumn<=I.startColumn||C.endLineNumber===I.endLineNumber&&C.endColumn>=I.endColumn)}plusRange(I){return k.plusRange(this,I)}static plusRange(I,C){let P,w,y,T;return C.startLineNumber<I.startLineNumber?(P=C.startLineNumber,w=C.startColumn):C.startLineNumber===I.startLineNumber?(P=C.startLineNumber,w=Math.min(C.startColumn,I.startColumn)):(P=I.startLineNumber,w=I.startColumn),C.endLineNumber>I.endLineNumber?(y=C.endLineNumber,T=C.endColumn):C.endLineNumber===I.endLineNumber?(y=C.endLineNumber,T=Math.max(C.endColumn,I.endColumn)):(y=I.endLineNumber,T=I.endColumn),new k(P,w,y,T)}intersectRanges(I){return k.intersectRanges(this,I)}static intersectRanges(I,C){let P=I.startLineNumber,w=I.startColumn,y=I.endLineNumber,T=I.endColumn;const S=C.startLineNumber,b=C.startColumn,g=C.endLineNumber,f=C.endColumn;return P<S?(P=S,w=b):P===S&&(w=Math.max(w,b)),y>g?(y=g,T=f):y===g&&(T=Math.min(T,f)),P>y||P===y&&w>T?null:new k(P,w,y,T)}equalsRange(I){return k.equalsRange(this,I)}static equalsRange(I,C){return!I&&!C?!0:!!I&&!!C&&I.startLineNumber===C.startLineNumber&&I.startColumn===C.startColumn&&I.endLineNumber===C.endLineNumber&&I.endColumn===C.endColumn}getEndPosition(){return k.getEndPosition(this)}static getEndPosition(I){return new E.Position(I.endLineNumber,I.endColumn)}getStartPosition(){return k.getStartPosition(this)}static getStartPosition(I){return new E.Position(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,C){return new k(this.startLineNumber,this.startColumn,I,C)}setStartPosition(I,C){return new k(I,C,this.endLineNumber,this.endColumn)}collapseToStart(){return k.collapseToStart(this)}static collapseToStart(I){return new k(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return k.collapseToEnd(this)}static collapseToEnd(I){return new k(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new k(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,C=I){return new k(I.lineNumber,I.column,C.lineNumber,C.column)}static lift(I){return I?new k(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,C){return!(I.endLineNumber<C.startLineNumber||I.endLineNumber===C.startLineNumber&&I.endColumn<C.startColumn||C.endLineNumber<I.startLineNumber||C.endLineNumber===I.startLineNumber&&C.endColumn<I.startColumn)}static areIntersecting(I,C){return!(I.endLineNumber<C.startLineNumber||I.endLineNumber===C.startLineNumber&&I.endColumn<=C.startColumn||C.endLineNumber<I.startLineNumber||C.endLineNumber===I.startLineNumber&&C.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,C){if(I&&C){const y=I.startLineNumber|0,T=C.startLineNumber|0;if(y===T){const S=I.startColumn|0,b=C.startColumn|0;if(S===b){const g=I.endLineNumber|0,f=C.endLineNumber|0;if(g===f){const p=I.endColumn|0,u=C.endColumn|0;return p-u}return g-f}return S-b}return y-T}return(I?1:0)-(C?1:0)}static compareRangesUsingEnds(I,C){return I.endLineNumber===C.endLineNumber?I.endColumn===C.endColumn?I.startLineNumber===C.startLineNumber?I.startColumn-C.startColumn:I.startLineNumber-C.startLineNumber:I.endColumn-C.endColumn:I.endLineNumber-C.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.Range=k}),define(ve[150],be([10,11]),function(ae,e){return ae.create("vs/base/common/actions",e)}),define(ve[151],be([10,11]),function(ae,e){return ae.create("vs/base/common/date",e)}),define(ve[152],be([1,0,151]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,l=k*60,I=l*24,C=I*7,P=I*30,w=I*365;function y(S,b,g,f){typeof S!="number"&&(S=S.getTime());const p=Math.round((new Date().getTime()-S)/1e3);if(p<-30)return(0,E.localize)(0,null,y(new Date().getTime()+p*1e3,!1));if(!f&&p<30)return(0,E.localize)(1,null);let u;return p<k?(u=p,b?u===1?g?(0,E.localize)(2,null,u):(0,E.localize)(3,null,u):g?(0,E.localize)(4,null,u):(0,E.localize)(5,null,u):u===1?g?(0,E.localize)(6,null,u):(0,E.localize)(7,null,u):g?(0,E.localize)(8,null,u):(0,E.localize)(9,null,u)):p<l?(u=Math.floor(p/k),b?u===1?g?(0,E.localize)(10,null,u):(0,E.localize)(11,null,u):g?(0,E.localize)(12,null,u):(0,E.localize)(13,null,u):u===1?g?(0,E.localize)(14,null,u):(0,E.localize)(15,null,u):g?(0,E.localize)(16,null,u):(0,E.localize)(17,null,u)):p<I?(u=Math.floor(p/l),b?u===1?g?(0,E.localize)(18,null,u):(0,E.localize)(19,null,u):g?(0,E.localize)(20,null,u):(0,E.localize)(21,null,u):u===1?g?(0,E.localize)(22,null,u):(0,E.localize)(23,null,u):g?(0,E.localize)(24,null,u):(0,E.localize)(25,null,u)):p<C?(u=Math.floor(p/I),b?u===1?(0,E.localize)(26,null,u):(0,E.localize)(27,null,u):u===1?(0,E.localize)(28,null,u):(0,E.localize)(29,null,u)):p<P?(u=Math.floor(p/C),b?u===1?g?(0,E.localize)(30,null,u):(0,E.localize)(31,null,u):g?(0,E.localize)(32,null,u):(0,E.localize)(33,null,u):u===1?g?(0,E.localize)(34,null,u):(0,E.localize)(35,null,u):g?(0,E.localize)(36,null,u):(0,E.localize)(37,null,u)):p<w?(u=Math.floor(p/P),b?u===1?g?(0,E.localize)(38,null,u):(0,E.localize)(39,null,u):g?(0,E.localize)(40,null,u):(0,E.localize)(41,null,u):u===1?g?(0,E.localize)(42,null,u):(0,E.localize)(43,null,u):g?(0,E.localize)(44,null,u):(0,E.localize)(45,null,u)):(u=Math.floor(p/w),b?u===1?g?(0,E.localize)(46,null,u):(0,E.localize)(47,null,u):g?(0,E.localize)(48,null,u):(0,E.localize)(49,null,u):u===1?g?(0,E.localize)(50,null,u):(0,E.localize)(51,null,u):g?(0,E.localize)(52,null,u):(0,E.localize)(53,null,u))}e.fromNow=y;function T(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=T}),define(ve[153],be([10,11]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(ve[37],be([1,0,18,8,153]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function I(S,b){return b&&(S.stack||S.stacktrace)?l.localize(0,null,P(S),C(S.stack)||C(S.stacktrace)):P(S)}function C(S){return Array.isArray(S)?S.join(`
`):S}function P(S){return typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?l.localize(1,null,S.message):S.message||l.localize(2,null)}function w(S=null,b=!1){if(!S)return l.localize(3,null);if(Array.isArray(S)){const g=E.coalesce(S),f=w(g[0],b);return g.length>1?l.localize(4,null,f,g.length):f}if(k.isString(S))return S;if(S.detail){const g=S.detail;if(g.error)return I(g.error,b);if(g.exception)return I(g.exception,b)}return S.stack?I(S,b):S.message?S.message:l.localize(5,null)}e.toErrorMessage=w;function y(S){const b=S;return b instanceof Error&&Array.isArray(b.actions)}e.isErrorWithActions=y;function T(S,b){let g;return typeof S=="string"?g=new Error(S):g=S,g.actions=b,g}e.createErrorWithActions=T}),define(ve[154],be([10,11]),function(ae,e){return ae.create("vs/base/common/jsonErrorMessages",e)}),define(ve[155],be([1,0,154]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function k(l){switch(l){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=k}),define(ve[156],be([10,11]),function(ae,e){return ae.create("vs/base/common/platform",e)}),define(ve[3],be([1,0,156]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let k=!1,l=!1,I=!1,C=!1,P=!1,w=!1,y=!1,T=!1,S=!1,b=!1,g,f=e.LANGUAGE_DEFAULT,p,u;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const v=typeof h?.versions?.electron=="string",d=v&&h?.type==="renderer";if(typeof navigator=="object"&&!d)u=navigator.userAgent,k=u.indexOf("Windows")>=0,l=u.indexOf("Macintosh")>=0,T=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=u.indexOf("Linux")>=0,b=u?.indexOf("Mobi")>=0,w=!0,g=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,f=g;else if(typeof h=="object"){k=h.platform==="win32",l=h.platform==="darwin",I=h.platform==="linux",C=I&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,y=v,S=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.LANGUAGE_DEFAULT,f=e.LANGUAGE_DEFAULT;const a=h.env.VSCODE_NLS_CONFIG;if(a)try{const s=JSON.parse(a),m=s.availableLanguages["*"];g=s.locale,f=m||e.LANGUAGE_DEFAULT,p=s._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var D;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function A(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=A;let t=0;l?t=1:k?t=3:I&&(t=2),e.isWindows=k,e.isMacintosh=l,e.isLinux=I,e.isLinuxSnap=C,e.isNative=P,e.isElectron=y,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=T,e.isMobile=b,e.isCI=S,e.platform=t,e.userAgent=u,e.language=f;var r;(function(a){function s(){return e.language}a.value=s;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=m;function R(){return e.language==="en"}a.isDefault=R})(r=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let R=0,L=a.length;R<L;R++){const $=a[R];if($.id===m.data.vscodeScheduleAsyncWork){a.splice(R,1),$.callback();return}}});let s=0;return m=>{const R=++s;a.push({id:R,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return a=>setTimeout(a)})();var n;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=l||T?2:k?1:3;let i=!0,o=!1;function c(){if(!o){o=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,i=new Uint16Array(a.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ve[28],be([1,0,3]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let k;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const l=E.globals.vscode.process;k={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?k={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:k={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.arch=k.arch}),define(ve[7],be([1,0,28]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,l=97,I=90,C=122,P=46,w=47,y=92,T=58,S=63;class b extends Error{constructor(r,n,i){let o;typeof n=="string"&&n.indexOf("not ")===0?(o="must not be",n=n.replace(/^not /,"")):o="must be";const c=r.indexOf(".")!==-1?"property":"argument";let a=`The "${r}" ${c} ${o} of type ${n}`;a+=`. Received type ${typeof i}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function g(t,r){if(t===null||typeof t!="object")throw new b(r,"Object",t)}function f(t,r){if(typeof t!="string")throw new b(r,"string",t)}const p=E.platform==="win32";function u(t){return t===w||t===y}function h(t){return t===w}function v(t){return t>=k&&t<=I||t>=l&&t<=C}function d(t,r,n,i){let o="",c=0,a=-1,s=0,m=0;for(let R=0;R<=t.length;++R){if(R<t.length)m=t.charCodeAt(R);else{if(i(m))break;m=w}if(i(m)){if(!(a===R-1||s===1))if(s===2){if(o.length<2||c!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const L=o.lastIndexOf(n);L===-1?(o="",c=0):(o=o.slice(0,L),c=o.length-1-o.lastIndexOf(n)),a=R,s=0;continue}else if(o.length!==0){o="",c=0,a=R,s=0;continue}}r&&(o+=o.length>0?`${n}..`:"..",c=2)}else o.length>0?o+=`${n}${t.slice(a+1,R)}`:o=t.slice(a+1,R),c=R-a-1;a=R,s=0}else m===P&&s!==-1?++s:s=-1}return o}function D(t,r){g(r,"pathObject");const n=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return n?n===r.root?`${n}${i}`:`${n}${t}${i}`:i}e.win32={resolve(...t){let r="",n="",i=!1;for(let o=t.length-1;o>=-1;o--){let c;if(o>=0){if(c=t[o],f(c,"path"),c.length===0)continue}else r.length===0?c=E.cwd():(c=E.env[`=${r}`]||E.cwd(),(c===void 0||c.slice(0,2).toLowerCase()!==r.toLowerCase()&&c.charCodeAt(2)===y)&&(c=`${r}\\`));const a=c.length;let s=0,m="",R=!1;const L=c.charCodeAt(0);if(a===1)u(L)&&(s=1,R=!0);else if(u(L))if(R=!0,u(c.charCodeAt(1))){let $=2,ie=$;for(;$<a&&!u(c.charCodeAt($));)$++;if($<a&&$!==ie){const ne=c.slice(ie,$);for(ie=$;$<a&&u(c.charCodeAt($));)$++;if($<a&&$!==ie){for(ie=$;$<a&&!u(c.charCodeAt($));)$++;($===a||$!==ie)&&(m=`\\\\${ne}\\${c.slice(ie,$)}`,s=$)}}}else s=1;else v(L)&&c.charCodeAt(1)===T&&(m=c.slice(0,2),s=2,a>2&&u(c.charCodeAt(2))&&(R=!0,s=3));if(m.length>0)if(r.length>0){if(m.toLowerCase()!==r.toLowerCase())continue}else r=m;if(i){if(r.length>0)break}else if(n=`${c.slice(s)}\\${n}`,i=R,R&&r.length>0)break}return n=d(n,!i,"\\",u),i?`${r}\\${n}`:`${r}${n}`||"."},normalize(t){f(t,"path");const r=t.length;if(r===0)return".";let n=0,i,o=!1;const c=t.charCodeAt(0);if(r===1)return h(c)?"\\":t;if(u(c))if(o=!0,u(t.charCodeAt(1))){let s=2,m=s;for(;s<r&&!u(t.charCodeAt(s));)s++;if(s<r&&s!==m){const R=t.slice(m,s);for(m=s;s<r&&u(t.charCodeAt(s));)s++;if(s<r&&s!==m){for(m=s;s<r&&!u(t.charCodeAt(s));)s++;if(s===r)return`\\\\${R}\\${t.slice(m)}\\`;s!==m&&(i=`\\\\${R}\\${t.slice(m,s)}`,n=s)}}}else n=1;else v(c)&&t.charCodeAt(1)===T&&(i=t.slice(0,2),n=2,r>2&&u(t.charCodeAt(2))&&(o=!0,n=3));let a=n<r?d(t.slice(n),!o,"\\",u):"";return a.length===0&&!o&&(a="."),a.length>0&&u(t.charCodeAt(r-1))&&(a+="\\"),i===void 0?o?`\\${a}`:a:o?`${i}\\${a}`:`${i}${a}`},isAbsolute(t){f(t,"path");const r=t.length;if(r===0)return!1;const n=t.charCodeAt(0);return u(n)||r>2&&v(n)&&t.charCodeAt(1)===T&&u(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,n;for(let c=0;c<t.length;++c){const a=t[c];f(a,"path"),a.length>0&&(r===void 0?r=n=a:r+=`\\${a}`)}if(r===void 0)return".";let i=!0,o=0;if(typeof n=="string"&&u(n.charCodeAt(0))){++o;const c=n.length;c>1&&u(n.charCodeAt(1))&&(++o,c>2&&(u(n.charCodeAt(2))?++o:i=!1))}if(i){for(;o<r.length&&u(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.win32.normalize(r)},relative(t,r){if(f(t,"from"),f(r,"to"),t===r)return"";const n=e.win32.resolve(t),i=e.win32.resolve(r);if(n===i||(t=n.toLowerCase(),r=i.toLowerCase(),t===r))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===y;)o++;let c=t.length;for(;c-1>o&&t.charCodeAt(c-1)===y;)c--;const a=c-o;let s=0;for(;s<r.length&&r.charCodeAt(s)===y;)s++;let m=r.length;for(;m-1>s&&r.charCodeAt(m-1)===y;)m--;const R=m-s,L=a<R?a:R;let $=-1,ie=0;for(;ie<L;ie++){const F=t.charCodeAt(o+ie);if(F!==r.charCodeAt(s+ie))break;F===y&&($=ie)}if(ie!==L){if($===-1)return i}else{if(R>L){if(r.charCodeAt(s+ie)===y)return i.slice(s+ie+1);if(ie===2)return i.slice(s+ie)}a>L&&(t.charCodeAt(o+ie)===y?$=ie:ie===2&&($=3)),$===-1&&($=0)}let ne="";for(ie=o+$+1;ie<=c;++ie)(ie===c||t.charCodeAt(ie)===y)&&(ne+=ne.length===0?"..":"\\..");return s+=$,ne.length>0?`${ne}${i.slice(s,m)}`:(i.charCodeAt(s)===y&&++s,i.slice(s,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.win32.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const n=r.charCodeAt(2);if(n!==S&&n!==P)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(v(r.charCodeAt(0))&&r.charCodeAt(1)===T&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return t},dirname(t){f(t,"path");const r=t.length;if(r===0)return".";let n=-1,i=0;const o=t.charCodeAt(0);if(r===1)return u(o)?t:".";if(u(o)){if(n=i=1,u(t.charCodeAt(1))){let s=2,m=s;for(;s<r&&!u(t.charCodeAt(s));)s++;if(s<r&&s!==m){for(m=s;s<r&&u(t.charCodeAt(s));)s++;if(s<r&&s!==m){for(m=s;s<r&&!u(t.charCodeAt(s));)s++;if(s===r)return t;s!==m&&(n=i=s+1)}}}}else v(o)&&t.charCodeAt(1)===T&&(n=r>2&&u(t.charCodeAt(2))?3:2,i=n);let c=-1,a=!0;for(let s=r-1;s>=i;--s)if(u(t.charCodeAt(s))){if(!a){c=s;break}}else a=!1;if(c===-1){if(n===-1)return".";c=n}return t.slice(0,c)},basename(t,r){r!==void 0&&f(r,"ext"),f(t,"path");let n=0,i=-1,o=!0,c;if(t.length>=2&&v(t.charCodeAt(0))&&t.charCodeAt(1)===T&&(n=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,s=-1;for(c=t.length-1;c>=n;--c){const m=t.charCodeAt(c);if(u(m)){if(!o){n=c+1;break}}else s===-1&&(o=!1,s=c+1),a>=0&&(m===r.charCodeAt(a)?--a===-1&&(i=c):(a=-1,i=s))}return n===i?i=s:i===-1&&(i=t.length),t.slice(n,i)}for(c=t.length-1;c>=n;--c)if(u(t.charCodeAt(c))){if(!o){n=c+1;break}}else i===-1&&(o=!1,i=c+1);return i===-1?"":t.slice(n,i)},extname(t){f(t,"path");let r=0,n=-1,i=0,o=-1,c=!0,a=0;t.length>=2&&t.charCodeAt(1)===T&&v(t.charCodeAt(0))&&(r=i=2);for(let s=t.length-1;s>=r;--s){const m=t.charCodeAt(s);if(u(m)){if(!c){i=s+1;break}continue}o===-1&&(c=!1,o=s+1),m===P?n===-1?n=s:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||o===-1||a===0||a===1&&n===o-1&&n===i+1?"":t.slice(n,o)},format:D.bind(null,"\\"),parse(t){f(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.length;let i=0,o=t.charCodeAt(0);if(n===1)return u(o)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(u(o)){if(i=1,u(t.charCodeAt(1))){let $=2,ie=$;for(;$<n&&!u(t.charCodeAt($));)$++;if($<n&&$!==ie){for(ie=$;$<n&&u(t.charCodeAt($));)$++;if($<n&&$!==ie){for(ie=$;$<n&&!u(t.charCodeAt($));)$++;$===n?i=$:$!==ie&&(i=$+1)}}}}else if(v(o)&&t.charCodeAt(1)===T){if(n<=2)return r.root=r.dir=t,r;if(i=2,u(t.charCodeAt(2))){if(n===3)return r.root=r.dir=t,r;i=3}}i>0&&(r.root=t.slice(0,i));let c=-1,a=i,s=-1,m=!0,R=t.length-1,L=0;for(;R>=i;--R){if(o=t.charCodeAt(R),u(o)){if(!m){a=R+1;break}continue}s===-1&&(m=!1,s=R+1),o===P?c===-1?c=R:L!==1&&(L=1):c!==-1&&(L=-1)}return s!==-1&&(c===-1||L===0||L===1&&c===s-1&&c===a+1?r.base=r.name=t.slice(a,s):(r.name=t.slice(a,c),r.base=t.slice(a,s),r.ext=t.slice(c,s))),a>0&&a!==i?r.dir=t.slice(0,a-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const A=(()=>{if(p){const t=/\\/g;return()=>{const r=E.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...t){let r="",n=!1;for(let i=t.length-1;i>=-1&&!n;i--){const o=i>=0?t[i]:A();f(o,"path"),o.length!==0&&(r=`${o}/${r}`,n=o.charCodeAt(0)===w)}return r=d(r,!n,"/",h),n?`/${r}`:r.length>0?r:"."},normalize(t){if(f(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===w,n=t.charCodeAt(t.length-1)===w;return t=d(t,!r,"/",h),t.length===0?r?"/":n?"./":".":(n&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return f(t,"path"),t.length>0&&t.charCodeAt(0)===w},join(...t){if(t.length===0)return".";let r;for(let n=0;n<t.length;++n){const i=t[n];f(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.posix.normalize(r)},relative(t,r){if(f(t,"from"),f(r,"to"),t===r||(t=e.posix.resolve(t),r=e.posix.resolve(r),t===r))return"";const n=1,i=t.length,o=i-n,c=1,a=r.length-c,s=o<a?o:a;let m=-1,R=0;for(;R<s;R++){const $=t.charCodeAt(n+R);if($!==r.charCodeAt(c+R))break;$===w&&(m=R)}if(R===s)if(a>s){if(r.charCodeAt(c+R)===w)return r.slice(c+R+1);if(R===0)return r.slice(c+R)}else o>s&&(t.charCodeAt(n+R)===w?m=R:R===0&&(m=0));let L="";for(R=n+m+1;R<=i;++R)(R===i||t.charCodeAt(R)===w)&&(L+=L.length===0?"..":"/..");return`${L}${r.slice(c+m)}`},toNamespacedPath(t){return t},dirname(t){if(f(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===w;let n=-1,i=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===w){if(!i){n=o;break}}else i=!1;return n===-1?r?"/":".":r&&n===1?"//":t.slice(0,n)},basename(t,r){r!==void 0&&f(r,"ext"),f(t,"path");let n=0,i=-1,o=!0,c;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,s=-1;for(c=t.length-1;c>=0;--c){const m=t.charCodeAt(c);if(m===w){if(!o){n=c+1;break}}else s===-1&&(o=!1,s=c+1),a>=0&&(m===r.charCodeAt(a)?--a===-1&&(i=c):(a=-1,i=s))}return n===i?i=s:i===-1&&(i=t.length),t.slice(n,i)}for(c=t.length-1;c>=0;--c)if(t.charCodeAt(c)===w){if(!o){n=c+1;break}}else i===-1&&(o=!1,i=c+1);return i===-1?"":t.slice(n,i)},extname(t){f(t,"path");let r=-1,n=0,i=-1,o=!0,c=0;for(let a=t.length-1;a>=0;--a){const s=t.charCodeAt(a);if(s===w){if(!o){n=a+1;break}continue}i===-1&&(o=!1,i=a+1),s===P?r===-1?r=a:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||i===-1||c===0||c===1&&r===i-1&&r===n+1?"":t.slice(r,i)},format:D.bind(null,"/"),parse(t){f(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.charCodeAt(0)===w;let i;n?(r.root="/",i=1):i=0;let o=-1,c=0,a=-1,s=!0,m=t.length-1,R=0;for(;m>=i;--m){const L=t.charCodeAt(m);if(L===w){if(!s){c=m+1;break}continue}a===-1&&(s=!1,a=m+1),L===P?o===-1?o=m:R!==1&&(R=1):o!==-1&&(R=-1)}if(a!==-1){const L=c===0&&n?1:c;o===-1||R===0||R===1&&o===a-1&&o===c+1?r.base=r.name=t.slice(L,a):(r.name=t.slice(L,o),r.base=t.slice(L,a),r.ext=t.slice(o,a))}return c>0?r.dir=t.slice(0,c-1):n&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(ve[56],be([1,0,7]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const k={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(T){const S=(0,E.extname)(T),b=k[S.toLowerCase()];return b!==void 0?b:C(T)}e.getMediaOrTextMime=I;function C(T){const S=(0,E.extname)(T);return l[S.toLowerCase()]}e.getMediaMime=C;function P(T){for(const S in l)if(l[S]===T)return S}e.getExtensionForMimeType=P;const w=/^(.+)\/(.+?)(;.+)?$/;function y(T,S){const b=w.exec(T);return b?`${b[1].toLowerCase()}/${b[2].toLowerCase()}${b[3]??""}`:S?void 0:T}e.normalizeMimeType=y}),define(ve[57],be([1,0,3]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var k;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(k=e.Source||(e.Source={}));var l;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function I(P,...w){const y=w.reduce((b,g)=>(b[g]=!0,b),{}),T=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(b=>!y[b]).forEach(b=>{for(let g=0;g<T.length;g++)if(b.search(T[g])!==-1){delete P[b];break}})}e.sanitizeProcessEnvironment=I;function C(P){!P||(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=C}),define(ve[93],be([1,0,3]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=E.globals.performance&&typeof E.globals.performance.now=="function";class l{static create(C=!0){return new l(C)}constructor(C){this.a=k&&C,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=l}),define(ve[6],be([1,0,9,69,2,87,93]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,w=!1;var y;(function(c){c.None=()=>l.Disposable.None;function a(q){if(w){const{onDidAddListener:ee}=q,fe=f.create();let W=0;q.onDidAddListener=()=>{++W===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),fe.print()),ee?.()}}}function s(q,ee){return z(q,()=>{},0,void 0,void 0,ee)}c.defer=s;function m(q){return(ee,fe=null,W)=>{let K=!1,Z;return Z=q(V=>{if(!K)return Z?Z.dispose():K=!0,ee.call(fe,V)},null,W),K&&Z.dispose(),Z}}c.once=m;function R(q,ee,fe){return _((W,K=null,Z)=>q(V=>W.call(K,ee(V)),null,Z),fe)}c.map=R;function L(q,ee,fe){return _((W,K=null,Z)=>q(V=>{ee(V),W.call(K,V)},null,Z),fe)}c.forEach=L;function $(q,ee,fe){return _((W,K=null,Z)=>q(V=>ee(V)&&W.call(K,V),null,Z),fe)}c.filter=$;function ie(q){return q}c.signal=ie;function ne(...q){return(ee,fe=null,W)=>(0,l.combinedDisposable)(...q.map(K=>K(Z=>ee.call(fe,Z),null,W)))}c.any=ne;function F(q,ee,fe,W){let K=fe;return R(q,Z=>(K=ee(K,Z),K),W)}c.reduce=F;function _(q,ee){let fe;const W={onWillAddFirstListener(){fe=q(K.fire,K)},onDidRemoveLastListener(){fe?.dispose()}};ee||a(W);const K=new u(W);return ee?.add(K),K.event}function z(q,ee,fe=100,W=!1,K,Z){let V,Q,G,X=0;const ce={leakWarningThreshold:K,onWillAddFirstListener(){V=q(Pe=>{X++,Q=ee(Q,Pe),W&&!G&&(pe.fire(Q),Q=void 0);const Ae=()=>{const Fe=Q;Q=void 0,G=void 0,(!W||X>1)&&pe.fire(Fe),X=0};typeof fe=="number"?(clearTimeout(G),G=setTimeout(Ae,fe)):G===void 0&&(G=0,queueMicrotask(Ae))})},onDidRemoveLastListener(){V.dispose()}};Z||a(ce);const pe=new u(ce);return Z?.add(pe),pe.event}c.debounce=z;function x(q,ee=0,fe){return c.debounce(q,(W,K)=>W?(W.push(K),W):[K],ee,void 0,void 0,fe)}c.accumulate=x;function le(q,ee=(W,K)=>W===K,fe){let W=!0,K;return $(q,Z=>{const V=W||!ee(Z,K);return W=!1,K=Z,V},fe)}c.latch=le;function Ee(q,ee,fe){return[c.filter(q,ee,fe),c.filter(q,W=>!ee(W),fe)]}c.split=Ee;function Y(q,ee=!1,fe=[]){let W=fe.slice(),K=q(Q=>{W?W.push(Q):V.fire(Q)});const Z=()=>{W?.forEach(Q=>V.fire(Q)),W=null},V=new u({onWillAddFirstListener(){K||(K=q(Q=>V.fire(Q)))},onDidAddFirstListener(){W&&(ee?setTimeout(Z):Z())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return V.event}c.buffer=Y;class H{constructor(ee){this.event=ee,this.c=new l.DisposableStore}map(ee){return new H(R(this.event,ee,this.c))}forEach(ee){return new H(L(this.event,ee,this.c))}filter(ee){return new H($(this.event,ee,this.c))}reduce(ee,fe){return new H(F(this.event,ee,fe,this.c))}latch(){return new H(le(this.event,void 0,this.c))}debounce(ee,fe=100,W=!1,K){return new H(z(this.event,ee,fe,W,K,this.c))}on(ee,fe,W){return this.event(ee,fe,W)}once(ee,fe,W){return m(this.event)(ee,fe,W)}dispose(){this.c.dispose()}}function U(q){return new H(q)}c.chain=U;function te(q,ee,fe=W=>W){const W=(...Q)=>V.fire(fe(...Q)),K=()=>q.on(ee,W),Z=()=>q.removeListener(ee,W),V=new u({onWillAddFirstListener:K,onDidRemoveLastListener:Z});return V.event}c.fromNodeEventEmitter=te;function re(q,ee,fe=W=>W){const W=(...Q)=>V.fire(fe(...Q)),K=()=>q.addEventListener(ee,W),Z=()=>q.removeEventListener(ee,W),V=new u({onWillAddFirstListener:K,onDidRemoveLastListener:Z});return V.event}c.fromDOMEventEmitter=re;function de(q){return new Promise(ee=>m(q)(ee))}c.toPromise=de;function oe(q,ee){return ee(void 0),q(fe=>ee(fe))}c.runAndSubscribe=oe;function j(q,ee){let fe=null;function W(Z){fe?.dispose(),fe=new l.DisposableStore,ee(Z,fe)}W(void 0);const K=q(Z=>W(Z));return(0,l.toDisposable)(()=>{K.dispose(),fe?.dispose()})}c.runAndSubscribeWithStore=j;class N{constructor(ee,fe){this.obs=ee,this.c=0,this.d=!1;const W={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};fe||a(W),this.emitter=new u(W),fe&&fe.add(this.emitter)}beginUpdate(ee){this.c++}handleChange(ee,fe){this.d=!0}endUpdate(ee){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function M(q,ee){return new N(q,ee).emitter.event}c.fromObservable=M})(y=e.Event||(e.Event={}));class T{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${T.c++}`,T.all.add(this)}start(a){this.d=new C.StopWatch(!0),this.listenerCount=a}stop(){if(this.d){const a=this.d.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this.d=void 0}}}T.all=new Set,T.c=0,e.EventProfiling=T;let S=-1;function b(c){const a=S;return S=c,{dispose(){S=a}}}e.setGlobalLeakWarningThreshold=b;class g{constructor(a,s=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=s,this.d=0}dispose(){this.c?.clear()}check(a,s){const m=this.threshold;if(m<=0||s<m)return;this.c||(this.c=new Map);const R=this.c.get(a.value)||0;if(this.c.set(a.value,R+1),this.d-=1,this.d<=0){this.d=m*.5;let L,$=0;for(const[ie,ne]of this.c)(!L||$<ne)&&(L=ie,$=ne);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${$}):`),console.warn(L)}return()=>{const L=this.c.get(a.value)||0;this.c.set(a.value,L-1)}}}class f{static create(){return new f(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(a,s,m){this.callback=a,this.callbackThis=s,this.stack=m,this.subscription=new l.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class u{constructor(a){this.j=!1,this.d=a,this.f=S>0||this.d?.leakWarningThreshold?new g(this.d?.leakWarningThreshold??S):void 0,this.g=this.d?._profName?new T(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const a=Array.from(this.q);queueMicrotask(()=>{for(const s of a)s.subscription.isset()&&(s.subscription.unset(),s.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(a,s,m)=>{if(this.q||(this.q=new I.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const R=this.q.isEmpty();R&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let L,$;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&($=f.create(),L=this.f.check($,this.q.size+1)),P&&($=$??f.create());const ie=new p(a,s,$),ne=this.q.push(ie);R&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,a,s);const F=ie.subscription.set(()=>{L?.(),this.j||(ne(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return m instanceof l.DisposableStore?m.add(F):Array.isArray(m)&&m.push(F),F}),this.l}fire(a){if(this.q){this.m||(this.m=new v);for(const s of this.q)this.m.push(this,s,a);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=u;class h{constructor(){this.c=new I.LinkedList}get size(){return this.c.size}push(a,s,m){this.c.push(new d(a,s,m))}clear(a){const s=new I.LinkedList;for(const m of this.c)m.emitter!==a&&s.push(m);this.c=s}deliver(){for(;this.c.size>0;){const a=this.c.shift();try{a.listener.invoke(a.event)}catch(s){(0,E.onUnexpectedError)(s)}}}}e.EventDeliveryQueue=h;class v extends h{clear(a){this.c.clear()}}class d{constructor(a,s,m){this.emitter=a,this.listener=s,this.event=m}}class D extends u{async fireAsync(a,s,m){if(!!this.q){this.c||(this.c=new I.LinkedList);for(const R of this.q)this.c.push([R,a]);for(;this.c.size>0&&!s.isCancellationRequested;){const[R,L]=this.c.shift(),$=[],ie={...L,token:s,waitUntil:ne=>{if(Object.isFrozen($))throw new Error("waitUntil can NOT be called asynchronous");m&&(ne=m(ne,R.callback)),$.push(ne)}};try{R.invoke(ie)}catch(ne){(0,E.onUnexpectedError)(ne);continue}Object.freeze($),await Promise.allSettled($).then(ne=>{for(const F of ne)F.status==="rejected"&&(0,E.onUnexpectedError)(F.reason)})}}}}e.AsyncEmitter=D;class A extends u{constructor(a){super(a),this.h=0,this.s=new I.LinkedList,this.t=a?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const a=Array.from(this.s);this.s.clear(),super.fire(this.t(a))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(a){this.q&&(this.h!==0?this.s.push(a):super.fire(a))}}e.PauseableEmitter=A;class t extends A{constructor(a){super(a),this.c=a.delay??100}fire(a){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(a)}}e.DebounceEmitter=t;class r extends u{constructor(a){super(a),this.c=[],this.h=a?.merge}fire(a){!this.hasListeners()||(this.c.push(a),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(s=>super.fire(s)),this.c=[]}))}}e.MicrotaskEmitter=r;class n{constructor(){this.d=!1,this.f=[],this.c=new u({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(a){const s={event:a,listener:null};this.f.push(s),this.d&&this.j(s);const m=()=>{this.d&&this.k(s);const R=this.f.indexOf(s);this.f.splice(R,1)};return(0,l.toDisposable)((0,k.once)(m))}g(){this.d=!0,this.f.forEach(a=>this.j(a))}h(){this.d=!1,this.f.forEach(a=>this.k(a))}j(a){a.listener=a.event(s=>this.c.fire(s))}k(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=n;class i{constructor(){this.c=[]}wrapEvent(a){return(s,m,R)=>a(L=>{const $=this.c[this.c.length-1];$?$.push(()=>s.call(m,L)):s.call(m,L)},void 0,R)}bufferEvents(a){const s=[];this.c.push(s);const m=a();return this.c.pop(),s.forEach(R=>R()),m}}e.EventBufferer=i;class o{constructor(){this.c=!1,this.d=y.None,this.f=l.Disposable.None,this.g=new u({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(a){this.d=a,this.c&&(this.f.dispose(),this.f=a(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(ve[157],be([1,0,6,2,150]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class I extends k.Disposable{constructor(b,g="",f="",p=!0,u){super(),this.h=this.B(new E.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=b,this.m=g,this.u=f,this.w=p,this.C=u}get id(){return this.j}get label(){return this.m}set label(b){this.D(b)}D(b){this.m!==b&&(this.m=b,this.h.fire({label:b}))}get tooltip(){return this.n||""}set tooltip(b){this.F(b)}F(b){this.n!==b&&(this.n=b,this.h.fire({tooltip:b}))}get class(){return this.u}set class(b){this.G(b)}G(b){this.u!==b&&(this.u=b,this.h.fire({class:b}))}get enabled(){return this.w}set enabled(b){this.H(b)}H(b){this.w!==b&&(this.w=b,this.h.fire({enabled:b}))}get checked(){return this.z}set checked(b){this.I(b)}I(b){this.z!==b&&(this.z=b,this.h.fire({checked:b}))}async run(b,g){this.C&&await this.C(b)}}e.Action=I;class C extends k.Disposable{constructor(){super(...arguments),this.f=this.B(new E.Emitter),this.onWillRun=this.f.event,this.h=this.B(new E.Emitter),this.onDidRun=this.h.event}async run(b,g){if(!b.enabled)return;this.f.fire({action:b});let f;try{await this.runAction(b,g)}catch(p){f=p}this.h.fire({action:b,error:f})}async runAction(b,g){await b.run(g)}}e.ActionRunner=C;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...b){let g=[];for(const f of b)f.length&&(g.length?g=[...g,new P,...f]:g=f);return g}async run(){}}P.ID="vs.actions.separator",e.Separator=P;class w{get actions(){return this.a}constructor(b,g,f,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=b,this.label=g,this.class=p,this.a=f}async run(){}}e.SubmenuAction=w;class y extends I{constructor(){super(y.ID,l.localize(0,null),void 0,!1)}}y.ID="vs.actions.empty",e.EmptySubmenuAction=y;function T(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async()=>S.run(),tooltip:S.label}}e.toAction=T}),define(ve[19],be([1,0,6]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(P,w){const y=setTimeout(P.bind(w),0);return{dispose(){clearTimeout(y)}}});var l;(function(P){function w(y){return y===P.None||y===P.Cancelled||y instanceof I?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}P.isCancellationToken=w,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(l=e.CancellationToken||(e.CancellationToken={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?k:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class C{constructor(w){this.a=void 0,this.b=void 0,this.b=w&&w.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new I),this.a}cancel(){this.a?this.a instanceof I&&this.a.cancel():this.a=l.Cancelled}dispose(w=!1){w&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof I&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=C}),define(ve[158],be([1,0,19]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class k{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new E.CancellationTokenSource,w=this.b(P.token);return this.a={promise:w,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=k;class l{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const w=JSON.stringify(P);return this.b!==w&&(this.b=w,this.a=this.c(P)),this.a}}e.LRUCachedFunction=l;class I{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const w=this.b(P);return this.a.set(P,w),w}}e.CachedFunction=I}),define(ve[16],be([1,0,158,141]),function(ae,e,E,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function I(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=I;const C=/{(\d+)}/g;function P(ue,...Ie){return Ie.length===0?ue:ue.replace(C,function(Ce,Le){const Ne=parseInt(Le,10);return isNaN(Ne)||Ne<0||Ne>=Ie.length?Ce:Ie[Ne]})}e.format=P;const w=/{([^}]+)}/g;function y(ue,Ie){return ue.replace(w,(Ce,Le)=>Ie[Le]??Ce)}e.format2=y;function T(ue){return ue.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}e.escape=T;function S(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function b(ue,Ie){let Ce=0;const Le=Ie.charCodeAt(0);for(let Ne=ue.length-1;Ne>=0;Ne--)ue.charCodeAt(Ne)===Le&&Ce++;return Ce}e.count=b;function g(ue,Ie,Ce="\u2026"){return ue.length<=Ie?ue:`${ue.substr(0,Ie)}${Ce}`}e.truncate=g;function f(ue,Ie=" "){const Ce=p(ue,Ie);return u(Ce,Ie)}e.trim=f;function p(ue,Ie){if(!ue||!Ie)return ue;const Ce=Ie.length;if(Ce===0||ue.length===0)return ue;let Le=0;for(;ue.indexOf(Ie,Le)===Le;)Le=Le+Ce;return ue.substring(Le)}e.ltrim=p;function u(ue,Ie){if(!ue||!Ie)return ue;const Ce=Ie.length,Le=ue.length;if(Ce===0||Le===0)return ue;let Ne=Le,ze=-1;for(;ze=ue.lastIndexOf(Ie,Ne-1),!(ze===-1||ze+Ce!==Ne);){if(ze===0)return"";Ne=ze}return ue.substring(0,Ne)}e.rtrim=u;function h(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function v(ue){return ue.replace(/\*/g,"")}e.stripWildcards=v;function d(ue,Ie,Ce={}){if(!ue)throw new Error("Cannot create regex from empty string");Ie||(ue=S(ue)),Ce.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Le="";return Ce.global&&(Le+="g"),Ce.matchCase||(Le+="i"),Ce.multiline&&(Le+="m"),Ce.unicode&&(Le+="u"),new RegExp(ue,Le)}e.createRegExp=d;function D(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=D;function A(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=A;function t(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=t;function r(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=r;function n(ue){for(let Ie=0,Ce=ue.length;Ie<Ce;Ie++){const Le=ue.charCodeAt(Ie);if(Le!==32&&Le!==9)return Ie}return-1}e.firstNonWhitespaceIndex=n;function i(ue,Ie=0,Ce=ue.length){for(let Le=Ie;Le<Ce;Le++){const Ne=ue.charCodeAt(Le);if(Ne!==32&&Ne!==9)return ue.substring(Ie,Le)}return ue.substring(Ie,Ce)}e.getLeadingWhitespace=i;function o(ue,Ie=ue.length-1){for(let Ce=Ie;Ce>=0;Ce--){const Le=ue.charCodeAt(Ce);if(Le!==32&&Le!==9)return Ce}return-1}e.lastNonWhitespaceIndex=o;function c(ue,Ie,Ce){const Le=[];let Ne=0;for(const ze of ue.matchAll(Ie)){if(Le.push(ue.slice(Ne,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Ne=ze.index+ze[0].length,Le.push(Ce(ze[0],...ze.slice(1),ze.index,ue,ze.groups))}return Le.push(ue.slice(Ne)),Promise.all(Le).then(ze=>ze.join(""))}e.replaceAsync=c;function a(ue,Ie){return ue<Ie?-1:ue>Ie?1:0}e.compare=a;function s(ue,Ie,Ce=0,Le=ue.length,Ne=0,ze=Ie.length){for(;Ce<Le&&Ne<ze;Ce++,Ne++){const st=ue.charCodeAt(Ce),Ze=Ie.charCodeAt(Ne);if(st<Ze)return-1;if(st>Ze)return 1}const Ve=Le-Ce,Xe=ze-Ne;return Ve<Xe?-1:Ve>Xe?1:0}e.compareSubstring=s;function m(ue,Ie){return R(ue,Ie,0,ue.length,0,Ie.length)}e.compareIgnoreCase=m;function R(ue,Ie,Ce=0,Le=ue.length,Ne=0,ze=Ie.length){for(;Ce<Le&&Ne<ze;Ce++,Ne++){let st=ue.charCodeAt(Ce),Ze=Ie.charCodeAt(Ne);if(st===Ze)continue;if(st>=128||Ze>=128)return s(ue.toLowerCase(),Ie.toLowerCase(),Ce,Le,Ne,ze);$(st)&&(st-=32),$(Ze)&&(Ze-=32);const rt=st-Ze;if(rt!==0)return rt}const Ve=Le-Ce,Xe=ze-Ne;return Ve<Xe?-1:Ve>Xe?1:0}e.compareSubstringIgnoreCase=R;function L(ue){return ue>=48&&ue<=57}e.isAsciiDigit=L;function $(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=$;function ie(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=ie;function ne(ue,Ie){return ue.length===Ie.length&&R(ue,Ie)===0}e.equalsIgnoreCase=ne;function F(ue,Ie){const Ce=Ie.length;return Ie.length>ue.length?!1:R(ue,Ie,0,Ce)===0}e.startsWithIgnoreCase=F;function _(ue,Ie){const Ce=Math.min(ue.length,Ie.length);let Le;for(Le=0;Le<Ce;Le++)if(ue.charCodeAt(Le)!==Ie.charCodeAt(Le))return Le;return Ce}e.commonPrefixLength=_;function z(ue,Ie){const Ce=Math.min(ue.length,Ie.length);let Le;const Ne=ue.length-1,ze=Ie.length-1;for(Le=0;Le<Ce;Le++)if(ue.charCodeAt(Ne-Le)!==Ie.charCodeAt(ze-Le))return Le;return Ce}e.commonSuffixLength=z;function x(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=x;function le(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=le;function Ee(ue,Ie){return(ue-55296<<10)+(Ie-56320)+65536}e.computeCodePoint=Ee;function Y(ue,Ie,Ce){const Le=ue.charCodeAt(Ce);if(x(Le)&&Ce+1<Ie){const Ne=ue.charCodeAt(Ce+1);if(le(Ne))return Ee(Le,Ne)}return Le}e.getNextCodePoint=Y;function H(ue,Ie){const Ce=ue.charCodeAt(Ie-1);if(le(Ce)&&Ie>1){const Le=ue.charCodeAt(Ie-2);if(x(Le))return Ee(Le,Ce)}return Ce}class U{get offset(){return this.e}constructor(Ie,Ce=0){this.c=Ie,this.d=Ie.length,this.e=Ce}setOffset(Ie){this.e=Ie}prevCodePoint(){const Ie=H(this.c,this.e);return this.e-=Ie>=65536?2:1,Ie}nextCodePoint(){const Ie=Y(this.c,this.d,this.e);return this.e+=Ie>=65536?2:1,Ie}eol(){return this.e>=this.d}}e.CodePointIterator=U;class te{get offset(){return this.c.offset}constructor(Ie,Ce=0){this.c=new U(Ie,Ce)}nextGraphemeLength(){const Ie=Ye.getInstance(),Ce=this.c,Le=Ce.offset;let Ne=Ie.getGraphemeBreakType(Ce.nextCodePoint());for(;!Ce.eol();){const ze=Ce.offset,Ve=Ie.getGraphemeBreakType(Ce.nextCodePoint());if(Me(Ne,Ve)){Ce.setOffset(ze);break}Ne=Ve}return Ce.offset-Le}prevGraphemeLength(){const Ie=Ye.getInstance(),Ce=this.c,Le=Ce.offset;let Ne=Ie.getGraphemeBreakType(Ce.prevCodePoint());for(;Ce.offset>0;){const ze=Ce.offset,Ve=Ie.getGraphemeBreakType(Ce.prevCodePoint());if(Me(Ve,Ne)){Ce.setOffset(ze);break}Ne=Ve}return Le-Ce.offset}eol(){return this.c.eol()}}e.GraphemeIterator=te;function re(ue,Ie){return new te(ue,Ie).nextGraphemeLength()}e.nextCharLength=re;function de(ue,Ie){return new te(ue,Ie).prevGraphemeLength()}e.prevCharLength=de;function oe(ue,Ie){Ie>0&&le(ue.charCodeAt(Ie))&&Ie--;const Ce=Ie+re(ue,Ie);return[Ce-de(ue,Ce),Ce]}e.getCharContainingOffset=oe;function j(ue){const Ie=new te(ue);let Ce=0;for(;!Ie.eol();)Ce++,Ie.nextGraphemeLength();return Ce}e.charCount=j;let N;function M(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function q(ue){return N||(N=M()),N.test(ue)}e.containsRTL=q;const ee=/^[\t\n\r\x20-\x7E]*$/;function fe(ue){return ee.test(ue)}e.isBasicASCII=fe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function W(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=W;function K(ue){return ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=K;function Z(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129008||ue>=129280&&ue<=129535||ue>=129648&&ue<=129782}e.isEmojiImprecise=Z;function V(ue,Ie){if(ue.length<Ie)return ue;const Ce=/\b/g;let Le=0;for(;Ce.test(ue)&&!(ue.length-Ce.lastIndex<Ie);)Le=Ce.lastIndex,Ce.lastIndex+=1;return ue.substring(Le).replace(/^\s/,"")}e.lcut=V;const Q=/\x1B\x5B[12]?K/g,G=/\x1b\[\d+m/g,X=/\x1b\[0?m/g;function ce(ue){return ue&&(ue=ue.replace(Q,""),ue=ue.replace(G,""),ue=ue.replace(X,"")),ue}e.removeAnsiEscapeCodes=ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function pe(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=pe;function Pe(ue){return pe(ue)?ue.substr(1):ue}e.stripUTF8BOM=Pe;function Ae(ue,Ie){if(!ue||!Ie||ue.length<Ie.length)return!1;const Ce=Ie.length,Le=ue.toLowerCase();let Ne=0,ze=-1;for(;Ne<Ce;){const Ve=Le.indexOf(Ie[Ne],ze+1);if(Ve<0)return!1;ze=Ve,Ne++}return!0}e.fuzzyContains=Ae;function Fe(ue,Ie=!1){return ue?(Ie&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=Fe;function $e(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=$e;function me(ue,Ie=1){if(Ie===0)return"";let Ce=-1;do Ce=ue.indexOf(`
`,Ce+1),Ie--;while(Ie>0&&Ce>=0);return Ce===-1?ue:(ue[Ce-1]==="\r"&&Ce--,ue.substr(0,Ce))}e.getNLines=me;function we(ue){return ue=ue%(2*26),ue<26?String.fromCharCode(97+ue):String.fromCharCode(65+ue-26)}e.singleLetterHash=we;function ye(ue){return Ye.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=ye;function Me(ue,Ie){return ue===0?Ie!==5&&Ie!==7:ue===2&&Ie===3?!1:ue===4||ue===2||ue===3||Ie===4||Ie===2||Ie===3?!0:!(ue===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(ue===11||ue===9)&&(Ie===9||Ie===10)||(ue===12||ue===10)&&Ie===10||Ie===5||Ie===13||Ie===7||ue===1||ue===13&&Ie===14||ue===6&&Ie===6)}var je;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(je=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ye{static getInstance(){return Ye.c||(Ye.c=new Ye),Ye.c}constructor(){this.d=He()}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Ce=this.d,Le=Ce.length/3;let Ne=1;for(;Ne<=Le;)if(Ie<Ce[3*Ne])Ne=2*Ne;else if(Ie>Ce[3*Ne+1])Ne=2*Ne+1;else return Ce[3*Ne+2];return 0}}Ye.c=null;function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ke(ue,Ie){if(ue===0)return 0;const Ce=Je(ue,Ie);if(Ce!==void 0)return Ce;const Le=new U(Ie,ue);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=Ke;function Je(ue,Ie){const Ce=new U(Ie,ue);let Le=Ce.prevCodePoint();for(;nt(Le)||Le===65039||Le===8419;){if(Ce.offset===0)return;Le=Ce.prevCodePoint()}if(!Z(Le))return;let Ne=Ce.offset;return Ne>0&&Ce.prevCodePoint()===8205&&(Ne=Ce.offset),Ne}function nt(ue){return 127995<=ue&&ue<=127999}var xe;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(xe||(xe={})),e.noBreakWhitespace="\xA0";class Ge{static getInstance(Ie){return Ge.d.get(Array.from(Ie))}static getLocales(){return Ge.e.value}constructor(Ie){this.f=Ie}isAmbiguous(Ie){return this.f.has(Ie)}getPrimaryConfusable(Ie){return this.f.get(Ie)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=Ge,Ge.c=new k.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ge.d=new E.LRUCachedFunction(ue=>{function Ie(Ze){const rt=new Map;for(let at=0;at<Ze.length;at+=2)rt.set(Ze[at],Ze[at+1]);return rt}function Ce(Ze,rt){const at=new Map(Ze);for(const[ct,bt]of rt)at.set(ct,bt);return at}function Le(Ze,rt){if(!Ze)return rt;const at=new Map;for(const[ct,bt]of Ze)rt.has(ct)&&at.set(ct,bt);return at}const Ne=l.c.value;let ze=ue.filter(Ze=>!Ze.startsWith("_")&&Ze in Ne);ze.length===0&&(ze=["_default"]);let Ve;for(const Ze of ze){const rt=Ie(Ne[Ze]);Ve=Le(Ve,rt)}const Xe=Ie(Ne._common),st=Ce(Xe,Ve);return new Ge(st)}),Ge.e=new k.Lazy(()=>Object.keys(Ge.c.value).filter(ue=>!ue.startsWith("_"))),e.AmbiguousCharacters=Ge;class et{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(et.c())),this.d}static isInvisibleCharacter(Ie){return et.e().has(Ie)}static get codePoints(){return et.e()}}et.d=void 0,e.InvisibleCharacters=et}),define(ve[38],be([1,0,7,3,16,8]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(o){return o===47||o===92}e.isPathSeparator=C;function P(o){return o.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function w(o){return o.indexOf("/")===-1&&(o=P(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=w;function y(o,c=E.posix.sep){if(!o)return"";const a=o.length,s=o.charCodeAt(0);if(C(s)){if(C(o.charCodeAt(1))&&!C(o.charCodeAt(2))){let R=3;const L=R;for(;R<a&&!C(o.charCodeAt(R));R++);if(L!==R&&!C(o.charCodeAt(R+1))){for(R+=1;R<a;R++)if(C(o.charCodeAt(R)))return o.slice(0,R+1).replace(/[\\/]/g,c)}}return c}else if(h(s)&&o.charCodeAt(1)===58)return C(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let m=o.indexOf("://");if(m!==-1){for(m+=3;m<a;m++)if(C(o.charCodeAt(m)))return o.slice(0,m+1)}return""}e.getRoot=y;function T(o){if(!k.isWindows||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let a=2;const s=a;for(;a<o.length&&(c=o.charCodeAt(a),c!==92);a++);return!(s===a||(c=o.charCodeAt(a+1),isNaN(c)||c===92))}e.isUNC=T;const S=/[\\/:\*\?"<>\|]/g,b=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(o,c=k.isWindows){const a=c?S:b;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||c&&g.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=f;function p(o,c,a){const s=o===c;return!a||s?s:!o||!c?!1:(0,l.equalsIgnoreCase)(o,c)}e.isEqual=p;function u(o,c,a,s=E.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(a){if(!(0,l.startsWithIgnoreCase)(o,c))return!1;if(c.length===o.length)return!0;let R=c.length;return c.charAt(c.length-1)===s&&R--,o.charAt(R)===s}return c.charAt(c.length-1)!==s&&(c+=s),o.indexOf(c)===0}e.isEqualOrParent=u;function h(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=h;function v(o,c){return k.isWindows&&o.endsWith(":")&&(o+=E.sep),(0,E.isAbsolute)(o)||(o=(0,E.join)(c,o)),o=(0,E.normalize)(o),k.isWindows?(o=(0,l.rtrim)(o,E.sep),o.endsWith(":")&&(o+=E.sep)):(o=(0,l.rtrim)(o,E.sep),o||(o=E.sep)),o}e.sanitizeFilePath=v;function d(o){const c=(0,E.normalize)(o);return k.isWindows?o.length>3?!1:D(c)&&(o.length===2||c.charCodeAt(2)===92):c===E.posix.sep}e.isRootOrDriveLetter=d;function D(o,c=k.isWindows){return c?h(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=D;function A(o){return D(o)?o[0]:void 0}e.getDriveLetter=A;function t(o,c,a){return c.length>o.length?-1:o===c?0:(a&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.indexOfPath=t;function r(o){const c=o.split(":");let a,s,m;for(const R of c){const L=Number(R);(0,I.isNumber)(L)?s===void 0?s=L:m===void 0&&(m=L):a=a?[a,R].join(":"):R}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:s!==void 0?s:void 0,column:m!==void 0?m:s!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(o,c,a=8){let s="";for(let R=0;R<a;R++)s+=n.charAt(Math.floor(Math.random()*n.length));let m;return c?m=`${c}-${s}`:m=s,o?(0,E.join)(o,m):m}e.randomPath=i}),define(ve[159],be([1,0,27,16]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function l(...G){return function(X,ce){for(let pe=0,Pe=G.length;pe<Pe;pe++){const Ae=G[pe](X,ce);if(Ae)return Ae}return null}}e.or=l,e.matchesStrictPrefix=I.bind(void 0,!1),e.matchesPrefix=I.bind(void 0,!0);function I(G,X,ce){if(!ce||ce.length<X.length)return null;let pe;return G?pe=k.startsWithIgnoreCase(ce,X):pe=ce.indexOf(X)===0,pe?X.length>0?[{start:0,end:X.length}]:[]:null}function C(G,X){const ce=X.toLowerCase().indexOf(G.toLowerCase());return ce===-1?null:[{start:ce,end:ce+G.length}]}e.matchesContiguousSubString=C;function P(G,X){return w(G.toLowerCase(),X.toLowerCase(),0,0)}e.matchesSubString=P;function w(G,X,ce,pe){if(ce===G.length)return[];if(pe===X.length)return null;if(G[ce]===X[pe]){let Pe=null;return(Pe=w(G,X,ce+1,pe+1))?h({start:pe,end:pe+1},Pe):null}return w(G,X,ce,pe+1)}function y(G){return 97<=G&&G<=122}function T(G){return 65<=G&&G<=90}e.isUpper=T;function S(G){return 48<=G&&G<=57}function b(G){return G===32||G===9||G===10||G===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(G=>g.add(G.charCodeAt(0)));function f(G){return b(G)||g.has(G)}function p(G,X){return G===X||f(G)&&f(X)}function u(G){return y(G)||T(G)||S(G)}function h(G,X){return X.length===0?X=[G]:G.end===X[0].start?X[0].start=G.start:X.unshift(G),X}function v(G,X){for(let ce=X;ce<G.length;ce++){const pe=G.charCodeAt(ce);if(T(pe)||S(pe)||ce>0&&!u(G.charCodeAt(ce-1)))return ce}return G.length}function d(G,X,ce,pe){if(ce===G.length)return[];if(pe===X.length)return null;if(G[ce]!==X[pe].toLowerCase())return null;{let Pe=null,Ae=pe+1;for(Pe=d(G,X,ce+1,pe+1);!Pe&&(Ae=v(X,Ae))<X.length;)Pe=d(G,X,ce+1,Ae),Ae++;return Pe===null?null:h({start:pe,end:pe+1},Pe)}}function D(G){let X=0,ce=0,pe=0,Pe=0,Ae=0;for(let ye=0;ye<G.length;ye++)Ae=G.charCodeAt(ye),T(Ae)&&X++,y(Ae)&&ce++,u(Ae)&&pe++,S(Ae)&&Pe++;const Fe=X/G.length,$e=ce/G.length,me=pe/G.length,we=Pe/G.length;return{upperPercent:Fe,lowerPercent:$e,alphaPercent:me,numericPercent:we}}function A(G){const{upperPercent:X,lowerPercent:ce}=G;return ce===0&&X>.6}function t(G){const{upperPercent:X,lowerPercent:ce,alphaPercent:pe,numericPercent:Pe}=G;return ce>.2&&X<.8&&pe>.6&&Pe<.2}function r(G){let X=0,ce=0,pe=0,Pe=0;for(let Ae=0;Ae<G.length;Ae++)pe=G.charCodeAt(Ae),T(pe)&&X++,y(pe)&&ce++,b(pe)&&Pe++;return(X===0||ce===0)&&Pe===0?G.length<=30:X<=5}function n(G,X){if(!X||(X=X.trim(),X.length===0)||!r(G)||X.length>60)return null;const ce=D(X);if(!t(ce)){if(!A(ce))return null;X=X.toLowerCase()}let pe=null,Pe=0;for(G=G.toLowerCase();Pe<X.length&&(pe=d(G,X,0,Pe))===null;)Pe=v(X,Pe+1);return pe}e.matchesCamelCase=n;function i(G,X,ce=!1){if(!X||X.length===0)return null;let pe=null,Pe=0;for(G=G.toLowerCase(),X=X.toLowerCase();Pe<X.length&&(pe=o(G,X,0,Pe,ce))===null;)Pe=c(X,Pe+1);return pe}e.matchesWords=i;function o(G,X,ce,pe,Pe){if(ce===G.length)return[];if(pe===X.length)return null;if(p(G.charCodeAt(ce),X.charCodeAt(pe))){let Ae=null,Fe=pe+1;if(Ae=o(G,X,ce+1,pe+1,Pe),!Pe)for(;!Ae&&(Fe=c(X,Fe))<X.length;)Ae=o(G,X,ce+1,Fe,Pe),Fe++;return Ae?G.charCodeAt(ce)!==X.charCodeAt(pe)?Ae:h({start:pe,end:pe+1},Ae):null}else return null}function c(G,X){for(let ce=X;ce<G.length;ce++)if(f(G.charCodeAt(ce))||ce>0&&f(G.charCodeAt(ce-1)))return ce;return G.length}const a=l(e.matchesPrefix,n,C),s=l(e.matchesPrefix,n,P),m=new E.LRUCache(1e4);function R(G,X,ce=!1){if(typeof G!="string"||typeof X!="string")return null;let pe=m.get(G);pe||(pe=new RegExp(k.convertSimple2RegExpPattern(G),"i"),m.set(G,pe));const Pe=pe.exec(X);return Pe?[{start:Pe.index,end:Pe.index+Pe[0].length}]:ce?s(G,X):a(G,X)}e.matchesFuzzy=R;function L(G,X){const ce=ee(G,G.toLowerCase(),0,X,X.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ce?ie(ce):null}e.matchesFuzzy2=L;function $(G,X,ce,pe,Pe,Ae){const Fe=Math.min(13,G.length);for(;ce<Fe;ce++){const $e=ee(G,X,ce,pe,Pe,Ae,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if($e)return $e}return[0,Ae]}e.anyScore=$;function ie(G){if(typeof G>"u")return[];const X=[],ce=G[1];for(let pe=G.length-1;pe>1;pe--){const Pe=G[pe]+ce,Ae=X[X.length-1];Ae&&Ae.end===Pe?Ae.end=Pe+1:X.push({start:Pe,end:Pe+1})}return X}e.createMatches=ie;const ne=128;function F(){const G=[],X=[];for(let ce=0;ce<=ne;ce++)X[ce]=0;for(let ce=0;ce<=ne;ce++)G.push(X.slice(0));return G}function _(G){const X=[];for(let ce=0;ce<=G;ce++)X[ce]=0;return X}const z=_(2*ne),x=_(2*ne),le=F(),Ee=F(),Y=F(),H=!1;function U(G,X,ce,pe,Pe){function Ae($e,me,we=" "){for(;$e.length<me;)$e=we+$e;return $e}let Fe=` |   |${pe.split("").map($e=>Ae($e,3)).join("|")}
`;for(let $e=0;$e<=ce;$e++)$e===0?Fe+=" |":Fe+=`${X[$e-1]}|`,Fe+=G[$e].slice(0,Pe+1).map(me=>Ae(me.toString(),3)).join("|")+`
`;return Fe}function te(G,X,ce,pe){G=G.substr(X),ce=ce.substr(pe),console.log(U(Ee,G,G.length,ce,ce.length)),console.log(U(Y,G,G.length,ce,ce.length)),console.log(U(le,G,G.length,ce,ce.length))}function re(G,X){if(X<0||X>=G.length)return!1;const ce=G.codePointAt(X);switch(ce){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(ce)}}function de(G,X){if(X<0||X>=G.length)return!1;switch(G.charCodeAt(X)){case 32:case 9:return!0;default:return!1}}function oe(G,X,ce){return X[G]!==ce[G]}function j(G,X,ce,pe,Pe,Ae,Fe=!1){for(;X<ce&&Pe<Ae;)G[X]===pe[Pe]&&(Fe&&(z[X]=Pe),X+=1),Pe+=1;return X===ce}e.isPatternInWord=j;var N;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(N||(N={}));var M;(function(G){G.Default=[-100,0];function X(ce){return!ce||ce.length===2&&ce[0]===-100&&ce[1]===0}G.isDefault=X})(M=e.FuzzyScore||(e.FuzzyScore={}));class q{constructor(X,ce){this.firstMatchCanBeWeak=X,this.boostFullMatch=ce}}q.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=q;function ee(G,X,ce,pe,Pe,Ae,Fe=q.default){const $e=G.length>ne?ne:G.length,me=pe.length>ne?ne:pe.length;if(ce>=$e||Ae>=me||$e-ce>me-Ae||!j(X,ce,$e,Pe,Ae,me,!0))return;fe($e,me,ce,Ae,X,Pe);let we=1,ye=1,Me=ce,je=Ae;const Ye=[!1];for(we=1,Me=ce;Me<$e;we++,Me++){const xe=z[Me],Ge=x[Me],et=Me+1<$e?x[Me+1]:me;for(ye=xe-Ae+1,je=xe;je<et;ye++,je++){let ue=Number.MIN_SAFE_INTEGER,Ie=!1;je<=Ge&&(ue=W(G,X,Me,ce,pe,Pe,je,me,Ae,le[we-1][ye-1]===0,Ye));let Ce=0;ue!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Ce=ue+Ee[we-1][ye-1]);const Le=je>xe,Ne=Le?Ee[we][ye-1]+(le[we][ye-1]>0?-5:0):0,ze=je>xe+1&&le[we][ye-1]>0,Ve=ze?Ee[we][ye-2]+(le[we][ye-2]>0?-5:0):0;if(ze&&(!Le||Ve>=Ne)&&(!Ie||Ve>=Ce))Ee[we][ye]=Ve,Y[we][ye]=3,le[we][ye]=0;else if(Le&&(!Ie||Ne>=Ce))Ee[we][ye]=Ne,Y[we][ye]=2,le[we][ye]=0;else if(Ie)Ee[we][ye]=Ce,Y[we][ye]=1,le[we][ye]=le[we-1][ye-1]+1;else throw new Error("not possible")}}if(H&&te(G,ce,pe,Ae),!Ye[0]&&!Fe.firstMatchCanBeWeak)return;we--,ye--;const He=[Ee[we][ye],Ae];let Ke=0,Je=0;for(;we>=1;){let xe=ye;do{const Ge=Y[we][xe];if(Ge===3)xe=xe-2;else if(Ge===2)xe=xe-1;else break}while(xe>=1);Ke>1&&X[ce+we-1]===Pe[Ae+ye-1]&&!oe(xe+Ae-1,pe,Pe)&&Ke+1>le[we][xe]&&(xe=ye),xe===ye?Ke++:Ke=1,Je||(Je=xe),we--,ye=xe-1,He.push(ye)}me===$e&&Fe.boostFullMatch&&(He[0]+=2);const nt=Je-$e;return He[0]-=nt,He}e.fuzzyScore=ee;function fe(G,X,ce,pe,Pe,Ae){let Fe=G-1,$e=X-1;for(;Fe>=ce&&$e>=pe;)Pe[Fe]===Ae[$e]&&(x[Fe]=$e,Fe--),$e--}function W(G,X,ce,pe,Pe,Ae,Fe,$e,me,we,ye){if(X[ce]!==Ae[Fe])return Number.MIN_SAFE_INTEGER;let Me=1,je=!1;return Fe===ce-pe?Me=G[ce]===Pe[Fe]?7:5:oe(Fe,Pe,Ae)&&(Fe===0||!oe(Fe-1,Pe,Ae))?(Me=G[ce]===Pe[Fe]?7:5,je=!0):re(Ae,Fe)&&(Fe===0||!re(Ae,Fe-1))?Me=5:(re(Ae,Fe-1)||de(Ae,Fe-1))&&(Me=5,je=!0),Me>1&&ce===pe&&(ye[0]=!0),je||(je=oe(Fe,Pe,Ae)||re(Ae,Fe-1)||de(Ae,Fe-1)),ce===pe?Fe>me&&(Me-=je?3:5):we?Me+=je?2:0:Me+=je?0:1,Fe+1===$e&&(Me-=je?3:5),Me}function K(G,X,ce,pe,Pe,Ae,Fe){return V(G,X,ce,pe,Pe,Ae,!0,Fe)}e.fuzzyScoreGracefulAggressive=K;function Z(G,X,ce,pe,Pe,Ae,Fe){return V(G,X,ce,pe,Pe,Ae,!1,Fe)}e.fuzzyScoreGraceful=Z;function V(G,X,ce,pe,Pe,Ae,Fe,$e){let me=ee(G,X,ce,pe,Pe,Ae,$e);if(me&&!Fe)return me;if(G.length>=3){const we=Math.min(7,G.length-1);for(let ye=ce+1;ye<we;ye++){const Me=Q(G,ye);if(Me){const je=ee(Me,Me.toLowerCase(),ce,pe,Pe,Ae,$e);je&&(je[0]-=3,(!me||je[0]>me[0])&&(me=je))}}}return me}function Q(G,X){if(X+1>=G.length)return;const ce=G[X],pe=G[X+1];if(ce!==pe)return G.slice(0,X)+pe+ce+G.slice(X+2)}}),define(ve[94],be([1,0,16]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function k(h){return l(h,0)}e.hash=k;function l(h,v){switch(typeof h){case"object":return h===null?I(349,v):Array.isArray(h)?w(h,v):y(h,v);case"string":return P(h,v);case"boolean":return C(h,v);case"number":return I(h,v);case"undefined":return I(937,v);default:return I(617,v)}}e.doHash=l;function I(h,v){return(v<<5)-v+h|0}e.numberHash=I;function C(h,v){return I(h?433:863,v)}function P(h,v){v=I(149417,v);for(let d=0,D=h.length;d<D;d++)v=I(h.charCodeAt(d),v);return v}e.stringHash=P;function w(h,v){return v=I(104579,v),h.reduce((d,D)=>l(D,d),v)}function y(h,v){return v=I(181387,v),Object.keys(h).sort().reduce((d,D)=>(d=P(D,d),l(h[D],d)),v)}class T{constructor(){this.g=0}get value(){return this.g}hash(v){return this.g=l(v,this.g),this.g}}e.Hasher=T;var S;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function b(h,v,d=32){const D=d-v,A=~((1<<D)-1);return(h<<v|(A&h)>>>D)>>>0}function g(h,v=0,d=h.byteLength,D=0){for(let A=0;A<d;A++)h[v+A]=D}function f(h,v,d="0"){for(;h.length<v;)h=d+h;return h}function p(h,v=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(d=>d.toString(16).padStart(2,"0")).join(""):f((h>>>0).toString(16),v/4)}e.toHexString=p;class u{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(v){const d=v.length;if(d===0)return;const D=this.p;let A=this.r,t=this.u,r,n;for(t!==0?(r=t,n=-1,t=0):(r=v.charCodeAt(0),n=0);;){let i=r;if(E.isHighSurrogate(r))if(n+1<d){const o=v.charCodeAt(n+1);E.isLowSurrogate(o)?(n++,i=E.computeCodePoint(r,o)):i=65533}else{t=r;break}else E.isLowSurrogate(r)&&(i=65533);if(A=this.w(D,A,i),n++,n<d)r=v.charCodeAt(n);else break}this.r=A,this.u=t}w(v,d,D){return D<128?v[d++]=D:D<2048?(v[d++]=192|(D&1984)>>>6,v[d++]=128|(D&63)>>>0):D<65536?(v[d++]=224|(D&61440)>>>12,v[d++]=128|(D&4032)>>>6,v[d++]=128|(D&63)>>>0):(v[d++]=240|(D&1835008)>>>18,v[d++]=128|(D&258048)>>>12,v[d++]=128|(D&4032)>>>6,v[d++]=128|(D&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,v[0]=v[64+0],v[1]=v[64+1],v[2]=v[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const v=8*this.t;this.q.setUint32(56,Math.floor(v/4294967296),!1),this.q.setUint32(60,v%4294967296,!1),this.y()}y(){const v=u.g,d=this.q;for(let a=0;a<64;a+=4)v.setUint32(a,d.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)v.setUint32(a,b(v.getUint32(a-12,!1)^v.getUint32(a-32,!1)^v.getUint32(a-56,!1)^v.getUint32(a-64,!1),1),!1);let D=this.h,A=this.l,t=this.m,r=this.n,n=this.o,i,o,c;for(let a=0;a<80;a++)a<20?(i=A&t|~A&r,o=1518500249):a<40?(i=A^t^r,o=1859775393):a<60?(i=A&t|A&r|t&r,o=2400959708):(i=A^t^r,o=3395469782),c=b(D,5)+i+n+o+v.getUint32(a*4,!1)&4294967295,n=r,r=t,t=b(A,30),A=D,D=c;this.h=this.h+D&4294967295,this.l=this.l+A&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+n&4294967295}}u.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=u}),define(ve[160],be([1,0,159,16,89]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const I="$(",C=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${C.source}`,"g");function w(h){return h.replace(P,(v,d)=>d?v:`\\${v}`)}e.escapeIcons=w;const y=new RegExp(`\\\\${C.source}`,"g");function T(h){return h.replace(y,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=T;const S=new RegExp(`(\\s)?(\\\\)?${C.source}(\\s)?`,"g");function b(h){return h.indexOf(I)===-1?h:h.replace(S,(v,d,D,A)=>D?v:d||A||"")}e.stripIcons=b;function g(h){return h?h.replace(/\$\((.*?)\)/g,(v,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=g;const f=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(h){f.lastIndex=0;let v="";const d=[];let D=0;for(;;){const A=f.lastIndex,t=f.exec(h),r=h.substring(A,t?.index);if(r.length>0){v+=r;for(let n=0;n<r.length;n++)d.push(D)}if(!t)break;D+=t[0].length}return{text:v,iconOffsets:d}}e.parseLabelWithIcons=p;function u(h,v,d=!1){const{text:D,iconOffsets:A}=v;if(!A||A.length===0)return(0,E.matchesFuzzy)(h,D,d);const t=(0,k.ltrim)(D," "),r=D.length-t.length,n=(0,E.matchesFuzzy)(h,t,d);if(n)for(const i of n){const o=A[i.start+r]+r;i.start+=o,i.end+=o}return n}e.matchesFuzzyIconAware=u}),define(ve[58],be([1,0,16]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(k||(k={})),function(l){const I="error",C="warning",P="warn",w="info",y="ignore";function T(b){return b?E.equalsIgnoreCase(I,b)?l.Error:E.equalsIgnoreCase(C,b)||E.equalsIgnoreCase(P,b)?l.Warning:E.equalsIgnoreCase(w,b)?l.Info:l.Ignore:l.Ignore}l.fromValue=T;function S(b){switch(b){case l.Error:return I;case l.Warning:return C;case l.Info:return w;default:return y}}l.toString=S}(k||(k={})),e.default=k}),define(ve[59],be([1,0,18,16]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(g){return this.b=g,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(g){const f=g.charCodeAt(0),p=this.b.charCodeAt(this.c);return f-p}value(){return this.b[this.c]}}e.StringIterator=l;class I{constructor(g=!0){this.e=g}reset(g){return this.b=g,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let g=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(g)this.c++;else break;else g=!1;return this}cmp(g){return this.e?(0,k.compareSubstring)(g,this.b,0,g.length,this.c,this.d):(0,k.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=I;class C{constructor(g=!0,f=!0){this.f=g,this.g=f}reset(g){this.d=0,this.e=0,this.b=g,this.c=g.length;for(let f=g.length-1;f>=0;f--,this.c--){const p=this.b.charCodeAt(f);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let g=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(g)this.d++;else break;else g=!1}return this}cmp(g){return this.g?(0,k.compareSubstring)(g,this.b,0,g.length,this.d,this.e):(0,k.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=C;var P;(function(b){b[b.Scheme=1]="Scheme",b[b.Authority=2]="Authority",b[b.Path=3]="Path",b[b.Query=4]="Query",b[b.Fragment=5]="Fragment"})(P||(P={}));class w{constructor(g,f){this.f=g,this.g=f,this.d=[],this.e=0}reset(g){return this.c=g,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new C(!1,!this.f(g)),this.b.reset(g.path),this.b.value()&&this.d.push(3)),this.g(g)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(g){if(this.d[this.e]===1)return(0,k.compareIgnoreCase)(g,this.c.scheme);if(this.d[this.e]===2)return(0,k.compareIgnoreCase)(g,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(g);if(this.d[this.e]===4)return(0,k.compare)(g,this.c.query);if(this.d[this.e]===5)return(0,k.compare)(g,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=w;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(b){b[b.Left=-1]="Left",b[b.Mid=0]="Mid",b[b.Right=1]="Right"})(T||(T={}));class S{static forUris(g=()=>!1,f=()=>!1){return new S(new w(g,f))}static forPaths(g=!1){return new S(new C(void 0,!g))}static forStrings(){return new S(new l)}static forConfigKeys(){return new S(new I)}constructor(g){this.b=g}clear(){this.c=void 0}fill(g,f){if(f){const p=f.slice(0);(0,E.shuffle)(p);for(const u of p)this.set(u,g)}else{const p=g.slice(0);(0,E.shuffle)(p);for(const u of p)this.set(u[0],u[1])}}set(g,f){const p=this.b.reset(g);let u;this.c||(this.c=new y,this.c.segment=p.value());const h=[];for(u=this.c;;){const d=p.cmp(u.segment);if(d>0)u.left||(u.left=new y,u.left.segment=p.value()),h.push([-1,u]),u=u.left;else if(d<0)u.right||(u.right=new y,u.right.segment=p.value()),h.push([1,u]),u=u.right;else if(p.hasNext())p.next(),u.mid||(u.mid=new y,u.mid.segment=p.value()),h.push([0,u]),u=u.mid;else break}const v=u.value;u.value=f,u.key=g;for(let d=h.length-1;d>=0;d--){const D=h[d][1];D.updateHeight();const A=D.balanceFactor();if(A<-1||A>1){const t=h[d][0],r=h[d+1][0];if(t===1&&r===1)h[d][1]=D.rotateLeft();else if(t===-1&&r===-1)h[d][1]=D.rotateRight();else if(t===1&&r===-1)D.right=h[d+1][1]=h[d+1][1].rotateRight(),h[d][1]=D.rotateLeft();else if(t===-1&&r===1)D.left=h[d+1][1]=h[d+1][1].rotateLeft(),h[d][1]=D.rotateRight();else throw new Error;if(d>0)switch(h[d-1][0]){case-1:h[d-1][1].left=h[d][1];break;case 1:h[d-1][1].right=h[d][1];break;case 0:h[d-1][1].mid=h[d][1];break}else this.c=h[0][1]}}return v}get(g){return this.d(g)?.value}d(g){const f=this.b.reset(g);let p=this.c;for(;p;){const u=f.cmp(p.segment);if(u>0)p=p.left;else if(u<0)p=p.right;else if(f.hasNext())f.next(),p=p.mid;else break}return p}has(g){const f=this.d(g);return!(f?.value===void 0&&f?.mid===void 0)}delete(g){return this.e(g,!1)}deleteSuperstr(g){return this.e(g,!0)}e(g,f){const p=this.b.reset(g),u=[];let h=this.c;for(;h;){const v=p.cmp(h.segment);if(v>0)u.push([-1,h]),h=h.left;else if(v<0)u.push([1,h]),h=h.right;else if(p.hasNext())p.next(),u.push([0,h]),h=h.mid;else break}if(!!h){if(f?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const v=this.f(h.right);if(v.key){const{key:d,value:D,segment:A}=v;this.e(v.key,!1),h.key=d,h.value=D,h.segment=A}}else{const v=h.left??h.right;if(u.length>0){const[d,D]=u[u.length-1];switch(d){case-1:D.left=v;break;case 0:D.mid=v;break;case 1:D.right=v;break}}else this.c=v}for(let v=u.length-1;v>=0;v--){const d=u[v][1];d.updateHeight();const D=d.balanceFactor();if(D>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),u[v][1]=d.rotateLeft()):D<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),u[v][1]=d.rotateRight()),v>0)switch(u[v-1][0]){case-1:u[v-1][1].left=u[v][1];break;case 1:u[v-1][1].right=u[v][1];break;case 0:u[v-1][1].mid=u[v][1];break}else this.c=u[0][1]}}}f(g){for(;g.left;)g=g.left;return g}findSubstr(g){const f=this.b.reset(g);let p=this.c,u;for(;p;){const h=f.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(f.hasNext())f.next(),u=p.value||u,p=p.mid;else break}return p&&p.value||u}findSuperstr(g){return this.g(g,!1)}g(g,f){const p=this.b.reset(g);let u=this.c;for(;u;){const h=p.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(p.hasNext())p.next(),u=u.mid;else return u.mid?this.h(u.mid):f?u.value:void 0}}hasElementOrSubtree(g){return this.g(g,!0)!==void 0}forEach(g){for(const[f,p]of this)g(p,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(g){const f=[];return this.j(g,f),f[Symbol.iterator]()}j(g,f){!g||(g.left&&this.j(g.left,f),g.value&&f.push([g.key,g.value]),g.mid&&this.j(g.mid,f),g.right&&this.j(g.right,f))}_isBalanced(){const g=f=>{if(!f)return!0;const p=f.balanceFactor();return p<-1||p>1?!1:g(f.left)&&g(f.right)};return g(this.c)}}e.TernarySearchTree=S}),define(ve[4],be([1,0,7,3]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,I=/^\//,C=/^\/\//;function P(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!l.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!I.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(C.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function w(n,i){return!n&&!i?"file":n}function y(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==S&&(i=S+i):i=S;break}return i}const T="",S="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(i){return i instanceof g?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,o,c,a,s,m=!1){typeof i=="object"?(this.scheme=i.scheme||T,this.authority=i.authority||T,this.path=i.path||T,this.query=i.query||T,this.fragment=i.fragment||T):(this.scheme=w(i,m),this.authority=o||T,this.path=y(this.scheme,c||T),this.query=a||T,this.fragment=s||T,P(this,m))}get fsPath(){return d(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:c,path:a,query:s,fragment:m}=i;return o===void 0?o=this.scheme:o===null&&(o=T),c===void 0?c=this.authority:c===null&&(c=T),a===void 0?a=this.path:a===null&&(a=T),s===void 0?s=this.query:s===null&&(s=T),m===void 0?m=this.fragment:m===null&&(m=T),o===this.scheme&&c===this.authority&&a===this.path&&s===this.query&&m===this.fragment?this:new p(o,c,a,s,m)}static parse(i,o=!1){const c=b.exec(i);return c?new p(c[2]||T,r(c[4]||T),r(c[5]||T),r(c[7]||T),r(c[9]||T),o):new p(T,T,T,T,T)}static file(i){let o=T;if(k.isWindows&&(i=i.replace(/\\/g,S)),i[0]===S&&i[1]===S){const c=i.indexOf(S,2);c===-1?(o=i.substring(2),i=S):(o=i.substring(2,c),i=i.substring(c)||S)}return new p("file",o,i,T,T)}static from(i){const o=new p(i.scheme,i.authority,i.path,i.query,i.fragment);return P(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return k.isWindows&&i.scheme==="file"?c=g.file(E.win32.join(d(i,!0),...o)).path:c=E.posix.join(i.path,...o),i.with({path:c})}toString(i=!1){return D(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof g)return i;{const o=new p(i);return o._formatted=i.external,o._fsPath=i._sep===f?i.fsPath:null,o}}else return i}}e.URI=g;const f=k.isWindows?1:void 0;class p extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(i=!1){return i?D(this,!0):(this._formatted||(this._formatted=D(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=f),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(n,i,o){let c,a=-1;for(let s=0;s<n.length;s++){const m=n.charCodeAt(s);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||i&&m===47||o&&m===91||o&&m===93||o&&m===58)a!==-1&&(c+=encodeURIComponent(n.substring(a,s)),a=-1),c!==void 0&&(c+=n.charAt(s));else{c===void 0&&(c=n.substr(0,s));const R=u[m];R!==void 0?(a!==-1&&(c+=encodeURIComponent(n.substring(a,s)),a=-1),c+=R):a===-1&&(a=s)}}return a!==-1&&(c+=encodeURIComponent(n.substring(a))),c!==void 0?c:n}function v(n){let i;for(let o=0;o<n.length;o++){const c=n.charCodeAt(o);c===35||c===63?(i===void 0&&(i=n.substr(0,o)),i+=u[c]):i!==void 0&&(i+=n[o])}return i!==void 0?i:n}function d(n,i){let o;return n.authority&&n.path.length>1&&n.scheme==="file"?o=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?o=n.path.substr(1):o=n.path[1].toLowerCase()+n.path.substr(2):o=n.path,k.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=d;function D(n,i){const o=i?v:h;let c="",{scheme:a,authority:s,path:m,query:R,fragment:L}=n;if(a&&(c+=a,c+=":"),(s||a==="file")&&(c+=S,c+=S),s){let $=s.indexOf("@");if($!==-1){const ie=s.substr(0,$);s=s.substr($+1),$=ie.lastIndexOf(":"),$===-1?c+=o(ie,!1,!1):(c+=o(ie.substr(0,$),!1,!1),c+=":",c+=o(ie.substr($+1),!1,!0)),c+="@"}s=s.toLowerCase(),$=s.lastIndexOf(":"),$===-1?c+=o(s,!1,!0):(c+=o(s.substr(0,$),!1,!0),c+=s.substr($))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const $=m.charCodeAt(1);$>=65&&$<=90&&(m=`/${String.fromCharCode($+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const $=m.charCodeAt(0);$>=65&&$<=90&&(m=`${String.fromCharCode($+32)}:${m.substr(2)}`)}c+=o(m,!0,!1)}return R&&(c+="?",c+=o(R,!1,!1)),L&&(c+="#",c+=i?L:h(L,!1,!1)),c}function A(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+A(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(t)?n.replace(t,i=>A(i)):n}}),define(ve[161],be([1,0,4]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function k(y){const T=y;return T&&typeof T.type=="string"&&typeof T.severity=="string"}e.isRemoteConsoleLog=k;function l(y){const T=[];let S;try{const b=JSON.parse(y.arguments),g=b[b.length-1];g&&g.__$stack&&(b.pop(),S=g.__$stack),T.push(...b)}catch{T.push("Unable to log remote console arguments",y.arguments)}return{args:T,stack:S}}e.parse=l;function I(y){if(typeof y!="string")return I(l(y).stack);const T=y;if(T){const S=C(T),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(b&&b.length===4)return{uri:E.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}e.getFirstFrame=I;function C(y){if(!y)return y;const T=y.indexOf(`
`);return T===-1?y:y.substring(0,T)}function P(y,T){const{args:S,stack:b}=l(y),g=typeof S[0]=="string"&&S.length===1;let f=C(b);f&&(f=`(${f.trim()})`);let p=[];if(typeof S[0]=="string"?f&&g?p=[`%c[${T}] %c${S[0]} %c${f}`,w("blue"),w(""),w("grey")]:p=[`%c[${T}] %c${S[0]}`,w("blue"),w(""),...S.slice(1)]:p=[`%c[${T}]%`,w("blue"),...S],f&&!g&&p.push(f),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,p)}e.log=P;function w(y){return`color: ${y}`}}),define(ve[48],be([1,0,15,16,4]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function I(y){return JSON.stringify(y,P)}e.stringify=I;function C(y){let T=JSON.parse(y);return T=w(T),T}e.parse=C;function P(y,T){return T instanceof RegExp?{$mid:2,source:T.source,flags:(0,k.regExpFlags)(T)}:T}function w(y,T=0){if(!y||T>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return l.URI.revive(y);case 2:return new RegExp(y.source,y.flags);case 16:return new Date(y.source)}if(y instanceof E.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let S=0;S<y.length;++S)y[S]=w(y[S],T+1);else for(const S in y)Object.hasOwnProperty.call(y,S)&&(y[S]=w(y[S],T+1))}return y}e.revive=w}),define(ve[13],be([1,0,9,3,4]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractive="vscode-interactive",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm"})(I=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class C{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(T){this.d=T}setDelegate(T){this.e=T}setServerRootPath(T){this.f=`${T}/${I.vscodeRemoteResource}`}set(T,S,b){this.a[T]=S,this.b[T]=b}setConnectionToken(T,S){this.c[T]=S}getPreferredWebSchema(){return this.d}rewrite(T){if(this.e)try{return this.e(T)}catch(u){return E.onUnexpectedError(u),T}const S=T.authority;let b=this.a[S];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const g=this.b[S],f=this.c[S];let p=`path=${encodeURIComponent(T.path)}`;return typeof f=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(f)}`),l.URI.from({scheme:k.isWeb?this.d:I.vscodeRemoteResource,authority:`${b}:${g}`,path:this.f,query:p})}}e.RemoteAuthorities=new C,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(T){const S=this.b(T,ae);return this.uriToBrowserUri(S)}uriToBrowserUri(T){return T.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(T):T.scheme===I.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${I.vscodeFileResource}://${P.a}`)?T.with({scheme:I.vscodeFileResource,authority:T.authority||P.a,query:null,fragment:null}):T}asFileUri(T){const S=this.b(T,ae);return this.uriToFileUri(S)}uriToFileUri(T){return T.scheme===I.vscodeFileResource?T.with({scheme:I.file,authority:T.authority!==P.a?T.authority:null,query:null,fragment:null}):T}b(T,S){return l.URI.isUri(T)?T:l.URI.parse(S.toUrl(T))}}P.a="vscode-app",e.FileAccess=new P;var w;(function(y){const T=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(T.get("3"));const S="vscode-coi";function b(f){let p;typeof f=="string"?p=new URL(f).searchParams:f instanceof URL?p=f.searchParams:l.URI.isUri(f)&&(p=new URL(f.toString(!0)).searchParams);const u=p?.get(S);if(!!u)return T.get(u)}y.getHeadersFromQuery=b;function g(f,p,u){if(!globalThis.crossOriginIsolated)return;const h=p&&u?"3":u?"2":"1";f instanceof URLSearchParams?f.set(S,h):f[S]=h}y.addSearchParam=g})(w=e.COI||(e.COI={}))}),define(ve[20],be([1,0,38,13,7,3,16,4]),function(ae,e,E,k,l,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function w(g){return(0,P.uriToFsPath)(g,!0)}e.originalFSPath=w;class y{constructor(f){this.a=f}compare(f,p,u=!1){return f===p?0:(0,C.compare)(this.getComparisonKey(f,u),this.getComparisonKey(p,u))}isEqual(f,p,u=!1){return f===p?!0:!f||!p?!1:this.getComparisonKey(f,u)===this.getComparisonKey(p,u)}getComparisonKey(f,p=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,p,u=!1){if(f.scheme===p.scheme){if(f.scheme===k.Schemas.file)return E.isEqualOrParent(w(f),w(p),this.a(f))&&f.query===p.query&&(u||f.fragment===p.fragment);if((0,e.isEqualAuthority)(f.authority,p.authority))return E.isEqualOrParent(f.path,p.path,this.a(f),"/")&&f.query===p.query&&(u||f.fragment===p.fragment)}return!1}joinPath(f,...p){return P.URI.joinPath(f,...p)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return l.posix.basename(f.path)}extname(f){return l.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let p;return f.scheme===k.Schemas.file?p=P.URI.file(l.dirname(w(f))).path:(p=l.posix.dirname(f.path),f.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),p="/")),f.with({path:p})}normalizePath(f){if(!f.path.length)return f;let p;return f.scheme===k.Schemas.file?p=P.URI.file(l.normalize(w(f))).path:p=l.posix.normalize(f.path),f.with({path:p})}relativePath(f,p){if(f.scheme!==p.scheme||!(0,e.isEqualAuthority)(f.authority,p.authority))return;if(f.scheme===k.Schemas.file){const v=l.relative(w(f),w(p));return I.isWindows?E.toSlashes(v):v}let u=f.path||"/";const h=p.path||"/";if(this.a(f)){let v=0;for(const d=Math.min(u.length,h.length);v<d&&!(u.charCodeAt(v)!==h.charCodeAt(v)&&u.charAt(v).toLowerCase()!==h.charAt(v).toLowerCase());v++);u=h.substr(0,v)+u.substr(v)}return l.posix.relative(u,h)}resolvePath(f,p){if(f.scheme===k.Schemas.file){const u=P.URI.file(l.resolve(w(f),p));return f.with({authority:u.authority,path:u.path})}return p=E.toPosixPath(p),f.with({path:l.posix.resolve(f.path,p)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,p){return f===p||f!==void 0&&p!==void 0&&(0,C.equalsIgnoreCase)(f,p)}hasTrailingPathSeparator(f,p=l.sep){if(f.scheme===k.Schemas.file){const u=w(f);return u.length>E.getRoot(u).length&&u[u.length-1]===p}else{const u=f.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,p=l.sep){return(0,e.hasTrailingPathSeparator)(f,p)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,p=l.sep){let u=!1;if(f.scheme===k.Schemas.file){const h=w(f);u=h!==void 0&&h.length===E.getRoot(h).length&&h[h.length-1]===p}else{p="/";const h=f.path;u=h.length===1&&h.charCodeAt(h.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(f,p)?f.with({path:f.path+"/"}):f}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(g=>g.scheme===k.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new y(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function T(g,f){const p=[];for(let u=0;u<g.length;u++){const h=f(g[u]);g.some((v,d)=>d===u?!1:(0,e.isEqualOrParent)(h,f(v)))||p.push(g[u])}return p}e.distinctParents=T;var S;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function f(p){const u=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(d=>{const[D,A]=d.split(":");D&&A&&u.set(D,A)});const v=p.path.substring(0,p.path.indexOf(";"));return v&&u.set(g.META_DATA_MIME,v),u}g.parseMetaData=f})(S=e.DataUri||(e.DataUri={}));function b(g,f,p){if(f){let u=g.path;return u&&u[0]!==l.posix.sep&&(u=l.posix.sep+u),g.with({scheme:p,authority:f,path:u})}return g.with({scheme:p})}e.toLocalResource=b}),define(ve[14],be([1,0,19,9,6,2,20,3,145]),function(ae,e,E,k,l,I,C,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(j){return!!j&&typeof j.then=="function"}e.isThenable=y;function T(j){const N=new E.CancellationTokenSource,M=j(N.token),q=new Promise((ee,fe)=>{const W=N.token.onCancellationRequested(()=>{W.dispose(),N.dispose(),fe(new k.CancellationError)});Promise.resolve(M).then(K=>{W.dispose(),N.dispose(),ee(K)},K=>{W.dispose(),N.dispose(),fe(K)})});return new class{cancel(){N.cancel()}then(ee,fe){return q.then(ee,fe)}catch(ee){return this.then(void 0,ee)}finally(ee){return q.finally(ee)}}}e.createCancelablePromise=T;function S(j,N,M){return new Promise((q,ee)=>{const fe=N.onCancellationRequested(()=>{fe.dispose(),q(M)});j.then(q,ee).finally(()=>fe.dispose())})}e.raceCancellation=S;function b(j,N){return new Promise((M,q)=>{const ee=N.onCancellationRequested(()=>{ee.dispose(),q(new k.CancellationError)});j.then(M,q).finally(()=>ee.dispose())})}e.raceCancellationError=b;async function g(j){let N=-1;const M=j.map((ee,fe)=>ee.then(W=>(N=fe,W))),q=await Promise.race(M);return j.forEach((ee,fe)=>{fe!==N&&ee.cancel()}),q}e.raceCancellablePromises=g;function f(j,N,M){let q;const ee=setTimeout(()=>{q?.(void 0),M?.()},N);return Promise.race([j.finally(()=>clearTimeout(ee)),new Promise(fe=>q=fe)])}e.raceTimeout=f;function p(j){return new Promise((N,M)=>{const q=j();y(q)?q.then(N,M):N(q)})}e.asPromise=p;class u{constructor(){this.a=null,this.b=null,this.d=null}queue(N){if(this.a){if(this.d=N,!this.b){const M=()=>{this.b=null;const q=this.queue(this.d);return this.d=null,q};this.b=new Promise(q=>{this.a.then(M,M).then(q)})}return new Promise((M,q)=>{this.b.then(M,q)})}return this.a=N(),new Promise((M,q)=>{this.a.then(ee=>{this.a=null,M(ee)},ee=>{this.a=null,q(ee)})})}}e.Throttler=u;class h{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.Sequencer=h;class v{constructor(){this.a=new Map}queue(N,M){const ee=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.a.get(N)===ee&&this.a.delete(N)});return this.a.set(N,ee),ee}}e.SequencerByKey=v;const d=(j,N)=>{let M=!0;const q=setTimeout(()=>{M=!1,N()},j);return{isTriggered:()=>M,dispose:()=>{clearTimeout(q),M=!1}}},D=j=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,j())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class A{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,M=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((ee,fe)=>{this.d=ee,this.f=fe}).then(()=>{if(this.b=null,this.d=null,this.g){const ee=this.g;return this.g=null,ee()}}));const q=()=>{this.a=null,this.d?.(null)};return this.a=M===w.MicrotaskDelay?D(q):d(M,q),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=A;class t{constructor(N){this.a=new A(N),this.b=new u}trigger(N,M){return this.a.trigger(()=>this.b.queue(N),M)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class r{constructor(){this.a=!1,this.b=new Promise((N,M)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class n extends r{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=n;function i(j,N){return N?new Promise((M,q)=>{const ee=setTimeout(()=>{fe.dispose(),M()},j),fe=N.onCancellationRequested(()=>{clearTimeout(ee),fe.dispose(),q(new k.CancellationError)})}):T(M=>i(j,M))}e.timeout=i;function o(j,N=0){const M=setTimeout(j,N);return(0,I.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=o;function c(j){const N=[];let M=0;const q=j.length;function ee(){return M<q?j[M++]():null}function fe(W){W!=null&&N.push(W);const K=ee();return K?K.then(fe):Promise.resolve(N)}return Promise.resolve(null).then(fe)}e.sequence=c;function a(j,N=q=>!!q,M=null){let q=0;const ee=j.length,fe=()=>{if(q>=ee)return Promise.resolve(M);const W=j[q++];return Promise.resolve(W()).then(Z=>N(Z)?Promise.resolve(Z):fe())};return fe()}e.first=a;function s(j,N=q=>!!q,M=null){if(j.length===0)return Promise.resolve(M);let q=j.length;const ee=()=>{q=-1;for(const fe of j)fe.cancel?.()};return new Promise((fe,W)=>{for(const K of j)K.then(Z=>{--q>=0&&N(Z)?(ee(),fe(Z)):q===0&&fe(M)}).catch(Z=>{--q>=0&&(ee(),W(Z))})})}e.firstParallel=s;class m{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((M,q)=>{this.f.push({factory:N,c:M,e:q}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const M=N.factory();M.then(N.c,N.e),M.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=m;class R extends m{constructor(){super(1)}}e.Queue=R;class L{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const N=new H;return this.b.add(N),N.p}d(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,M=C.extUri){const q=M.getComparisonKey(N);let ee=this.a.get(q);return ee||(ee=new R,l.Event.once(ee.onDrained)(()=>{ee?.dispose(),this.a.delete(q),this.f()}),this.a.set(q,ee)),ee}f(){!this.d()||this.g()}g(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.g()}}e.ResourceQueue=L;class ${constructor(N,M){this.a=-1,typeof N=="function"&&typeof M=="number"&&this.setIfNotSet(N,M)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,M){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},M)}setIfNotSet(N,M){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},M))}}e.TimeoutTimer=$;class ie{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(N,M){this.cancel(),this.a=setInterval(()=>{N()},M)}}e.IntervalTimer=ie;class ne{constructor(N,M){this.b=-1,this.a=N,this.d=M,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=ne;class F{constructor(N,M){M%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.a=N,this.b=M,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=F;class _ extends ne{constructor(N,M){super(N,M),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=_;class z extends I.Disposable{constructor(N,M){super(),this.g=N,this.h=M,this.a=[],this.b=this.B(new I.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const M of N)this.a.push(M);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=j=>{(0,P.setTimeout0)(()=>{if(N)return;const M=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(j,N)=>{const M=requestIdleCallback(j,typeof N=="number"?{timeout:N}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(M))}}}}();class x{constructor(N){this.d=!1,this.a=()=>{try{this.f=N()}catch(M){this.g=M}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=x;async function le(j,N,M){let q;for(let ee=0;ee<M;ee++)try{return await j()}catch(fe){q=fe,await i(N)}throw q}e.retry=le;class Ee{hasPending(N){return this.a?typeof N=="number"?this.a.taskId===N:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(N,M,q){return this.a={taskId:N,cancel:()=>q?.(),promise:M},M.then(()=>this.d(N),()=>this.d(N)),M}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this.b)this.b.run=N;else{let M,q;const ee=new Promise((fe,W)=>{M=fe,q=W});this.b={run:N,promise:ee,promiseResolve:M,promiseReject:q}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=Ee;class Y{constructor(N,M=()=>Date.now()){this.d=N,this.f=M,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.IntervalCounter=Y;class H{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((N,M)=>{this.a=N,this.b=M})}complete(N){return new Promise(M=>{this.a(N),this.f=!0,M()})}error(N){return new Promise(M=>{this.b(N),this.d=!0,M()})}cancel(){new Promise(N=>{this.b(new k.CancellationError),this.d=!0,N()})}}e.DeferredPromise=H;var U;(function(j){async function N(q){let ee;const fe=await Promise.all(q.map(W=>W.then(K=>K,K=>{ee||(ee=K)})));if(typeof ee<"u")throw ee;return fe}j.settled=N;function M(q){return new Promise(async(ee,fe)=>{try{await q(ee,fe)}catch(W){fe(W)}})}j.withAsyncBody=M})(U=e.Promises||(e.Promises={}));var te;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(te||(te={}));class re{static fromArray(N){return new re(M=>{M.emitMany(N)})}static fromPromise(N){return new re(async M=>{M.emitMany(await N)})}static fromPromises(N){return new re(async M=>{await Promise.all(N.map(async q=>M.emitOne(await q)))})}static merge(N){return new re(async M=>{await Promise.all(N.map(async q=>{for await(const ee of q)M.emitOne(ee)}))})}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const M={emitOne:q=>this.g(q),emitMany:q=>this.h(q),reject:q=>this.k(q)};try{await Promise.resolve(N(M)),this.j()}catch(q){this.k(q)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(N,M){return new re(async q=>{for await(const ee of N)q.emitOne(M(ee))})}map(N){return re.map(this,N)}static filter(N,M){return new re(async q=>{for await(const ee of N)M(ee)&&q.emitOne(ee)})}filter(N){return re.filter(this,N)}static coalesce(N){return re.filter(N,M=>!!M)}coalesce(){return re.coalesce(this)}static async toPromise(N){const M=[];for await(const q of N)M.push(q);return M}toPromise(){return re.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}re.EMPTY=re.fromArray([]),e.AsyncIterableObject=re;class de extends re{constructor(N,M){super(M),this.l=N}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=de;function oe(j){const N=new E.CancellationTokenSource,M=j(N.token);return new de(N,async q=>{const ee=N.token.onCancellationRequested(()=>{ee.dispose(),N.dispose(),q.reject(new k.CancellationError)});try{for await(const fe of M){if(N.token.isCancellationRequested)return;q.emitOne(fe)}ee.dispose(),N.dispose()}catch(fe){ee.dispose(),N.dispose(),q.reject(fe)}})}e.createCancelableAsyncIterable=oe}),define(ve[71],be([1,0,18,14,38,27,7,3,16]),function(ae,e,E,k,l,I,C,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function y(){return Object.create(null)}e.getEmptyExpression=y,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const T="[/\\\\]",S="[^/\\\\]",b=/\//g;function g(Y,H){switch(Y){case 0:return"";case 1:return`${S}*?`;default:return`(?:${T}|${S}+${T}${H?`|${T}${S}+`:""})*?`}}function f(Y,H){if(!Y)return[];const U=[];let te=!1,re=!1,de="";for(const oe of Y){switch(oe){case H:if(!te&&!re){U.push(de),de="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":re=!0;break;case"]":re=!1;break}de+=oe}return de&&U.push(de),U}e.splitGlobAware=f;function p(Y){if(!Y)return"";let H="";const U=f(Y,e.GLOB_SPLIT);if(U.every(te=>te===e.GLOBSTAR))H=".*";else{let te=!1;U.forEach((re,de)=>{if(re===e.GLOBSTAR){if(te)return;H+=g(2,de===U.length-1)}else{let oe=!1,j="",N=!1,M="";for(const q of re){if(q!=="}"&&oe){j+=q;continue}if(N&&(q!=="]"||!M)){let ee;q==="-"?ee=q:(q==="^"||q==="!")&&!M?ee="^":q===e.GLOB_SPLIT?ee="":ee=(0,w.escapeRegExpCharacters)(q),M+=ee;continue}switch(q){case"{":oe=!0;continue;case"[":N=!0;continue;case"}":{H+=`(?:${f(j,",").map(W=>p(W)).join("|")})`,oe=!1,j="";break}case"]":{H+="["+M+"]",N=!1,M="";break}case"?":H+=S;continue;case"*":H+=g(1);continue;default:H+=(0,w.escapeRegExpCharacters)(q)}}de<U.length-1&&(U[de+1]!==e.GLOBSTAR||de+2<U.length)&&(H+=T)}te=re===e.GLOBSTAR})}return H}const u=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,A=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.LRUCache(1e4),r=function(){return!1},n=function(){return null};function i(Y,H){if(!Y)return n;let U;typeof Y!="string"?U=Y.pattern:U=Y,U=U.trim();const te=`${U}_${!!H.trimForExclusions}`;let re=t.get(te);if(re)return o(re,Y);let de;return u.test(U)?re=a(U.substr(4),U):(de=h.exec(c(U,H)))?re=s(de[1],U):(H.trimForExclusions?d:v).test(U)?re=m(U,H):(de=D.exec(c(U,H)))?re=R(de[1].substr(1),U,!0):(de=A.exec(c(U,H)))?re=R(de[1],U,!1):re=L(U),t.set(te,re),o(re,Y)}function o(Y,H){if(typeof H=="string")return Y;const U=function(te,re){return(0,l.isEqualOrParent)(te,H.base,!P.isLinux)?Y((0,w.ltrim)(te.substr(H.base.length),C.sep),re):null};return U.allBasenames=Y.allBasenames,U.allPaths=Y.allPaths,U.basenames=Y.basenames,U.patterns=Y.patterns,U}function c(Y,H){return H.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function a(Y,H){return function(U,te){return typeof U=="string"&&U.endsWith(Y)?H:null}}function s(Y,H){const U=`/${Y}`,te=`\\${Y}`,re=function(oe,j){return typeof oe!="string"?null:j?j===Y?H:null:oe===Y||oe.endsWith(U)||oe.endsWith(te)?H:null},de=[Y];return re.basenames=de,re.patterns=[H],re.allBasenames=de,re}function m(Y,H){const U=le(Y.slice(1,-1).split(",").map(j=>i(j,H)).filter(j=>j!==n),Y),te=U.length;if(!te)return n;if(te===1)return U[0];const re=function(j,N){for(let M=0,q=U.length;M<q;M++)if(U[M](j,N))return Y;return null},de=U.find(j=>!!j.allBasenames);de&&(re.allBasenames=de.allBasenames);const oe=U.reduce((j,N)=>N.allPaths?j.concat(N.allPaths):j,[]);return oe.length&&(re.allPaths=oe),re}function R(Y,H,U){const te=C.sep===C.posix.sep,re=te?Y:Y.replace(b,C.sep),de=C.sep+re,oe=C.posix.sep+Y;let j;return U?j=function(N,M){return typeof N=="string"&&(N===re||N.endsWith(de)||!te&&(N===Y||N.endsWith(oe)))?H:null}:j=function(N,M){return typeof N=="string"&&(N===re||!te&&N===Y)?H:null},j.allPaths=[(U?"*/":"./")+Y],j}function L(Y){try{const H=new RegExp(`^${p(Y)}$`);return function(U){return H.lastIndex=0,typeof U=="string"&&H.test(U)?Y:null}}catch{return n}}function $(Y,H,U){return!Y||typeof H!="string"?!1:ie(Y)(H,void 0,U)}e.match=$;function ie(Y,H={}){if(!Y)return r;if(typeof Y=="string"||ne(Y)){const U=i(Y,H);if(U===n)return r;const te=function(re,de){return!!U(re,de)};return U.allBasenames&&(te.allBasenames=U.allBasenames),U.allPaths&&(te.allPaths=U.allPaths),te}return z(Y,H)}e.parse=ie;function ne(Y){const H=Y;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.isRelativePattern=ne;function F(Y){return Y.allBasenames||[]}e.getBasenameTerms=F;function _(Y){return Y.allPaths||[]}e.getPathTerms=_;function z(Y,H){const U=le(Object.getOwnPropertyNames(Y).map(j=>x(j,Y[j],H)).filter(j=>j!==n)),te=U.length;if(!te)return n;if(!U.some(j=>!!j.requiresSiblings)){if(te===1)return U[0];const j=function(q,ee){let fe;for(let W=0,K=U.length;W<K;W++){const Z=U[W](q,ee);if(typeof Z=="string")return Z;(0,k.isThenable)(Z)&&(fe||(fe=[]),fe.push(Z))}return fe?(async()=>{for(const W of fe){const K=await W;if(typeof K=="string")return K}return null})():null},N=U.find(q=>!!q.allBasenames);N&&(j.allBasenames=N.allBasenames);const M=U.reduce((q,ee)=>ee.allPaths?q.concat(ee.allPaths):q,[]);return M.length&&(j.allPaths=M),j}const re=function(j,N,M){let q,ee;for(let fe=0,W=U.length;fe<W;fe++){const K=U[fe];K.requiresSiblings&&M&&(N||(N=(0,C.basename)(j)),q||(q=N.substr(0,N.length-(0,C.extname)(j).length)));const Z=K(j,N,q,M);if(typeof Z=="string")return Z;(0,k.isThenable)(Z)&&(ee||(ee=[]),ee.push(Z))}return ee?(async()=>{for(const fe of ee){const W=await fe;if(typeof W=="string")return W}return null})():null},de=U.find(j=>!!j.allBasenames);de&&(re.allBasenames=de.allBasenames);const oe=U.reduce((j,N)=>N.allPaths?j.concat(N.allPaths):j,[]);return oe.length&&(re.allPaths=oe),re}function x(Y,H,U){if(H===!1)return n;const te=i(Y,U);if(te===n)return n;if(typeof H=="boolean")return te;if(H){const re=H.when;if(typeof re=="string"){const de=(oe,j,N,M)=>{if(!M||!te(oe,j))return null;const q=re.replace("$(basename)",()=>N),ee=M(q);return(0,k.isThenable)(ee)?ee.then(fe=>fe?Y:null):ee?Y:null};return de.requiresSiblings=!0,de}}return te}function le(Y,H){const U=Y.filter(j=>!!j.basenames);if(U.length<2)return Y;const te=U.reduce((j,N)=>{const M=N.basenames;return M?j.concat(M):j},[]);let re;if(H){re=[];for(let j=0,N=te.length;j<N;j++)re.push(H)}else re=U.reduce((j,N)=>{const M=N.patterns;return M?j.concat(M):j},[]);const de=function(j,N){if(typeof j!="string")return null;if(!N){let q;for(q=j.length;q>0;q--){const ee=j.charCodeAt(q-1);if(ee===47||ee===92)break}N=j.substr(q)}const M=te.indexOf(N);return M!==-1?re[M]:null};de.basenames=te,de.patterns=re,de.allBasenames=te;const oe=Y.filter(j=>!j.basenames);return oe.push(de),oe}function Ee(Y,H){return(0,E.equals)(Y,H,(U,te)=>typeof U=="string"&&typeof te=="string"?U===te:typeof U!="string"&&typeof te!="string"?U.base===te.base&&U.pattern===te.pattern:!1)}e.patternsEquals=Ee}),define(ve[95],be([1,0,9,160,20,16,4]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class w{constructor(h="",v=!1){if(this.value=h,typeof this.value!="string")throw(0,E.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(h,v=0){return this.value+=b(this.supportThemeIcons?(0,k.escapeIcons)(h):h).replace(/([ \t]+)/g,(d,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,v){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(h,v,d){return this.value+="[",this.value+=this.c(v,"]"),this.value+="](",this.value+=this.c(String(h),")"),d&&(this.value+=` "${this.c(this.c(d,'"'),")")}"`),this.value+=")",this}c(h,v){const d=new RegExp((0,I.escapeRegExpCharacters)(v),"g");return h.replace(d,(D,A)=>h.charAt(A-1)!=="\\"?`\\${D}`:D)}}e.MarkdownString=w;function y(u){return T(u)?!u.value:Array.isArray(u)?u.every(y):!0}e.isEmptyMarkdownString=y;function T(u){return u instanceof w?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=T;function S(u,h){return u===h?!0:!u||!h?!1:u.value===h.value&&u.isTrusted===h.isTrusted&&u.supportThemeIcons===h.supportThemeIcons&&u.supportHtml===h.supportHtml&&(u.baseUri===h.baseUri||!!u.baseUri&&!!h.baseUri&&(0,l.isEqual)(C.URI.from(u.baseUri),C.URI.from(h.baseUri)))}e.markdownStringEqual=S;function b(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=b;function g(u){return u.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=g;function f(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=f;function p(u){const h=[],v=u.split("|").map(D=>D.trim());u=v[0];const d=v[1];if(d){const D=/height=(\d+)/.exec(d),A=/width=(\d+)/.exec(d),t=D?D[1]:"",r=A?A[1]:"",n=isFinite(parseInt(r)),i=isFinite(parseInt(t));n&&h.push(`width="${r}"`),i&&h.push(`height="${t}"`)}return{href:u,dimensions:h}}e.parseHrefAndDimensions=p}),define(ve[162],be([1,0,18,38,7,3,20,16]),function(ae,e,E,k,l,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function w(n,i){const{os:o,tildify:c,relative:a}=i;if(a){const R=y(n,a,o);if(typeof R=="string")return R}let s=n.fsPath;if(o===1&&!I.isWindows?s=s.replace(/\//g,"\\"):o!==1&&I.isWindows&&(s=s.replace(/\\/g,"/")),o!==1&&c?.userHome){const R=c.userHome.fsPath;let L;n.scheme!==c.userHome.scheme&&n.path.startsWith(l.posix.sep)?L=c.userHome.with({path:n.path}).fsPath:L=n.fsPath,s=b(L,R,o)}return(o===1?l.win32:l.posix).normalize(T(s,o===1))}e.getPathLabel=w;function y(n,i,o){const c=o===1?l.win32:l.posix,a=o===3?C.extUri:C.extUriIgnorePathCase,s=i.getWorkspace(),m=(0,E.firstOrDefault)(s.folders);if(!m)return;n.scheme!==m.uri.scheme&&n.path.startsWith(l.posix.sep)&&(n=m.uri.with({path:n.path}));const R=i.getWorkspaceFolder(n);if(!R)return;let L;if(a.isEqual(R.uri,n)?L="":L=a.relativePath(R.uri,n)??"",L&&(L=c.normalize(L)),s.folders.length>1&&!i.noPrefix){const $=R.name?R.name:a.basenameOrAuthority(R.uri);L=L?`${$} \u2022 ${L}`:$}return L}function T(n,i=I.isWindows){return(0,k.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=T;let S=Object.create(null);function b(n,i,o=I.OS){if(o===1||!n||!i)return n;let c=S.original===i?S.normalized:void 0;c||(c=i,I.isWindows&&(c=(0,k.toSlashes)(c)),c=`${(0,P.rtrim)(c,l.posix.sep)}${l.posix.sep}`,S={original:i,normalized:c});let a=n;return I.isWindows&&(a=(0,k.toSlashes)(a)),(o===3?a.startsWith(c):(0,P.startsWithIgnoreCase)(a,c))?`~/${a.substr(c.length)}`:n}e.tildify=b;function g(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=g;const f="\u2026",p="\\\\",u="~";function h(n,i=l.sep){const o=new Array(n.length);let c=!1;for(let a=0;a<n.length;a++){const s=n[a];if(s===""){o[a]=`.${i}`;continue}if(!s){o[a]=s;continue}c=!0;let m="",R=s;R.indexOf(p)===0?(m=R.substr(0,R.indexOf(p)+p.length),R=R.substr(R.indexOf(p)+p.length)):R.indexOf(i)===0?(m=R.substr(0,R.indexOf(i)+i.length),R=R.substr(R.indexOf(i)+i.length)):R.indexOf(u)===0&&(m=R.substr(0,R.indexOf(u)+u.length),R=R.substr(R.indexOf(u)+u.length));const L=R.split(i);for(let $=1;c&&$<=L.length;$++)for(let ie=L.length-$;c&&ie>=0;ie--){c=!1;let ne=L.slice(ie,ie+$).join(i);for(let F=0;!c&&F<n.length;F++)if(F!==a&&n[F]&&n[F].indexOf(ne)>-1){const _=ie+$===L.length,z=ie>0&&n[F].indexOf(i)>-1?i+ne:ne,x=n[F].endsWith(z);c=!_||x}if(!c){let F="";(L[0].endsWith(":")||m!=="")&&(ie===1&&(ie=0,$++,ne=L[0]+i+ne),ie>0&&(F=L[0]+i),F=m+F),ie>0&&(F=F+f+i),F=F+ne,ie+$<L.length&&(F=F+i+f),o[a]=F}}c&&(o[a]=s)}return o}e.shorten=h;var v;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function d(n,i=Object.create(null)){const o=[];let c=!1,a="";for(const s of n)if(s==="$"||c&&s==="{")a&&o.push({value:a,type:v.TEXT}),a="",c=!0;else if(s==="}"&&c){const m=i[a];if(typeof m=="string")m.length&&o.push({value:m,type:v.VARIABLE});else if(m){const R=o[o.length-1];(!R||R.type!==v.SEPARATOR)&&o.push({value:m.label,type:v.SEPARATOR})}a="",c=!1}else a+=s;return a&&!c&&o.push({value:a,type:v.TEXT}),o.filter((s,m)=>{if(s.type===v.SEPARATOR){const R=o[m-1],L=o[m+1];return[R,L].every($=>$&&($.type===v.VARIABLE||$.type===v.TEXT)&&$.value.length>0)}return!0}).map(s=>s.value).join("")}e.template=d;function D(n,i){return I.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):n.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function A(n,i){return I.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):I.isWindows?n.replace(/&&|&/g,o=>o==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=A;function t(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=t;function r(n){const i=n.indexOf("/")!==-1?l.posix:l.win32,o=i.basename(n),c=i.dirname(n);return o.length?{name:o,parentPath:c}:{name:c,parentPath:""}}e.splitName=r}),define(ve[72],be([1,0,15,4]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(S){return S.toJSON()}class I{constructor(b){this.a=b}transformIncoming(b){const g=this.a.transformIncoming(b);return g===b?b:l(k.URI.from(g))}transformOutgoing(b){const g=this.a.transformOutgoing(b);return g===b?b:l(k.URI.from(g))}transformOutgoingURI(b){const g=this.a.transformOutgoing(b);return g===b?b:k.URI.from(g)}transformOutgoingScheme(b){return this.a.transformOutgoingScheme(b)}}e.URITransformer=I,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function C(S,b,g){if(!S||g>200)return null;if(typeof S=="object"){if(S instanceof k.URI)return b.transformOutgoing(S);for(const f in S)if(Object.hasOwnProperty.call(S,f)){const p=C(S[f],b,g+1);p!==null&&(S[f]=p)}}return null}function P(S,b){const g=C(S,b,0);return g===null?S:g}e.transformOutgoingURIs=P;function w(S,b,g,f){if(!S||f>200)return null;if(typeof S=="object"){if(S.$mid===1)return g?k.URI.revive(b.transformIncoming(S)):b.transformIncoming(S);if(S instanceof E.VSBuffer)return null;for(const p in S)if(Object.hasOwnProperty.call(S,p)){const u=w(S[p],b,g,f+1);u!==null&&(S[p]=u)}}return null}function y(S,b){const g=w(S,b,!1,0);return g===null?S:g}e.transformIncomingURIs=y;function T(S,b){const g=w(S,b,!0,0);return g===null?S:g}e.transformAndReviveIncomingURIs=T}),define(ve[96],be([1,0,31,9,59,22,148]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(T){return this.a||(this.a=l.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(T)}value(){if(this.b===void 0){let T=0,S=0;const b=(0,E.networkInterfaces)();for(const g in b){const f=b[g];if(f)for(const{mac:p,internal:u}of f)u||(S+=1,this.c(p.toUpperCase())&&(T+=1))}this.b=S>0?T/S:0}return this.b}};let P;async function w(){return P||(P=(async()=>await y()||I.generateUuid())()),P}e.getMachineId=w;async function y(){try{const T=await new Promise((b,g)=>{ae(["crypto"],b,g)}),S=(0,C.getMac)();return T.createHash("sha256").update(S,"utf8").digest("hex")}catch(T){k.onUnexpectedError(T);return}}}),define(ve[21],be([1,0,30,31,279,14,38,88,7,3,20,4]),function(ae,e,E,k,l,I,C,P,w,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var b;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function g(z,x=b.UNLINK){if((0,C.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return x===b.UNLINK?p(z):f(z)}async function f(z){try{const x=(0,C.randomPath)((0,k.tmpdir)());try{await E.promises.rename(z,x)}catch(le){return le.code==="ENOENT"?void 0:p(z)}p(x).catch(le=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function p(z){return(0,l.promisify)(E.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function u(z){if((0,C.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function h(z,x){return D(await(x?v(z):(0,l.promisify)(E.readdir)(z)))}async function v(z){try{return await(0,l.promisify)(E.readdir)(z,{withFileTypes:!0})}catch(Ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",Ee)}const x=[],le=await h(z);for(const Ee of le){let Y=!1,H=!1,U=!1;try{const te=await e.Promises.lstat((0,w.join)(z,Ee));Y=te.isFile(),H=te.isDirectory(),U=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}x.push({name:Ee,isFile:()=>Y,isDirectory:()=>H,isSymbolicLink:()=>U})}return x}function d(z){return D(E.readdirSync(z))}e.readdirSync=d;function D(z){return z.map(x=>typeof x=="string"?y.isMacintosh?(0,P.normalizeNFC)(x):x:(x.name=y.isMacintosh?(0,P.normalizeNFC)(x.name):x.name,x))}async function A(z){const x=await h(z),le=[];for(const Ee of x)await r.existsDirectory((0,w.join)(z,Ee))&&le.push(Ee);return le}function t(z,x=1e3){return new Promise(le=>{let Ee=!1;const Y=setInterval(()=>{Ee||(Ee=!0,E.access(z,H=>{Ee=!1,H&&(clearInterval(Y),le(void 0))}))},x)})}e.whenDeleted=t;var r;(function(z){async function x(Y){let H;try{if(H=await e.Promises.lstat(Y),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(y.isWindows&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw te}throw U}}z.stat=x;async function le(Y){try{const{stat:H,symbolicLink:U}=await z.stat(Y);return H.isFile()&&U?.dangling!==!0}catch{}return!1}z.existsFile=le;async function Ee(Y){try{const{stat:H,symbolicLink:U}=await z.stat(Y);return H.isDirectory()&&U?.dangling!==!0}catch{}return!1}z.existsDirectory=Ee})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new I.ResourceQueue;function i(z,x,le){return n.queueFor(S.URI.file(z),T.extUriBiasedIgnorePathCase).queue(()=>{const Ee=m(le);return new Promise((Y,H)=>a(z,x,Ee,U=>U?H(U):Y()))})}let o=!0;function c(z){o=z}e.configureFlushOnWrite=c;function a(z,x,le,Ee){if(!o)return E.writeFile(z,x,{mode:le.mode,flag:le.flag},Ee);E.open(z,le.flag,le.mode,(Y,H)=>{if(Y)return Ee(Y);E.writeFile(H,x,U=>{if(U)return E.close(H,()=>Ee(U));E.fdatasync(H,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),c(!1)),E.close(H,re=>Ee(re))))})})}function s(z,x,le){const Ee=m(le);if(!o)return E.writeFileSync(z,x,{mode:Ee.mode,flag:Ee.flag});const Y=E.openSync(z,Ee.flag,Ee.mode);try{E.writeFileSync(Y,x);try{E.fdatasyncSync(Y)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),c(!1)}}finally{E.closeSync(Y)}}e.writeFileSync=s;function m(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function R(z,x){if(z!==x)try{await e.Promises.rename(z,x)}catch(le){if(z.toLowerCase()!==x.toLowerCase()&&le.code==="EXDEV"||z.endsWith("."))await L(z,x,{preserveSymlinks:!1}),await g(z,b.MOVE);else throw le}}async function L(z,x,le){return ie(z,x,{root:{source:z,target:x},options:le,handledSourcePaths:new Set})}const $=511;async function ie(z,x,le){if(le.handledSourcePaths.has(z))return;le.handledSourcePaths.add(z);const{stat:Ee,symbolicLink:Y}=await r.stat(z);if(Y){if(le.options.preserveSymlinks)try{return await _(z,x,le)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(Y.dangling)return}return Ee.isDirectory()?ne(z,x,Ee.mode&$,le):F(z,x,Ee.mode&$)}async function ne(z,x,le,Ee){await e.Promises.mkdir(x,{recursive:!0,mode:le});const Y=await h(z);for(const H of Y)await ie((0,w.join)(z,H),(0,w.join)(x,H),Ee)}async function F(z,x,le){await e.Promises.copyFile(z,x),await e.Promises.chmod(x,le)}async function _(z,x,le){let Ee=await e.Promises.readlink(z);(0,C.isEqualOrParent)(Ee,le.root.source,!y.isLinux)&&(Ee=(0,w.join)(le.root.target,Ee.substr(le.root.source.length+1))),await e.Promises.symlink(Ee,x)}e.Promises=new class{get access(){return(0,l.promisify)(E.access)}get stat(){return(0,l.promisify)(E.stat)}get lstat(){return(0,l.promisify)(E.lstat)}get utimes(){return(0,l.promisify)(E.utimes)}get read(){return(z,x,le,Ee,Y)=>new Promise((H,U)=>{E.read(z,x,le,Ee,Y,(te,re,de)=>te?U(te):H({bytesRead:re,buffer:de}))})}get readFile(){return(0,l.promisify)(E.readFile)}get write(){return(z,x,le,Ee,Y)=>new Promise((H,U)=>{E.write(z,x,le,Ee,Y,(te,re,de)=>te?U(te):H({bytesWritten:re,buffer:de}))})}get appendFile(){return(0,l.promisify)(E.appendFile)}get fdatasync(){return(0,l.promisify)(E.fdatasync)}get truncate(){return(0,l.promisify)(E.truncate)}get rename(){return(0,l.promisify)(E.rename)}get copyFile(){return(0,l.promisify)(E.copyFile)}get open(){return(0,l.promisify)(E.open)}get close(){return(0,l.promisify)(E.close)}get symlink(){return(0,l.promisify)(E.symlink)}get readlink(){return(0,l.promisify)(E.readlink)}get chmod(){return(0,l.promisify)(E.chmod)}get mkdir(){return(0,l.promisify)(E.mkdir)}get unlink(){return(0,l.promisify)(E.unlink)}get rmdir(){return(0,l.promisify)(E.rmdir)}get realpath(){return(0,l.promisify)(E.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return A}get writeFile(){return i}get rm(){return g}get move(){return R}get copy(){return L}}}),define(ve[163],be([1,0,30,7,3,16,21]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(b){if(l.isLinux)return b;const g=(0,k.dirname)(b);if(b===g)return b;const f=((0,k.basename)(b)||b).toLowerCase();try{const u=(0,C.readdirSync)(g).filter(h=>h.toLowerCase()===f);if(u.length===1){const h=P(g);if(h)return(0,k.join)(h,u[0])}else if(u.length>1){const h=u.indexOf(f);if(h>=0){const v=P(g);if(v)return(0,k.join)(v,u[h])}}}catch{}return null}e.realcaseSync=P;async function w(b){if(l.isLinux)return b;const g=(0,k.dirname)(b);if(b===g)return b;const f=((0,k.basename)(b)||b).toLowerCase();try{const u=(await C.Promises.readdir(g)).filter(h=>h.toLowerCase()===f);if(u.length===1){const h=await w(g);if(h)return(0,k.join)(h,u[0])}else if(u.length>1){const h=u.indexOf(f);if(h>=0){const v=await w(g);if(v)return(0,k.join)(v,u[h])}}}catch{}return null}e.realcase=w;async function y(b){try{return await C.Promises.realpath(b)}catch{const f=S(b);return await C.Promises.access(f,E.constants.R_OK),f}}e.realpath=y;function T(b){try{return E.realpathSync(b)}catch{const f=S(b);return E.accessSync(f,E.constants.R_OK),f}}e.realpathSync=T;function S(b){return(0,I.rtrim)((0,k.normalize)(b),k.sep)}}),define(ve[97],be([1,0,31,7,21]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const I=/^\d+$/,C=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var w;(function(D){D[D.x64=0]="x64",D[D.x86=1]="x86",D[D.ARM=2]="ARM"})(w||(w={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let T;process.env.PROCESSOR_ARCHITEW6432?T=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?T=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?T=1:T=0;class S{constructor(A,t,r){this.exePath=A,this.displayName=t,this.a=r}async exists(){return this.a===void 0&&(this.a=await l.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:D=!1}={}){return D?y===0?process.env["ProgramFiles(x86)"]||null:T===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:D=!1,findPreview:A=!1}={}){const t=b({useAlternateBitness:D});if(!t)return null;const r=k.join(t,"PowerShell");if(!await l.SymlinkSupport.existsDirectory(r))return null;let n=-1,i=null;for(const a of await l.Promises.readdir(r)){let s=-1;if(A){const R=a.indexOf("-");if(R<0)continue;const L=a.substring(0,R);if(!I.test(L)||a.substring(R+1)!=="preview")continue;s=parseInt(L,10)}else{if(!I.test(a))continue;s=parseInt(a,10)}if(s<=n)continue;const m=k.join(r,a,"pwsh.exe");!await l.SymlinkSupport.existsFile(m)||(i=m,n=s)}if(!i)return null;const o=t.includes("x86")?" (x86)":"",c=A?" Preview":"";return new S(i,`PowerShell${c}${o}`,!0)}async function f({findPreview:D}={}){if(!process.env.LOCALAPPDATA)return null;const A=k.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await l.SymlinkSupport.existsDirectory(A))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=D?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:C,pwshMsixName:"PowerShell (Store)"};for(const n of await l.Promises.readdir(A))if(t.test(n)){const i=k.join(A,n,"pwsh.exe");return new S(i,r)}return null}function p(){const D=k.join(E.homedir(),".dotnet","tools","pwsh.exe");return new S(D,".NET Core PowerShell Global Tool")}function u(){const D=k.join(process.env.windir,y===1&&T!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new S(D,"Windows PowerShell",!0)}async function*h(){let D=await g();D&&(yield D),D=await g({useAlternateBitness:!0}),D&&(yield D),D=await f(),D&&(yield D),D=p(),D&&(yield D),D=await g({findPreview:!0}),D&&(yield D),D=await f({findPreview:!0}),D&&(yield D),D=await g({useAlternateBitness:!0,findPreview:!0}),D&&(yield D),D=u(),D&&(yield D)}async function*v(){for await(const D of h())await D.exists()&&(yield D)}e.enumeratePowerShellInstallations=v;async function d(){for await(const D of v())return D;return null}e.getFirstAvailablePowerShellInstallation=d}),define(ve[98],be([1,0,7,3,28,57,8,21]),function(ae,e,E,k,l,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function w(S=l.env){return S.comspec||"cmd.exe"}e.getWindowsShell=w;function y(S){let b=[],g=!1;const f=function(p){if(g){b.push(p);return}(!S.send(p,h=>{if(h&&console.error(h),g=!1,b.length>0){const v=b.slice(0);b=[],v.forEach(d=>f(d))}})||k.isWindows)&&(g=!0)};return{send:f}}e.createQueuedSender=y;var T;(function(S){async function b(g,f,p){if(E.isAbsolute(g))return g;if(f===void 0&&(f=l.cwd()),E.dirname(g)!=="."||(p===void 0&&C.isString(l.env.PATH)&&(p=l.env.PATH.split(E.delimiter)),p===void 0||p.length===0))return E.join(f,g);async function h(v){if(await P.Promises.exists(v)){let d;try{d=await P.Promises.stat(v)}catch(D){D.message.startsWith("EACCES")&&(d=await P.Promises.lstat(v))}return d?!d.isDirectory():!1}return!1}for(const v of p){let d;if(E.isAbsolute(v)?d=E.join(v,g):d=E.join(f,v,g),await h(d))return d;let D=d+".com";if(await h(D)||(D=d+".exe",await h(D)))return D}return E.join(f,g)}S.findExecutable=b})(T=e.win32||(e.win32={}))}),define(ve[99],be([1,0,49,13]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function l(C){return new Promise((P,w)=>{let y;const T=new Map;function S(g,f,p,u,h){const v=T.get(f);if(g===C||v){const d={name:b(p),cmd:p,pid:g,ppid:f,load:u,mem:h};T.set(g,d),g===C&&(y=d),v&&(v.children||(v.children=[]),v.children.push(d),v.children.length>1&&(v.children=v.children.sort((D,A)=>D.pid-A.pid)))}}function b(g){const f=/--vscode-window-kind=shared-process/,p=/--vscode-window-kind=issue-reporter/,u=/--vscode-window-kind=process-explorer/,h=/--utility-sub-type=network/,v=/--utility-sub-type=node.mojom.NodeService/,d=/--crashes-directory/,D=/\\pipe\\winpty-control/,A=/conhost\.exe/,t=/--type=([a-zA-Z-]+)/;if(d.exec(g))return"electron-crash-reporter";if(D.exec(g))return"winpty-process";if(A.exec(g))return"console-window-host (Windows internal process)";let r=t.exec(g);if(r&&r.length===2){if(r[1]==="renderer")return f.exec(g)?"shared-process":p.exec(g)?"issue-reporter":u.exec(g)?"process-explorer":"window";if(r[1]==="utility"){if(h.exec(g))return"utility-network-service";if(v.exec(g))return"extension-host"}else if(r[1]==="extensionHost")return"extension-host";return r[1]}const n=/[a-zA-Z-]+\.js/g;let i="";do r=n.exec(g),r&&(i+=r+" ");while(r);return i&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${i}`:g}if(process.platform==="win32"){const g=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,p)=>{ae(["windows-process-tree"],f,p)}).then(f=>{f.getProcessList(C,p=>{if(!p){w(new Error(`Root process ${C} not found`));return}f.getProcessCpuUsage(p,u=>{const h=new Map;u.forEach(v=>{const d=g(v.commandLine||"");h.set(v.pid,{name:b(d),cmd:d,pid:v.pid,ppid:v.ppid,load:v.cpu||0,mem:v.memory||0})}),y=h.get(C),y?(h.forEach(v=>{const d=h.get(v.ppid);d&&(d.children||(d.children=[]),d.children.push(v))}),h.forEach(v=>{v.children&&(v.children=v.children.sort((d,D)=>d.pid-D.pid))}),P(y)):w(new Error(`Root process ${C} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let g=function(){let f=[y];const p=[];for(;f.length;){const h=f.shift();h&&(p.push(h.pid),h.children&&(f=f.concat(h.children)))}let u=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);u+=" "+p.join(" "),(0,E.exec)(u,{},(h,v,d)=>{if(h||d)w(h||new Error(d.toString()));else{const D=v.toString().split(`
`);for(let A=0;A<p.length;A++){const t=T.get(p[A]);t.load=parseFloat(D[A])}if(!y){w(new Error(`Root process ${C} not found`));return}P(y)}})};(0,E.exec)("which ps",{},(f,p,u)=>{if(f||u)if(process.platform!=="linux")w(f||new Error(u.toString()));else{const h=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(h,{},(v,d,D)=>{v||D?w(v||new Error(D.toString())):(I(d,S),g())})}else{const h=p.toString().trim(),v="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${h} ${v}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,D,A)=>{d||A&&!A.includes("screen size is bogus")?w(d||new Error(A.toString())):(I(D,S),process.platform==="linux"?g():y?P(y):w(new Error(`Root process ${C} not found`)))})}})}})}e.listProcesses=l;function I(C,P){const w=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=C.toString().split(`
`);for(const T of y){const S=w.exec(T.trim());S&&S.length===6&&P(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}}),define(ve[164],be([1,0,31,3,97,98]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function C(S,b){return S===1?k.isWindows?T():I.getWindowsShell(b):w(S,b)}e.getSystemShell=C;let P=null;function w(S,b){if(k.isLinux&&S===2||k.isMacintosh&&S===3)return"/bin/bash";if(!P){let g;if(k.isWindows)g="/bin/bash";else{if(g=b.SHELL,!g)try{g=(0,E.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}P=g}return P}let y=null;async function T(){return y||(y=(await(0,l.getFirstAvailablePowerShellInstallation)()).exePath),y}});var Re=this&&this.__decorate||function(ae,e,E,k){var l=arguments.length,I=l<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,E):k,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate(ae,e,E,k);else for(var P=ae.length-1;P>=0;P--)(C=ae[P])&&(I=(l<3?C(I):l>3?C(e,E,I):C(e,E))||I);return l>3&&I&&Object.defineProperty(e,E,I),I};define(ve[41],be([1,0,18,14,15,19,85,9,6,2,48,16,8]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var g;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(g||(g={}));function f(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(p||(p={}));function u(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(h||(h={}));function v(H){let U=0;for(let te=0;;te+=7){const re=H.read(1);if(U|=(re.buffer[0]&127)<<te,!(re.buffer[0]&128))return U}}const d=n(0);function D(H,U){if(U===0){H.write(d);return}let te=0;for(let de=U;de!==0;de=de>>>7)te++;const re=l.VSBuffer.alloc(te);for(let de=0;U!==0;de++)re.buffer[de]=U&127,U=U>>>7,U>0&&(re.buffer[de]|=128);H.write(re)}class A{constructor(U){this.b=U,this.a=0}read(U){const te=this.b.slice(this.a,this.a+U);return this.a+=te.byteLength,te}}e.BufferReader=A;class t{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write(U){this.a.push(U)}}e.BufferWriter=t;var r;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(r||(r={}));function n(H){const U=l.VSBuffer.alloc(1);return U.writeUInt8(H,0),U}const i={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},o=typeof Buffer<"u";function c(H,U){if(typeof U>"u")H.write(i.Undefined);else if(typeof U=="string"){const te=l.VSBuffer.fromString(U);H.write(i.String),D(H,te.byteLength),H.write(te)}else if(o&&Buffer.isBuffer(U)){const te=l.VSBuffer.wrap(U);H.write(i.Buffer),D(H,te.byteLength),H.write(te)}else if(U instanceof l.VSBuffer)H.write(i.VSBuffer),D(H,U.byteLength),H.write(U);else if(Array.isArray(U)){H.write(i.Array),D(H,U.length);for(const te of U)c(H,te)}else if(typeof U=="number"&&(U|0)===U)H.write(i.Uint),D(H,U);else{const te=l.VSBuffer.fromString(JSON.stringify(U));H.write(i.Object),D(H,te.byteLength),H.write(te)}}e.serialize=c;function a(H){switch(H.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return H.read(v(H)).toString();case r.Buffer:return H.read(v(H)).buffer;case r.VSBuffer:return H.read(v(H));case r.Array:{const te=v(H),re=[];for(let de=0;de<te;de++)re.push(a(H));return re}case r.Object:return JSON.parse(H.read(v(H)).toString());case r.Int:return v(H)}}e.deserialize=a;class s{constructor(U,te,re=null,de=1e3){this.h=U,this.j=te,this.k=re,this.l=de,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(U,te){this.b.set(U,te),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const te=this.o([U.type]);this.k?.logOutgoing(te,0,1,u(U.type));return}case 201:case 202:case 204:case 203:{const te=this.o([U.type,U.id],U.data);this.k?.logOutgoing(te,U.id,1,u(U.type),U.data);return}}}o(U,te=void 0){const re=new t;return c(re,U),c(re,te),this.p(re.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const te=new A(U),re=a(te),de=a(te),oe=re[0];switch(oe){case 100:return this.k?.logIncoming(U.byteLength,re[1],1,`${f(oe)}: ${re[2]}.${re[3]}`,de),this.s({type:oe,id:re[1],channelName:re[2],name:re[3],arg:de});case 102:return this.k?.logIncoming(U.byteLength,re[1],1,`${f(oe)}: ${re[2]}.${re[3]}`,de),this.t({type:oe,id:re[1],channelName:re[2],name:re[3],arg:de});case 101:return this.k?.logIncoming(U.byteLength,re[1],1,`${f(oe)}`),this.u({type:oe,id:re[1]});case 103:return this.k?.logIncoming(U.byteLength,re[1],1,`${f(oe)}`),this.u({type:oe,id:re[1]})}}s(U){const te=this.b.get(U.channelName);if(!te){this.v(U);return}const re=new I.CancellationTokenSource;let de;try{de=te.call(this.j,U.name,U.arg,re.token)}catch(N){de=Promise.reject(N)}const oe=U.id;de.then(N=>{this.m({id:oe,data:N,type:201}),this.d.delete(U.id)},N=>{N instanceof Error?this.m({id:oe,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.m({id:oe,data:N,type:203}),this.d.delete(U.id)});const j=(0,y.toDisposable)(()=>re.cancel());this.d.set(U.id,j)}t(U){const te=this.b.get(U.channelName);if(!te){this.v(U);return}const re=U.id,oe=te.listen(this.j,U.name,U.arg)(j=>this.m({id:re,data:j,type:204}));this.d.set(U.id,oe)}u(U){const te=this.d.get(U.id);te&&(te.dispose(),this.d.delete(U.id))}v(U){let te=this.g.get(U.channelName);te||(te=[],this.g.set(U.channelName,te));const re=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);te.push({request:U,timeoutTimer:re})}w(U){const te=this.g.get(U);if(te){for(const re of te)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=s;var m;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(U,te=null){this.l=U,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=te}getChannel(U){const te=this;return{call(re,de,oe){return te.a?Promise.reject(new P.CancellationError):te.m(U,re,de,oe)},listen(re,de){return te.a?w.Event.None:te.o(U,re,de)}}}m(U,te,re,de=I.CancellationToken.None){const oe=this.g++,N={id:oe,type:100,channelName:U,name:te,arg:re};if(de.isCancellationRequested)return Promise.reject(new P.CancellationError);let M;return new Promise((ee,fe)=>{if(de.isCancellationRequested)return fe(new P.CancellationError);const W=()=>{const Q=G=>{switch(G.type){case 201:this.f.delete(oe),ee(G.data);break;case 202:{this.f.delete(oe);const X=new Error(G.data.message);X.stack=Array.isArray(G.data.stack)?G.data.stack.join(`
`):G.data.stack,X.name=G.data.name,fe(X);break}case 203:this.f.delete(oe),fe(G.data);break}};this.f.set(oe,Q),this.p(N)};let K=null;this.b===h.Idle?W():(K=(0,k.createCancelablePromise)(Q=>this.u()),K.then(()=>{K=null,W()}));const Z=()=>{K?(K.cancel(),K=null):this.p({id:oe,type:101}),fe(new P.CancellationError)},V=de.onCancellationRequested(Z);M=(0,y.combinedDisposable)((0,y.toDisposable)(Z),V),this.d.add(M)}).finally(()=>{this.d.delete(M)})}o(U,te,re){const de=this.g++,j={id:de,type:102,channelName:U,name:te,arg:re};let N=null;const M=new w.Emitter({onWillAddFirstListener:()=>{N=(0,k.createCancelablePromise)(ee=>this.u()),N.then(()=>{N=null,this.d.add(M),this.p(j)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.d.delete(M),this.p({id:de,type:103}))}}),q=ee=>M.fire(ee.data);return this.f.set(de,q),M.event}p(U){switch(U.type){case 100:case 102:{const te=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(te,U.id,0,`${f(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const te=this.q([U.type,U.id]);this.j?.logOutgoing(te,U.id,0,f(U.type));return}}}q(U,te=void 0){const re=new t;return c(re,U),c(re,te),this.r(re.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const te=new A(U),re=a(te),de=a(te),oe=re[0];switch(oe){case 200:return this.j?.logIncoming(U.byteLength,0,0,u(oe)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,re[1],0,u(oe),de),this.t({type:re[0],id:re[1],data:de})}}t(U){if(U.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.dispose)(this.d.values()),this.d.clear()}}Re([C.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class L{get connections(){const U=[];return this.f.forEach(te=>U.push(te)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new w.Emitter,this.onDidAddConnection=this.g.event,this.h=new w.Emitter,this.onDidRemoveConnection=this.h.event,U(({protocol:te,onDidClientDisconnect:re})=>{w.Event.once(te.onMessage)(oe=>{const j=new A(oe),N=a(j),M=new s(te,N),q=new R(te);this.a.forEach((fe,W)=>M.registerChannel(W,fe));const ee={channelServer:M,channelClient:q,ctx:N};this.f.add(ee),this.g.fire(ee),re(()=>{M.dispose(),q.dispose(),this.f.delete(ee),this.h.fire(ee)})})})}getChannel(U,te){const re=this;return{call(de,oe,j){let N;if((0,b.isFunction)(te)){const q=(0,E.getRandomElement)(re.connections.filter(te));N=q?Promise.resolve(q):w.Event.toPromise(w.Event.filter(re.onDidAddConnection,te))}else N=te.routeCall(re,de,oe);const M=N.then(q=>q.channelClient.getChannel(U));return ie(M).call(de,oe,j)},listen(de,oe){if((0,b.isFunction)(te))return re.j(U,te,de,oe);const j=te.routeEvent(re,de,oe).then(N=>N.channelClient.getChannel(U));return ie(j).listen(de,oe)}}}j(U,te,re,de){const oe=this;let j=new y.DisposableStore;const N=new w.Emitter({onWillAddFirstListener:()=>{j=new y.DisposableStore;const M=new w.EventMultiplexer,q=new Map,ee=W=>{const Z=W.channelClient.getChannel(U).listen(re,de),V=M.add(Z);q.set(W,V)},fe=W=>{const K=q.get(W);!K||(K.dispose(),q.delete(W))};oe.connections.filter(te).forEach(ee),w.Event.filter(oe.onDidAddConnection,te)(ee,void 0,j),oe.onDidRemoveConnection(fe,void 0,j),M.event(N.fire,N,j),j.add(M)},onDidRemoveLastListener:()=>{j.dispose()}});return N.event}registerChannel(U,te){this.a.set(U,te),this.f.forEach(re=>{re.channelServer.registerChannel(U,te)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=L;class ${constructor(U,te,re=null){const de=new t;c(de,te),U.send(de.buffer),this.a=new R(U,re),this.d=new s(U,te,re)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,te){this.d.registerChannel(U,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=$;function ie(H){return{call(U,te,re){return H.then(de=>de.call(U,te,re))},listen(U,te){const re=new w.Relay;return H.then(de=>re.input=de.listen(U,te)),re.event}}}e.getDelayedChannel=ie;function ne(H){let U=!1;return{call(te,re,de){return U?H.call(te,re,de):(0,k.timeout)(0).then(()=>U=!0).then(()=>H.call(te,re,de))},listen(te,re){if(U)return H.listen(te,re);const de=new w.Relay;return(0,k.timeout)(0).then(()=>U=!0).then(()=>de.input=H.listen(te,re)),de.event}}}e.getNextTickChannel=ne;class F{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const te of U.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await w.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.StaticRouter=F;var _;(function(H){function U(oe,j){const N=oe,M=j&&j.disableMarshalling,q=new Map;for(const ee in N)re(ee)&&q.set(ee,w.Event.buffer(N[ee],!0));return new class{listen(ee,fe,W){const K=q.get(fe);if(K)return K;if(de(fe)){const Z=N[fe];if(typeof Z=="function")return Z.call(N,W)}throw new Error(`Event not found: ${fe}`)}call(ee,fe,W){const K=N[fe];if(typeof K=="function"){if(!M&&Array.isArray(W))for(let Z=0;Z<W.length;Z++)W[Z]=(0,T.revive)(W[Z]);return K.apply(N,W)}throw new Error(`Method not found: ${fe}`)}}}H.fromService=U;function te(oe,j){const N=j&&j.disableMarshalling;return new Proxy({},{get(M,q){if(typeof q=="string")return j?.properties?.has(q)?j.properties.get(q):de(q)?function(ee){return oe.listen(q,ee)}:re(q)?oe.listen(q):async function(...ee){let fe;j&&!(0,b.isUndefinedOrNull)(j.context)?fe=[j.context,...ee]:fe=ee;const W=await oe.call(q,fe);return N?W:(0,T.revive)(W)};throw new Error(`Property not found: ${String(q)}`)}})}H.toService=te;function re(oe){return oe[0]==="o"&&oe[1]==="n"&&S.isUpperAsciiLetter(oe.charCodeAt(2))}function de(oe){return/^onDynamic/.test(oe)&&S.isUpperAsciiLetter(oe.charCodeAt(9))}})(_=e.ProxyChannel||(e.ProxyChannel={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const U=H.toString();if(U!=="[object Object]")return U}return H}function le(H){return Array.isArray(H)?H.map(x):x(H)}function Ee(H,U,te,re,de,oe,j){j=le(j);const N=z[de],M=N[re%N.length];let q=[`%c[${H}]%c[${String(U).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(oe)?(q=q.concat(j),q.push(")")):q.push(j),console.log.apply(console,q)}class Y{constructor(U,te){this.d=U,this.f=te,this.a=0,this.b=0}logOutgoing(U,te,re,de,oe){this.b+=U,Ee(this.d,this.b,U,te,re,de,oe)}logIncoming(U,te,re,de,oe){this.a+=U,Ee(this.f,this.a,U,te,re,de,oe)}}e.IPCLogger=Y}),define(ve[100],be([1,0,14,15,6,2,41]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(R){R.Created="created",R.Read="read",R.Write="write",R.Open="open",R.Error="error",R.Close="close",R.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",R.NodeEndReceived="nodeEndReceived",R.NodeEndSent="nodeEndSent",R.NodeDrainBegin="nodeDrainBegin",R.NodeDrainEnd="nodeDrainEnd",R.zlibInflateError="zlibInflateError",R.zlibInflateData="zlibInflateData",R.zlibInflateInitialWrite="zlibInflateInitialWrite",R.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",R.zlibInflateWrite="zlibInflateWrite",R.zlibInflateFlushFired="zlibInflateFlushFired",R.zlibDeflateError="zlibDeflateError",R.zlibDeflateData="zlibDeflateData",R.zlibDeflateWrite="zlibDeflateWrite",R.zlibDeflateFlushFired="zlibDeflateFlushFired",R.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",R.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",R.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",R.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",R.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",R.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",R.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",R.ProtocolHeaderRead="protocolHeaderRead",R.ProtocolMessageRead="protocolMessageRead",R.ProtocolHeaderWrite="protocolHeaderWrite",R.ProtocolMessageWrite="protocolMessageWrite",R.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var w;(function(R){R.enableDiagnostics=!1,R.records=[];const L=new WeakMap;let $=0;function ie(F,_){if(!L.has(F)){const z=String(++$);L.set(F,z)}return L.get(F)}function ne(F,_,z,x){if(!R.enableDiagnostics)return;const le=ie(F,_);if(x instanceof k.VSBuffer||x instanceof Uint8Array||x instanceof ArrayBuffer||ArrayBuffer.isView(x)){const Ee=k.VSBuffer.alloc(x.byteLength);Ee.set(x),R.records.push({timestamp:Date.now(),id:le,label:_,type:z,buff:Ee})}else R.records.push({timestamp:Date.now(),id:le,label:_,type:z,data:x})}R.traceSocketEvent=ne})(w=e.SocketDiagnostics||(e.SocketDiagnostics={}));var y;(function(R){R[R.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",R[R.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(y=e.SocketCloseEventType||(e.SocketCloseEventType={}));let T=null;function S(){return T||(T=k.VSBuffer.alloc(0)),T}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(L){this.a.push(L),this.b+=L.byteLength}read(L){return this.c(L,!0)}peek(L){return this.c(L,!1)}c(L,$){if(L===0)return S();if(L>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===L){const _=this.a[0];return $&&(this.a.shift(),this.b-=L),_}if(this.a[0].byteLength>L){const _=this.a[0].slice(0,L);return $&&(this.a[0]=this.a[0].slice(L),this.b-=L),_}const ie=k.VSBuffer.alloc(L);let ne=0,F=0;for(;L>0;){const _=this.a[F];if(_.byteLength>L){const z=_.slice(0,L);ie.set(z,ne),ne+=L,$&&(this.a[F]=_.slice(L),this.b-=L),L-=L}else ie.set(_,ne),ne+=_.byteLength,$?(this.a.shift(),this.b-=_.byteLength):F++,L-=_.byteLength}return ie}}e.ChunkStream=b;var g;(function(R){R[R.None=0]="None",R[R.Regular=1]="Regular",R[R.Control=2]="Control",R[R.Ack=3]="Ack",R[R.Disconnect=5]="Disconnect",R[R.ReplayRequest=6]="ReplayRequest",R[R.Pause=7]="Pause",R[R.Resume=8]="Resume",R[R.KeepAlive=9]="KeepAlive",R[R.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",R[R.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(g||(g={}));function f(R){switch(R){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var p;(function(R){R[R.HeaderLength=13]="HeaderLength",R[R.AcknowledgeTime=2e3]="AcknowledgeTime",R[R.TimeoutTime=2e4]="TimeoutTime",R[R.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",R[R.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",R[R.KeepAliveSendTime=5e3]="KeepAliveSendTime",R[R.LatencySampleTime=6e4]="LatencySampleTime",R[R.LatencySampleCount=5]="LatencySampleCount",R[R.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",R[R.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(L,$,ie,ne){this.type=L,this.id=$,this.ack=ie,this.data=ne,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends I.Disposable{constructor(L){super(),this.f=this.B(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=L,this.b=!1,this.c=new b,this.B(this.a.onData($=>this.acceptChunk($))),this.lastReadTime=Date.now()}acceptChunk(L){if(!(!L||L.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(L);this.c.byteLength>=this.g.readLen;){const $=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=$.readUInt32BE(9),this.g.messageType=$.readUInt8(0),this.g.id=$.readUInt32BE(1),this.g.ack=$.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const ie=this.g.messageType,ne=this.g.id,F=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",$),this.f.fire(new u(ie,ne,F,$)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class v{constructor(L){this.k=null,this.a=!1,this.b=!1,this.c=L,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(L){if(this.a)return;L.writtenTime=Date.now(),this.lastWriteTime=Date.now();const $=k.VSBuffer.alloc(13);$.writeUInt8(L.type,0),$.writeUInt32BE(L.id,1),$.writeUInt32BE(L.ack,5),$.writeUInt32BE(L.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(L.type),id:L.id,ack:L.ack,messageSize:L.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",L.data),this.j($,L.data)}g(L,$){const ie=this.f===0;return this.d.push(L,$),this.f+=L.byteLength+$.byteLength,ie}h(){const L=k.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,L}j(L,$){this.g(L,$)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const L=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:L.byteLength}),this.c.write(L)}}class d extends I.Disposable{constructor(L){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=L,this.b=this.B(new v(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage($=>{$.type===1&&this.f.fire($.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(L){this.b.write(new u(1,0,0,L))}}e.Protocol=d;class D extends C.IPCClient{static fromSocket(L,$){return new D(new d(L),$)}get onDidDispose(){return this.b.onDidDispose}constructor(L,$,ie=null){super(L,$,ie),this.b=L}dispose(){super.dispose();const L=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),L.end()}}e.Client=D;class A{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(L){this.b?this.d.length>0?this.d.push(L):this.a.fire(L):this.d.push(L)}flushBuffer(){this.d=[]}}e.BufferedEmitter=A;class t{constructor(L){this.data=L,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let L=0,$=this.a;for(;$;)$=$.next,L++;return L}peek(){return this.a?this.a.data:null}toArray(){const L=[];let $=0,ie=this.a;for(;ie;)L[$++]=ie.data,ie=ie.next;return L}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(L){const $=new t(L);if(!this.a){this.a=$,this.b=$;return}this.b.next=$,this.b=$}}class n{static getInstance(){return n.b||(n.b=new n),n.b}constructor(){this.c=[];const L=Date.now();for(let $=0;$<n.a;$++)this.c[$]=L-1e3*$;setInterval(()=>{for(let $=n.a;$>=1;$--)this.c[$]=this.c[$-1];this.c[0]=Date.now()},1e3)}d(){const L=Date.now(),$=(1+n.a)*1e3;let ie=0;for(let ne=0;ne<n.a;ne++)L-this.c[ne]<=$&&ie++;return 1-ie/n.a}hasHighLoad(){return this.d()>=.5}}n.a=10,n.b=null;var i;(function(R){R[R.Good=0]="Good",R[R.Poor=1]="Poor"})(i=e.ConnectionHealth||(e.ConnectionHealth={}));function o(R){switch(R){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class c{constructor(L){this.connectionHealth=L}}e.ConnectionHealthChangedEvent=c;class a{constructor(L,$){this.roundTripTime=L,this.recentHighRoundTripCount=$}}e.HighRoundTripTimeEvent=a;class s{get unacknowledgedCount(){return this.c-this.d}constructor(L){this.x=new A,this.onControlMessage=this.x.event,this.y=new A,this.onMessage=this.y.event,this.z=new A,this.onDidDispose=this.z.event,this.A=new A,this.onSocketClose=this.A.event,this.B=new A,this.onSocketTimeout=this.B.event,this.C=new A,this.onHighRoundTripTime=this.C.event,this.D=new A,this.onDidChangeConnectionHealth=this.D.event,this.u=L.loadEstimator??n.getInstance(),this.v=L.measureRoundTripTime??!1,this.w=L.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new I.DisposableStore,this.o=L.socket,this.p=this.t.add(new v(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage($=>this.E($))),this.t.add(this.o.onClose($=>this.A.fire($))),this.r=this.t.add(new m),this.t.add(this.r.onSendLatencyRequest($=>this.J($))),this.t.add(this.r.onHighRoundTripTime($=>this.C.fire($))),this.t.add(this.r.onDidChangeConnectionHealth($=>this.D.fire($))),this.v&&this.r.start(),L.initialChunk&&this.q.acceptChunk(L.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const L=new u(5,0,0,S());this.p.write(L),this.p.flush()}sendPause(){const L=new u(7,0,0,S());this.p.write(L)}sendResume(){const L=new u(8,0,0,S());this.p.write(L)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(L,$){this.a=!0,this.t.dispose(),this.t=new I.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=L,this.p=this.t.add(new v(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(ie=>this.E(ie))),this.t.add(this.o.onClose(ie=>this.A.fire(ie))),this.r=this.t.add(new m),this.t.add(this.r.onSendLatencyRequest(ie=>this.J(ie))),this.t.add(this.r.onHighRoundTripTime(ie=>this.C.fire(ie))),this.t.add(this.r.onDidChangeConnectionHealth(ie=>this.D.fire(ie))),this.q.acceptChunk($)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const L=new u(3,0,this.h,S());this.p.write(L);const $=this.b.toArray();for(let ie=0,ne=$.length;ie<ne;ie++)this.p.write($[ie]);this.G()}acceptDisconnect(){this.z.fire()}E(L){if(L.ack>this.d){this.d=L.ack;do{const $=this.b.peek();if($&&$.id<=L.ack)this.b.pop();else break}while(!0)}switch(L.type){case 0:break;case 1:{if(L.id>this.g)if(L.id!==this.g+1){const $=Date.now();$-this.m>1e4&&(this.m=$,this.p.write(new u(6,0,0,S())))}else this.g=L.id,this.j=Date.now(),this.F(),this.y.fire(L.data);break}case 2:{this.x.fire(L.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const $=this.b.toArray();for(let ie=0,ne=$.length;ie<ne;ie++)this.p.write($[ie]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(L.data);break}case 11:{this.r.handleResponse(L.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(L){const $=++this.c;this.h=this.g;const ie=new u(1,$,this.h,L);this.b.push(ie),this.a||(this.p.write(ie),this.G())}sendControl(L){const $=new u(2,0,0,L);this.p.write($)}F(){if(this.g<=this.h||this.k)return;const L=Date.now()-this.j;if(L>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-L+5)}G(){if(this.c<=this.d||this.f||this.a)return;const L=this.b.peek(),$=Date.now()-L.writtenTime,ie=Date.now()-this.q.lastReadTime,ne=Date.now()-this.n;if($>=2e4&&ie>=2e4&&ne>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:$,timeSinceLastReceivedSomeData:ie});return}const F=Math.max(2e4-$,2e4-ie,2e4-ne,500);this.f=setTimeout(()=>{this.f=null,this.G()},F)}H(){if(this.g<=this.h)return;this.h=this.g;const L=new u(3,0,this.h,S());this.p.write(L)}I(){this.h=this.g;const L=new u(9,0,this.h,S());this.p.write(L)}J(L){this.h=this.g;const $=new u(10,0,this.h,L);this.p.write($)}K(L){this.h=this.g;const $=new u(11,0,this.h,L);this.p.write($)}}e.PersistentProtocol=s;class m extends I.Disposable{constructor(){super(),this.a=this.B(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new E.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},L=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const L=++this.h,$=k.VSBuffer.alloc(4);$.writeUInt32BE(L,0),this.a.fire($)},6e4)}handleResponse(L){if(L.byteLength!==4)return;const $=L.readUInt32BE(0);if(this.g<=0||$!==this.h)return;const ie=Date.now()-this.g,ne=this.k++;this.j[ne%this.j.length]=ie;const F=this.l,_=this.j.filter(z=>z>=1e3).length;this.l=_>=3?1:0,ie>1e3&&this.b.fire(new a(ie,_)),F!==this.l&&this.c.fire(this.l)}}}),define(ve[101],be([1,0,49,14,15,19,161,9,6,2,23,98,57,41]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends g.ChannelServer{constructor(h){super({send:v=>{try{process.send?.(v.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",v=>l.VSBuffer.wrap(Buffer.from(v,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=f;class p{constructor(h,v){this.i=h,this.j=v,this.c=new Set,this.g=new Map,this.h=new w.Emitter,this.onDidProcessExit=this.h.event;const d=v&&v.timeout?v.timeout:6e4;this.b=new k.Delayer(d),this.d=null,this.f=null}getChannel(h){const v=this;return{call(d,D,A){return v.k(h,d,D,A)},listen(d,D){return v.l(h,d,D)}}}k(h,v,d,D=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(D.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const A=this.n(h),t=(0,k.createCancelablePromise)(i=>A.call(v,d,i)),r=D.onCancellationRequested(()=>t.cancel()),n=(0,y.toDisposable)(()=>t.cancel());return this.c.add(n),t.finally(()=>{r.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,v,d){if(!this.b)return w.Event.None;this.b.cancel();let D;const A=new w.Emitter({onWillAddFirstListener:()=>{D=this.n(h).listen(v,d)(A.fire,A),this.c.add(D)},onDidRemoveLastListener:()=>{this.c.delete(D),D.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return A.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],v=Object.create(null);v.env={...(0,T.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(v.env={...v.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(v.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,b.removeDangerousEnvVariables)(v.env),this.d=(0,E.fork)(this.i,h,v);const d=new w.Emitter;w.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,C.isRemoteConsoleLog)(o)){(0,C.log)(o,`IPC Library: ${this.j.serverName}`);return}d.fire(l.VSBuffer.wrap(Buffer.from(o,"base64")))});const A=this.j.useQueue?(0,S.createQueuedSender)(this.d):this.d,t=o=>this.d&&this.d.connected&&A.send(o.buffer.toString("base64")),r=d.event,n={send:t,onMessage:r};this.f=new g.ChannelClient(n);const i=()=>this.o();process.once("exit",i),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,c)=>{process.removeListener("exit",i),this.c.forEach(a=>(0,y.dispose)(a)),this.c.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+c),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:c})})}return this.f}n(h){let v=this.g.get(h);return v||(v=this.m.getChannel(h),this.g.set(h,v)),v}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=p}),define(ve[60],be([1,0,15,9,6,2,7,3,22,41,100]),function(ae,e,E,k,l,I,C,P,w,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function S(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class b{traceSocketEvent(a,s){T.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,s)}constructor(a,s=""){this.f=!0,this.debugLabel=s,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=m=>{if(this.traceSocketEvent("error",{code:m?.code,message:m?.message}),m){if(m.code==="EPIPE")return;(0,k.onUnexpectedError)(m)}},this.socket.on("error",this.a),this.b=m=>{this.traceSocketEvent("close",{hadError:m}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(a){const s=m=>{this.traceSocketEvent("read",m),a(E.VSBuffer.wrap(m))};return this.socket.on("data",s),{dispose:()=>this.socket.off("data",s)}}onClose(a){const s=m=>{a({type:0,hadError:m,error:void 0})};return this.socket.on("close",s),{dispose:()=>this.socket.off("close",s)}}onEnd(a){const s=()=>{a()};return this.socket.on("end",s),{dispose:()=>this.socket.off("end",s)}}write(a){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,s=>{if(s){if(s.code==="EPIPE")return;(0,k.onUnexpectedError)(s)}})}catch(s){if(s.code==="EPIPE")return;(0,k.onUnexpectedError)(s)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,s)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const m=()=>{this.socket.off("close",m),this.socket.off("end",m),this.socket.off("error",m),this.socket.off("timeout",m),this.socket.off("drain",m),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",m),this.socket.on("end",m),this.socket.on("error",m),this.socket.on("timeout",m),this.socket.on("drain",m)})}}e.NodeSocket=b;var g;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(g||(g={}));var f;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(f||(f={}));class p extends I.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(a,s){this.socket.traceSocketEvent(a,s)}constructor(a,s,m,R){super(),this.f=this.B(new l.Emitter),this.g=this.B(new l.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:s,inflateBytesLength:m?.byteLength||0,recordInflateBytes:R}),this.a=this.B(new u(this,s,m,R,this.f,(L,$)=>this.k(L,$))),this.B(this.a.onError(L=>{console.error(L),(0,k.onUnexpectedError)(L),this.g.fire({type:0,hadError:!0,error:L})})),this.b=new T.ChunkStream,this.B(this.socket.onData(L=>this.l(L))),this.B(this.socket.onClose(L=>this.g.fire(L)))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this.f.event(a)}onClose(a){return this.g.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this.a.writeMessage(a)}k(a,s){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let m=2;a.byteLength<126?m+=0:a.byteLength<2**16?m+=2:m+=8;const R=E.VSBuffer.alloc(m);if(s?R.writeUInt8(194,0):R.writeUInt8(130,0),a.byteLength<126)R.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){R.writeUInt8(126,1);let L=1;R.writeUInt8(a.byteLength>>>8&255,++L),R.writeUInt8(a.byteLength>>>0&255,++L)}else{R.writeUInt8(127,1);let L=1;R.writeUInt8(0,++L),R.writeUInt8(0,++L),R.writeUInt8(0,++L),R.writeUInt8(0,++L),R.writeUInt8(a.byteLength>>>24&255,++L),R.writeUInt8(a.byteLength>>>16&255,++L),R.writeUInt8(a.byteLength>>>8&255,++L),R.writeUInt8(a.byteLength>>>0&255,++L)}this.socket.write(E.VSBuffer.concat([R,a]))}end(){this.h=!0,this.socket.end()}l(a){if(a.byteLength!==0){for(this.b.acceptChunk(a);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const s=this.b.peek(this.j.readLen),m=s.readUInt8(0),R=(m&128)>>>7,L=(m&64)>>>6,$=s.readUInt8(1),ie=($&128)>>>7,ne=$&127;this.j.state=2,this.j.readLen=2+(ie?4:0)+(ne===126?2:0)+(ne===127?8:0),this.j.fin=R,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(L)),this.j.firstFrameOfMessage=Boolean(R),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const s=this.b.read(this.j.readLen),m=s.readUInt8(1),R=(m&128)>>>7;let L=m&127,$=1;L===126?L=s.readUInt8(++$)*2**8+s.readUInt8(++$):L===127&&(L=s.readUInt8(++$)*0+s.readUInt8(++$)*0+s.readUInt8(++$)*0+s.readUInt8(++$)*0+s.readUInt8(++$)*2**24+s.readUInt8(++$)*2**16+s.readUInt8(++$)*2**8+s.readUInt8(++$));let ie=0;R&&(ie=s.readUInt8(++$)*2**24+s.readUInt8(++$)*2**16+s.readUInt8(++$)*2**8+s.readUInt8(++$)),this.j.state=3,this.j.readLen=L,this.j.mask=ie,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const s=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",s),d(s,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",s),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(s,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class u extends I.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(a,s,m,R,L,$){super(),this.k=a,this.l=L,this.m=$,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new l.Emitter),this.onDidFinishProcessingWriteQueue=this.j.event,this.n=!1,this.s=!1,s?(this.b=this.B(new h(this.k,R,m,{windowBits:15})),this.f=this.B(new v(this.k,{windowBits:15})),this.B(this.b.onError(ie=>this.a.fire(ie))),this.B(this.f.onError(ie=>this.a.fire(ie)))):(this.b=null,this.f=null)}writeMessage(a){this.g.push(a),this.p()}async p(){if(!this.n){for(this.n=!0;this.g.length>0;){const a=this.g.shift();if(this.f){const s=await this.r(this.f,a);this.m(s,!0)}else this.m(a,!1)}this.n=!1,this.j.fire()}}isProcessingWriteQueue(){return this.n}r(a,s){return new Promise((m,R)=>{a.write(s),a.flush(L=>m(L))})}acceptFrame(a,s,m){this.h.push({data:a,isCompressed:s,isLastFrameOfMessage:m}),this.t()}async t(){if(!this.s){for(this.s=!0;this.h.length>0;){const a=this.h.shift();if(this.b&&a.isCompressed){const s=await this.u(this.b,a.data,a.isLastFrameOfMessage);this.l.fire(s)}else this.l.fire(a.data)}this.s=!1}}u(a,s,m){return new Promise((R,L)=>{a.write(s),m&&a.write(E.VSBuffer.fromByteArray([0,0,255,255])),a.flush($=>R($))})}}class h extends I.Disposable{get recordedInflateBytes(){return this.j?E.VSBuffer.concat(this.f):E.VSBuffer.alloc(0)}constructor(a,s,m,R){super(),this.h=a,this.j=s,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=S().zlib.createInflateRaw(R),this.b.on("error",L=>{this.h.traceSocketEvent("zlibInflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.h.traceSocketEvent("zlibInflateData",L),this.g.push(E.VSBuffer.wrap(L))}),m&&(this.h.traceSocketEvent("zlibInflateInitialWrite",m.buffer),this.b.write(m.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(a){this.j&&this.f.push(a.clone()),this.h.traceSocketEvent("zlibInflateWrite",a),this.b.write(a.buffer)}flush(a){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const s=E.VSBuffer.concat(this.g);this.g.length=0,a(s)})}}class v extends I.Disposable{constructor(a,s){super(),this.g=a,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.b=S().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",m=>{this.g.traceSocketEvent("zlibDeflateError",{message:m?.message,code:m?.code}),this.a.fire(m)}),this.b.on("data",m=>{this.g.traceSocketEvent("zlibDeflateData",m),this.f.push(E.VSBuffer.wrap(m))})}write(a){this.g.traceSocketEvent("zlibDeflateWrite",a.buffer),this.b.write(a.buffer)}flush(a){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let s=E.VSBuffer.concat(this.f);this.f.length=0,s=s.slice(0,s.byteLength-4),a(s)})}}function d(c,a){if(a===0)return;const s=c.byteLength>>>2;for(let ne=0;ne<s;ne++){const F=c.readUInt32BE(ne*4);c.writeUInt32BE(F^a,ne*4)}const m=s*4,R=c.byteLength-m,L=a>>>24&255,$=a>>>16&255,ie=a>>>8&255;R>=1&&c.writeUInt8(c.readUInt8(m)^L,m),R>=2&&c.writeUInt8(c.readUInt8(m+1)^$,m+1),R>=3&&c.writeUInt8(c.readUInt8(m+2)^ie,m+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const D={[2]:107,[1]:103};function A(){const c=(0,w.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):a=(0,C.join)(S().os.tmpdir(),`vscode-ipc-${c}.sock`),r(a),a}e.createRandomIPCHandle=A;function t(c,a,s){const m=S().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${m}-${s}-${a}-sock`;let R;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?R=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${m.substr(0,8)}-${s}-${a}.sock`):R=(0,C.join)(c,`${s}-${a}.sock`),r(R),R}e.createStaticIPCHandle=t;function r(c){const a=D[P.platform];typeof a=="number"&&c.length>=a&&console.warn(`WARNING: IPC handle "${c}" is longer than ${a} chars, try a shorter --user-data-dir`)}class n extends y.IPCServer{static b(a){const s=l.Event.fromNodeEventEmitter(a,"connection");return l.Event.map(s,m=>({protocol:new T.Protocol(new b(m,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(m,"close"))}))}constructor(a){super(n.b(a)),this.d=a}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=n;function i(c){return new Promise((a,s)=>{const m=S().net.createServer();m.on("error",s),m.listen(c,()=>{m.removeListener("error",s),a(new n(m))})})}e.serve=i;function o(c,a){return new Promise((s,m)=>{const R=S().net.createConnection(c,()=>{R.removeListener("error",m),s(T.Client.fromSocket(new b(R,`ipc-client${a}`),a))});R.once("error",m)})}e.connect=o}),define(ve[165],be([1,0,14,6,2,8]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var C;(function(S){S[S.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",S[S.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(C=e.StorageHint||(e.StorageHint={}));function P(S){const b=S;return b?.changed instanceof Map||b?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var w;(function(S){S[S.None=0]="None",S[S.Initialized=1]="Initialized",S[S.Closed=2]="Closed"})(w=e.StorageState||(e.StorageState={}));class y extends l.Disposable{constructor(b,g=Object.create(null)){super(),this.m=b,this.n=g,this.b=this.B(new k.Emitter),this.onDidChangeStorage=this.b.event,this.c=w.None,this.f=new Map,this.g=new E.ThrottledDelayer(y.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(b=>this.r(b)))}r(b){b.changed?.forEach((g,f)=>this.s(f,g)),b.deleted?.forEach(g=>this.s(g,void 0))}s(b,g){if(this.c===w.Closed)return;let f=!1;(0,I.isUndefinedOrNull)(g)?f=this.f.delete(b):this.f.get(b)!==g&&(this.f.set(b,g),f=!0),f&&this.b.fire(b)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===w.None&&(this.c=w.Initialized,this.n.hint!==C.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(b,g){const f=this.f.get(b);return(0,I.isUndefinedOrNull)(f)?g:f}getBoolean(b,g){const f=this.get(b);return(0,I.isUndefinedOrNull)(f)?g:f==="true"}getNumber(b,g){const f=this.get(b);return(0,I.isUndefinedOrNull)(f)?g:parseInt(f,10)}async set(b,g){if(this.c===w.Closed)return;if((0,I.isUndefinedOrNull)(g))return this.delete(b);const f=String(g);if(this.f.get(b)!==f)return this.f.set(b,f),this.j.set(b,f),this.h.delete(b),this.b.fire(b),this.w()}async delete(b){if(!(this.c===w.Closed||!this.f.delete(b)))return this.h.has(b)||this.h.add(b),this.j.delete(b),this.b.fire(b),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=w.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const b={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(b).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(b){if(!!this.u)return this.w(b)}async w(b){return this.g.trigger(()=>this.v(),b)}async whenFlushed(){if(!!this.u)return new Promise(b=>this.l.push(b))}isInMemory(){return this.n.hint===C.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}y.a=100,e.Storage=y;class T{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(b){b.insert?.forEach((g,f)=>this.a.set(f,g)),b.delete?.forEach(g=>this.a.delete(g))}async close(){}}e.InMemoryStorageDatabase=T}),define(ve[166],be([1,0,6,2]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class l{constructor(){this.a=new Map,this.b=new Map,this.c=new E.Emitter,this.onDidChange=this.c.event,this.d=null}fire(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,w){return this.a.set(P,w),this.fire([P]),(0,k.toDisposable)(()=>{this.a.get(P)===w&&(this.a.delete(P),this.fire([P]))})}registerFactory(P,w){this.b.get(P)?.dispose();const y=new I(this,P,w);return this.b.set(P,y),(0,k.toDisposable)(()=>{const T=this.b.get(P);!T||T!==y||(this.b.delete(P),T.dispose())})}async getOrCreate(P){const w=this.get(P);if(w)return w;const y=this.b.get(P);return!y||y.isResolved?null:(await y.resolve(),this.get(P))}get(P){return this.a.get(P)||null}isResolved(P){if(this.get(P))return!0;const y=this.b.get(P);return!!(!y||y.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=l;class I extends k.Disposable{get isResolved(){return this.c}constructor(P,w,y){super(),this.f=P,this.g=w,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const P=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(ve[167],be([1,0,45,4,47,166]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class C{constructor(m,R,L){this._tokenBrand=void 0,this.offset=m,this.type=R,this.language=L}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=C;class P{constructor(m,R){this._tokenizationResultBrand=void 0,this.tokens=m,this.endState=R}}e.TokenizationResult=P;class w{constructor(m,R){this._encodedTokenizationResultBrand=void 0,this.tokens=m,this.endState=R}}e.EncodedTokenizationResult=w;var y;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(y=e.CompletionItemKind||(e.CompletionItemKind={}));var T;(function(s){const m=new Map;m.set(0,E.Codicon.symbolMethod),m.set(1,E.Codicon.symbolFunction),m.set(2,E.Codicon.symbolConstructor),m.set(3,E.Codicon.symbolField),m.set(4,E.Codicon.symbolVariable),m.set(5,E.Codicon.symbolClass),m.set(6,E.Codicon.symbolStruct),m.set(7,E.Codicon.symbolInterface),m.set(8,E.Codicon.symbolModule),m.set(9,E.Codicon.symbolProperty),m.set(10,E.Codicon.symbolEvent),m.set(11,E.Codicon.symbolOperator),m.set(12,E.Codicon.symbolUnit),m.set(13,E.Codicon.symbolValue),m.set(15,E.Codicon.symbolEnum),m.set(14,E.Codicon.symbolConstant),m.set(15,E.Codicon.symbolEnum),m.set(16,E.Codicon.symbolEnumMember),m.set(17,E.Codicon.symbolKeyword),m.set(27,E.Codicon.symbolSnippet),m.set(18,E.Codicon.symbolText),m.set(19,E.Codicon.symbolColor),m.set(20,E.Codicon.symbolFile),m.set(21,E.Codicon.symbolReference),m.set(22,E.Codicon.symbolCustomColor),m.set(23,E.Codicon.symbolFolder),m.set(24,E.Codicon.symbolTypeParameter),m.set(25,E.Codicon.account),m.set(26,E.Codicon.issues);function R(ie){let ne=m.get(ie);return ne||(console.info("No codicon found for CompletionItemKind "+ie),ne=E.Codicon.symbolProperty),ne}s.toIcon=R;const L=new Map;L.set("method",0),L.set("function",1),L.set("constructor",2),L.set("field",3),L.set("variable",4),L.set("class",5),L.set("struct",6),L.set("interface",7),L.set("module",8),L.set("property",9),L.set("event",10),L.set("operator",11),L.set("unit",12),L.set("value",13),L.set("constant",14),L.set("enum",15),L.set("enum-member",16),L.set("enumMember",16),L.set("keyword",17),L.set("snippet",27),L.set("text",18),L.set("color",19),L.set("file",20),L.set("reference",21),L.set("customcolor",22),L.set("folder",23),L.set("type-parameter",24),L.set("typeParameter",24),L.set("account",25),L.set("issue",26);function $(ie,ne){let F=L.get(ie);return typeof F>"u"&&!ne&&(F=9),F}s.fromString=$})(T=e.CompletionItemKinds||(e.CompletionItemKinds={}));var S;(function(s){s[s.Deprecated=1]="Deprecated"})(S=e.CompletionItemTag||(e.CompletionItemTag={}));var b;(function(s){s[s.None=0]="None",s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(b=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var g;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var f;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(f=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var p;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(p=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var u;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(u=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function v(s){return s&&k.URI.isUri(s.uri)&&l.Range.isIRange(s.range)&&(l.Range.isIRange(s.originSelectionRange)||l.Range.isIRange(s.targetSelectionRange))}e.isLocationLink=v;var d;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(d=e.SymbolKind||(e.SymbolKind={}));var D;(function(s){s[s.Deprecated=1]="Deprecated"})(D=e.SymbolTag||(e.SymbolTag={}));var A;(function(s){const m=new Map;m.set(0,E.Codicon.symbolFile),m.set(1,E.Codicon.symbolModule),m.set(2,E.Codicon.symbolNamespace),m.set(3,E.Codicon.symbolPackage),m.set(4,E.Codicon.symbolClass),m.set(5,E.Codicon.symbolMethod),m.set(6,E.Codicon.symbolProperty),m.set(7,E.Codicon.symbolField),m.set(8,E.Codicon.symbolConstructor),m.set(9,E.Codicon.symbolEnum),m.set(10,E.Codicon.symbolInterface),m.set(11,E.Codicon.symbolFunction),m.set(12,E.Codicon.symbolVariable),m.set(13,E.Codicon.symbolConstant),m.set(14,E.Codicon.symbolString),m.set(15,E.Codicon.symbolNumber),m.set(16,E.Codicon.symbolBoolean),m.set(17,E.Codicon.symbolArray),m.set(18,E.Codicon.symbolObject),m.set(19,E.Codicon.symbolKey),m.set(20,E.Codicon.symbolNull),m.set(21,E.Codicon.symbolEnumMember),m.set(22,E.Codicon.symbolStruct),m.set(23,E.Codicon.symbolEvent),m.set(24,E.Codicon.symbolOperator),m.set(25,E.Codicon.symbolTypeParameter);function R(L){let $=m.get(L);return $||(console.info("No codicon found for SymbolKind "+L),$=E.Codicon.symbolProperty),$}s.toIcon=R})(A=e.SymbolKinds||(e.SymbolKinds={}));class t{constructor(m){this.value=m}}t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region"),e.FoldingRangeKind=t;var r;(function(s){function m(R){return!R||typeof R!="object"?!1:typeof R.id=="string"&&typeof R.title=="string"}s.is=m})(r=e.Command||(e.Command={}));var n;(function(s){s[s.Collapsed=0]="Collapsed",s[s.Expanded=1]="Expanded"})(n=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var i;(function(s){s[s.Unresolved=0]="Unresolved",s[s.Resolved=1]="Resolved"})(i=e.CommentThreadState||(e.CommentThreadState={}));var o;(function(s){s[s.Editing=0]="Editing",s[s.Preview=1]="Preview"})(o=e.CommentMode||(e.CommentMode={}));var c;(function(s){s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(c=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new I.TokenizationRegistry;var a;(function(s){s[s.None=0]="None",s[s.Option=1]="Option",s[s.Default=2]="Default",s[s.Preferred=3]="Preferred"})(a=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ve[168],be([10,11]),function(ae,e){return ae.create("vs/base/node/zip",e)}),define(ve[169],be([10,11]),function(ae,e){return ae.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ve[170],be([10,11]),function(ae,e){return ae.create("vs/platform/environment/node/argv",e)}),define(ve[171],be([10,11]),function(ae,e){return ae.create("vs/platform/environment/node/argvHelper",e)}),define(ve[172],be([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ve[173],be([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ve[174],be([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ve[175],be([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ve[176],be([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ve[177],be([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ve[178],be([10,11]),function(ae,e){return ae.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ve[179],be([10,11]),function(ae,e){return ae.create("vs/platform/extensions/common/extensionValidator",e)}),define(ve[180],be([10,11]),function(ae,e){return ae.create("vs/platform/files/common/fileService",e)}),define(ve[181],be([10,11]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(ve[182],be([10,11]),function(ae,e){return ae.create("vs/platform/files/common/io",e)}),define(ve[183],be([10,11]),function(ae,e){return ae.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ve[184],be([10,11]),function(ae,e){return ae.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ve[185],be([10,11]),function(ae,e){return ae.create("vs/platform/markers/common/markers",e)}),define(ve[186],be([10,11]),function(ae,e){return ae.create("vs/platform/request/common/request",e)}),define(ve[187],be([10,11]),function(ae,e){return ae.create("vs/platform/shell/node/shellEnv",e)}),define(ve[188],be([10,11]),function(ae,e){return ae.create("vs/platform/telemetry/common/telemetryService",e)}),define(ve[189],be([10,11]),function(ae,e){return ae.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ve[190],be([10,11]),function(ae,e){return ae.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ve[191],be([10,11]),function(ae,e){return ae.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ve[192],be([10,11]),function(ae,e){return ae.create("vs/platform/workspace/common/workspace",e)}),define(ve[193],be([10,11]),function(ae,e){return ae.create("vs/server/node/serverEnvironmentService",e)}),define(ve[194],be([10,11]),function(ae,e){return ae.create("vs/server/node/serverServices",e)}),define(ve[195],be([10,11]),function(ae,e){return ae.create("vs/workbench/common/editor",e)}),define(ve[196],be([10,11]),function(ae,e){return ae.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ve[197],be([10,11]),function(ae,e){return ae.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(ve[198],be([1,0,6,2]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class l{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(P,w,y){switch(w){case"close":return Promise.resolve(this.a.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(P,w,y){switch(w){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}l.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=l;class I extends k.Disposable{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,w,y){this.b.call("attach",[P,w,y])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,w){this.b.call("terminate",[P,w])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,w){return this.b.call("openExtensionDevelopmentHostWindow",[P,w])}}e.ExtensionHostDebugChannelClient=I}),define(ve[199],be([1,0,4]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class k{constructor(C){this.a=C}listen(C,P,w){throw new Error("Invalid listen")}call(C,P,w){switch(P){case"download":return this.a.download(E.URI.revive(w[0]),E.URI.revive(w[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=k;class l{constructor(C,P){this.a=C,this.b=P}async download(C,P){const w=this.b();w&&(C=w.transformOutgoingURI(C),P=w.transformOutgoingURI(P)),await this.a.call("download",[C,P])}}e.DownloadServiceChannelClient=l}),define(ve[102],be([1,0,152,85,13,7,28,20,4]),function(ae,e,E,k,l,I,C,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class y{get appRoot(){return(0,I.dirname)(l.FileAccess.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,I.join)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,I.join)(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return w.URI.file((0,I.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return w.URI.file((0,I.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(w.URI.file((0,I.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=C.env.VSCODE_PORTABLE;return f?w.URI.file((0,I.join)(f,"argv.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,I.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,I.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,I.resolve)(f):(0,I.normalize)((0,I.join)(l.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?w.URI.file((0,I.resolve)(f)):w.URI.file((0,I.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,I.resolve)(f);const p=C.env.VSCODE_EXTENSIONS;if(p)return p;const u=C.env.VSCODE_PORTABLE;return u?(0,I.join)(u,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(p=>/^[^:/?#]+?:\/\//.test(p)?w.URI.parse(p):w.URI.file((0,I.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?w.URI.parse(f):w.URI.file((0,I.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return T(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!C.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const p of this.args.log||[]){const u=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);u&&u[1]&&u[2]&&f.push([u[1],u[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return w.URI.file((0,I.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=C.env.VSCODE_PORTABLE;return f?w.URI.file((0,I.join)(f,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,p,u){this.a=f,this.b=p,this.c=u,this.editSessionId=this.args.editSessionId}}Re([k.memoize],y.prototype,"appRoot",null),Re([k.memoize],y.prototype,"userHome",null),Re([k.memoize],y.prototype,"userDataPath",null),Re([k.memoize],y.prototype,"appSettingsHome",null),Re([k.memoize],y.prototype,"tmpDir",null),Re([k.memoize],y.prototype,"cacheHome",null),Re([k.memoize],y.prototype,"stateResource",null),Re([k.memoize],y.prototype,"userRoamingDataHome",null),Re([k.memoize],y.prototype,"userDataSyncHome",null),Re([k.memoize],y.prototype,"userDataSyncLogResource",null),Re([k.memoize],y.prototype,"editSessionsLogResource",null),Re([k.memoize],y.prototype,"sync",null),Re([k.memoize],y.prototype,"machineSettingsResource",null),Re([k.memoize],y.prototype,"workspaceStorageHome",null),Re([k.memoize],y.prototype,"localHistoryHome",null),Re([k.memoize],y.prototype,"keyboardLayoutResource",null),Re([k.memoize],y.prototype,"argvResource",null),Re([k.memoize],y.prototype,"isExtensionDevelopment",null),Re([k.memoize],y.prototype,"untitledWorkspacesHome",null),Re([k.memoize],y.prototype,"installSourcePath",null),Re([k.memoize],y.prototype,"builtinExtensionsPath",null),Re([k.memoize],y.prototype,"extensionsPath",null),Re([k.memoize],y.prototype,"extensionDevelopmentLocationURI",null),Re([k.memoize],y.prototype,"extensionDevelopmentKind",null),Re([k.memoize],y.prototype,"extensionTestsLocationURI",null),Re([k.memoize],y.prototype,"debugExtensionHost",null),Re([k.memoize],y.prototype,"logLevel",null),Re([k.memoize],y.prototype,"extensionLogLevel",null),Re([k.memoize],y.prototype,"serviceMachineIdResource",null),Re([k.memoize],y.prototype,"telemetryLogResource",null),Re([k.memoize],y.prototype,"disableWorkspaceTrust",null),Re([k.memoize],y.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=y;function T(g,f){return b(g["inspect-extensions"],g["inspect-brk-extensions"],5870,f,g.debugId,g.extensionEnvironment)}e.parseExtensionHostPort=T;function S(g,f){return b(g["inspect-ptyhost"],g["inspect-brk-ptyhost"],5877,f,g.extensionEnvironment)}e.parsePtyHostPort=S;function b(g,f,p,u,h,v){const D=Number(f||g)||(u?null:p),A=D?Boolean(!!f):!1;let t;if(v)try{t=JSON.parse(v)}catch{}return{port:D,break:A,debugId:h,env:t}}}),define(ve[61],be([1,0,280,3,170]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const I={o:(0,l.localize)(0,null),e:(0,l.localize)(1,null),t:(0,l.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,l.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,l.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,l.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,l.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,l.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,l.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,l.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,l.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,l.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,l.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,l.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,l.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,l.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,l.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,l.localize)(17,null)},category:{type:"string",cat:"e",description:(0,l.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,l.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,l.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,l.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,l.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,l.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,l.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,l.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,l.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,l.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,l.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,l.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,l.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,l.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,l.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,l.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,l.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,l.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const C={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(p,u,h=C){const v=p.find(c=>c.length>0&&c[0]!=="-"),d={},D=["_"],A=[],t={};let r;for(const c in u){const a=u[c];a.type==="subcommand"?c===v&&(r=a):(a.alias&&(d[c]=a.alias),a.type==="string"||a.type==="string[]"?(D.push(c),a.deprecates&&D.push(...a.deprecates)):a.type==="boolean"&&(A.push(c),a.deprecates&&A.push(...a.deprecates)),a.global&&(t[c]=a))}if(r&&v){const c=t;for(const R in r.options)c[R]=r.options[R];const a=p.filter(R=>R!==v),s=h.getSubcommandReporter?h.getSubcommandReporter(v):void 0,m=P(a,c,s);return{[v]:m,_:[]}}const n=E(p,{string:D,boolean:A,alias:d}),i={},o=n;i._=n._.map(c=>String(c)).filter(c=>c.length>0),delete o._;for(const c in u){const a=u[c];if(a.type==="subcommand")continue;a.alias&&delete o[a.alias];let s=o[c];if(a.deprecates)for(const m of a.deprecates)o.hasOwnProperty(m)&&(s||(s=o[m],s&&h.onDeprecatedOption(m,a.deprecationMessage||(0,l.localize)(36,null,c))),delete o[m]);if(typeof s<"u"){if(a.type==="string[]"){if(Array.isArray(s)||(s=[s]),!a.allowEmptyValue){const m=s.filter(R=>R.length>0);m.length!==s.length&&(h.onEmptyValue(c),s=m.length>0?m:void 0)}}else a.type==="string"&&(Array.isArray(s)?(s=s.pop(),h.onMultipleValues(c,s)):!s&&!a.allowEmptyValue&&(h.onEmptyValue(c),s=void 0));i[c]=s,a.deprecationMessage&&h.onDeprecatedOption(c,a.deprecationMessage)}delete o[c]}for(const c in o)h.onUnknownOption(c);return i}e.parseArgs=P;function w(p,u){let h="";return u.args&&(Array.isArray(u.args)?h=` <${u.args.join("> <")}>`:h=` <${u.args}>`),u.alias?`-${u.alias} --${p}${h}`:`--${p}${h}`}function y(p,u){const h=[];for(const v in p){const d=p[v],D=w(v,d);h.push([D,d.description])}return T(h,u)}e.formatOptions=y;function T(p,u){const v=p.reduce((A,t)=>Math.max(A,t[0].length),12)+2+1;if(u-v<25)return p.reduce((A,t)=>A.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const d=u-v-1,D=[];for(const A of p){const t=A[0],r=b(A[1],d),n=S(v-t.length-2);D.push("  "+t+n+r[0]);for(let i=1;i<r.length;i++)D.push(S(v)+r[i])}return D}function S(p){return" ".repeat(p)}function b(p,u){const h=[];for(;p.length;){const v=p.length<u?p.length:p.lastIndexOf(" ",u),d=p.slice(0,v).trim();p=p.slice(v),h.push(d)}return h}function g(p,u,h,v,d){const D=process.stdout.isTTY&&process.stdout.columns||80,A=d?.noInputFiles!==!0?`[${(0,l.localize)(37,null)}...]`:"",t=[`${p} ${h}`];t.push(""),t.push(`${(0,l.localize)(38,null)}: ${u} [${(0,l.localize)(39,null)}]${A}`),t.push(""),d?.noPipe!==!0&&(k.isWindows?t.push((0,l.localize)(40,null,u)):t.push((0,l.localize)(41,null,u)),t.push(""));const r={},n=[];for(const i in v){const o=v[i];if(o.type==="subcommand")o.description&&n.push({command:i,description:o.description});else if(o.description&&o.cat){let c=r[o.cat];c||(r[o.cat]=c={}),c[i]=o}}for(const i in r){const o=i,c=r[o];c&&(t.push(I[o]),t.push(...y(c,D)),t.push(""))}return n.length&&(t.push((0,l.localize)(42,null)),t.push(...T(n.map(i=>[i.command,i.description]),D)),t.push("")),t.join(`
`)}e.buildHelpMessage=g;function f(p,u){return`${p||(0,l.localize)(43,null)}
${u||(0,l.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=f}),define(ve[200],be([1,0,281,171,61]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const I=2048;function C(b,g){const f=(D,A)=>{console.warn((0,k.localize)(0,null,D,A))},p=D=>{console.warn((0,k.localize)(1,null,D))},u=(D,A)=>{console.warn((0,k.localize)(2,null,D,A))},h=D=>({onUnknownOption:A=>{D!=="tunnel"&&console.warn((0,k.localize)(3,null,A,D))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:u,getSubcommandReporter:D!=="tunnel"?h:void 0}),v={onUnknownOption:D=>{console.warn((0,k.localize)(4,null,D))},onMultipleValues:f,onEmptyValue:p,onDeprecatedOption:u,getSubcommandReporter:h},d=(0,l.parseArgs)(b,l.OPTIONS,g?v:void 0);return d.goto&&d._.forEach(D=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(D),(0,k.localize)(5,null))),d["max-memory"]&&E(parseInt(d["max-memory"])>=I,`The max-memory argument cannot be specified lower than ${I} MB.`),d}function P(b){const g=b.findIndex(f=>!/^-/.test(f));if(g>-1)return[...b.slice(0,g),...b.slice(g+1)]}function w(b){let[,...g]=b;process.env.VSCODE_DEV&&(g=P(g)||[]);const f=!S(process.env);return C(g,f)}e.parseMainProcessArgv=w;function y(b){let[,,...g]=b;return process.env.VSCODE_DEV&&(g=P(g)||[]),C(g,!0)}e.parseCLIProcessArgv=y;function T(b,...g){const f=b.indexOf("--");return f===-1?b.push(...g):b.splice(f,0,...g),b}e.addArg=T;function S(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=S}),function(){"use strict";function ae(e,E,k){function l(C,P){const w=I(C,P),y=[w];return e.isAbsolute(w)||y.unshift(k),e.resolve(...y)}function I(C,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let y=process.env.VSCODE_APPDATA;if(y)return e.join(y,P);const T=C["user-data-dir"];if(T)return T;switch(process.platform){case"win32":if(y=process.env.APPDATA,!y){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");y=e.join(S,"AppData","Roaming")}break;case"darwin":y=e.join(E.homedir(),"Library","Application Support");break;case"linux":y=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(y,P)}return{getUserDataPath:l}}if(typeof define=="function")define(ve[201],be([90,31,28]),function(e,E,k){return ae(e,E,k.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=ae(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ve[202],be([1,0,31,102,201]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class I extends k.AbstractNativeEnvironmentService{constructor(P,w){super(P,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,l.getUserDataPath)(P,w.nameShort)},w)}}e.NativeEnvironmentService=I}),define(ve[203],be([1,0,8,175]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function l(C,P,w){try{I(C,P,w)}catch(y){console.error(y?.message??y)}return C}e.localizeManifest=l;function I(C,P,w){const y=(T,S,b)=>{const g=T[S];if((0,E.isString)(g)){const f=g,p=f.length;if(p>1&&f[0]==="%"&&f[p-1]==="%"){const u=f.substr(1,p-2);let h=P[u];h===void 0&&w&&(h=w[u]);const v=typeof h=="string"?h:h?.message,d=w?.[u],D=typeof d=="string"?d:d?.message;if(!v){D||console.warn(`[${C.name}]: ${(0,k.localize)(0,null,u)}`);return}if(b&&(S==="title"||S==="category")&&D&&D!==v){const A={value:v,original:D};T[S]=A}else T[S]=v}}else if((0,E.isObject)(g))for(const f in g)g.hasOwnProperty(f)&&(f==="commands"?y(g,f,!0):y(g,f,b));else if(Array.isArray(g))for(let f=0;f<g.length;f++)y(g,f,b)};for(const T in C)C.hasOwnProperty(T)&&y(C,T)}}),define(ve[204],be([1,0,9]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class k{constructor(){this.a=new Map}register(I,C){this.a.set(I,C)}updateManifest(I){if(!(typeof I.main>"u"&&typeof I.browser>"u")&&(I.activationEvents===void 0&&Object.assign(I,{activationEvents:[]}),!(!Array.isArray(I.activationEvents)||!I.contributes)))for(const C in I.contributes){const P=this.a.get(C);if(!P)continue;const w=I.contributes[C],y=Array.isArray(w)?w:[w];try{P(y,I.activationEvents)}catch(T){(0,E.onUnexpectedError)(T)}}}}e.ImplicitActivationEventsImpl=k,e.ImplicitActivationEvents=new k}),define(ve[73],be([1,0,20,58,179,50]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const C=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function w(h){return h=h.trim(),h==="*"||C.test(h)}e.isValidVersionStr=w;function y(h){if(!w(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=h.match(C);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=y;function T(h){if(!h)return null;const v=h.majorBase,d=h.majorMustEqual,D=h.minorBase;let A=h.minorMustEqual;const t=h.patchBase;let r=h.patchMustEqual;h.hasCaret&&(v===0||(A=!1),r=!1);let n=0;if(h.preRelease){const i=P.exec(h.preRelease);if(i){const[,o,c,a]=i;n=Date.UTC(Number(o),Number(c)-1,Number(a))}}return{majorBase:v,majorMustEqual:d,minorBase:D,minorMustEqual:A,patchBase:t,patchMustEqual:r,isMinimum:h.hasGreaterEquals,notBefore:n}}e.normalizeVersion=T;function S(h,v,d){let D;typeof h=="string"?D=T(y(h)):D=h;let A;v instanceof Date?A=v.getTime():typeof v=="string"&&(A=new Date(v).getTime());let t;if(typeof d=="string"?t=T(y(d)):t=d,!D||!t)return!1;const r=D.majorBase,n=D.minorBase,i=D.patchBase;let o=t.majorBase,c=t.minorBase,a=t.patchBase;const s=t.notBefore;let m=t.majorMustEqual,R=t.minorMustEqual,L=t.patchMustEqual;return t.isMinimum?r>o?!0:r<o?!1:n>c?!0:n<c||A&&A<s?!1:i>=a:(r===1&&o===0&&(!m||!R||!L)&&(o=1,c=0,a=0,m=!0,R=!1,L=!1),r<o?!1:r>o?!m:n<c?!1:n>c?!R:i<a?!1:i>a?!L:!(A&&A<s))}e.isValidVersion=S;function b(h,v,d,D,A){const t=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return t.push([k.default.Error,l.localize(0,null)]),t;if(typeof D.name!="string")return t.push([k.default.Error,l.localize(1,null,"name")]),t;if(typeof D.version!="string")return t.push([k.default.Error,l.localize(2,null,"version")]),t;if(!D.engines)return t.push([k.default.Error,l.localize(3,null,"engines")]),t;if(typeof D.engines.vscode!="string")return t.push([k.default.Error,l.localize(4,null,"engines.vscode")]),t;if(typeof D.extensionDependencies<"u"&&!u(D.extensionDependencies))return t.push([k.default.Error,l.localize(5,null,"extensionDependencies")]),t;if(typeof D.activationEvents<"u"){if(!u(D.activationEvents))return t.push([k.default.Error,l.localize(6,null,"activationEvents")]),t;if(typeof D.main>"u"&&typeof D.browser>"u")return t.push([k.default.Error,l.localize(7,null,"activationEvents","main")]),t}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&t.push([k.default.Warning,l.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return t.push([k.default.Error,l.localize(9,null,"main")]),t;{const i=(0,E.joinPath)(d,D.main);(0,E.isEqualOrParent)(i,d)||t.push([k.default.Warning,l.localize(10,null,i.path,d.path)])}if(typeof D.activationEvents>"u")return t.push([k.default.Error,l.localize(11,null,"activationEvents","main")]),t}if(typeof D.browser<"u"){if(typeof D.browser!="string")return t.push([k.default.Error,l.localize(12,null,"browser")]),t;{const i=(0,E.joinPath)(d,D.browser);(0,E.isEqualOrParent)(i,d)||t.push([k.default.Warning,l.localize(13,null,i.path,d.path)])}if(typeof D.activationEvents>"u")return t.push([k.default.Error,l.localize(14,null,"activationEvents","browser")]),t}if(!I.valid(D.version))return t.push([k.default.Error,l.localize(15,null)]),t;const r=[];if(!g(h,v,D,A,r))for(const i of r)t.push([k.default.Error,i]);return t}e.validateExtensionManifest=b;function g(h,v,d,D,A){return D||typeof d.main>"u"&&typeof d.browser>"u"?!0:p(h,v,d.engines.vscode,A)}e.isValidExtensionVersion=g;function f(h,v,d){return h==="*"||p(v,d,h)}e.isEngineValid=f;function p(h,v,d,D=[]){const A=T(y(d));if(!A)return D.push(l.localize(16,null,d)),!1;if(A.majorBase===0){if(!A.majorMustEqual||!A.minorMustEqual)return D.push(l.localize(17,null,d)),!1}else if(!A.majorMustEqual)return D.push(l.localize(18,null,d)),!1;return S(h,v,A)?!0:(D.push(l.localize(19,null,h,d)),!1)}function u(h){if(!Array.isArray(h))return!1;for(let v=0,d=h.length;v<d;v++)if(typeof h[v]!="string")return!1;return!0}}),define(ve[205],be([1,0,15,22]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function l(I,C,P){let w=P&&P.get("storage.serviceMachineId",-1)||null;if(w)return w;try{const T=(await C.readFile(I.serviceMachineIdResource)).value.toString();w=(0,k.isUUID)(T)?T:null}catch{w=null}if(!w){w=(0,k.generateUuid)();try{await C.writeFile(I.serviceMachineIdResource,E.VSBuffer.fromString(w))}catch{}}return P?.store("storage.serviceMachineId",w,-1,1),w}e.getServiceMachineId=l}),define(ve[62],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(l,I=[],C=!1){this.ctor=l,this.staticArguments=I,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=E}),define(ve[206],be([1,0,62]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const k=[];var l;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function I(P,w,y){w instanceof E.SyncDescriptor||(w=new E.SyncDescriptor(w,[],Boolean(y))),k.push([P,w])}e.registerSingleton=I;function C(){return k}e.getSingletonServiceDescriptors=C}),define(ve[207],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(I,C){this.key=I,this.data=C,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class k{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const C of this.a.values())C.outgoing.size===0&&I.push(C);return I}insertEdge(I,C){const P=this.lookupOrInsertNode(I),w=this.lookupOrInsertNode(C);P.outgoing.set(w.key,w),w.incoming.set(P.key,P)}removeNode(I){const C=this.b(I);this.a.delete(C);for(const P of this.a.values())P.outgoing.delete(C),P.incoming.delete(C)}lookupOrInsertNode(I){const C=this.b(I);let P=this.a.get(C);return P||(P=new E(C,I),this.a.set(C,P)),P}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[C,P]of this.a)I.push(`${C}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,C]of this.a){const P=new Set([I]),w=this.c(C,P);if(w)return w}}c(I,C){for(const[P,w]of I.outgoing){if(C.has(P))return[...C,P].join(" -> ");C.add(P);const y=this.c(w,C);if(y)return y;C.delete(P)}}}e.Graph=k}),define(ve[5],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function P(w){return w[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=P})(E=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function k(C,P,w){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:C,index:w}):(P[E.DI_DEPENDENCIES]=[{id:C,index:w}],P[E.DI_TARGET]=P)}function l(C){if(E.serviceIds.has(C))return E.serviceIds.get(C);const P=function(w,y,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(P,w,T)};return P.toString=()=>C,E.serviceIds.set(C,P),P}e.createDecorator=l;function I(C){return C}e.refineServiceDecorator=I}),define(ve[24],be([1,0,8,4,5]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function I(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof k.URI)}e.isConfigurationOverrides=I;function C(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof k.URI)}e.isConfigurationUpdateOverrides=C;var P;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function w(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=w;function y(u,h){const v=Object.create(null);for(const d in u)T(v,d,u[d],h);return v}e.toValuesTree=y;function T(u,h,v,d){const D=h.split("."),A=D.pop();let t=u;for(let r=0;r<D.length;r++){const n=D[r];let i=t[n];switch(typeof i){case"undefined":i=t[n]=Object.create(null);break;case"object":break;default:d(`Ignoring ${h} as ${D.slice(0,r+1).join(".")} is ${JSON.stringify(i)}`);return}t=i}if(typeof t=="object"&&t!==null)try{t[A]=v}catch{d(`Ignoring ${h} as ${D.join(".")} is ${JSON.stringify(t)}`)}else d(`Ignoring ${h} as ${D.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=T;function S(u,h){const v=h.split(".");b(u,v)}e.removeFromValueTree=S;function b(u,h){const v=h.shift();if(h.length===0){delete u[v];return}if(Object.keys(u).indexOf(v)!==-1){const d=u[v];typeof d=="object"&&!Array.isArray(d)&&(b(d,h),Object.keys(d).length===0&&delete u[v])}}function g(u,h,v){function d(t,r){let n=t;for(const i of r){if(typeof n!="object"||n===null)return;n=n[i]}return n}const D=h.split("."),A=d(u,D);return typeof A>"u"?v:A}e.getConfigurationValue=g;function f(u,h,v){Object.keys(h).forEach(d=>{d!=="__proto__"&&(d in u?E.isObject(u[d])&&E.isObject(h[d])?f(u[d],h[d],v):v&&(u[d]=h[d]):u[d]=h[d])})}e.merge=f;function p(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(ve[103],be([1,0,3,16,5]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",E.isMacintosh),I.set("isLinux",E.isLinux),I.set("isWindows",E.isWindows),I.set("isWeb",E.isWeb),I.set("isMacNative",E.isMacintosh&&!E.isWeb),I.set("isEdge",E.isEdge),I.set("isFirefox",E.isFirefox),I.set("isChrome",E.isChrome),I.set("isSafari",E.isSafari);const C=Object.prototype.hasOwnProperty;var P;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(P=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return S.INSTANCE}static true(){return b.INSTANCE}static has(F){return g.create(F)}static equals(F,_){return f.create(F,_)}static notEquals(F,_){return h.create(F,_)}static regex(F,_){return n.create(F,_)}static in(F,_){return p.create(F,_)}static notIn(F,_){return u.create(F,_)}static not(F){return v.create(F)}static and(...F){return c.create(F,null,!0)}static or(...F){return a.create(F,null,!0)}static greater(F,_){return D.create(F,_)}static greaterEquals(F,_){return A.create(F,_)}static smaller(F,_){return t.create(F,_)}static smallerEquals(F,_){return r.create(F,_)}static deserialize(F,_=!1){if(!!F)return this.c(F,_)}static c(F,_){const z=F.split("||");return a.create(z.map(x=>this.d(x,_)),null,!0)}static d(F,_){const z=F.split("&&");return c.create(z.map(x=>this.f(x,_)),null,!0)}static f(F,_){if(F=F.trim(),F.indexOf("!=")>=0){const z=F.split("!=");return h.create(z[0].trim(),this.g(z[1],_))}if(F.indexOf("==")>=0){const z=F.split("==");return f.create(z[0].trim(),this.g(z[1],_))}if(F.indexOf("=~")>=0){const z=F.split("=~");return n.create(z[0].trim(),this.h(z[1],_))}if(F.indexOf(" not in ")>=0){const z=F.split(" not in ");return u.create(z[0].trim(),this.g(z[1],_))}if(F.indexOf(" in ")>=0){const z=F.split(" in ");return p.create(z[0].trim(),this.g(z[1],_))}if(/^[^<=>]+>=[^<=>]+$/.test(F)){const z=F.split(">=");return A.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(F)){const z=F.split(">");return D.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(F)){const z=F.split("<=");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(F)){const z=F.split("<");return t.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(F)?v.create(F.substr(1).trim()):g.create(F)}static g(F,_){if(F=F.trim(),F==="true")return!0;if(F==="false")return!1;const z=/^'([^']*)'$/.exec(F);return z?z[1].trim():F}static h(F,_){if((0,k.isFalsyOrWhitespace)(F)){if(_)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const z=F.indexOf("/"),x=F.lastIndexOf("/");if(z===x||z<0){if(_)throw new Error(`bad regexp-value '${F}', missing /-enclosure`);return console.warn(`bad regexp-value '${F}', missing /-enclosure`),null}const le=F.slice(z+1,x),Ee=F[x+1]==="i"?"i":"";try{return new RegExp(le,Ee)}catch(Y){if(_)throw new Error(`bad regexp-value '${F}', parse error: ${Y}`);return console.warn(`bad regexp-value '${F}', parse error: ${Y}`),null}}}e.ContextKeyExpr=w;function y(ne,F){const _=ne?ne.substituteConstants():void 0,z=F?F.substituteConstants():void 0;return!_&&!z?!0:!_||!z?!1:_.equals(z)}e.expressionsAreEqualWithConstantSubstitution=y;function T(ne,F){return ne.cmp(F)}class S{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return b.INSTANCE}}S.INSTANCE=new S,e.ContextKeyFalseExpr=S;class b{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return S.INSTANCE}}b.INSTANCE=new b,e.ContextKeyTrueExpr=b;class g{static create(F,_=null){const z=I.get(F);return typeof z=="boolean"?z?b.INSTANCE:S.INSTANCE:new g(F,_)}constructor(F,_){this.key=F,this.c=_,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:m(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=I.get(this.key);return typeof F=="boolean"?F?b.INSTANCE:S.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=v.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=g;class f{static create(F,_,z=null){if(typeof _=="boolean")return _?g.create(F,z):v.create(F,z);const x=I.get(F);return typeof x=="boolean"?_===(x?"true":"false")?b.INSTANCE:S.INSTANCE:new f(F,_,z)}constructor(F,_,z){this.c=F,this.d=_,this.f=z,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=I.get(this.c);if(typeof F=="boolean"){const _=F?"true":"false";return this.d===_?b.INSTANCE:S.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=f;class p{static create(F,_){return new p(F,_)}constructor(F,_){this.d=F,this.f=_,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:R(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const _=F.getValue(this.f),z=F.getValue(this.d);return Array.isArray(_)?_.includes(z):typeof z=="string"&&typeof _=="object"&&_!==null?C.call(_,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=p;class u{static create(F,_){return new u(F,_)}constructor(F,_){this.d=F,this.f=_,this.type=11,this.c=p.create(F,_)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=u;class h{static create(F,_,z=null){if(typeof _=="boolean")return _?v.create(F,z):g.create(F,z);const x=I.get(F);return typeof x=="boolean"?_===(x?"true":"false")?S.INSTANCE:b.INSTANCE:new h(F,_,z)}constructor(F,_,z){this.c=F,this.d=_,this.f=z,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=I.get(this.c);if(typeof F=="boolean"){const _=F?"true":"false";return this.d===_?S.INSTANCE:b.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=h;class v{static create(F,_=null){const z=I.get(F);return typeof z=="boolean"?z?S.INSTANCE:b.INSTANCE:new v(F,_)}constructor(F,_){this.c=F,this.d=_,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:m(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=I.get(this.c);return typeof F=="boolean"?F?S.INSTANCE:b.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.ContextKeyNotExpr=v;function d(ne,F){if(typeof ne=="string"){const _=parseFloat(ne);isNaN(_)||(ne=_)}return typeof ne=="string"||typeof ne=="number"?F(ne):S.INSTANCE}class D{static create(F,_,z=null){return d(_,x=>new D(F,x,z))}constructor(F,_,z){this.c=F,this.d=_,this.f=z,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=D;class A{static create(F,_,z=null){return d(_,x=>new A(F,x,z))}constructor(F,_,z){this.c=F,this.d=_,this.f=z,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=t.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=A;class t{static create(F,_,z=null){return d(_,x=>new t(F,x,z))}constructor(F,_,z){this.c=F,this.d=_,this.f=z,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=t;class r{static create(F,_,z=null){return d(_,x=>new r(F,x,z))}constructor(F,_,z){this.c=F,this.d=_,this.f=z,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:R(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=r;class n{static create(F,_){return new n(F,_)}constructor(F,_){this.d=F,this.f=_,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const _=this.f?this.f.source:"",z=F.f?F.f.source:"";return _<z?-1:_>z?1:0}equals(F){if(F.type===this.type){const _=this.f?this.f.source:"",z=F.f?F.f.source:"";return this.d===F.d&&_===z}return!1}substituteConstants(){return this}evaluate(F){const _=F.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.ignoreCase?"i":""}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=i.create(this)),this.c}}e.ContextKeyRegexExpr=n;class i{static create(F){return new i(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(F){return new i(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=i;function o(ne){let F=null;for(let _=0,z=ne.length;_<z;_++){const x=ne[_].substituteConstants();if(ne[_]!==x&&F===null){F=[];for(let le=0;le<_;le++)F[le]=ne[le]}F!==null&&(F[_]=x)}return F===null?ne:F}class c{static create(F,_,z){return c.d(F,_,z)}constructor(F,_){this.expr=F,this.c=_,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let _=0,z=this.expr.length;_<z;_++){const x=T(this.expr[_],F.expr[_]);if(x!==0)return x}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let _=0,z=this.expr.length;_<z;_++)if(!this.expr[_].equals(F.expr[_]))return!1;return!0}return!1}substituteConstants(){const F=o(this.expr);return F===this.expr?this:c.create(F,this.c,!1)}evaluate(F){for(let _=0,z=this.expr.length;_<z;_++)if(!this.expr[_].evaluate(F))return!1;return!0}static d(F,_,z){const x=[];let le=!1;for(const Ee of F)if(!!Ee){if(Ee.type===1){le=!0;continue}if(Ee.type===0)return S.INSTANCE;if(Ee.type===6){x.push(...Ee.expr);continue}x.push(Ee)}if(x.length===0&&le)return b.INSTANCE;if(x.length!==0){if(x.length===1)return x[0];x.sort(T);for(let Ee=1;Ee<x.length;Ee++)x[Ee-1].equals(x[Ee])&&(x.splice(Ee,1),Ee--);if(x.length===1)return x[0];for(;x.length>1;){const Ee=x[x.length-1];if(Ee.type!==9)break;x.pop();const Y=x.pop(),H=x.length===0,U=a.create(Ee.expr.map(te=>c.create([te,Y],null,z)),null,H);U&&(x.push(U),x.sort(T))}if(x.length===1)return x[0];if(z){for(let Ee=0;Ee<x.length;Ee++)for(let Y=Ee+1;Y<x.length;Y++)if(x[Ee].negate().equals(x[Y]))return S.INSTANCE;if(x.length===1)return x[0]}return new c(x,_)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const _ of this.expr)F.push(..._.keys());return F}map(F){return new c(this.expr.map(_=>_.map(F)),null)}negate(){if(!this.c){const F=[];for(const _ of this.expr)F.push(_.negate());this.c=a.create(F,this,!0)}return this.c}}class a{static create(F,_,z){return a.d(F,_,z)}constructor(F,_){this.expr=F,this.c=_,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let _=0,z=this.expr.length;_<z;_++){const x=T(this.expr[_],F.expr[_]);if(x!==0)return x}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let _=0,z=this.expr.length;_<z;_++)if(!this.expr[_].equals(F.expr[_]))return!1;return!0}return!1}substituteConstants(){const F=o(this.expr);return F===this.expr?this:a.create(F,this.c,!1)}evaluate(F){for(let _=0,z=this.expr.length;_<z;_++)if(this.expr[_].evaluate(F))return!0;return!1}static d(F,_,z){let x=[],le=!1;if(F){for(let Ee=0,Y=F.length;Ee<Y;Ee++){const H=F[Ee];if(!!H){if(H.type===0){le=!0;continue}if(H.type===1)return b.INSTANCE;if(H.type===9){x=x.concat(H.expr);continue}x.push(H)}}if(x.length===0&&le)return S.INSTANCE;x.sort(T)}if(x.length!==0){if(x.length===1)return x[0];for(let Ee=1;Ee<x.length;Ee++)x[Ee-1].equals(x[Ee])&&(x.splice(Ee,1),Ee--);if(x.length===1)return x[0];if(z){for(let Ee=0;Ee<x.length;Ee++)for(let Y=Ee+1;Y<x.length;Y++)if(x[Ee].negate().equals(x[Y]))return b.INSTANCE;if(x.length===1)return x[0]}return new a(x,_)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const _ of this.expr)F.push(..._.keys());return F}map(F){return new a(this.expr.map(_=>_.map(F)),null)}negate(){if(!this.c){const F=[];for(const _ of this.expr)F.push(_.negate());for(;F.length>1;){const _=F.shift(),z=F.shift(),x=[];for(const le of ie(_))for(const Ee of ie(z))x.push(c.create([le,Ee],null,!1));F.unshift(a.create(x,null,!1))}this.c=a.create(F,this,!0)}return this.c}}class s extends g{static all(){return s.d.values()}constructor(F,_,z){super(F,null),this.f=_,typeof z=="object"?s.d.push({...z,key:F}):z!==!0&&s.d.push({key:F,description:z,type:_!=null?typeof _:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return f.create(this.key,F)}notEqualsTo(F){return h.create(this.key,F)}}s.d=[],e.RawContextKey=s,e.IContextKeyService=(0,l.createDecorator)("contextKeyService");function m(ne,F){return ne<F?-1:ne>F?1:0}function R(ne,F,_,z){return ne<_?-1:ne>_?1:F<z?-1:F>z?1:0}function L(ne,F){if(ne.type===0||F.type===1)return!0;if(ne.type===9)return F.type===9?$(ne.expr,F.expr):!1;if(F.type===9){for(const _ of F.expr)if(L(ne,_))return!0;return!1}if(ne.type===6){if(F.type===6)return $(F.expr,ne.expr);for(const _ of ne.expr)if(L(_,F))return!0;return!1}return ne.equals(F)}e.implies=L;function $(ne,F){let _=0,z=0;for(;_<ne.length&&z<F.length;){const x=ne[_].cmp(F[z]);if(x<0)return!1;x===0&&_++,z++}return _===ne.length}function ie(ne){return ne.type===9?ne.expr:[ne]}}),define(ve[74],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class k{constructor(){this.a={}}async getPassword(I,C){return this.a[I]?.[C]??null}async setPassword(I,C,P){this.a[I]=this.a[I]??{},this.a[I][C]=P}async deletePassword(I,C){return this.a[I]?.[C]?(delete this.a[I][C],Object.keys(this.a[I]).length===0&&delete this.a[I],!0):!1}async findPassword(I){return JSON.stringify(this.a[I])??null}async findCredentials(I){const C=[];for(const P of Object.keys(this.a[I]||{}))C.push({account:P,password:this.a[I][P]});return C}async clear(){this.a={}}}e.InMemoryCredentialsProvider=k}),define(ve[208],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function k(I){return!!I.hostName&&!!I.errorMessage}e.isRemoteDiagnosticError=k;class l{async getPerformanceInfo(C,P){return{}}async getSystemInfo(C,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(C,P){return""}async getWorkspaceFileExtensions(C){return{extensions:[]}}async reportWorkspaceStats(C){}}e.NullDiagnosticsService=l}),define(ve[75],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,E.createDecorator)("downloadService")}),define(ve[209],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(ve[25],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(ve[32],be([1,0,173,5]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function I(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function C(h,v){switch(h){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=C;function P(h,v){return v==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function w(h,v,d){return P(v,d)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===d?!0:y(d).includes(h)}e.isTargetPlatformCompatible=w;function y(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=y;function T(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=T;var S;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var b;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(b=e.SortOrder||(e.SortOrder={}));var g;(function(h){h.Install="install",h.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var f;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var p;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(v,d){super(v),this.code=d,this.name=d}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"}}),define(ve[210],be([1,0,6,2,48,23,4,72,32]),function(ae,e,E,k,l,I,C,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function y(u,h){return C.URI.revive(h?h.transformIncoming(u):u)}function T(u,h){return h?h.transformOutgoingURI(u):u}function S(u,h){h=h||P.DefaultURITransformer;const v=u.manifest;return{...(0,P.transformAndReviveIncomingURIs)({...u,manifest:void 0},h),manifest:v}}function b(u,h){return h?(0,I.cloneAndChange)(u,v=>v instanceof C.URI?h.transformOutgoingURI(v):void 0):u}class g{constructor(h,v){this.a=h,this.b=v,this.onInstallExtension=E.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=E.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=E.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=E.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=E.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,v){const d=this.b(h);switch(v){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return E.Event.map(this.onDidInstallExtensions,D=>D.map(A=>({...A,local:A.local?b(A.local,d):A.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension;case"onDidUpdateExtensionMetadata":return this.onDidUpdateExtensionMetadata}throw new Error("Invalid listen")}call(h,v,d){const D=this.b(h);switch(v){case"zip":return this.a.zip(S(d[0],D)).then(A=>T(A,D));case"unzip":return this.a.unzip(y(d[0],D));case"install":return this.a.install(y(d[0],D),(0,l.revive)(d[1]));case"installFromLocation":return this.a.installFromLocation(y(d[0],D),C.URI.revive(d[1]));case"getManifest":return this.a.getManifest(y(d[0],D));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],(0,l.revive)(d[1]));case"uninstall":return this.a.uninstall(S(d[0],D),(0,l.revive)(d[1]));case"reinstallFromGallery":return this.a.reinstallFromGallery(S(d[0],D));case"getInstalled":return this.a.getInstalled(d[0],C.URI.revive(d[1])).then(A=>A.map(t=>b(t,D)));case"getMetadata":return this.a.getMetadata(S(d[0],D),C.URI.revive(d[1]));case"updateMetadata":return this.a.updateMetadata(S(d[0],D),d[1],C.URI.revive(d[2])).then(A=>b(A,D));case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1])}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class f extends k.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.k=h,this.c=this.B(new E.Emitter),this.f=this.B(new E.Emitter),this.g=this.B(new E.Emitter),this.h=this.B(new E.Emitter),this.j=this.B(new E.Emitter),this.B(this.k.listen("onInstallExtension")(v=>this.c.fire({identifier:v.identifier,source:this.l(v.source)?C.URI.revive(v.source):v.source,profileLocation:C.URI.revive(v.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(v=>this.f.fire(v.map(d=>({...d,local:d.local?S(d.local,null):d.local,source:this.l(d.source)?C.URI.revive(d.source):d.source,profileLocation:C.URI.revive(d.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(v=>this.g.fire({identifier:v.identifier,profileLocation:C.URI.revive(v.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(v=>this.h.fire({...v,profileLocation:C.URI.revive(v.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(v=>this.j.fire(S(v,null))))}l(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.m||(this.m=this.k.call("getTargetPlatform")),this.m}async canInstall(h){const v=await this.getTargetPlatform();return h.allTargetPlatforms.some(d=>(0,w.isTargetPlatformCompatible)(d,h.allTargetPlatforms,v))}zip(h){return Promise.resolve(this.k.call("zip",[h]).then(v=>C.URI.revive(v)))}unzip(h){return Promise.resolve(this.k.call("unzip",[h]))}install(h,v){return Promise.resolve(this.k.call("install",[h,v])).then(d=>S(d,null))}installFromLocation(h,v){return Promise.resolve(this.k.call("installFromLocation",[h,v])).then(d=>S(d,null))}getManifest(h){return Promise.resolve(this.k.call("getManifest",[h]))}installFromGallery(h,v){return Promise.resolve(this.k.call("installFromGallery",[h,v])).then(d=>S(d,null))}uninstall(h,v){return Promise.resolve(this.k.call("uninstall",[h,v]))}reinstallFromGallery(h){return Promise.resolve(this.k.call("reinstallFromGallery",[h])).then(v=>S(v,null))}getInstalled(h=null,v){return Promise.resolve(this.k.call("getInstalled",[h,v])).then(d=>d.map(D=>S(D,null)))}getMetadata(h,v){return Promise.resolve(this.k.call("getMetadata",[h,v]))}updateMetadata(h,v,d){return Promise.resolve(this.k.call("updateMetadata",[h,v,d])).then(D=>S(D,null))}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(h,v){const d=await this.k.call("download",[h,v]);return C.URI.revive(d)}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class p{constructor(h){this.a=h}listen(h,v){throw new Error("Invalid listen")}call(h,v,d){switch(v){case"getConfigBasedTips":return this.a.getConfigBasedTips(C.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=p}),define(ve[76],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,E.createDecorator)("IExtensionSignatureVerificationService");class k{b(){return this.a||(this.a=new Promise((I,C)=>ae(["node-vsce-sign"],async P=>I(P),C))),this.a}async verify(I,C){let P;try{P=await this.b()}catch{return!1}return P.verify(I,C)}}e.ExtensionSignatureVerificationService=k}),define(ve[17],be([1,0,59,7,16,8,4,181,5,3,13]),function(ae,e,E,k,l,I,C,P,w,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,w.createDecorator)("fileService");function S(U){return U.create===!0}e.isFileOpenForWriteOptions=S;var b;(function(U){U[U.Unknown=0]="Unknown",U[U.File=1]="File",U[U.Directory=2]="Directory",U[U.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var g;(function(U){U[U.Readonly=1]="Readonly"})(g=e.FilePermission||(e.FilePermission={}));var f;(function(U){U[U.None=0]="None",U[U.FileReadWrite=2]="FileReadWrite",U[U.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",U[U.FileReadStream=16]="FileReadStream",U[U.FileFolderCopy=8]="FileFolderCopy",U[U.PathCaseSensitive=1024]="PathCaseSensitive",U[U.Readonly=2048]="Readonly",U[U.Trash=4096]="Trash",U[U.FileWriteUnlock=8192]="FileWriteUnlock",U[U.FileAtomicRead=16384]="FileAtomicRead",U[U.FileClone=32768]="FileClone"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(U){return!!(U.capabilities&2)}e.hasReadWriteCapability=p;function u(U){return!!(U.capabilities&8)}e.hasFileFolderCopyCapability=u;function h(U){return!!(U.capabilities&32768)}e.hasFileCloneCapability=h;function v(U){return!!(U.capabilities&4)}e.hasOpenReadWriteCloseCapability=v;function d(U){return!!(U.capabilities&16)}e.hasFileReadStreamCapability=d;function D(U){return p(U)?!!(U.capabilities&16384):!1}e.hasFileAtomicReadCapability=D;var A;(function(U){U.FileExists="EntryExists",U.FileNotFound="EntryNotFound",U.FileNotADirectory="EntryNotADirectory",U.FileIsADirectory="EntryIsADirectory",U.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",U.FileTooLarge="EntryTooLarge",U.FileWriteLocked="EntryWriteLocked",U.NoPermissions="NoPermissions",U.Unavailable="Unavailable",U.Unknown="Unknown"})(A=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{constructor(te,re){super(te),this.code=re}}e.FileSystemProviderError=t;function r(U,te){const re=new t(U.toString(),te);return i(re,te),re}e.createFileSystemProviderError=r;function n(U){return U||r((0,P.localize)(0,null),A.Unknown)}e.ensureFileSystemProviderError=n;function i(U,te){return U.name=te?`${te} (FileSystemError)`:"FileSystemError",U}e.markAsFileSystemProviderError=i;function o(U){if(!U)return A.Unknown;if(U instanceof t)return U.code;const te=/^(.+) \(FileSystemError\)$/.exec(U.name);if(!te)return A.Unknown;switch(te[1]){case A.FileExists:return A.FileExists;case A.FileIsADirectory:return A.FileIsADirectory;case A.FileNotADirectory:return A.FileNotADirectory;case A.FileNotFound:return A.FileNotFound;case A.FileExceedsMemoryLimit:return A.FileExceedsMemoryLimit;case A.FileTooLarge:return A.FileTooLarge;case A.FileWriteLocked:return A.FileWriteLocked;case A.NoPermissions:return A.NoPermissions;case A.Unavailable:return A.Unavailable}return A.Unknown}e.toFileSystemProviderErrorCode=o;function c(U){if(U instanceof $)return U.fileOperationResult;switch(o(U)){case A.FileNotFound:return 1;case A.FileIsADirectory:return 0;case A.FileNotADirectory:return 10;case A.FileWriteLocked:return 5;case A.NoPermissions:return 6;case A.FileExists:return 4;case A.FileExceedsMemoryLimit:return 9;case A.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=c;var a;(function(U){U[U.CREATE=0]="CREATE",U[U.DELETE=1]="DELETE",U[U.MOVE=2]="MOVE",U[U.COPY=3]="COPY",U[U.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class s{constructor(te,re,de){this.resource=te,this.operation=re,this.target=de}isOperation(te){return this.operation===te}}e.FileOperationEvent=s;var m;(function(U){U[U.UPDATED=0]="UPDATED",U[U.ADDED=1]="ADDED",U[U.DELETED=2]="DELETED"})(m=e.FileChangeType||(e.FileChangeType={}));class R{constructor(te,re){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const de=new Map;for(const oe of te){const j=de.get(oe.type);switch(j?j.push([oe.resource,oe]):de.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,j]of de)switch(oe){case 1:this.a=E.TernarySearchTree.forUris(()=>re),this.a.fill(j);break;case 0:this.b=E.TernarySearchTree.forUris(()=>re),this.b.fill(j);break;case 2:this.c=E.TernarySearchTree.forUris(()=>re),this.c.fill(j);break}}contains(te,...re){return this.d(te,{includeChildren:!1},...re)}affects(te,...re){return this.d(te,{includeChildren:!0},...re)}d(te,re,...de){if(!te)return!1;const oe=de.length>0;return!!((!oe||de.includes(1))&&(this.a?.get(te)||re.includeChildren&&this.a?.findSuperstr(te))||(!oe||de.includes(0))&&(this.b?.get(te)||re.includeChildren&&this.b?.findSuperstr(te))||(!oe||de.includes(2))&&(this.c?.findSubstr(te)||re.includeChildren&&this.c?.findSuperstr(te)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=R;function L(U,te,re){return!U||!te||U===te||te.length>U.length?!1:(te.charAt(te.length-1)!==k.sep&&(te+=k.sep),re?(0,l.startsWithIgnoreCase)(U,te):U.indexOf(te)===0)}e.isParent=L;class $ extends Error{constructor(te,re,de){super(te),this.fileOperationResult=re,this.options=de}}e.FileOperationError=$;class ie extends ${constructor(te,re,de,oe){super(te,re,oe),this.fileOperationResult=re,this.size=de}}e.TooLargeFileOperationError=ie;class ne extends ${constructor(te,re,de){super(te,2,de),this.stat=re}}e.NotModifiedSinceFileOperationError=ne;var F;(function(U){U[U.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",U[U.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",U[U.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",U[U.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",U[U.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",U[U.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",U[U.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",U[U.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",U[U.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",U[U.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",U[U.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",U[U.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var _;(function(U){U[U.FILE=0]="FILE",U[U.FOLDER=1]="FOLDER",U[U.ROOT_FOLDER=2]="ROOT_FOLDER"})(_=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function z(U){if(!(typeof U.size!="number"||typeof U.mtime!="number"))return U.mtime.toString(29)+U.size.toString(31)}e.etag=z;async function x(U,te){if(!te.hasProvider(C.URI.from({scheme:U.scheme})))return new Promise(re=>{const de=te.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===U.scheme&&oe.added&&(de.dispose(),re())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class le{static formatSize(te){return(0,I.isNumber)(te)||(te=0),te<le.KB?(0,P.localize)(1,null,te.toFixed(0)):te<le.MB?(0,P.localize)(2,null,(te/le.KB).toFixed(2)):te<le.GB?(0,P.localize)(3,null,(te/le.MB).toFixed(2)):te<le.TB?(0,P.localize)(4,null,(te/le.GB).toFixed(2)):(0,P.localize)(5,null,(te/le.TB).toFixed(2))}}le.KB=1024,le.MB=le.KB*le.KB,le.GB=le.MB*le.KB,le.TB=le.GB*le.KB,e.ByteSize=le;var Ee;(function(U){U[U.IA32=0]="IA32",U[U.OTHER=1]="OTHER"})(Ee=e.Arch||(e.Arch={}));function Y(U){return{maxFileSize:U===0?300*le.MB:16*le.GB,maxHeapSize:U===0?700*le.MB:2*700*le.MB}}e.getPlatformFileLimits=Y;function H(U){const te=typeof U=="string"||U?.scheme===T.Schemas.vscodeRemote;return typeof U!="string"&&U?.scheme===T.Schemas.file?1024*le.MB:te?10*le.MB:y.isWeb?50*le.MB:1024*le.MB}e.getLargeFileConfirmationLimit=H}),define(ve[211],be([1,0,15,37,9,6,2,44,4,22,17]),function(ae,e,E,k,l,I,C,P,w,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class S extends C.Disposable{constructor(g,f){super(),this.a=g,this.b=f,this.onDidChangeCapabilities=I.Event.None,this.f=this.B(new I.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new I.Emitter),this.onDidWatchError=this.g.event,this.h=(0,y.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,f){const{buffer:p}=await this.a.call("readFile",[g,f]);return p}readFileStream(g,f,p){const u=(0,P.newWriteableStream)(v=>E.VSBuffer.concat(v.map(d=>E.VSBuffer.wrap(d))).buffer),h=this.a.listen("readFileStream",[g,f])(v=>{if(v instanceof E.VSBuffer)u.write(v.buffer);else{if(v==="end")u.end();else{let d;if(v instanceof Error)d=v;else{const D=v;d=(0,T.createFileSystemProviderError)(D.message??(0,k.toErrorMessage)(D),D.code??T.FileSystemProviderErrorCode.Unknown)}u.error(d),u.end()}h.dispose()}});return p.onCancellationRequested(()=>{u.error((0,l.canceled)()),u.end(),h.dispose()}),u}writeFile(g,f,p){return this.a.call("writeFile",[g,E.VSBuffer.wrap(f),p])}open(g,f){return this.a.call("open",[g,f])}close(g){return this.a.call("close",[g])}async read(g,f,p,u,h){const[v,d]=await this.a.call("read",[g,f,h]);return p.set(v.buffer.slice(0,d),u),d}write(g,f,p,u,h){return this.a.call("write",[g,f,E.VSBuffer.wrap(p),u,h])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,f){return this.a.call("delete",[g,f])}rename(g,f,p){return this.a.call("rename",[g,f,p])}copy(g,f,p){return this.a.call("copy",[g,f,p])}cloneFile(g,f){return this.a.call("cloneFile",[g,f])}i(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const f=g;this.f.fire(f.map(p=>({resource:w.URI.revive(p.resource),type:p.type})))}else{const f=g;this.g.fire(f)}}))}watch(g,f){const p=(0,y.generateUuid)();return this.a.call("watch",[this.h,p,g,f]),(0,C.toDisposable)(()=>this.a.call("unwatch",[this.h,p]))}}e.DiskFileSystemProviderClient=S}),define(ve[104],be([1,0,15,9,182,17]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function C(T,S,b,g,f,p){let u;try{await P(T,S,b,g,f,p)}catch(h){u=h}finally{u&&f.errorTransformer&&(u=f.errorTransformer(u)),typeof u<"u"&&b.error(u),b.end()}}e.readFileIntoStream=C;async function P(T,S,b,g,f,p){w(p);const u=await T.open(S,{create:!1});try{w(p);let h=0,v=0,d=f&&typeof f.length=="number"?f.length:void 0,D=E.VSBuffer.alloc(Math.min(f.bufferSize,typeof d=="number"?d:f.bufferSize)),A=f&&typeof f.position=="number"?f.position:0,t=0;do v=await T.read(u,A,D.buffer,t,D.byteLength-t),A+=v,t+=v,h+=v,typeof d=="number"&&(d-=v),t===D.byteLength&&(await b.write(g(D)),D=E.VSBuffer.alloc(Math.min(f.bufferSize,typeof d=="number"?d:f.bufferSize)),t=0);while(v>0&&(typeof d!="number"||d>0)&&w(p)&&y(h,f));if(t>0){let r=t;typeof d=="number"&&(r=Math.min(t,d)),b.write(g(D.slice(0,r)))}}catch(h){throw(0,I.ensureFileSystemProviderError)(h)}finally{await T.close(u)}}function w(T){if(T.isCancellationRequested)throw(0,k.canceled)();return!0}function y(T,S){if(S?.limits){if(typeof S.limits.memory=="number"&&T>S.limits.memory)throw(0,I.createFileSystemProviderError)((0,l.localize)(0,null),I.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&T>S.limits.size)throw(0,I.createFileSystemProviderError)((0,l.localize)(1,null),I.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ve[63],be([1,0,71,2,7,3,4,17]),function(ae,e,E,k,l,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function w(h){return h.recursive===!0}e.isRecursiveWatchRequest=w;class y extends k.Disposable{constructor(v,d,D,A){super(),this.h=v,this.i=d,this.j=D,this.k=A,this.c=this.B(new k.MutableDisposable),this.f=void 0,this.g=0}m(){const v=new k.DisposableStore;this.c.value=v,this.b=this.l(v),this.b.setVerboseLogging(this.j),v.add(this.b.onDidChangeFile(d=>this.h(d))),v.add(this.b.onDidLogMessage(d=>this.i(d))),v.add(this.b.onDidError(d=>this.n(d)))}n(v){this.k.restartOnError?this.g<y.a&&this.f?(this.r(`restarting watcher after error: ${v}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${v}`):this.r(v)}p(v){this.g++,this.m(),this.watch(v)}async watch(v){this.f=v,await this.b?.watch(v)}async setVerboseLogging(v){this.j=v,await this.b?.setVerboseLogging(v)}r(v){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${v}`})}dispose(){return this.b=void 0,super.dispose()}}y.a=5,e.AbstractWatcherClient=y;class T extends y{constructor(v,d,D){super(v,d,D,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=T;class S extends y{constructor(v,d,D){super(v,d,D,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=S;function b(h){return h.map(v=>({type:v.type,resource:C.URI.file(v.path)}))}e.toFileChanges=b;function g(h){const v=new u;for(const d of h)v.processEvent(d);return v.coalesce()}e.coalesceEvents=g;function f(h,v){return typeof v=="string"&&!v.startsWith(E.GLOBSTAR)&&!(0,l.isAbsolute)(v)?{base:h,pattern:v}:v}e.normalizeWatcherPattern=f;function p(h,v){const d=[];for(const D of v)d.push((0,E.parse)(f(h,D)));return d}e.parseWatcherPatterns=p;class u{constructor(){this.a=new Set,this.b=new Map}c(v){return I.isLinux?v.path:v.path.toLowerCase()}processEvent(v){const d=this.b.get(this.c(v));let D=!1;if(d){const A=d.type,t=v.type;d.path!==v.path&&(v.type===2||v.type===1)?D=!0:A===1&&t===2?(this.b.delete(this.c(v)),this.a.delete(d)):A===2&&t===1?d.type=0:A===1&&t===0||(d.type=t)}else D=!0;D&&(this.a.add(v),this.b.set(this.c(v),v))}coalesce(){const v=[],d=[];return Array.from(this.a).filter(D=>D.type!==2?(v.push(D),!1):!0).sort((D,A)=>D.path.length-A.path.length).filter(D=>d.some(A=>(0,P.isParent)(D.path,A,!I.isLinux))?!1:(d.push(D.path),!0)).concat(v)}}}),define(ve[212],be([1,0,30,14,19,38,2,88,7,3,163,21,63]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends C.Disposable{constructor(u,h,v,d){super(),this.j=u,this.k=h,this.l=v,this.m=d,this.c=this.B(new k.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},D=>this.k(D))),this.f=this.B(new k.RunOnceWorker(D=>this.u(D),g.b)),this.g=(0,b.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,b.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new l.CancellationTokenSource,this.ready=this.n()}async n(){try{const u=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const h=await S.Promises.stat(u);this.B(await this.s(u,h.isDirectory()))}catch(u){u.code!=="ENOENT"?this.w(u):this.z(u)}}async r(u){let h=u.path;try{h=await S.Promises.realpath(u.path),u.path===h&&(h=await(0,T.realcase)(u.path)??u.path),u.path!==h&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${h})`)}catch{}return h}async s(u,h){if(y.isMacintosh&&(0,I.isEqualOrParent)(u,"/Volumes/",!0))return this.w(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),C.Disposable.None;const v=new l.CancellationTokenSource(this.i.token),d=new C.DisposableStore;try{const D=(0,w.basename)(u),A=(0,E.watch)(u);d.add((0,C.toDisposable)(()=>{A.removeAllListeners(),A.close()})),this.z(`Started watching: '${u}'`);const t=new Set;if(h)try{for(const n of await S.Promises.readdir(u))t.add(n)}catch(n){this.w(n)}const r=new Map;d.add((0,C.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),A.on("error",(n,i)=>{this.w(`Failed to watch ${u} for changes using fs.watch() (${n}, ${i})`),this.dispose()}),A.on("change",(n,i)=>{if(v.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${i}`);let o="";if(i&&(o=i.toString(),y.isMacintosh&&(o=(0,P.normalizeNFC)(o))),!(!o||n!=="change"&&n!=="rename"))if(h)if(n==="rename"){r.get(o)?.dispose();const c=setTimeout(async()=>{if(r.delete(o),o===D&&!await S.Promises.exists(u)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.v((0,w.join)(u,o));if(v.token.isCancellationRequested)return;let s;a?t.has(o)?s=0:(s=1,t.add(o)):(t.delete(o),s=2),this.t({path:(0,w.join)(this.j.path,o),type:s})},g.a);r.set(o,(0,C.toDisposable)(()=>clearTimeout(c)))}else{let c;t.has(o)?c=0:(c=1,t.add(o)),this.t({path:(0,w.join)(this.j.path,o),type:c})}else if(n==="rename"||o!==D){const c=setTimeout(async()=>{const a=await S.Promises.exists(u);v.token.isCancellationRequested||(a?(this.t({path:this.j.path,type:0},!0),d.add(await this.s(u,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},g.a);d.clear(),d.add((0,C.toDisposable)(()=>clearTimeout(c)))}else this.t({path:this.j.path,type:0},!0)})}catch(D){await S.Promises.exists(u)&&!v.token.isCancellationRequested&&this.w(`Failed to watch ${u} for changes using fs.watch() (${D.toString()})`)}return(0,C.toDisposable)(()=>{v.dispose(!0),d.dispose()})}t(u,h=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`),!h&&this.g.some(v=>v(u.path))?this.m&&this.z(` >> ignored (excluded) ${u.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(v=>v(u.path))?this.m&&this.z(` >> ignored (not included) ${u.path}`):this.f.work(u))}u(u){const h=(0,b.coalesceEvents)(u);if(h.length>0){if(this.m)for(const d of h)this.z(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);this.c.work(h)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(u){if(y.isLinux)return S.Promises.exists(u);try{const h=(0,w.basename)(u);return(await S.Promises.readdir((0,w.dirname)(u))).some(d=>d===h)}catch(h){return this.z(h),!1}}setVerboseLogging(u){this.m=u}w(u){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}y(u){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}z(u){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}g.a=100,g.b=75,e.NodeJSFileWatcherLibrary=g;async function f(p,u,h,v,d=512){const D=await S.Promises.open(p,"r"),A=Buffer.allocUnsafe(d),t=new l.CancellationTokenSource(v);let r,n=!1;const i={path:p,excludes:[],recursive:!1},o=new g(i,c=>{(async()=>{for(const{type:a}of c)if(a===0){if(n)return;n=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:s}=await S.Promises.read(D,A,0,d,null);if(!s||t.token.isCancellationRequested)break;u(A.slice(0,s))}}catch(s){r=new Error(s),t.dispose(!0)}finally{n=!1}}})()});return await o.ready,h(),new Promise((c,a)=>{t.token.onCancellationRequested(async()=>{o.dispose();try{await S.Promises.close(D)}catch(s){r=new Error(s)}r?a(r):c()})})}e.watchFileContents=f}),define(ve[213],be([1,0,6,71,2,3,212]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(y){const T=this.i(y),S=T.filter(g=>{const f=this.c.get(g.path);return f?!(0,k.patternsEquals)(f.request.excludes,g.excludes)||!(0,k.patternsEquals)(f.request.includes,g.includes):!0}),b=Array.from(this.c.values()).filter(({request:g})=>!T.find(f=>f.path===g.path&&(0,k.patternsEquals)(f.excludes,g.excludes)&&(0,k.patternsEquals)(f.includes,g.includes))).map(({request:g})=>g.path);S.length&&this.j(`Request to start watching: ${S.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),b.length&&this.j(`Request to stop watching: ${b.join(",")}`);for(const g of b)this.h(g);for(const g of S)this.g(g)}g(y){const T=new C.NodeJSFileWatcherLibrary(y,b=>this.a.fire(b),b=>this.b.fire(b),this.f),S={request:y,instance:T};this.c.set(y.path,S)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const T=this.c.get(y);T&&(this.c.delete(y),T.instance.dispose())}i(y){const T=new Map;for(const S of y){const b=I.isLinux?S.path:S.path.toLowerCase();T.set(b,S)}return Array.from(T.values())}async setVerboseLogging(y){this.f=y;for(const[,T]of this.c)T.instance.setVerboseLogging(y)}j(y){this.f&&this.b.fire({type:"trace",message:this.k(y)})}k(y,T){return T?`[File Watcher (node.js)] ${y} (path: ${T.request.path})`:`[File Watcher (node.js)] ${y}`}}e.NodeJSWatcher=P}),define(ve[214],be([1,0,63,213]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class l extends E.AbstractNonRecursiveWatcherClient{constructor(C,P,w){super(C,P,w),this.m()}l(){return new k.NodeJSWatcher}}e.NodeJSWatcherClient=l}),define(ve[215],be([1,0,13,41,101,63]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class C extends I.AbstractUniversalWatcherClient{constructor(w,y,T){super(w,y,T),this.m()}l(w){const y=w.add(new l.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(y.onDidProcessExit(({code:T,signal:S})=>this.n(`terminated by itself with code ${T}, signal: ${S}`))),k.ProxyChannel.toService((0,k.getNextTickChannel)(y.getChannel("watcher")))}}e.UniversalWatcherClient=C}),define(ve[77],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...l){this.a=new Map;for(const[I,C]of l)this.set(I,C)}set(l,I){const C=this.a.get(l);return this.a.set(l,I),C}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=E}),define(ve[105],be([1,0,14,9,2,62,207,5,77,87]),function(ae,e,E,k,l,I,C,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const T=!1;class S extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class b{constructor(u=new w.ServiceCollection,h=!1,v,d=T){this.f=u,this.g=h,this.h=v,this.i=d,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=d?v?._globalGraph??new C.Graph(D=>D):void 0}createChild(u){return new b(u,this.g,this,this.i)}invokeFunction(u,...h){const v=f.traceInvocation(this.i,u);let d=!1;try{return u({get:A=>{if(d)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(A,v);if(!t)throw new Error(`[invokeFunction] unknown service '${A}'`);return t}},...h)}finally{d=!0,v.stop()}}createInstance(u,...h){let v,d;return u instanceof I.SyncDescriptor?(v=f.traceCreation(this.i,u.ctor),d=this.j(u.ctor,u.staticArguments.concat(h),v)):(v=f.traceCreation(this.i,u),d=this.j(u,h,v)),v.stop(),d}j(u,h=[],v){const d=P._util.getServiceDependencies(u).sort((t,r)=>t.index-r.index),D=[];for(const t of d){const r=this.m(t.id,v);r||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${t.id}.`,!1),D.push(r)}const A=d.length>0?d[0].index:h.length;if(h.length!==A){console.trace(`[createInstance] First service dependency of ${u.name} at position ${A+1} conflicts with ${h.length} static arguments`);const t=A-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,A)}return Reflect.construct(u,h.concat(D))}k(u,h){if(this.f.get(u)instanceof I.SyncDescriptor)this.f.set(u,h);else if(this.h)this.h.k(u,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const h=this.f.get(u);return!h&&this.h?this.h.l(u):h}m(u,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const v=this.l(u);return v instanceof I.SyncDescriptor?this.q(u,v,h.branch(u,!0)):(h.branch(u,!1),v)}q(u,h,v){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,h,v)}finally{this.o.delete(u)}}r(u,h,v){const d=new C.Graph(t=>t.id.toString());let D=0;const A=[{id:u,desc:h,_trace:v}];for(;A.length;){const t=A.pop();if(d.lookupOrInsertNode(t),D++>1e3)throw new S(d);for(const r of P._util.getServiceDependencies(t.desc.ctor)){const n=this.l(r.id);if(n||this.u(`[createInstance] ${u} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),n instanceof I.SyncDescriptor){const i={id:r.id,desc:n,_trace:t._trace.branch(r.id,!0)};d.insertEdge(t,i),A.push(i)}}}for(;;){const t=d.roots();if(t.length===0){if(!d.isEmpty())throw new S(d);break}for(const{data:r}of t){if(this.l(r.id)instanceof I.SyncDescriptor){const i=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,i)}d.removeNode(r)}}return this.l(u)}s(u,h,v=[],d,D){if(this.f.get(u)instanceof I.SyncDescriptor)return this.t(u,h,v,d,D);if(this.h)return this.h.s(u,h,v,d,D);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(u,h,v=[],d,D){if(d){const A=new b(void 0,this.g,this,this.i);A.c=String(u);const t=new Map,r=new E.IdleValue(()=>{const n=A.j(h,v,D);for(const[i,o]of t){const c=n[i];if(typeof c=="function")for(const a of o)c.apply(n,a)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,i){if(!r.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let a=t.get(i);return a||(a=new y.LinkedList,t.set(i,a)),(m,R,L)=>{const $=a.push([m,R,L]);return(0,l.toDisposable)($)}}if(i in n)return n[i];const o=r.value;let c=o[i];return typeof c!="function"||(c=c.bind(o),n[i]=c),c},set(n,i,o){return r.value[i]=o,!0},getPrototypeOf(n){return h.prototype}})}else return this.j(h,v,D)}u(u,h){if(h&&console.warn(u),this.g)throw new Error(u)}}e.InstantiationService=b;var g;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(g||(g={}));class f{static traceInvocation(u,h){return u?new f(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(u,h){return u?new f(1,h.name):f.c}constructor(u,h){this.type=u,this.name=h,this.g=Date.now(),this.h=[]}branch(u,h){const v=new f(3,u.toString());return this.h.push([u,h,v]),v}stop(){const u=Date.now()-this.g;f.f+=u;let h=!1;function v(D,A){const t=[],r=new Array(D+1).join("	");for(const[n,i,o]of A.h)if(i&&o){h=!0,t.push(`${r}CREATES -> ${n}`);const c=v(D+1,o);c&&t.push(c)}else t.push(`${r}uses -> ${n}`);return t.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(u>2||h)&&f.all.add(d.join(`
`))}}f.all=new Set,f.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}},f.f=0,e.Trace=f}),define(ve[216],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.ILabelService=void 0,e.ILabelService=(0,E.createDecorator)("labelService");var k;(function(l){l[l.SHORT=0]="SHORT",l[l.MEDIUM=1]="MEDIUM",l[l.LONG=2]="LONG"})(k=e.Verbosity||(e.Verbosity={}))});var Te=this&&this.__param||function(ae,e){return function(E,k){e(E,k,ae)}};define(ve[78],be([1,0,19,2,3,184,32,5]),function(ae,e,E,k,l,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function w(T){return T.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=w,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let y=class extends k.Disposable{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new E.CancellationTokenSource;setTimeout(()=>S.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const f=b.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(u=>u.startsWith("lp-"))).map(p=>{const u=p.properties.localizedLanguages?.[0],h=w(p);return{...this.f(h,u,p),extensionId:p.identifier.id,galleryExtension:p}});return f.push(this.f("en","English")),f}f(S,b,g){const f=b??S;let p;if(f!==S&&(p=`(${S})`),S.toLowerCase()===l.language.toLowerCase()&&(p??="",p+=(0,I.localize)(0,null)),g?.installCount){p??="";const u=g.installCount;let h;u>1e6?h=`${Math.floor(u/1e5)/10}M`:u>1e3?h=`${Math.floor(u/1e3)}K`:h=String(u),p+=` $(cloud-download) ${h}`}return{id:S,label:f,description:p}}};y=Re([Te(0,C.IExtensionGalleryService)],y),e.LanguagePackBaseService=y}),define(ve[12],be([1,0,37,6,2,27,3,8,4,5]),function(ae,e,E,k,l,I,C,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,y.createDecorator)("logService"),e.ILoggerService=(0,y.createDecorator)("loggerService");function T(){return new Date().toISOString()}function S(a){return(0,P.isNumber)(a)}e.isLogLevel=S;var b;(function(a){a[a.Off=0]="Off",a[a.Trace=1]="Trace",a[a.Debug=2]="Debug",a[a.Info=3]="Info",a[a.Warning=4]="Warning",a[a.Error=5]="Error"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function g(a,s,m){switch(s){case b.Trace:a.trace(m);break;case b.Debug:a.debug(m);break;case b.Info:a.info(m);break;case b.Warning:a.warn(m);break;case b.Error:a.error(m);break;case b.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=g;function f(a){let s="";for(let m=0;m<a.length;m++){let R=a[m];if(typeof R=="object")try{R=JSON.stringify(R)}catch{}s+=(m>0?" ":"")+R}return s}e.format=f;class p extends l.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new k.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==b.Off&&this.b<=s}}e.AbstractLogger=p;class u extends p{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...m){this.f(b.Trace)&&this.g(b.Trace,f([s,...m]))}debug(s,...m){this.f(b.Debug)&&this.g(b.Debug,f([s,...m]))}info(s,...m){this.f(b.Info)&&this.g(b.Info,f([s,...m]))}warn(s,...m){this.f(b.Warning)&&this.g(b.Warning,f([s,...m]))}error(s,...m){if(this.f(b.Error))if(s instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=s.stack,this.g(b.Error,f(R))}else this.g(b.Error,f([s,...m]))}flush(){}}e.AbstractMessageLogger=u;class h extends p{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!C.isWindows}trace(s,...m){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,s,...m):console.log(`[main ${T()}]`,s,...m))}debug(s,...m){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,s,...m):console.log(`[main ${T()}]`,s,...m))}info(s,...m){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,s,...m):console.log(`[main ${T()}]`,s,...m))}warn(s,...m){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${T()}]\x1B[0m`,s,...m):console.warn(`[main ${T()}]`,s,...m))}error(s,...m){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${T()}]\x1B[0m`,s,...m):console.error(`[main ${T()}]`,s,...m))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class v extends p{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...m){this.f(b.Trace)&&console.log("%cTRACE","color: #888",s,...m)}debug(s,...m){this.f(b.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...m)}info(s,...m){this.f(b.Info)&&console.log("%c INFO","color: #33f",s,...m)}warn(s,...m){this.f(b.Warning)&&console.log("%c WARN","color: #993",s,...m)}error(s,...m){this.f(b.Error)&&console.log("%c  ERR","color: #f33",s,...m)}dispose(){}flush(){}}e.ConsoleLogger=v;class d extends p{constructor(s,m=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(m)}trace(s,...m){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(s),...m])}debug(s,...m){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(s),...m])}info(s,...m){this.f(b.Info)&&this.g.log(b.Info,[this.h(s),...m])}warn(s,...m){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(s),...m])}error(s,...m){this.f(b.Error)&&this.g.log(b.Error,[this.h(s),...m])}h(s){return typeof s=="string"?s:(0,E.toErrorMessage)(s,this.f(b.Trace))}dispose(){}flush(){}}e.AdapterLogger=d;class D extends p{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const m of this.g)m.setLevel(s);super.setLevel(s)}trace(s,...m){for(const R of this.g)R.trace(s,...m)}debug(s,...m){for(const R of this.g)R.debug(s,...m)}info(s,...m){for(const R of this.g)R.info(s,...m)}warn(s,...m){for(const R of this.g)R.warn(s,...m)}error(s,...m){for(const R of this.g)R.error(s,...m)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogger=D;class A extends l.Disposable{constructor(s,m){if(super(),this.j=s,this.b=new I.ResourceMap,this.c=new I.ResourceMap,this.f=this.B(new k.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new k.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new k.Emitter),this.onDidChangeVisibility=this.h.event,m)for(const R of m)this.c.set(R.resource,R)}getLogger(s){return this.b.get(s)}createLogger(s,m){let R=this.b.get(s);const L=m?.logLevel==="always"?b.Trace:m?.logLevel;return R||(R=this.k(s,L??this.getLogLevel(s)??this.j,m),this.b.set(s,R)),this.registerLogger({resource:s,id:m?.id??s.toString(),logLevel:L,name:m?.name,hidden:m?.hidden,extensionId:m?.extensionId}),R}setLogLevel(s,m){if(w.URI.isUri(s)){const R=s,L=m,$=this.c.get(R);$&&L!==$.logLevel&&($.logLevel=L===this.j?void 0:L,this.b.get(R)?.setLevel(L),this.c.set($.resource,$),this.g.fire([R,L]))}else{this.j=s;for(const[R,L]of this.b.entries())this.c.get(R)?.logLevel===void 0&&L.setLevel(this.j);this.g.fire(this.j)}}setVisibility(s,m){const R=this.c.get(s);R&&m!==!R.hidden&&(R.hidden=!m,this.c.set(R.resource,R),this.h.fire([s,m]))}getLogLevel(s){let m;return s&&(m=this.c.get(s)?.logLevel),m??this.j}registerLogger(s){const m=this.c.get(s.resource);m?m.hidden!==s.hidden&&this.setVisibility(s.resource,!s.hidden):(this.c.set(s.resource,s),this.f.fire({added:[s],removed:[]}))}deregisterLogger(s){const m=this.c.get(s);if(m){this.c.delete(s);const R=this.b.get(s);R&&(this.b.delete(s),R.dispose()),this.f.fire({added:[],removed:[m]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(s){return this.c.get(s)}dispose(){this.b.forEach(s=>s.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=A;class t{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(s){}getLevel(){return b.Info}trace(s,...m){}debug(s,...m){}info(s,...m){}warn(s,...m){}error(s,...m){}critical(s,...m){}dispose(){}flush(){}}e.NullLogger=t;class r extends t{}e.NullLogService=r;class n extends A{constructor(){super(b.Info)}k(s,m,R){return new t}}e.NullLoggerService=n;function i(a){if(a.verbose)return b.Trace;if(typeof a.logLevel=="string"){const s=c(a.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=i;function o(a){switch(a){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.LogLevelToString=o;function c(a){switch(a){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.parseLogLevel=c}),define(ve[217],be([1,0,74,6,2,12,3,14]),function(ae,e,E,k,l,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let w=class qt extends l.Disposable{constructor(T){super(),this.g=T,this.c=this.B(new k.Emitter),this.onDidChangePassword=this.c.event}async getPassword(T,S){this.g.trace("Getting password from keytar:",T,S);let b;try{b=await this.h()}catch{return null}const g=await(0,P.retry)(()=>b.getPassword(T,S),50,3);if(!g)return this.g.trace("Did not get a password from keytar for account:",S),g;let f,p;try{const u=JSON.parse(g);f=u.content,p=u.hasNextChunk}catch{}if(!f||!p)return this.g.trace("Got password from keytar for account:",S),g;try{let u=1;for(;p;){const h=await(0,P.retry)(()=>b.getPassword(T,`${S}-${u}`),50,3),v=JSON.parse(h);f+=v.content,p=v.hasNextChunk,u++}return this.g.trace(`Got ${u}-chunked password from keytar for account:`,S),f}catch(u){return this.g.error(u),g}}async setPassword(T,S,b){this.g.trace("Setting password using keytar:",T,S);let g;try{g=await this.h()}catch(f){throw this.i?.(f),f}if(C.isWindows&&b.length>qt.a){let f=0,p=0,u=!0;for(;u;){const h=b.substring(f,f+qt.b);f+=qt.b,u=b.length-f>0;const v={content:h,hasNextChunk:u};await(0,P.retry)(()=>g.setPassword(T,p?`${S}-${p}`:S,JSON.stringify(v)),50,3),p++}this.g.trace(`Got${p?` ${p}-chunked`:""} password from keytar for account:`,S)}else await(0,P.retry)(()=>g.setPassword(T,S,b),50,3),this.g.trace("Got password from keytar for account:",S);this.c.fire({service:T,account:S})}async deletePassword(T,S){this.g.trace("Deleting password using keytar:",T,S);let b;try{b=await this.h()}catch(h){throw this.i?.(h),h}const g=await b.getPassword(T,S);if(!g)return this.g.trace("Did not get a password to delete from keytar for account:",S),!1;let f,p;try{const h=JSON.parse(g);f=h.content,p=h.hasNextChunk}catch{}let u=0;if(f&&p)try{for(u++;p;){const h=`${S}-${u}`,v=await b.getPassword(T,h);await b.deletePassword(T,h),p=JSON.parse(v).hasNextChunk,u++}}catch(h){this.g.error(h)}return await b.deletePassword(T,S)?(this.c.fire({service:T,account:S}),this.g.trace(`Deleted${u?` ${u}-chunked`:""} password from keytar for account:`,S),!0):(this.g.trace(`Keytar failed to delete${u?` ${u}-chunked`:""} password for account:`,S),!1)}async findPassword(T){let S;try{S=await this.h()}catch{return null}return await S.findPassword(T)}async findCredentials(T){let S;try{S=await this.h()}catch{return[]}return await S.findCredentials(T)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};w.a=2500,w.b=w.a-100,w=Re([Te(0,I.ILogService)],w),e.BaseCredentialsMainService=w}),define(ve[218],be([1,0,12]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let k=class{constructor(I,C){this.a=I,this.b=C}c(){return new Promise((I,C)=>ae(["vscode-encrypt"],I,C))}async encrypt(I){let C;try{C=await this.c()}catch{return I}try{return C.encrypt(this.a,I)}catch(P){return this.b.error(P),I}}async decrypt(I){let C;try{C=await this.c()}catch{return I}try{return C.decrypt(this.a,I)}catch(P){return this.b.error(P),I}}};k=Re([Te(1,E.ILogService)],k),e.EncryptionMainService=k}),define(ve[219],be([1,0,18,14,9,6,2,7,63,12]),function(ae,e,E,k,l,I,C,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class T extends C.Disposable{constructor(b,g){super(),this.a=b,this.b=g,this.c=this.B(new I.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new I.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new k.ThrottledDelayer(0)),this.s=[],this.t=this.B(new k.ThrottledDelayer(0))}watch(b,g){return g.recursive||this.b?.watcher?.forceUniversal?this.l(b,g):this.u(b,g)}l(b,g){const f={path:this.C(b),excludes:g.excludes,includes:g.includes,recursive:g.recursive},p=(0,E.insert)(this.j,f);return this.m(),(0,C.toDisposable)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(b=>(0,l.onUnexpectedError)(b))}n(){this.h||(this.h=this.B(this.p(g=>this.c.fire((0,w.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const b=this.b?.watcher?.recursive?.usePolling;if(b===!0)for(const g of this.j)(0,w.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(b))for(const g of this.j)(0,w.isRecursiveWatchRequest)(g)&&b.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(b,g){const f={path:this.C(b),excludes:g.excludes,includes:g.includes,recursive:!1},p=(0,E.insert)(this.s,f);return this.v(),(0,C.toDisposable)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(b=>(0,l.onUnexpectedError)(b))}w(){return this.r||(this.r=this.B(this.y(b=>this.c.fire((0,w.toFileChanges)(b)),b=>this.z(b),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.r.watch(this.s)}z(b){b.type==="error"&&this.g.fire(b.message),this.a[b.type](b.message)}C(b){return(0,P.normalize)(b.fsPath)}}e.AbstractDiskFileSystemProvider=T}),define(ve[106],be([1,0,18,14,15,19,6,94,55,2,59,13,46,20,44,180,17,104,12,9]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let D=class extends y.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new C.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new C.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new C.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new C.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new C.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new C.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new k.ResourceQueue)}registerProvider(t,r){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${t}`);const n=new y.DisposableStore;return this.h.set(t,r),this.c.fire({added:!0,scheme:t,provider:r}),n.add(r.onDidChangeFile(i=>this.R.fire(new u.FileChangesEvent(i,!this.O(r))))),typeof r.onDidWatchError=="function"&&n.add(r.onDidWatchError(i=>this.S.fire(new Error(i)))),n.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:t}))),(0,y.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:r}),this.h.delete(t),(0,y.dispose)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const r=[];this.f.fire({scheme:t,join(n){r.push(n)}}),!this.h.has(t)&&await k.Promises.settled(r)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,r){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&r)}listCapabilities(){return w.Iterable.map(this.h,([t,r])=>({scheme:t,capabilities:r.capabilities}))}async j(t){if(!(0,g.isAbsolutePath)(t))throw new u.FileOperationError((0,p.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const r=this.h.get(t.scheme);if(!r){const n=new d.ErrorNoTelemetry;throw n.message=(0,p.localize)(1,null,t.toString()),n}return r}async k(t){const r=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(r)||(0,u.hasReadWriteCapability)(r)||(0,u.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const r=await this.j(t);if((0,u.hasOpenReadWriteCloseCapability)(r)||(0,u.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,r){try{return await this.n(t,r)}catch(n){throw(0,u.toFileSystemProviderErrorCode)(n)===u.FileSystemProviderErrorCode.FileNotFound?new u.FileOperationError((0,p.localize)(2,null,this.nb(t)),1):(0,u.ensureFileSystemProviderError)(n)}}async n(t,r){const n=await this.j(t),i=this.O(n),o=r?.resolveTo,c=r?.resolveSingleChildDescendants,a=r?.resolveMetadata,s=await n.stat(t);let m;return this.p(n,t,s,void 0,!!a,(R,L)=>(m||(m=T.TernarySearchTree.forUris(()=>!i),m.set(t,!0),o&&m.fill(!0,o)),m.get(R.resource)||m.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&c?L===1:!1))}async p(t,r,n,i,o,c){const{providerExtUri:a}=this.N(t),s={resource:r,name:a.basename(r),isFile:(n.type&u.FileType.File)!==0,isDirectory:(n.type&u.FileType.Directory)!==0,isSymbolicLink:(n.type&u.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&u.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,u.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(s.isDirectory&&c(s,i)){try{const m=await t.readdir(r),R=await k.Promises.settled(m.map(async([L,$])=>{try{const ie=a.joinPath(r,L),ne=o?await t.stat(ie):{type:$};return await this.p(t,ie,ne,m.length,o,c)}catch(ie){return this.b.trace(ie),null}}));s.children=(0,E.coalesce)(R)}catch(m){this.b.trace(m),s.children=[]}return s}return s}async resolveAll(t){return k.Promises.settled(t.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const r=await this.j(t),n=await r.stat(t);return this.p(r,t,n,void 0,!0,()=>!1)}async exists(t){const r=await this.j(t);try{return!!await r.stat(t)}catch{return!1}}async canCreateFile(t,r){try{await this.r(t,r)}catch(n){return n}return!0}async r(t,r){if(!r?.overwrite&&await this.exists(t))throw new u.FileOperationError((0,p.localize)(3,null,this.nb(t)),3,r)}async createFile(t,r=l.VSBuffer.fromString(""),n){await this.r(t,n);const i=await this.writeFile(t,r);return this.m.fire(new u.FileOperationEvent(t,0,i)),i}async writeFile(t,r,n){const i=this.lb(await this.l(t),t),{providerExtUri:o}=this.N(i);try{await this.s(i,t,n)||await this.P(i,o.dirname(t));let a;if((0,u.hasReadWriteCapability)(i)&&!(r instanceof l.VSBuffer))if((0,f.isReadableStream)(r)){const s=await(0,f.peekStream)(r,3);s.ended?a=l.VSBuffer.concat(s.buffer):a=s}else a=(0,f.peekReadable)(r,s=>l.VSBuffer.concat(s),3);else a=r;!(0,u.hasOpenReadWriteCloseCapability)(i)||(0,u.hasReadWriteCapability)(i)&&a instanceof l.VSBuffer?await this.cb(i,t,n,a):await this.Y(i,t,n,a instanceof l.VSBuffer?(0,l.bufferToReadable)(a):a),this.m.fire(new u.FileOperationEvent(t,4))}catch(c){throw new u.FileOperationError((0,p.localize)(4,null,this.nb(t),(0,u.ensureFileSystemProviderError)(c).toString()),(0,u.toFileOperationResult)(c),n)}return this.resolve(t,{resolveMetadata:!0})}async s(t,r,n){if(!!n?.unlock&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.nb(r)));let o;try{o=await t.stat(r)}catch{return}if((o.type&u.FileType.Directory)!==0)throw new u.FileOperationError((0,p.localize)(6,null,this.nb(r)),0,n);if(this.mb(r,o),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==u.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&n.mtime<o.mtime&&n.etag!==(0,u.etag)({mtime:n.mtime,size:o.size}))throw new u.FileOperationError((0,p.localize)(7,null),3,n);return o}async readFile(t,r,n){const i=await this.k(t);return r?.atomic?this.t(i,t,r,n):this.u(i,t,r,n)}async t(t,r,n,i){return new Promise((o,c)=>{this.X.queueFor(r,this.N(t).providerExtUri).queue(async()=>{try{const a=await this.u(t,r,n,i);o(a)}catch(a){c(a)}})})}async u(t,r,n,i){const o=await this.v(t,r,{...n,preferUnbuffered:!0},i);return{...o,value:await(0,l.streamToBuffer)(o.value)}}async readFileStream(t,r,n){const i=await this.k(t);return this.v(i,t,r,n)}async v(t,r,n,i){const o=new I.CancellationTokenSource(i),c=this.F(r,n).then(s=>s,s=>{throw o.cancel(),s});let a;try{return typeof n?.etag=="string"&&n.etag!==u.ETAG_DISABLED&&await c,n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)||!((0,u.hasOpenReadWriteCloseCapability)(t)||(0,u.hasFileReadStreamCapability)(t))||(0,u.hasReadWriteCapability)(t)&&n?.preferUnbuffered?a=this.D(t,r,n):(0,u.hasFileReadStreamCapability)(t)?a=this.z(t,r,o.token,n):a=this.C(t,r,o.token,n),{...await c,value:a}}catch(s){throw a&&await(0,f.consumeStream)(a),this.w(s,r,n)}}w(t,r,n){const i=(0,p.localize)(8,null,this.nb(r),(0,u.ensureFileSystemProviderError)(t).toString());return t instanceof u.NotModifiedSinceFileOperationError?new u.NotModifiedSinceFileOperationError(i,t.stat,n):t instanceof u.TooLargeFileOperationError?new u.TooLargeFileOperationError(i,t.fileOperationResult,t.size,t.options):new u.FileOperationError(i,(0,u.toFileOperationResult)(t),n)}z(t,r,n,i=Object.create(null)){const o=t.readFileStream(r,i,n);return(0,f.transform)(o,{data:c=>c instanceof l.VSBuffer?c:l.VSBuffer.wrap(c),error:c=>this.w(c,r,i)},c=>l.VSBuffer.concat(c))}C(t,r,n,i=Object.create(null)){const o=(0,l.newWriteableBufferStream)();return(0,h.readFileIntoStream)(t,r,o,c=>c,{...i,bufferSize:this.a,errorTransformer:c=>this.w(c,r,i)},n),o}D(t,r,n){const i=(0,f.newWriteableStream)(o=>l.VSBuffer.concat(o));return(async()=>{try{let o;n?.atomic&&(0,u.hasFileAtomicReadCapability)(t)?o=await t.readFile(r,{atomic:!0}):o=await t.readFile(r),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.G(r,o.byteLength,n),i.end(l.VSBuffer.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async F(t,r){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new u.FileOperationError((0,p.localize)(9,null,this.nb(t)),0,r);if(typeof r?.etag=="string"&&r.etag!==u.ETAG_DISABLED&&r.etag===n.etag)throw new u.NotModifiedSinceFileOperationError((0,p.localize)(10,null),n,r);return this.G(t,n.size,r),n}G(t,r,n){if(n?.limits){let i;if(typeof n.limits.memory=="number"&&r>n.limits.memory&&(i=9),typeof n.limits.size=="number"&&r>n.limits.size&&(i=7),typeof i=="number")throw new u.TooLargeFileOperationError((0,p.localize)(11,null,this.nb(t)),i,r,n)}}async canMove(t,r,n){return this.H(t,r,"move",n)}async canCopy(t,r,n){return this.H(t,r,"copy",n)}async H(t,r,n,i){if(t.toString()!==r.toString())try{const o=n==="move"?this.lb(await this.l(t),t):await this.k(t),c=this.lb(await this.l(r),r);await this.M(o,t,c,r,n,i)}catch(o){return o}return!0}async move(t,r,n){const i=this.lb(await this.l(t),t),o=this.lb(await this.l(r),r),c=await this.I(i,t,o,r,"move",!!n),a=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,c==="move"?2:3,a)),a}async copy(t,r,n){const i=await this.k(t),o=this.lb(await this.l(r),r),c=await this.I(i,t,o,r,"copy",!!n),a=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,c==="copy"?3:2,a)),a}async I(t,r,n,i,o,c){if(r.toString()===i.toString())return o;const{exists:a,isSameResourceWithDifferentPathCase:s}=await this.M(t,r,n,i,o,c);if(a&&!s&&c&&await this.del(i,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(i)),o==="copy"){if(t===n&&(0,u.hasFileFolderCopyCapability)(t))await t.copy(r,i,{overwrite:c});else{const m=await this.resolve(r);m.isDirectory?await this.L(t,m,n,i):await this.J(t,r,n,i)}return o}else return t===n?(await t.rename(r,i,{overwrite:c}),o):(await this.I(t,r,n,i,"copy",c),await this.del(r,{recursive:!0}),"copy")}async J(t,r,n,i){if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.eb(t,r,n,i);if((0,u.hasOpenReadWriteCloseCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.kb(t,r,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasOpenReadWriteCloseCapability)(n))return this.ib(t,r,n,i);if((0,u.hasReadWriteCapability)(t)&&(0,u.hasReadWriteCapability)(n))return this.gb(t,r,n,i)}async L(t,r,n,i){await n.mkdir(i),Array.isArray(r.children)&&await k.Promises.settled(r.children.map(async o=>{const c=this.N(n).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.L(t,await this.resolve(o.resource),n,c):this.J(t,o.resource,n,c)}))}async M(t,r,n,i,o,c){let a=!1;if(t===n){const{providerExtUri:m,isPathCaseSensitive:R}=this.N(t);if(R||(a=m.isEqual(r,i)),a&&o==="copy")throw new Error((0,p.localize)(12,null,this.nb(r),this.nb(i)));if(!a&&m.isEqualOrParent(i,r))throw new Error((0,p.localize)(13,null,this.nb(r),this.nb(i)))}const s=await this.exists(i);if(s&&!a){if(!c)throw new u.FileOperationError((0,p.localize)(14,null,this.nb(r),this.nb(i)),4);if(t===n){const{providerExtUri:m}=this.N(t);if(m.isEqualOrParent(r,i))throw new Error((0,p.localize)(15,null,this.nb(r),this.nb(i)))}}return{exists:s,isSameResourceWithDifferentPathCase:a}}N(t){const r=this.O(t);return{providerExtUri:r?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:r}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const r=this.lb(await this.j(t),t);await this.P(r,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new u.FileOperationEvent(t,0,n)),n}async P(t,r){const n=[],{providerExtUri:i}=this.N(t);for(;!i.isEqual(r,i.dirname(r));)try{if(((await t.stat(r)).type&u.FileType.Directory)===0)throw new Error((0,p.localize)(16,null,this.nb(r)));break}catch(o){if((0,u.toFileSystemProviderErrorCode)(o)!==u.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(i.basename(r)),r=i.dirname(r)}for(let o=n.length-1;o>=0;o--){r=i.joinPath(r,n[o]);try{await t.mkdir(r)}catch(c){if((0,u.toFileSystemProviderErrorCode)(c)!==u.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(t,r){try{await this.Q(t,r)}catch(n){return n}return!0}async Q(t,r){const n=this.lb(await this.j(t),t);if(!!r?.useTrash&&!(n.capabilities&4096))throw new Error((0,p.localize)(17,null,this.nb(t)));let o;try{o=await n.stat(t)}catch{}if(o)this.mb(t,o);else throw new u.FileOperationError((0,p.localize)(18,null,this.nb(t)),1);if(!!!r?.recursive){const a=await this.resolve(t);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,p.localize)(19,null,this.nb(t)))}return n}async del(t,r){const n=await this.Q(t,r),i=!!r?.useTrash,o=!!r?.recursive;await n.delete(t,{recursive:o,useTrash:i}),this.m.fire(new u.FileOperationEvent(t,1))}async cloneFile(t,r){const n=await this.j(t),i=this.lb(await this.l(r),r);if(n===i&&this.N(n).providerExtUri.isEqual(t,r))return;if(n===i&&(0,u.hasFileCloneCapability)(n))return n.cloneFile(t,r);await this.P(i,this.N(i).providerExtUri.dirname(r));const o=this.X.queueFor(t,this.N(n).providerExtUri);return n===i&&(0,u.hasFileFolderCopyCapability)(n)?o.queue(()=>n.copy(t,r,{overwrite:!0})):o.queue(()=>this.J(n,t,i,r))}watch(t,r={recursive:!1,excludes:[]}){const n=new y.DisposableStore;let i=!1,o=()=>{i=!0};return n.add((0,y.toDisposable)(()=>o())),(async()=>{try{const c=await this.W(t,r);i?(0,y.dispose)(c):o=()=>(0,y.dispose)(c)}catch(c){this.b.error(c)}})(),n}async W(t,r){const n=await this.j(t),i=(0,P.hash)([this.N(n).providerExtUri.getComparisonKey(t),r]);let o=this.U.get(i);return o||(o={count:0,disposable:n.watch(t,r)},this.U.set(i,o)),o.count+=1,(0,y.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,y.dispose)(o.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,y.dispose)(t.disposable);this.U.clear()}async Y(t,r,n,i){return this.X.queueFor(r,this.N(t).providerExtUri).queue(async()=>{const o=await t.open(r,{create:!0,unlock:n?.unlock??!1});try{(0,f.isReadableStream)(i)||(0,f.isReadableBufferedStream)(i)?await this.Z(t,o,i):await this.ab(t,o,i)}catch(c){throw(0,u.ensureFileSystemProviderError)(c)}finally{await t.close(o)}})}async Z(t,r,n){let i=0,o;if((0,f.isReadableBufferedStream)(n)){if(n.buffer.length>0){const c=l.VSBuffer.concat(n.buffer);await this.bb(t,r,c,c.byteLength,i,0),i+=c.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((c,a)=>{(0,f.listenStream)(o,{onData:async s=>{o.pause();try{await this.bb(t,r,s,s.byteLength,i,0)}catch(m){return a(m)}i+=s.byteLength,setTimeout(()=>o.resume())},onError:s=>a(s),onEnd:()=>c()})})}async ab(t,r,n){let i=0,o;for(;(o=n.read())!==null;)await this.bb(t,r,o,o.byteLength,i,0),i+=o.byteLength}async bb(t,r,n,i,o,c){let a=0;for(;a<i;)a+=await t.write(r,o+a,n.buffer,c+a,i-a)}async cb(t,r,n,i){return this.X.queueFor(r,this.N(t).providerExtUri).queue(()=>this.db(t,r,n,i))}async db(t,r,n,i){let o;i instanceof l.VSBuffer?o=i:(0,f.isReadableStream)(i)?o=await(0,l.streamToBuffer)(i):(0,f.isReadableBufferedStream)(i)?o=await(0,l.bufferedStreamToBuffer)(i):o=(0,l.readableToBuffer)(i),await t.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async eb(t,r,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.fb(t,r,n,i))}async fb(t,r,n,i){let o,c;try{o=await t.open(r,{create:!1}),c=await n.open(i,{create:!0,unlock:!1});const a=l.VSBuffer.alloc(this.a);let s=0,m=0,R=0;do R=await t.read(o,s,a.buffer,m,a.byteLength-m),await this.bb(n,c,a,R,s,m),s+=R,m+=R,m===a.byteLength&&(m=0);while(R>0)}catch(a){throw(0,u.ensureFileSystemProviderError)(a)}finally{await k.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof c=="number"?n.close(c):Promise.resolve()])}}async gb(t,r,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.hb(t,r,n,i))}async hb(t,r,n,i){return n.writeFile(i,await t.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async ib(t,r,n,i){return this.X.queueFor(i,this.N(n).providerExtUri).queue(()=>this.jb(t,r,n,i))}async jb(t,r,n,i){const o=await n.open(i,{create:!0,unlock:!1});try{const c=await t.readFile(r);await this.bb(n,o,l.VSBuffer.wrap(c),c.byteLength,0,0)}catch(c){throw(0,u.ensureFileSystemProviderError)(c)}finally{await n.close(o)}}async kb(t,r,n,i){const o=await(0,l.streamToBuffer)(this.C(t,r,I.CancellationToken.None));await this.cb(n,i,void 0,o)}lb(t,r){if(t.capabilities&2048)throw new u.FileOperationError((0,p.localize)(20,null,this.nb(r)),6);return t}mb(t,r){if((r.permissions??0)&u.FilePermission.Readonly)throw new u.FileOperationError((0,p.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===S.Schemas.file?t.fsPath:t.toString(!0)}};D=Re([Te(0,v.ILogService)],D),e.FileService=D}),define(ve[64],be([1,0,30,282,14,27,15,6,38,2,7,3,20,44,21,183,17,104,219,37,215,214]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v,d,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,k.gracefulify)(E)}catch(r){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(r)}`)}})();class t extends v.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i),this.onDidChangeCapabilities=P.Event.None,this.H=new I.ResourceMap(o=>b.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,S.isLinux&&(this.F|=1024)),this.F}async stat(n){try{const{stat:i,symbolicLink:o}=await f.SymlinkSupport.stat(this.C(n));return{type:this.G(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.Y(i)}}async readdir(n){try{const i=await f.Promises.readdir(this.C(n),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,b.joinPath)(n,c.name))).type:a=this.G(c),o.push([c.name,a])}catch(a){this.a.trace(a)}})),o}catch(i){throw this.Y(i)}}G(n,i){let o;return i?.dangling?o=u.FileType.Unknown:n.isFile()?o=u.FileType.File:n.isDirectory()?o=u.FileType.Directory:o=u.FileType.Unknown,i&&(o|=u.FileType.SymbolicLink),o}async I(n){const i=this.C(n);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.H.get(n);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const c=new l.Barrier;return this.H.set(n,c),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,y.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.H.get(n)===c&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.H.delete(n)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),c.open()})}async readFile(n,i){let o;try{i?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),o=await this.I(n));const c=this.C(n);return await f.Promises.readFile(c)}catch(c){throw this.Y(c)}finally{o?.dispose()}}J(n){t.D&&this.a.trace(n)}readFileStream(n,i,o){const c=(0,g.newWriteableStream)(a=>C.VSBuffer.concat(a.map(s=>C.VSBuffer.wrap(s))).buffer);return(0,h.readFileIntoStream)(this,n,c,a=>a.buffer,{...i,bufferSize:256*1024},o),c}async writeFile(n,i,o){let c;try{const a=this.C(n);if(!o.create||!o.overwrite){if(await f.Promises.exists(a)){if(!o.overwrite)throw(0,u.createFileSystemProviderError)((0,p.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,u.createFileSystemProviderError)((0,p.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(n,{create:!0,unlock:o.unlock}),await this.write(c,0,i,0,i.byteLength)}catch(a){throw await this.Z(n,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(n){t.O=n}async open(n,i){const o=this.C(n);let c;(0,u.isFileOpenForWriteOptions)(i)&&(c=await this.I(n));let a;try{if((0,u.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:m}=await f.SymlinkSupport.stat(o);m.mode&128||await f.Promises.chmod(o,m.mode|128)}catch(m){this.a.trace(m)}let s;if((0,u.isFileOpenForWriteOptions)(i)){if(S.isWindows)try{await f.Promises.truncate(o,0),s="r+"}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}s||(s="w")}else s="r";a=await f.Promises.open(o,s)}catch(s){throw c?.dispose(),(0,u.isFileOpenForWriteOptions)(i)?await this.Z(n,s):this.Y(s)}if(this.L.set(a,0),(0,u.isFileOpenForWriteOptions)(i)&&this.N.set(a,n),c){const s=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.M.set(a,c),s&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),s.dispose())}return a}async close(n){const i=this.M.get(n);try{if(this.L.delete(n),this.N.delete(n)&&t.O)try{await f.Promises.fdatasync(n)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await f.Promises.close(n)}catch(o){throw this.Y(o)}finally{i&&(this.M.get(n)===i&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.M.delete(n)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,o,c,a){const s=this.P(n,i);let m=null;try{m=(await f.Promises.read(n,o,c,a,s)).bytesRead}catch(R){throw this.Y(R)}finally{this.Q(n,s,m)}return m}P(n,i){return i===this.L.get(n)?null:i}Q(n,i,o){const c=this.L.get(n);typeof c=="number"&&(typeof i=="number"||(typeof o=="number"?this.L.set(n,c+o):this.L.delete(n)))}async write(n,i,o,c,a){return(0,l.retry)(()=>this.R(n,i,o,c,a),100,3)}async R(n,i,o,c,a){const s=this.P(n,i);let m=null;try{m=(await f.Promises.write(n,o,c,a,s)).bytesWritten}catch(R){throw await this.Z(this.N.get(n),R)}finally{this.Q(n,s,m)}return m}async mkdir(n){try{await f.Promises.mkdir(this.C(n))}catch(i){throw this.Y(i)}}async delete(n,i){try{const o=this.C(n);i.recursive?await f.Promises.rm(o,f.RimRafMode.MOVE):await f.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(n,i,o){const c=this.C(n),a=this.C(i);if(c!==a)try{await this.S(n,i,"move",o.overwrite),await f.Promises.move(c,a)}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,p.localize)(2,null,(0,T.basename)(c),(0,T.basename)((0,T.dirname)(a)),s.toString()))),this.Y(s)}}async copy(n,i,o){const c=this.C(n),a=this.C(i);if(c!==a)try{await this.S(n,i,"copy",o.overwrite),await f.Promises.copy(c,a,{preserveSymlinks:!0})}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,p.localize)(3,null,(0,T.basename)(c),(0,T.basename)((0,T.dirname)(a)),s.toString()))),this.Y(s)}}async S(n,i,o,c){const a=this.C(n),s=this.C(i);let m=!1;if(!!(this.capabilities&1024)||(m=(0,w.isEqual)(a,s,!0)),m&&o==="copy")throw(0,u.createFileSystemProviderError)((0,p.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!m&&await f.Promises.exists(s)){if(!c)throw(0,u.createFileSystemProviderError)((0,p.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(n,i){return this.U(n,i,!1)}async U(n,i,o){const c=this.C(n),a=this.C(i),s=!!(this.capabilities&1024);if((0,w.isEqual)(c,a,!s))return;const m=new y.DisposableStore;try{const[R,L]=await Promise.all([this.I(n),this.I(i)]);m.add(R),m.add(L),o&&await f.Promises.mkdir((0,T.dirname)(a),{recursive:!0}),await f.Promises.copyFile(c,a)}catch(R){if(R.code==="ENOENT"&&!o)return this.U(n,i,!0);throw this.Y(R)}finally{m.dispose()}}p(n,i,o){return new D.UniversalWatcherClient(c=>n(c),c=>i(c),o)}y(n,i,o){return new A.NodeJSWatcherClient(c=>n(c),c=>i(c),o)}Y(n){if(n instanceof u.FileSystemProviderError)return n;let i;switch(n.code){case"ENOENT":i=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=u.FileSystemProviderErrorCode.NoPermissions;break;default:i=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(n,i)}async Z(n,i){let o=this.Y(i);if(n&&o.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await f.SymlinkSupport.stat(this.C(n));c.mode&128||(o=(0,u.createFileSystemProviderError)(i,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.a.trace(c)}return o}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(ve[220],be([1,0,6,64,2,15,44,19]),function(ae,e,E,k,l,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class w extends l.Disposable{constructor(S,b){super(),this.a=S,this.b=b,this.w=new Map,this.y=new Map}call(S,b,g){const f=this.c(S);switch(b){case"stat":return this.g(f,g[0]);case"readdir":return this.h(f,g[0]);case"open":return this.l(f,g[0],g[1]);case"close":return this.m(g[0]);case"read":return this.n(g[0],g[1],g[2]);case"readFile":return this.i(f,g[0],g[1]);case"write":return this.p(g[0],g[1],g[2],g[3],g[4]);case"writeFile":return this.k(f,g[0],g[1],g[2]);case"rename":return this.t(f,g[0],g[1],g[2]);case"copy":return this.u(f,g[0],g[1],g[2]);case"cloneFile":return this.v(f,g[0],g[1]);case"mkdir":return this.r(f,g[0]);case"delete":return this.s(f,g[0],g[1]);case"watch":return this.C(f,g[0],g[1],g[2],g[3]);case"unwatch":return this.D(g[0],g[1])}throw new Error(`IPC Command ${b} not found`)}listen(S,b,g){const f=this.c(S);switch(b){case"fileChange":return this.z(f,g[0]);case"readFileStream":return this.j(f,g[0],g[1])}throw new Error(`Unknown event ${b}`)}g(S,b){const g=this.f(S,b,!0);return this.a.stat(g)}h(S,b){const g=this.f(S,b);return this.a.readdir(g)}async i(S,b,g){const f=this.f(S,b,!0),p=await this.a.readFile(f,g);return I.VSBuffer.wrap(p)}j(S,b,g){const f=this.f(S,b,!0),p=new P.CancellationTokenSource,u=new E.Emitter({onDidRemoveLastListener:()=>{p.cancel()}}),h=this.a.readFileStream(f,g,p.token);return(0,C.listenStream)(h,{onData:v=>u.fire(I.VSBuffer.wrap(v)),onError:v=>u.fire(v),onEnd:()=>{u.fire("end"),u.dispose(),p.dispose()}}),u.event}k(S,b,g,f){const p=this.f(S,b);return this.a.writeFile(p,g.buffer,f)}l(S,b,g){const f=this.f(S,b,!0);return this.a.open(f,g)}m(S){return this.a.close(S)}async n(S,b,g){const f=I.VSBuffer.alloc(g),p=0,u=await this.a.read(S,b,f.buffer,p,g);return[f,u]}p(S,b,g,f,p){return this.a.write(S,b,g.buffer,f,p)}r(S,b){const g=this.f(S,b);return this.a.mkdir(g)}s(S,b,g){const f=this.f(S,b);return this.a.delete(f,g)}t(S,b,g,f){const p=this.f(S,b),u=this.f(S,g);return this.a.rename(p,u,f)}u(S,b,g,f){const p=this.f(S,b),u=this.f(S,g);return this.a.copy(p,u,f)}v(S,b,g){const f=this.f(S,b),p=this.f(S,g);return this.a.cloneFile(f,p)}z(S,b){const g=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(b,this.F(S,g))},onDidRemoveLastListener:()=>{(0,l.dispose)(this.w.get(b)),this.w.delete(b)}});return g.event}async C(S,b,g,f,p){const u=this.w.get(b);if(u){const h=this.f(S,f),v=u.watch(g,h,p);this.y.set(b+g,v)}}async D(S,b){const g=S+b,f=this.y.get(g);f&&((0,l.dispose)(f),this.y.delete(g))}dispose(){super.dispose();for(const[,S]of this.y)S.dispose();this.y.clear();for(const[,S]of this.w)S.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=w;class y extends l.Disposable{constructor(S,b,g,f){super(),this.c=S,this.f=g,this.g=f,this.a=new Map,this.b=this.B(new k.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(b)}h(S){const b=this.B(new E.Emitter);this.B(b.event(g=>{S.fire(g.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type})))})),this.B(this.b.onDidChangeFile(g=>b.fire(g))),this.B(this.b.onDidWatchError(g=>S.fire(g)))}i(S){}j(S){}watch(S,b,g){const f=this.j(this.g);return Array.isArray(f)&&(g.excludes=[...g.excludes,...f]),this.a.set(S,this.b.watch(b,g)),(0,l.toDisposable)(()=>{(0,l.dispose)(this.a.get(S)),this.a.delete(S)})}dispose(){super.dispose();for(const[,S]of this.a)S.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=y}),define(ve[107],be([1,0,4,6,12,2]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class C extends l.AbstractLoggerService{constructor(S,b,g,f){super(b,g),this.l=S,this.m=f,this.B(f.listen("onDidChangeLogLevel",S)(p=>{(0,l.isLogLevel)(p)?super.setLogLevel(p):super.setLogLevel(E.URI.revive(p[0]),p[1])})),this.B(f.listen("onDidChangeVisibility",S)(([p,u])=>super.setVisibility(E.URI.revive(p),u))),this.B(f.listen("onDidChangeLoggers",S)(({added:p,removed:u})=>{for(const h of p)super.registerLogger({...h,resource:E.URI.revive(h.resource)});for(const h of u)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new l.AdapterLogger({log:(S,b)=>{this.m.call("consoleLog",[S,b])}})}registerLogger(S){super.registerLogger(S),this.m.call("registerLogger",[S,this.l])}deregisterLogger(S){super.deregisterLogger(S),this.m.call("deregisterLogger",[S,this.l])}setLogLevel(S,b){super.setLogLevel(S,b),this.m.call("setLogLevel",[S,b])}setVisibility(S,b){super.setVisibility(S,b),this.m.call("setVisibility",[S,b])}k(S,b,g){return new P(this.m,S,b,g,this.l)}static setLogLevel(S,b,g){return S.call("setLogLevel",[b,g])}}e.LoggerChannelClient=C;class P extends l.AbstractMessageLogger{constructor(S,b,g,f,p){super(f?.logLevel==="always"),this.m=S,this.n=b,this.k=!1,this.l=[],this.setLevel(g),this.m.call("createLogger",[b,f,p]).then(()=>{this.r(this.l),this.k=!0})}g(S,b){const g=[[S,b]];this.k?this.r(g):this.l.push(...g)}r(S){this.m.call("log",[this.n,S])}}class w{constructor(S,b){this.a=S,this.b=b}listen(S,b){const g=this.b(S);switch(b){case"onDidChangeLoggers":return k.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(p=>this.c(p,g)),removed:[...f.removed].map(p=>this.c(p,g))}));case"onDidChangeVisibility":return k.Event.map(this.a.onDidChangeVisibility,f=>[g.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return k.Event.map(this.a.onDidChangeLogLevel,f=>(0,l.isLogLevel)(f)?f:[g.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${b}`)}async call(S,b,g){const f=this.b(S);switch(b){case"setLogLevel":return(0,l.isLogLevel)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(E.URI.revive(f.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,f)))}throw new Error(`Call not found: ${b}`)}c(S,b){return{...S,resource:b.transformOutgoingURI(S.resource)}}}e.LoggerChannel=w;class y extends I.Disposable{constructor(S,b){super(),b.call("setLogLevel",[S.getLogLevel()]),this.B(S.onDidChangeLogLevel(g=>b.call("setLogLevel",[g]))),b.call("getRegisteredLoggers").then(g=>{for(const f of g)S.registerLogger({...f,resource:E.URI.revive(f.resource)})}),this.B(b.listen("onDidChangeVisibility")(([g,f])=>S.setVisibility(E.URI.revive(g),f))),this.B(b.listen("onDidChangeLoggers")(({added:g,removed:f})=>{for(const p of g)S.registerLogger({...p,resource:E.URI.revive(p.resource)});for(const p of f)S.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=y}),define(ve[108],be([1,0,2,12]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends E.Disposable{constructor(C,P=[]){super(),this.a=new k.MultiplexLogger([C,...P]),this.B(C.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(C){this.a.setLevel(C)}getLevel(){return this.a.getLevel()}trace(C,...P){this.a.trace(C,...P)}debug(C,...P){this.a.debug(C,...P)}info(C,...P){this.a.info(C,...P)}warn(C,...P){this.a.warn(C,...P)}error(C,...P){this.a.error(C,...P)}flush(){this.a.flush()}}e.LogService=l}),define(ve[109],be([1,0,17,12]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var l;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(l||(l={}));async function I(y,T,S,b,g){try{const f=await new Promise((u,h)=>{ae(["spdlog"],u,h)});f.setFlushOn(l.Trace);const p=await f.createAsyncRotatingLogger(y,T,S,b);return g?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(f){console.error(f)}return null}function C(y,T,S){switch(T){case k.LogLevel.Trace:y.trace(S);break;case k.LogLevel.Debug:y.debug(S);break;case k.LogLevel.Info:y.info(S);break;case k.LogLevel.Warning:y.warn(S);break;case k.LogLevel.Error:y.error(S);break;case k.LogLevel.Off:break;default:throw new Error(`Invalid log level ${T}`)}}function P(y,T){switch(T){case k.LogLevel.Trace:y.setLevel(l.Trace);break;case k.LogLevel.Debug:y.setLevel(l.Debug);break;case k.LogLevel.Info:y.setLevel(l.Info);break;case k.LogLevel.Warning:y.setLevel(l.Warning);break;case k.LogLevel.Error:y.setLevel(l.Error);break;case k.LogLevel.Off:y.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${T}`)}}class w extends k.AbstractMessageLogger{constructor(T,S,b,g,f){super(),this.k=[],this.setLevel(f),this.l=this.n(T,S,b,g),this.B(this.onDidChangeLogLevel(p=>{this.m&&P(this.m,p)}))}async n(T,S,b,g){const f=b?6:1,p=30/f*E.ByteSize.MB,u=await I(T,S,p,f,g);if(u){this.m=u,P(this.m,this.getLevel());for(const{level:h,message:v}of this.k)C(this.m,h,v);this.k=[]}}g(T,S){this.m?C(this.m,T,S):this.getLevel()<=T&&this.k.push({level:T,message:S})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=w}),define(ve[221],be([1,0,22,12,109]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class I extends k.AbstractLoggerService{k(P,w,y){return new l.SpdLogLogger((0,E.generateUuid)(),P.fsPath,!y?.donotRotate,!!y?.donotUseFormatters,w)}}e.LoggerService=I}),define(ve[222],be([1,0,58,185,5]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function(w){w[w.Unnecessary=1]="Unnecessary",w[w.Deprecated=2]="Deprecated"})(I=e.MarkerTag||(e.MarkerTag={}));var C;(function(w){w[w.Hint=1]="Hint",w[w.Info=2]="Info",w[w.Warning=4]="Warning",w[w.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(w){function y(f,p){return p-f}w.compare=y;const T=Object.create(null);T[w.Error]=(0,k.localize)(0,null),T[w.Warning]=(0,k.localize)(1,null),T[w.Info]=(0,k.localize)(2,null);function S(f){return T[f]||""}w.toString=S;function b(f){switch(f){case E.default.Error:return w.Error;case E.default.Warning:return w.Warning;case E.default.Info:return w.Info;case E.default.Ignore:return w.Hint}}w.fromSeverity=b;function g(f){switch(f){case w.Error:return E.default.Error;case w.Warning:return E.default.Warning;case w.Info:return E.default.Info;case w.Hint:return E.default.Ignore}}w.toSeverity=g}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(w){const y="";function T(b){return S(b,!0)}w.makeKey=T;function S(b,g){const f=[y];return b.source?f.push(b.source.replace("\xA6","\\\xA6")):f.push(y),b.code?typeof b.code=="string"?f.push(b.code.replace("\xA6","\\\xA6")):f.push(b.code.value.replace("\xA6","\\\xA6")):f.push(y),b.severity!==void 0&&b.severity!==null?f.push(C.toString(b.severity)):f.push(y),b.message&&g?f.push(b.message.replace("\xA6","\\\xA6")):f.push(y),b.startLineNumber!==void 0&&b.startLineNumber!==null?f.push(b.startLineNumber.toString()):f.push(y),b.startColumn!==void 0&&b.startColumn!==null?f.push(b.startColumn.toString()):f.push(y),b.endLineNumber!==void 0&&b.endLineNumber!==null?f.push(b.endLineNumber.toString()):f.push(y),b.endColumn!==void 0&&b.endColumn!==null?f.push(b.endColumn.toString()):f.push(y),f.push(y),f.join("\xA6")}w.makeKeyOptionalMessage=S})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,l.createDecorator)("markerService")}),define(ve[65],be([1,0,6,55,2,5]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,I.createDecorator)("policy");class C extends l.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(y){const T=Object.keys(this.f).length;return this.f={...y,...this.f},T!==Object.keys(this.f).length&&await this.i(y),k.Iterable.reduce(this.g.entries(),(S,[b,g])=>({...S,[b]:g}),{})}getPolicyValue(y){return this.g.get(y)}serialize(){return k.Iterable.reduce(Object.entries(this.f),(y,[T,S])=>({...y,[T]:{definition:S,value:this.g.get(T)}}),{})}}e.AbstractPolicyService=C;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(ve[51],be([1,0,3,28]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const I=E.globals.vscode.context.configuration();if(I)l=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,k.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:I.version})}}else l={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","ms-edgedevtools.vscode-edge-devtools":"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","xdebug.php-debug":"{**/*.php,**/php.ini}","rust-lang.rust-analyzer":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","stylelint.vscode-stylelint":"{**/.stylelintrc,**/stylelint.config.js}","ms-mssql.mssql":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","vue.volar":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}","ms-vscode.vscode-github-issue-notebooks":"{**/*.github-issues}","REditorSupport.r":"**/*.r","betterthantomorrow.calva":"{**/*.clj,**/*.cljs}","Pivotal.vscode-boot-dev-pack":"{**/application.properties}","GitHub.copilot":"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools-extension-pack":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"vue.volar":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.makefile-tools":{name:"Makefile Tools",languages:["makefile"],pattern:"{**/makefile,**/Makefile}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"ms-azure-devops.azure-pipelines":{name:"Azure Pipelines",pattern:"{**/azure-pipelines.yaml}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Dev Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"},"ms-vscode.vscode-github-issue-notebooks":{name:"GitHub Issue Notebooks",pattern:"{**/*.github-issues}"},"ms-playwright.playwright":{name:"Playwright",pattern:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}"},"vscjava.vscode-gradle":{name:"Gradle for Java",pattern:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}"},"REditorSupport.r":{name:"R",languages:["r"],pattern:"{**/*.r}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","rebornix.ruby","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver","testContinuousRun"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["quickPickSortByLabel","testObserver"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"GitHub.vscode-pull-request-github":["contribCommentThreadAdditionalMenu","tokenInformation","commentsResolvedState","contribShareMenu","contribCommentPeekContext","treeItemCheckbox","codiconDecoration","diffCommand","contribCommentEditorActionsMenu","quickDiffProvider"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookControllerKind","notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev"],trustedExtensionAuthAccess:["vscode.git","vscode.github","ms-vscode.remote-repositories","github.remotehub","ms-vscode.azure-repos","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","ms-vsliveshare.vsliveshare"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]}}},builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.75.1",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.18",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.75.1",commit:"441438abd1ac652551dbe4d408dfcec8a499b8bf",date:"2023-02-08T21:11:50.046Z"},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(ve[26],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ve[223],be([1,0,74,12,25,26,217]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let P=class extends C.BaseCredentialsMainService{constructor(y,T,S){super(y),this.k=T,this.l=S}async getSecretStoragePrefix(){return Promise.resolve(`${this.l.urlProtocol}-server`)}async h(){if(this.f)return this.f;if(this.k.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;try{this.f=await new Promise((y,T)=>{ae(["keytar"],y,T)}),await this.f.findCredentials("test-keytar-loads")}catch(y){this.g.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${y.message??y}`),this.f=new E.InMemoryCredentialsProvider}return this.f}};P=Re([Te(0,k.ILogService),Te(1,l.INativeEnvironmentService),Te(2,I.IProductService)],P),e.CredentialsWebMainService=P}),define(ve[39],be([1,0,86,8]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(C,P){E.ok(k.isString(C)),E.ok(k.isObject(P)),E.ok(!this.a.has(C),"There is already an extension with this id"),this.a.set(C,P)}knows(C){return this.a.has(C)}as(C){return this.a.get(C)||null}}e.Registry=new l}),define(ve[224],be([1,0,6,39]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class I{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(w,y){this.a[l(w)]=y,this.b.fire(w)}notifySchemaChanged(w){this.b.fire(w)}getSchemaContributions(){return{schemas:this.a}}}const C=new I;k.Registry.add(e.Extensions.JSONContribution,C)}),define(ve[52],be([1,0,18,6,8,169,24,224,39]),function(ae,e,E,k,l,I,C,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var y;(function(A){A.Multiline="multilineText",A.Singleline="singlelineText"})(y=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var T;(function(A){A[A.APPLICATION=1]="APPLICATION",A[A.MACHINE=2]="MACHINE",A[A.WINDOW=3]="WINDOW",A[A.RESOURCE=4]="RESOURCE",A[A.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",A[A.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=w.Registry.as(P.Extensions.JSONContribution);class b{constructor(){this.h=new Set,this.i=new k.Emitter,this.onDidSchemaChange=this.i.event,this.j=new k.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const n=new Set;this.n(t,r,n),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const r=new Set;this.o(t,r),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const n=new Set;this.o(r,n),this.n(t,!1,n),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const n=[];for(const{overrides:i,source:o}of t)for(const c in i)if(r.add(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.a.get(c),s=a?.valuesSources??new Map;if(o)for(const $ of Object.keys(i[c]))s.set($,o);const m={...a?.value||{},...i[c]};this.a.set(c,{source:o,value:m,valuesSources:s});const R=(0,C.getLanguageTagSettingPlainKey)(c),L={type:"object",default:m,description:I.localize(1,null,R),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:l.isString(o)?void 0:o,defaultValueSource:o};n.push(...p(c)),this.d[c]=L,this.b.properties[c]=L}else{this.a.set(c,{value:i[c],source:o});const a=this.d[c];a&&(this.w(c,a),this.r(c,a))}this.m(n)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:n,source:i}of t)for(const o in n){const c=this.a.get(o),a=l.isString(i)?i:i?.id,s=l.isString(c?.source)?c?.source:c?.source?.id;if(a===s)if(r.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const m=this.d[o];m&&(this.w(o,m),this.r(o,m))}}this.u()}deltaConfiguration(t){let r=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,n){t.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,n),this.c.push(i),this.q(i)})}o(t,r){const n=i=>{if(i.properties)for(const o in i.properties){r.add(o);const c=this.d[o];c?.policy?.name&&this.e.delete(c.policy.name),delete this.d[o],this.s(o,i.properties[o])}i.allOf?.forEach(o=>n(o))};for(const i of t){n(i);const o=this.c.indexOf(i);o!==-1&&this.c.splice(o,1)}}p(t,r=!0,n,i,o=3,c){o=l.isUndefinedOrNull(t.scope)?o:t.scope;const a=t.properties;if(a)for(const m in a){const R=a[m];if(r&&d(m,R)){delete a[m];continue}if(R.source=n,R.defaultDefaultValue=a[m].default,this.w(m,R),e.OVERRIDE_PROPERTY_REGEX.test(m)?R.scope=void 0:(R.scope=l.isUndefinedOrNull(R.scope)?o:R.scope,R.restricted=l.isUndefinedOrNull(R.restricted)?!!i?.includes(m):R.restricted),a[m].hasOwnProperty("included")&&!a[m].included){this.f[m]=a[m],delete a[m];continue}else this.d[m]=a[m],a[m].policy?.name&&this.e.set(a[m].policy.name,m);!a[m].deprecationMessage&&a[m].markdownDeprecationMessage&&(a[m].deprecationMessage=a[m].markdownDeprecationMessage),c.add(m)}const s=t.allOf;if(s)for(const m of s)this.p(m,r,n,i,o,c)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=n=>{const i=n.properties;if(i)for(const c in i)this.r(c,i[c]);n.allOf?.forEach(r)};r(t)}r(t,r){switch(e.allSettings.properties[t]=r,r.scope){case 1:e.applicationSettings.properties[t]=r;break;case 2:e.machineSettings.properties[t]=r;break;case 6:e.machineOverridableSettings.properties[t]=r;break;case 3:e.windowSettings.properties[t]=r;break;case 4:e.resourceSettings.properties[t]=r;break;case 5:e.resourceSettings.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.allSettings.properties[t],r.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,n={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,n),e.allSettings.properties[r]=n,e.applicationSettings.properties[r]=n,e.machineSettings.properties[r]=n,e.machineOverridableSettings.properties[r]=n,e.windowSettings.properties[r]=n,e.resourceSettings.properties[r]=n}}v(){const t={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,r){const n=this.a.get(t);let i=n?.value,o=n?.source;l.isUndefined(i)&&(i=r.defaultDefaultValue,o=void 0),l.isUndefined(i)&&(i=h(r.type)),r.default=i,r.defaultValueSource=o}}const g="\\[([^\\]]+)\\]",f=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(A){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(A)){let r=f.exec(A);for(;r?.length;){const n=r[1].trim();n&&t.push(n),r=f.exec(A)}}return(0,E.distinct)(t)}e.overrideIdentifiersFromKey=p;function u(A){return A.reduce((t,r)=>`${t}[${r}]`,"")}e.keyFromOverrideIdentifiers=u;function h(A){switch(Array.isArray(A)?A[0]:A){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const v=new b;w.Registry.add(e.Extensions.Configuration,v);function d(A,t){return A.trim()?e.OVERRIDE_PROPERTY_REGEX.test(A)?I.localize(7,null,A):v.getConfigurationProperties()[A]!==void 0?I.localize(8,null,A):t.policy?.name&&v.getPolicyConfigurations().get(t.policy?.name)!==void 0?I.localize(9,null,A,t.policy?.name,v.getPolicyConfigurations().get(t.policy?.name)):null:I.localize(6,null)}e.validateProperty=d;function D(){const A=[],t=v.getConfigurationProperties();for(const r of Object.keys(t))A.push([r,t[r].scope]);return A.push(["launch",4]),A.push(["task",4]),A}e.getScopes=D}),define(ve[110],be([1,0,18,6,70,2,27,23,8,4,24,52,39]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function g(r){return Object.isFrozen(r)?r:P.deepFreeze(r)}class f{constructor(n={},i=[],o=[],c){this.b=n,this.c=i,this.d=o,this.raw=c,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(i=>{if(i instanceof f)return i;const o=new p("");return o.parseRaw(i),o.configurationModel});this.f=n.reduce((i,o)=>o===i?o:i.merge(o),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,T.getConfigurationValue)(this.contents,n):this.contents}inspect(n,i){const o=this.rawConfiguration.getValue(n),c=i?this.rawConfiguration.getOverrideValue(n,i):void 0,a=i?this.rawConfiguration.override(i).getValue(n):o;return{value:o,override:c,merged:a}}getOverrideValue(n,i){const o=this.i(i);return o?n?(0,T.getConfigurationValue)(o,n):o:void 0}getKeysForOverrideIdentifier(n){const i=[];for(const o of this.overrides)o.identifiers.includes(n)&&i.push(...o.keys);return E.distinct(i)}getAllOverrideIdentifiers(){const n=[];for(const i of this.overrides)n.push(...i.identifiers);return E.distinct(n)}override(n){let i=this.a.get(n);return i||(i=this.g(n),this.a.set(n,i)),i}merge(...n){const i=P.deepClone(this.contents),o=P.deepClone(this.overrides),c=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const s of n)if(a.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.h(i,s.contents);for(const m of s.overrides){const[R]=o.filter(L=>E.equals(L.identifiers,m.identifiers));R?(this.h(R.contents,m.contents),R.keys.push(...m.keys),R.keys=E.distinct(R.keys)):o.push(P.deepClone(m))}for(const m of s.keys)c.indexOf(m)===-1&&c.push(m)}return new f(i,c,o,a.every(s=>s instanceof f)?void 0:a)}g(n){const i=this.i(n);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const c of E.distinct([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[c];const s=i[c];s&&(typeof a=="object"&&typeof s=="object"?(a=P.deepClone(a),this.h(a,s)):a=s),o[c]=a}return new f(o,this.keys,this.overrides)}h(n,i){for(const o of Object.keys(i)){if(o in n&&w.isObject(n[o])&&w.isObject(i[o])){this.h(n[o],i[o]);continue}n[o]=P.deepClone(i[o])}}i(n){let i=null,o=null;const c=a=>{a&&(o?this.h(o,a):o=P.deepClone(a))};for(const a of this.overrides)E.equals(a.identifiers,[n])?i=a.contents:a.identifiers.includes(n)&&c(a.contents);return c(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,i){this.j(n,i,!0)}setValue(n,i){this.j(n,i,!1)}removeValue(n){const i=this.keys.indexOf(n);i!==-1&&(this.keys.splice(i,1),(0,T.removeFromValueTree)(this.contents,n),S.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.splice(this.overrides.findIndex(o=>E.equals(o.identifiers,(0,S.overrideIdentifiersFromKey)(n))),1))}j(n,i,o){(0,T.addToValueTree)(this.contents,n,i,c=>console.error(c)),o=o||this.keys.indexOf(n)===-1,o&&this.keys.push(n),S.OVERRIDE_PROPERTY_REGEX.test(n)&&this.overrides.push({identifiers:(0,S.overrideIdentifiersFromKey)(n),keys:Object.keys(this.contents[n]),contents:(0,T.toValuesTree)(this.contents[n],c=>console.error(c))})}}e.ConfigurationModel=f;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new f}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,i){if(!w.isUndefinedOrNull(n)){const o=this.g(n);this.parseRaw(o,i)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,i){this.a=n;const{contents:o,keys:c,overrides:a,restricted:s,hasExcludedProperties:m}=this.h(n,i);this.b=new f(o,c,a,m?[n]:void 0),this.c=s||[]}g(n){let i={},o=null,c=[];const a=[],s=[];function m(L){Array.isArray(c)?c.push(L):o!==null&&(c[o]=L)}const R={onObjectBegin:()=>{const L={};m(L),a.push(c),c=L,o=null},onObjectProperty:L=>{o=L},onObjectEnd:()=>{c=a.pop()},onArrayBegin:()=>{const L=[];m(L),a.push(c),c=L,o=null},onArrayEnd:()=>{c=a.pop()},onLiteralValue:m,onError:(L,$,ie)=>{s.push({error:L,offset:$,length:ie})}};if(n)try{l.visit(n,R),i=c[0]||{}}catch(L){console.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return i}h(n,i){const o=b.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),c=this.i(n,o,!0,i);n=c.raw;const a=(0,T.toValuesTree)(n,R=>console.error(`Conflict in settings file ${this.f}: ${R}`)),s=Object.keys(n),m=this.j(n,R=>console.error(`Conflict in settings file ${this.f}: ${R}`));return{contents:a,keys:s,overrides:m,restricted:c.restricted,hasExcludedProperties:c.hasExcludedProperties}}i(n,i,o,c){let a=!1;if(!c?.scopes&&!c?.skipRestricted)return{raw:n,restricted:[],hasExcludedProperties:a};const s={},m=[];for(const R in n)if(S.OVERRIDE_PROPERTY_REGEX.test(R)&&o){const L=this.i(n[R],i,!1,c);s[R]=L.raw,a=a||L.hasExcludedProperties,m.push(...L.restricted)}else{const L=i[R],$=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&m.push(R),($===void 0||c.scopes===void 0||c.scopes.includes($))&&!(c.skipRestricted&&L?.restricted)?s[R]=n[R]:a=!0}return{raw:s,restricted:m,hasExcludedProperties:a}}j(n,i){const o=[];for(const c of Object.keys(n))if(S.OVERRIDE_PROPERTY_REGEX.test(c)){const a={};for(const s in n[c])a[s]=n[c][s];o.push({identifiers:(0,S.overrideIdentifiersFromKey)(c),keys:Object.keys(a),contents:(0,T.toValuesTree)(a,i)})}return o}}e.ConfigurationModelParser=p;class u extends I.Disposable{constructor(n,i,o,c){super(),this.f=n,this.g=i,this.h=c,this.c=this.B(new k.Emitter),this.onDidChange=this.c.event,this.a=new p(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(k.Event.any(k.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),k.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&o.isEqual(a.resource,n)))(()=>this.c.fire()))}async loadConfiguration(){try{const n=await this.h.readFile(this.f);return this.a.parse(n.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new f}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=u;class h{constructor(n,i,o,c,a,s,m,R,L,$,ie,ne,F){this.a=n,this.b=i,this.c=o,this.overrideIdentifiers=c,this.d=a,this.f=s,this.g=m,this.h=R,this.i=L,this.j=$,this.k=ie,this.l=ne,this.m=F}get value(){return g(this.c)}n(n,i,o){const c=n.inspect(i,o);return{get value(){return g(c.value)},get override(){return g(c.override)},get merged(){return g(c.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class v{constructor(n,i,o,c,a=new f,s=new f,m=new C.ResourceMap,R=new f,L=new C.ResourceMap){this.c=n,this.d=i,this.f=o,this.g=c,this.h=a,this.i=s,this.j=m,this.l=R,this.m=L,this.a=null,this.b=new C.ResourceMap,this.n=null}getValue(n,i,o){return this.q(n,i,o).getValue(n)}updateValue(n,i,o={}){let c;o.resource?(c=this.m.get(o.resource),c||(c=new f,this.m.set(o.resource,c))):c=this.l,i===void 0?c.removeValue(n):c.setValue(n,i),o.resource||(this.a=null)}inspect(n,i,o){const c=this.q(n,i,o),a=this.u(i.resource,o),s=i.resource?this.m.get(i.resource)||this.l:this.l,m=new Set;for(const R of c.overrides)for(const L of R.identifiers)c.getOverrideValue(n,L)!==void 0&&m.add(L);return new h(n,i,c.getValue(n),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,a||void 0,s)}keys(n){const i=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,i){this.j.set(n,i),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,i){const o=[];if(!i){const{added:c,updated:a,removed:s}=A(this.c,n);i=[...c,...a,...s]}for(const c of i)for(const a of(0,S.overrideIdentifiersFromKey)(c)){const s=this.c.getKeysForOverrideIdentifier(a),m=n.getKeysForOverrideIdentifier(a),R=[...m.filter(L=>s.indexOf(L)===-1),...s.filter(L=>m.indexOf(L)===-1),...s.filter(L=>!P.equals(this.c.override(a).getValue(L),n.override(a).getValue(L)))];o.push([a,R])}return this.updateDefaultConfiguration(n),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(n){const{added:i,updated:o,removed:c}=A(this.d,n),a=[...i,...o,...c];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:i,updated:o,removed:c,overrides:a}=A(this.applicationConfiguration,n),s=[...i,...o,...c];return s.length&&this.updateApplicationConfiguration(n),{keys:s,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:i,updated:o,removed:c,overrides:a}=A(this.localUserConfiguration,n),s=[...i,...o,...c];return s.length&&this.updateLocalUserConfiguration(n),{keys:s,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:i,updated:o,removed:c,overrides:a}=A(this.remoteUserConfiguration,n),s=[...i,...o,...c];return s.length&&this.updateRemoteUserConfiguration(n),{keys:s,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:i,updated:o,removed:c,overrides:a}=A(this.workspaceConfiguration,n),s=[...i,...o,...c];return s.length&&this.updateWorkspaceConfiguration(n),{keys:s,overrides:a}}compareAndUpdateFolderConfiguration(n,i){const o=this.p.get(n),{added:c,updated:a,removed:s,overrides:m}=A(o,i),R=[...c,...a,...s];return(R.length||!o)&&this.updateFolderConfiguration(n,i),{keys:R,overrides:m}}compareAndDeleteFolderConfiguration(n){const i=this.p.get(n);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:o,updated:c,removed:a,overrides:s}=A(i,void 0);return{keys:[...o,...c,...a],overrides:s}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,i,o){let c=this.r(i,o);return i.overrideIdentifier&&(c=c.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(c=c.merge(this.d)),c}r({resource:n},i){let o=this.s();if(i&&n){const c=i.getFolder(n);c&&(o=this.t(c.uri)||o);const a=this.m.get(n);a&&(o=o.merge(a))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let i=this.b.get(n);if(!i){const o=this.s(),c=this.j.get(n);c?(i=o.merge(c),this.b.set(n,i)):i=o}return i}u(n,i){if(i&&n){const o=i.getFolder(n);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,i)=>{const{contents:o,overrides:c,keys:a}=this.j.get(i);return n.push([i,{contents:o,overrides:c,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(i=>n.add(i)),this.userConfiguration.keys.forEach(i=>n.add(i)),this.i.keys.forEach(i=>n.add(i)),this.j.forEach(i=>i.keys.forEach(o=>n.add(o))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>n.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(o=>n.add(o))),[...n.values()]}w(n){const i=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this.i.getKeysForOverrideIdentifier(n).forEach(o=>i.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(n).forEach(c=>i.add(c))),[...i.values()]}static parse(n){const i=this.x(n.defaults),o=this.x(n.policy),c=this.x(n.application),a=this.x(n.user),s=this.x(n.workspace),m=n.folders.reduce((R,L)=>(R.set(y.URI.revive(L[0]),this.x(L[1])),R),new C.ResourceMap);return new v(i,o,c,a,new f,s,m,new f,new C.ResourceMap)}static x(n){return new f(n.contents,n.keys,n.overrides)}}e.Configuration=v;function d(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const n=new Set,i=new Map;for(const c of r)c.keys.forEach(a=>n.add(a)),c.overrides.forEach(([a,s])=>{const m=(0,C.getOrSet)(i,a,new Set);s.forEach(R=>m.add(R))});const o=[];return i.forEach((c,a)=>o.push([a,[...c.values()]])),{keys:[...n.values()],overrides:o}}e.mergeChanges=d;class D{constructor(n,i,o,c){this.change=n,this.f=i,this.g=o,this.h=c,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const s of a)this.affectedKeys.add(s);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=v.parse(this.f.data)),this.i}affectsConfiguration(n,i){const o=this.a+n,c=this.d.indexOf(o);if(c<0)return!1;const a=c+o.length;if(a>=this.d.length)return!1;const s=this.d.charCodeAt(a);if(s!==this.b&&s!==this.c)return!1;if(i){const m=this.previousConfiguration?this.previousConfiguration.getValue(n,i,this.f?.workspace):void 0,R=this.g.getValue(n,i,this.h);return!P.equals(m,R)}return!0}}e.ConfigurationChangeEvent=D;function A(r,n){const{added:i,removed:o,updated:c}=t(n?.rawConfiguration,r?.rawConfiguration),a=[],s=r?.getAllOverrideIdentifiers()||[],m=n?.getAllOverrideIdentifiers()||[];if(n){const R=m.filter(L=>!s.includes(L));for(const L of R)a.push([L,n.getKeysForOverrideIdentifier(L)])}if(r){const R=s.filter(L=>!m.includes(L));for(const L of R)a.push([L,r.getKeysForOverrideIdentifier(L)])}if(n&&r){for(const R of s)if(m.includes(R)){const L=t({contents:r.getOverrideValue(void 0,R)||{},keys:r.getKeysForOverrideIdentifier(R)},{contents:n.getOverrideValue(void 0,R)||{},keys:n.getKeysForOverrideIdentifier(R)});a.push([R,[...L.added,...L.removed,...L.updated]])}}return{added:i,removed:o,updated:c,overrides:a}}function t(r,n){const i=r?n?r.keys.filter(a=>n.keys.indexOf(a)===-1):[...r.keys]:[],o=n?r?n.keys.filter(a=>r.keys.indexOf(a)===-1):[...n.keys]:[],c=[];if(r&&n){for(const a of n.keys)if(r.keys.indexOf(a)!==-1){const s=(0,T.getConfigurationValue)(n.contents,a),m=(0,T.getConfigurationValue)(r.contents,a);P.equals(s,m)||c.push(a)}}return{added:i,removed:o,updated:c}}}),define(ve[225],be([1,0,18,6,2,23,8,110,52,12,65,39]),function(ae,e,E,k,l,I,C,P,w,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class b extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new k.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:h})=>this.c(Array.from(u),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(u,h){this.h(u,S.Registry.as(w.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:u})}f(){return{}}g(){this.b=new P.ConfigurationModel;const u=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(u),u)}h(u,h){const v=this.f();for(const d of u){const D=v[d],A=h[d];D!==void 0?this.b.addValue(d,D):A?this.b.addValue(d,A.default):this.b.removeValue(d)}}}e.DefaultConfiguration=b;class g{constructor(){this.onDidChangeConfiguration=k.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let f=class extends l.Disposable{get configurationModel(){return this.b}constructor(u,h,v){super(),this.c=u,this.f=h,this.g=v,this.a=this.B(new k.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(u=>this.i(u))),this.B(this.c.onDidChangeConfiguration(async({properties:u})=>this.j(await this.h(u),!0))),this.b}async h(u){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",u);const h={},v=[],d=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(const D of u){const A=d[D];if(!A){v.push(D);continue}if(A.policy){if(A.type!=="string"&&A.type!=="number"){this.g.warn(`Policy ${A.policy.name} has unsupported type ${A.type}`);continue}v.push(D),h[A.policy.name]={type:A.type}}}return(0,C.isEmptyObject)(h)||await this.f.updatePolicyDefinitions(h),v}i(u){this.g.trace("PolicyConfiguration#onDidChangePolicies",u);const h=S.Registry.as(w.Extensions.Configuration).getPolicyConfigurations(),v=(0,E.coalesce)(u.map(d=>h.get(d)));this.j(v,!0)}j(u,h){this.g.trace("PolicyConfiguration#update",u);const v=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),d=[],D=this.b.isEmpty();for(const A of u){const t=v[A]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(D?r!==void 0:!(0,I.equals)(this.b.getValue(A),r))&&d.push([A,r])}else this.b.getValue(A)!==void 0&&d.push([A,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const A=this.b;this.b=new P.ConfigurationModel;for(const t of A.keys)this.b.setValue(t,A.getValue(t));for(const[t,r]of d)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);h&&this.a.fire(this.b)}}};f=Re([Te(1,T.IPolicyService),Te(2,y.ILogService)],f),e.PolicyConfiguration=f}),define(ve[111],be([1,0,14,6,2,20,24,110,225,65]),function(ae,e,E,k,l,I,C,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class T extends l.Disposable{constructor(b,g,f,p){super(),this.i=b,this.h=this.B(new k.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.DefaultConfiguration),this.c=f instanceof y.NullPolicyService?new w.NullPolicyConfiguration:this.B(new w.PolicyConfiguration(this.b,f,p)),this.f=this.B(new P.UserSettings(this.i,void 0,I.extUriBiasedIgnorePathCase,g)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:u,properties:h})=>this.k(u,h))),this.B(this.c.onDidChangeConfiguration(u=>this.l(u))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[b,g,f]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(b,g,new P.ConfigurationModel,f)}getConfigurationData(){return this.a.toData()}getValue(b,g){const f=typeof b=="string"?b:void 0,p=(0,C.isConfigurationOverrides)(b)?b:(0,C.isConfigurationOverrides)(g)?g:{};return this.a.getValue(f,p,void 0)}updateValue(b,g,f,p){return Promise.reject(new Error("not supported"))}inspect(b){return this.a.inspect(b,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const b=await this.f.loadConfiguration();this.j(b)}j(b){const g=this.a.toData(),f=this.a.compareAndUpdateLocalUserConfiguration(b);this.m(f,g,2)}k(b,g){const f=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(b,g);this.m(p,f,7)}l(b){const g=this.a.toData(),f=this.a.compareAndUpdatePolicyConfiguration(b);this.m(f,g,7)}m(b,g,f){const p=new P.ConfigurationChangeEvent(b,{data:g},this.a);p.source=f,p.sourceConfig=this.n(f),this.h.fire(p)}n(b){switch(b){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=T}),define(ve[112],be([1,0,9,5]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,k.createDecorator)("remoteAuthorityResolverService");var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class I extends E.ErrorNoTelemetry{static isNotAvailable(w){return w instanceof I&&w._code===l.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof I&&w._code===l.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof I&&w._code===l.NoResolverFound}static isHandled(w){return w instanceof I&&w.isHandled}constructor(w,y=l.Unknown,T){super(w),this._message=w,this._code=y,this._detail=T,this.isHandled=y===l.NotAvailable&&T===!0,Object.setPrototypeOf(this,I.prototype)}}e.RemoteAuthorityResolverError=I;function C(P){const w=P.indexOf("+");return w===-1?P:P.substring(0,w)}e.getRemoteAuthorityPrefix=C}),define(ve[66],be([1,0,13]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function k(y){return y.scheme===E.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=k;function l(y){if(!y)return;const T=y.indexOf("+");return T<0?y:y.substr(0,T)}e.getRemoteName=l;function I(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.getRemoteServerRootPath=I;function C(y){const{host:T,port:S}=w(y);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:T,port:S}}e.parseAuthorityWithPort=C;function P(y,T){let{host:S,port:b}=w(y);return typeof b>"u"&&(b=T),{host:S,port:b}}e.parseAuthorityWithOptionalPort=P;function w(y){const T=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(T)return{host:T[1],port:parseInt(T[2],10)};const S=y.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const b=y.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:y,port:void 0}}}),define(ve[33],be([1,0,16,5,66]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function I(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=I;function C(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(P=e.ExtensionType||(e.ExtensionType={}));var w;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(w=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(p){this.value=p,this.c=p.toLowerCase()}static equals(p,u){if(typeof p>"u"||p===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof p=="string"||typeof u=="string"){const h=typeof p=="string"?p:p.value,v=typeof u=="string"?u:u.value;return E.equalsIgnoreCase(h,v)}return p.c===u.c}static toKey(p){return typeof p=="string"?p.toLowerCase():p.c}}e.ExtensionIdentifier=y;function T(f){return S(f)}e.isApplicationScopedExtension=T;function S(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function b(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=b;function g(f,p){if(p){const u=`onResolveRemoteAuthority:${(0,l.getRemoteName)(p)}`;return f.activationEvents?.indexOf(u)!==-1}return!1}e.isResolverExtension=g,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(ve[226],be([1,0,2,7,21,33]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class C extends E.Disposable{constructor(w,y){super(),this.b=w,this.a=(0,k.join)(this.b.userDataPath,I.MANIFEST_CACHE_FOLDER,I.USER_MANIFEST_CACHE_FILE),this.B(y.onDidInstallExtensions(T=>this.c(T))),this.B(y.onDidUninstallExtension(T=>this.f(T)))}c(w){w.some(y=>!!y.local)&&this.invalidate()}f(w){w.error||this.invalidate()}invalidate(){l.Promises.rm(this.a,l.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=C}),define(ve[53],be([1,0,15,186,52,5,39]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,I.createDecorator)("requestService");function P(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=P;function w(p){return p.res.statusCode===204}async function y(p){return w(p)?null:(await(0,E.streamToBuffer)(p.stream)).toString()}e.asText=y;async function T(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);return y(p)}e.asTextOrError=T;async function S(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);if(w(p))return null;const h=(await(0,E.streamToBuffer)(p.stream)).toString();try{return JSON.parse(h)}catch(v){throw v.message+=`:
`+h,v}}e.asJson=S;function b(p){f(p)}e.updateProxyConfigurationsScope=b;let g;function f(p){const u=C.Registry.as(l.Extensions.Configuration),h=g;g={id:"http",order:15,title:(0,k.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(4,null),(0,k.localize)(5,null),(0,k.localize)(6,null),(0,k.localize)(7,null)],default:"override",description:(0,k.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(9,null),restricted:!0}}},u.updateConfigurations({add:[g],remove:h?[h]:[]})}f(2)}),define(ve[227],be([1,0,19,13,17,53]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let C=class{constructor(w,y){this.a=w,this.b=y}async download(w,y,T=E.CancellationToken.None){if(w.scheme===k.Schemas.file||w.scheme===k.Schemas.vscodeRemote){await this.b.copy(w,y);return}const S={type:"GET",url:w.toString(!0)},b=await this.a.request(S,T);if(b.res.statusCode===200)await this.b.writeFile(y,b.stream);else{const g=await(0,I.asTextOrError)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${g}`)}}};C=Re([Te(0,I.IRequestService),Te(1,l.IFileService)],C),e.DownloadService=C}),define(ve[228],be([1,0,15,19]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class l{constructor(P){this.a=P}listen(P,w){throw new Error("Invalid listen")}call(P,w,y,T=k.CancellationToken.None){switch(w){case"request":return this.a.request(y[0],T).then(async({res:S,stream:b})=>{const g=await(0,E.streamToBuffer)(b);return[{statusCode:S.statusCode,headers:S.headers},g]});case"resolveProxy":return this.a.resolveProxy(y[0])}throw new Error("Invalid call")}}e.RequestChannel=l;class I{constructor(P){this.a=P}async request(P,w){const[y,T]=await this.a.call("request",[P],w);return{res:y,stream:(0,E.bufferToStream)(T)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=I}),define(ve[229],be([1,0,79,8]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function l(C,P){return C.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:C.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function I(C,P,w={}){const y=(0,E.parse)(C),T=w.proxyUrl||l(y,P);if(!T)return null;const S=(0,E.parse)(T);if(!/^https?:$/.test(S.protocol||""))return null;const b={host:S.hostname||"",port:S.port||(S.protocol==="https"?"443":"80"),auth:S.auth,rejectUnauthorized:(0,k.isBoolean)(w.strictSSL)?w.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((g,f)=>{ae(["http-proxy-agent"],g,f)}))(b):new(await new Promise((g,f)=>{ae(["https-proxy-agent"],g,f)}))(b)}e.getProxyAgent=I}),define(ve[80],be([1,0,49,7,187,19,37,9,3,22,164,200,14,143]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let f;async function p(h,v,d,D){return d["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(D)&&!d["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(D)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=b.Promises.withAsyncBody(async(A,t)=>{const r=new I.CancellationTokenSource;let n=1e4;const i=h.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(n=(0,g.clamp)(i,1,120)*1e3);const o=setTimeout(()=>{r.dispose(!0),t(new Error((0,l.localize)(0,null)))},n);try{A(await u(v,r.token))}catch(c){!(0,P.isCancellationError)(c)&&!r.token.isCancellationRequested?t(new Error((0,l.localize)(1,null,(0,C.toErrorMessage)(c)))):A({})}finally{clearTimeout(o),r.dispose()}})),f)}e.getResolvedShellEnv=p;async function u(h,v){const d=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",d);const D=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",D);const A=(0,y.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(A+"({.*})"+A),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",r);const n=await(0,T.getSystemShell)(w.OS,r);return h.trace("getUnixShellEnvironment#shell",n),new Promise((i,o)=>{if(v.isCancellationRequested)return o(new P.CancellationError);const c=(0,k.basename)(n);let a,s;const m=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${m} -p '''${A}'' + JSON.stringify(process.env) + ''${A}'''`,s=["-Login","-Command"]):(a=`'${process.execPath}' ${m} -p '"${A}" + JSON.stringify(process.env) + "${A}"'`,c==="tcsh"||c==="csh"?s=["-ic"]:s=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(s),a);const R=(0,E.spawn)(n,[...s,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});v.onCancellationRequested(()=>(R.kill(),o(new P.CancellationError))),R.on("error",ie=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,C.toErrorMessage)(ie)),o(ie)});const L=[];R.stdout.on("data",ie=>L.push(ie));const $=[];R.stderr.on("data",ie=>$.push(ie)),R.on("close",(ie,ne)=>{const F=Buffer.concat(L).toString("utf8");h.trace("getUnixShellEnvironment#raw",F);const _=Buffer.concat($).toString("utf8");if(_.trim()&&h.trace("getUnixShellEnvironment#stderr",_),ie||ne)return o(new Error((0,l.localize)(2,null,ie,ne)));const z=t.exec(F),x=z?z[1]:"{}";try{const le=JSON.parse(x);d?le.ELECTRON_RUN_AS_NODE=d:delete le.ELECTRON_RUN_AS_NODE,D?le.ELECTRON_NO_ATTACH_CONSOLE=D:delete le.ELECTRON_NO_ATTACH_CONSOLE,delete le.VSCODE_RESOLVING_ENVIRONMENT,delete le.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",le),i(le)}catch(le){h.error("getUnixShellEnvironment#errorCaught",(0,C.toErrorMessage)(le)),o(le)}})})}}),define(ve[230],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(ve[113],be([1,0,3,28,4,22]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function C(y){if(E.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function P(y,T,S,b,g,f,p,u,h,v){const d=Object.create(null);d["common.machineId"]=p,d.sessionID=(0,I.generateUuid)()+Date.now(),d.commitHash=g,d.version=f,d["common.platformVersion"]=(T||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,E.PlatformToString)(E.platform),d["common.nodePlatform"]=k.platform,d["common.nodeArch"]=b,d["common.product"]=v||"desktop",u&&(d["common.msftInternal"]=u);let D=0;const A=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-A,enumerable:!0},"common.sequence":{get:()=>D++,enumerable:!0}}),E.isLinuxSnap&&(d["common.snap"]="true");const t=C(S);t&&(d["common.platformDetail"]=t);try{const r=await y.readFile(l.URI.file(h));d["common.source"]=r.value.toString().slice(0,30)}catch{}return d}e.resolveCommonProperties=P;function w(y){const T=k.env.USERDNSDOMAIN;if(!T)return!1;const S=T.toLowerCase();return y.some(b=>S===b)}e.verifyMicrosoftInternalDomain=w}),define(ve[231],be([1,0,18,9,2,23,17]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var P;(function(y){function T(S,b){return S.callstack<b.callstack?-1:S.callstack>b.callstack?1:0}y.compare=T})(P=e.ErrorEvent||(e.ErrorEvent={}));class w{constructor(T,S=w.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new l.DisposableStore,this.c=T,this.d=S;const b=k.errorHandler.addListener(g=>this.j(g));this.h.add((0,l.toDisposable)(b)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(T){if(!T||(T.detail&&T.detail.stack&&(T=T.detail),k.ErrorNoTelemetry.isErrorNoTelemetry(T)||T instanceof C.FileOperationError))return;const S=Array.isArray(T.stack)?T.stack.join(`
`):T.stack,b=T.message?T.message:(0,I.safeStringify)(T);!S||this.k({msg:b,callstack:S})}k(T){const S=(0,E.binarySearch)(this.g,T,P.compare);S<0?(T.count=1,this.g.splice(~S,0,T)):(this.g[S].count||(this.g[S].count=0),this.g[S].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const T of this.g)this.c.publicLogError2("UnhandledError",T);this.g.length=0}}w.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=w}),define(ve[232],be([1,0,2]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class k extends E.Disposable{constructor(I,C){super(),this.a=I,this.b=C}async call(I,C,P){switch(C){case"updateTelemetryLevel":{const{telemetryLevel:w}=P;return this.a.updateInjectedTelemetryLevel(w)}case"logTelemetry":{const{eventName:w,data:y}=P;return this.b?this.b.log(w,y):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${C} not found`)}listen(I,C,P){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=k}),define(ve[29],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var k;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(k=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ve[233],be([1,0,31,14,70,13,7,3,4,96,21,99,208,17,26,29]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const u=new Map;async function h(t,r){const n=`${t}::${r.join(":")}`,i=u.get(n);if(i)return i;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,a=new Map,s=2e4;function m(L,$,ie,ne){const F=$.substring(L.length+1);return k.Promises.withAsyncBody(async _=>{let z;try{z=await T.Promises.readdir($,{withFileTypes:!0})}catch{_();return}if(ne.count>=s){ne.count+=z.length,ne.maxReached=!0,_();return}let x=z.length;if(x===0){_();return}let le=z;ne.count+z.length>s&&(ne.maxReached=!0,x=s-ne.count,le=z.slice(0,x)),ne.count+=z.length;for(const Ee of le)if(Ee.isDirectory()){if(ie.includes(Ee.name)||await m(L,(0,C.join)($,Ee.name),ie,ne),--x===0){_();return}}else{const Y=Ee.name.lastIndexOf(".");if(Y>=0){const H=Ee.name.substring(Y+1);H&&c.set(H,(c.get(H)??0)+1)}for(const H of o)H.relativePathPattern?.test(F)!==!1&&H.filePattern.test(Ee.name)&&a.set(H.tag,(a.get(H.tag)??0)+1);if(--x===0){_();return}}})}const R=k.Promises.withAsyncBody(async L=>{const $={count:0,maxReached:!1};await m(t,t,r,$);const ie=await D(t);L({configFiles:v(a),fileTypes:v(c),fileCount:$.count,maxFilesReached:$.maxReached,launchConfigFiles:ie})});return u.set(n,R),R}e.collectWorkspaceStats=h;function v(t){return Array.from(t.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function d(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(y.virtualMachineHint.value()*100)}%`},r=E.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=d;async function D(t){try{const r=new Map,n=(0,C.join)(t,".vscode","launch.json"),i=await T.Promises.readFile(n),o=[],c=(0,l.parse)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${n}`),[];if((0,l.getNodeType)(c)==="object"&&c.configurations)for(const a of c.configurations){const s=a.type;s&&(r.has(s)?r.set(s,r.get(s)+1):r.set(s,1))}return v(r)}catch{return[]}}e.collectLaunchConfigs=D;let A=class{constructor(r,n){this.c=r,this.d=n}f(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}g(r){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const i=E.cpus();return i&&i.length>0&&n.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),n.push(`Memory (System):  ${(E.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||n.push(`Load (avg):       ${E.loadavg().map(o=>Math.round(o)).join(", ")}`),n.push(`VM:               ${Math.round(y.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,S.listProcesses)(r.mainPID),this.k(r)]).then(async i=>{let[o,c]=i,a=this.m(r,o);return n.forEach(s=>{if((0,b.isRemoteDiagnosticError)(s))a+=`
${s.errorMessage}`,c+=`
${s.errorMessage}`;else if(a+=`

Remote: ${s.hostName}`,s.processes&&(a+=`
${this.m(r,s.processes)}`),s.workspaceMetadata){c+=`
|  Remote: ${s.hostName}`;for(const m of Object.keys(s.workspaceMetadata)){const R=s.workspaceMetadata[m];let L=`${R.fileCount} files`;R.maxFilesReached&&(L=`more than ${L}`),c+=`|    Folder (${m}): ${L}`,c+=this.h(R)}}}),{processInfo:a,workspaceInfo:c}})}async getSystemInfo(r,n){const{memory:i,vmHint:o,os:c,cpus:a}=d(),s={os:c,memory:i,cpus:a,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return P.isWindows||(s.load=`${E.loadavg().map(m=>Math.round(m)).join(", ")}`),P.isLinux&&(s.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(s)}async getDiagnostics(r,n){const i=[];return(0,S.listProcesses)(r.mainPID).then(async o=>(i.push(""),i.push(this.g(r)),i.push(""),i.push(this.m(r,o)),r.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(r))),n.forEach(c=>{if((0,b.isRemoteDiagnosticError)(c))i.push(`
${c.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${c.hostName}`),i.push(this.f(c.machineInfo)),c.processes&&i.push(this.m(r,c.processes)),c.workspaceMetadata)for(const a of Object.keys(c.workspaceMetadata)){const s=c.workspaceMetadata[a];let m=`${s.fileCount} files`;s.maxFilesReached&&(m=`more than ${m}`),i.push(`Folder (${a}): ${m}`),i.push(this.h(s))}}),i.push(""),i.push(""),i.join(`
`)))}h(r){const n=[];let o=0;const c=(R,L)=>{const $=` ${R}(${L})`;o+$.length>60?(n.push(a),a="|                 ",o=a.length):o+=$.length,a+=$};let a="|      File types:";const s=10,m=r.fileTypes.length>s?s:r.fileTypes.length;for(let R=0;R<m;R++){const L=r.fileTypes[R];c(L.name,L.count)}if(n.push(a),r.configFiles.length>=0&&(a="|      Conf files:",o=0,r.configFiles.forEach(R=>{c(R.name,R.count)}),n.push(a)),r.launchConfigFiles.length>0){let R="|      Launch Configs:";r.launchConfigFiles.forEach(L=>{R+=L.count>1?` ${L.name}(${L.count})`:` ${L.name}`}),n.push(R)}return n.join(`
`)}j(r){const n=Math.max(...Object.keys(r).map(i=>i.length));return Object.keys(r).map(i=>`${i}:  ${" ".repeat(n-i.length)}  ${r[i]}`).join(`
                  `)}k(r){const n=[],i=[];return r.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(n.push(`|  Window (${o.title})`),o.folderURIs.forEach(c=>{const a=w.URI.revive(c);if(a.scheme===I.Schemas.file){const s=a.fsPath;i.push(h(s,["node_modules",".git"]).then(m=>{let R=`${m.fileCount} files`;m.maxFilesReached&&(R=`more than ${R}`),n.push(`|    Folder (${(0,C.basename)(s)}): ${R}`),n.push(this.h(m))}).catch(m=>{n.push(`|      Error: Unable to collect workspace stats for folder ${s} (${m.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>n.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,n){const i=new Map;r.windows.forEach(c=>i.set(c.pid,c.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),n&&this.n(r.mainPID,i,o,n,0),o.join(`
`)}n(r,n,i,o,c){const a=c===0;let s;a?s=o.pid===r?`${this.d.applicationName} main`:"remote agent":(s=`${"  ".repeat(c)} ${o.name}`,o.name==="window"&&(s=`${s} (${n.get(o.pid)})`));const m=process.platform==="win32"?o.mem:E.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(m/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${s}`),Array.isArray(o.children)&&o.children.forEach(R=>this.n(r,n,i,R,c+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:i}of r.folders){const o=w.URI.revive(i);if(o.scheme!==I.Schemas.file)continue;const c=o.fsPath;try{(await h(c,["node_modules",".git"])).fileTypes.forEach(s=>n.add(s.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const i=w.URI.revive(n);if(i.scheme!==I.Schemas.file)continue;const o=i.fsPath;try{const c=await h(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),c.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),c.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),c.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};A=Re([Te(0,p.ITelemetryService),Te(1,f.IProductService)],A),e.DiagnosticsService=A}),define(ve[40],be([1,0,23,8,6,24,66,113,29]),function(ae,e,E,k,l,I,C,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class y{constructor(a){this.value=a}}e.TelemetryTrustedValue=y;class T{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(a,s){return Promise.resolve(void 0)}publicLog2(a,s){return this.publicLog(a,s)}publicLogError(a,s){return Promise.resolve(void 0)}publicLogError2(a,s){return this.publicLogError(a,s)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=T,e.NullTelemetryService=new T;class S{async publicLog(a,s,m){}async publicLogError(a,s,m){}}e.NullEndpointTelemetryService=S,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(c,a){return l.Event.debounce(a.onDidChangeConfiguration,(m,R)=>{const L=m?new Set([...m.affectedKeys,...R.affectedKeys]):R.affectedKeys;return{...R,affectedKeys:L}},1e3,!0)(m=>{m.source!==7&&c.publicLog2("updateConfiguration",{configurationSource:(0,I.ConfigurationTargetToString)(m.source),configurationKeys:D(m.affectedKeys)})})}e.configurationTelemetry=b;function g(c,a){return!a.isBuilt&&!a.disableTelemetry?!0:!(a.disableTelemetry||!c.enableTelemetry||a.extensionTestsLocationURI)}e.supportsTelemetry=g;function f(c,a){return!(a.isBuilt||a.disableTelemetry||c.enableTelemetry&&c.aiConfig?.ariaKey)}e.isLoggingOnly=f;function p(c){const a=c.getValue(w.TELEMETRY_SETTING_ID),s=c.getValue(w.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(c.getValue(w.TELEMETRY_OLD_SETTING_ID)===!1||s===!1)return 0;switch(a??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function u(c){const a={},s={},m={};d(c,m);for(let R in m){R=R.length>150?R.substr(R.length-149):R;const L=m[R];typeof L=="number"?s[R]=L:typeof L=="boolean"?s[R]=L?1:0:typeof L=="string"?(L.length>8192&&console.warn(`Telemetry property: ${R} has been trimmed to 8192, the original length is ${L.length}`),a[R]=L.substring(0,8191)):typeof L<"u"&&L!==null&&(a[R]=L)}return{properties:a,measurements:s}}e.validateTelemetryData=u;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces"]);function v(c){if(!c)return"none";const a=(0,C.getRemoteName)(c);return h.has(a)?a:"other"}e.cleanRemoteAuthority=v;function d(c,a,s=0,m){if(!!c)for(const R of Object.getOwnPropertyNames(c)){const L=c[R],$=m?m+R:R;Array.isArray(L)?a[$]=(0,E.safeStringify)(L):L instanceof Date?a[$]=L.toISOString():(0,k.isObject)(L)?s<2?d(L,a,s+1,$+"."):a[$]=(0,E.safeStringify)(L):a[$]=L}}function D(c){if(!c)return[];const a=[];return A(a,"",c),a}function A(c,a,s){s&&typeof s=="object"&&!Array.isArray(s)?Object.keys(s).forEach(m=>A(c,a?`${a}.${m}`:m,s[m])):c.push(a)}function t(c,a){const s=c.msftInternalDomains||[],m=a.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(s)||m}e.isInternalTelemetry=t;function r(c){return[c.appRoot,c.extensionsPath,c.userHome.fsPath,c.tmpDir.fsPath,c.userDataPath]}e.getPiiPathsFromEnvironment=r;function n(c,a){if(!c||!c.includes("/")&&!c.includes("\\"))return c;let s=c;const m=[];for(const ie of a)for(;;){const ne=ie.exec(c);if(!ne)break;m.push([ne.index,ie.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,L=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(s="";;){const ie=L.exec(c);if(!ie)break;const ne=m.some(([F,_])=>ie.index<_&&F<L.lastIndex);!R.test(ie[0])&&!ne&&(s+=c.substring($,ie.index)+"<REDACTED: user-file-path>",$=L.lastIndex)}return $<c.length&&(s+=c.substr($)),s}function i(c){if(!c)return c;const a=c.toLowerCase(),s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const m of s)if(m.regex.test(a))return`<REDACTED: ${m.label}>`;return c}function o(c,a){return(0,E.cloneAndChange)(c,s=>{if(s instanceof y)return s.value;if(typeof s=="string"){let m=s.replaceAll("%20"," ");m=n(m,a);for(const R of a)m=m.replace(R,"");return m=i(m),m}})}e.cleanData=o}),define(ve[35],be([1,0,16,32,33,3,4,9,28,40]),function(ae,e,E,k,l,I,C,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function T(n,i){return n.uuid&&i.uuid?n.uuid===i.uuid:n.id===i.id?!0:(0,E.compareIgnoreCase)(n.id,i.id)===0}e.areSameExtensions=T;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const o=i.manifest?i.manifest.version:i.version,c=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,o,c)}static parse(i){const o=S.exec(i);return o&&o[1]&&o[2]?new b({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,c="undefined"){this.version=o,this.targetPlatform=c,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?T(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=b;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(n){const i=g.exec(n);return i&&i[1]?[u(i[1]),i[2]]:[u(n),void 0]}e.getIdAndVersion=f;function p(n,i){return`${n}.${i}`}e.getExtensionId=p;function u(n){return n.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function h(n,i){return u(p(n,i))}e.getGalleryExtensionId=h;function v(n,i){const o=[],c=a=>{for(const s of o)if(s.some(m=>T(i(m),i(a))))return s;return null};for(const a of n){const s=c(a);s?s.push(a):o.push([a])}return o}e.groupByExtension=v;function d(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=d;function D(n){return{id:new y.TelemetryTrustedValue(n.identifier.id),name:new y.TelemetryTrustedValue(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function A(n,i){const o=[],c=i.manifest.extensionDependencies?.slice(0)??[];for(;c.length;){const a=c.shift();if(a&&o.every(s=>!T(s.identifier,{id:a}))){const s=n.filter(m=>T(m.identifier,{id:a}));s.length===1&&(o.push(s[0]),c.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=A;async function t(n,i){if(!I.isLinux)return!1;let o;try{o=(await n.readFile(C.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await n.readFile(C.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(a))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=t;async function r(n,i){const o=await t(n,i),c=(0,k.getTargetPlatform)(o?"alpine":I.platform,w.arch);return i.debug("ComputeTargetPlatform:",c),c}e.computeTargetPlatform=r}),define(ve[114],be([1,0,19,9,13,20,50,4,174,32,35,33]),function(ae,e,E,k,l,I,C,P,w,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const b=u=>(0,w.localize)(0,null,u),g=(0,w.localize)(1,null,"ms-dotnettools.csharp");function f(u,h){return h?`${u.publisher}.${u.name}@${u.version}`:`${u.publisher}.${u.name}`}let p=class{constructor(h,v){this.a=h,this.b=v}get d(){}async listExtensions(h,v,d,D=console){let A=await this.a.getInstalled(1,d);const t=S.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(v&&v!==""){if(t.indexOf(v.toLowerCase())<0){D.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}A=A.filter(n=>n.manifest.categories?n.manifest.categories.map(o=>o.toLowerCase()).indexOf(v.toLowerCase())>-1:!1)}else if(v===""){D.log("Possible Categories: "),t.forEach(n=>{D.log(n)});return}this.d&&D.log((0,w.localize)(2,null,this.d)),A=A.sort((n,i)=>n.identifier.id.localeCompare(i.identifier.id));let r;for(const n of A)r!==n.identifier.id&&(r=n.identifier.id,D.log(f(n.manifest,h)))}async installExtensions(h,v,d,D,A=console){const t=[],r=[];h.length&&A.log(this.d?(0,w.localize)(3,null,this.d):(0,w.localize)(4,null));const n=await this.a.getInstalled(1,d.profileLocation),i=(s,m)=>{const R=n.find(L=>(0,T.areSameExtensions)(L.identifier,{id:s}));if(R){if(!D&&(!m||m==="prerelease"&&R.preRelease))return A.log((0,w.localize)(5,null,s,R.manifest.version,s)),!1;if(m&&R.manifest.version===m)return A.log((0,w.localize)(6,null,`${s}@${m}`)),!1}return!0},o=(s,m,R)=>{a.push({id:s,version:m!=="prerelease"?m:void 0,installOptions:{...d,isBuiltin:R,installPreReleaseVersion:m==="prerelease"||d.installPreReleaseVersion}})},c=[],a=[];for(const s of h)if(s instanceof P.URI)c.push(s);else{const[m,R]=(0,T.getIdAndVersion)(s);i(m,R)&&o(m,R,!1)}for(const s of v){const[m,R]=(0,T.getIdAndVersion)(s);i(m,R)&&o(m,R,!0)}if(c.length&&await Promise.all(c.map(async s=>{try{const m=await this.f(s,{...d,isBuiltin:!1},D,A);m&&r.push(m)}catch(m){A.error(m.message||m.stack||m),t.push(s.toString())}})),a.length){const s=await this.g(a);await Promise.all(a.map(async m=>{const R=s.get(m.id.toLowerCase());if(R)try{const L=await this.h(m,R,n,D,A);L&&r.push(L)}catch(L){A.error(L.message||L.stack||L),t.push(m.id)}else A.error(`${b(m.version?`${m.id}@${m.version}`:m.id)}
${g}`),t.push(m.id)}))}if(t.length)throw new Error((0,w.localize)(7,null,t.join(", ")))}async f(h,v,d,D){const A=await this.a.getManifest(h);if(!A)throw new Error("Invalid vsix");if(await this.k(A,d,v.profileLocation,D))try{return await this.a.install(h,v),D.log((0,w.localize)(8,null,(0,I.basename)(h))),A}catch(r){if((0,k.isCancellationError)(r))return D.log((0,w.localize)(9,null,(0,I.basename)(h))),null;throw r}return null}async g(h){const v=new Map,d=h.some(A=>A.installOptions.installPreReleaseVersion),D=await this.b.getExtensions(h.map(A=>({...A,preRelease:d})),E.CancellationToken.None);for(const A of D)v.set(A.identifier.id.toLowerCase(),A);return v}async h({id:h,version:v,installOptions:d},D,A,t,r){const n=await this.b.getManifest(D,E.CancellationToken.None);if(n&&!this.j(n,r))return null;const i=A.find(o=>(0,T.areSameExtensions)(o.identifier,D.identifier));if(i){if(D.version===i.manifest.version)return r.log((0,w.localize)(10,null,v?`${h}@${v}`:h)),null;r.log((0,w.localize)(11,null,h,D.version))}try{d.isBuiltin?r.log(v?(0,w.localize)(12,null,h,v):(0,w.localize)(13,null,h)):r.log(v?(0,w.localize)(14,null,h,v):(0,w.localize)(15,null,h));const o=await this.a.installFromGallery(D,{...d,installGivenVersion:!!v});return r.log((0,w.localize)(16,null,h,o.manifest.version)),n}catch(o){if((0,k.isCancellationError)(o))return r.log((0,w.localize)(17,null,h)),null;throw o}}j(h,v){return!0}async k(h,v,d,D){const A={id:(0,T.getGalleryExtensionId)(h.publisher,h.name)},r=(await this.a.getInstalled(1,d)).find(n=>(0,T.areSameExtensions)(A,n.identifier)&&(0,C.gt)(n.manifest.version,h.version));return r&&!v?(D.log((0,w.localize)(18,null,r.identifier.id,r.manifest.version,h.version)),!1):this.j(h,D)}async uninstallExtensions(h,v,d,D=console){const A=async r=>{if(r instanceof P.URI){const n=await this.a.getManifest(r);return f(n)}return r},t=[];for(const r of h){const n=await A(r),o=(await this.a.getInstalled(void 0,d)).filter(c=>(0,T.areSameExtensions)(c.identifier,{id:n}));if(!o.length)throw new Error(`${this.l(n)}
${g}`);if(o.some(c=>c.type===0)){D.log((0,w.localize)(19,null,n));return}if(!v&&o.some(c=>c.isBuiltin)){D.log((0,w.localize)(20,null,n));return}D.log((0,w.localize)(21,null,n));for(const c of o)await this.a.uninstall(c,{profileLocation:d}),t.push(c);this.d?D.log((0,w.localize)(22,null,n,this.d)):D.log((0,w.localize)(23,null,n))}}async locateExtension(h,v=console){const d=await this.a.getInstalled();h.forEach(D=>{d.forEach(A=>{if(A.identifier.id===D&&A.location.scheme===l.Schemas.file){v.log(A.location.fsPath);return}})})}l(h){return this.d?(0,w.localize)(24,null,h,this.d):(0,w.localize)(25,null,h)}};p=Re([Te(0,y.IExtensionManagementService),Te(1,y.IExtensionGalleryService)],p),e.ExtensionManagementCLI=p}),define(ve[234],be([1,0,14,9,2,13,3,20,50,8,22,21,24,25,32,35,76,17,12]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let d=class Pn extends l.Disposable{constructor(A,t,r,n,i,o){super(),this.h=t,this.i=r,this.j=n,this.k=i,this.l=o,this.extensionsDownloadDir=A.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(A,t){await this.g;const r=(0,P.joinPath)(this.extensionsDownloadDir,this.v(A));try{await this.r(A,r,i=>this.i.download(A,i,t))}catch(i){throw new f.ExtensionManagementError(i.message,f.ExtensionManagementErrorCode.Download)}let n="Unverified";if(await this.m(A)){const i=await this.n(A);try{await this.k.verify(r.fsPath,i.fsPath)&&(n="Verified"),this.l.info(`Extension signature verification: ${A.identifier.id}. Verification status: ${n}.`)}catch(o){const c=o,a=c.code;if(a==="UnknownError")n="UnknownError",this.l.warn(`Extension signature verification: ${A.identifier.id}. Verification status: ${n}.`);else if(!c.didExecute)this.l.warn(`Extension signature verification: ${A.identifier.id}. Verification status: ${n} (${a})`);else throw await this.delete(i),await this.delete(r),new f.ExtensionManagementError(a,f.ExtensionManagementErrorCode.Signature)}}return{location:r,verificationStatus:n}}async m(A){if(!A.isSigned)return!1;const t=this.j.getValue("extensions.verifySignature");return(0,y.isBoolean)(t)?t:!0}async n(A){await this.g;const t=(0,P.joinPath)(this.extensionsDownloadDir,`${this.v(A)}${Pn.c}`);return await this.r(A,t,r=>this.i.downloadSignatureArchive(A,r)),t}async r(A,t,r){if(await this.h.exists(t))return;if(t.scheme!==I.Schemas.file){await r(t);return}const n=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,T.generateUuid)()}`);await this.h.exists(n)||await r(n);try{await this.t(n,t,Date.now()+2*60*1e3)}catch(i){try{await this.h.del(n)}catch{}if(i.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",A.identifier.id,t.path);else throw this.l.info(`Rename failed because of ${(0,k.getErrorMessage)(i)}. Deleted the file from downloaded location`,n.path),i}}async delete(A){await this.g,await this.h.del(A)}async t(A,t,r){try{await S.Promises.rename(A.fsPath,t.fsPath)}catch(n){if(C.isWindows&&n&&n.code==="EPERM"&&Date.now()<r)return this.l.info(`Failed renaming ${A} to ${t} with 'EPERM' error. Trying again...`),this.t(A,t,r);throw n}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const A=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(A.children){const t=[],r=[],n=[];for(const c of A.children)if(c.name.endsWith(Pn.c))n.push(c.resource);else{const a=p.ExtensionKey.parse(c.name);a&&r.push([a,c])}const i=(0,p.groupByExtension)(r,([c])=>c),o=[];for(const c of i)c.sort((a,s)=>w.rcompare(a[0].version,s[0].version)),t.push(...c.slice(1).map(a=>a[1].resource)),o.push(c[0][1]);o.sort((c,a)=>c.mtime-a.mtime),t.push(...o.slice(0,Math.max(0,o.length-this.f)).map(c=>c.resource)),t.push(...n),await E.Promises.settled(t.map(c=>(this.l.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(A){this.l.error(A)}}v(A){return this.f?p.ExtensionKey.create(A).toString().toLowerCase():(0,T.generateUuid)()}};d.c=".sigzip",d=Re([Te(0,g.INativeEnvironmentService),Te(1,h.IFileService),Te(2,f.IExtensionGalleryService),Te(3,b.IConfigurationService),Te(4,u.IExtensionSignatureVerificationService),Te(5,v.ILogService)],d),e.ExtensionsDownloader=d}),define(ve[235],be([1,0,6,2,27,35,33]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends k.Disposable{constructor(y,T,S,b,g,f,p){super(),this.f=y,this.g=T,this.h=S,this.i=b,this.j=g,this.k=f,this.l=p,this.a=this.B(new E.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new k.DisposableMap),this.m().then(null,u=>p.error(u))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(y=>this.p(y.added,y.removed))),this.B(this.i.onAddExtensions(y=>this.r(y))),this.B(this.i.onDidAddExtensions(y=>this.s(y))),this.B(this.i.onRemoveExtensions(y=>this.t(y))),this.B(this.i.onDidRemoveExtensions(y=>this.u(y))),this.B(this.k.onDidFilesChange(y=>this.v(y)))}async p(y,T){try{await Promise.all(T.map(S=>(this.c.deleteAndDispose(S.id),this.z(S.extensionsResource)))),y.length&&await Promise.all(y.map(S=>(this.c.set(S.id,(0,k.combinedDisposable)(this.k.watch(this.j.extUri.dirname(S.extensionsResource)),this.k.watch(S.extensionsResource))),this.y(S.extensionsResource))))}catch(S){throw this.l.error(S),S}}async r(y){for(const T of y.extensions)this.D(this.G(T.identifier,T.version),y.profileLocation)}async s(y){for(const T of y.extensions){const S=this.G(T.identifier,T.version);y.error?this.F(S,y.profileLocation):this.D(S,y.profileLocation)}}async t(y){for(const T of y.extensions)this.F(this.G(T.identifier,T.version),y.profileLocation)}async u(y){let T=!1;for(const S of y.extensions){const b=this.G(S.identifier,S.version);y.error?this.D(b,y.profileLocation):(this.F(b,y.profileLocation),T=T||!this.b.has(b))}T&&await this.C()}v(y){for(const T of this.h.profiles)y.contains(T.extensionsResource,0,1)&&this.w(T.extensionsResource)}async w(y){const T=[],S=[],b=await this.i.scanProfileExtensions(y),g=new Set,f=new Set;for(const[p,u]of this.b)u.has(y)&&f.add(p);for(const p of b){const u=this.G(p.identifier,p.version);g.add(u),f.has(u)||(T.push(p.identifier),this.D(u,y))}for(const p of f)if(!g.has(p)){const u=this.H(p);u&&(S.push(u.identifier),this.F(p,y))}(T.length||S.length)&&this.a.fire({added:T.length?{extensions:T,profileLocation:y}:void 0,removed:S.length?{extensions:S,profileLocation:y}:void 0})}async y(y){const T=await this.i.scanProfileExtensions(y);for(const S of T)this.D(this.G(S.identifier,S.version),y)}async z(y){for(const T of[...this.b.keys()])this.F(T,y);await this.C()}async C(){const T=(await this.f.getAllUserInstalled()).filter(S=>S.installedTimestamp&&!this.b.has(this.G(S.identifier,S.manifest.version)));T.length&&await this.f.markAsUninstalled(...T)}D(y,T){let S=this.b.get(y);S||this.b.set(y,S=new l.ResourceSet(b=>this.j.extUri.getComparisonKey(b))),S.add(T)}F(y,T){const S=this.b.get(y);S&&S.delete(T),S?.size||this.b.delete(y)}G(y,T){return`${C.ExtensionIdentifier.toKey(y.id)}@${T}`}H(y){const[T,S]=(0,I.getIdAndVersion)(y);return S?{identifier:{id:T},version:S}:void 0}}e.ExtensionsWatcher=P}),define(ve[236],be([1,0,205,40]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function l(I,C,P,w,y,T,S){const b={"X-Market-Client-Id":`VSCode ${I}`,"User-Agent":`VSCode ${I} (${C.nameShort})`};if((0,k.supportsTelemetry)(C,P)&&(0,k.getTelemetryLevel)(w)===3){const g=await(0,E.getServiceMachineId)(P,y,T),{machineId:f}=await S.getTelemetryInfo();b["X-Market-User-Id"]=g,b["VSCode-SessionId"]=f||g}return b}e.resolveMarketplaceHeaders=l}),define(ve[115],be([1,0,116,18,14,2,13,7,21,25,32,35,12,78,3,4]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let u=class extends g.LanguagePackBaseService{constructor(D,A,t,r){super(t),this.h=D,this.i=r,this.g=this.B(new h(A,r)),this.h.registerParticipant({postInstall:async n=>this.j(n),postUninstall:async n=>this.k(n)})}async getBuiltInExtensionTranslationsUri(D){const t=(await this.g.getLanguagePacks())[f.Language.value()];if(!t){this.i.warn(`No language pack found for ${f.Language.value()}`);return}const r=t.translations[D];return r?p.URI.file(r):void 0}async getInstalledLanguages(){const D=await this.g.getLanguagePacks(),A=Object.keys(D).map(t=>{const r=D[t];return{...this.f(t,r.label),extensionId:r.extensions[0].extensionIdentifier.id}});return A.push(this.f("en","English")),A.sort((t,r)=>t.label.localeCompare(r.label)),A}async j(D){D&&D.manifest&&D.manifest.contributes&&D.manifest.contributes.localizations&&D.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",D.identifier.id),await this.update())}async k(D){const A=await this.g.getLanguagePacks();Object.keys(A).some(t=>A[t]&&A[t].extensions.some(r=>(0,S.areSameExtensions)(r.extensionIdentifier,D.identifier)))&&(this.i.info("Removing language packs from the extension",D.identifier.id),await this.update())}async update(){const[D,A]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),t=await this.g.update(A);return!(0,k.equals)(Object.keys(D),Object.keys(t))}};u=Re([Te(0,T.IExtensionManagementService),Te(1,y.INativeEnvironmentService),Te(2,T.IExtensionGalleryService),Te(3,b.ILogService)],u),e.NativeLanguagePackService=u;let h=class extends I.Disposable{constructor(D,A){super(),this.i=A,this.c={},this.f=(0,P.join)(D.userDataPath,"languagepacks.json"),this.g=new l.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(D){return this.m(A=>{Object.keys(A).forEach(t=>delete A[t]),this.j(A,...D)}).then(()=>this.c)}j(D,...A){for(const t of A)t&&t.manifest&&t.manifest.contributes&&t.manifest.contributes.localizations&&t.manifest.contributes.localizations.length&&this.k(D,t);Object.keys(D).forEach(t=>this.l(D[t]))}k(D,A){const t=A.identifier,r=A.manifest.contributes&&A.manifest.contributes.localizations?A.manifest.contributes.localizations:[];for(const n of r)if(A.location.scheme===C.Schemas.file&&v(n)){let i=D[n.languageId];i||(i={hash:"",extensions:[],translations:{},label:n.localizedLanguageName??n.languageName},D[n.languageId]=i);const o=i.extensions.filter(c=>(0,S.areSameExtensions)(c.extensionIdentifier,t))[0];o?o.version=A.manifest.version:i.extensions.push({extensionIdentifier:t,version:A.manifest.version});for(const c of n.translations)i.translations[c.id]=(0,P.join)(A.location.fsPath,c.path)}}l(D){if(D){const A=(0,E.createHash)("md5");for(const t of D.extensions)A.update(t.extensionIdentifier.uuid||t.extensionIdentifier.id).update(t.version);D.hash=A.digest("hex")}}m(D=()=>null){return this.g.queue(()=>{let A=null;return w.Promises.readFile(this.f,"utf8").then(void 0,t=>t.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(t)).then(t=>{try{return JSON.parse(t)}catch{return{}}}).then(t=>(A=D(t),t)).then(t=>{for(const n of Object.keys(t))t[n]||delete t[n];this.c=t,this.h=!0;const r=JSON.stringify(this.c);return this.i.debug("Writing language packs",r),w.Promises.writeFile(this.f,r)}).then(()=>A,t=>this.i.error(t))})}};h=Re([Te(0,y.INativeEnvironmentService),Te(1,b.ILogService)],h);function v(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const D of d.translations)if(typeof D.id!="string"||typeof D.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(ve[237],be([1,0,9,23,40]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",C="https://mobile.events.data.microsoft.com/ping";async function P(y,T,S){const b=await new Promise((h,v)=>{ae(["@microsoft/1ds-core-js"],h,v)}),g=await new Promise((h,v)=>{ae(["@microsoft/1ds-post-js"],h,v)}),f=new b.AppInsightsCore,p=new g.PostChannel,u={instrumentationKey:y,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(S){u.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:S};u.extensionConfig[p.identifier]=h}return f.initialize(u,[]),f.addTelemetryInitializer(h=>{T&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),f}class w{constructor(T,S,b,g,f){this.e=T,this.f=S,this.g=b,this.h=f,this.c=I,this.d=C,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(T){if(!!this.a){if(typeof this.a!="string"){T(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(S=>{T(S)},S=>{(0,E.onUnexpectedError)(S),console.error(S)})}}log(T,S){if(!this.a)return;S=(0,k.mixin)(S,this.g),S=(0,l.validateTelemetryData)(S);const b=this.f+"/"+T;try{this.i(g=>{g.pluginVersionString=S?.properties.version??"Unknown",g.track({name:b,baseData:{name:b,properties:S?.properties,measurements:S?.measurements}})})}catch{}}flush(){return this.a?new Promise(T=>{this.i(S=>{S.unload(!0,()=>{this.a=void 0,T(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=w}),define(ve[238],be([1,0,2,23,3,16,188,24,52,51,26,39,29,40]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(h,v,d){this.k=v,this.l=d,this.d={},this.i=new E.DisposableStore,this.j=[],this.b=h.appenders,this.c=h.commonProperties||Promise.resolve({}),this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const D of this.f)this.j.push(new RegExp((0,I.escapeRegExpCharacters)(D),"gi")),D.indexOf("\\")>=0&&this.j.push(new RegExp((0,I.escapeRegExpCharacters)(D.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(D=>{(D.affectsConfiguration(b.TELEMETRY_SETTING_ID)||D.affectsConfiguration(b.TELEMETRY_OLD_SETTING_ID)||D.affectsConfiguration(b.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(h,v){this.d[h]=v}m(){let h=(0,g.getTelemetryLevel)(this.k);const v=this.l.enabledTelemetryLevels;if(v){this.h=this.sendErrorTelemetry?v.error:!1;const d=v.usage?3:v.error?2:0;h=Math.min(h,d)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const h=await this.c,v=h.sessionID,d=h["common.machineId"],D=h["common.firstSessionDate"],A=h["common.msftInternal"];return{sessionId:v,machineId:d,firstSessionDate:D,msftInternal:A}}dispose(){this.i.dispose()}n(h,v,d){return this.g<v?Promise.resolve(void 0):this.c.then(D=>{d=(0,k.mixin)(d,this.d),d=(0,g.cleanData)(d,this.j),d=(0,k.mixin)(d,D),this.b.forEach(A=>A.log(h,d))},D=>{console.error(D)})}publicLog(h,v){return this.n(h,3,v)}publicLog2(h,v){return this.publicLog(h,v)}publicLogError(h,v){return this.h?this.n(h,2,v):Promise.resolve(void 0)}publicLogError2(h,v){return this.publicLogError(h,v)}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=Re([Te(1,P.IConfigurationService),Te(2,T.IProductService)],f),e.TelemetryService=f;function p(){const u=(0,C.localize)(0,null,y.default.nameLong),h=y.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",y.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=l.isWeb?"":(0,C.localize)(3,null),d=(0,C.localize)(4,null),D=(0,C.localize)(5,null),A=(0,C.localize)(6,null),t=(0,C.localize)(7,null),r=`
|       | ${d} | ${D} | ${A} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,C.localize)(8,null);return`
${u} ${h} ${v}

&nbsp;

${t}
${r}

&nbsp;

${n}
`}S.Registry.as(w.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(w.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:y.default.privacyStatementUrl?(0,C.localize)(16,null,y.default.nameLong,y.default.privacyStatementUrl):(0,C.localize)(15,null,y.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ve[239],be([1,0,24,5,26,29,238,40]),function(ae,e,E,k,l,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let w=class extends C.TelemetryService{constructor(T,S,b,g){super(T,b,g),this.o=S}publicLog(T,S){return this.o<3?Promise.resolve(void 0):super.publicLog(T,S)}publicLog2(T,S){return this.publicLog(T,S)}publicLogError(T,S){return this.o<2?Promise.resolve(void 0):super.publicLogError(T,S)}publicLogError2(T,S){return this.publicLogError(T,S)}async updateInjectedTelemetryLevel(T){if(T===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,T):T,this.o===0&&this.dispose()}};w=Re([Te(2,E.IConfigurationService),Te(3,l.IProductService)],w),e.ServerTelemetryService=w,e.ServerNullTelemetryService=new class extends P.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,k.refineServiceDecorator)(I.ITelemetryService)}),define(ve[240],be([1,0,283,237]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class l extends k.AbstractOneDataSystemAppender{constructor(C,P,w,y){const T={sendPOST:(S,b)=>{const g={method:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data)}};try{const f=E.request(S.urlString,g,p=>{p.on("data",function(u){b(p.statusCode??200,p.headers,u.toString())}),p.on("error",function(u){b(0,{})})});f.write(S.data),f.end()}catch{b(0,{})}}};super(C,P,w,y,T)}}e.OneDataSystemAppender=l}),define(ve[241],be([1,0,9,231]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class l extends k.default{i(){(0,E.setUnexpectedErrorHandler)(P=>console.error(P));const C=[];process.on("unhandledRejection",(P,w)=>{C.push(w),setTimeout(()=>{const y=C.indexOf(w);y>=0&&w.catch(T=>{C.splice(y,1),(0,E.isCancellationError)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T.stack&&console.warn(`stack trace: ${T.stack}`),P&&(0,E.onUnexpectedError)(P))})},1e3)}),process.on("rejectionHandled",P=>{const w=C.indexOf(P);w>=0&&C.splice(w,1)}),process.on("uncaughtException",P=>{(0,E.isSigPipeError)(P)||(0,E.onUnexpectedError)(P)})}}e.default=l}),define(ve[117],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var E;(function(k){k[k.Replace=1]="Replace",k[k.Append=2]="Append",k[k.Prepend=3]="Prepend"})(E=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(ve[118],be([1,0,3,117]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class l{constructor(w){this.collections=w,this.map=new Map,w.forEach((y,T)=>{const S=y.map.entries();let b=S.next();for(;!b.done;){const g=b.value[0];let f=this.map.get(g);if(f||(f=[],this.map.set(g,f)),f.length>0&&f[0].type===k.EnvironmentVariableMutatorType.Replace){b=S.next();continue}const p=b.value[1];f.unshift({extensionIdentifier:T,value:p.value,type:p.type}),b=S.next()}})}async applyToProcessEnvironment(w,y){let T;E.isWindows&&(T={},Object.keys(w).forEach(S=>T[S.toLowerCase()]=S));for(const[S,b]of this.map){const g=E.isWindows&&T[S.toLowerCase()]||S;for(const f of b){const p=y?await y(f.value):f.value;switch(f.type){case k.EnvironmentVariableMutatorType.Append:w[g]=(w[g]||"")+p;break;case k.EnvironmentVariableMutatorType.Prepend:w[g]=p+(w[g]||"");break;case k.EnvironmentVariableMutatorType.Replace:w[g]=p;break}}}}diff(w){const y=new Map,T=new Map,S=new Map;if(w.map.forEach((b,g)=>{const f=this.map.get(g),p=I(b,f);p&&y.set(g,p)}),this.map.forEach((b,g)=>{const f=w.map.get(g),p=I(b,f);p&&S.set(g,p)}),this.map.forEach((b,g)=>{const f=w.map.get(g),p=C(b,f);p&&T.set(g,p)}),!(y.size===0&&T.size===0&&S.size===0))return{added:y,changed:T,removed:S}}}e.MergedEnvironmentVariableCollection=l;function I(P,w){if(!w)return P;const y=new Set;w.forEach(S=>y.add(S.extensionIdentifier));const T=[];return P.forEach(S=>{y.has(S.extensionIdentifier)||T.push(S)}),T.length===0?void 0:T}function C(P,w){if(!w)return;const y=new Map;w.forEach(S=>y.set(S.extensionIdentifier,S));const T=[];return P.forEach(S=>{const b=y.get(S.extensionIdentifier);b&&(S.type!==b.type||S.value!==b.value)&&T.push(b)}),T.length===0?void 0:T}}),define(ve[81],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=E;function k(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=k;function l(C){return Array.from(C.entries()).map(P=>[P[0],E(P[1].map)])}e.serializeEnvironmentVariableCollections=l;function I(C){return new Map(C.map(P=>[P[0],{map:k(P[1])}]))}e.deserializeEnvironmentVariableCollections=I}),define(ve[242],be([1,0,14,19,6,2,12]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends I.Disposable{constructor(y,T){super(),this.h=T,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new l.Emitter),this.onCreateRequest=this.g.event,this.b=y===void 0?15e3:y}createRequest(y){return new Promise((T,S)=>{const b=++this.a;this.c.set(b,T),this.g.fire({requestId:b,...y});const g=new k.CancellationTokenSource;(0,E.timeout)(this.b,g.token).then(()=>S(`Request ${b} timed out (${this.b}ms)`)),this.f.set(b,[(0,I.toDisposable)(()=>g.cancel())])})}acceptReply(y,T){const S=this.c.get(y);S?(this.c.delete(y),(0,I.dispose)(this.f.get(y)||[]),this.f.delete(y),S(T)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${y}`)}};P=Re([Te(1,C.ILogService)],P),e.RequestStore=P}),define(ve[119],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var k;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(k=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var l;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsDefaultColor="terminal.integrated.tabs.defaultColor",d.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.TabStopWidth="terminal.integrated.tabStopWidth",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",d.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",d.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",d.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",d.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",d.SmoothScrolling="terminal.integrated.smoothScrolling"})(l=e.TerminalSettingId||(e.TerminalSettingId={}));var I;(function(d){d.FileName="ptyhost"})(I=e.TerminalLogConstants||(e.TerminalLogConstants={}));var C;(function(d){d.PowerShell="pwsh",d.Bash="bash",d.Fish="fish",d.Sh="sh",d.Csh="csh",d.Ksh="ksh",d.Zsh="zsh"})(C=e.PosixShellType||(e.PosixShellType={}));var P;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var w;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(w=e.TitleEventSource||(e.TitleEventSource={}));var y;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Logger="logger",d.Heartbeat="heartbeat"})(y=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,E.createDecorator)("ptyService");var T;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions",d.FailedShellIntegrationActivation="failedShellIntegrationActivation",d.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(T=e.ProcessPropertyType||(e.ProcessPropertyType={}));var S;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S=e.HeartbeatConstants||(e.HeartbeatConstants={}));var b;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(b=e.TerminalLocation||(e.TerminalLocation={}));var g;(function(d){d.TerminalView="view",d.Editor="editor"})(g=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var p;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(p=e.FlowControlConstants||(e.FlowControlConstants={}));var u;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(u=e.ProfileSource||(e.ProfileSource={}));var h;(function(d){d[d.Off=0]="Off",d[d.FinalTerm=1]="FinalTerm",d[d.VSCode=2]="VSCode"})(h=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var v;(function(d){d[d.Unknown=0]="Unknown",d[d.Shutdown=1]="Shutdown",d[d.Process=2]="Process",d[d.User=3]="User",d[d.Extension=4]="Extension"})(v=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ve[243],be([1,0,3]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function k(C){let P=C;P.includes("\\")&&(P=P.replace(/\\/g,"\\\\"));const w=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return P=P.replace(w,""),`'${P}'`}e.escapeNonWindowsPath=k;function l(C,P,w){if(!C)return"";if(!P)return C;P.match(/[\/\\]$/)&&(P=P.slice(0,P.length-1));const y=C.replace(/\\/g,"/").toLowerCase(),T=P.replace(/\\/g,"/").toLowerCase();return y.includes(T)?`~${w}${C.slice(P.length+1)}`:C}e.collapseTildePath=l;function I(C){return C.match(/^['"].*['"]$/)&&(C=C.substring(1,C.length-1)),E.OS===1&&C&&C[1]===":"?C[0].toUpperCase()+C.substring(1):C}e.sanitizeCwd=I}),define(ve[244],be([1,0,45,4,190,89]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function C(b,g){const f=[{name:null,description:(0,l.localize)(0,null)}];return f.push(...b.map(p=>({name:p.profileName,description:P(p)}))),g&&f.push(...g.map(p=>({name:p.title,description:w(p)}))),{values:f.map(p=>p.name),markdownDescriptions:f.map(p=>p.description)}}e.createProfileSchemaEnums=C;function P(b){let g=`$(${I.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:E.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?g+=`
- args: "${b.args}"`:g+=`
- args: [${b.args.length===0?"":`'${b.args.join("','")}'`}]`),b.overrideName!==void 0&&(g+=`
- overrideName: ${b.overrideName}`),b.color&&(g+=`
- color: ${b.color}`),b.env&&(g+=`
- env: ${JSON.stringify(b.env)}`),g}function w(b){return`$(${I.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:E.Codicon.terminal.id}) ${b.title}
- extensionIdentifier: ${b.extensionIdentifier}`}function y(b,g){if(!b&&!g)return!0;if(typeof b=="string"&&typeof g=="string")return b===g;if(Array.isArray(b)&&Array.isArray(g)){if(b.length!==g.length)return!1;for(let f=0;f<b.length;f++)if(b[f]!==g[f])return!1;return!0}return!1}e.terminalProfileArgsMatch=y;function T(b,g){if(!b&&!g)return!0;if(!b||!g)return!1;if(I.ThemeIcon.isThemeIcon(b)&&I.ThemeIcon.isThemeIcon(g))return b.id===g.id&&b.color===g.color;if(typeof b=="object"&&"light"in b&&"dark"in b&&typeof g=="object"&&"light"in g&&"dark"in g){const f=b,p=g;if((k.URI.isUri(f.light)||S(f.light))&&(k.URI.isUri(f.dark)||S(f.dark))&&(k.URI.isUri(p.light)||S(p.light))&&(k.URI.isUri(p.dark)||S(p.dark)))return f.light.path===p.light.path&&f.dark.path===p.dark.path}if(k.URI.isUri(b)&&k.URI.isUri(g)||S(b)||S(g)){const f=b,p=g;return f.path===p.path&&f.scheme===p.scheme}return!1}e.terminalIconsEqual=T;function S(b){return b?typeof b.path=="string"&&typeof b.scheme=="string":!1}e.isUriComponents=S}),define(ve[245],be([1,0,45,189,52,39,244]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,E.getAllCodicons)(),D=>D.id),markdownEnumDescriptions:Array.from((0,E.getAllCodicons)(),D=>`$(${D.id})`)};const P={args:{description:(0,k.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,k.localize)(1,null),type:"boolean"},icon:{description:(0,k.localize)(2,null),...e.terminalIconSchema},color:{description:(0,k.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,k.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},w={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},y={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(6,null),type:["string"],items:{type:"string"}},...P}},T=(0,k.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),S=(0,k.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),b=(0,k.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),g=(0,k.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),f=(0,k.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),p=(0,k.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),u={id:"terminal",order:100,title:(0,k.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:T},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:T},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:S},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,k.localize)(26,null)}},{type:"string",markdownDescription:(0,k.localize)(27,null)}],default:[],markdownDeprecationMessage:b},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,k.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(30,null),type:"string"},id:{description:(0,k.localize)(31,null),type:"string"},title:{description:(0,k.localize)(32,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(34,null),type:"string"},id:{description:(0,k.localize)(35,null),type:"string"},title:{description:(0,k.localize)(36,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(38,null),type:"string"},id:{description:(0,k.localize)(39,null),type:"string"},title:{description:(0,k.localize)(40,null),type:"string"},...P}},{type:"null"},w]}},["terminal.integrated.useWslProfiles"]:{description:(0,k.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,k.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,k.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,k.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,k.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){I.Registry.as(l.Extensions.Configuration).registerConfiguration(u),d()}e.registerTerminalPlatformConfiguration=h;let v;function d(D,A){const t=I.Registry.as(l.Extensions.Configuration);let r;D&&(r=(0,C.createProfileSchemaEnums)(D?.profiles,A));const n=v;v={id:"terminal",order:100,title:(0,k.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,k.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:D?.os===3?r?.values:void 0,markdownEnumDescriptions:D?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,k.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:D?.os===2?r?.values:void 0,markdownEnumDescriptions:D?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,k.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:D?.os===1?r?.values:void 0,markdownEnumDescriptions:D?.os===1?r?.markdownDescriptions:void 0}}},t.updateConfigurations({add:[v],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=d}),define(ve[246],be([1,0,31,13,23,7,3,28,16,8,21,117,81,118]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function f(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let o=0;return i&&i.length===4&&(o=parseInt(i[3])),o}e.getWindowsBuildNumber=f;async function p(i,o,c,a=P.env,s=T.Promises.exists){if(I.isAbsolute(i))return await s(i)?i:void 0;if(o===void 0&&(o=P.cwd()),I.dirname(i)!=="."){const $=I.join(o,i);return await s($)?$:void 0}const R=(0,l.getCaseInsensitive)(a,"PATH");if(c===void 0&&(0,y.isString)(R)&&(c=R.split(I.delimiter)),c===void 0||c.length===0){const $=I.join(o,i);return await s($)?$:void 0}for(const $ of c){let ie;if(I.isAbsolute($)?ie=I.join($,i):ie=I.join(o,$,i),await s(ie))return ie;if(C.isWindows){let ne=ie+".com";if(await s(ne)||(ne=ie+".exe",await s(ne)))return ne}}const L=I.join(o,i);return await s(L)?L:void 0}e.findExecutable=p;function u(i,o,c,a,s){if(!o.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||C.isWindows&&!o.windowsEnableConpty)return;const m=i.args,R=P.platform==="win32"?I.basename(i.executable).toLowerCase():I.basename(i.executable),L=I.dirname(k.FileAccess.asFileUri("").fsPath);let $;const ie={VSCODE_INJECTION:"1"};if(C.isWindows){if(R==="pwsh.exe"||R==="powershell.exe")return!m||r(m)?$=d.get(v.WindowsPwsh):t(m)&&($=d.get(v.WindowsPwshLogin)),$?($=[...$],$[$.length-1]=(0,w.format)($[$.length-1],L,""),o.shellIntegration.suggestEnabled&&(ie.VSCODE_SUGGEST="1"),{newArgs:$,envMixin:ie}):void 0;a.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(R){case"bash":return!m||m.length===0?$=d.get(v.Bash):n(m)&&(ie.VSCODE_SHELL_LOGIN="1",h(o,ie),$=d.get(v.Bash)),$?($=[...$],$[$.length-1]=(0,w.format)($[$.length-1],L),{newArgs:$,envMixin:ie}):void 0;case"fish":{const ne=c?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",F=I.join(L,"out/vs/workbench/contrib/xdg_data");return ie.XDG_DATA_DIRS=`${ne}:${F}`,h(o,ie),{newArgs:void 0,envMixin:ie}}case"pwsh":return!m||r(m)?$=d.get(v.Pwsh):t(m)&&($=d.get(v.PwshLogin)),$?(o.shellIntegration.suggestEnabled&&(ie.VSCODE_SUGGEST="1"),$=[...$],$[$.length-1]=(0,w.format)($[$.length-1],L,""),{newArgs:$,envMixin:ie}):void 0;case"zsh":{if(!m||m.length===0?$=d.get(v.Zsh):n(m)?($=d.get(v.ZshLogin),h(o,ie)):(m===d.get(v.Zsh)||m===d.get(v.ZshLogin))&&($=m),!$)return;$=[...$],$[$.length-1]=(0,w.format)($[$.length-1],L);let ne;try{ne=E.userInfo().username}catch{ne="unknown"}const F=I.join(E.tmpdir(),`${ne}-${s.applicationName}-zsh`);ie.ZDOTDIR=F;const _=c?.ZDOTDIR??E.homedir()??"~";ie.USER_ZDOTDIR=_;const z=[];return z.push({source:I.join(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:I.join(F,".zshrc")}),z.push({source:I.join(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:I.join(F,".zprofile")}),z.push({source:I.join(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:I.join(F,".zshenv")}),z.push({source:I.join(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:I.join(F,".zlogin")}),{newArgs:$,envMixin:ie,filesToCopy:z}}}a.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=u;function h(i,o){if(C.isMacintosh&&i.environmentVariableCollections){const c=(0,b.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),s=new g.MergedEnvironmentVariableCollection(c).map.get("PATH"),m=[];if(s)for(const R of s)R.type===S.EnvironmentVariableMutatorType.Prepend&&m.push(R.value);m.length>0&&(o.VSCODE_PATH_PREFIX=m.join(""))}}var v;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(v||(v={}));const d=new Map;d.set(v.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(v.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(v.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(v.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(v.Zsh,["-i"]),d.set(v.ZshLogin,["-il"]),d.set(v.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const D=["-login","-l"],A=["-nol","-nologo"];function t(i){return typeof i=="string"?D.includes(i.toLowerCase()):i.length===1&&D.includes(i[0].toLowerCase())||i.length===2&&(D.includes(i[0].toLowerCase())||D.includes(i[1].toLowerCase()))&&(A.includes(i[0].toLowerCase())||A.includes(i[1].toLowerCase()))}function r(i){return typeof i=="string"?A.includes(i.toLowerCase()):i.length===0||i?.length===1&&A.includes(i[0].toLowerCase())}function n(i){return i==="string"&&D.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&D.includes(i[0].toLowerCase())}}),define(ve[247],be([1,0,49,45,7,3,8,21,97,246]),function(ae,e,E,k,l,I,C,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let T,S=!0;function b(r,n,i,o,c=process.env,a,s,m,R){return a=a||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},I.isWindows?g(i,a,c,s,o.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:o.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:o.getValue("terminal.integrated.defaultProfile.windows"),R,m):D(a,s,i,r&&typeof r=="object"?{...r}:o.getValue(I.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:o.getValue(I.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),R,m,c)}e.detectAvailableProfiles=b;async function g(r,n,i,o,c,a,s,m,R){const L=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),$=`${process.env.windir}\\${L?"Sysnative":"System32"}`;let ie=!1;(0,y.getWindowsBuildNumber)()>=16299&&(ie=!0),await u(m);const ne=new Map;if(r){ne.set("PowerShell",{source:"PowerShell",icon:k.Codicon.terminalPowershell,isAutoDetected:!0}),ne.set("Windows PowerShell",{path:`${$}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:k.Codicon.terminalPowershell,isAutoDetected:!0}),ne.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ne.set("Command Prompt",{path:`${$}\\cmd.exe`,icon:k.Codicon.terminalCmd,isAutoDetected:!0}),ne.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ne.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:k.Codicon.terminalBash,isAutoDetected:!0});const _=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ne.set("Cmder",{path:`${$}\\cmd.exe`,args:["/K",_],requiresPath:process.env.CMDER_ROOT?_:{path:_,isUnsafe:!0},isAutoDetected:!0})}A(a,ne);const F=await f(ne.entries(),s,n,i,o,R);if(r||c)try{const _=await v(`${$}\\${ie?"wsl":"bash"}.exe`,s);for(const z of _)(!a||!(z.profileName in a))&&F.push(z)}catch{S&&(o?.info("WSL is not installed, so could not detect WSL profiles"),S=!1)}return F}async function f(r,n,i,o=process.env,c,a){const s=[];for(const[m,R]of r){if(R===null)continue;let L,$,ie;if("source"in R){const z=T?.get(R.source);if(!z)continue;L=z.paths,$=R.args||z.args,R.icon?ie=p(R.icon):z.icon&&(ie=z.icon)}else L=Array.isArray(R.path)?R.path:[R.path],$=I.isWindows||Array.isArray(R.args)?R.args:void 0,ie=p(R.icon);let ne;if(a){const z=L.map(le=>typeof le=="string"?le:le.path),x=await a(z);ne=new Array(L.length);for(let le=0;le<L.length;le++)typeof L[le]=="string"?ne[le]=x[le]:ne[le]={path:x[le],isUnsafe:!0}}else ne=L.slice();let F;if(R.requiresPath){let z;if((0,C.isString)(R.requiresPath)?z=R.requiresPath:(z=R.requiresPath.path,R.requiresPath.isUnsafe&&(F=z)),!await i.existsFile(z))continue}const _=await t(m,n,ne,i,o,$,R.env,R.overrideName,R.isAutoDetected,F);_?(_.isAutoDetected=R.isAutoDetected,_.icon=ie,_.color=R.color,s.push(_)):c?.debug("Terminal profile not validated",m,L)}return c?.debug("Validated terminal profiles",s),s}function p(r){return typeof r=="string"?{id:r}:r}async function u(r){T&&!r||(T=new Map,T.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),T.set("PowerShell",{profileName:"PowerShell",paths:r||await h(),icon:k.Codicon.terminalPowershell}))}async function h(){const r=[];for await(const n of(0,w.enumeratePowerShellInstallations)())r.push(n.exePath);return r}async function v(r,n){const i=[],o=await new Promise((s,m)=>{E.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(R,L)=>{if(R)return m("Problem occurred when getting wsl distros");s(L)})});if(!o)return[];const c=new RegExp(/[\r?\n]/),a=o.split(c).filter(s=>s.trim().length>0&&s!=="");for(const s of a){if(s===""||s.startsWith("docker-desktop"))continue;const m=`${s} (WSL)`,R={profileName:m,path:r,args:["-d",`${s}`],isDefault:m===n,icon:d(s),isAutoDetected:!1};i.push(R)}return i}function d(r){return r.includes("Ubuntu")?k.Codicon.terminalUbuntu:r.includes("Debian")?k.Codicon.terminalDebian:k.Codicon.terminalLinux}async function D(r,n,i,o,c,a,s,m){const R=new Map;if(i){const L=(await r.readFile("/etc/shells")).toString(),$=a||L.split(`
`).filter(ne=>ne.trim().includes("#")&&ne.trim().length>0),ie=new Map;for(const ne of $){let F=(0,l.basename)(ne),_=ie.get(F)||0;_++,_>1&&(F=`${F} (${_})`),ie.set(F,_),R.set(F,{path:ne,isAutoDetected:!0})}}return A(o,R),await f(R.entries(),c,r,m,n,s)}function A(r,n){if(!!r)for(const[i,o]of Object.entries(r))o===null||!("path"in o)&&!("source"in o)?n.delete(i):(o.icon=o.icon||n.get(i)?.icon,n.set(i,o))}async function t(r,n,i,o,c,a,s,m,R,L){if(i.length===0)return Promise.resolve(void 0);const $=i.shift();if($==="")return t(r,n,i,o,c,a,s,m,R);const ie=typeof $!="string"&&$.isUnsafe,ne=typeof $=="string"?$:$.path,F={profileName:r,path:ne,args:a,env:s,overrideName:m,isAutoDetected:R,isDefault:r===n,isUnsafePath:ie,requiresUnsafePath:L};if((0,l.basename)(ne)===ne){const z=c.PATH?c.PATH.split(l.delimiter):void 0,x=await(0,y.findExecutable)(ne,void 0,z,void 0,o.existsFile);return x?(F.path=x,F.isFromPath=!0,F):t(r,n,i,o,c,a)}return await o.existsFile((0,l.normalize)(ne))?F:t(r,n,i,o,c,a,s,m,R)}}),define(ve[248],be([1,0,6,2,13,3,41,101,24,25,102,80,12,242,119,245,247,107]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var v;(function(A){A[A.MaxRestarts=5]="MaxRestarts"})(v||(v={}));let d=0,D=class extends k.Disposable{constructor(t,r,n,i,o,c){super(),this.C=t,this.D=r,this.F=n,this.G=i,this.H=o,this.I=c,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new E.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new E.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new E.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new E.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new E.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new E.Emitter),this.onProcessData=this.s.event,this.t=this.B(new E.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new E.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new E.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new E.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new E.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new E.Emitter),this.onProcessExit=this.z.event,(0,p.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,k.toDisposable)(()=>this.O())),this.f=this.B(new g.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(I.isWindows)return process.env;try{return await(0,S.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(t){return this.H.error("ptyHost was unable to resolve shell environment",t),{}}}N(){const t={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsPath],env:{VSCODE_LAST_PTY_ID:d,VSCODE_PTY_LOG_NAME:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},r=(0,T.parsePtyHostPort)(this.G.args,this.G.isBuilt);r&&(r.break&&r.port?t.debugBrk=r.port:!r.break&&r.port&&(t.debug=r.port));const n=new P.Client(l.FileAccess.asFileUri("bootstrap-fork").fsPath,t);this.m.fire(),C.ProxyChannel.toService(n.getChannel(f.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(n.onDidProcessExit(c=>{this.l.fire(c.code),this.i||(this.g<=v.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${c.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${c.code}, giving up`))})),this.B(new h.RemoteLoggerChannelClient(this.I,n.getChannel(f.TerminalIpcChannels.Logger)));const o=C.ProxyChannel.toService(n.getChannel(f.TerminalIpcChannels.PtyHost));return this.B(o.onProcessData(c=>this.s.fire(c))),this.B(o.onProcessReady(c=>this.t.fire(c))),this.B(o.onProcessExit(c=>this.z.fire(c))),this.B(o.onDidChangeProperty(c=>this.y.fire(c))),this.B(o.onProcessReplay(c=>this.u.fire(c))),this.B(o.onProcessOrphanQuestion(c=>this.v.fire(c))),this.B(o.onDidRequestDetach(c=>this.w.fire(c))),[n,o]}dispose(){this.i=!0,super.dispose()}async createProcess(t,r,n,i,o,c,a,s,m,R,L){const $=setTimeout(()=>this.S(),f.HeartbeatConstants.CreateProcessTimeout),ie=await this.b.createProcess(t,r,n,i,o,c,a,s,m,R,L);return clearTimeout($),d=Math.max(d,ie),ie}updateTitle(t,r,n){return this.b.updateTitle(t,r,n)}updateIcon(t,r,n,i){return this.b.updateIcon(t,r,n,i)}attachToProcess(t){return this.b.attachToProcess(t)}detachFromProcess(t,r){return this.b.detachFromProcess(t,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(t){return this.b.start(t)}shutdown(t,r){return this.b.shutdown(t,r)}input(t,r){return this.b.input(t,r)}processBinary(t,r){return this.b.processBinary(t,r)}resize(t,r,n){return this.b.resize(t,r,n)}acknowledgeDataEvent(t,r){return this.b.acknowledgeDataEvent(t,r)}setUnicodeVersion(t,r){return this.b.setUnicodeVersion(t,r)}getInitialCwd(t){return this.b.getInitialCwd(t)}getCwd(t){return this.b.getCwd(t)}getLatency(t){return this.b.getLatency(t)}orphanQuestionReply(t){return this.b.orphanQuestionReply(t)}installAutoReply(t,r){return this.b.installAutoReply(t,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(t){return this.b.uninstallAutoReply(t)}getDefaultSystemShell(t){return this.b.getDefaultSystemShell(t)}async getProfiles(t,r,n,i=!1){const o=await this.c;return(0,u.detectAvailableProfiles)(r,n,i,this.F,o,void 0,this.H,this.W.bind(this,t))}getEnvironment(){return this.b.getEnvironment()}getWslPath(t,r){return this.b.getWslPath(t,r)}getRevivedPtyNewId(t){return this.b.getRevivedPtyNewId(t)}setTerminalLayoutInfo(t){return this.b.setTerminalLayoutInfo(t)}async getTerminalLayoutInfo(t){return await this.b.getTerminalLayoutInfo(t)}async requestDetachInstance(t,r){return this.b.requestDetachInstance(t,r)}async acceptDetachInstanceReply(t,r){return this.b.acceptDetachInstanceReply(t,r)}async freePortKillProcess(t){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(t)}async serializeTerminalState(t){return this.b.serializeTerminalState(t)}async reviveTerminalProcesses(t,r){return this.b.reviveTerminalProcesses(t,r)}async refreshProperty(t,r){return this.b.refreshProperty(t,r)}async updateProperty(t,r,n){return this.b.updateProperty(t,r,n)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier+f.HeartbeatConstants.BeatInterval*f.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${f.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(t,r){return this.f.createRequest({workspaceId:t,originalText:r})}async acceptPtyHostResolvedVariables(t,r){this.f.acceptReply(t,r)}};D=Re([Te(2,w.IConfigurationService),Te(3,y.IEnvironmentService),Te(4,b.ILogService),Te(5,b.ILoggerService)],D),e.PtyHostService=D}),define(ve[36],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(ve[120],be([1,0,36,206,17,20,144,6,2]),function(ae,e,E,k,l,I,C,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class y{constructor(b){this.uri=b,this.time=y._clock++}touch(){return this.time=y._clock++,this}}y._clock=0;let T=class{constructor(b){this.g=b,this.c=new w.DisposableStore,this.f=2**16;const g=new Map,f=p=>{let u=g.get(p.scheme);return u===void 0&&(u=b.hasProvider(p)&&!this.g.hasCapability(p,1024),g.set(p.scheme,u)),u};this.c.add(P.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(p=>{g.delete(p.scheme)})),this.extUri=new I.ExtUri(f),this.d=new C.SkipList((p,u)=>this.extUri.compare(p,u,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,I.normalizePath)(b));const g=this.d.get(b);return g?g.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new y(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((f,p)=>f[1].touch<p[1].touch?1:f[1].touch>p[1].touch?-1:0);y._clock=0,this.d.clear();const g=this.f*.5;for(let f=0;f<g;f++)this.d.set(b[f][0],b[f][1].touch())}};T=Re([Te(0,l.IFileService)],T),e.UriIdentityService=T,(0,k.registerSingleton)(E.IUriIdentityService,T,1)}),define(ve[82],be([1,0,192,7,59,20,4,5,13]),function(ae,e,E,k,l,I,C,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function y(n){const i=n;return typeof i?.id=="string"&&C.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=y;function T(n){return typeof n?.id=="string"&&!y(n)&&!b(n)}e.isEmptyWorkspaceIdentifier=T,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function S(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,k.basename)(n)}:i?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=S;function b(n){const i=n;return typeof i?.id=="string"&&C.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=b;function g(n){const i=n;if(i?.uri)return{id:i.id,uri:C.URI.revive(i.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:C.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=g;var f;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function p(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=p;function u(n){const i=n;return!!(i&&typeof i=="object"&&C.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=u;class h{constructor(i,o,c,a,s){this.h=i,this.j=c,this.k=a,this.l=s,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class v{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,I.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=v;function d(n){return new v({uri:n,index:0,name:(0,I.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=d,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(n,i){return I.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=D;function A(n){let i;return C.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===w.Schemas.tmp}e.isTemporaryWorkspace=A;function t(n,i){return!D(n,i)&&!A(n)}e.isSavedWorkspace=t;function r(n){return(typeof n=="string"?(0,k.extname)(n):(0,I.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(ve[34],be([1,0,94,6,2,20,4,191,25,17,5,12,82,27,36,14,22,16,8]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function d(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&C.URI.isUri(i.location)&&C.URI.isUri(i.globalStorageHome)&&C.URI.isUri(i.settingsResource)&&C.URI.isUri(i.keybindingsResource)&&C.URI.isUri(i.tasksResource)&&C.URI.isUri(i.snippetsHome)&&C.URI.isUri(i.extensionsResource))}e.isUserDataProfile=d,e.IUserDataProfilesService=(0,T.createDecorator)("IUserDataProfilesService");function D(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:C.URI.revive(n.location).with({scheme:i}),globalStorageHome:C.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:C.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:C.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:C.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:C.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:C.URI.revive(n.extensionsResource)?.with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.reviveProfile=D;function A(n,i,o,c){return{id:n,name:i,location:o,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,I.joinPath)(o,"globalStorage"),settingsResource:(0,I.joinPath)(o,"settings.json"),keybindingsResource:(0,I.joinPath)(o,"keybindings.json"),tasksResource:(0,I.joinPath)(o,"tasks.json"),snippetsHome:(0,I.joinPath)(o,"snippets"),extensionsResource:(0,I.joinPath)(o,"extensions.json"),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=A;let t=class extends l.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(i,o,c,a){super(),this.m=i,this.n=o,this.r=c,this.s=a,this.f=!0,this.g=this.B(new k.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new k.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new k.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new k.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new g.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,I.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(i){this.f!==i&&(this.t=void 0,this.f=i)}isEnabled(){return this.f}get u(){if(!this.t){const i=[];if(this.f)for(const s of this.I()){if(!s.name||!(0,v.isString)(s.name)||!s.location){this.s.warn("Skipping the invalid stored profile",s.location||s.name);continue}i.push(A((0,I.basename)(s.location),s.name,s.location,{shortName:s.shortName,useDefaultFlags:s.useDefaultFlags}))}const o=new g.ResourceMap,c=new Map,a=this.v();if(i.unshift({...a,extensionsResource:this.N()??a.extensionsResource,isDefault:!0}),i.length){const s=this.L();if(s.workspaces)for(const[m,R]of Object.entries(s.workspaces)){const L=C.URI.parse(m),$=i.find(ie=>ie.id===R);$&&o.set(L,$)}if(s.emptyWindows)for(const[m,R]of Object.entries(s.emptyWindows)){const L=i.find($=>$.id===R);L&&c.set(m,L)}}this.t={profiles:i,workspaces:o,emptyWindows:c}}return this.t}v(){return A("__default__profile__",(0,P.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(i){const o="Temp",c=new RegExp(`${(0,h.escapeRegExpCharacters)(o)}\\s(\\d+)`);let a=0;for(const m of this.profiles){const R=c.exec(m.name),L=R?parseInt(R[1]):0;a=L>a?L:a}const s=`${o} ${a+1}`;return this.createProfile((0,E.hash)((0,u.generateUuid)()).toString(16),s,{transient:!0},i)}async createNamedProfile(i,o,c){return this.createProfile((0,E.hash)((0,u.generateUuid)()).toString(16),i,o,c)}async createProfile(i,o,c,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const s=await this.w(i,o,c);return a&&await this.setProfileForWorkspace(a,s),s}async w(i,o,c){if(!(0,v.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(o);return a||(a=(async()=>{try{const s=this.profiles.find(L=>L.name===o||L.id===i);if(s)return s;const m=A(i,o,(0,I.joinPath)(this.profilesHome,i),c);await this.n.createFolder(m.location);const R=[];return this.h.fire({profile:m,join(L){R.push(L)}}),await p.Promises.settled(R),this.C([m],[],[]),m}finally{this.k.delete(o)}})(),this.k.set(o,a)),a}async updateProfile(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(a=>a.id===i.id);if(!c)throw new Error(`Profile '${i.name}' does not exist`);return c=A(c.id,o.name??c.name,c.location,{shortName:o.shortName??c.shortName,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags}),this.C([],[],[c]),c}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(a=>a.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);const c=[];this.i.fire({profile:o,join(a){c.push(a)}});try{await Promise.allSettled(c)}catch(a){this.s.error(a)}for(const a of[...this.u.emptyWindows.keys()])o.id===this.u.emptyWindows.get(a)?.id&&this.u.emptyWindows.delete(a);for(const a of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.G(),this.C([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(a){this.s.error(a)}}async setProfileForWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(a=>a.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.F(i,c)}unsetWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(i,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const i=await this.n.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.r.extUri.isEqual(c.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.l.profiles.filter(o=>!this.z(o));await Promise.allSettled(i.map(o=>this.removeProfile(o)))}getProfileForWorkspace(i){const o=this.y(i);return C.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindows.get(o)??this.u.emptyWindows.get(o)}y(i){return(0,b.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,b.isWorkspaceIdentifier)(i)?i.configPath:i.id}z(i){return!!([...this.l.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,i.location))||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,i.location))||[...this.u.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,i.location))||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,i.location)))}C(i,o,c){const a=[...this.profiles,...i],s=[];this.l.profiles=[];for(let m of a)m.isDefault||o.some(R=>m.id===R.id)||(m=c.find(R=>m.id===R.id)??m,m.isTransient?this.l.profiles.push(m):s.push({location:m.location,name:m.name,shortName:m.shortName,useDefaultFlags:m.useDefaultFlags}));this.J(s),this.t=void 0,this.D(i,o,c)}D(i,o,c){this.g.fire({added:i,removed:o,updated:c,all:this.profiles})}F(i,o,c){c=o?.isTransient?!0:c,c||this.F(i,void 0,!0);const a=this.y(i),s=c?this.l:this.u;C.URI.isUri(a)?(s.workspaces.delete(a),o&&s.workspaces.set(a,o)):(s.emptyWindows.delete(a),o&&s.emptyWindows.set(a,o)),c||this.G()}G(){const i={};for(const[c,a]of this.u.workspaces.entries())i[c.toString()]=a.id;const o={};for(const[c,a]of this.u.emptyWindows.entries())o[c.toString()]=a.id;this.M({workspaces:i,emptyWindows:o}),this.t=void 0}H(i){const o={},c=this.v();if(i.workspaces)for(const[s,m]of Object.entries(i.workspaces)){const R=C.URI.parse(m);o[s]=this.r.extUri.isEqual(R,c.location)?c.id:this.r.extUri.basename(R)}const a={};if(i.emptyWindows)for(const[s,m]of Object.entries(i.emptyWindows)){const R=C.URI.parse(m);a[s]=this.r.extUri.isEqual(R,c.location)?c.id:this.r.extUri.basename(R)}return{workspaces:o,emptyWindows:a}}I(){return[]}J(i){throw new Error("not implemented")}L(){return{}}M(i){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=Re([Te(0,w.IEnvironmentService),Te(1,y.IFileService),Te(2,f.IUriIdentityService),Te(3,S.ILogService)],t),e.UserDataProfilesService=t;class r extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(i){this.a=i}L(){return this.Q}M(i){this.Q=i}}e.InMemoryUserDataProfilesService=r}),define(ve[249],be([1,0,18,14,19,9,6,2,3,4,172,32,35,33,12,26,29,34]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var v;(function(n){n.Verified="Verified",n.Unverified="Unverified",n.UnknownError="UnknownError"})(v=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let d=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,o,c,a,s){super(),this.t=i,this.u=o,this.v=c,this.w=a,this.y=s,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new C.Emitter),this.m=this.B(new C.Emitter),this.n=this.B(new C.Emitter),this.p=this.B(new C.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:m})=>m.cancel()),this.k.forEach(m=>m.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const o=await this.getTargetPlatform();return i.allTargetPlatforms.some(c=>(0,S.isTargetPlatformCompatible)(c,i.allTargetPlatforms,o))}async installFromGallery(i,o={}){try{if(!this.t.isEnabled())throw new S.ExtensionManagementError(T.localize(0,null),S.ExtensionManagementErrorCode.Internal);const c=await this.G(i,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.z(c.manifest,c.extension,o)}catch(c){throw t(this.u,"extensionGallery:install",{extensionData:(0,b.getGalleryExtensionTelemetryData)(i),error:c}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(c),A(c)}}async uninstall(i,o={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,o)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,o,c){const a={...c,installOnlyNewlyAddedFromExtensionPack:y.URI.isUri(o)?c.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,g.isApplicationScopedExtension)(i)?this.y.defaultProfile.extensionsResource:c.profileLocation??this.P()},s=ne=>`${b.ExtensionKey.create(ne).toString()}${a.profileLocation?`-${a.profileLocation.toString()}`:""}`;if(!y.URI.isUri(o)){const ne=this.j.get(s(o));if(ne){this.v.info("Extensions is already requested to install",o.identifier.id);const{local:F}=await ne.task.waitUntilTaskIsFinished();return F}}const m=[],R=[],L=[],$=this.Q(i,o,a);y.URI.isUri(o)||this.j.set(s(o),{task:$,waitingTasks:[]}),this.l.fire({identifier:$.identifier,source:o,profileLocation:a.profileLocation}),this.v.info("Installing extension:",$.identifier.id),m.push({task:$,manifest:i});let ie=!1;try{if(a.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",$.identifier.id);else try{const F=await this.F($.identifier,i,!!a.installOnlyNewlyAddedFromExtensionPack,!!a.installPreReleaseVersion,a.profileLocation),_=await this.getInstalled(void 0,a.profileLocation);for(const{gallery:z,manifest:x}of(0,E.distinct)(F,({gallery:le})=>le.identifier.id)){ie=ie||!!x.extensionDependencies?.some(Y=>(0,b.areSameExtensions)({id:Y},$.identifier));const le=s(z),Ee=this.j.get(le);if(Ee){if(this.C($,Ee.task)){const Y=Ee.task.identifier;this.v.info("Waiting for already requested installing extension",Y.id,$.identifier.id),Ee.waitingTasks.push($),R.push(C.Event.toPromise(C.Event.filter(this.onDidInstallExtensions,H=>H.some(U=>(0,b.areSameExtensions)(U.identifier,Y)))).then(H=>{if(this.v.info("Finished waiting for already requested installing extension",Y.id,$.identifier.id),!H.find(te=>(0,b.areSameExtensions)(te.identifier,Y))?.local)throw new Error(`Extension ${Y.id} is not installed`)}))}}else if(!_.some(({identifier:Y})=>(0,b.areSameExtensions)(Y,z.identifier))){const Y=this.Q(x,z,{...a,donotIncludePackAndDependencies:!0});this.j.set(le,{task:Y,waitingTasks:[$]}),this.l.fire({identifier:Y.identifier,source:z,profileLocation:a.profileLocation}),this.v.info("Installing extension:",Y.identifier.id,$.identifier.id),m.push({task:Y,manifest:x})}}}catch(F){if(y.URI.isUri($.source))(0,E.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",$.identifier.id,F.message),(0,E.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",$.identifier.id,F.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",$.identifier.id),F}const ne=m.reduce((F,{task:_,manifest:z})=>(F.set(_.identifier.id.toLowerCase(),{task:_,manifest:z}),F),new Map);for(;ne.size;){let F;const _=[...ne.values()].filter(({manifest:z})=>!z.extensionDependencies?.some(x=>ne.has(x.toLowerCase())));_.length?F=ne.size===1?_:_.filter(({task:z})=>!(z===$&&!ie)):(this.v.info("Found extensions with circular dependencies",_.map(({task:z})=>z.identifier.id)),F=[...ne.values()]),await this.D(F.map(async({task:z})=>{const x=new Date().getTime();try{const{local:le}=await z.run();if(await this.D(this.s.map(Ee=>Ee.postInstall(le,z.source,a,l.CancellationToken.None))),!y.URI.isUri(z.source)){const Ee=z.operation===3,Y=Ee?void 0:(new Date().getTime()-z.source.lastUpdated)/1e3;if(t(this.u,Ee?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,b.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-x,durationSinceUpdate:Y}),w.isWeb&&z.operation!==3)try{await this.t.reportStatistic(le.manifest.publisher,le.manifest.name,le.manifest.version,"install")}catch{}}L.push({local:le,identifier:z.identifier,operation:z.operation,source:z.source,context:a.context,profileLocation:a.profileLocation,applicationScoped:le.isApplicationScoped})}catch(le){throw y.URI.isUri(z.source)||t(this.u,z.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,b.getGalleryExtensionTelemetryData)(z.source),verificationStatus:z.verificationStatus,duration:new Date().getTime()-x,error:le}),this.v.error("Error while installing the extension:",z.identifier.id),le}finally{ne.delete(z.identifier.id.toLowerCase())}}))}return R.length&&await this.D(R),L.forEach(({identifier:F})=>this.v.info("Extension installed successfully:",F.id)),this.m.fire(L),L.filter(({identifier:F})=>(0,b.areSameExtensions)(F,$.identifier))[0].local}catch(ne){if(m.forEach(({task:F})=>F.cancel()),L.length)try{const F=await Promise.allSettled(L.map(({local:_})=>this.R(_,{versionOnly:!0,profileLocation:a.profileLocation}).run()));for(let _=0;_<F.length;_++){const z=F[_],{identifier:x}=L[_];z.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",x.id):this.v.warn("Rollback: Error while uninstalling extension",x.id,(0,I.getErrorMessage)(z.reason))}}catch(F){this.v.warn("Error while rolling back extensions",(0,I.getErrorMessage)(F),L.map(({identifier:_})=>_.id))}throw this.m.fire(m.map(({task:F})=>({identifier:F.identifier,operation:2,source:F.source,context:a.context,profileLocation:a.profileLocation}))),ne}finally{for(const{task:ne}of m)ne.source&&!y.URI.isUri(ne.source)&&this.j.delete(s(ne.source))}}C(i,o){for(const[,{task:c,waitingTasks:a}]of this.j.entries())if(c===i&&(a.includes(o)||a.some(s=>this.C(s,o)))||c===o&&a[0]&&!this.C(i,a[0]))return!1;return!0}async D(i){const o=[],c=[],a=await Promise.allSettled(i);for(const s of a)s.status==="fulfilled"?o.push(s.value):c.push(s.reason);if(c.length)throw D(c);return o}async F(i,o,c,a,s){if(!this.t.isEnabled())return[];const m=await this.getInstalled(void 0,s),R=[],L=[],$=async(ie,ne)=>{R.push(ie);const F=ne.extensionDependencies||[],_=[...F];if(ne.extensionPack){const z=c?m.find(x=>(0,b.areSameExtensions)(x.identifier,ie)):void 0;for(const x of ne.extensionPack)z&&z.manifest.extensionPack&&z.manifest.extensionPack.some(le=>(0,b.areSameExtensions)({id:le},{id:x}))||_.every(le=>!(0,b.areSameExtensions)({id:le},{id:x}))&&_.push(x)}if(_.length){const z=_.filter(x=>R.every(le=>!(0,b.areSameExtensions)(le,{id:x})));if(z.length){const x=await this.t.getExtensions(z.map(le=>({id:le,preRelease:a})),l.CancellationToken.None);for(const le of x){if(R.find(H=>(0,b.areSameExtensions)(H,le.identifier)))continue;const Ee=F.some(H=>(0,b.areSameExtensions)({id:H},le.identifier));let Y;try{Y=await this.G(le,!1,a)}catch(H){if(H instanceof S.ExtensionManagementError&&H.code===S.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Ee){this.v.info("Skipping the packed extension as it cannot be installed",le.identifier.id);continue}else throw H}L.push({gallery:Y.extension,manifest:Y.manifest}),await $(Y.extension.identifier,Y.manifest)}}}};return await $(i,o),L}async G(i,o,c){if((await this.getExtensionsControlManifest()).malicious.some(R=>(0,b.areSameExtensions)(i.identifier,R)))throw new S.ExtensionManagementError(T.localize(1,null,i.identifier.id),S.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const R=await this.getTargetPlatform();throw new S.ExtensionManagementError(T.localize(2,null,i.identifier.id,this.w.nameLong,(0,S.TargetPlatformToString)(R)),S.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.H(i,o,c);if(s){if(c&&!o&&i.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new S.ExtensionManagementError(T.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),S.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!c&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],l.CancellationToken.None))[0]?new S.ExtensionManagementError(T.localize(4,null,i.identifier.id),S.ExtensionManagementErrorCode.ReleaseVersionNotFound):new S.ExtensionManagementError(T.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),S.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",s.identifier.id);const m=await this.t.getManifest(s,l.CancellationToken.None);if(m===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,S.ExtensionManagementErrorCode.Invalid);if(m.version!==s.version)throw new S.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,S.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:m}}async H(i,o,c){const a=await this.getTargetPlatform();let s=null;return!o&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==c&&(s=(await this.t.getExtensions([{...i.identifier,preRelease:c}],{targetPlatform:a,compatible:!0},l.CancellationToken.None))[0]||null),!s&&await this.t.isExtensionCompatible(i,c,a)&&(s=i),s||(o?s=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:a,compatible:!0},l.CancellationToken.None))[0]||null:s=await this.t.getCompatibleExtension(i,c,a)),s}async I(i,o){const c={...o,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},a=ie=>`${ie.id.toLowerCase()}${c.versionOnly?`-${i.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,s=this.k.get(a(i.identifier));if(s)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),s.waitUntilTaskIsFinished();const m=ie=>{const ne=this.R(ie,c);return this.k.set(a(ne.extension.identifier),ne),c.profileLocation?this.v.info("Uninstalling extension from the profile:",`${ie.identifier.id}@${ie.manifest.version}`,c.profileLocation.toString()):this.v.info("Uninstalling extension:",`${ie.identifier.id}@${ie.manifest.version}`),this.n.fire({identifier:ie.identifier,profileLocation:c.profileLocation,applicationScoped:ie.isApplicationScoped}),ne},R=(ie,ne)=>{ne?c.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${ie.identifier.id}@${ie.manifest.version}`,c.profileLocation.toString(),ne.message):this.v.error("Failed to uninstall extension:",`${ie.identifier.id}@${ie.manifest.version}`,ne.message):c.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${ie.identifier.id}@${ie.manifest.version}`,c.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${ie.identifier.id}@${ie.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,b.getLocalExtensionTelemetryData)(ie),error:ne}),this.p.fire({identifier:ie.identifier,error:ne?.code,profileLocation:c.profileLocation,applicationScoped:ie.isApplicationScoped})},L=[],$=[];try{L.push(m(i));const ie=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const ne=this.M(i,ie);for(const F of ne)this.k.has(a(F.identifier))?this.v.info("Extensions is already requested to uninstall",F.identifier.id):L.push(m(F))}c.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(L.map(ne=>ne.extension),ie,i),await this.D(L.map(async ne=>{try{if(await ne.run(),await this.D(this.s.map(F=>F.postUninstall(ne.extension,c,l.CancellationToken.None))),ne.extension.identifier.uuid)try{await this.t.reportStatistic(ne.extension.manifest.publisher,ne.extension.manifest.name,ne.extension.manifest.version,"uninstall")}catch{}R(ne.extension)}catch(F){const _=F instanceof S.ExtensionManagementError?F:new S.ExtensionManagementError((0,I.getErrorMessage)(F),S.ExtensionManagementErrorCode.Internal);throw R(ne.extension,_),_}finally{$.push(ne)}}))}catch(ie){const ne=ie instanceof S.ExtensionManagementError?ie:new S.ExtensionManagementError((0,I.getErrorMessage)(ie),S.ExtensionManagementErrorCode.Internal);for(const F of L){try{F.cancel()}catch{}$.includes(F)||R(F.extension,ne)}throw ne}finally{for(const ie of L)this.k.delete(a(ie.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",ie.extension.identifier.id)}}J(i,o,c){for(const a of i){const s=this.N(a,o);if(s.length){const m=s.filter(R=>!i.some(L=>(0,b.areSameExtensions)(L.identifier,R.identifier)));if(m.length)throw new Error(this.L(a,m,c))}}}L(i,o,c){return c===i?o.length===1?T.localize(6,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?T.localize(7,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):T.localize(8,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?T.localize(9,null,c.manifest.displayName||c.manifest.name,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?T.localize(10,null,c.manifest.displayName||c.manifest.name,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):T.localize(11,null,c.manifest.displayName||c.manifest.name,i.manifest.displayName||i.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}M(i,o,c=[]){if(c.indexOf(i)!==-1)return[];c.push(i);const a=i.manifest.extensionPack?i.manifest.extensionPack:[];if(a.length){const s=o.filter(R=>!R.isBuiltin&&a.some(L=>(0,b.areSameExtensions)({id:L},R.identifier))),m=[];for(const R of s)m.push(...this.M(R,o,c));return[...s,...m]}return[]}N(i,o){return o.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(a=>(0,b.areSameExtensions)({id:a},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};d=Re([Te(0,S.IExtensionGalleryService),Te(1,u.ITelemetryService),Te(2,f.ILogService),Te(3,p.IProductService),Te(4,h.IUserDataProfilesService)],d),e.AbstractExtensionManagementService=d;function D(n){const i=Array.isArray(n)?n:[n];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.joinErrors=D;function A(n){if(n instanceof S.ExtensionManagementError)return n;const i=new S.ExtensionManagementError(n.message,S.ExtensionManagementErrorCode.Internal);return i.stack=n.stack,i}function t(n,i,{extensionData:o,verificationStatus:c,duration:a,error:s,durationSinceUpdate:m}){let R,L;s&&(s instanceof S.ExtensionManagementError?(R=s.code,s.code===S.ExtensionManagementErrorCode.Signature&&(L=s.message)):R=S.ExtensionManagementErrorCode.Internal),n.publicLog(i,{...o,verificationStatus:c,success:!s,duration:a,errorcode:R,errorcodeDetail:L,durationSinceUpdate:m})}e.reportTelemetry=t;class r{constructor(){this.d=new k.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,k.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,k.createCancelablePromise)(i=>new Promise((o,c)=>{const a=i.onCancellationRequested(()=>{a.dispose(),c(new I.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=r}),define(ve[42],be([1,0,14,15,2,6,27,4,35,33,17,5,12,34,36,8,9,29]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var v;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(v=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class d extends Error{constructor(n,i){super(n),this.code=i}}e.ExtensionsProfileScanningError=d,e.IExtensionsProfileScannerService=(0,S.createDecorator)("IExtensionsProfileScannerService");let D=class extends l.Disposable{constructor(n,i,o,c,a,s){super(),this.i=n,this.j=i,this.k=o,this.l=c,this.m=a,this.n=s,this.b=this.B(new I.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new I.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new I.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new I.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new C.ResourceMap}scanProfileExtensions(n,i){return this.p(n,void 0,i)}async addExtensionsToProfile(n,i){const o=[],c=[];try{return await this.p(i,a=>{const s=[];for(const m of a)n.some(([R])=>(0,w.areSameExtensions)(R.identifier,m.identifier)&&R.manifest.version!==m.version)?o.push(m):s.push(m);for(const[m,R]of n)if(!s.some(L=>(0,w.areSameExtensions)(L.identifier,m.identifier)&&L.version===m.manifest.version)){const L={identifier:m.identifier,version:m.manifest.version,location:m.location,metadata:R};c.push(L),s.push(L)}return c.length&&this.b.fire({extensions:c,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),s}),c.length&&this.c.fire({extensions:c,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),c}catch(a){throw c.length&&this.c.fire({extensions:c,error:a,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:a,profileLocation:i}),a}}async updateMetadata(n,i){const o=[];return await this.p(i,c=>{const a=[];for(const s of c){const m=n.find(([R])=>(0,w.areSameExtensions)(R.identifier,s.identifier)&&R.manifest.version===s.version);m&&(s.metadata={...s.metadata,...m[1]},o.push(s)),a.push(s)}return a}),o}async removeExtensionFromProfile(n,i){const o=[];this.f.fire({extensions:o,profileLocation:i});try{await this.p(i,c=>{const a=[];for(const s of c)(0,w.areSameExtensions)(s.identifier,n.identifier)?o.push(s):a.push(s);return o.length&&this.f.fire({extensions:o,profileLocation:i}),a}),o.length&&this.g.fire({extensions:o,profileLocation:i})}catch(c){throw o.length&&this.g.fire({extensions:o,error:c,profileLocation:i}),c}}async p(n,i,o){return this.w(n).queue(async()=>{let c=[],a;try{const s=await this.j.readFile(n);a=JSON.parse(s.value.toString())}catch(s){if((0,T.toFileOperationResult)(s)!==1)throw s;if(this.l.extUri.isEqual(n,this.k.defaultProfile.extensionsResource)&&(a=await this.v()),!a&&o?.bailOutWhenFileNotFound)throw new d((0,u.getErrorMessage)(s),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.r(n);let s=!1;for(const m of a){A(m)||this.r(n);let R;if((0,p.isString)(m.relativeLocation))R=this.t(m.relativeLocation);else if((0,p.isString)(m.location))R=this.t(m.location),s=!0,m.relativeLocation=m.location,m.location=R.toJSON();else{R=P.URI.revive(m.location);const L=this.s(R);L&&(s=!0,m.relativeLocation=L)}c.push({identifier:m.identifier,location:R,version:m.version,metadata:m.metadata})}s&&await this.j.writeFile(n,k.VSBuffer.fromString(JSON.stringify(a)))}if(i){c=i(c);const s=c.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),relativeLocation:this.s(m.location),metadata:m.metadata}));await this.j.writeFile(n,k.VSBuffer.fromString(JSON.stringify(s)))}return c})}r(n){const i=new d(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(n){return this.l.extUri.isEqualOrParent(n,this.i)?this.l.extUri.relativePath(this.i,n):void 0}t(n){return this.l.extUri.joinPath(this.i,n)}async v(){return this.u||(this.u=(async()=>{const n=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json");let i;try{i=(await this.j.readFile(n)).value.toString()}catch(c){if((0,T.toFileOperationResult)(c)===1)return;throw c}this.n.info("Migrating extensions from old default profile location",n.toString());let o;try{const c=JSON.parse(i);Array.isArray(c)&&c.every(a=>A(a))?o=c:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.n.error(c)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,k.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",n.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(c){if((0,T.toFileOperationResult)(c)===3)this.n.info("Migration from old default profile location to new location is done by another window",n.toString(),this.k.defaultProfile.extensionsResource.toString());else throw c}try{await this.j.del(n)}catch(c){(0,T.toFileOperationResult)(c)!==1&&this.n.error(c)}return o})()),this.u}w(n){let i=this.h.get(n);return i||(i=new E.Queue,this.h.set(n,i)),i}};D=Re([Te(1,T.IFileService),Te(2,g.IUserDataProfilesService),Te(3,f.IUriIdentityService),Te(4,h.ITelemetryService),Te(5,b.ILogService)],D),e.AbstractExtensionsProfileScannerService=D;function A(r){return(0,p.isObject)(r)&&(0,y.isIExtensionIdentifier)(r.identifier)&&(t(r.location)||(0,p.isString)(r.location))&&((0,p.isUndefined)(r.relativeLocation)||(0,p.isString)(r.relativeLocation))&&r.version&&(0,p.isString)(r.version)}function t(r){return r?(0,p.isString)(r.path)&&(0,p.isString)(r.scheme):!1}}),define(ve[54],be([1,0,18,14,23,15,9,70,155,2,13,7,3,20,50,58,8,4,176,25,35,33,73,17,5,12,26,6,48,42,34,36,203,204]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v,d,D,A,t,r,n,i,o,c,a,s,m,R,L,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var ie;(function(Ee){function Y(H,U){if(H===U)return!0;const te=Object.keys(H),re=new Set;for(const de of Object.keys(U))re.add(de);if(te.length!==re.size)return!1;for(const de of te){if(H[de]!==U[de])return!1;re.delete(de)}return re.size===0}Ee.equals=Y})(ie=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,n.createDecorator)("IExtensionsScannerService");let ne=class extends y.Disposable{constructor(Y,H,U,te,re,de,oe,j,N,M,q,ee){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=H,this.l=U,this.m=te,this.n=re,this.p=de,this.r=oe,this.s=j,this.t=N,this.u=M,this.v=q,this.w=ee,this.g=this.B(new c.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(z,(0,g.joinPath)(this.m,A.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(z,(0,g.joinPath)(this.m,A.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(_,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,D.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(Y,H,U){const[te,re]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(H)]),de=U?await this.scanExtensionsUnderDevelopment(Y,[...te,...re]):[];return this.F(te,re,de,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const H=[];H.push(this.G(!!Y.useCache,Y.language)),H.push(this.H(Y.language,!!Y.checkControlFile));const[U,te]=await Promise.all(H);return this.D([...U,...te],0,Y,!1)}async scanUserExtensions(Y){const H=Y.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",H);const U=this.v.extUri.isEqual(Y.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,te=await this.J(H,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,U),re=Y.useCache&&!te.devMode&&te.excludeObsolete?this.j:this.k;let de;try{de=await re.scanExtensions(te)}catch(oe){if(oe instanceof s.ExtensionsProfileScanningError&&oe.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),de=await re.scanExtensions(te);else throw oe}return de=await this.D(de,1,Y,!0),this.s.trace("Scanned user extensions:",de.length),de}async scanExtensionsUnderDevelopment(Y,H){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const U=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(te=>te.scheme===T.Schemas.file).map(async te=>{const re=await this.J(te,!1,1,!0,Y.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(re)).map(oe=>(oe.type=H.find(j=>(0,D.areSameExtensions)(j.identifier,oe.identifier))?.type??oe.type,this.k.validate(oe,re)))}))).flat();return this.D(U,"development",Y,!0)}return[]}async scanExistingExtension(Y,H,U){const te=await this.J(Y,!1,H,!0,U.language,!0,void 0),re=await this.k.scanExtension(te);return!re||!U.includeInvalid&&!re.isValid?null:re}async scanOneOrMultipleExtensions(Y,H,U){const te=await this.J(Y,!1,H,!0,U.language,!0,void 0),re=await this.k.scanOneOrMultipleExtensions(te);return this.D(re,H,U,!0)}async scanMetadata(Y){const H=(0,g.joinPath)(Y,"package.json"),U=(await this.r.readFile(H)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(Y,H){const U=(0,g.joinPath)(Y,"package.json"),te=(await this.r.readFile(U)).value.toString(),re=JSON.parse(te);H.isMachineScoped=H.isMachineScoped||void 0,H.isBuiltin=H.isBuiltin||void 0,H.installedTimestamp=H.installedTimestamp||void 0,re.__metadata={...re.__metadata,...H},await this.r.writeFile((0,g.joinPath)(Y,"package.json"),I.VSBuffer.fromString(JSON.stringify(re,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof s.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw Y}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.p.addExtensionsToProfile(Y.map(H=>[H,H.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,I.VSBuffer.fromString(JSON.stringify([])))}catch(H){(0,r.toFileOperationResult)(H)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,C.getErrorMessage)(H))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.s.error(Y)}finally{this.z=void 0}})()),this.z}async D(Y,H,U,te){return U.includeAllVersions||(Y=this.F(H===0?Y:void 0,H===1?Y:void 0,H==="development"?Y:void 0,await this.getTargetPlatform(),te)),U.includeInvalid||(Y=Y.filter(re=>re.isValid)),Y.sort((re,de)=>{const oe=S.basename(re.location.fsPath),j=S.basename(de.location.fsPath);return oe<j?-1:oe>j?1:0})}F(Y,H,U,te,re){const de=(j,N,M)=>{if(j.isValid&&!N.isValid)return!1;if(j.isValid===N.isValid){if(re&&f.gt(j.manifest.version,N.manifest.version))return this.s.debug(`Skipping extension ${N.location.path} with lower version ${N.manifest.version} in favour of ${j.location.path} with version ${j.manifest.version}`),!1;if(f.eq(j.manifest.version,N.manifest.version)){if(j.type===0)return this.s.debug(`Skipping extension ${N.location.path} in favour of system extension ${j.location.path} with same version`),!1;if(j.targetPlatform===te)return this.s.debug(`Skipping extension ${N.location.path} from different target platform ${N.targetPlatform}`),!1}}return M?this.s.warn(`Overwriting user extension ${j.location.path} with ${N.location.path}.`):this.s.debug(`Overwriting user extension ${j.location.path} with ${N.location.path}.`),!0},oe=new Map;return Y?.forEach(j=>{const N=A.ExtensionIdentifier.toKey(j.identifier.id),M=oe.get(N);(!M||de(M,j,!1))&&oe.set(N,j)}),H?.forEach(j=>{const N=A.ExtensionIdentifier.toKey(j.identifier.id),M=oe.get(N);if(!M&&Y&&j.type===0){this.s.debug(`Skipping obsolete system extension ${j.location.path}.`);return}(!M||de(M,j,!1))&&oe.set(N,j)}),U?.forEach(j=>{const N=A.ExtensionIdentifier.toKey(j.identifier.id),M=oe.get(N);(!M||de(M,j,!0))&&oe.set(N,j),oe.set(N,j)}),[...oe.values()]}async G(Y,H){this.s.trace("Started scanning system extensions");const U=await this.J(this.systemExtensionsLocation,!1,0,!0,H,!0,void 0),re=await(Y&&!U.devMode?this.i:this.k).scanExtensions(U);return this.s.trace("Scanned system extensions:",re.length),re}async H(Y,H){const U=this.t.isBuilt?[]:this.u.builtInExtensions;if(!U?.length)return[];this.s.trace("Started scanning dev system extensions");const te=H?await this.I():{},re=[],de=h.URI.file(S.normalize(S.join(T.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const j of U){const N=te[j.name]||"marketplace";switch(N){case"disabled":break;case"marketplace":re.push((0,g.joinPath)(de,j.name));break;default:re.push(h.URI.file(N));break}}const oe=await Promise.all(re.map(async j=>this.k.scanExtension(await this.J(j,!1,0,!0,Y,!0,void 0))));return this.s.trace("Scanned dev system extensions:",oe.length),(0,E.coalesce)(oe)}async I(){try{const Y=await this.r.readFile(this.l);return JSON.parse(Y.value.toString())}catch{return{}}}async J(Y,H,U,te,re,de,oe){const j=await this.f(re??b.language),N=await this.L(Y),M=H&&!this.v.extUri.isEqual(Y,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,q=M?await this.L(M):void 0;return new F(Y,N,M,q,H,oe,U,te,de,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,re,j)}async L(Y){try{const H=await this.r.stat(Y);if(typeof H.mtime=="number")return H.mtime}catch{}}};ne=Re([Te(4,m.IUserDataProfilesService),Te(5,s.IExtensionsProfileScannerService),Te(6,r.IFileService),Te(7,i.ILogService),Te(8,d.IEnvironmentService),Te(9,o.IProductService),Te(10,R.IUriIdentityService),Te(11,n.IInstantiationService)],ne),e.AbstractExtensionsScannerService=ne;class F{constructor(Y,H,U,te,re,de,oe,j,N,M,q,ee,fe,W,K){this.location=Y,this.mtime=H,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=te,this.profile=re,this.profileScanOptions=de,this.type=oe,this.excludeObsolete=j,this.validate=N,this.productVersion=M,this.productDate=q,this.productCommit=ee,this.devMode=fe,this.language=W,this.translations=K}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,H){return(0,g.isEqual)(Y.location,H.location)&&Y.mtime===H.mtime&&(0,g.isEqual)(Y.applicationExtensionslocation,H.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===H.applicationExtensionslocationMtime&&Y.profile===H.profile&&l.equals(Y.profileScanOptions,H.profileScanOptions)&&Y.type===H.type&&Y.excludeObsolete===H.excludeObsolete&&Y.validate===H.validate&&Y.productVersion===H.productVersion&&Y.productDate===H.productDate&&Y.productCommit===H.productCommit&&Y.devMode===H.devMode&&Y.language===H.language&&ie.equals(Y.translations,H.translations)}}e.ExtensionScannerInput=F;let _=class extends y.Disposable{constructor(Y,H,U,te,re){super(),this.f=Y,this.g=H,this.h=U,this.i=te,this.j=re}async scanExtensions(Y){const H=Y.profile?await this.l(Y):await this.k(Y);let U={};if(Y.excludeObsolete&&Y.type===1)try{const te=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(te)}catch{}return(0,u.isEmptyObject)(U)?H:H.filter(te=>!U[D.ExtensionKey.create(te).toString()])}async k(Y){const H=await this.i.resolve(Y.location);if(!H.children?.length)return[];const U=await Promise.all(H.children.map(async te=>{if(!te.isDirectory||Y.type===1&&(0,g.basename)(te.resource).indexOf(".")===0)return null;const re=new F(te.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(re)}));return(0,E.coalesce)(U).sort((te,re)=>te.location.path<re.location.path?-1:1)}async l(Y){let H=await this.m(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.h.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){H=H.filter(te=>!te.metadata?.isApplicationScoped);const U=await this.m(Y.applicationExtensionslocation,te=>!!te.metadata?.isApplicationScoped,Y);H.push(...U)}return H}async m(Y,H,U){const te=await this.g.scanProfileExtensions(Y,U.profileScanOptions);if(!te.length)return[];const re=await Promise.all(te.map(async de=>{if(H(de)){const oe=new F(de.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(oe,de.metadata)}return null}));return(0,E.coalesce)(re)}async scanOneOrMultipleExtensions(Y){try{if(await this.i.exists((0,g.joinPath)(Y.location,"package.json"))){const H=await this.scanExtension(Y);return H?[H]:[]}else return await this.scanExtensions(Y)}catch(H){return this.j.error(`Error scanning extensions at ${Y.location.path}:`,(0,C.getErrorMessage)(H)),[]}}async scanExtension(Y,H){try{let U=await this.scanExtensionManifest(Y.location);if(U){U.publisher||(U.publisher=A.UNDEFINED_PUBLISHER),H=H??U.__metadata,delete U.__metadata;const te=(0,D.getGalleryExtensionId)(U.publisher,U.name),re=H?.id?{id:te,uuid:H.id}:{id:te},de=H?.isSystem?0:Y.type,oe=de===0||!!H?.isBuiltin;$.ImplicitActivationEvents.updateManifest(U),U=await this.n(Y.location,U,F.createNlsConfiguration(Y));const j={type:de,identifier:re,manifest:U,location:Y.location,isBuiltin:oe,targetPlatform:H?.targetPlatform??"undefined",metadata:H,isValid:!0,validations:[]};return Y.validate?this.validate(j,Y):j}}catch(U){Y.type!==0&&this.j.error(U)}return null}validate(Y,H){let U=!0;const te=(0,t.validateExtensionManifest)(H.productVersion,H.productDate,H.location,Y.manifest,Y.isBuiltin);for(const[re,de]of te)re===p.default.Error&&(U=!1,this.j.error(this.t(H.location,de)));return Y.isValid=U,Y.validations=te,Y}async scanExtensionManifest(Y){const H=(0,g.joinPath)(Y,"package.json");let U;try{U=(await this.i.readFile(H)).value.toString()}catch(re){return(0,r.toFileOperationResult)(re)!==1&&this.j.error(this.t(Y,(0,v.localize)(0,null,H.path,re.message))),null}let te;try{te=JSON.parse(U)}catch{const de=[];(0,P.parse)(U,de);for(const oe of de)this.j.error(this.t(Y,(0,v.localize)(1,null,H.path,oe.offset,oe.length,(0,w.getParseErrorMessage)(oe.error))));return null}return(0,P.getNodeType)(te)!=="object"?(this.j.error(this.t(Y,(0,v.localize)(2,null,H.path))),null):te}async n(Y,H,U){const te=await this.p(Y,H,U);if(te)try{const re=[],de=await this.r(te.default,re);if(re.length>0)return re.forEach(j=>{this.j.error(this.t(Y,(0,v.localize)(3,null,te.default?.path,(0,w.getParseErrorMessage)(j.error))))}),H;if((0,P.getNodeType)(te)!=="object")return this.j.error(this.t(Y,(0,v.localize)(4,null,te.default?.path))),H;const oe=te.values||Object.create(null);return(0,L.localizeManifest)(H,oe,de)}catch{}return H}async p(Y,H,U){const te=(0,g.joinPath)(Y,"package.nls.json"),re=(N,M)=>{M.forEach(q=>{this.j.error(this.t(Y,(0,v.localize)(5,null,N?.path,(0,w.getParseErrorMessage)(q.error))))})},de=N=>{this.j.error(this.t(Y,(0,v.localize)(6,null,N?.path)))},oe=`${H.publisher}.${H.name}`,j=U.translations[oe];if(j)try{const N=h.URI.file(j),M=(await this.i.readFile(N)).value.toString(),q=[],ee=(0,P.parse)(M,q);return q.length>0?(re(N,q),{values:void 0,default:te}):(0,P.getNodeType)(ee)!=="object"?(de(N),{values:void 0,default:te}):{values:ee.contents?ee.contents.package:void 0,default:te}}catch{return{values:void 0,default:te}}else{if(!await this.i.exists(te))return;let M;try{M=await this.s(Y,U)}catch{return}if(!M.localized)return{values:void 0,default:M.original};try{const q=(await this.i.readFile(M.localized)).value.toString(),ee=[],fe=(0,P.parse)(q,ee);return ee.length>0?(re(M.localized,ee),{values:void 0,default:M.original}):(0,P.getNodeType)(fe)!=="object"?(de(M.localized),{values:void 0,default:M.original}):{values:fe,default:M.original}}catch{return{values:void 0,default:M.original}}}}async r(Y,H){if(Y)try{const U=(await this.i.readFile(Y)).value.toString();return(0,P.parse)(U,H)}catch{}}s(Y,H){return new Promise((U,te)=>{const re=de=>{const oe=(0,g.joinPath)(Y,`package.nls.${de}.json`);this.i.exists(oe).then(j=>{j&&U({localized:oe,original:(0,g.joinPath)(Y,"package.nls.json")});const N=de.lastIndexOf("-");N===-1?U({localized:(0,g.joinPath)(Y,"package.nls.json"),original:null}):(de=de.substring(0,N),re(de))})};if(H.devMode||H.pseudo||!H.language)return U({localized:(0,g.joinPath)(Y,"package.nls.json"),original:null});re(H.language)})}t(Y,H){return`[${Y.path}]: ${H}`}};_=Re([Te(1,s.IExtensionsProfileScannerService),Te(2,R.IUriIdentityService),Te(3,r.IFileService),Te(4,i.ILogService)],_);let z=class extends _{constructor(Y,H,U,te,re,de){super(H,U,te,re,de),this.y=Y,this.v=this.B(new k.ThrottledDelayer(3e3)),this.w=this.B(new c.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(Y){const H=await this.z();if(this.u=Y,H&&H.input&&F.equals(H.input,this.u))return this.j.debug("Using cached extensions scan result",Y.location.toString()),this.v.trigger(()=>this.D()),H.result.map(te=>(te.location=h.URI.revive(te.location),te));const U=await super.scanExtensions(Y);return await this.C({input:Y,result:U}),U}async z(){try{const Y=await this.i.readFile(this.y),H=JSON.parse(Y.value.toString());return{result:H.result,input:(0,a.revive)(H.input)}}catch(Y){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,C.getErrorMessage)(Y))}return null}async C(Y){try{await this.i.writeFile(this.y,I.VSBuffer.fromString(JSON.stringify(Y)))}catch(H){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,C.getErrorMessage)(H))}}async D(){if(!this.u)return;const Y=await this.z();if(!Y)return;const H=Y.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!l.equals(U,H))try{await this.i.del(this.y),this.w.fire()}catch(te){this.j.error(te)}}};z=Re([Te(2,s.IExtensionsProfileScannerService),Te(3,R.IUriIdentityService),Te(4,r.IFileService),Te(5,i.ILogService)],z);function x(Ee,Y){const H=(0,D.getExtensionId)(Ee.manifest.publisher,Ee.manifest.name);return{id:H,identifier:new A.ExtensionIdentifier(H),isBuiltin:Ee.type===0,isUserBuiltin:Ee.type===1&&Ee.isBuiltin,isUnderDevelopment:Y,extensionLocation:Ee.location,uuid:Ee.identifier.uuid,targetPlatform:Ee.targetPlatform,...Ee.manifest}}e.toExtensionDescription=x;class le extends ne{constructor(Y,H,U,te,re,de,oe,j,N,M,q,ee){super(Y,H,(0,g.joinPath)(U,".vscode-oss-dev","extensions","control.json"),(0,g.joinPath)(te,A.MANIFEST_CACHE_FOLDER),re,de,oe,j,N,M,q,ee),this.M=(async()=>{if(b.translationsConfigFile)try{const fe=await this.r.readFile(h.URI.file(b.translationsConfigFile));return JSON.parse(fe.value.toString())}catch{}return Object.create(null)})()}f(Y){return this.M}}e.NativeExtensionsScannerService=le}),define(ve[250],be([1,0,49,14,37,6,2,13,7,21,12,34]),function(ae,e,E,k,l,I,C,P,w,y,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let b=class extends C.Disposable{constructor(f,p){super(),this.b=f,this.f=p,this.a=new k.Limiter(5)}async postUninstall(f){const p=this.g(f,"uninstall");return p&&(this.f.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.a.queue(()=>this.h(p.script,"uninstall",p.args,!0,f).then(()=>this.f.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),u=>this.f.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${u}`)))),y.Promises.rm(this.j(f)).then(void 0,u=>this.f.error("Error while removing extension storage path",u))}g(f,p){const u=`vscode:${p}`;if(f.location.scheme===P.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[u]=="string"){const h=f.manifest.scripts[u].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(f.identifier.id,f.manifest.version,`${u} should be a node script`),null):{script:(0,w.join)(f.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(f,p,u,h,v){return new Promise((d,D)=>{const A=this.i(f,p,u,v);let t;const r=n=>{t&&(clearTimeout(t),t=null),n?D(n):d(void 0)};A.on("error",n=>{r((0,l.toErrorMessage)(n)||"Unknown")}),A.on("exit",(n,i)=>{r(n?`post-${p} process exited with code ${n}`:void 0)}),h&&(t=setTimeout(()=>{t=null,A.kill(),D("timed out")},5e3))})}i(f,p,u,h){const v={silent:!0,execArgv:void 0},d=(0,E.fork)(f,[`--type=extension-post-${p}`,...u],v);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const D=I.Event.fromNodeEventEmitter(d.stdout,"data"),A=I.Event.fromNodeEventEmitter(d.stderr,"data");D(n=>this.f.info(h.identifier.id,h.manifest.version,`post-${p}`,n)),A(n=>this.f.error(h.identifier.id,h.manifest.version,`post-${p}`,n));const t=I.Event.any(I.Event.map(D,n=>({data:`%c${n}`,format:[""]})),I.Event.map(A,n=>({data:`%c${n}`,format:["color: red"]})));return I.Event.debounce(t,(n,i)=>n?{data:n.data+i.data,format:[...n.format,...i.format]}:{data:i.data,format:i.format},100)(n=>{console.group(h.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),d}j(f){return(0,w.join)(this.b.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};b=Re([Te(0,S.IUserDataProfilesService),Te(1,T.ILogService)],b),e.ExtensionsLifecycle=b}),define(ve[121],be([1,0,12,34,36,29,42,17,25,4]),function(ae,e,E,k,l,I,C,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let T=class extends C.AbstractExtensionsProfileScannerService{constructor(b,g,f,p,u,h){super(y.URI.file(b.extensionsPath),g,f,p,u,h)}};T=Re([Te(0,w.INativeEnvironmentService),Te(1,P.IFileService),Te(2,k.IUserDataProfilesService),Te(3,l.IUriIdentityService),Te(4,I.ITelemetryService),Te(5,E.ILogService)],T),e.ExtensionsProfileScannerService=T}),define(ve[251],be([1,0,14,6,2,46,8,165,5,34]),function(ae,e,E,k,l,I,C,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,w.createDecorator)("storageService");var T;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(T=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(v){v[v.APPLICATION=-1]="APPLICATION",v[v.PROFILE=0]="PROFILE",v[v.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var b;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(b=e.StorageTarget||(e.StorageTarget={}));function g(v){const d=v.get(e.TARGET_KEY);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.loadKeyTargets=g;class f extends l.Disposable{constructor(d={flushInterval:f.a}){super(),this.j=d,this.b=this.B(new k.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new k.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new k.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new l.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,l.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.J()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(d,D){if(D===e.TARGET_KEY){switch(d){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:D,target:this.F(d)[D]})}r(d){this.f.fire({reason:d})}get(d,D,A){return this.L(D)?.get(d,A)}getBoolean(d,D,A){return this.L(D)?.getBoolean(d,A)}getNumber(d,D,A){return this.L(D)?.getNumber(d,A)}store(d,D,A,t){if((0,C.isUndefinedOrNull)(D)){this.remove(d,A);return}this.t(()=>{this.u(d,A,t),this.L(A)?.set(d,D)})}remove(d,D){this.t(()=>{this.u(d,D,void 0),this.L(D)?.delete(d)})}t(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,D){const A=[],t=this.F(d);for(const r of Object.keys(t))t[r]===D&&A.push(r);return A}u(d,D,A){const t=this.F(D);typeof A=="number"?t[d]!==A&&(t[d]=A,this.L(D)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[d]=="number"&&(delete t[d],this.L(D)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(d){switch(d){case-1:return this.D;case 0:return this.z;default:return this.w}}G(d){const D=this.L(d);return D?g(D):Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=T.NONE){this.f.fire({reason:d});const D=this.L(-1),A=this.L(0),t=this.L(1);switch(d){case T.NONE:await E.Promises.settled([D?.whenFlushed()??Promise.resolve(),A?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case T.SHUTDOWN:await E.Promises.settled([D?.flush(0)??Promise.resolve(),A?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.L(-1)?.items??new Map,D=this.L(0)?.items??new Map,A=this.L(1)?.items??new Map;return h(d,D,A,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(d,D){return this.r(T.NONE),(0,y.isUserDataProfile)(d)?this.N(d,D):this.O(d,D)}H(d,D){return!(d.id===D.id||p(D)&&p(d))}I(d,D,A,t){this.t(()=>{if(t)for(const[r,n]of d)D.set(r,n);else{const r=new Set;for(const[n,i]of d)r.add(n),D.get(n)!==i&&this.n(A,n);for(const[n]of D.items)r.has(n)||this.n(A,n)}})}}f.a=60*1e3,e.AbstractStorageService=f;function p(v){return v.isDefault||!!v.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class u extends f{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(d=>this.n(1,d))),this.B(this.P.onDidChangeStorage(d=>this.n(0,d))),this.B(this.p.onDidChangeStorage(d=>this.n(-1,d)))}L(d){switch(d){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(d){return!1}}e.InMemoryStorageService=u;async function h(v,d,D,A,t,r){const n=$=>{try{return JSON.parse($)}catch{return $}},i=new Map,o=new Map;v.forEach(($,ie)=>{i.set(ie,$),o.set(ie,n($))});const c=new Map,a=new Map;d.forEach(($,ie)=>{c.set(ie,$),a.set(ie,n($))});const s=new Map,m=new Map;D.forEach(($,ie)=>{s.set(ie,$),m.set(ie,n($))}),console.group(A!==t?`Storage: Application (path: ${A})`:`Storage: Application & Profile (path: ${A}, default profile)`);const R=[];if(i.forEach(($,ie)=>{R.push({key:ie,value:$})}),console.table(R),console.groupEnd(),console.log(o),A!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const $=[];c.forEach((ie,ne)=>{$.push({key:ne,value:ie})}),console.table($),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const L=[];s.forEach(($,ie)=>{L.push({key:ie,value:$})}),console.table(L),console.groupEnd(),console.log(m)}e.logStorage=h}),define(ve[122],be([1,0,18,19,9,3,28,8,4,24,25,32,35,73,17,12,26,53,236,251,29]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v,d,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const A=I.isWeb?"web":(0,S.getTargetPlatform)(I.platform,C.arch),t="X-Market-Search-Activity-Id";var r;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function n(...N){return String(N.reduce((M,q)=>M|q,0))}var i;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class m{constructor(M=s){this.d=M}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(M,q=this.d.pageSize){return new m({...this.d,pageNumber:M,pageSize:q})}withFilter(M,...q){const ee=[...this.d.criteria,...q.length?q.map(fe=>({filterType:M,value:fe})):[{filterType:M}]];return new m({...this.d,criteria:ee})}withSortBy(M){return new m({...this.d,sortBy:M})}withSortOrder(M){return new m({...this.d,sortOrder:M})}withFlags(...M){return new m({...this.d,flags:M.reduce((q,ee)=>q|ee,0)})}withAssetTypes(...M){return new m({...this.d,assetTypes:M})}withSource(M){return new m({...this.d,source:M})}get raw(){const{criteria:M,pageNumber:q,pageSize:ee,sortBy:fe,sortOrder:W,flags:K,assetTypes:Z}=this.d;return{filters:[{criteria:M,pageNumber:q,pageSize:ee,sortBy:fe,sortOrder:W}],assetTypes:Z,flags:K}}get searchText(){const M=this.d.criteria.filter(q=>q.filterType===i.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(M=>String(M.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function R(N,M){const q=(N||[]).filter(ee=>ee.statisticName===M)[0];return q?q.value:0}function L(N){const M="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(ee=>ee.assetType.indexOf(M)===0).reduce((ee,fe)=>{const W=ne(N,fe.assetType);return W&&ee.push([fe.assetType.substring(M.length),W]),ee},[])}function $(N){if(N.properties){const M=N.properties.filter(fe=>fe.key===o.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ee=M.filter(fe=>q.test(fe.value))[0];return ee?{uri:ee.value,fallbackUri:ee.value}:null}return ne(N,o.Repository)}function ie(N){return{uri:`${N.fallbackAssetUri}/${o.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${o.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function ne(N,M){return N.files.filter(ee=>ee.assetType===M)[0]?{uri:`${N.assetUri}/${M}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${M}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function F(N,M){const q=N.properties?N.properties.filter(fe=>fe.key===M):[],ee=q.length>0&&q[0].value;return ee?ee.split(",").map(fe=>(0,b.adoptToGalleryExtensionId)(fe)):[]}function _(N){const M=N.properties?N.properties.filter(q=>q.key===c.Engine):[];return M.length>0&&M[0].value||""}function z(N){const M=N.properties?N.properties.filter(q=>q.key===c.PreRelease):[];return M.length>0&&M[0].value==="true"}function x(N){const M=N.properties?N.properties.filter(ee=>ee.key===c.LocalizedLanguages):[],q=M.length>0&&M[0].value||"";return q?q.split(","):[]}function le(N){return N.properties?.find(M=>M.key===c.SponsorLink)?.value}function Ee(N){return N.indexOf("preview")!==-1}function Y(N){return N.targetPlatform?(0,S.toTargetPlatform)(N.targetPlatform):"undefined"}function H(N){const M=(0,E.distinct)(N.versions.map(Y)),q=!!N.tags?.includes(S.WEB_EXTENSION_TAG),ee=M.indexOf("web");return q?ee===-1&&M.push("web"):ee!==-1&&M.splice(ee,1),M}function U(N,M){const q=(0,S.getFallbackTargetPlarforms)(M);for(let ee=0;ee<N.length;ee++){const fe=N[ee];if(fe.version===N[ee-1]?.version){let W=ee;const K=Y(fe);if(K===M)for(;W>0&&N[W-1].version===fe.version;)W--;else if(q.includes(K))for(;W>0&&N[W-1].version===fe.version&&Y(N[W-1])!==M;)W--;W!==ee&&(N.splice(ee,1),N.splice(W,0,fe))}}return N}e.sortExtensionVersions=U;function te(N,M,q){N.telemetryData={index:M,querySource:q,queryActivityId:N.queryContext?.[t]}}function re(N,M,q,ee){const fe=N.versions[0],W={manifest:ne(M,o.Manifest),readme:ne(M,o.Details),changelog:ne(M,o.Changelog),license:ne(M,o.License),repository:$(M),download:ie(M),icon:ne(M,o.Icon),signature:ne(M,o.Signature),coreTranslations:L(M)};return{identifier:{id:(0,b.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:M.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:le(fe),description:N.shortDescription||"",installCount:R(N.statistics,"install"),rating:R(N.statistics,"averagerating"),ratingCount:R(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:q,assets:W,properties:{dependencies:F(M,c.Dependency),extensionPack:F(M,c.ExtensionPack),engine:_(M),localizedLanguages:x(M),targetPlatform:Y(M),isPreReleaseVersion:z(M)},hasPreReleaseVersion:z(fe),hasReleaseVersion:!0,preview:Ee(N.flags),isSigned:!!W.signature,queryContext:ee}}let de=class{constructor(M,q,ee,fe,W,K,Z,V){this.k=q,this.l=ee,this.n=fe,this.o=W,this.q=K,this.u=Z,this.w=V;const Q=Z.extensionsGallery,G=Q?.servicePPEUrl&&V.getValue("_extensionsGallery.enablePPE");this.d=G?Q.servicePPEUrl:Q?.serviceUrl,this.g=G?void 0:Q?.searchUrl,this.h=Q?.controlUrl,this.j=(0,v.resolveMarketplaceHeaders)(Z.version,Z,this.n,this.w,this.q,M,this.o)}x(M=""){return`${this.d}${M}`}isEnabled(){return!!this.d}async getExtensions(M,q,ee){const fe=k.CancellationToken.isCancellationToken(q)?{}:q,W=k.CancellationToken.isCancellationToken(q)?q:ee,K=[],Z=[],V=[],Q=[];let G=!0;for(const pe of M){pe.uuid?Z.push(pe.uuid):K.push(pe.id);const Pe=!!(pe.version||pe.preRelease);V.push({id:pe.id,uuid:pe.uuid,includePreRelease:Pe}),pe.version&&Q.push({id:pe.id,uuid:pe.uuid,version:pe.version}),G=G&&!!pe.hasPreRelease&&!Pe}if(!Z.length&&!K.length)return[];let X=new m().withPage(1,M.length);Z.length&&(X=X.withFilter(i.ExtensionId,...Z)),K.length&&(X=X.withFilter(i.ExtensionName,...K)),(fe.queryAllVersions||G)&&(X=X.withFlags(X.flags,r.IncludeVersions)),fe.source&&(X=X.withSource(fe.source));const{extensions:ce}=await this.z(X,{targetPlatform:fe.targetPlatform??A,includePreRelease:V,versions:Q,compatible:!!fe.compatible},W);return fe.source&&ce.forEach((pe,Pe)=>te(pe,Pe,fe.source)),ce}async getCompatibleExtension(M,q,ee){if((0,S.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,ee))return null;if(await this.isExtensionCompatible(M,q,ee))return M;const fe=new m().withFlags(r.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,M.identifier.uuid),{extensions:W}=await this.z(fe,{targetPlatform:ee,compatible:!0,includePreRelease:q},k.CancellationToken.None);return W[0]||null}async isExtensionCompatible(M,q,ee){if(!(0,S.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,ee)||!q&&M.properties.isPreReleaseVersion)return!1;let fe=M.properties.engine;if(!fe){const W=await this.getManifest(M,k.CancellationToken.None);if(!W)throw new Error("Manifest was not found");fe=W.engines.vscode}return(0,g.isEngineValid)(fe,this.u.version,this.u.date)}async y(M,q,ee,fe,W){if(!(0,S.isTargetPlatformCompatible)(Y(M),fe,W)||q!=="any"&&z(M)!==(q==="prerelease"))return!1;if(ee)try{const K=await this.E(M);if(!(0,g.isEngineValid)(K,this.u.version,this.u.date))return!1}catch(K){return this.l.error(`Error while getting the engine for the version ${M.version}.`,(0,l.getErrorMessage)(K)),!1}return!0}async query(M,q){let ee=M.text||"";const fe=M.pageSize??50;let W=new m().withPage(1,fe);ee?(ee=ee.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,X,ce)=>(W=W.withFilter(i.Category,ce||X),"")),ee=ee.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(G,X,ce)=>(W=W.withFilter(i.Tag,ce||X),"")),ee=ee.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(i.Featured),"")),ee=ee.trim(),ee&&(ee=ee.length<200?ee:ee.substring(0,200),W=W.withFilter(i.SearchText,ee)),W=W.withSortBy(0)):M.ids?W=W.withFilter(i.ExtensionId,...M.ids):M.names?W=W.withFilter(i.ExtensionName,...M.names):W=W.withSortBy(4),typeof M.sortBy=="number"&&(W=W.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(W=W.withSortOrder(M.sortOrder)),M.source&&(W=W.withSource(M.source));const K=async(G,X)=>{const{extensions:ce,total:pe}=await this.z(G,{targetPlatform:A,compatible:!1,includePreRelease:!!M.includePreRelease},X);return ce.forEach((Pe,Ae)=>te(Pe,(G.pageNumber-1)*G.pageSize+Ae,M.source)),{extensions:ce,total:pe}},{extensions:Z,total:V}=await K(W,q),Q=async(G,X)=>{if(X.isCancellationRequested)throw new l.CancellationError;const{extensions:ce}=await K(W.withPage(G+1),X);return ce};return{firstPage:Z,total:V,pageSize:W.pageSize,getPage:Q}}async z(M,q,ee){const fe=M.flags;!!(M.flags&r.IncludeLatestVersionOnly)&&!!(M.flags&r.IncludeVersions)&&(M=M.withFlags(M.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(M.flags&r.IncludeLatestVersionOnly)&&!(M.flags&r.IncludeVersions)&&(M=M.withFlags(M.flags,r.IncludeLatestVersionOnly)),q.versions?.length&&(M=M.withFlags(M.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),M=M.withFlags(M.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:W,total:K,context:Z}=await this.B(M,ee);if(!(M.flags&r.IncludeLatestVersionOnly)){const X=[];for(const ce of W){const pe=await this.A(ce,q,Z);pe&&X.push(pe)}return{extensions:X,total:K}}const Q=[],G=new Map;for(let X=0;X<W.length;X++){const ce=W[X],pe={id:(0,b.getGalleryExtensionId)(ce.publisher.publisherName,ce.extensionName),uuid:ce.extensionId},Pe=(0,P.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Fe=>(0,b.areSameExtensions)(Fe,pe))?.includePreRelease;if(q.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(H(ce),q.targetPlatform))continue;const Ae=await this.A(ce,q,Z);!Ae||Ae.properties.isPreReleaseVersion&&(!Pe||!Ae.hasReleaseVersion)||!Ae.properties.isPreReleaseVersion&&Ae.properties.targetPlatform!==q.targetPlatform&&Ae.hasPreReleaseVersion?G.set(ce.extensionId,X):Q.push([X,Ae])}if(G.size){const X=new Date().getTime(),ce=new m().withFlags(fe&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,G.size).withFilter(i.ExtensionId,...G.keys()),{extensions:pe}=await this.z(ce,q,ee);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-X,count:G.size});for(const Pe of pe){const Ae=G.get(Pe.identifier.uuid);Q.push([Ae,Pe])}}return{extensions:Q.sort((X,ce)=>X[0]-ce[0]).map(([,X])=>X),total:K}}async A(M,q,ee){const fe={id:(0,b.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},W=q.versions?.find(Q=>(0,b.areSameExtensions)(Q,fe))?.version,K=(0,P.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Q=>(0,b.areSameExtensions)(Q,fe))?.includePreRelease,Z=H(M),V=U(M.versions,q.targetPlatform);if(q.compatible&&(0,S.isNotWebExtensionInWebTargetPlatform)(Z,q.targetPlatform))return null;for(let Q=0;Q<V.length;Q++){const G=V[Q];if(!(W&&G.version!==W)){if(await this.y(G,K?"any":"release",q.compatible,Z,q.targetPlatform))return re(M,G,Z,ee);if(W&&G.version===W)return null}}return W||q.compatible?null:re(M,M.versions[0],Z)}async B(M,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,r.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,n(r.Unpublished));const ee=await this.j,fe=JSON.stringify(M.raw),W={...ee,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(fe.length)},K=new Date().getTime();let Z,V,Q=0;try{if(Z=await this.k.request({type:"POST",url:this.g&&M.criteria.some(X=>X.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:fe,headers:W},q),Z.res.statusCode&&Z.res.statusCode>=400&&Z.res.statusCode<500)return{galleryExtensions:[],total:Q};const G=await(0,h.asJson)(Z);if(G){const X=G.results[0],ce=X.extensions,pe=X.resultMetadata&&X.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return Q=pe&&pe.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:ce,total:Q,context:{[t]:Z.res.headers.activityid}}}return{galleryExtensions:[],total:Q}}catch(G){throw V=G,G}finally{this.o.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(fe.length),duration:new Date().getTime()-K,success:!!Z&&(0,h.isSuccess)(Z),responseBodySize:Z?.res.headers["Content-Length"],statusCode:Z?String(Z.res.statusCode):void 0,errorCode:V?(0,l.isCancellationError)(V)?"canceled":(0,l.getErrorMessage)(V).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Q)})}}async reportStatistic(M,q,ee,fe){if(!this.isEnabled())return;const W=I.isWeb?this.x(`/itemName/${M}.${q}/version/${ee}/statType/${fe==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${M}/extensions/${q}/${ee}/stats?statType=${fe}`),K=I.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",V={...await this.j,Accept:K};try{await this.k.request({type:"POST",url:W,headers:V},k.CancellationToken.None)}catch{}}async download(M,q,ee){this.l.trace("ExtensionGalleryService#download",M.identifier.id);const fe=(0,b.getGalleryExtensionTelemetryData)(M),W=new Date().getTime(),K=X=>this.o.publicLog("galleryService:downloadVSIX",{...fe,duration:X}),Z=ee===2?"install":ee===3?"update":"",V=Z?{uri:`${M.assets.download.uri}${w.URI.parse(M.assets.download.uri).query?"&":"?"}${Z}=true`,fallbackUri:`${M.assets.download.fallbackUri}${w.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${Z}=true`}:M.assets.download,Q=M.queryContext?.[t]?{[t]:M.queryContext[t]}:void 0,G=await this.D(V,Q?{headers:Q}:void 0);await this.q.writeFile(q,G.stream),K(new Date().getTime()-W)}async downloadSignatureArchive(M,q){if(!M.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",M.identifier.id);const ee=await this.D(M.assets.signature);await this.q.writeFile(q,ee.stream)}async getReadme(M,q){if(M.assets.readme){const ee=await this.D(M.assets.readme,{},q);return await(0,h.asTextOrError)(ee)||""}return""}async getManifest(M,q){if(M.assets.manifest){const ee=await this.D(M.assets.manifest,{},q),fe=await(0,h.asTextOrError)(ee);return fe?JSON.parse(fe):null}return null}async C(M,q){const ee=ne(M,o.Manifest);if(!ee)throw new Error("Manifest was not found");const fe={"Accept-Encoding":"gzip"},W=await this.D(ee,{headers:fe});return await(0,h.asJson)(W)}async getCoreTranslation(M,q){const ee=M.assets.coreTranslations.filter(fe=>fe[0]===q.toUpperCase())[0];if(ee){const fe=await this.D(ee[1]),W=await(0,h.asTextOrError)(fe);return W?JSON.parse(W):null}return null}async getChangelog(M,q){if(M.assets.changelog){const ee=await this.D(M.assets.changelog,{},q);return await(0,h.asTextOrError)(ee)||""}return""}async getAllCompatibleVersions(M,q,ee){let fe=new m().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?fe=fe.withFilter(i.ExtensionId,M.identifier.uuid):fe=fe.withFilter(i.ExtensionName,M.identifier.id);const{galleryExtensions:W}=await this.B(fe,k.CancellationToken.None);if(!W.length)return[];const K=H(W[0]);if((0,S.isNotWebExtensionInWebTargetPlatform)(K,ee))return[];const Z=[];await Promise.all(W[0].versions.map(async G=>{try{await this.y(G,q?"any":"release",!0,K,ee)&&Z.push(G)}catch{}}));const V=[],Q=new Set;for(const G of U(Z,ee))Q.has(G.version)||(Q.add(G.version),V.push({version:G.version,date:G.lastUpdated,isPreReleaseVersion:z(G)}));return V}async D(M,q={},ee=k.CancellationToken.None){const fe=await this.j,W={type:"GET"},K={...fe,...q.headers||{}};q={...q,...W,headers:K};const Z=M.uri,V=M.fallbackUri,Q={...q,url:Z};try{const G=await this.k.request(Q,ee);if(G.res.statusCode===200)return G;const X=await(0,h.asTextOrError)(G);throw new Error(`Expected 200, got back ${G.res.statusCode} instead.

${X}`)}catch(G){if((0,l.isCancellationError)(G))throw G;const X=(0,l.getErrorMessage)(G);this.o.publicLog2("galleryService:cdnFallback",{url:Z,message:X});const ce={...q,url:V};return this.k.request(ce,ee)}}async E(M){let q=_(M);if(!q){const ee=await this.C(M,k.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");q=ee.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const M=await this.k.request({type:"GET",url:this.h},k.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,h.asJson)(M),ee=[],fe={};if(q){for(const W of q.malicious)ee.push({id:W});if(q.migrateToPreRelease)for(const[W,K]of Object.entries(q.migrateToPreRelease))(!K.engine||(0,g.isEngineValid)(K.engine,this.u.version,this.u.date))&&(fe[W.toLowerCase()]={disallowInstall:!0,extension:{id:K.id,displayName:K.displayName,autoMigrate:{storage:!!K.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[W,K]of Object.entries(q.deprecated))K&&(fe[W.toLowerCase()]=(0,P.isBoolean)(K)?{}:K)}return{malicious:ee,deprecated:fe}}};de=Re([Te(1,h.IRequestService),Te(2,p.ILogService),Te(3,T.IEnvironmentService),Te(4,D.ITelemetryService),Te(5,f.IFileService),Te(6,u.IProductService),Te(7,y.IConfigurationService)],de);let oe=class extends de{constructor(M,q,ee,fe,W,K,Z,V){super(M,q,ee,fe,W,K,Z,V)}};oe=Re([Te(0,d.IStorageService),Te(1,h.IRequestService),Te(2,p.ILogService),Te(3,T.IEnvironmentService),Te(4,D.ITelemetryService),Te(5,f.IFileService),Te(6,u.IProductService),Te(7,y.IConfigurationService)],oe),e.ExtensionGalleryService=oe;let j=class extends de{constructor(M,q,ee,fe,W,K,Z){super(void 0,M,q,ee,fe,W,K,Z)}};j=Re([Te(0,h.IRequestService),Te(1,p.ILogService),Te(2,T.IEnvironmentService),Te(3,D.ITelemetryService),Te(4,f.IFileService),Te(5,u.IProductService),Te(6,y.IConfigurationService)],j),e.ExtensionGalleryServiceWithNoStorageService=j}),define(ve[123],be([1,0,8,4,25,17,12,230,36,34]),function(ae,e,E,k,l,I,C,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.ServerUserDataProfilesService=void 0;let T=class extends y.UserDataProfilesService{constructor(g,f,p,u){super(f,p,g,u),this.a=f}N(){return this.r.extUri.joinPath(k.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};T=Re([Te(0,w.IUriIdentityService),Te(1,l.INativeEnvironmentService),Te(2,I.IFileService),Te(3,C.ILogService)],T),e.ServerUserDataProfilesService=T;let S=class xt extends T{constructor(g,f,p,u,h){super(f,p,u,h),this.Q=g}I(){return this.Q.getItem(xt.b,[]).map(f=>({...f,location:(0,E.isString)(f.location)?this.r.extUri.joinPath(this.profilesHome,f.location):k.URI.revive(f.location)}))}L(){const g=this.Q.getItem(xt.c,{});return this.Q.getItem(xt.P,!1)?g:this.H(g)}N(){return this.r.extUri.joinPath(k.URI.file(this.a.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};S.P="profileAssociationsMigration",S=Re([Te(0,P.IStateService),Te(1,w.IUriIdentityService),Te(2,l.INativeEnvironmentService),Te(3,I.IFileService),Te(4,C.ILogService)],S),e.UserDataProfilesService=S}),define(ve[124],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,E.createDecorator)("extensionHostStatusService");class k{constructor(){this.a=new Map}setExitInfo(I,C){this.a.set(I,C)}getExitInfo(I){return this.a.get(I)||null}}e.ExtensionHostStatusService=k}),define(ve[252],be([1,0,6,14]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=void 0;function l(C){let P=0,w=0,y=0;C>=1e3&&(y=Math.floor(C/1e3),C-=y*1e3),y>=60&&(w=Math.floor(y/60),y-=w*60),w>=60&&(P=Math.floor(w/60),w-=P*60);const T=P?`${P}h`:"",S=w?`${w}m`:"",b=y?`${y}s`:"",g=C?`${C}ms`:"";return`${T}${S}${b}${g}`}class I{constructor(P,w,y,T){this.i=P,this.j=w,this.a=new E.Emitter,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=y,this.protocol=T,this.e=!1,this.f=new k.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection grace time of ${l(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new k.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection short grace time of ${l(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${l(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(P){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${P}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${l(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const P=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),P.end(),this.a.fire(void 0)}acceptReconnection(P,w,y){this.d=P,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(w,y),this.protocol.endAcceptReconnection()}}e.ManagementConnection=I}),define(ve[125],be([1,0,30,13,7,147,51]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const P=l.join(k.FileAccess.asFileUri("").fsPath,"nls.metadata.json"),w=new Map;function y(b){return new Promise(g=>E.exists(b,g))}function T(b,g){return y(P).then(f=>{if(!f||!C.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});const p=`${b}||${g}`;let u=w.get(p);return u||(u=I.getNLSConfiguration(C.default.commit,g,P,b).then(h=>(S.is(h)&&(h._languagePackSupport=!0),h)),w.set(p,u)),u})}e.getNLSConfiguration=T;var S;(function(b){function g(f){const p=f;return p&&typeof p._languagePackId=="string"}b.is=g})(S=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(ve[126],be([1,0,20,4,25,42,54,33,17,5,12,26,36,34,125]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends C.AbstractExtensionsScannerService{constructor(h,v,d,D,A,t,r,n){super(k.URI.file(A.builtinExtensionsPath),k.URI.file(A.extensionsPath),(0,E.joinPath)(A.userHome,".vscode-oss-dev","extensions","control.json"),(0,E.joinPath)(k.URI.file(A.userDataPath),P.MANIFEST_CACHE_FOLDER),h,v,d,D,A,t,r,n),this.M=A}async f(h){const v=await(0,f.getNLSConfiguration)(h,this.M.userDataPath);if(f.InternalNLSConfiguration.is(v))try{const d=await this.r.readFile(k.URI.file(v._translationsConfigFile));return JSON.parse(d.value.toString())}catch{}return Object.create(null)}};p=Re([Te(0,g.IUserDataProfilesService),Te(1,I.IExtensionsProfileScannerService),Te(2,w.IFileService),Te(3,T.ILogService),Te(4,l.INativeEnvironmentService),Te(5,S.IProductService),Te(6,b.IUriIdentityService),Te(7,y.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(ve[253],be([1,0,254,30,7,22,13,21]),function(ae,e,E,k,l,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const w=/^[0-9A-Za-z_-]+$/;var y;(function(h){h[h.None=0]="None",h[h.Optional=1]="Optional",h[h.Mandatory=2]="Mandatory"})(y=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class T{constructor(){this.type=0}validate(v){return!0}}e.NoneServerConnectionToken=T;class S{constructor(v){this.value=v,this.type=1}validate(v){return v===this.value}}e.OptionalServerConnectionToken=S;class b{constructor(v){this.value=v,this.type=2}validate(v){return v===this.value}}e.MandatoryServerConnectionToken=b;class g{constructor(v){this.message=v}}e.ServerConnectionTokenParseError=g;async function f(h,v){const d=h["without-connection-token"],D=h["connection-token"],A=h["connection-token-file"],t=h.compatibility==="1.63";if(d)return typeof D<"u"||typeof A<"u"?new g("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new T;if(typeof A<"u"){if(typeof D<"u")return new g("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let r;try{r=k.readFileSync(A).toString().replace(/\r?\n$/,"")}catch{return new g(`Unable to read the connection token file at '${A}'.`)}return w.test(r)?new b(r):new g(`The connection token defined in '${A} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof D<"u"?w.test(D)?t?new S(D):new b(D):new g(`The connection token '${D} does not adhere to the characters 0-9, a-z, A-Z or -.`):t?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new S(await v())):new b(await v())}e.parseServerConnectionToken=f;async function p(h){return f(h,async()=>{if(!h["user-data-dir"])return(0,I.generateUuid)();const d=l.join(h["user-data-dir"],"token");try{const t=(await P.Promises.readFile(d)).toString().replace(/\r?\n$/,"");if(w.test(t))return t}catch{}const D=(0,I.generateUuid)();try{await P.Promises.writeFile(d,D,{mode:384})}catch{}return D})}e.determineServerConnectionToken=p;function u(h,v,d){if(h.validate(d.query[C.connectionTokenQueryName]))return!0;const D=E.parse(v.headers.cookie||"");return h.validate(D[C.connectionTokenCookieName])}e.requestHasValidConnectionToken=u}),define(ve[43],be([1,0,193,202,61,5,25]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={host:{type:"string",cat:"o",args:"ip-address",description:E.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:E.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:E.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:E.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:E.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:E.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:E.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:E.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:E.localize(8,null)},"user-data-dir":l.OPTIONS["user-data-dir"],"enable-smoke-test-driver":l.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":l.OPTIONS["disable-telemetry"],"disable-workspace-trust":l.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:l.OPTIONS.log,logsPath:l.OPTIONS.logsPath,"force-disable-user-env":l.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:E.localize(9,null)},"default-workspace":{type:"string",description:E.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":l.OPTIONS["extensions-dir"],"extensions-download-dir":l.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":l.OPTIONS["builtin-extensions-dir"],"install-extension":l.OPTIONS["install-extension"],"install-builtin-extension":l.OPTIONS["install-builtin-extension"],"uninstall-extension":l.OPTIONS["uninstall-extension"],"list-extensions":l.OPTIONS["list-extensions"],"locate-extension":l.OPTIONS["locate-extension"],"show-versions":l.OPTIONS["show-versions"],category:l.OPTIONS.category,force:l.OPTIONS.force,"do-not-sync":l.OPTIONS["do-not-sync"],"pre-release":l.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:E.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:l.OPTIONS.help,version:l.OPTIONS.version,"locate-shell-integration-path":l.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:l.OPTIONS._},e.IServerEnvironmentService=(0,I.refineServiceDecorator)(C.IEnvironmentService);class P extends k.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=P}),define(ve[255],be([1,0,30,90,79,254,116,38,56,3,12,43,7,13,22,26,53,19,4,15,8,66]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v,d,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const t={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function r(a,s,m,R){s.writeHead(m,{"Content-Type":"text/plain"}),s.end(R)}e.serveError=r;var n;(function(a){a[a.NO_CACHING=0]="NO_CACHING",a[a.ETAG=1]="ETAG",a[a.NO_EXPIRY=2]="NO_EXPIRY"})(n=e.CacheControl||(e.CacheControl={}));async function i(a,s,m,R,L,$){try{const ie=await E.promises.stat(a);if(s===1){const ne=`W/"${[ie.ino,ie.size,ie.mtime.getTime()].join("-")}"`;if(R.headers["if-none-match"]===ne)return L.writeHead(304),void L.end();$.Etag=ne}else s===2?$["Cache-Control"]="public, max-age=31536000":s===0&&($["Cache-Control"]="no-store");$["Content-Type"]=t[(0,b.extname)(a)]||(0,w.getMediaMime)(a)||"text/plain",L.writeHead(200,$),(0,E.createReadStream)(a).pipe(L)}catch(ie){return ie.code!=="ENOENT"?(m.error(ie),console.error(ie.toString())):console.error(`File not found: ${a}`),L.writeHead(404,{"Content-Type":"text/plain"}),void L.end("Not found")}}e.serveFile=i;const o=(0,b.dirname)(g.FileAccess.asFileUri("").fsPath);let c=class{constructor(s,m,R,L,$){this.f=s,this.g=m,this.h=R,this.i=L,this.j=$,this.a=this.j.extensionsGallery?.resourceUrlTemplate?v.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const ie=(0,A.getRemoteServerRootPath)($);this.b=`${ie}/static`,this.c=`${ie}/callback`,this.d=`${ie}/web-extension-resource`}async handle(s,m,R){try{const L=R.pathname;return L.startsWith(this.b)&&L.charCodeAt(this.b.length)===47?this.k(s,m,R):L==="/"?this.n(s,m,R):L===this.c?this.p(m):L.startsWith(this.d)&&L.charCodeAt(this.d.length)===47?this.m(s,m,R):r(s,m,404,"Not found.")}catch(L){return this.h.error(L),console.error(L.toString()),r(s,m,500,"Internal Server Error.")}}async k(s,m,R){const L=Object.create(null),ie=decodeURIComponent(R.pathname).substring(this.b.length+1),ne=(0,b.join)(o,ie);return(0,P.isEqualOrParent)(ne,o,!y.isLinux)?i(ne,this.g.isBuilt?2:1,this.h,s,m,L):r(s,m,400,"Bad request.")}l(s){const m=s.authority.indexOf(".");return m!==-1?s.authority.substring(m+1):void 0}async m(s,m,R){if(!this.a)return r(s,m,500,"No extension gallery service configured.");const L=decodeURIComponent(R.pathname),$=(0,b.normalize)(L.substring(this.d.length+1)),ie=v.URI.parse($).with({scheme:this.a.scheme,authority:$.substring(0,$.indexOf("/")),path:$.substring($.indexOf("/")+1)});if(this.l(this.a)!==this.l(ie))return r(s,m,403,"Request Forbidden");const ne={},F=Y=>{const H=s.headers[Y];H&&((0,D.isString)(H)||H[0])?ne[Y]=(0,D.isString)(H)?H:H[0]:Y!==Y.toLowerCase()&&F(Y.toLowerCase())};F("X-Client-Name"),F("X-Client-Version"),F("X-Machine-Id"),F("X-Client-Commit");const _=await this.i.request({type:"GET",url:ie.toString(!0),headers:ne},h.CancellationToken.None),z=_.res.statusCode||500;if(z!==200){let Y=null;try{Y=await(0,u.asTextOrError)(_)}catch{}return r(s,m,z,Y||`Request failed with status ${z}`)}const x=Object.create(null),le=Y=>{const H=_.res.headers[Y];H?x[Y]=H:Y!==Y.toLowerCase()&&le(Y.toLowerCase())};le("Cache-Control"),le("Content-Type"),m.writeHead(200,x);const Ee=await(0,d.streamToBuffer)(_.stream);return void m.end(Ee.buffer)}async n(s,m,R){const L=R.query[g.connectionTokenQueryName];if(typeof L=="string"){const re=Object.create(null);re["Set-Cookie"]=I.serialize(g.connectionTokenCookieName,L,{sameSite:"lax",maxAge:60*60*24*7});const de=Object.create(null);for(const j in R.query)j!==g.connectionTokenQueryName&&(de[j]=R.query[j]);const oe=l.format({pathname:"/",query:de});return re.Location=oe,m.writeHead(302,re),void m.end()}const $=re=>{const de=s.headers[re];return Array.isArray(de)?de[0]:de},ie=$("x-original-host")||$("x-forwarded-host")||s.headers.host;if(!ie)return r(s,m,400,"Bad request.");function ne(re){return JSON.stringify(re).replace(/"/g,"&quot;")}let F;this.g.args["enable-smoke-test-driver"]&&(F=!1);const _=re=>re&&v.URI.file(k.resolve(re)).with({scheme:g.Schemas.vscodeRemote,authority:ie}),z=g.FileAccess.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,x=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,f.generateUuid)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,le={remoteAuthority:ie,_wrapWebWorkerExtHostInIframe:F,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:_(this.g.args["default-folder"]),workspaceUri:_(this.g.args["default-workspace"]),productConfiguration:{embedderIdentifier:"server-distro",extensionsGallery:this.a?{...this.j.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:ie,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0},callbackRoute:this.c},Ee=this.j.extensionsGallery?.nlsBaseUrl,Y={WORKBENCH_WEB_CONFIGURATION:ne(le),WORKBENCH_AUTH_SESSION:x?ne(x):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:Ee?`${Ee}${Ee.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""};let H;try{H=(await E.promises.readFile(z)).toString().replace(/\{\{([^}]+)\}\}/g,(de,oe)=>Y[oe]??"undefined")}catch{return m.writeHead(404,{"Content-Type":"text/plain"}),void m.end("Not found")}const U=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(H).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=' http://${ie};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),te={"Content-Type":"text/html","Content-Security-Policy":U};return this.f.type!==0&&(te["Set-Cookie"]=I.serialize(g.connectionTokenCookieName,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),m.writeHead(200,te),void m.end(H)}o(s){const m=/<script>([\s\S]+?)<\/script>/img,R=[];let L;for(;L=m.exec(s);){const $=C.createHash("sha256"),ie=L[1].replace(/\r\n/g,`
`),ne=$.update(Buffer.from(ie)).digest().toString("base64");R.push(`'sha256-${ne}'`)}return R}async p(s){const m=g.FileAccess.asFileUri("vs/code/browser/workbench/callback.html").fsPath,R=(await E.promises.readFile(m)).toString(),L=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(R).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return s.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":L}),void s.end(R)}};c=Re([Te(1,S.IServerEnvironmentService),Te(2,T.ILogService),Te(3,u.IRequestService),Te(4,p.IProductService)],c),e.WebClientServer=c}),define(ve[256],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class k{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.ExtHostRpcService=k}),define(ve[67],be([1,0,72]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function k(I){return{transformIncoming:C=>C.scheme==="vscode-remote"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="file"?{scheme:"vscode-local",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoing:C=>C.scheme==="file"?{scheme:"vscode-remote",authority:I,path:C.path,query:C.query,fragment:C.fragment}:C.scheme==="vscode-local"?{scheme:"file",path:C.path,query:C.query,fragment:C.fragment}:C,transformOutgoingScheme:C=>C==="file"?"vscode-remote":C==="vscode-local"?"file":C}}function l(I){return new E.URITransformer(k(I))}e.createURITransformer=l}),define(ve[257],be([1,0,4,67,64,7,220]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class P extends C.AbstractDiskFileSystemProviderChannel{constructor(T,S){super(new l.DiskFileSystemProvider(T),T),this.H=S,this.G=new Map,this.B(this.a)}c(T){let S=this.G.get(T.remoteAuthority);return S||(S=(0,k.createURITransformer)(T.remoteAuthority),this.G.set(T.remoteAuthority,S)),S}f(T,S,b=!1){if(b&&S.path==="/vscode-resource"&&S.query){const g=JSON.parse(S.query).requestResourcePath;return E.URI.from({scheme:"file",path:g})}return E.URI.revive(T.transformIncoming(S))}F(T,S){return new w(T,S,this.b,this.H)}}e.RemoteAgentFileSystemProviderChannel=P;class w extends C.AbstractSessionFileWatcher{constructor(T,S,b,g){super(T,S,b,g)}i(T){const S=T.args["file-watcher-polling"];if(S){const b=S.split(I.delimiter),g=Number(b[0]);if(g>0)return{usePolling:b.length>1?b.slice(1):!0,pollingInterval:g}}}j(T){if(T.extensionsPath)return[I.posix.join(T.extensionsPath,"**")]}}}),define(ve[83],be([1,0,195,8,4,2,5,39,17,13,37,157,58]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var g;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(g=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var f;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(f=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function p(oe){const j=oe;return!!j&&typeof j.getSelection=="function"&&!!j.onDidChangeSelection}e.isEditorPaneWithSelection=p;function u(oe,j,N){for(const M of N.visibleEditorPanes)if(M.group.id===j&&oe.matches(M.input))return M.getViewState()}e.findViewStateForEditor=u;function h(oe){if(s(oe))return!1;const j=oe;return l.URI.isUri(j?.resource)}e.isResourceEditorInput=h;function v(oe){if(s(oe))return!1;const j=oe;return j?.original!==void 0&&j.modified!==void 0}e.isResourceDiffEditorInput=v;function d(oe){if(s(oe)||v(oe))return!1;const j=oe;return j?.primary!==void 0&&j.secondary!==void 0}e.isResourceSideBySideEditorInput=d;function D(oe){if(s(oe))return!1;const j=oe;return j?j.resource===void 0||j.resource.scheme===y.Schemas.untitled||j.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=D;const A=/Untitled-\d+/;function t(oe){return oe.scheme===y.Schemas.untitled&&oe.path.length>1&&!A.test(oe.path)}e.isUntitledWithAssociatedResource=t;function r(oe){if(s(oe))return!1;const j=oe;return l.URI.isUri(j?.base?.resource)&&l.URI.isUri(j?.input1?.resource)&&l.URI.isUri(j?.input2?.resource)&&l.URI.isUri(j?.result?.resource)}e.isResourceMergeEditorInput=r;var n;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(n=e.Verbosity||(e.Verbosity={}));var i;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.a=new Map}registerSource(j,N){let M=this.a.get(j);return M||(M={source:j,label:N},this.a.set(j,M)),M.source}getSourceLabel(j){return this.a.get(j)?.label??j}}e.SaveSourceRegistry=new o;var c;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors"})(c=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends I.Disposable{}e.AbstractEditorInput=a;function s(oe){return oe instanceof a}e.isEditorInput=s;function m(oe){const j=oe;return l.URI.isUri(j?.preferredResource)}function R(oe){const j=oe;return s(j?.primary)&&s(j?.secondary)}e.isSideBySideEditorInput=R;function L(oe){const j=oe;return s(j?.modified)&&s(j?.original)}e.isDiffEditorInput=L;function $(oe,j,N,M,q){return de(M,[(0,S.toAction)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const ee={...N,limits:{size:Number.MAX_VALUE}};oe.openEditor(j,ee)}}),(0,S.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:b.default.Warning})}e.createTooLargeFileError=$;function ie(oe){return s(oe?.editor)}e.isEditorInputWithOptions=ie;function ne(oe){const j=oe;return ie(oe)&&j?.group!==void 0}e.isEditorInputWithOptionsAndGroup=ne;function F(oe){const j=oe;return typeof j?.groupId=="number"&&s(j.editor)}e.isEditorIdentifier=F;var _;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(_=e.EditorCloseContext||(e.EditorCloseContext={}));var z;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LOCKED=2]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=3]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=4]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=5]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=7]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=9]="EDITOR_PIN",oe[oe.EDITOR_STICKY=10]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=11]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(z=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var x;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(x=e.SideBySideEditor||(e.SideBySideEditor={}));class le{getOriginalUri(j,N){if(!j)return;if(r(j))return e.EditorResourceAccessor.getOriginalUri(j.result,N);if(N?.supportSideBySide){const{primary:q,secondary:ee}=this.a(j);if(q&&ee){if(N?.supportSideBySide===x.BOTH)return{primary:this.getOriginalUri(q,{filterByScheme:N.filterByScheme}),secondary:this.getOriginalUri(ee,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===x.ANY)return this.getOriginalUri(q,{filterByScheme:N.filterByScheme})??this.getOriginalUri(ee,{filterByScheme:N.filterByScheme});j=N.supportSideBySide===x.PRIMARY?q:ee}}if(v(j)||d(j)||r(j))return;const M=m(j)?j.preferredResource:j.resource;return!M||!N||!N.filterByScheme?M:this.b(M,N.filterByScheme)}a(j){return R(j)||d(j)?{primary:j.primary,secondary:j.secondary}:L(j)||v(j)?{primary:j.modified,secondary:j.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(j,N){if(!j)return;if(r(j))return e.EditorResourceAccessor.getCanonicalUri(j.result,N);if(N?.supportSideBySide){const{primary:q,secondary:ee}=this.a(j);if(q&&ee){if(N?.supportSideBySide===x.BOTH)return{primary:this.getCanonicalUri(q,{filterByScheme:N.filterByScheme}),secondary:this.getCanonicalUri(ee,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===x.ANY)return this.getCanonicalUri(q,{filterByScheme:N.filterByScheme})??this.getCanonicalUri(ee,{filterByScheme:N.filterByScheme});j=N.supportSideBySide===x.PRIMARY?q:ee}}if(v(j)||d(j)||r(j))return;const M=j.resource;return!M||!N||!N.filterByScheme?M:this.b(M,N.filterByScheme)}b(j,N){if(Array.isArray(N)){if(N.some(M=>j.scheme===M))return j}else if(N===j.scheme)return j}}e.EditorResourceAccessor=new le;var Ee;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(Ee=e.CloseDirection||(e.CloseDirection={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(j){const N=this.a=j.get(C.IInstantiationService);for(const[M,q]of this.c)this.e(M,q,N);this.c.clear()}e(j,N,M){const q=M.createInstance(N);this.d.set(j,q)}registerFileEditorFactory(j){if(this.b)throw new Error("Can only register one file editor factory.");this.b=j}getFileEditorFactory(){return(0,k.assertIsDefined)(this.b)}registerEditorSerializer(j,N){if(this.c.has(j)||this.d.has(j))throw new Error(`A editor serializer with type ID '${j}' was already registered.`);return this.a?this.e(j,N,this.a):this.c.set(j,N),(0,I.toDisposable)(()=>{this.c.delete(j),this.d.delete(j)})}getEditorSerializer(j){return this.d.get(typeof j=="string"?j:j.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new Y);async function H(oe,j,N){return!oe||!oe.length?[]:await Promise.all(oe.map(async M=>{const q=l.URI.revive(M.fileUri);if(!q){N.info("Cannot resolve the path because it is not valid.",M);return}if(!await j.canHandleResource(q)){N.info("Cannot resolve the path because it cannot be handled",M);return}let fe=M.exists,W=M.type;if(typeof fe!="boolean"||typeof W!="number")try{W=(await j.stat(q)).isDirectory?w.FileType.Directory:w.FileType.Unknown,fe=!0}catch(Z){N.error(Z),fe=!1}if(!fe&&M.openOnlyIfExists){N.info("Cannot resolve the path because it does not exist",M);return}if(W===w.FileType.Directory){N.info("Cannot resolve the path because it is a directory",M);return}const K={...M.options,pinned:!0};return fe?{resource:q,options:K}:{resource:q,options:K,forceUntitled:!0}}))}e.pathsToEditors=H;var U;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(U=e.EditorsOrder||(e.EditorsOrder={}));function te(oe){const j=oe;if(!j)return!1;const N=j;if(N.modified)return te(N.modified);const M=j;return!!(M.contributionsState&&M.viewState&&Array.isArray(M.cursorState))}e.isTextEditorViewState=te;function re(oe){return(0,T.isErrorWithActions)(oe)}e.isEditorOpenError=re;function de(oe,j,N){const M=(0,T.createErrorWithActions)(oe,j);return M.forceMessage=N?.forceMessage,M.forceSeverity=N?.forceSeverity,M.allowDialog=N?.allowDialog,M}e.createEditorOpenError=de}),define(ve[127],be([1,0,15,71,55,56,13,7,3,103]),function(ae,e,E,k,l,I,C,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var T;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(T=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",I.Mimes.latex,I.Mimes.markdown,"image/png","image/jpeg",I.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[I.Mimes.latex,I.Mimes.markdown,"application/json",I.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var S;(function(x){x[x.Running=1]="Running",x[x.Idle=2]="Idle"})(S=e.NotebookRunState||(e.NotebookRunState={}));var b;(function(x){x[x.Unconfirmed=1]="Unconfirmed",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(b=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var g;(function(x){x[x.WithHardKernelDependency=0]="WithHardKernelDependency",x[x.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",x[x.Pure=2]="Pure",x[x.Never=3]="Never"})(g=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(x){x.Always="always",x.Never="never",x.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(x){x[x.ModelChange=1]="ModelChange",x[x.Move=2]="Move",x[x.ChangeCellLanguage=5]="ChangeCellLanguage",x[x.Initialize=6]="Initialize",x[x.ChangeCellMetadata=7]="ChangeCellMetadata",x[x.Output=8]="Output",x[x.OutputItem=9]="OutputItem",x[x.ChangeCellContent=10]="ChangeCellContent",x[x.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",x[x.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",x[x.ChangeCellMime=13]="ChangeCellMime",x[x.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(x){x[x.Handle=0]="Handle",x[x.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(x){x[x.Replace=1]="Replace",x[x.Output=2]="Output",x[x.Metadata=3]="Metadata",x[x.CellLanguage=4]="CellLanguage",x[x.DocumentMetadata=5]="DocumentMetadata",x[x.Move=6]="Move",x[x.OutputItems=7]="OutputItems",x[x.PartialMetadata=8]="PartialMetadata",x[x.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var v;(function(x){x.scheme=C.Schemas.vscodeNotebookCell;const le=["W","X","Y","Z","a","b","c","d","e","f"],Ee=new RegExp(`^[${le.join("")}]+`),Y=7;function H(j,N){const M=N.toString(Y),ee=`${M.length<le.length?le[M.length-1]:"z"}${M}s${(0,E.encodeBase64)(E.VSBuffer.fromString(j.scheme),!0,!0)}`;return j.with({scheme:x.scheme,fragment:ee})}x.generate=H;function U(j){if(j.scheme!==x.scheme)return;const N=j.fragment.indexOf("s");if(N<0)return;const M=parseInt(j.fragment.substring(0,N).replace(Ee,""),Y),q=(0,E.decodeBase64)(j.fragment.substring(N+1)).toString();if(!isNaN(M))return{handle:M,notebook:j.with({scheme:q,fragment:null})}}x.parse=U;function te(j,N){return j.with({scheme:C.Schemas.vscodeNotebookCellOutput,fragment:`op${N??""},${j.scheme!==C.Schemas.file?j.scheme:""}`})}x.generateCellOutputUri=te;function re(j){if(j.scheme!==C.Schemas.vscodeNotebookCellOutput)return;const N=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(j.fragment);if(!N)return;const M=N[1]&&N[1]!==""?N[1]:void 0,q=N[2];return{outputId:M,notebook:j.with({scheme:q||C.Schemas.file,fragment:null})}}x.parseCellOutputUri=re;function de(j,N,M){return x.generate(j,N).with({scheme:M})}x.generateCellPropertyUri=de;function oe(j,N){if(j.scheme===N)return x.parse(j.with({scheme:x.scheme}))}x.parseCellPropertyUri=oe})(v=e.CellUri||(e.CellUri={}));const d=x=>w.isWindows?x.replace(/\//g,"\\"):x;class D{constructor(le=[],Ee=e.NOTEBOOK_DISPLAY_ORDER){this.e=Ee,this.d=[...new Set(le)].map(Y=>({pattern:Y,matches:k.parse(d(Y))}))}sort(le){const Ee=new Map(l.Iterable.map(le,H=>[H,d(H)]));let Y=[];for(const{matches:H}of this.d)for(const[U,te]of Ee)if(H(te)){Y.push(U),Ee.delete(U);break}return Ee.size&&(Y=Y.concat([...Ee.keys()].sort((H,U)=>this.e.indexOf(H)-this.e.indexOf(U)))),Y}prioritize(le,Ee){const Y=this.f(le);if(Y===-1){this.d.unshift({pattern:le,matches:k.parse(d(le))});return}const H=new Set(Ee.map(te=>this.f(te,Y)));H.delete(-1);const U=Array.from(H).sort();this.d.splice(Y+1,0,...U.map(te=>this.d[te]));for(let te=U.length-1;te>=0;te--)this.d.splice(U[te],1)}toArray(){return this.d.map(le=>le.pattern)}f(le,Ee=this.d.length){const Y=d(le);for(let H=0;H<Ee;H++)if(this.d[H].matches(Y))return H;return-1}}e.MimeTypeDisplayOrder=D;function A(x,le,Ee,Y=(H,U)=>H===U){const H=[];function U(de,oe,j){if(oe===0&&j.length===0)return;const N=H[H.length-1];N&&N.start+N.deleteCount===de?(N.deleteCount+=oe,N.toInsert.push(...j)):H.push({start:de,deleteCount:oe,toInsert:j})}let te=0,re=0;for(;;){if(te===x.length){U(te,0,le.slice(re));break}if(re===le.length){U(te,x.length-te,[]);break}const de=x[te],oe=le[re];if(Y(de,oe)){te+=1,re+=1;continue}Ee(oe)?(U(te,1,[]),te+=1):(U(te,0,[oe]),re+=1)}return H}e.diff=A,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new y.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(x){x.default="default",x.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(x){const le=x;return!!((typeof le.include=="string"||k.isRelativePattern(le.include))&&(typeof le.exclude=="string"||k.isRelativePattern(le.exclude)))}e.isDocumentExcludePattern=r;function n(x,le,Ee){if(Array.isArray(x.viewType)&&x.viewType.indexOf(le)>=0||x.viewType===le)return!0;if(x.filenamePattern){const Y=r(x.filenamePattern)?x.filenamePattern.include:x.filenamePattern,H=r(x.filenamePattern)?x.filenamePattern.exclude:void 0;if(k.match(Y,(0,P.basename)(Ee.fsPath).toLowerCase()))return!(H&&k.match(H,(0,P.basename)(Ee.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",logging:"notebook.logging"};var i;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(le){return`${o.d}${le}`}static parse(le){if(le.startsWith(o.d))return le.substring(o.d.length)}}o.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=o;function c(x){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(x)}e.isTextStreamMime=c;const a=new TextDecoder;function s(x){const le=[];let Ee=!1;for(const Y of x)(le.length===0||Ee)&&(le.push(Y),Ee=!0);return $(le),z(E.VSBuffer.concat(le.map(Y=>E.VSBuffer.wrap(Y))))}e.compressOutputItemStreams=s;const m=`${String.fromCharCode(27)}[A`,R=m.split("").map(x=>x.charCodeAt(0)),L=10;function $(x){x.forEach((le,Ee)=>{if(Ee===0||le.length<m.length)return;const Y=x[Ee-1],H=le.subarray(0,m.length);if(H[0]===R[0]&&H[1]===R[1]&&H[2]===R[2]){const U=Y.lastIndexOf(L);if(U===-1)return;x[Ee-1]=Y.subarray(0,U),x[Ee]=le.subarray(m.length)}})}function ie(x){let le=x;do x=le,le=x.replace(/[^\n]\x08/gm,"");while(le.length<x.length);return x}function ne(x){for(x=x.replace(/\r+\n/gm,`
`);x.search(/\r[^$]/g)>-1;){const le=x.match(/^(.*)\r+/m)[1];let Ee=x.match(/\r+(.*)$/m)[1];Ee=Ee+le.slice(Ee.length,le.length),x=x.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Ee)}return x}const F="\b".charCodeAt(0),_="\r".charCodeAt(0);function z(x){return!x.buffer.includes(F)&&!x.buffer.includes(_)?x:E.VSBuffer.fromString(ne(ie(a.decode(x.buffer))))}}),define(ve[258],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,E.createDecorator)("environmentVariableService")}),define(ve[259],be([1,0,7,57,3,243,8]),function(ae,e,E,k,l,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preparePathForShell=e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function P(t,r){if(!!r)if(l.isWindows)for(const n in r){let i=n;for(const c in t)if(n.toLowerCase()===c.toLowerCase()){i=c;break}const o=r[n];o!==void 0&&w(t,i,o)}else Object.keys(r).forEach(n=>{const i=r[n];i!==void 0&&w(t,n,i)})}e.mergeEnvironments=P;function w(t,r,n){typeof n=="string"?t[r]=n:delete t[r]}function y(t,r,n,i){t.TERM_PROGRAM="vscode",r&&(t.TERM_PROGRAM_VERSION=r),b(t,i)&&(t.LANG=g(n)),t.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=y;function T(t,r){if(!!r)for(const n of Object.keys(r)){const i=r[n];i&&(t[n]=i)}}async function S(t,r){return await Promise.all(Object.entries(r).map(async([n,i])=>{if(typeof i=="string")try{r[n]=await t(i)}catch{r[n]=i}})),r}function b(t,r){if(r==="on")return!0;if(r==="auto"){const n=t.LANG;return!n||n.search(/\.UTF\-8$/)===-1&&n.search(/\.utf8$/)===-1&&n.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=b;function g(t){const r=t?t.split("-"):[],n=r.length;if(n===0)return"en_US.UTF-8";if(n===1){const i={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};r[0]in i&&r.push(i[r[0]])}else r[1]=r[1].toUpperCase();return r.join("_")+".UTF-8"}e.getLangEnvVariable=g;async function f(t,r,n,i,o,c){if(t.cwd){const s=typeof t.cwd=="object"?t.cwd.fsPath:t.cwd,m=await p(s,n);return(0,I.sanitizeCwd)(m||s)}let a;return!t.ignoreConfigurationCwd&&o&&(n&&(o=await p(o,n,c)),o&&(E.isAbsolute(o)?a=o:i&&(a=E.join(i.fsPath,o)))),a||(a=i?i.fsPath:r||""),(0,I.sanitizeCwd)(a)}e.getCwd=f;async function p(t,r,n){if(r)try{return await r(t)}catch(i){n?.error("Could not resolve terminal cwd",i);return}return t}function u(t,r,n){if(!!n)return i=>n.resolveWithEnvironment(r,t,i)}e.createVariableResolver=u;async function h(t,r,n,i,o,c,a,s=l.platform){let m;a&&(m=d(t,"automationShell",s)),m||(m=d(t,"shell",s));let R=m||r;if(s===3&&!n&&i){const L=E.join(i,"Sysnative").replace(/\//g,"\\").toLowerCase();R&&R.toLowerCase().indexOf(L)===0&&(R=E.join(i,"System32",R.substr(L.length+1)))}if(R&&s===3&&(R=R.replace(/\//g,"\\")),o)try{R=await o(R)}catch(L){c.error("Could not resolve shell",L)}return R}e.getDefaultShell=h;async function v(t,r,n,i,o=l.platform){if(r&&d(t,"automationShell",o))return[];const c=o===3?"windows":o===1?"osx":"linux";let a=t(`terminal.integrated.shellArgs.${c}`);if(!a)return[];if(typeof a=="string"&&o===3)return n?await n(a):a;if(n){const s=[];for(const m of a)try{s.push(await n(m))}catch(R){i.error(`Could not resolve terminal.integrated.shellArgs.${c}`,R),s.push(m)}a=s}return a}e.getDefaultShellArgs=v;function d(t,r,n=l.platform){return t(`terminal.integrated.${r}.${n===3?"windows":n===1?"osx":"linux"}`)}async function D(t,r,n,i,o,c){const a={};if(t.strictEnv)T(a,t.env);else{T(a,c);const s={...r};n&&(s&&await S(n,s),t.env&&await S(n,t.env)),(0,k.sanitizeProcessEnvironment)(a,"VSCODE_IPC_HOOK_CLI"),P(a,s),P(a,t.env),y(a,i,l.language,o)}return a}e.createTerminalEnvironment=D;async function A(t,r,n,i,o,c,a=l.isWindows){let s;if((0,C.isString)(t)?s=t:(s=t.fsPath,a&&c!==1?s=s.replace(/\\/g,"/"):!a&&c===1&&(s=s.replace(/\//g,"\\"))),!r)return s;const m=s.includes(" "),R=s.includes("(")||s.includes(")"),L=E.basename(r,".exe"),$=L==="pwsh"||n==="pwsh"||L==="powershell"||n==="powershell";if($&&(m||s.includes("'")))return`& '${s.replace(/'/g,"''")}'`;if(R&&$)return`& '${s}'`;if(c===1){if(i!==void 0)return i==="gitbash"?(0,I.escapeNonWindowsPath)(s.replace(/\\/g,"/")):i==="wsl"?o?.getWslPath(s,"win-to-unix")||s:m?`"${s}"`:s;const ie=r.toLowerCase();return ie.includes("wsl")||ie.includes("bash.exe")&&!ie.toLowerCase().includes("git")?o?.getWslPath(s,"win-to-unix")||s:m?`"${s}"`:s}return(0,I.escapeNonWindowsPath)(s)}e.preparePathForShell=A}),define(ve[68],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(I){I.Delimiter="\0"})(E=e.TestIdPathParts||(e.TestIdPathParts={}));var k;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(k=e.TestPosition||(e.TestPosition={}));class l{static fromExtHostTestItem(C,P,w=C.parent){if(C._isRoot)return new l([P]);const y=[C.id];for(let T=w;T&&T.id!==P;T=T.parent)y.push(T.id);return y.push(P),new l(y.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const P=C.indexOf("\0");return P===-1?C:C.slice(0,P)}static fromString(C){return new l(C.split("\0"))}static join(C,P){return new l([...C.path,P])}static joinToString(C,P){return C.toString()+"\0"+P}static parentId(C){const P=C.lastIndexOf("\0");return P===-1?void 0:C.slice(0,P)}static localId(C){const P=C.lastIndexOf("\0");return P===-1?C:C.slice(P+1)}static compare(C,P){return C===P?0:P.startsWith(C+"\0")?2:C.startsWith(P+"\0")?3:1}constructor(C,P=C.length){if(this.path=C,this.d=P,C.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new l(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let C=1;C<=this.d;C++)yield new l(this.path,C)}*idsToRoot(){for(let C=this.d;C>0;C--)yield new l(this.path,C)}compare(C){if(typeof C=="string")return l.compare(this.toString(),C);for(let P=0;P<C.d&&P<this.d;P++)if(C.path[P]!==this.path[P])return 1;return C.d>this.d?2:C.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let C=1;C<this.d;C++)this.c+="\0",this.c+=this.path[C]}return this.c}}e.TestId=l}),define(ve[84],be([1,0,4,47,68]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var I;(function(a){a[a.Unset=0]="Unset",a[a.Queued=1]="Queued",a[a.Running=2]="Running",a[a.Passed=3]="Passed",a[a.Failed=4]="Failed",a[a.Skipped=5]="Skipped",a[a.Errored=6]="Errored"})(I=e.TestResultState||(e.TestResultState={}));var C;(function(a){a[a.Run=2]="Run",a[a.Debug=4]="Debug",a[a.Coverage=8]="Coverage",a[a.HasNonDefaultProfile=16]="HasNonDefaultProfile",a[a.HasConfigurable=32]="HasConfigurable",a[a.SupportsContinuousRun=64]="SupportsContinuousRun"})(C=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const P=a=>"runId"in a;e.isStartControllerTests=P;var w;(function(a){a.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),a.deserialize=s=>({range:k.Range.lift(s.range),uri:E.URI.revive(s.uri)})})(w=e.IRichLocation||(e.IRichLocation={}));var y;(function(a){a[a.Error=0]="Error",a[a.Output=1]="Output"})(y=e.TestMessageType||(e.TestMessageType={}));var T;(function(a){a.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&w.serialize(s.location)}),a.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&w.deserialize(s.location)})})(T=e.ITestErrorMessage||(e.ITestErrorMessage={}));const S=(a,s)=>`${s?"s":"e"}${a}`;e.getMarkId=S;var b;(function(a){a.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&w.serialize(s.location)}),a.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&w.deserialize(s.location)})})(b=e.ITestOutputMessage||(e.ITestOutputMessage={}));var g;(function(a){a.serialize=s=>s.type===0?T.serialize(s):b.serialize(s),a.deserialize=s=>s.type===0?T.deserialize(s):b.deserialize(s)})(g=e.ITestMessage||(e.ITestMessage={}));var f;(function(a){a.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),a.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(g.serialize)}),a.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(g.deserialize)})})(f=e.ITestTaskState||(e.ITestTaskState={}));const p="\0",u=(a,s)=>a+p+s;e.namespaceTestTag=u;const h=a=>{const s=a.indexOf(p);return{ctrlId:a.slice(0,s),tagId:a.slice(s+1)}};e.denamespaceTestTag=h;var v;(function(a){a.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),a.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?E.URI.revive(s.uri):void 0,range:s.range?k.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(v=e.ITestItem||(e.ITestItem={}));var d;(function(a){a[a.NotExpandable=0]="NotExpandable",a[a.Expandable=1]="Expandable",a[a.BusyExpanding=2]="BusyExpanding",a[a.Expanded=3]="Expanded"})(d=e.TestItemExpandState||(e.TestItemExpandState={}));var D;(function(a){a.serialize=s=>({expand:s.expand,item:v.serialize(s.item)}),a.deserialize=s=>({controllerId:l.TestId.root(s.item.extId),expand:s.expand,item:v.deserialize(s.item)})})(D=e.InternalTestItem||(e.InternalTestItem={}));var A;(function(a){a.serialize=s=>{let m;return s.item&&(m={},s.item.label!==void 0&&(m.label=s.item.label),s.item.tags!==void 0&&(m.tags=s.item.tags),s.item.busy!==void 0&&(m.busy=s.item.busy),s.item.uri!==void 0&&(m.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(m.range=s.item.range?.toJSON()),s.item.description!==void 0&&(m.description=s.item.description),s.item.error!==void 0&&(m.error=s.item.error),s.item.sortText!==void 0&&(m.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:m}},a.deserialize=s=>{let m;return s.item&&(m={},s.item.label!==void 0&&(m.label=s.item.label),s.item.tags!==void 0&&(m.tags=s.item.tags),s.item.busy!==void 0&&(m.busy=s.item.busy),s.item.range!==void 0&&(m.range=s.item.range?k.Range.lift(s.item.range):null),s.item.description!==void 0&&(m.description=s.item.description),s.item.error!==void 0&&(m.error=s.item.error),s.item.sortText!==void 0&&(m.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:m}}})(A=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(a,s)=>{s.expand!==void 0&&(a.expand=s.expand),s.item!==void 0&&(a.item=a.item?Object.assign(a.item,s.item):s.item)};e.applyTestItemUpdate=t;var r;(function(a){a.serializeWithoutMessages=s=>({...D.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(f.serializeWithoutMessages),retired:s.retired}),a.serialize=s=>({...D.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(f.serialize),retired:s.retired}),a.deserialize=s=>({...D.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(f.deserialize),retired:!0})})(r=e.TestResultItem||(e.TestResultItem={}));var n;(function(a){a[a.Function=0]="Function",a[a.Statement=1]="Statement"})(n=e.DetailType||(e.DetailType={}));var i;(function(a){a[a.Add=0]="Add",a[a.Update=1]="Update",a[a.DocumentSynced=2]="DocumentSynced",a[a.Remove=3]="Remove",a[a.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",a[a.Retire=5]="Retire",a[a.AddTag=6]="AddTag",a[a.RemoveTag=7]="RemoveTag"})(i=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(a){a.deserialize=s=>s.op===0?{op:s.op,item:D.deserialize(s.item)}:s.op===1?{op:s.op,item:A.deserialize(s.item)}:s.op===2?{op:s.op,uri:E.URI.revive(s.uri),docv:s.docv}:s,a.serialize=s=>s.op===0?{op:s.op,item:D.serialize(s.item)}:s.op===1?{op:s.op,item:A.serialize(s.item)}:s})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(s){const m=this.o();for(const R of s)switch(R.op){case 0:this.j(D.deserialize(R.item),m);break;case 1:this.k(A.deserialize(R.item),m);break;case 3:this.l(R.itemId,m);break;case 5:this.m(R.itemId);break;case 4:this.updatePendingRoots(R.amount);break;case 6:this.c.set(R.tag.id,R.tag);break;case 7:this.c.delete(R.id);break}m.complete?.()}j(s,m){const R=l.TestId.parentId(s.item.extId)?.toString();let L;if(!R)L=this.p(s),this.f.add(L),this.d.set(s.item.extId,L);else if(this.d.has(R)){const $=this.d.get(R);$.children.add(s.item.extId),L=this.p(s,$),this.d.set(s.item.extId,L)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(s)}`);return}return m.add?.(L),s.expand===2&&this.g++,L}k(s,m){const R=this.d.get(s.extId);if(!!R)return s.expand!==void 0&&(R.expand===2&&this.g--,s.expand===2&&this.g++),(0,e.applyTestItemUpdate)(R,s),m.update?.(R),R}l(s,m){const R=this.d.get(s);if(!R)return;const L=l.TestId.parentId(R.item.extId)?.toString();L?this.d.get(L).children.delete(R.item.extId):this.f.delete(R);const $=[[s]];for(;$.length;)for(const ie of $.pop()){const ne=this.d.get(ie);ne&&($.push(ne.children),this.d.delete(ie),m.remove?.(ne,ne!==R),ne.expand===2&&this.g--)}}m(s){}updatePendingRoots(s){this.h+=s}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(ve[128],be([1,0,14,6,2,86,84,68]),function(ae,e,E,k,l,I,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var w;(function(v){v[v.Upsert=0]="Upsert",v[v.SetTags=1]="SetTags",v[v.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",v[v.RemoveChild=3]="RemoveChild",v[v.SetProp=4]="SetProp",v[v.Bulk=5]="Bulk",v[v.DocumentSynced=6]="DocumentSynced"})(w=e.TestItemEventOp||(e.TestItemEventOp={}));const y=(v,d)=>v===d,S=Object.entries({range:(v,d)=>v===d?!0:!v||!d?!1:v.equalsRange(d),busy:y,label:y,description:y,error:y,sortText:y,tags:(v,d)=>!(v.length!==d.length||v.some(D=>!d.includes(D)))}),b=(v,d)=>{let D;for(const[A,t]of S)t(v[A],d[A])||(D?D[A]=d[A]:D={[A]:d[A]});return D};class g extends l.Disposable{get root(){return this.m.root}constructor(d){super(),this.m=d,this.f=this.B(new E.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new k.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(d){this.h=d;for(const D of this.tree.values())this.G(D)}collectDiff(){const d=this.k;return this.k=[],d}pushDiff(d){switch(d.op){case 2:{for(const D of this.k)if(D.op===2&&D.uri===d.uri){D.docv=d.docv;return}break}case 1:{const D=this.k[this.k.length-1];if(D){if(D.op===1&&D.item.extId===d.item.extId){(0,C.applyTestItemUpdate)(D.item,d.item);return}if(D.op===0&&D.item.item.extId===d.item.extId){(0,C.applyTestItemUpdate)(D.item,d.item);return}}break}}this.k.push(d),this.f.isScheduled()||this.f.schedule()}expand(d,D){const A=this.tree.get(d);if(!!A){if((A.expandLevels===void 0||D>A.expandLevels)&&(A.expandLevels=D),A.expand===1){const t=this.I(A);return t.isOpen()?this.H(A,D-1):t.wait().then(()=>this.H(A,D-1))}else if(A.expand===3)return A.resolveBarrier?.isOpen()===!1?A.resolveBarrier.wait().then(()=>this.H(A,D-1)):this.H(A,D-1)}}dispose(){for(const d of this.tree.values())this.m.getApiFor(d.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(d,D){switch(D.op){case 3:this.L(P.TestId.joinToString(d.fullId,D.id));break;case 0:this.u(D.item,d);break;case 5:for(const A of D.ops)this.p(d,A);break;case 1:this.w(D.new,D.old,d.fullId.toString());break;case 2:this.G(d);break;case 4:this.pushDiff({op:1,item:{extId:d.fullId.toString(),item:D.update}});break;case 6:this.s(d.actual.uri);break;default:(0,I.assertNever)(D)}}s(d){d&&this.pushDiff({op:2,uri:d,docv:this.m.getDocumentVersion(d)})}u(d,D){const A=P.TestId.fromExtHostTestItem(d,this.root.id,D?.actual),t=this.m.getApiFor(d);t.parent&&t.parent!==D?.actual&&this.m.getChildren(t.parent).delete(d.id);let r=this.tree.get(A.toString());if(!r){r={fullId:A,actual:d,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},d.tags.forEach(this.y,this),this.tree.set(r.fullId.toString(),r),this.C(d,D),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:r.expand,item:this.m.toITestItem(d)}}),this.F(d,r,D);return}if(r.actual===d){this.D(d,r,D);return}if(r.actual.uri?.toString()!==d.uri?.toString())return this.L(A.toString()),this.u(d,D);const n=this.m.getChildren(r.actual),i=r.actual,o=b(this.m.toITestItem(i),this.m.toITestItem(d));this.m.getApiFor(i).listener=void 0,r.actual=d,r.expand=0,o&&(o.hasOwnProperty("tags")&&(this.w(d.tags,i.tags,A.toString()),delete o.tags),this.p(r,{op:4,update:o})),this.F(d,r,D);for(const[c,a]of n)this.m.getChildren(d).get(a.id)||this.L(P.TestId.joinToString(A,a.id));this.s(r.actual.uri)}w(d,D,A){const t=new Set(D.map(r=>r.id));for(const r of d)t.delete(r.id)||this.y(r);this.pushDiff({op:1,item:{extId:A,item:{tags:d.map(r=>(0,C.namespaceTestTag)(this.m.controllerId,r.id))}}}),t.forEach(this.z,this)}y(d){const D=this.j.get(d.id);D?D.refCount++:(this.j.set(d.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,C.namespaceTestTag)(this.m.controllerId,d.id)}}))}z(d){const D=this.j.get(d);D&&!--D.refCount&&(this.j.delete(d),this.pushDiff({op:7,id:(0,C.namespaceTestTag)(this.m.controllerId,d)}))}C(d,D){this.m.getApiFor(d).parent=D&&D.actual!==this.root?D.actual:void 0}D(d,D,A){this.C(d,A);const t=this.m.getApiFor(d);t.parent=A?.actual,t.listener=r=>this.p(D,r),this.G(D)}F(d,D,A){this.D(d,D,A);for(const[t,r]of this.m.getChildren(d))this.u(r,D)}G(d){let D;this.h?d.resolveBarrier?D=d.resolveBarrier.isOpen()?3:2:D=d.actual.canResolveChildren?1:0:D=0,D!==d.expand&&(d.expand=D,this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:D}}),D===1&&d.expandLevels!==void 0&&this.I(d))}H(d,D){if(D<0)return;const A=[];for(const[t,r]of this.m.getChildren(d.actual)){const n=this.expand(P.TestId.joinToString(d.fullId,r.id),D);(0,E.isThenable)(n)&&A.push(n)}if(A.length)return Promise.all(A).then(()=>{})}I(d){if(d.resolveBarrier)return d.resolveBarrier;if(!this.h){const r=new E.Barrier;return r.open(),r}d.expand=2,this.J(d);const D=d.resolveBarrier=new E.Barrier,A=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,r)};let t;try{t=this.h(d.actual===this.root?void 0:d.actual)}catch(r){A(r)}return(0,E.isThenable)(t)?t.catch(A).then(()=>{D.open(),this.G(d)}):(D.open(),this.G(d)),d.resolveBarrier}J(d){this.pushDiff({op:1,item:{extId:d.fullId.toString(),expand:d.expand}})}L(d){const D=this.tree.get(d);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:d});const A=[D];for(;A.length;){const t=A.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.z(r.id);this.tree.delete(t.fullId.toString());for(const[r,n]of this.m.getChildren(t.actual))A.push(this.tree.get(P.TestId.joinToString(t.fullId,n.id)))}}}flushDiff(){const d=this.collectDiff();d.length&&this.g.fire(d)}}e.TestItemCollection=g;class f extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.DuplicateTestItemError=f;class p extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class u extends Error{constructor(d,D,A){super(`TestItem with ID "${d}" is from controller "${D}" and cannot be added as a child of an item from controller "${A}".`)}}e.MixedTestItemController=u;const h=(v,d,D)=>{let A=new Map;return{get size(){return A.size},forEach(t,r){for(const n of A.values())t.call(r,n,this)},[Symbol.iterator](){return A.entries()},replace(t){const r=new Map,n=new Set(A.keys()),i={op:5,ops:[]};for(const o of t){if(!(o instanceof D))throw new p(o.id);const c=d(o).controllerId;if(c!==v.controllerId)throw new u(o.id,c,v.controllerId);if(r.has(o.id))throw new f(o.id);r.set(o.id,o),n.delete(o.id),i.ops.push({op:0,item:o})}for(const o of n.keys())i.ops.push({op:3,id:o});v.listener?.(i),A=r},add(t){if(!(t instanceof D))throw new p(t.id);A.set(t.id,t),v.listener?.({op:0,item:t})},delete(t){A.delete(t)&&v.listener?.({op:3,id:t})},get(t){return A.get(t)},toJSON(){return Array.from(A.values())}}};e.createTestItemChildren=h}),define(ve[129],be([1,0,128]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const k=new WeakMap,l=(C,P)=>{const w={controllerId:P};return k.set(C,w),w};e.createPrivateApiFor=l;const I=C=>{const P=k.get(C);if(!P)throw new E.InvalidTestItemError(C?.id||"<unknown>");return P};e.getPrivateApiFor=I}),define(ve[260],be([1,0,24,5]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5,6],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,k.refineServiceDecorator)(E.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(ve[130],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,E.createDecorator)("configurationResolverService");var k;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator"})(k=e.VariableKind||(e.VariableKind={}));class l extends Error{constructor(C,P){super(P),this.variable=C}}e.VariableError=l}),define(ve[261],be([1,0,7,28,8,23,3,162,196,130,16]),function(ae,e,E,k,l,I,C,P,w,y,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class S{constructor(g,f,p,u){this.g=new Map,this.a=g,this.b=f,this.d=p,u&&(this.c=u.then(h=>this.h(h)))}h(g){if(C.isWindows){const f=Object.create(null);return Object.keys(g).forEach(p=>{f[p.toLowerCase()]=g[p]}),f}return g}resolveWithEnvironment(g,f,p){return this.j({env:this.h(g),userHome:void 0},f?f.uri:void 0,p)}async resolveAsync(g,f){const p={env:await this.c,userHome:await this.d};return this.j(p,g?g.uri:void 0,f)}async i(g,f,p,u){const h=I.deepClone(f);C.isWindows&&h.windows?Object.keys(h.windows).forEach(d=>h[d]=h.windows[d]):C.isMacintosh&&h.osx?Object.keys(h.osx).forEach(d=>h[d]=h.osx[d]):C.isLinux&&h.linux&&Object.keys(h.linux).forEach(d=>h[d]=h.linux[d]),delete h.windows,delete h.osx,delete h.linux;const v={env:await this.c,userHome:await this.d};return this.j(v,g?g.uri:void 0,h,p,u)}async resolveAnyAsync(g,f,p){return this.i(g,f,p)}async resolveAnyMap(g,f,p){const u=new Map;return{newConfig:await this.i(g,f,p,u),resolvedVariables:u}}resolveWithInteractionReplace(g,f,p,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(g,f,p,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(g,f){if(this.g.has(g))throw new Error("Variable "+g+" is contributed twice.");this.g.set(g,f)}async j(g,f,p,u,h){if(l.isString(p))return this.l(g,f,p,u,h);if(Array.isArray(p))return Promise.all(p.map(v=>this.j(g,f,v,u,h)));if(l.isObject(p)){const v=Object.create(null),d=await Promise.all(Object.keys(p).map(async D=>[await this.l(g,f,D,u,h),await this.j(g,f,p[D],u,h)]));for(const[D,A]of d)v[D]=A;return v}return p}l(g,f,p,u,h){return(0,T.replaceAsync)(p,S.VARIABLE_REGEXP,async(v,d)=>{if(d.includes(S.VARIABLE_LHS))return v;let D=await this.n(g,v,d,f,u);return h?.set(d,D),D!==v&&l.isString(D)&&D.match(S.VARIABLE_REGEXP)&&(D=await this.l(g,f,D,u,h)),D})}m(g){return this.b?this.b.getUriLabel(g,{noPrefix:!0}):g.fsPath}async n(g,f,p,u,h){let v;const d=p.split(":");d.length>1&&(p=d[0],v=d[1]);const D=r=>{const n=this.a.getFilePath();if(n)return(0,P.normalizeDriveLetter)(n);throw new y.VariableError(r,(0,w.localize)(0,null,f))},A=r=>{const n=D(r);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,P.normalizeDriveLetter)(i)}throw new y.VariableError(r,(0,w.localize)(1,null,f,E.basename(n)))},t=r=>{if(v){const n=this.a.getFolderUri(v);if(n)return n;throw new y.VariableError(r,(0,w.localize)(2,null,f,v))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new y.VariableError(r,(0,w.localize)(3,null,f)):new y.VariableError(r,(0,w.localize)(4,null,f))};switch(p){case"env":if(v){if(g.env){const r=g.env[C.isWindows?v.toLowerCase():v];if(l.isString(r))return r}return""}throw new y.VariableError(y.VariableKind.Env,(0,w.localize)(5,null,f));case"config":if(v){const r=this.a.getConfigurationValue(u,v);if(l.isUndefinedOrNull(r))throw new y.VariableError(y.VariableKind.Config,(0,w.localize)(6,null,f,v));if(l.isObject(r))throw new y.VariableError(y.VariableKind.Config,(0,w.localize)(7,null,f,v));return r}throw new y.VariableError(y.VariableKind.Config,(0,w.localize)(8,null,f));case"command":return this.o(y.VariableKind.Command,f,v,h,"command");case"input":return this.o(y.VariableKind.Input,f,v,h,"input");case"extensionInstallFolder":if(v){const r=await this.a.getExtension(v);if(!r)throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,w.localize)(9,null,f,v));return this.m(r.extensionLocation)}throw new y.VariableError(y.VariableKind.ExtensionInstallFolder,(0,w.localize)(10,null,f));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.m(t(y.VariableKind.WorkspaceFolder)));case"cwd":return u||v?(0,P.normalizeDriveLetter)(this.m(t(y.VariableKind.Cwd))):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(E.basename(this.m(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(g.userHome)return g.userHome;throw new y.VariableError(y.VariableKind.UserHome,(0,w.localize)(11,null,f))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new y.VariableError(y.VariableKind.LineNumber,(0,w.localize)(12,null,f))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new y.VariableError(y.VariableKind.SelectedText,(0,w.localize)(13,null,f))}case"file":return D(y.VariableKind.File);case"fileWorkspaceFolder":return A(y.VariableKind.FileWorkspaceFolder);case"relativeFile":return u||v?E.relative(this.m(t(y.VariableKind.RelativeFile)),D(y.VariableKind.RelativeFile)):D(y.VariableKind.RelativeFile);case"relativeFileDirname":{const r=E.dirname(D(y.VariableKind.RelativeFileDirname));if(u||v){const n=E.relative(this.m(t(y.VariableKind.RelativeFileDirname)),r);return n.length===0?".":n}return r}case"fileDirname":return E.dirname(D(y.VariableKind.FileDirname));case"fileExtname":return E.extname(D(y.VariableKind.FileExtname));case"fileBasename":return E.basename(D(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=E.basename(D(y.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-E.extname(r).length)}case"fileDirnameBasename":return E.basename(E.dirname(D(y.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||f}case"execInstallFolder":{const r=this.a.getAppRoot();return r||f}case"pathSeparator":return E.sep;default:try{const r=v?`${p}:${v}`:p;return this.o(y.VariableKind.Unknown,f,r,h,void 0)}catch{return f}}}}o(g,f,p,u,h){if(p&&u){const v=h===void 0?u[p]:u[h+":"+p];if(typeof v=="string")return v;throw new y.VariableError(g,(0,w.localize)(14,null,f))}return f}}S.VARIABLE_LHS="${",S.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=S}),define(ve[262],be([1,0,5,83]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,E.createDecorator)("editorGroupsService");var l;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(l=e.GroupDirection||(e.GroupDirection={}));var I;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(I=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var P;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var w;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(w=e.MergeGroupMode||(e.MergeGroupMode={}));function y(f){const p=f;return(0,k.isEditorInput)(p?.editor)&&(0,k.isEditorInput)(p?.replacement)}e.isEditorReplacement=y;var T;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T=e.GroupsOrder||(e.GroupsOrder={}));var S;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(S=e.OpenEditorContext||(e.OpenEditorContext={}));function b(f){const p=f;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=b;function g(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=g}),define(ve[131],be([1,0,5,262]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function l(I){const C=I;return typeof I=="number"||(0,k.isEditorGroup)(C)}e.isPreferredGroup=l}),define(ve[263],be([1,0,8,260,12,112,82,81,130,83,131,13,216,258]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let f=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(u,h,v,d,D,A,t,r,n,i){this.a=u,this.b=h,this.c=v,this.d=d,this.e=D,this.f=A,this.g=t,this.h=r,this.i=n,this.j=i}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(u,h,v,d,D,A,t,r){await this.c.whenRemoteConfigurationLoaded();const n=Object.create(null),i=v?(0,E.withNullAsUndefined)(this.d.getWorkspaceFolder(v)):void 0;let o;try{o=(await this.e.resolveAnyMap(i,{shellLaunchConfig:u,configuration:h})).resolvedVariables}catch(ne){this.h.error(ne)}if(o)for(const[ne,F]of o.entries())(/^config:/.test(ne)||ne==="selectedText"||ne==="lineNumber")&&(n[ne]=F);const c=[];for(const[ne,F]of this.f.collections.entries())c.push([ne,(0,P.serializeEnvironmentVariableCollection)(F.map)]);const a=await this.g.resolveAuthority(this.a),s=a.options&&a.options.extensionHostEnv,m=this.d.getWorkspace(),R=m.folders,L=v?this.d.getWorkspaceFolder(v):null,$=y.EditorResourceAccessor.getOriginalUri(this.i.activeEditor,{supportSideBySide:y.SideBySideEditor.PRIMARY,filterByScheme:[S.Schemas.file,S.Schemas.vscodeUserData,S.Schemas.vscodeRemote]}),ie={configuration:h,resolvedVariables:n,envVariableCollections:c,shellLaunchConfig:u,workspaceId:m.id,workspaceName:this.j.getWorkspaceLabel(m),workspaceFolders:R,activeWorkspaceFolder:L,activeFileResource:$,shouldPersistTerminal:D,options:d,cols:A,rows:t,unicodeVersion:r,resolverEnv:s};return await this.b.call("$createProcess",ie)}requestDetachInstance(u,h){return this.b.call("$requestDetachInstance",[u,h])}acceptDetachInstanceReply(u,h){return this.b.call("$acceptDetachInstanceReply",[u,h])}attachToProcess(u){return this.b.call("$attachToProcess",[u])}detachFromProcess(u,h){return this.b.call("$detachFromProcess",[u,h])}listProcesses(){return this.b.call("$listProcesses")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(u,h){return this.b.call("$processBinary",[u,h])}start(u){return this.b.call("$start",[u])}input(u,h){return this.b.call("$input",[u,h])}acknowledgeDataEvent(u,h){return this.b.call("$acknowledgeDataEvent",[u,h])}setUnicodeVersion(u,h){return this.b.call("$setUnicodeVersion",[u,h])}shutdown(u,h){return this.b.call("$shutdown",[u,h])}resize(u,h,v){return this.b.call("$resize",[u,h,v])}getInitialCwd(u){return this.b.call("$getInitialCwd",[u])}getCwd(u){return this.b.call("$getCwd",[u])}orphanQuestionReply(u){return this.b.call("$orphanQuestionReply",[u])}sendCommandResult(u,h,v){return this.b.call("$sendCommandResult",[u,h,v])}freePortKillProcess(u){return this.b.call("$freePortKillProcess",[u])}installAutoReply(u,h){return this.b.call("$installAutoReply",[u,h])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(u){return this.b.call("$getDefaultSystemShell",[u])}getProfiles(u,h,v){return this.b.call("$getProfiles",[this.d.getWorkspace().id,u,h,v])}acceptPtyHostResolvedVariables(u,h){return this.b.call("$acceptPtyHostResolvedVariables",[u,h])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(u,h){return this.b.call("$getWslPath",[u,h])}setTerminalLayoutInfo(u){const v={workspaceId:this.d.getWorkspace().id,tabs:u?u.tabs:[]};return this.b.call("$setTerminalLayoutInfo",v)}updateTitle(u,h,v){return this.b.call("$updateTitle",[u,h,v])}updateIcon(u,h,v,d){return this.b.call("$updateIcon",[u,h,v,d])}refreshProperty(u,h){return this.b.call("$refreshProperty",[u,h])}updateProperty(u,h,v){return this.b.call("$updateProperty",[u,h,v])}getTerminalLayoutInfo(){const h={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",h)}reviveTerminalProcesses(u,h){return this.b.call("$reviveTerminalProcesses",[u,h])}getRevivedPtyNewId(u){return this.b.call("$getRevivedPtyNewId",[u])}serializeTerminalState(u){return this.b.call("$serializeTerminalState",[u])}};f=Re([Te(2,k.IWorkbenchConfigurationService),Te(3,C.IWorkspaceContextService),Te(4,w.IConfigurationResolverService),Te(5,g.IEnvironmentVariableService),Te(6,I.IRemoteAuthorityResolverService),Te(7,l.ILogService),Te(8,T.IEditorService),Te(9,b.ILabelService)],f),e.RemoteTerminalChannelClient=f}),define(ve[264],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var E;(function(T){T[T.IPC=1]="IPC",T[T.Socket=2]="Socket",T[T.MessagePort=3]="MessagePort"})(E=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class k{constructor(S){this.pipeName=S,this.type=1}serialize(S){S[k.ENV_KEY]=this.pipeName}}k.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=k;class l{constructor(){this.type=2}serialize(S){S[l.ENV_KEY]="1"}}l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=l;class I{constructor(){this.type=3}serialize(S){S[I.ENV_KEY]="1"}}I.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=I;function C(T){delete T[k.ENV_KEY],delete T[l.ENV_KEY],delete T[I.ENV_KEY]}function P(T,S){C(S),T.serialize(S)}e.writeExtHostConnection=P;function w(T){if(T[k.ENV_KEY])return y(T,new k(T[k.ENV_KEY]));if(T[l.ENV_KEY])return y(T,new l);if(T[I.ENV_KEY])return y(T,new I);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=w;function y(T,S){return C(T),S}}),define(ve[132],be([1,0,49,91,125,13,7,15,6,60,80,12,43,3,57,124,2,264,24]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function d(i={},o,c,a,s,m){const R=await(0,l.getNLSConfiguration)(c,a.userDataPath);let L={};if(o)try{L=await(0,T.getResolvedShellEnv)(m,s,a.args,process.env)}catch(z){s.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",z)}const ie={...process.env,...L,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(R,void 0,0),...i},ne=a.isBuilt?(0,C.join)(a.appRoot,"bin"):(0,C.join)(a.appRoot,"resources","server","bin-dev"),F=(0,C.join)(ne,"remote-cli");let _=t(ie,"PATH");return _?_=F+C.delimiter+_:_=F,r(ie,"PATH",_),a.args["without-browser-env-var"]||(ie.BROWSER=(0,C.join)(ne,"helpers",g.isWindows?"browser.cmd":"browser.sh")),n(ie),ie}e.buildUserEnvironment=d;class D{constructor(o,c){this.socket=o,this.initialDataChunk=c}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let o,c,a;return this.socket instanceof y.NodeSocket?(o=!0,c=!1,a=P.VSBuffer.alloc(0)):(o=!1,c=this.socket.permessageDeflate,a=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:o,permessageDeflate:c,inflateBytes:a.buffer.toString("base64")}}}let A=class{constructor(o,c,a,s,m,R,L,$){this.i=o,this.j=m,this.l=R,this.m=L,this.n=$,this.b=new w.Emitter,this.onClose=this.b.event,this.c=!g.isWindows||!this.j.args["socket-path"],this.d=!1,this.f=c,this.g=null,this.h=new D(a,s),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(o){this.l.info(`${this.o}${o}`)}q(o){this.l.error(`${this.o}${o}`)}async r(o,c){const a=new u.DisposableStore;a.add(c.socket),a.add((0,u.toDisposable)(()=>{o.destroy()}));const s=()=>{a.dispose()};a.add(c.socket.onEnd(s)),a.add(c.socket.onClose(s)),a.add(w.Event.fromNodeEventEmitter(o,"end")(s)),a.add(w.Event.fromNodeEventEmitter(o,"close")(s)),a.add(w.Event.fromNodeEventEmitter(o,"error")(s)),a.add(c.socket.onData(m=>o.write(m.buffer))),a.add(w.Event.fromNodeEventEmitter(o,"data")(m=>{c.socket.write(P.VSBuffer.wrap(m))})),c.initialDataChunk.byteLength>0&&o.write(c.initialDataChunk.buffer)}async s(o,c){await c.socketDrain();const a=c.toIExtHostSocketMessage();let s;c.socket instanceof y.NodeSocket?s=c.socket.socket:s=c.socket.socket.socket,o.send(a,s)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const o={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(o)}acceptReconnection(o,c,a){this.f=o,this.p("The client has reconnected.");const s=new D(c,a);if(!this.g){this.h=s;return}this.s(this.g,s)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(o){try{let c=process.execArgv?process.execArgv.filter(F=>!/^--inspect(-brk)?=/.test(F)):[];o.port&&!process.pkg&&(c=[`--inspect${o.break?"-brk":""}=${o.port}`]);const a=await d(o.env,!0,o.language,this.j,this.l,this.n);(0,f.removeDangerousEnvVariables)(a);let s;if(this.c)(0,h.writeExtHostConnection)(new h.SocketExtHostConnection,a),s=null;else{const{namedPipeServer:F,pipeName:_}=await this.u();(0,h.writeExtHostConnection)(new h.IPCExtHostConnection(_),a),s=F}const m={env:a,execArgv:c,silent:!0},R=["--type=extensionHost","--transformURIs"],L=this.j.args["use-host-proxy"];R.push(`--useHostProxy=${L?"true":"false"}`),this.g=E.fork(I.FileAccess.asFileUri("bootstrap-fork").fsPath,R,m);const $=this.g.pid;this.p(`<${$}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const ie=w.Event.fromNodeEventEmitter(this.g.stdout,"data"),ne=w.Event.fromNodeEventEmitter(this.g.stderr,"data");if(ie(F=>this.p(`<${$}> ${F}`)),ne(F=>this.p(`<${$}><stderr> ${F}`)),this.g.on("error",F=>{this.q(`<${$}> Extension Host Process had an error`),this.l.error(F),this.t()}),this.g.on("exit",(F,_)=>{this.m.setExitInfo(this.i,{code:F,signal:_}),this.p(`<${$}> Extension Host Process exited with code: ${F}, signal: ${_}.`),this.t()}),s)s.on("connection",F=>{s.close(),this.r(F,this.h)});else{const F=_=>{_.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",F),this.s(this.g,this.h),this.h=null)};this.g.on("message",F)}}catch(c){console.error("ExtensionHostConnection errored"),c&&console.error(c)}}u(){return new Promise((o,c)=>{const a=(0,y.createRandomIPCHandle)(),s=k.createServer();s.on("error",c),s.listen(a,()=>{s?.removeListener("error",c),o({pipeName:a,namedPipeServer:s})})})}};A=Re([Te(4,b.IServerEnvironmentService),Te(5,S.ILogService),Te(6,p.IExtensionHostStatusService),Te(7,v.IConfigurationService)],A),e.ExtensionHostConnection=A;function t(i,o){const c=Object.keys(i).filter(s=>s.toLowerCase()===o.toLowerCase()),a=c.length>0?c[0]:o;return i[a]}function r(i,o,c){const a=Object.keys(i).filter(m=>m.toLowerCase()===o.toLowerCase()),s=a.length>0?a[0]:o;i[s]=c}function n(i){for(const o of Object.keys(i))i[o]===null&&delete i[o]}}),define(ve[265],be([1,0,6,4,5,33,35]),function(ae,e,E,k,l,I,C){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new I.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,l.createDecorator)("extensionService");class w{constructor(c){this.affinity=c,this.kind=1}equals(c){return this.kind===c.kind&&this.affinity===c.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=w;class y{constructor(c){this.affinity=c,this.kind=2}equals(c){return this.kind===c.kind&&this.affinity===c.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=y;class T{constructor(){this.kind=3,this.affinity=0}equals(c){return this.kind===c.kind}asString(){return"Remote"}}e.RemoteRunningLocation=T;class S{constructor(c){this.dependency=c}}e.MissingExtensionDependency=S;var b;(function(o){o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(b=e.ExtensionHostKind||(e.ExtensionHostKind={}));function g(o){if(o===null)return"None";switch(o){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=g;class f{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(c,a){const s=[],m=[],R=[],L=[],$=h(this.c),ie=h(c),ne=(x,le)=>x.extensionLocation.toString()===le.extensionLocation.toString()||x.isBuiltin===le.isBuiltin||x.isUserBuiltin===le.isUserBuiltin||x.isUnderDevelopment===le.isUnderDevelopment;for(const x of this.c){const le=ie.get(I.ExtensionIdentifier.toKey(x.identifier));if(!le){s.push(x.identifier),$.delete(I.ExtensionIdentifier.toKey(x.identifier));continue}if(!ne(x,le)){s.push(x.identifier),$.delete(I.ExtensionIdentifier.toKey(x.identifier));continue}}for(const x of c){const le=$.get(I.ExtensionIdentifier.toKey(x.identifier));if(!le){m.push(x);continue}if(!ne(le,x)){s.push(le.identifier),$.delete(I.ExtensionIdentifier.toKey(le.identifier));continue}}const F=u(this.d),_=u(a);for(const x of this.d)_.has(I.ExtensionIdentifier.toKey(x))||R.push(x);for(const x of a)F.has(I.ExtensionIdentifier.toKey(x))||L.push(x);const z={toRemove:s,toAdd:m,myToRemove:R,myToAdd:L};return this.delta(z),z}delta(c){const{toRemove:a,toAdd:s,myToRemove:m,myToAdd:R}=c,L=u(a),$=u(m);for(let ie=0;ie<this.c.length;ie++)L.has(I.ExtensionIdentifier.toKey(this.c[ie].identifier))&&(this.c.splice(ie,1),ie--);for(let ie=0;ie<this.d.length;ie++)$.has(I.ExtensionIdentifier.toKey(this.d[ie]))&&(this.d.splice(ie,1),ie--);for(const ie of s)this.c.push(ie);for(const ie of R)this.d.push(ie)}containsExtension(c){for(const a of this.d)if(I.ExtensionIdentifier.equals(a,c))return!0;return!1}}e.ExtensionHostExtensions=f;class p{constructor(c){if(this[P]="ExtensionIdentifierSet",this.c=new Map,this.d=I.ExtensionIdentifier.toKey,c)for(const a of c)this.add(a)}get size(){return this.c.size}add(c){return this.c.set(this.d(c),c),this}clear(){this.c.clear()}delete(c){return this.c.delete(this.d(c))}has(c){return this.c.has(this.d(c))}forEach(c,a){this.c.forEach(s=>c.call(a,s,s,this))}*entries(){for(const[c,a]of this.c)yield[a,a]}keys(){return this.c.values()}values(){return this.c.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=p;function u(o){const c=new Set;for(const a of o)c.add(I.ExtensionIdentifier.toKey(a));return c}e.extensionIdentifiersArrayToSet=u;function h(o){const c=new Map;for(const a of o)c.set(I.ExtensionIdentifier.toKey(a.identifier),a);return c}function v(o,c){return o.enabledApiProposals?o.enabledApiProposals.includes(c):!1}e.isProposedApiEnabled=v;function d(o,c){if(!v(o,c))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=d;class D{constructor(c,a,s,m){this.codeLoadingTime=c,this.activateCallTime=a,this.activateResolvedTime=s,this.activationReason=m}}e.ActivationTimes=D;class A{constructor(c,a){this.description=c,this.value=a}}e.ExtensionPointContribution=A,e.ExtensionHostLogFileName="exthost";var t;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function r(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function n(o,c){return{identifier:new I.ExtensionIdentifier((0,C.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!c,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,browserNlsBundleUris:o.browserNlsBundleUris}}e.toExtensionDescription=n;class i{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(c,a){return Promise.resolve(0)}getInspectPorts(c,a){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=i});var Ot=this&&this.__classPrivateFieldSet||function(ae,e,E,k,l){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?l.call(ae,E):l?l.value=E:e.set(ae,E),E},it=this&&this.__classPrivateFieldGet||function(ae,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!k:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ae):k?k.value:e.get(ae)};define(ve[133],be([1,0,18,9,95,27,56,16,8,4,22,17,112,127,265]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f){"use strict";var p,u,h,v,d,D,A,t,r,n,i,o,c,a,s,m,R,L,$,ie,ne,F,_;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function z(B){return Object.assign(B,{apply:function(){const se=arguments.length===1?[]:arguments[1];return Reflect.construct(B,se,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(B,[]);{const[se,...ge]=arguments;return Reflect.construct(B,ge,se.constructor)}}})}var x;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(x=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var le;(function(B){B[B.Command=0]="Command",B[B.Opener=1]="Opener"})(le=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let Ee=D=class{static from(...O){let se=O;return new D(function(){if(se){for(const ge of se)ge&&typeof ge.dispose=="function"&&ge.dispose();se=void 0}})}constructor(O){p.set(this,void 0),Ot(this,p,O,"f")}dispose(){typeof it(this,p,"f")=="function"&&(it(this,p,"f").call(this),Ot(this,p,void 0,"f"))}};p=new WeakMap,Ee=D=Re([z],Ee),e.Disposable=Ee;let Y=A=class{static Min(...O){if(O.length===0)throw new TypeError;let se=O[0];for(let ge=1;ge<O.length;ge++){const Ue=O[ge];Ue.isBefore(se)&&(se=Ue)}return se}static Max(...O){if(O.length===0)throw new TypeError;let se=O[0];for(let ge=1;ge<O.length;ge++){const Ue=O[ge];Ue.isAfter(se)&&(se=Ue)}return se}static isPosition(O){if(!O)return!1;if(O instanceof A)return!0;const{line:se,character:ge}=O;return typeof se=="number"&&typeof ge=="number"}static of(O){if(O instanceof A)return O;if(this.isPosition(O))return new A(O.line,O.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(O,se){if(O<0)throw(0,k.illegalArgument)("line must be non-negative");if(se<0)throw(0,k.illegalArgument)("character must be non-negative");this.c=O,this.e=se}isBefore(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<O.e}isBeforeOrEqual(O){return this.c<O.c?!0:O.c<this.c?!1:this.e<=O.e}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this.c===O.c&&this.e===O.e}compareTo(O){return this.c<O.c?-1:this.c>O.line?1:this.e<O.e?-1:this.e>O.e?1:0}translate(O,se=0){if(O===null||se===null)throw(0,k.illegalArgument)();let ge;return typeof O>"u"?ge=0:typeof O=="number"?ge=O:(ge=typeof O.lineDelta=="number"?O.lineDelta:0,se=typeof O.characterDelta=="number"?O.characterDelta:0),ge===0&&se===0?this:new A(this.line+ge,this.character+se)}with(O,se=this.character){if(O===null||se===null)throw(0,k.illegalArgument)();let ge;return typeof O>"u"?ge=this.line:typeof O=="number"?ge=O:(ge=typeof O.line=="number"?O.line:this.line,se=typeof O.character=="number"?O.character:this.character),ge===this.line&&se===this.character?this:new A(ge,se)}toJSON(){return{line:this.line,character:this.character}}};Y=A=Re([z],Y),e.Position=Y;let H=t=class{static isRange(O){return O instanceof t?!0:O?Y.isPosition(O.start)&&Y.isPosition(O.end):!1}static of(O){if(O instanceof t)return O;if(this.isRange(O))return new t(O.start,O.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(O,se,ge,Ue){let We,Qe;if(typeof O=="number"&&typeof se=="number"&&typeof ge=="number"&&typeof Ue=="number"?(We=new Y(O,se),Qe=new Y(ge,Ue)):Y.isPosition(O)&&Y.isPosition(se)&&(We=Y.of(O),Qe=Y.of(se)),!We||!Qe)throw new Error("Invalid arguments");We.isBefore(Qe)?(this.c=We,this.e=Qe):(this.c=Qe,this.e=We)}contains(O){return t.isRange(O)?this.contains(O.start)&&this.contains(O.end):Y.isPosition(O)?!(Y.of(O).isBefore(this.c)||this.e.isBefore(O)):!1}isEqual(O){return this.c.isEqual(O.c)&&this.e.isEqual(O.e)}intersection(O){const se=Y.Max(O.start,this.c),ge=Y.Min(O.end,this.e);if(!se.isAfter(ge))return new t(se,ge)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const se=Y.Min(O.start,this.c),ge=Y.Max(O.end,this.end);return new t(se,ge)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(O,se=this.end){if(O===null||se===null)throw(0,k.illegalArgument)();let ge;return O?Y.isPosition(O)?ge=O:(ge=O.start||this.start,se=O.end||this.end):ge=this.start,ge.isEqual(this.c)&&se.isEqual(this.end)?this:new t(ge,se)}toJSON(){return[this.start,this.end]}};H=t=Re([z],H),e.Range=H;let U=r=class extends H{static isSelection(O){return O instanceof r?!0:O?H.isRange(O)&&Y.isPosition(O.anchor)&&Y.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(O,se,ge,Ue){let We,Qe;if(typeof O=="number"&&typeof se=="number"&&typeof ge=="number"&&typeof Ue=="number"?(We=new Y(O,se),Qe=new Y(ge,Ue)):Y.isPosition(O)&&Y.isPosition(se)&&(We=Y.of(O),Qe=Y.of(se)),!We||!Qe)throw new Error("Invalid arguments");super(We,Qe),this.f=We,this.g=Qe}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};U=r=Re([z],U),e.Selection=U;class te{constructor(O,se,ge){if(typeof O!="string"||O.length===0)throw(0,k.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,k.illegalArgument)("port");if(typeof ge<"u"&&(typeof ge!="string"||ge.length===0||!/^[0-9A-Za-z_\-]+$/.test(ge)))throw(0,k.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(se),this.connectionToken=ge}}e.ResolvedAuthority=te;class re extends Error{static NotAvailable(O,se){return new re(O,b.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(O){return new re(O,b.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(O,se=b.RemoteAuthorityResolverErrorCode.Unknown,ge){super(O),this._message=O,this._code=se,this._detail=ge,Object.setPrototypeOf(this,re.prototype)}}e.RemoteAuthorityResolverError=re;var de;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(de=e.EndOfLine||(e.EndOfLine={}));var oe;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(oe=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let j=n=class{static isTextEdit(O){return O instanceof n?!0:O?H.isRange(O)&&typeof O.newText=="string":!1}static replace(O,se){return new n(O,se)}static insert(O,se){return n.replace(new H(O,O),se)}static delete(O){return n.replace(O,"")}static setEndOfLine(O){const se=new n(new H(new Y(0,0),new Y(0,0)),"");return se.newEol=O,se}get range(){return this.c}set range(O){if(O&&!H.isRange(O))throw(0,k.illegalArgument)("range");this.c=O}get newText(){return this.e||""}set newText(O){if(O&&typeof O!="string")throw(0,k.illegalArgument)("newText");this.e=O}get newEol(){return this.f}set newEol(O){if(O&&typeof O!="number")throw(0,k.illegalArgument)("newEol");this.f=O}constructor(O,se){this.c=O,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};j=n=Re([z],j),e.TextEdit=j;let N=i=class{static isNotebookCellEdit(O){return O instanceof i?!0:O?Tt.isNotebookRange(O)&&Array.isArray(O.newCells):!1}static replaceCells(O,se){return new i(O,se)}static insertCells(O,se){return new i(new Tt(O,O),se)}static deleteCells(O){return new i(O,[])}static updateCellMetadata(O,se){const ge=new i(new Tt(O,O),[]);return ge.newCellMetadata=se,ge}static updateNotebookMetadata(O){const se=new i(new Tt(0,0),[]);return se.newNotebookMetadata=O,se}constructor(O,se){this.range=O,this.newCells=se}};N=i=Re([z],N),e.NotebookEdit=N;class M{static isSnippetTextEdit(O){return O instanceof M?!0:O?H.isRange(O.range)&&fe.isSnippetString(O.snippet):!1}static replace(O,se){return new M(O,se)}static insert(O,se){return M.replace(new H(O,O),se)}constructor(O,se){this.range=O,this.snippet=se}}e.SnippetTextEdit=M;var q;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(q=e.FileEditType||(e.FileEditType={}));let ee=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(O,se,ge,Ue){this.c.push({_type:1,from:O,to:se,options:ge,metadata:Ue})}createFile(O,se,ge){this.c.push({_type:1,from:void 0,to:O,options:se,metadata:ge})}deleteFile(O,se,ge){this.c.push({_type:1,from:O,to:void 0,options:se,metadata:ge})}e(O,se,ge){this.c.push({_type:3,metadata:ge,uri:O,edit:{editType:5,metadata:se},notebookMetadata:se})}f(O,se,ge,Ue){const We=se.start,Qe=se.end;(We!==Qe||ge.length>0)&&this.c.push({_type:5,uri:O,index:We,count:Qe-We,cells:ge,metadata:Ue})}g(O,se,ge,Ue){this.c.push({_type:3,metadata:Ue,uri:O,edit:{editType:8,index:se,metadata:ge}})}replace(O,se,ge,Ue){this.c.push({_type:2,uri:O,edit:new j(se,ge),metadata:Ue})}insert(O,se,ge,Ue){this.replace(O,new H(se,se),ge,Ue)}delete(O,se,ge){this.replace(O,se,"",ge)}has(O){return this.c.some(se=>se._type===2&&se.uri.toString()===O.toString())}set(O,se){if(se)for(const ge of se){if(!ge)continue;let Ue,We;Array.isArray(ge)?(Ue=ge[0],We=ge[1]):Ue=ge,N.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.g(O,Ue.range.start,Ue.newCellMetadata,We):Ue.newNotebookMetadata?this.e(O,Ue.newNotebookMetadata,We):this.f(O,Ue.range,Ue.newCells,We):M.isSnippetTextEdit(Ue)?this.c.push({_type:6,uri:O,range:Ue.range,edit:Ue.snippet,metadata:We}):this.c.push({_type:2,uri:O,edit:Ue,metadata:We})}else{for(let ge=0;ge<this.c.length;ge++){const Ue=this.c[ge];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===O.toString()&&(this.c[ge]=void 0);break}}(0,E.coalesceInPlace)(this.c)}}get(O){const se=[];for(const ge of this.c)ge._type===2&&ge.uri.toString()===O.toString()&&se.push(ge.edit);return se}entries(){const O=new I.ResourceMap;for(const se of this.c)if(se._type===2){let ge=O.get(se.uri);ge||(ge=[se.uri,[]],O.set(se.uri,ge)),ge[1].push(se.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};ee=Re([z],ee),e.WorkspaceEdit=ee;let fe=o=class{static isSnippetString(O){return O instanceof o?!0:O?typeof O.value=="string":!1}static c(O){return O.replace(/\$|}|\\/g,"\\$&")}constructor(O){this.e=1,this.value=O||""}appendText(O){return this.value+=o.c(O),this}appendTabstop(O=this.e++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,se=this.e++){if(typeof O=="function"){const ge=new o;ge.e=this.e,O(ge),this.e=ge.e,O=ge.value}else O=o.c(O);return this.value+="${",this.value+=se,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,se=this.e++){const ge=O.map(Ue=>Ue.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ge,this.value+="|}",this}appendVariable(O,se){if(typeof se=="function"){const ge=new o;ge.e=this.e,se(ge),this.e=ge.e,se=ge.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,se&&(this.value+=":",this.value+=se),this.value+="}",this}};fe=o=Re([z],fe),e.SnippetString=fe;var W;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(W=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Z=c=class{static isLocation(O){return O instanceof c?!0:O?H.isRange(O.range)&&y.URI.isUri(O.uri):!1}constructor(O,se){if(this.uri=O,se)if(H.isRange(se))this.range=H.of(se);else if(Y.isPosition(se))this.range=new H(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};Z=c=Re([z],Z),e.Location=Z;let V=class{static is(O){return O?typeof O.message=="string"&&O.location&&H.isRange(O.location.range)&&y.URI.isUri(O.location.uri):!1}constructor(O,se){this.location=O,this.message=se}static isEqual(O,se){return O===se?!0:!O||!se?!1:O.message===se.message&&O.location.range.isEqual(se.location.range)&&O.location.uri.toString()===se.location.uri.toString()}};V=Re([z],V),e.DiagnosticRelatedInformation=V;let Q=class{constructor(O,se,ge=K.Error){if(!H.isRange(O))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=O,this.message=se,this.severity=ge}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,se){return O===se?!0:!O||!se?!1:O.message===se.message&&O.severity===se.severity&&O.code===se.code&&O.severity===se.severity&&O.source===se.source&&O.range.isEqual(se.range)&&(0,E.equals)(O.tags,se.tags)&&(0,E.equals)(O.relatedInformation,se.relatedInformation,V.isEqual)}};Q=Re([z],Q),e.Diagnostic=Q;let G=class{constructor(O,se){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=se}};G=Re([z],G),e.Hover=G;var X;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(X=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ce=class{constructor(O,se=X.Text){this.range=O,this.kind=se}toJSON(){return{range:this.range,kind:X[this.kind]}}};ce=Re([z],ce),e.DocumentHighlight=ce;var pe;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(pe=e.SymbolKind||(e.SymbolKind={}));var Pe;(function(B){B[B.Deprecated=1]="Deprecated"})(Pe=e.SymbolTag||(e.SymbolTag={}));let Ae=a=class{static validate(O){if(!O.name)throw new Error("name must not be falsy")}constructor(O,se,ge,Ue,We){this.name=O,this.kind=se,this.containerName=We,typeof ge=="string"&&(this.containerName=ge),Ue instanceof Z?this.location=Ue:ge instanceof H&&(this.location=new Z(Ue,ge)),a.validate(this)}toJSON(){return{name:this.name,kind:pe[this.kind],location:this.location,containerName:this.containerName}}};Ae=a=Re([z],Ae),e.SymbolInformation=Ae;let Fe=s=class{static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children?.forEach(s.validate)}constructor(O,se,ge,Ue,We){this.name=O,this.detail=se,this.kind=ge,this.range=Ue,this.selectionRange=We,this.children=[],s.validate(this)}};Fe=s=Re([z],Fe),e.DocumentSymbol=Fe;var $e;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})($e=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let me=class{constructor(O,se){this.title=O,this.kind=se}};me=Re([z],me),e.CodeAction=me;let we=m=class{constructor(O){this.value=O}append(O){return new m(this.value?this.value+m.c+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+m.c)}};we.c=".",we=m=Re([z],we),e.CodeActionKind=we,we.Empty=new we(""),we.QuickFix=we.Empty.append("quickfix"),we.Refactor=we.Empty.append("refactor"),we.RefactorExtract=we.Refactor.append("extract"),we.RefactorInline=we.Refactor.append("inline"),we.RefactorMove=we.Refactor.append("move"),we.RefactorRewrite=we.Refactor.append("rewrite"),we.Source=we.Empty.append("source"),we.SourceOrganizeImports=we.Source.append("organizeImports"),we.SourceFixAll=we.Source.append("fixAll");let ye=class{constructor(O,se){if(this.range=O,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ye=Re([z],ye),e.SelectionRange=ye;class Me{constructor(O,se,ge,Ue,We,Qe){this.kind=O,this.name=se,this.detail=ge,this.uri=Ue,this.range=We,this.selectionRange=Qe}}e.CallHierarchyItem=Me;class je{constructor(O,se){this.fromRanges=se,this.from=O}}e.CallHierarchyIncomingCall=je;class Ye{constructor(O,se){this.fromRanges=se,this.to=O}}e.CallHierarchyOutgoingCall=Ye;var He;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(He=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Ke=class{constructor(O,se){this.range=O,this.command=se}get isResolved(){return!!this.command}};Ke=Re([z],Ke),e.CodeLens=Ke;let Je=R=class{static isMarkdownString(O){return O instanceof R?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}constructor(O,se=!1){u.set(this,void 0),Ot(this,u,new l.MarkdownString(O,{supportThemeIcons:se}),"f")}get value(){return it(this,u,"f").value}set value(O){it(this,u,"f").value=O}get isTrusted(){return it(this,u,"f").isTrusted}set isTrusted(O){it(this,u,"f").isTrusted=O}get supportThemeIcons(){return it(this,u,"f").supportThemeIcons}set supportThemeIcons(O){it(this,u,"f").supportThemeIcons=O}get supportHtml(){return it(this,u,"f").supportHtml}set supportHtml(O){it(this,u,"f").supportHtml=O}get baseUri(){return it(this,u,"f").baseUri}set baseUri(O){it(this,u,"f").baseUri=O}appendText(O){return it(this,u,"f").appendText(O),this}appendMarkdown(O){return it(this,u,"f").appendMarkdown(O),this}appendCodeblock(O,se){return it(this,u,"f").appendCodeblock(se??"",O),this}};u=new WeakMap,Je=R=Re([z],Je),e.MarkdownString=Je;let nt=class{constructor(O,se){this.label=O,this.documentation=se}};nt=Re([z],nt),e.ParameterInformation=nt;let xe=class{constructor(O,se){this.label=O,this.documentation=se,this.parameters=[]}};xe=Re([z],xe),e.SignatureInformation=xe;let Ge=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ge=Re([z],Ge),e.SignatureHelp=Ge;var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ue;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(ue=e.InlayHintKind||(e.InlayHintKind={}));let Ie=class{constructor(O){this.value=O}};Ie=Re([z],Ie),e.InlayHintLabelPart=Ie;let Ce=class{constructor(O,se,ge){this.position=O,this.label=se,this.kind=ge}};Ce=Re([z],Ce),e.InlayHint=Ce;var Le;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ne;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Ne=e.CompletionItemKind||(e.CompletionItemKind={}));var ze;(function(B){B[B.Deprecated=1]="Deprecated"})(ze=e.CompletionItemTag||(e.CompletionItemTag={}));let Ve=class{constructor(O,se){this.label=O,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&Ne[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ve=Re([z],Ve),e.CompletionItem=Ve;let Xe=class{constructor(O=[],se=!1){this.items=O,this.isIncomplete=se}};Xe=Re([z],Xe),e.CompletionList=Xe;let st=class{constructor(O,se,ge){this.insertText=O,this.range=se,this.command=ge}};st=Re([z],st),e.InlineSuggestion=st;let Ze=class{constructor(O){this.commands=void 0,this.items=O}};Ze=Re([z],Ze),e.InlineSuggestionList=Ze;var rt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(rt=e.ViewColumn||(e.ViewColumn={}));var at;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(at=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ct;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(ct=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var bt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(bt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Nt;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Nt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var mt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var St;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(St=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var It;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(It=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function O(se){switch(se){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=O}(mt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let At=class{constructor(O,se){if(se&&!y.URI.isUri(se))throw(0,k.illegalArgument)("target");if(!H.isRange(O)||O.isEmpty)throw(0,k.illegalArgument)("range");this.range=O,this.target=se}};At=Re([z],At),e.DocumentLink=At;let Ct=class{constructor(O,se,ge,Ue){this.red=O,this.green=se,this.blue=ge,this.alpha=Ue}};Ct=Re([z],Ct),e.Color=Ct;let Rt=class{constructor(O,se){if(se&&!(se instanceof Ct))throw(0,k.illegalArgument)("color");if(!H.isRange(O)||O.isEmpty)throw(0,k.illegalArgument)("range");this.range=O,this.color=se}};Rt=Re([z],Rt),e.ColorInformation=Rt;let gt=class{constructor(O){if(!O||typeof O!="string")throw(0,k.illegalArgument)("label");this.label=O}};gt=Re([z],gt),e.ColorPresentation=gt;var Ft;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Ft=e.ColorFormat||(e.ColorFormat={}));var ot;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(ot=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ht;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ht=e.TerminalExitReason||(e.TerminalExitReason={}));class Se{constructor(O,se,ge){if(this.startIndex=O,this.length=se,this.tooltip=ge,typeof O!="number"||O<0)throw(0,k.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,k.illegalArgument)("length");if(ge!==void 0&&typeof ge!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=Se;class De{constructor(O){this.uri=O}}e.TerminalQuickFixOpener=De;class he{constructor(O){this.terminalCommand=O}}e.TerminalQuickFixCommand=he;var J;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(J=e.TerminalLocation||(e.TerminalLocation={}));class ke{constructor(O){if(this.options=O,typeof O!="object")throw(0,k.illegalArgument)("options")}}e.TerminalProfile=ke;var Oe;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Oe=e.TaskRevealKind||(e.TaskRevealKind={}));var qe;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(qe=e.TaskPanelKind||(e.TaskPanelKind={}));let Be=L=class{static from(O){switch(O){case"clean":return L.Clean;case"build":return L.Build;case"rebuild":return L.Rebuild;case"test":return L.Test;default:return}}constructor(O,se){if(this.label=se,typeof O!="string"||typeof se!="string")throw(0,k.illegalArgument)("name");this.c=O}get id(){return this.c}};Be.Clean=new L("clean","Clean"),Be.Build=new L("build","Build"),Be.Rebuild=new L("rebuild","Rebuild"),Be.Test=new L("test","Test"),Be=L=Re([z],Be),e.TaskGroup=Be;function tt(B){let O="";for(let se=0;se<B.length;se++)O+=B[se].replace(/,/g,",,")+",";return O}let lt=class{constructor(O,se,ge){if(typeof O!="string")throw(0,k.illegalArgument)("process");this.e=[],this.c=O,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=ge):this.f=se)}get process(){return this.c}set process(O){if(typeof O!="string")throw(0,k.illegalArgument)("process");this.c=O}get args(){return this.e}set args(O){Array.isArray(O)||(O=[]),this.e=O}get options(){return this.f}set options(O){this.f=O}computeId(){const O=[];if(O.push("process"),this.c!==void 0&&O.push(this.c),this.e&&this.e.length>0)for(const se of this.e)O.push(se);return tt(O)}};lt=Re([z],lt),e.ProcessExecution=lt;let Et=class{constructor(O,se,ge){if(this.f=[],Array.isArray(se)){if(!O)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,k.illegalArgument)("command");this.e=O,this.f=se,this.g=ge}else{if(typeof O!="string")throw(0,k.illegalArgument)("commandLine");this.c=O,this.g=se}}get commandLine(){return this.c}set commandLine(O){if(typeof O!="string")throw(0,k.illegalArgument)("commandLine");this.c=O}get command(){return this.e?this.e:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,k.illegalArgument)("command");this.e=O}get args(){return this.f}set args(O){this.f=O||[]}get options(){return this.g}set options(O){this.g=O}computeId(){const O=[];if(O.push("shell"),this.c!==void 0&&O.push(this.c),this.e!==void 0&&O.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)O.push(typeof se=="string"?se:se.value);return tt(O)}};Et=Re([z],Et),e.ShellExecution=Et;var Dt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Dt=e.ShellQuoting||(e.ShellQuoting={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft=e.TaskScope||(e.TaskScope={}));class yt{constructor(O){this.c=O}computeId(){return"customExecution"+(0,T.generateUuid)()}set callback(O){this.c=O}get callback(){return this.c}}e.CustomExecution=yt;let Lt=$=class{constructor(O,se,ge,Ue,We,Qe){this.j=!1,this.k=this.definition=O;let _e;typeof se=="string"?(this.m=this.name=se,this.t=this.source=ge,this.execution=Ue,_e=We,this.j=!0):se===ft.Global||se===ft.Workspace?(this.target=se,this.m=this.name=ge,this.t=this.source=Ue,this.execution=We,_e=Qe):(this.target=se,this.m=this.name=ge,this.t=this.source=Ue,this.execution=We,_e=Qe),typeof _e=="string"?(this.o=[_e],this.q=!0):Array.isArray(_e)?(this.o=_e,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(O){this.h=O}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof lt?this.k={type:$.e,id:this.n.computeId()}:this.n instanceof Et?this.k={type:$.f,id:this.n.computeId()}:this.n instanceof yt?this.k={type:$.c,id:this.n.computeId()}:this.k={type:$.g,id:(0,T.generateUuid)()}}get definition(){return this.k}set definition(O){if(O==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=O}get scope(){return this.l}set target(O){this.y(),this.l=O}get name(){return this.m}set name(O){if(typeof O!="string")throw(0,k.illegalArgument)("name");this.y(),this.m=O}get execution(){return this.n}set execution(O){O===null&&(O=void 0),this.y(),this.n=O;const se=this.k.type;($.g===se||$.e===se||$.f===se||$.c===se)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(O){if(Array.isArray(O))this.y(),this.o=O,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.y(),this.r=O}get source(){return this.t}set source(O){if(typeof O!="string"||O.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.y(),this.t=O}get group(){return this.u}set group(O){O===null&&(O=void 0),this.y(),this.u=O}get detail(){return this.x}set detail(O){O===null&&(O=void 0),this.x=O}get presentationOptions(){return this.v}set presentationOptions(O){O==null&&(O=Object.create(null)),this.y(),this.v=O}get runOptions(){return this.w}set runOptions(O){O==null&&(O=Object.create(null)),this.y(),this.w=O}};Lt.c="customExecution",Lt.e="process",Lt.f="shell",Lt.g="$empty",Lt=$=Re([z],Lt),e.Task=Lt;var Tn;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Tn=e.ProgressLocation||(e.ProgressLocation={}));var Rn;(function(B){function O(se){const ge=se;return(0,w.isNumber)(ge.value)?ge.tooltip&&!(0,w.isString)(ge.tooltip)?(console.log("INVALID view badge, invalid tooltip",ge.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ge.value),!1)}B.isViewBadge=O})(Rn=e.ViewBadge||(e.ViewBadge={}));let Gt=ie=class{static isTreeItem(O,se){if(O instanceof ie)return!0;const ge=O;if(ge.label!==void 0&&!(0,w.isString)(ge.label)&&!ge.label?.label)return console.log("INVALID tree item, invalid label",ge.label),!1;if(ge.id!==void 0&&!(0,w.isString)(ge.id))return console.log("INVALID tree item, invalid id",ge.id),!1;if(ge.iconPath!==void 0&&!(0,w.isString)(ge.iconPath)&&!y.URI.isUri(ge.iconPath)&&(!ge.iconPath||!(0,w.isString)(ge.iconPath.id))){const Ue=ge.iconPath;if(!Ue||!(0,w.isString)(Ue.light)&&!y.URI.isUri(Ue.light)&&!(0,w.isString)(Ue.dark)&&!y.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",ge.iconPath),!1}if(ge.description!==void 0&&!(0,w.isString)(ge.description)&&typeof ge.description!="boolean")return console.log("INVALID tree item, invalid description",ge.description),!1;if(ge.resourceUri!==void 0&&!y.URI.isUri(ge.resourceUri))return console.log("INVALID tree item, invalid resourceUri",ge.resourceUri),!1;if(ge.tooltip!==void 0&&!(0,w.isString)(ge.tooltip)&&!(ge.tooltip instanceof Je))return console.log("INVALID tree item, invalid tooltip",ge.tooltip),!1;if(ge.command!==void 0&&!ge.command.command)return console.log("INVALID tree item, invalid command",ge.command),!1;if(ge.collapsibleState!==void 0&&ge.collapsibleState<$t.None&&ge.collapsibleState>$t.Expanded)return console.log("INVALID tree item, invalid collapsibleState",ge.collapsibleState),!1;if(ge.contextValue!==void 0&&!(0,w.isString)(ge.contextValue))return console.log("INVALID tree item, invalid contextValue",ge.contextValue),!1;if(ge.accessibilityInformation!==void 0&&!ge.accessibilityInformation?.label)return console.log("INVALID tree item, invalid accessibilityInformation",ge.accessibilityInformation),!1;if(ge.checkboxState!==void 0){(0,f.checkProposedApiEnabled)(se,"treeItemCheckbox");const Ue=(0,w.isNumber)(ge.checkboxState)?ge.checkboxState:(0,w.isObject)(ge.checkboxState)&&(0,w.isNumber)(ge.checkboxState.state)?ge.checkboxState.state:void 0,We=!(0,w.isNumber)(ge.checkboxState)&&(0,w.isObject)(ge.checkboxState)?ge.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==Kt.Checked&&Ue!==Kt.Unchecked||We!==void 0&&!(0,w.isString)(We))return console.log("INVALID tree item, invalid checkboxState",ge.checkboxState),!1}return!0}constructor(O,se=$t.None){this.collapsibleState=se,y.URI.isUri(O)?this.resourceUri=O:this.label=O}};Gt=ie=Re([z],Gt),e.TreeItem=Gt;var $t;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})($t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Kt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Kt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(O,se){this.value=O,this.id=se??(0,T.generateUuid)()}};Yt=Re([z],Yt),e.DataTransferItem=Yt;let Jt=class{constructor(O){h.set(this,new Map);for(const[se,ge]of O??[]){const Ue=it(this,h,"f").get(se);Ue?Ue.push(ge):it(this,h,"f").set(se,[ge])}}get(O){return it(this,h,"f").get(O)?.[0]}set(O,se){it(this,h,"f").set(O,[se])}forEach(O,se){for(const[ge,Ue]of it(this,h,"f"))for(const We of Ue)O.call(se,We,ge,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[O,se]of it(this,h,"f"))for(const ge of se)yield[O,ge]}};Jt=Re([z],Jt),e.DataTransfer=Jt;let Xt=class{constructor(O){this.insertText=O}};Xt=Re([z],Xt),e.DocumentDropEdit=Xt;let Qt=class{constructor(O){this.insertText=O}};Qt=Re([z],Qt),e.DocumentPasteEdit=Qt;let Pt=class{constructor(O,se){this.id=O,this.color=se}static isThemeIcon(O){return typeof O.id!="string"?(console.log("INVALID ThemeIcon, invalid id",O.id),!1):!0}};Pt=Re([z],Pt),e.ThemeIcon=Pt,Pt.File=new Pt("file"),Pt.Folder=new Pt("folder");let Zt=class{constructor(O){this.id=O}};Zt=Re([z],Zt),e.ThemeColor=Zt;var Ln;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Ln=e.ConfigurationTarget||(e.ConfigurationTarget={}));let _t=class{get base(){return this.c}set base(O){this.c=O,this.e=y.URI.file(O)}get baseUri(){return this.e}set baseUri(O){this.e=O,this.c=O.fsPath}constructor(O,se){if(typeof O!="string"&&(!O||!y.URI.isUri(O)&&!y.URI.isUri(O.uri)))throw(0,k.illegalArgument)("base");if(typeof se!="string")throw(0,k.illegalArgument)("pattern");typeof O=="string"?this.baseUri=y.URI.file(O):y.URI.isUri(O)?this.baseUri=O:this.baseUri=O.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};_t=Re([z],_t),e.RelativePattern=_t;const kn=new WeakMap;function On(B,O){kn.set(B,O)}e.setBreakpointId=On;let Mt=class{constructor(O,se,ge,Ue){this.enabled=typeof O=="boolean"?O:!0,typeof se=="string"&&(this.condition=se),typeof ge=="string"&&(this.hitCondition=ge),typeof Ue=="string"&&(this.logMessage=Ue)}get id(){return this.c||(this.c=kn.get(this)??(0,T.generateUuid)()),this.c}};Mt=Re([z],Mt),e.Breakpoint=Mt;let en=class extends Mt{constructor(O,se,ge,Ue,We){if(super(se,ge,Ue,We),O===null)throw(0,k.illegalArgument)("location");this.location=O}};en=Re([z],en),e.SourceBreakpoint=en;let tn=class extends Mt{constructor(O,se,ge,Ue,We){super(se,ge,Ue,We),this.functionName=O}};tn=Re([z],tn),e.FunctionBreakpoint=tn;let nn=class extends Mt{constructor(O,se,ge,Ue,We,Qe,_e){if(super(Ue,We,Qe,_e),!se)throw(0,k.illegalArgument)("dataId");this.label=O,this.dataId=se,this.canPersist=ge}};nn=Re([z],nn),e.DataBreakpoint=nn;let rn=class{constructor(O,se,ge){this.command=O,this.args=se||[],this.options=ge}};rn=Re([z],rn),e.DebugAdapterExecutable=rn;let sn=class{constructor(O,se){this.port=O,this.host=se}};sn=Re([z],sn),e.DebugAdapterServer=sn;let on=class{constructor(O){this.path=O}};on=Re([z],on),e.DebugAdapterNamedPipeServer=on;let an=class{constructor(O){this.implementation=O}};an=Re([z],an),e.DebugAdapterInlineImplementation=an;let ln=class{constructor(O,se){this.range=O,this.expression=se}};ln=Re([z],ln),e.EvaluatableExpression=ln;var Nn;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Nn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let cn=class{constructor(O,se){this.range=O,this.text=se}};cn=Re([z],cn),e.InlineValueText=cn;let un=class{constructor(O,se,ge=!0){this.range=O,this.variableName=se,this.caseSensitiveLookup=ge}};un=Re([z],un),e.InlineValueVariableLookup=un;let fn=class{constructor(O,se){this.range=O,this.expression=se}};fn=Re([z],fn),e.InlineValueEvaluatableExpression=fn;let hn=class{constructor(O,se){this.frameId=O,this.stoppedLocation=se}};hn=Re([z],hn),e.InlineValueContext=hn;var Fn;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Fn=e.FileChangeType||(e.FileChangeType={}));let dn=ne=class extends Error{static FileExists(O){return new ne(O,S.FileSystemProviderErrorCode.FileExists,ne.FileExists)}static FileNotFound(O){return new ne(O,S.FileSystemProviderErrorCode.FileNotFound,ne.FileNotFound)}static FileNotADirectory(O){return new ne(O,S.FileSystemProviderErrorCode.FileNotADirectory,ne.FileNotADirectory)}static FileIsADirectory(O){return new ne(O,S.FileSystemProviderErrorCode.FileIsADirectory,ne.FileIsADirectory)}static NoPermissions(O){return new ne(O,S.FileSystemProviderErrorCode.NoPermissions,ne.NoPermissions)}static Unavailable(O){return new ne(O,S.FileSystemProviderErrorCode.Unavailable,ne.Unavailable)}constructor(O,se=S.FileSystemProviderErrorCode.Unknown,ge){super(y.URI.isUri(O)?O.toString(!0):O),this.code=ge?.name??"Unknown",(0,S.markAsFileSystemProviderError)(this,se),Object.setPrototypeOf(this,ne.prototype),typeof Error.captureStackTrace=="function"&&typeof ge=="function"&&Error.captureStackTrace(this,ge)}};dn=ne=Re([z],dn),e.FileSystemError=dn;let mn=class{constructor(O,se,ge){this.start=O,this.end=se,this.kind=ge}};mn=Re([z],mn),e.FoldingRange=mn;var Mn;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Mn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Un;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Un=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Bn;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Bn=e.CommentMode||(e.CommentMode={}));var jn;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(jn=e.CommentThreadState||(e.CommentThreadState={}));class $n{constructor(O,se=[]){this.tokenTypes=O,this.tokenModifiers=se}}e.SemanticTokensLegend=$n;function zn(B){return typeof B>"u"||(0,w.isStringArray)(B)}class gn{constructor(O){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,O){this.l=!0;for(let se=0,ge=O.tokenTypes.length;se<ge;se++)this.j.set(O.tokenTypes[se],se);for(let se=0,ge=O.tokenModifiers.length;se<ge;se++)this.k.set(O.tokenModifiers[se],se)}}push(O,se,ge,Ue,We){if(typeof O=="number"&&typeof se=="number"&&typeof ge=="number"&&typeof Ue=="number"&&(typeof We=="number"||typeof We>"u"))return typeof We>"u"&&(We=0),this.n(O,se,ge,Ue,We);if(H.isRange(O)&&typeof se=="string"&&zn(ge))return this.m(O,se,ge);throw(0,k.illegalArgument)()}m(O,se,ge){if(!this.l)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(se))throw new Error("`tokenType` is not in the provided legend");const Ue=O.start.line,We=O.start.character,Qe=O.end.character-O.start.character,_e=this.j.get(se);let ut=0;if(ge)for(const dt of ge){if(!this.k.has(dt))throw new Error("`tokenModifier` is not in the provided legend");const vt=this.k.get(dt);ut|=1<<vt>>>0}this.n(Ue,We,Qe,_e,ut)}n(O,se,ge,Ue,We){if(this.f&&(O<this.c||O===this.c&&se<this.e)){this.f=!1;const ut=this.g.length/5|0;let dt=0,vt=0;for(let wt=0;wt<ut;wt++){let kt=this.g[5*wt],Bt=this.g[5*wt+1];kt===0?(kt=dt,Bt+=vt):kt+=dt,this.g[5*wt]=kt,this.g[5*wt+1]=Bt,dt=kt,vt=Bt}}let Qe=O,_e=se;this.f&&this.h>0&&(Qe-=this.c,Qe===0&&(_e-=this.e)),this.g[this.h++]=Qe,this.g[this.h++]=_e,this.g[this.h++]=ge,this.g[this.h++]=Ue,this.g[this.h++]=We,this.c=O,this.e=se}static o(O){const se=[],ge=O.length/5|0;for(let _e=0;_e<ge;_e++)se[_e]=_e;se.sort((_e,ut)=>{const dt=O[5*_e],vt=O[5*ut];if(dt===vt){const wt=O[5*_e+1],kt=O[5*ut+1];return wt-kt}return dt-vt});const Ue=new Uint32Array(O.length);let We=0,Qe=0;for(let _e=0;_e<ge;_e++){const ut=5*se[_e],dt=O[ut+0],vt=O[ut+1],wt=O[ut+2],kt=O[ut+3],Bt=O[ut+4],An=dt-We,Di=An===0?vt-Qe:vt,jt=5*_e;Ue[jt+0]=An,Ue[jt+1]=Di,Ue[jt+2]=wt,Ue[jt+3]=kt,Ue[jt+4]=Bt,We=dt,Qe=vt}return Ue}build(O){return this.f?new pn(new Uint32Array(this.g),O):new pn(gn.o(this.g),O)}}e.SemanticTokensBuilder=gn;class pn{constructor(O,se){this.resultId=se,this.data=O}}e.SemanticTokens=pn;class Wn{constructor(O,se,ge){this.start=O,this.deleteCount=se,this.data=ge}}e.SemanticTokensEdit=Wn;class Hn{constructor(O,se){this.resultId=se,this.edits=O}}e.SemanticTokensEdits=Hn;var Vn;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Vn=e.DebugConsoleMode||(e.DebugConsoleMode={}));let zt=class{constructor(){}};zt.Back={iconPath:new Pt("arrow-left")},zt=Re([z],zt),e.QuickInputButtons=zt;var qn;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(qn=e.QuickPickItemKind||(e.QuickPickItemKind={}));var xn;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(xn=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Gn;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Gn=e.ExtensionKind||(e.ExtensionKind={}));class Kn{static validate(O){if(typeof O.badge=="string"){let se=(0,P.nextCharLength)(O.badge,0);if(se<O.badge.length&&(se+=(0,P.nextCharLength)(O.badge,se)),O.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(O.badge&&!Pt.isThemeIcon(O.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}constructor(O,se,ge){this.badge=O,this.tooltip=se,this.color=ge}}e.FileDecoration=Kn;let vn=class{constructor(O){this.kind=O}};vn=Re([z],vn),e.ColorTheme=vn;var Yn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Yn=e.ColorThemeKind||(e.ColorThemeKind={}));class Tt{static isNotebookRange(O){return O instanceof Tt?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(O,se){if(O<0)throw(0,k.illegalArgument)("start must be positive");if(se<0)throw(0,k.illegalArgument)("end must be positive");O<=se?(this.c=O,this.e=se):(this.c=se,this.e=O)}with(O){let se=this.c,ge=this.e;return O.start!==void 0&&(se=O.start),O.end!==void 0&&(ge=O.end),se===this.c&&ge===this.e?this:new Tt(se,ge)}}e.NotebookRange=Tt;class Wt{static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(se=>Wt.isNotebookCellData(se))}static isNotebookCellData(O){return!0}constructor(O,se,ge,Ue,We,Qe,_e){this.kind=O,this.value=se,this.languageId=ge,this.mime=Ue,this.outputs=We??[],this.metadata=Qe,this.executionSummary=_e,Wt.validate(this)}}e.NotebookCellData=Wt;class Jn{constructor(O){this.cells=O}}e.NotebookData=Jn;class pt{static isNotebookCellOutputItem(O){return O instanceof pt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const se={name:O.name,message:O.message,stack:O.stack};return pt.json(se,"application/vnd.code.notebook.error")}static stdout(O){return pt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return pt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,se="application/octet-stream"){return new pt(O,se)}static text(O,se=C.Mimes.text){const ge=it(pt,v,"f",d).encode(String(O));return new pt(ge,se)}static json(O,se="text/x-json"){const ge=JSON.stringify(O,void 0,"	");return pt.text(ge,se)}constructor(O,se){this.data=O,this.mime=se;const ge=(0,C.normalizeMimeType)(se,!0);if(!ge)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ge}}v=pt,d={value:new TextEncoder},e.NotebookCellOutputItem=pt;class Ht{static isNotebookCellOutput(O){return O instanceof Ht?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&Array.isArray(O.items)}static ensureUniqueMimeTypes(O,se=!1){const ge=new Set,Ue=new Set;for(let We=0;We<O.length;We++){const Qe=O[We],_e=(0,C.normalizeMimeType)(Qe.mime);if(!ge.has(_e)||(0,g.isTextStreamMime)(_e)){ge.add(_e);continue}Ue.add(We),se&&console.warn(`DUPLICATED mime type '${Qe.mime}' will be dropped`)}return Ue.size===0?O:O.filter((We,Qe)=>!Ue.has(Qe))}constructor(O,se,ge){this.items=Ht.ensureUniqueMimeTypes(O,!0),typeof se=="string"?(this.id=se,this.metadata=ge):(this.id=(0,T.generateUuid)(),this.metadata=se??ge)}}e.NotebookCellOutput=Ht;var Xn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Xn=e.NotebookCellKind||(e.NotebookCellKind={}));var Qn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Qn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Zn;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(Zn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _n;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(_n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class ei{constructor(O,se){this.text=O,this.alignment=se}}e.NotebookCellStatusBarItem=ei;var ti;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(ti=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var ni;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(ni=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class ii{constructor(O,se=[]){this.uri=O,this.provides=(0,E.asArray)(se)}}e.NotebookRendererScript=ii;class ri{constructor(O){this.label=O}}e.NotebookKernelSourceAction=ri;let bn=class{constructor(O,se){this.label=O,this.timestamp=se}};bn=Re([z],bn),e.TimelineItem=bn;var si;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(si=e.ExtensionMode||(e.ExtensionMode={}));var oi;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(oi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ai;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(ai=e.StandardTokenType||(e.StandardTokenType={}));class li{constructor(O,se){this.ranges=O,this.wordPattern=se}}e.LinkedEditingRanges=li;class ci{constructor(O,se){this.c=O,this.e=se}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=ci;var ui;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(ui=e.TestResultState||(e.TestResultState={}));var fi;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(fi=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Vt=class{constructor(O=void 0,se=void 0,ge=void 0){this.include=O,this.exclude=se,this.profile=ge}};Vt=Re([z],Vt),e.TestRunRequest=Vt;let En=class extends Vt{constructor(O=void 0,se=void 0,ge=void 0,Ue=!1){super(O,se,ge),this.continuous=Ue}};En=Re([z],En),e.TestRunRequest2=En;let yn=F=class{static diff(O,se,ge){const Ue=new F(O);return Ue.expectedOutput=se,Ue.actualOutput=ge,Ue}constructor(O){this.message=O}};yn=F=Re([z],yn),e.TestMessage=yn;let wn=class{constructor(O){this.id=O}};wn=Re([z],wn),e.TestTag=wn;let Ut=class{constructor(O,se){this.covered=O,this.total=se}};Ut=Re([z],Ut),e.CoveredCount=Ut;let Sn=_=class{static fromDetails(O,se){const ge=new Ut(0,0),Ue=new Ut(0,0),We=new Ut(0,0);for(const _e of se)if("branches"in _e){ge.total+=1,ge.covered+=_e.executionCount>0?1:0;for(const ut of _e.branches)Ue.total+=1,Ue.covered+=ut.executionCount>0?1:0}else We.total+=1,We.covered+=_e.executionCount>0?1:0;const Qe=new _(O,ge,Ue.total>0?Ue:void 0,We.total>0?We:void 0);return Qe.detailedCoverage=se,Qe}constructor(O,se,ge,Ue){this.uri=O,this.statementCoverage=se,this.branchCoverage=ge,this.functionCoverage=Ue}};Sn=_=Re([z],Sn),e.FileCoverage=Sn;let In=class{constructor(O,se,ge=[]){this.executionCount=O,this.location=se,this.branches=ge}};In=Re([z],In),e.StatementCoverage=In;let Cn=class{constructor(O,se){this.executionCount=O,this.location=se}};Cn=Re([z],Cn),e.BranchCoverage=Cn;let Dn=class{constructor(O,se){this.executionCount=O,this.location=se}};Dn=Re([z],Dn),e.FunctionCoverage=Dn;var hi;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(hi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var di;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(di=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var mi;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(mi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class gi{constructor(O,se,ge,Ue,We,Qe){this.kind=O,this.name=se,this.detail=ge,this.uri=Ue,this.range=We,this.selectionRange=Qe}}e.TypeHierarchyItem=gi;class pi{constructor(O){this.uri=O}}e.TextTabInput=pi;class vi{constructor(O,se){this.original=O,this.modified=se}}e.TextDiffTabInput=vi;class bi{constructor(O,se,ge,Ue){this.base=O,this.input1=se,this.input2=ge,this.result=Ue}}e.TextMergeTabInput=bi;class Ei{constructor(O,se){this.uri=O,this.viewType=se}}e.CustomEditorTabInput=Ei;class yi{constructor(O){this.viewType=O}}e.WebviewEditorTabInput=yi;class wi{constructor(O,se){this.uri=O,this.notebookType=se}}e.NotebookEditorTabInput=wi;class Si{constructor(O,se,ge){this.original=O,this.modified=se,this.notebookType=ge}}e.NotebookDiffEditorTabInput=Si;class Ii{constructor(){}}e.TerminalEditorTabInput=Ii;class Ci{constructor(O,se){this.uri=O,this.inputBoxUri=se}}e.InteractiveWindowInput=Ci}),define(ve[134],be([1,0,18,15,146,69,95,27,142,48,56,23,8,4,47,167,222,129,83,127,68,84,131,133]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v,d,D,A,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Se){function De(J){const{selectionStartLineNumber:ke,selectionStartColumn:Oe,positionLineNumber:qe,positionColumn:Be}=J,tt=new r.Position(ke-1,Oe-1),lt=new r.Position(qe-1,Be-1);return new r.Selection(tt,lt)}Se.to=De;function he(J){const{anchor:ke,active:Oe}=J;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}Se.from=he})(n=e.Selection||(e.Selection={}));var i;(function(Se){function De(J){if(!J)return;const{start:ke,end:Oe}=J;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}Se.from=De;function he(J){if(!J)return;const{startLineNumber:ke,startColumn:Oe,endLineNumber:qe,endColumn:Be}=J;return new r.Range(ke-1,Oe-1,qe-1,Be-1)}Se.to=he})(i=e.Range||(e.Range={}));var o;(function(Se){function De(he){switch(he){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Se.to=De})(o=e.TokenType||(e.TokenType={}));var c;(function(Se){function De(J){return new r.Position(J.lineNumber-1,J.column-1)}Se.to=De;function he(J){return{lineNumber:J.line+1,column:J.character+1}}Se.from=he})(c=e.Position||(e.Position={}));var a;(function(Se){function De(ke,Oe){return(0,E.coalesce)((0,E.asArray)(ke).map(qe=>he(qe,Oe)))}Se.from=De;function he(ke,Oe){if(typeof ke=="string")return{$serialized:!0,language:ke};if(ke)return{$serialized:!0,language:ke.language,scheme:J(ke.scheme,Oe),pattern:ue.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType}}function J(ke,Oe){return Oe&&typeof ke=="string"?Oe.transformOutgoingScheme(ke):ke}})(a=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(Se){function De(J){switch(J){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Se.from=De;function he(J){switch(J){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Se.to=he})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var m;(function(Se){function De(J){let ke;return J.code&&((0,b.isString)(J.code)||(0,b.isNumber)(J.code)?ke=String(J.code):ke={value:String(J.code.value),target:J.code.target}),{...i.from(J.range),message:J.message,source:J.source,code:ke,severity:L.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(R.from),tags:Array.isArray(J.tags)?(0,E.coalesce)(J.tags.map(s.from)):void 0}}Se.from=De;function he(J){const ke=new r.Diagnostic(i.to(J),J.message,L.to(J.severity));return ke.source=J.source,ke.code=(0,b.isString)(J.code)?J.code:J.code?.value,ke.relatedInformation=J.relatedInformation&&J.relatedInformation.map(R.to),ke.tags=J.tags&&(0,E.coalesce)(J.tags.map(s.to)),ke}Se.to=he})(m=e.Diagnostic||(e.Diagnostic={}));var R;(function(Se){function De(J){return{...i.from(J.location.range),message:J.message,resource:J.location.uri}}Se.from=De;function he(J){return new r.DiagnosticRelatedInformation(new r.Location(J.resource,i.to(J)),J.message)}Se.to=he})(R=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var L;(function(Se){function De(J){switch(J){case r.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Se.from=De;function he(J){switch(J){case u.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Se.to=he})(L=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var $;(function(Se){function De(J){return typeof J=="number"&&J>=r.ViewColumn.One?J-1:J===r.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Se.from=De;function he(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=he})($=e.ViewColumn||(e.ViewColumn={}));function ie(Se){return typeof Se.range<"u"}function ne(Se){return Se.length===0?!0:!!ie(Se[0])}e.isDecorationOptionsArr=ne;var F;(function(Se){function De(Be){return Be.map(Se.from)}Se.fromMany=De;function he(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function J(Be){let tt;if(he(Be)){const{language:ft,value:yt}=Be;tt={value:"```"+ft+`
`+yt+"\n```\n"}}else r.MarkdownString.isMarkdownString(Be)?tt={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?tt={value:Be}:tt={value:""};const lt=Object.create(null);tt.uris=lt;const Et=ft=>{try{let yt=g.URI.parse(ft,!0);yt=yt.with({query:ke(yt.query,lt)}),lt[ft]=yt}catch{}return""},Dt=new w.marked.Renderer;return Dt.link=Et,Dt.image=ft=>typeof ft=="string"?Et(C.parseHrefAndDimensions(ft).href):"",(0,w.marked)(tt.value,{renderer:Dt}),tt}Se.from=J;function ke(Be,tt){if(!Be)return Be;let lt;try{lt=(0,y.parse)(Be)}catch{}if(!lt)return Be;let Et=!1;return lt=(0,S.cloneAndChange)(lt,Dt=>{if(g.URI.isUri(Dt)){const ft=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[ft]=Dt,Et=!0,ft}else return}),Et?JSON.stringify(lt):Be}function Oe(Be){const tt=new r.MarkdownString(Be.value,Be.supportThemeIcons);return tt.isTrusted=Be.isTrusted,tt.supportHtml=Be.supportHtml,tt.baseUri=Be.baseUri?g.URI.from(Be.baseUri):void 0,tt}Se.to=Oe;function qe(Be){if(!!Be)return typeof Be=="string"?Be:Se.from(Be)}Se.fromStrict=qe})(F=e.MarkdownString||(e.MarkdownString={}));function _(Se){return ne(Se)?Se.map(De=>({range:i.from(De.range),hoverMessage:Array.isArray(De.hoverMessage)?F.fromMany(De.hoverMessage):De.hoverMessage?F.from(De.hoverMessage):void 0,renderOptions:De.renderOptions})):Se.map(De=>({range:i.from(De)}))}e.fromRangeOrRangeWithMessage=_;function z(Se){return typeof Se>"u"?Se:typeof Se=="string"?g.URI.file(Se):Se}e.pathOrURIToURI=z;var x;(function(Se){function De(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?z(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}Se.from=De})(x=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var le;(function(Se){function De(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?z(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?x.from(he.before):void 0,after:he.after?x.from(he.after):void 0}}Se.from=De})(le=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var Ee;(function(Se){function De(he){if(typeof he>"u")return he;switch(he){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=De})(Ee=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var Y;(function(Se){function De(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?Ee.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?le.from(he.light):void 0,dark:he.dark?le.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?z(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?x.from(he.before):void 0,after:he.after?x.from(he.after):void 0}}Se.from=De})(Y=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(Se){function De(J){return{text:J.newText,eol:J.newEol&&Je.from(J.newEol),range:i.from(J.range)}}Se.from=De;function he(J){const ke=new r.TextEdit(i.to(J.range),J.text);return ke.newEol=typeof J.eol>"u"?void 0:Je.to(J.eol),ke}Se.to=he})(H=e.TextEdit||(e.TextEdit={}));var U;(function(Se){function De(J,ke){const Oe={edits:[]};if(J instanceof r.WorkspaceEdit){const qe=new P.ResourceSet;for(const Be of J._allEntries())Be._type===1&&g.URI.isUri(Be.to)&&Be.from===void 0&&qe.add(Be.to);for(const Be of J._allEntries())Be._type===1?Oe.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contentsBase64:Be.options?.contents&&(0,k.encodeBase64)(k.VSBuffer.wrap(Be.options.contents))},metadata:Be.metadata}):Be._type===2?Oe.edits.push({resource:Be.uri,textEdit:H.from(Be.edit),versionId:qe.has(Be.uri)?void 0:ke?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?Oe.edits.push({resource:Be.uri,textEdit:{range:i.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:qe.has(Be.uri)?void 0:ke?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Oe.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Oe.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:ke?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(Xe.from)}})}return Oe}Se.from=De;function he(J){const ke=new r.WorkspaceEdit;for(const Oe of J.edits)Oe.textEdit?ke.replace(g.URI.revive(Oe.resource),i.to(Oe.textEdit.range),Oe.textEdit.text):ke.renameFile(g.URI.revive(Oe.oldResource),g.URI.revive(Oe.newResource),Oe.options);return ke}Se.to=he})(U=e.WorkspaceEdit||(e.WorkspaceEdit={}));var te;(function(Se){const De=Object.create(null);De[r.SymbolKind.File]=0,De[r.SymbolKind.Module]=1,De[r.SymbolKind.Namespace]=2,De[r.SymbolKind.Package]=3,De[r.SymbolKind.Class]=4,De[r.SymbolKind.Method]=5,De[r.SymbolKind.Property]=6,De[r.SymbolKind.Field]=7,De[r.SymbolKind.Constructor]=8,De[r.SymbolKind.Enum]=9,De[r.SymbolKind.Interface]=10,De[r.SymbolKind.Function]=11,De[r.SymbolKind.Variable]=12,De[r.SymbolKind.Constant]=13,De[r.SymbolKind.String]=14,De[r.SymbolKind.Number]=15,De[r.SymbolKind.Boolean]=16,De[r.SymbolKind.Array]=17,De[r.SymbolKind.Object]=18,De[r.SymbolKind.Key]=19,De[r.SymbolKind.Null]=20,De[r.SymbolKind.EnumMember]=21,De[r.SymbolKind.Struct]=22,De[r.SymbolKind.Event]=23,De[r.SymbolKind.Operator]=24,De[r.SymbolKind.TypeParameter]=25;function he(ke){return typeof De[ke]=="number"?De[ke]:6}Se.from=he;function J(ke){for(const Oe in De)if(De[Oe]===ke)return Number(Oe);return r.SymbolKind.Property}Se.to=J})(te=e.SymbolKind||(e.SymbolKind={}));var re;(function(Se){function De(J){switch(J){case r.SymbolTag.Deprecated:return 1}}Se.from=De;function he(J){switch(J){case 1:return r.SymbolTag.Deprecated}}Se.to=he})(re=e.SymbolTag||(e.SymbolTag={}));var de;(function(Se){function De(J){return{name:J.name,kind:te.from(J.kind),tags:J.tags&&J.tags.map(re.from),containerName:J.containerName,location:q.from(J.location)}}Se.from=De;function he(J){const ke=new r.SymbolInformation(J.name,te.to(J.kind),J.containerName,q.to(J.location));return ke.tags=J.tags&&J.tags.map(re.to),ke}Se.to=he})(de=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var oe;(function(Se){function De(J){const ke={name:J.name||"!!MISSING: name!!",detail:J.detail,range:i.from(J.range),selectionRange:i.from(J.selectionRange),kind:te.from(J.kind),tags:J.tags?.map(re.from)??[]};return J.children&&(ke.children=J.children.map(De)),ke}Se.from=De;function he(J){const ke=new r.DocumentSymbol(J.name,J.detail,te.to(J.kind),i.to(J.range),i.to(J.selectionRange));return(0,E.isNonEmptyArray)(J.tags)&&(ke.tags=J.tags.map(re.to)),J.children&&(ke.children=J.children.map(he)),ke}Se.to=he})(oe=e.DocumentSymbol||(e.DocumentSymbol={}));var j;(function(Se){function De(J){const ke=new r.CallHierarchyItem(te.to(J.kind),J.name,J.detail||"",g.URI.revive(J.uri),i.to(J.range),i.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}Se.to=De;function he(J,ke,Oe){if(ke=ke??J._sessionId,Oe=Oe??J._itemId,ke===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Oe,name:J.name,detail:J.detail,kind:te.from(J.kind),uri:J.uri,range:i.from(J.range),selectionRange:i.from(J.selectionRange),tags:J.tags?.map(re.from)}}Se.from=he})(j=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(Se){function De(he){return new r.CallHierarchyIncomingCall(j.to(he.from),he.fromRanges.map(J=>i.to(J)))}Se.to=De})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(Se){function De(he){return new r.CallHierarchyOutgoingCall(j.to(he.to),he.fromRanges.map(J=>i.to(J)))}Se.to=De})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var q;(function(Se){function De(J){return{range:J.range&&i.from(J.range),uri:J.uri}}Se.from=De;function he(J){return new r.Location(g.URI.revive(J.uri),i.to(J.range))}Se.to=he})(q=e.location||(e.location={}));var ee;(function(Se){function De(J){const ke=J,Oe=J;return{originSelectionRange:ke.originSelectionRange?i.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Oe.uri,range:i.from(ke.targetRange?ke.targetRange:Oe.range),targetSelectionRange:ke.targetSelectionRange?i.from(ke.targetSelectionRange):void 0}}Se.from=De;function he(J){return{targetUri:g.URI.revive(J.uri),targetRange:i.to(J.range),targetSelectionRange:J.targetSelectionRange?i.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?i.to(J.originSelectionRange):void 0}}Se.to=he})(ee=e.DefinitionLink||(e.DefinitionLink={}));var fe;(function(Se){function De(J){return{range:i.from(J.range),contents:F.fromMany(J.contents)}}Se.from=De;function he(J){return new r.Hover(J.contents.map(F.to),i.to(J.range))}Se.to=he})(fe=e.Hover||(e.Hover={}));var W;(function(Se){function De(J){return{range:i.from(J.range),expression:J.expression}}Se.from=De;function he(J){return new r.EvaluatableExpression(i.to(J.range),J.expression)}Se.to=he})(W=e.EvaluatableExpression||(e.EvaluatableExpression={}));var K;(function(Se){function De(J){if(J instanceof r.InlineValueText)return{type:"text",range:i.from(J.range),text:J.text};if(J instanceof r.InlineValueVariableLookup)return{type:"variable",range:i.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:i.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=De;function he(J){switch(J.type){case"text":return{range:i.to(J.range),text:J.text};case"variable":return{range:i.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:i.to(J.range),expression:J.expression}}}Se.to=he})(K=e.InlineValue||(e.InlineValue={}));var Z;(function(Se){function De(J){return{frameId:J.frameId,stoppedLocation:i.from(J.stoppedLocation)}}Se.from=De;function he(J){return new r.InlineValueContext(J.frameId,i.to(J.stoppedLocation))}Se.to=he})(Z=e.InlineValueContext||(e.InlineValueContext={}));var V;(function(Se){function De(J){return{range:i.from(J.range),kind:J.kind}}Se.from=De;function he(J){return new r.DocumentHighlight(i.to(J.range),J.kind)}Se.to=he})(V=e.DocumentHighlight||(e.DocumentHighlight={}));var Q;(function(Se){function De(he){switch(he){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Se.to=De})(Q=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var G;(function(Se){function De(he){return{triggerKind:Q.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}Se.to=De})(G=e.CompletionContext||(e.CompletionContext={}));var X;(function(Se){function De(J){switch(J){case r.CompletionItemTag.Deprecated:return 1}}Se.from=De;function he(J){switch(J){case 1:return r.CompletionItemTag.Deprecated}}Se.to=he})(X=e.CompletionItemTag||(e.CompletionItemTag={}));var ce;(function(Se){const De=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function he(Oe){return De.get(Oe)??9}Se.from=he;const J=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function ke(Oe){return J.get(Oe)??r.CompletionItemKind.Property}Se.to=ke})(ce=e.CompletionItemKind||(e.CompletionItemKind={}));var pe;(function(Se){function De(he,J){const ke=new r.CompletionItem(he.label);return ke.insertText=he.insertText,ke.kind=ce.to(he.kind),ke.tags=he.tags?.map(X.to),ke.detail=he.detail,ke.documentation=C.isMarkdownString(he.documentation)?F.to(he.documentation):he.documentation,ke.sortText=he.sortText,ke.filterText=he.filterText,ke.preselect=he.preselect,ke.commitCharacters=he.commitCharacters,f.Range.isIRange(he.range)?ke.range=i.to(he.range):typeof he.range=="object"&&(ke.range={inserting:i.to(he.range.insert),replacing:i.to(he.range.replace)}),ke.keepWhitespace=typeof he.insertTextRules>"u"?!1:Boolean(he.insertTextRules&1),typeof he.insertTextRules<"u"&&he.insertTextRules&4?ke.insertText=new r.SnippetString(he.insertText):(ke.insertText=he.insertText,ke.textEdit=ke.range instanceof r.Range?new r.TextEdit(ke.range,ke.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(ke.additionalTextEdits=he.additionalTextEdits.map(Oe=>H.to(Oe))),ke.command=J&&he.command?J.fromInternal(he.command):void 0,ke}Se.to=De})(pe=e.CompletionItem||(e.CompletionItem={}));var Pe;(function(Se){function De(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:F.fromStrict(J.documentation)}}Se.from=De;function he(J){return{label:J.label,documentation:C.isMarkdownString(J.documentation)?F.to(J.documentation):J.documentation}}Se.to=he})(Pe=e.ParameterInformation||(e.ParameterInformation={}));var Ae;(function(Se){function De(J){return{label:J.label,documentation:F.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(Pe.from):[],activeParameter:J.activeParameter}}Se.from=De;function he(J){return{label:J.label,documentation:C.isMarkdownString(J.documentation)?F.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(Pe.to):[],activeParameter:J.activeParameter}}Se.to=he})(Ae=e.SignatureInformation||(e.SignatureInformation={}));var Fe;(function(Se){function De(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(Ae.from):[]}}Se.from=De;function he(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(Ae.to):[]}}Se.to=he})(Fe=e.SignatureHelp||(e.SignatureHelp={}));var $e;(function(Se){function De(he,J){const ke=new r.InlayHint(c.to(J.position),typeof J.label=="string"?J.label:J.label.map(me.to.bind(void 0,he)),J.kind&&we.to(J.kind));return ke.textEdits=J.textEdits&&J.textEdits.map(H.to),ke.tooltip=C.isMarkdownString(J.tooltip)?F.to(J.tooltip):J.tooltip,ke.paddingLeft=J.paddingLeft,ke.paddingRight=J.paddingRight,ke}Se.to=De})($e=e.InlayHint||(e.InlayHint={}));var me;(function(Se){function De(he,J){const ke=new r.InlayHintLabelPart(J.label);return ke.tooltip=C.isMarkdownString(J.tooltip)?F.to(J.tooltip):J.tooltip,p.Command.is(J.command)&&(ke.command=he.fromInternal(J.command)),J.location&&(ke.location=q.to(J.location)),ke}Se.to=De})(me=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(Se){function De(J){return J}Se.from=De;function he(J){return J}Se.to=he})(we=e.InlayHintKind||(e.InlayHintKind={}));var ye;(function(Se){function De(J){return{range:i.from(J.range),url:J.target,tooltip:J.tooltip}}Se.from=De;function he(J){let ke;if(J.url)try{ke=typeof J.url=="string"?g.URI.parse(J.url,!0):g.URI.revive(J.url)}catch{}return new r.DocumentLink(i.to(J.range),ke)}Se.to=he})(ye=e.DocumentLink||(e.DocumentLink={}));var Me;(function(Se){function De(J){const ke=new r.ColorPresentation(J.label);return J.textEdit&&(ke.textEdit=H.to(J.textEdit)),J.additionalTextEdits&&(ke.additionalTextEdits=J.additionalTextEdits.map(Oe=>H.to(Oe))),ke}Se.to=De;function he(J){return{label:J.label,textEdit:J.textEdit?H.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ke=>H.from(ke)):void 0}}Se.from=he})(Me=e.ColorPresentation||(e.ColorPresentation={}));var je;(function(Se){function De(J){return new r.Color(J[0],J[1],J[2],J[3])}Se.to=De;function he(J){return[J.red,J.green,J.blue,J.alpha]}Se.from=he})(je=e.Color||(e.Color={}));var Ye;(function(Se){function De(J){return{range:i.from(J.range)}}Se.from=De;function he(J){return new r.SelectionRange(i.to(J.range))}Se.to=he})(Ye=e.SelectionRange||(e.SelectionRange={}));var He;(function(Se){function De(he){switch(he){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Se.to=De})(He=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ke;(function(Se){function De(J){switch(J){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=De;function he(J){switch(J){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Se.to=he})(Ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Je;(function(Se){function De(J){if(J===r.EndOfLine.CRLF)return 1;if(J===r.EndOfLine.LF)return 0}Se.from=De;function he(J){if(J===1)return r.EndOfLine.CRLF;if(J===0)return r.EndOfLine.LF}Se.to=he})(Je=e.EndOfLine||(e.EndOfLine={}));var nt;(function(Se){function De(he){if(typeof he=="object")return he.viewId;switch(he){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=De})(nt=e.ProgressLocation||(e.ProgressLocation={}));var xe;(function(Se){function De(he){const J={start:he.start+1,end:he.end+1};return he.kind&&(J.kind=Ge.from(he.kind)),J}Se.from=De})(xe=e.FoldingRange||(e.FoldingRange={}));var Ge;(function(Se){function De(he){if(he)switch(he){case r.FoldingRangeKind.Comment:return p.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return p.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return p.FoldingRangeKind.Region}}Se.from=De})(Ge=e.FoldingRangeKind||(e.FoldingRangeKind={}));var et;(function(Se){function De(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?i.from(he.selection):void 0,override:typeof he.override=="boolean"?v.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=De})(et=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ue;(function(Se){function De(Oe){return Oe instanceof r.RelativePattern?Oe.toJSON():typeof Oe=="string"?Oe:he(Oe)||J(Oe)?new r.RelativePattern(Oe.baseUri??Oe.base,Oe.pattern).toJSON():Oe}Se.from=De;function he(Oe){const qe=Oe;return qe?g.URI.isUri(qe.baseUri)&&typeof qe.pattern=="string":!1}function J(Oe){const qe=Oe;return qe?typeof qe.base=="string"&&typeof qe.pattern=="string":!1}function ke(Oe){return typeof Oe=="string"?Oe:new r.RelativePattern(g.URI.revive(Oe.baseUri),Oe.pattern)}Se.to=ke})(ue=e.GlobPattern||(e.GlobPattern={}));var Ie;(function(Se){function De(he){if(he){if(Array.isArray(he))return he.map(De);if(typeof he=="string")return he;{const J=he;return{language:J.language,scheme:J.scheme,pattern:ue.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Se.from=De})(Ie=e.LanguageSelector||(e.LanguageSelector={}));var Ce;(function(Se){function De(J){return{start:J.start,end:J.end}}Se.from=De;function he(J){return new r.NotebookRange(J.start,J.end)}Se.to=he})(Ce=e.NotebookRange||(e.NotebookRange={}));var Le;(function(Se){function De(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Se.to=De;function he(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Se.from=he})(Le=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Ne;(function(Se){function De(he){if(he===d.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(he===d.NotebookCellExecutionState.Pending)return;if(he===d.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}Se.to=De})(Ne=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ze;(function(Se){function De(J){switch(J){case r.NotebookCellKind.Markup:return d.CellKind.Markup;case r.NotebookCellKind.Code:default:return d.CellKind.Code}}Se.from=De;function he(J){switch(J){case d.CellKind.Markup:return r.NotebookCellKind.Markup;case d.CellKind.Code:default:return r.NotebookCellKind.Code}}Se.to=he})(ze=e.NotebookCellKind||(e.NotebookCellKind={}));var Ve;(function(Se){function De(J){const ke={metadata:J.metadata??Object.create(null),cells:[]};for(const Oe of J.cells)r.NotebookCellData.validate(Oe),ke.cells.push(Xe.from(Oe));return ke}Se.from=De;function he(J){const ke=new r.NotebookData(J.cells.map(Xe.to));return(0,b.isEmptyObject)(J.metadata)||(ke.metadata=J.metadata),ke}Se.to=he})(Ve=e.NotebookData||(e.NotebookData={}));var Xe;(function(Se){function De(J){return{cellKind:ze.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:Le.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Ze.from):[]}}Se.from=De;function he(J){return new r.NotebookCellData(ze.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Ze.to):void 0,J.metadata,J.internalMetadata?Le.to(J.internalMetadata):void 0)}Se.to=he})(Xe=e.NotebookCellData||(e.NotebookCellData={}));var st;(function(Se){function De(J){return{mime:J.mime,valueBytes:k.VSBuffer.wrap(J.data)}}Se.from=De;function he(J){return new r.NotebookCellOutputItem(J.valueBytes.buffer,J.mime)}Se.to=he})(st=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ze;(function(Se){function De(J){return{outputId:J.id,items:J.items.map(st.from),metadata:J.metadata}}Se.from=De;function he(J){const ke=J.items.map(st.to);return new r.NotebookCellOutput(ke,J.outputId,J.metadata)}Se.to=he})(Ze=e.NotebookCellOutput||(e.NotebookCellOutput={}));var rt;(function(Se){function De(ke){return J(ke)?{include:(0,b.withNullAsUndefined)(ue.from(ke.include)),exclude:(0,b.withNullAsUndefined)(ue.from(ke.exclude))}:(0,b.withNullAsUndefined)(ue.from(ke))}Se.from=De;function he(ke){return J(ke)?{include:ue.to(ke.include),exclude:ue.to(ke.exclude)}:ue.to(ke)}Se.to=he;function J(ke){const Oe=ke;return Oe?!(0,b.isUndefinedOrNull)(Oe.include)&&!(0,b.isUndefinedOrNull)(Oe.exclude):!1}})(rt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var at;(function(Se){function De(he,J,ke){const Oe=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Oe,ke),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}Se.from=De})(at=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ct;(function(Se){function De(he,J,ke){const Oe=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:J.toInternal(Oe,ke),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}Se.from=De})(ct=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var bt;(function(Se){function De(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}Se.from=De})(bt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Nt;(function(Se){function De(J){return{uri:J.uri,provides:J.provides}}Se.from=De;function he(J){return new r.NotebookRendererScript(g.URI.revive(J.uri),J.provides)}Se.to=he})(Nt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var mt;(function(Se){function De(J){return{message:F.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,location:J.location&&{range:i.from(J.location.range),uri:J.location.uri}}}Se.from=De;function he(J){const ke=new r.TestMessage(typeof J.message=="string"?J.message:F.to(J.message));return ke.actualOutput=J.actual,ke.expectedOutput=J.expected,ke.location=J.location?q.to(J.location):void 0,ke}Se.to=he})(mt=e.TestMessage||(e.TestMessage={}));var St;(function(Se){Se.namespace=A.namespaceTestTag,Se.denamespace=A.denamespaceTestTag})(St=e.TestTag||(e.TestTag={}));var It;(function(Se){function De(J){const ke=(0,h.getPrivateApiFor)(J).controllerId;return{extId:D.TestId.fromExtHostTestItem(J,ke).toString(),label:J.label,uri:g.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Oe=>St.namespace(ke,Oe.id)),range:f.Range.lift(i.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&F.fromStrict(J.error)||null}}Se.from=De;function he(J){return{parent:void 0,error:void 0,id:D.TestId.fromString(J.extId).localId,label:J.label,uri:g.URI.revive(J.uri),tags:(J.tags||[]).map(ke=>{const{tagId:Oe}=St.denamespace(ke);return new r.TestTag(Oe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:i.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Se.toPlain=he})(It=e.TestItem||(e.TestItem={})),function(Se){function De(J){return{id:J.id}}Se.from=De;function he(J){return new r.TestTag(J.id)}Se.to=he}(St=e.TestTag||(e.TestTag={}));var At;(function(Se){const De=(J,ke)=>{const Oe=[];for(const[Be,tt]of ke)D.TestId.compare(tt.item.extId,Be)===2&&(ke.delete(Be),Oe.push(tt));const qe={...It.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(tt=>tt.type===0).map(mt.to)})),children:Oe.map(Be=>De(Be,ke))};for(const Be of qe.children)Be.parent=qe;return qe};function he(J){const ke=[],Oe=new Map;for(const qe of J.items){Oe.set(qe.item.extId,qe);const Be=D.TestId.root(qe.item.extId);J.request.targets.some(tt=>tt.controllerId===Be&&tt.testIds.includes(qe.item.extId))&&ke.push(qe)}return{completedAt:J.completedAt,results:ke.map(qe=>De(qe,Oe))}}Se.to=he})(At=e.TestResults||(e.TestResults={}));var Ct;(function(Se){function De(Oe){return{covered:Oe.covered,total:Oe.covered}}function he(Oe){return"line"in Oe?c.from(Oe):i.from(Oe)}function J(Oe){return"branches"in Oe?{count:Oe.executionCount,location:he(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(qe=>({count:qe.executionCount,location:qe.location&&he(qe.location)})):void 0}:{type:0,count:Oe.executionCount,location:he(Oe.location)}}Se.fromDetailed=J;function ke(Oe){return{uri:Oe.uri,statement:De(Oe.statementCoverage),branch:Oe.branchCoverage&&De(Oe.branchCoverage),function:Oe.functionCoverage&&De(Oe.functionCoverage),details:Oe.detailedCoverage?.map(J)}}Se.fromFile=ke})(Ct=e.TestCoverage||(e.TestCoverage={}));var Rt;(function(Se){function De(he){switch(he){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Se.to=De})(Rt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var gt;(function(Se){function De(J){const ke=new r.TypeHierarchyItem(te.to(J.kind),J.name,J.detail||"",g.URI.revive(J.uri),i.to(J.range),i.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}Se.to=De;function he(J,ke,Oe){if(ke=ke??J._sessionId,Oe=Oe??J._itemId,ke===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Oe,kind:te.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:i.from(J.range),selectionRange:i.from(J.selectionRange),tags:J.tags?.map(re.from)}}Se.from=he})(gt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Ft;(function(Se){function De(he){if(!!he)return{value:he.value,tooltip:he.tooltip}}Se.from=De})(Ft=e.ViewBadge||(e.ViewBadge={}));var ot;(function(Se){function De(Oe,qe,Be){const tt=qe.fileData;return tt?new class extends r.DataTransferItem{asFile(){return{name:tt.name,uri:g.URI.revive(tt.uri),data:(0,I.once)(()=>Be())}}}("",qe.id):Oe===T.Mimes.uriList&&qe.uriListData?new r.DataTransferItem(ke(qe.uriListData)):new r.DataTransferItem(qe.asString)}Se.to=De;async function he(Oe,qe){const Be=await qe.asString();if(Oe===T.Mimes.uriList)return{id:qe.id,asString:Be,fileData:void 0,uriListData:J(Be)};const tt=qe.asFile();return{id:qe.id,asString:Be,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Se.from=he;function J(Oe){return l.UriList.split(Oe).map(qe=>{if(qe.startsWith("#"))return qe;try{return g.URI.parse(qe)}catch{}return qe})}function ke(Oe){return l.UriList.create(Oe.map(qe=>typeof qe=="string"?qe:g.URI.revive(qe)))}})(ot=e.DataTransferItem||(e.DataTransferItem={}));var ht;(function(Se){function De(J,ke){const Oe=J.items.map(([qe,Be])=>[qe,ot.to(qe,Be,()=>ke(Be.id))]);return new r.DataTransfer(Oe)}Se.toDataTransfer=De;async function he(J){const ke={items:[]},Oe=[];return J.forEach((qe,Be)=>{Oe.push((async()=>{ke.items.push([Be,await ot.from(Be,qe)])})())}),await Promise.all(Oe),ke}Se.toDataTransferDTO=he})(ht=e.DataTransfer||(e.DataTransfer={}))}),define(ve[266],be([1,0,47,129,68,128,84,134,4]),function(ae,e,E,k,l,I,C,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const y=(d,D,A,t)=>{let r=D;return{enumerable:!0,configurable:!1,get(){return r},set(n){if(!A(r,n)){const i=r;r=n,d.listener?.(t(n,i))}}}},T=(d,D)=>d===D,S={range:(d,D)=>d===D?!0:!d||!D?!1:d.isEqual(D),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(d,D)=>!(d.length!==D.length||d.some(A=>!D.find(t=>A.id===t.id)))},b=d=>D=>({op:4,update:d(D)}),g=(d,D)=>({range:(()=>{let A;const t=b(r=>({range:E.Range.lift(P.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return A},set(r){d.listener?.({op:6}),S.range(A,r)||(A=r,d.listener?.(t(r)))}}})(),label:y(d,D,S.label,b(A=>({label:A}))),description:y(d,void 0,S.description,b(A=>({description:A}))),sortText:y(d,void 0,S.sortText,b(A=>({sortText:A}))),canResolveChildren:y(d,!1,S.canResolveChildren,A=>({op:2,state:A})),busy:y(d,!1,S.busy,b(A=>({busy:A}))),error:y(d,void 0,S.error,b(A=>({error:P.MarkdownString.fromStrict(A)||null}))),tags:y(d,[],S.tags,(A,t)=>({op:1,new:A.map(P.TestTag.from),old:t.map(P.TestTag.from)}))}),f=d=>{const D=l.TestId.fromString(d.extId),A=new u(D.controllerId,D.localId,d.label,w.URI.revive(d.uri)||void 0);return A.range=P.Range.to(d.range||void 0),A.description=d.description||void 0,A.sortText=d.sortText||void 0,A.tags=d.tags.map(t=>P.TestTag.to({id:(0,C.denamespaceTestTag)(t).tagId})),A},p=d=>{let D;for(const A of d.tests){const t=f(A.item);(0,k.getPrivateApiFor)(t).parent=D,D=t}return D};e.toItemFromContext=p;class u{constructor(D,A,t,r){if(A.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(A)} symbol`);const n=(0,k.createPrivateApiFor)(this,D);Object.defineProperties(this,{id:{value:A,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof h?void 0:n.parent}},children:{value:(0,I.createTestItemChildren)(n,k.getPrivateApiFor,u),enumerable:!0,writable:!1},...g(n,t)})}}e.TestItemImpl=u;class h extends u{constructor(D,A){super(D,D,A,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class v extends I.TestItemCollection{constructor(D,A,t){super({controllerId:D,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:k.getPrivateApiFor,getChildren:r=>r.children,root:new h(D,A),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(ve[267],be([1,0,33,197,50]),function(ae,e,E,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function I(C,P,w,y){const T=new Map;C.forEach(b=>{const g=E.ExtensionIdentifier.toKey(b.identifier),f=T.get(g);f&&y.warn((0,k.localize)(0,null,f.extensionLocation.fsPath,b.extensionLocation.fsPath)),T.set(g,b)}),P.forEach(b=>{const g=E.ExtensionIdentifier.toKey(b.identifier),f=T.get(g);if(f)if(f.isBuiltin){if(l.gte(f.version,b.version)){y.warn(`Skipping extension ${b.extensionLocation.path} in favour of the builtin extension ${f.extensionLocation.path}.`);return}b.isBuiltin=!0}else y.warn((0,k.localize)(1,null,f.extensionLocation.fsPath,b.extensionLocation.fsPath));else if(b.isBuiltin){y.warn(`Skipping obsolete builtin extension ${b.extensionLocation.path}`);return}T.set(g,b)}),w.forEach(b=>{y.info((0,k.localize)(2,null,b.extensionLocation.fsPath));const g=E.ExtensionIdentifier.toKey(b.identifier),f=T.get(g);f&&f.isBuiltin&&(b.isBuiltin=!0),T.set(g,b)});const S=[];return T.forEach(b=>S.push(b)),S}e.dedupExtensions=I}),define(ve[268],be([1,0,3,46,4,67,13,72,103,99,233,7,28,54,267]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class p{constructor(h,v,d,D,A,t,r){if(this.c=h,this.d=v,this.f=d,this.g=A,this.h=t,this.i=r,v.args["install-builtin-extension"]){const i={isMachineScoped:!!v.args["do-not-sync"],installPreReleaseVersion:!!v.args["pre-release"]};this.b=D.installExtensions([],v.args["install-builtin-extension"],i,!!v.args.force).then(null,o=>{A.error(o)})}else this.b=Promise.resolve();const n=v.args["install-extension"];if(n){const i=n.map(o=>/\.vsix$/i.test(o)?l.URI.file((0,S.isAbsolute)(o)?o:(0,S.join)((0,b.cwd)(),o)):o);this.b.then(()=>D.installExtensions(i,[],{isMachineScoped:!!v.args["do-not-sync"],installPreReleaseVersion:!!v.args["pre-release"]},!!v.args.force)).then(null,o=>{A.error(o)})}}async call(h,v,d){switch(v){case"getEnvironmentData":{const D=d,A=(0,I.createURITransformer)(D.remoteAuthority);let t=await this.k();return t=(0,P.transformOutgoingURIs)(t,A),t}case"getExtensionHostExitInfo":{const D=d;return this.h.getExitInfo(D.reconnectionToken)}case"whenExtensionsReady":{await this.b;return}case"scanExtensions":{await this.b;const D=d,A=D.language;this.g.trace(`Scanning extensions using UI language: ${A}`);const t=(0,I.createURITransformer)(D.remoteAuthority),r=D.extensionDevelopmentPath&&D.extensionDevelopmentPath.map(o=>l.URI.revive(t.transformIncoming(o))),n=r?r.filter(o=>o.scheme===C.Schemas.file).map(o=>o.fsPath):void 0;let i=await this.l(A,n);return i=(0,P.transformOutgoingURIs)(i,t),this.g.trace("Scanned Extensions",i),p.j(i),i}case"scanSingleExtension":{await this.b;const D=d,A=D.language,t=D.isBuiltin,r=(0,I.createURITransformer)(D.remoteAuthority),n=l.URI.revive(r.transformIncoming(D.extensionLocation)),i=n.scheme===C.Schemas.file?n.fsPath:null;if(!i)return null;let o=await this.p(i,t,A);return o?(o=(0,P.transformOutgoingURIs)(o,r),p.j([o]),o):null}case"getDiagnosticInfo":{const D=d,A={machineInfo:(0,T.getMachineInfo)()},t=D.includeProcesses?(0,y.listProcesses)(process.pid):Promise.resolve();let r=[];const n={};if(D.folders){const i=(0,I.createURITransformer)("");r=D.folders.map(c=>l.URI.revive(i.transformIncoming(c))).filter(c=>c.scheme==="file").map(c=>(0,T.collectWorkspaceStats)(c.fsPath,["node_modules",".git"]).then(a=>{n[(0,S.basename)(c.fsPath)]=a}))}return Promise.all([t,...r]).then(([i,o])=>(A.processes=i||void 0,A.workspaceMetadata=D.folders?n:void 0,A))}}throw new Error(`IPC Command ${v} not found`)}listen(h,v,d){throw new Error("Not supported")}static j(h){const v=(n,i)=>n.replace(/file/g,"vscode-remote"),d=n=>{let i="";return i+=n.global?"g":"",i+=n.ignoreCase?"i":"",i+=n.multiline?"m":"",new RegExp(v(n.source,!0),i)},D=new class{mapDefined(n){return w.ContextKeyDefinedExpr.create(n)}mapNot(n){return w.ContextKeyNotExpr.create(n)}mapEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?w.ContextKeyEqualsExpr.create(n,v(i,!1)):w.ContextKeyEqualsExpr.create(n,i)}mapNotEquals(n,i){return n==="resourceScheme"&&typeof i=="string"?w.ContextKeyNotEqualsExpr.create(n,v(i,!1)):w.ContextKeyNotEqualsExpr.create(n,i)}mapGreater(n,i){return w.ContextKeyGreaterExpr.create(n,i)}mapGreaterEquals(n,i){return w.ContextKeyGreaterEqualsExpr.create(n,i)}mapSmaller(n,i){return w.ContextKeySmallerExpr.create(n,i)}mapSmallerEquals(n,i){return w.ContextKeySmallerEqualsExpr.create(n,i)}mapRegex(n,i){return n==="resourceScheme"&&i?w.ContextKeyRegexExpr.create(n,d(i)):w.ContextKeyRegexExpr.create(n,i)}mapIn(n,i){return w.ContextKeyInExpr.create(n,i)}mapNotIn(n,i){return w.ContextKeyNotInExpr.create(n,i)}},A=n=>{if(!n||!n.when||!/resourceScheme/.test(n.when))return;const i=w.ContextKeyExpr.deserialize(n.when);if(!i)return;const o=i.map(D);n.when=o.serialize()},t=n=>{if(Array.isArray(n))for(const i of n)A(i);else A(n)},r=n=>{for(const i in n)t(n[i])};h.forEach(n=>{n.contributes&&(n.contributes.menus&&r(n.contributes.menus),n.contributes.keybindings&&t(n.contributes.keybindings),n.contributes.views&&r(n.contributes.views))})}async k(){return{pid:process.pid,connectionToken:this.c.type!==0?this.c.value:"",appRoot:l.URI.file(this.d.appRoot),settingsPath:this.d.machineSettingsResource,logsPath:l.URI.file(this.d.logsPath),extensionsPath:l.URI.file(this.d.extensionsPath),extensionHostLogsPath:l.URI.file((0,S.join)(this.d.logsPath,`exthost${p.a++}`)),globalStorageHome:this.f.defaultProfile.globalStorageHome,workspaceStorageHome:this.d.workspaceStorageHome,localHistoryHome:this.d.localHistoryHome,userHome:this.d.userHome,os:E.OS,arch:process.arch,marks:k.getMarks(),useHostProxy:!!this.d.args["use-host-proxy"]}}async l(h,v){const[d,D,A]=await Promise.all([this.n(h),this.o(h),this.m(h,v)]);return(0,f.dedupExtensions)(d,D,A,this.g)}async m(h,v){return v?(await Promise.all(v.map(d=>this.i.scanOneOrMultipleExtensions(l.URI.file((0,S.resolve)(d)),1,{language:h})))).flat().map(d=>(0,g.toExtensionDescription)(d,!0)):[]}async n(h){return(await this.i.scanSystemExtensions({language:h,useCache:!0})).map(d=>(0,g.toExtensionDescription)(d,!1))}async o(h){return(await this.i.scanUserExtensions({profileLocation:this.f.defaultProfile.extensionsResource,language:h,useCache:!0})).map(d=>(0,g.toExtensionDescription)(d,!1))}async p(h,v,d){const D=l.URI.file((0,S.resolve)(h)),A=v?0:1,t=await this.i.scanExistingExtension(D,A,{language:d});return t?(0,g.toExtensionDescription)(t,!1):null}}p.a=1,e.RemoteAgentEnvironmentChannel=p}),define(ve[135],be([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(w){this._proxyIdentifierBrand=void 0,this.sid=w,this.nid=++E.count}}E.count=0,e.ProxyIdentifier=E;const k=[];function l(P){const w=new E(P);return k[w.nid]=w,w}e.createProxyIdentifier=l;function I(P){return k[P].sid}e.getStringIdentifierForProxy=I;class C{constructor(w){this.value=w}}e.SerializableObjectWithBuffers=C}),define(ve[269],be([1,0,135]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var k;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var l;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(l=e.TabInputKind||(e.TabInputKind={}));var I;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(I=e.TabModelOperationKind||(e.TabModelOperationKind={}));var C;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(C=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var w;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(w=e.CellOutputKind||(e.CellOutputKind={}));var y;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(y=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var T;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(T=e.CandidatePortSource||(e.CandidatePortSource={}));class S{static mixin(u){return u._id=S.a++,u}}S.a=0,e.IdObject=S;var b;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})(b=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var g;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(g=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var f;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(f=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,E.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,E.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,E.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,E.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,E.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,E.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,E.createProxyIdentifier)("ExtHostLocalization")}});var Ot=this&&this.__classPrivateFieldSet||function(ae,e,E,k,l){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?l.call(ae,E):l?l.value=E:e.set(ae,E),E},it=this&&this.__classPrivateFieldGet||function(ae,e,E,k){if(E==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!k:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?k:E==="a"?k.call(ae):k?k.value:e.get(ae)};define(ve[270],be([1,0,8,133,134,23,269,18,12,48,47,92,4,2,5,256,266,15,135,37,93,40]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v,d,D,A){"use strict";var t,r;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let n=class{constructor(m,R){t.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),Ot(this,t,m.getProxy(C.MainContext.MainThreadCommands),"f"),this.d=R,Ot(this,r,m.getProxy(C.MainContext.MainThreadTelemetry),"f"),this.converter=new i(this,L=>{const $=this.c.get(L);return $?.result===c.Void?$:void 0},R),this.f=[{processArgument(L){return(0,y.revive)(L)}},{processArgument(L){return(0,I.cloneAndChange)(L,function($){if(T.Range.isIRange($))return l.Range.to($);if(S.Position.isIPosition($))return l.Position.to($);if(T.Range.isIRange($.range)&&b.URI.isUri($.uri))return l.location.to($);if($ instanceof h.VSBuffer)return $.buffer.buffer;if(!Array.isArray($))return $})}}]}registerArgumentProcessor(m){this.f.push(m)}registerApiCommand(m){const R=this.registerCommand(!1,m.id,async(...L)=>{const $=m.args.map((ne,F)=>{if(!ne.validate(L[F]))throw new Error(`Invalid argument '${ne.name}' when running '${m.id}', received: ${L[F]}`);return ne.convert(L[F])}),ie=await this.executeCommand(m.internalId,...$);return m.result.convert(ie,L,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this.c.set(m.id,m),new k.Disposable(()=>{R.dispose(),this.c.delete(m.id)})}registerCommand(m,R,L,$,ie,ne){if(this.d.trace("ExtHostCommands#registerCommand",R),!R.trim().length)throw new Error("invalid id");if(this.b.has(R))throw new Error(`command '${R}' already exists`);return this.b.set(R,{callback:L,thisArg:$,description:ie,extension:ne}),m&&it(this,t,"f").$registerCommand(R),new k.Disposable(()=>{this.b.delete(R)&&m&&it(this,t,"f").$unregisterCommand(R)})}executeCommand(m,...R){return this.d.trace("ExtHostCommands#executeCommand",m),this.g(m,R,!0)}async g(m,R,L){if(this.b.has(m))return it(this,t,"f").$fireCommandActivationEvent(m),this.h(m,R,!1);{let $=!1;const ie=(0,I.cloneAndChange)(R,function(ne){if(ne instanceof k.Position)return l.Position.from(ne);if(ne instanceof k.Range)return l.Range.from(ne);if(ne instanceof k.Location)return l.location.from(ne);if(k.NotebookRange.isNotebookRange(ne))return l.NotebookRange.from(ne);if(ne instanceof ArrayBuffer)return $=!0,h.VSBuffer.wrap(new Uint8Array(ne));if(ne instanceof Uint8Array)return $=!0,h.VSBuffer.wrap(ne);if(ne instanceof h.VSBuffer)return $=!0,ne;if(!Array.isArray(ne))return ne});try{const ne=await it(this,t,"f").$executeCommand(m,$?new v.SerializableObjectWithBuffers(ie):ie,L);return(0,y.revive)(ne)}catch(ne){if(ne instanceof Error&&ne.message==="$executeCommand:retry")return this.g(m,R,!1);throw ne}}}async h(m,R,L){const $=this.b.get(m);if(!$)throw new Error("Unknown command");const{callback:ie,thisArg:ne,description:F}=$;if(F)for(let z=0;z<F.args.length;z++)try{(0,E.validateConstraint)(R[z],F.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${F.args[z].name}' - ${F.args[z].description}`)}const _=D.StopWatch.create();try{return await ie.apply(ne,R)}catch(z){if(m===this.converter.delegatingCommandId){const x=this.converter.getActualCommand(...R);x&&(m=x.command)}throw this.d.error(z,m,$.extension?.identifier),L?new class extends Error{constructor(){super((0,d.toErrorMessage)(z)),this.id=m,this.source=$.extension?.displayName??$.extension?.name}}:z}finally{this.j($,m,_.elapsed())}}j(m,R,L){!m.extension||it(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:m.extension.identifier.value,id:new A.TelemetryTrustedValue(R),duration:L})}$executeContributedCommand(m,...R){this.d.trace("ExtHostCommands#$executeContributedCommand",m);const L=this.b.get(m);return L?(R=R.map($=>this.f.reduce((ie,ne)=>ne.processArgument(ie,L.extension?.identifier),$)),this.h(m,R,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this.d.trace("ExtHostCommands#getCommands",m),it(this,t,"f").$getCommands().then(R=>(m&&(R=R.filter(L=>L[0]!=="_")),R))}$getContributedCommandHandlerDescriptions(){const m=Object.create(null);for(const[R,L]of this.b){const{description:$}=L;$&&(m[R]=$)}return Promise.resolve(m)}};t=new WeakMap,r=new WeakMap,n=Re([Te(0,p.IExtHostRpcService),Te(1,w.ILogService)],n),e.ExtHostCommands=n,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class i{constructor(m,R,L){this.d=m,this.f=R,this.g=L,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(m,R){if(!m)return;const L={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return L;const $=this.f(m.command);if($)L.id=$.internalId,L.arguments=$.args.map((ie,ne)=>ie.convert(m.arguments&&m.arguments[ne]));else if((0,P.isNonEmptyArray)(m.arguments)){const ie=`${m.command}/${++this.c}`;this.b.set(ie,m),R.add((0,g.toDisposable)(()=>{this.b.delete(ie),this.g.trace("CommandsConverter#DISPOSE",ie)})),L.$ident=ie,L.id=this.delegatingCommandId,L.arguments=[ie],this.g.trace("CommandsConverter#CREATE",m.command,ie)}return L}fromInternal(m){return typeof m.$ident=="string"?this.b.get(m.$ident):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this.b.get(m[0])}h(...m){const R=this.getActualCommand(...m);return this.g.trace("CommandsConverter#EXECUTE",m[0],R?R.command:"MISSING"),R?this.d.executeCommand(R.command,...R.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${m[0]}`)}}e.CommandsConverter=i;class o{constructor(m,R,L,$){this.name=m,this.description=R,this.validate=L,this.convert=$}optional(){return new o(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,R){return new o(m??this.name,R??this.description,this.validate,this.convert)}}o.Uri=new o("uri","Uri of a text document",s=>b.URI.isUri(s),s=>s),o.Position=new o("position","A position in a text document",s=>k.Position.isPosition(s),l.Position.from),o.Range=new o("range","A range in a text document",s=>k.Range.isRange(s),l.Range.from),o.Selection=new o("selection","A selection in a text document",s=>k.Selection.isSelection(s),l.Selection.from),o.Number=new o("number","",s=>typeof s=="number",s=>s),o.String=new o("string","",s=>typeof s=="string",s=>s),o.CallHierarchyItem=new o("item","A call hierarchy item",s=>s instanceof k.CallHierarchyItem,l.CallHierarchyItem.from),o.TypeHierarchyItem=new o("item","A type hierarchy item",s=>s instanceof k.TypeHierarchyItem,l.TypeHierarchyItem.from),o.TestItem=new o("testItem","A VS Code TestItem",s=>s instanceof u.TestItemImpl,l.TestItem.from),e.ApiCommandArgument=o;class c{constructor(m,R){this.description=m,this.convert=R}}c.Void=new c("no result",s=>s),e.ApiCommandResult=c;class a{constructor(m,R,L,$,ie){this.id=m,this.internalId=R,this.description=L,this.args=$,this.result=ie}}e.ApiCommand=a}),define(ve[271],be([1,0,60,284,30,270,4,12,82]),function(ae,e,E,k,l,I,C,P,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class y{constructor(b,g,f){this.b=b,this.c=g,this.f=f,this.a=k.createServer((p,u)=>this.h(p,u)),this.g().catch(p=>(g.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",b=>this.c.error(b))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(b,g){const f=(u,h)=>{g.writeHead(u,{"content-type":"application/json"}),g.end(JSON.stringify(h||null),v=>v&&this.c.error(v))},p=[];b.setEncoding("utf8"),b.on("data",u=>p.push(u)),b.on("end",async()=>{try{const u=JSON.parse(p.join(""));let h;switch(u.type){case"open":h=await this.i(u);break;case"openExternal":h=await this.j(u);break;case"status":h=await this.l(u);break;case"extensionManagement":h=await this.k(u);break;default:f(404,`Unknown message type: ${u.type}`);break}f(200,h)}catch(u){const h=u instanceof Error?u.message:JSON.stringify(u);f(500,h),this.c.error("Error while processing pipe request",u)}})}async i(b){const{fileURIs:g,folderURIs:f,forceNewWindow:p,diffMode:u,mergeMode:h,addMode:v,forceReuseWindow:d,gotoLineMode:D,waitMarkerFilePath:A,remoteAuthority:t}=b,r=[];if(Array.isArray(f))for(const c of f)try{r.push({folderUri:C.URI.parse(c)})}catch{}if(Array.isArray(g))for(const c of g)try{(0,w.hasWorkspaceFileExtension)(c)?r.push({workspaceUri:C.URI.parse(c)}):r.push({fileUri:C.URI.parse(c)})}catch{}const n=A?C.URI.file(A):void 0,o={forceNewWindow:p,diffMode:u,mergeMode:h,addMode:v,gotoLineMode:D,forceReuseWindow:d,preferNewWindow:!d&&!n&&!v,waitMarkerFileURI:n,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",r,o),""}async j(b){for(const g of b.uris){const f=C.URI.parse(g),p=f.scheme==="file"?f:g;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k(b){const g=p=>p?.map(u=>/\.vsix$/i.test(u)?C.URI.parse(u):u),f={list:b.list,install:g(b.install),uninstall:g(b.uninstall),force:b.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",f)}async l(b){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&l.existsSync(this.f)&&l.unlinkSync(this.f)}}e.CLIServerBase=y;let T=class extends y{constructor(b,g){super(b,g,(0,E.createRandomIPCHandle)())}};T=Re([Te(0,I.IExtHostCommands),Te(1,P.ILogService)],T),e.CLIServer=T}),define(ve[272],be([1,0,31,6,23,2,7,3,4,60,67,271,118,81,259,261,132]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class h extends p.AbstractVariableResolverService{constructor(D,A,t,r,n){super({getFolderUri:i=>{const o=A.filter(c=>c.name===i);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>A.length,getConfigurationValue:(i,o)=>r[`config:${o}`],getExecPath:()=>D.VSCODE_EXEC_PATH,getAppRoot:()=>D.VSCODE_CWD,getFilePath:()=>{if(t)return C.normalize(t.fsPath)},getSelectedText:()=>r.selectedText,getLineNumber:()=>r.lineNumber,getExtension:async i=>{const c=(await n.getInstalled()).find(a=>a.identifier.id===i);return c&&{extensionLocation:c.location}}},void 0,Promise.resolve(E.homedir()),Promise.resolve(D))}}class v extends I.Disposable{constructor(D,A,t,r,n,i){super(),this.g=D,this.h=A,this.i=t,this.j=r,this.l=n,this.m=i,this.a=0,this.b=new Map,this.c=this.B(new k.Emitter),this.onExecuteCommand=this.c.event}async call(D,A,t){switch(A){case"$restartPtyHost":return this.i.restartPtyHost?.apply(this.i,t);case"$createProcess":{const r=(0,T.createURITransformer)(D.remoteAuthority);return this.n(r,t)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,t);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,t);case"$listProcesses":return this.i.listProcesses.apply(this.i,t);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,t);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables?.apply(this.i,t);case"$start":return this.i.start.apply(this.i,t);case"$input":return this.i.input.apply(this.i,t);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,t);case"$shutdown":return this.i.shutdown.apply(this.i,t);case"$resize":return this.i.resize.apply(this.i,t);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,t);case"$getCwd":return this.i.getCwd.apply(this.i,t);case"$processBinary":return this.i.processBinary.apply(this.i,t);case"$sendCommandResult":return this.r(t[0],t[1],t[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,t);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,t);case"$getDefaultSystemShell":return this.s.apply(this,t);case"$getProfiles":return this.t.apply(this,t);case"$getEnvironment":return this.u();case"$getWslPath":return this.w(t[0],t[1]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(t);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(t);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,t);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,t);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,t);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,t);case"$reduceConnectionGraceTime":return this.y();case"$updateIcon":return this.i.updateIcon.apply(this.i,t);case"$updateTitle":return this.i.updateTitle.apply(this.i,t);case"$updateProperty":return this.i.updateProperty.apply(this.i,t);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,t);case"$requestDetachInstance":return this.i.requestDetachInstance(t[0],t[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(t[0],t[1]);case"$freePortKillProcess":return this.i.freePortKillProcess?.apply(this.i,t)}throw new Error(`IPC Command ${A} not found`)}listen(D,A,t){switch(A){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||k.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||k.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||k.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||k.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||k.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||k.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty;default:break}throw new Error("Not supported")}async n(D,A){const t={name:A.shellLaunchConfig.name,executable:A.shellLaunchConfig.executable,args:A.shellLaunchConfig.args,cwd:typeof A.shellLaunchConfig.cwd=="string"||typeof A.shellLaunchConfig.cwd>"u"?A.shellLaunchConfig.cwd:w.URI.revive(D.transformIncoming(A.shellLaunchConfig.cwd)),env:A.shellLaunchConfig.env,useShellEnvironment:A.shellLaunchConfig.useShellEnvironment,reconnectionProperties:A.shellLaunchConfig.reconnectionProperties,type:A.shellLaunchConfig.type,isFeatureTerminal:A.shellLaunchConfig.isFeatureTerminal},r=await(0,u.buildUserEnvironment)(A.resolverEnv,!!A.shellLaunchConfig.useShellEnvironment,P.language,this.g,this.h,this.m);this.h.trace("baseEnv",r);const n=z=>({uri:w.URI.revive(D.transformIncoming(z.uri)),name:z.name,index:z.index,toResource:()=>{throw new Error("Not implemented")}}),i=A.workspaceFolders.map(n),o=A.activeWorkspaceFolder?n(A.activeWorkspaceFolder):void 0,c=A.activeFileResource?w.URI.revive(D.transformIncoming(A.activeFileResource)):void 0,a=new h(r,i,c,A.resolvedVariables,this.l),s=f.createVariableResolver(o,process.env,a),m=await f.getCwd(t,E.homedir(),s,o?.uri,A.configuration["terminal.integrated.cwd"],this.h);t.cwd=m;const R=P.isWindows?"terminal.integrated.env.windows":P.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",L=A.configuration[R],$=await f.createTerminalEnvironment(t,L,s,this.j.version,A.configuration["terminal.integrated.detectLocale"],r);if(!t.strictEnv){const z=[];for(const[Ee,Y]of A.envVariableCollections)z.push([Ee,{map:(0,g.deserializeEnvironmentVariableCollection)(Y)}]);const x=new Map(z);await new b.MergedEnvironmentVariableCollection(x).applyToProcessEnvironment($,s)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:t,initialCwd:m,cols:A.cols,rows:A.rows,env:$});const ie=(0,y.createRandomIPCHandle)();$.VSCODE_IPC_HOOK_CLI=ie;const ne=await this.i.createProcess(t,m,A.cols,A.rows,A.unicodeVersion,$,r,A.options,A.shouldPersistTerminal,A.workspaceId,A.workspaceName),F={executeCommand:(z,...x)=>this.p(ne,z,x,D)},_=new S.CLIServerBase(F,this.h,ie);return this.i.onProcessExit(z=>z.id===ne&&_.dispose()),{persistentTerminalId:ne,resolvedShellLaunchConfig:t}}p(D,A,t,r){let n,i;const o=new Promise((s,m)=>{n=s,i=m}),c=++this.a;this.b.set(c,{resolve:n,reject:i,uriTransformer:r});const a=(0,l.cloneAndChange)(t,s=>{if(s&&s.$mid===1)return r.transformOutgoing(s);if(s&&s instanceof w.URI)return r.transformOutgoingURI(s)});return this.c.fire({reqId:c,persistentProcessId:D,commandId:A,commandArgs:a}),o}r(D,A,t){const r=this.b.get(D);if(!r)return;this.b.delete(D);const n=(0,l.cloneAndChange)(t,i=>{if(i&&i.$mid===1)return r.uriTransformer.transformIncoming(i)});A?r.reject(n):r.resolve(n)}s(D){return this.i.getDefaultSystemShell(D)}async t(D,A,t,r){return this.i.getProfiles?.(D,A,t,r)||[]}u(){return{...process.env}}w(D,A){return this.i.getWslPath(D,A)}y(){return this.i.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=v}),define(ve[136],be([1,0,5]),function(ae,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(ve[273],be([1,0,9,2,13,211]),function(ae,e,E,k,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class C extends I.DiskFileSystemProviderClient{static register(w,y,T){const S=w.getConnection();if(!S)return k.Disposable.None;const b=new k.DisposableStore,g=(async()=>{try{const f=await w.getRawEnvironment();f?y.registerProvider(l.Schemas.vscodeRemote,b.add(new C(f,S))):T.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(f){T.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,E.getErrorMessage)(f))}})();return b.add(y.onWillActivateFileSystemProvider(f=>{f.scheme===l.Schemas.vscodeRemote&&f.join(g)})),b}constructor(w,y){super(y.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:w.os===3})}}e.RemoteFileSystemProviderClient=C}),define(ve[137],be([1,0,30,14,7,8,21,168,285,286]),function(ae,e,E,k,l,I,C,P,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class T extends Error{constructor(t,r){let n=r.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=t,this.cause=r}}e.ExtractError=T;function S(A){const t=A.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,n)=>r+n,t&61440)}function b(A){if(A instanceof T)return A;let t;return/end of central directory record signature not found/.test(A.message)&&(t="CorruptZip"),new T(t,A)}function g(A,t,r,n,i,o){const c=l.dirname(t),a=l.join(n,c);if(!a.startsWith(n))return Promise.reject(new Error(P.localize(0,null,t)));const s=l.join(n,t);let m;return o.onCancellationRequested(()=>{m?.destroy()}),Promise.resolve(C.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((R,L)=>{if(!o.isCancellationRequested)try{m=(0,E.createWriteStream)(s,{mode:r}),m.once("close",()=>R()),m.once("error",L),A.once("error",L),A.pipe(m)}catch($){L($)}}))}function f(A,t,r,n){let i=(0,k.createCancelablePromise)(()=>Promise.resolve()),o=0;return n.onCancellationRequested(()=>{i.cancel(),A.close()}),new Promise((c,a)=>{const s=new k.Sequencer,m=R=>{R.isCancellationRequested||(o++,A.readEntry())};A.once("error",a),A.once("close",()=>i.then(()=>{n.isCancellationRequested||A.entryCount===o?c():a(new T("Incomplete",new Error(P.localize(1,null,o,A.entryCount))))},a)),A.readEntry(),A.on("entry",R=>{if(n.isCancellationRequested)return;if(!r.sourcePathRegex.test(R.fileName)){m(n);return}const L=R.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(L)){const ne=l.join(t,L);i=(0,k.createCancelablePromise)(F=>C.Promises.mkdir(ne,{recursive:!0}).then(()=>m(F)).then(void 0,a));return}const $=u(A,R),ie=S(R);i=(0,k.createCancelablePromise)(ne=>s.queue(()=>$.then(F=>g(F,L,ie,t,r,ne).then(()=>m(ne)))).then(null,a))})})}function p(A,t=!1){return new Promise((r,n)=>{(0,w.open)(A,t?{lazyEntries:!0}:void 0,(i,o)=>{i?n(b(i)):r((0,I.assertIsDefined)(o))})})}function u(A,t){return new Promise((r,n)=>{A.openReadStream(t,(i,o)=>{i?n(b(i)):r((0,I.assertIsDefined)(o))})})}function h(A,t){return new Promise((r,n)=>{const i=new y.ZipFile;t.forEach(c=>{c.contents?i.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&i.addFile(c.localPath,c.path)}),i.end();const o=(0,E.createWriteStream)(A);i.outputStream.pipe(o),i.outputStream.once("error",n),o.once("error",n),o.once("finish",()=>r(A))})}e.zip=h;function v(A,t,r={},n){const i=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=p(A,!0);return r.overwrite&&(o=o.then(c=>C.Promises.rm(t).then(()=>c))),o.then(c=>f(c,t,{sourcePathRegex:i},n))}e.extract=v;function d(A,t){return p(A).then(r=>new Promise((n,i)=>{r.on("entry",o=>{o.fileName===t&&u(r,o).then(c=>n(c),c=>i(c))}),r.once("close",()=>i(new Error(P.localize(2,null,t))))}))}function D(A,t){return d(A,t).then(r=>new Promise((n,i)=>{const o=[];r.once("error",i),r.on("data",c=>o.push(c)),r.on("end",()=>n(Buffer.concat(o)))}))}e.buffer=D}),define(ve[274],be([1,0,137,178]),function(ae,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function l(I){return(0,E.buffer)(I,"extension/package.json").then(C=>{try{return JSON.parse(C.toString("utf8"))}catch{throw new Error((0,k.localize)(0,null))}})}e.getManifest=l}),define(ve[138],be([1,0,14,19,37,9,6,2,27,13,7,3,20,50,8,4,22,21,137,177,75,25,249,32,35,42,54,234,250,274,226,235,33,73,17,5,12,26,29,36,34]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v,d,D,A,t,r,n,i,o,c,a,s,m,R,L,$,ie,ne,F,_,z,x,le){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,ne.refineServiceDecorator)(r.IExtensionManagementService);let Ee=class extends t.AbstractExtensionManagementService{constructor(j,N,M,q,ee,fe,W,K,Z,V,Q,G){super(j,N,M,V,G),this.Z=ee,this.ab=fe,this.bb=W,this.cb=Z,this.db=Q,this.X=this.B(new C.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new w.ResourceSet;const X=this.B(K.createInstance(a.ExtensionsLifecycle));this.S=this.B(K.createInstance(Y,pe=>X.postUninstall(pe))),this.U=this.B(new m.ExtensionsManifestCache(q,this)),this.W=this.B(K.createInstance(c.ExtensionsDownloader));const ce=this.B(new R.ExtensionsWatcher(this,this.Z,G,fe,Q,Z,M));this.B(ce.onDidChangeExtensionsByAnotherSource(pe=>this.kb(pe))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,n.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(j){this.v.trace("ExtensionManagementService#zip",j.identifier.id);const N=await this.jb(j),M=await(0,v.zip)((0,b.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)()).fsPath,N);return p.URI.file(M)}async unzip(j){return this.v.trace("ExtensionManagementService#unzip",j.toString()),(await this.install(j)).identifier}async getManifest(j){const{location:N,cleanup:M}=await this.fb(j),q=T.resolve(N.fsPath);try{return await(0,s.getManifest)(q)}finally{await M()}}getInstalled(j,N){return this.S.scanExtensions(j??null,N)}getAllUserInstalled(){return this.S.scanAllUserExtensions(!1)}async install(j,N={}){this.v.trace("ExtensionManagementService#install",j.toString());const{location:M,cleanup:q}=await this.fb(j);try{const ee=await(0,s.getManifest)(T.resolve(M.fsPath));if(ee.engines&&ee.engines.vscode&&!(0,$.isEngineValid)(ee.engines.vscode,this.w.version,this.w.date))throw new Error(d.localize(0,null,(0,n.getGalleryExtensionId)(ee.publisher,ee.name),this.w.version));return await this.z(ee,M,N)}finally{await q()}}async installFromLocation(j,N){this.v.trace("ExtensionManagementService#installFromLocation",j.toString());const M=await this.S.scanUserExtensionAtLocation(j);if(!M)throw new Error(`Cannot find a valid extension from the location ${j.toString()}`);return await this.ob([M],N),this.v.info("Successfully installed extension",M.identifier.id,N.toString()),M}getMetadata(j,N=this.y.defaultProfile.extensionsResource){return this.S.scanMetadata(j,N)}async updateMetadata(j,N,M=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",j.identifier.id),N.isPreReleaseVersion&&(N.preRelease=!0),N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.pinned=N.pinned||void 0,j=await this.S.updateMetadata(j,N,M),this.U.invalidate(),this.X.fire(j),j}async reinstallFromGallery(j){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",j.identifier.id),!this.t.isEnabled())throw new Error(d.localize(1,null));const N=await this.getTargetPlatform(),[M]=await this.t.getExtensions([{...j.identifier,preRelease:j.preRelease}],{targetPlatform:N,compatible:!0},k.CancellationToken.None);if(!M)throw new Error(d.localize(2,null));await this.S.setUninstalled(j);try{await this.S.removeUninstalledExtension(j)}catch(q){throw new Error(d.localize(3,null,(0,l.toErrorMessage)(q)))}return this.installFromGallery(M)}markAsUninstalled(...j){return this.S.setUninstalled(...j)}removeUninstalledExtensions(){return this.S.cleanUp()}async download(j,N){const{location:M}=await this.W.download(j,N);return M}async fb(j){if(j.scheme===y.Schemas.file)return{location:j,async cleanup(){}};this.v.trace("Downloading extension from",j.toString());const N=(0,b.joinPath)(this.W.extensionsDownloadDir,(0,u.generateUuid)());return await this.bb.download(j,N),this.v.info("Downloaded extension to",N.toString()),{location:N,cleanup:async()=>{try{await this.cb.del(N)}catch(q){this.v.error(q)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(j,N,M){let q;if(p.URI.isUri(N))q=new te(j,N,M,this.t,this.S,this.v);else{const ee=n.ExtensionKey.create(N).toString();q=this.Y.get(ee),q||(this.Y.set(ee,q=new U(j,N,M,this.W,this.S,this.v)),q.waitUntilTaskIsFinished().then(()=>this.Y.delete(ee)))}return new re(q,M.profileLocation,this.db,this.y,this.Z,this.ab)}R(j,N){return new de(j,N.profileLocation,this.ab)}async jb(j){const N=async q=>{let ee=await h.Promises.readdir(q);ee=ee.map(K=>T.join(q,K));const fe=await Promise.all(ee.map(K=>h.Promises.stat(K)));let W=Promise.resolve([]);return fe.forEach((K,Z)=>{const V=ee[Z];K.isFile()&&(W=W.then(Q=>[...Q,V])),K.isDirectory()&&(W=W.then(Q=>N(V).then(G=>[...Q,...G])))}),W};return(await N(j.location.fsPath)).map(q=>({path:`extension/${T.relative(j.location.fsPath,q)}`,localPath:q}))}async kb({added:j,removed:N}){if(N)for(const M of N.extensions)this.v.info("Extensions removed from another source",M.id,N.profileLocation.toString()),this.p.fire({identifier:M,profileLocation:N.profileLocation});if(j){const q=(await this.S.scanExtensions(1,j.profileLocation)).filter(ee=>j.extensions.some(fe=>(0,n.areSameExtensions)(fe,ee.identifier)));this.m.fire(q.map(ee=>(this.v.info("Extensions added from another source",ee.identifier.id,j.profileLocation.toString()),{identifier:ee.identifier,local:ee,profileLocation:j.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(N=>this.lb.add(N)));const j=await this.cb.resolve(this.Z.userExtensionsLocation);for(const N of j.children??[])N.isDirectory&&this.lb.add(N.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(N=>this.nb(N)))}async nb(j){if(!j.affects(this.Z.userExtensionsLocation,1))return;const N=[];for(const M of j.rawAdded){if(this.lb.has(M)||!this.db.extUri.isEqual(this.db.extUri.dirname(M),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(M,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(M).startsWith(".")||!(await this.cb.stat(M)).isDirectory)continue;const q=await this.S.scanUserExtensionAtLocation(M);q&&q.installedTimestamp===void 0&&(this.lb.add(M),N.push(q))}N.length&&(await this.ob(N,this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",N.map(M=>M.identifier.id)))}async ob(j,N){await this.ab.addExtensionsToProfile(j.map(M=>[M,void 0]),N),this.m.fire(j.map(M=>({local:M,identifier:M.identifier,operation:1,profileLocation:N})))}};Ee=Re([Te(0,r.IExtensionGalleryService),Te(1,z.ITelemetryService),Te(2,F.ILogService),Te(3,A.INativeEnvironmentService),Te(4,o.IExtensionsScannerService),Te(5,i.IExtensionsProfileScannerService),Te(6,D.IDownloadService),Te(7,ne.IInstantiationService),Te(8,ie.IFileService),Te(9,_.IProductService),Te(10,x.IUriIdentityService),Te(11,le.IUserDataProfilesService)],Ee),e.ExtensionManagementService=Ee;let Y=class extends P.Disposable{constructor(j,N,M,q,ee){super(),this.j=j,this.k=N,this.l=M,this.m=q,this.n=ee,this.h=this.B(new C.Emitter),this.onExtract=this.h.event,this.c=(0,b.joinPath)(this.l.userExtensionsLocation,".obsolete").fsPath,this.g=new E.Queue}async cleanUp(){await this.w()}async scanExtensions(j,N){const M={includeInvalid:!0,profileLocation:N};let q=[];return j===null||j===0?q.push(...await this.l.scanAllExtensions({includeInvalid:!0},M,!1)):j===1&&q.push(...await this.l.scanUserExtensions(M)),q=j!==null?q.filter(ee=>ee.type===j):q,Promise.all(q.map(ee=>this.v(ee)))}async scanAllUserExtensions(j){const N=await this.l.scanUserExtensions({includeAllVersions:!j,includeInvalid:!0});return Promise.all(N.map(M=>this.v(M)))}async scanUserExtensionAtLocation(j){try{const N=await this.l.scanExistingExtension(j,1,{includeInvalid:!0});if(N)return await this.v(N)}catch(N){this.n.error(N)}return null}async extractUserExtension(j,N,M,q){const ee=j.toString(),fe=T.join(this.l.userExtensionsLocation.fsPath,`.${(0,u.generateUuid)()}`),W=T.join(this.l.userExtensionsLocation.fsPath,ee);try{await h.Promises.rm(W)}catch{throw new r.ExtensionManagementError(d.localize(4,null,W,j.id),r.ExtensionManagementErrorCode.Delete)}await this.s(j,N,fe,q),await this.l.updateMetadata(p.URI.file(fe),M);try{this.h.fire(p.URI.file(W)),await this.t(j,fe,W,Date.now()+2*60*1e3),this.n.info("Renamed to",W)}catch(K){try{await h.Promises.rm(fe)}catch{}if(K.code==="ENOTEMPTY")this.n.info("Rename failed because extension was installed by another source. So ignoring renaming.",j.id);else throw this.n.info(`Rename failed because of ${(0,I.getErrorMessage)(K)}. Deleted from extracted location`,fe),K}return this.u(p.URI.file(W),1)}async scanMetadata(j,N){return N?(await this.m.scanProfileExtensions(N)).find(q=>(0,n.areSameExtensions)(q.identifier,j.identifier))?.metadata:this.l.scanMetadata(j.location)}async updateMetadata(j,N,M){return M?await this.m.updateMetadata([[j,N]],M):await this.l.updateMetadata(j.location,N),this.u(j.location,j.type)}getUninstalledExtensions(){return this.p()}async setUninstalled(...j){const N=j.map(M=>n.ExtensionKey.create(M));await this.p(M=>N.forEach(q=>{M[q.toString()]=!0,this.n.info("Marked extension as uninstalled",q.toString())}))}async setInstalled(j){await this.p(q=>delete q[j.toString()]);const M=(await this.scanAllUserExtensions(!0)).find(q=>n.ExtensionKey.create(q).equals(j))||null;return M?this.updateMetadata(M,{installedTimestamp:Date.now()}):null}async removeExtension(j,N){this.n.trace(`Deleting ${N} extension from disk`,j.identifier.id,j.location.fsPath),await h.Promises.rm(j.location.fsPath),this.n.info("Deleted from disk",j.identifier.id,j.location.fsPath)}async removeUninstalledExtension(j){await this.removeExtension(j,"uninstalled"),await this.p(N=>delete N[n.ExtensionKey.create(j).toString()])}async p(j){return this.g.queue(async()=>{let N;try{N=await h.Promises.readFile(this.c,"utf8")}catch(q){if(q.code!=="ENOENT")throw q}let M={};if(N)try{M=JSON.parse(N)}catch{}return j&&(j(M),Object.keys(M).length?await h.Promises.writeFile(this.c,JSON.stringify(M)):await h.Promises.rm(this.c)),M})}async s(j,N,M,q){this.n.trace(`Started extracting the extension from ${N} to ${M}`);try{await h.Promises.rm(M)}catch(ee){throw new r.ExtensionManagementError(this.y(ee).message,r.ExtensionManagementErrorCode.Delete)}try{await(0,v.extract)(N,M,{sourcePath:"extension",overwrite:!0},q),this.n.info(`Extracted extension to ${M}:`,j.id)}catch(ee){try{await h.Promises.rm(M)}catch{}let fe=r.ExtensionManagementErrorCode.Extract;throw ee instanceof v.ExtractError&&(ee.type==="CorruptZip"?fe=r.ExtensionManagementErrorCode.CorruptZip:ee.type==="Incomplete"&&(fe=r.ExtensionManagementErrorCode.IncompleteZip)),new r.ExtensionManagementError(ee.message,fe)}}async t(j,N,M,q){try{await h.Promises.rename(N,M)}catch(ee){if(S.isWindows&&ee&&ee.code==="EPERM"&&Date.now()<q)return this.n.info(`Failed renaming ${N} to ${M} with 'EPERM' error. Trying again...`,j.id),this.t(j,N,M,q);throw new r.ExtensionManagementError(ee.message||d.localize(5,null,N,M),ee.code||r.ExtensionManagementErrorCode.Rename)}}async u(j,N){const M=await this.l.scanExistingExtension(j,N,{includeInvalid:!0});if(M)return this.v(M);throw new Error(d.localize(6,null,j.path))}async v(j){const N=await this.k.resolve(j.location);let M,q;return N.children&&(M=N.children.find(({name:ee})=>/^readme(\.txt|\.md|)$/i.test(ee))?.resource,q=N.children.find(({name:ee})=>/^changelog(\.txt|\.md|)$/i.test(ee))?.resource),{identifier:j.identifier,type:j.type,isBuiltin:j.isBuiltin||!!j.metadata?.isBuiltin,location:j.location,manifest:j.manifest,targetPlatform:j.targetPlatform,validations:j.validations,isValid:j.isValid,readmeUrl:M,changelogUrl:q,publisherDisplayName:j.metadata?.publisherDisplayName||null,publisherId:j.metadata?.publisherId||null,isApplicationScoped:!!j.metadata?.isApplicationScoped,isMachineScoped:!!j.metadata?.isMachineScoped,isPreReleaseVersion:!!j.metadata?.isPreReleaseVersion,preRelease:!!j.metadata?.preRelease,installedTimestamp:j.metadata?.installedTimestamp,updated:!!j.metadata?.updated,pinned:!!j.metadata?.pinned}}async w(){const j=await this.getUninstalledExtensions(),N=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),M=new Set;for(const fe of N)j[n.ExtensionKey.create(fe).toString()]||M.add(fe.identifier.id.toLowerCase());const q=(0,n.groupByExtension)(N,fe=>fe.identifier);await E.Promises.settled(q.map(async fe=>{const W=fe.sort((K,Z)=>g.rcompare(K.manifest.version,Z.manifest.version))[0];M.has(W.identifier.id.toLowerCase())||await this.j(await this.v(W))}));const ee=N.filter(fe=>fe.metadata&&j[n.ExtensionKey.create(fe).toString()]);await E.Promises.settled(ee.map(fe=>this.removeUninstalledExtension(fe)))}y(j){const N=Array.isArray(j)?j:[j];return N.length===1?N[0]instanceof Error?N[0]:new Error(N[0]):N.reduce((M,q)=>new Error(`${M.message}${M.message?",":""}${q instanceof Error?q.message:q}`),new Error(""))}};Y=Re([Te(1,ie.IFileService),Te(2,o.IExtensionsScannerService),Te(3,i.IExtensionsProfileScannerService),Te(4,F.ILogService)],Y),e.ExtensionsScanner=Y;class H extends t.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,f.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(j,N,M,q,ee){super(),this.identifier=j,this.source=N,this.l=M,this.m=q,this.n=ee,this.j="Unverified",this.k=2}async o(j,N){try{const M=await this.p(j.key);if(M)return this.m.updateMetadata(M,j.metadata)}catch{throw S.isMacintosh?new r.ExtensionManagementError(d.localize(7,null),r.ExtensionManagementErrorCode.Internal):new r.ExtensionManagementError(d.localize(8,null),r.ExtensionManagementErrorCode.Internal)}return this.s(j,N)}async p(j){if(!await this.q(j))return null;this.n.trace("Removing the extension from uninstalled list:",j.id);const M=await this.m.setInstalled(j);return this.n.info("Removed the extension from uninstalled list:",j.id),M}async q(j){return!!(await this.m.getUninstalledExtensions())[j.toString()]}async s({zipPath:j,key:N,metadata:M},q){const ee=await this.m.extractUserExtension(N,j,M,q);return this.n.info("Extracting completed.",N.id),ee}}class U extends H{constructor(j,N,M,q,ee,fe){super(N.identifier,N,M,ee,fe),this.t=j,this.u=N,this.v=q}async h(j){const M=(await this.m.scanExtensions(null,this.l.profileLocation)).find(W=>(0,n.areSameExtensions)(W.identifier,this.u.identifier));M&&(this.k=3);const q={id:this.u.identifier.uuid,publisherId:this.u.publisherId,publisherDisplayName:this.u.publisherDisplayName,targetPlatform:this.u.properties.targetPlatform,isApplicationScoped:(0,L.isApplicationScopedExtension)(this.t),isMachineScoped:this.l.isMachineScoped||M?.isMachineScoped,isBuiltin:this.l.isBuiltin||M?.isBuiltin,isSystem:M?.type===0?!0:void 0,updated:!!M,isPreReleaseVersion:this.u.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.u.properties.isPreReleaseVersion||((0,f.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:M?.preRelease)};if(M?.manifest.version===this.u.version)return{local:await this.m.updateMetadata(M,q),metadata:q};const{location:ee,verificationStatus:fe}=await this.v.download(this.u,this.k);try{return this.j=fe,this.x(ee.fsPath),{local:await this.o({zipPath:ee.fsPath,key:n.ExtensionKey.create(this.u),metadata:q},j),metadata:q}}catch(W){try{await this.v.delete(ee)}catch(K){this.n.warn("Error while deleting the downloaded file",ee.toString(),(0,I.getErrorMessage)(K))}throw W}}async x(j){try{await(0,s.getManifest)(j)}catch(N){throw new r.ExtensionManagementError((0,t.joinErrors)(N).message,r.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=U;class te extends H{constructor(j,N,M,q,ee,fe){super({id:(0,n.getGalleryExtensionId)(j.publisher,j.name)},N,M,ee,fe),this.t=j,this.u=N,this.v=q}async h(j){const N=new n.ExtensionKey(this.identifier,this.t.version),q=(await this.m.scanExtensions(1,this.l.profileLocation)).find(W=>(0,n.areSameExtensions)(this.identifier,W.identifier)),ee=await this.x(this.identifier.id,this.t.version,j);if(ee.isApplicationScoped=(0,L.isApplicationScopedExtension)(this.t),ee.isMachineScoped=this.l.isMachineScoped||q?.isMachineScoped,ee.isBuiltin=this.l.isBuiltin||q?.isBuiltin,ee.installedTimestamp=Date.now(),ee.pinned=this.l.installGivenVersion?!0:void 0,q)if(this.k=3,N.equals(new n.ExtensionKey(q.identifier,q.manifest.version)))try{await this.m.removeExtension(q,"existing")}catch{throw new Error(d.localize(9,null,this.t.displayName||this.t.name))}else!this.l.profileLocation&&g.gt(q.manifest.version,this.t.version)&&await this.m.setUninstalled(q);else{const W=await this.p(N);if(W)try{await this.m.removeExtension(W,"existing")}catch{throw new Error(d.localize(10,null,this.t.displayName||this.t.name))}}return{local:await this.o({zipPath:T.resolve(this.u.fsPath),key:N,metadata:ee},j),metadata:ee}}async x(j,N,M){try{let[q]=await this.v.getExtensions([{id:j,version:N}],M);if(q||([q]=await this.v.getExtensions([{id:j}],M)),q)return{id:q.identifier.uuid,publisherDisplayName:q.publisherDisplayName,publisherId:q.publisherId,isPreReleaseVersion:q.properties.isPreReleaseVersion,preRelease:q.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class re{get operation(){return this.d.operation}get verificationStatus(){return this.d.verificationStatus}constructor(j,N,M,q,ee,fe){this.d=j,this.g=N,this.h=M,this.j=q,this.k=ee,this.l=fe,this.identifier=this.d.identifier,this.source=this.d.source,this.c=this.m()}async m(){const j=await this.d.waitUntilTaskIsFinished();return this.h.extUri.isEqual(this.j.defaultProfile.extensionsResource,this.g)&&await this.k.initializeDefaultProfileExtensions(),await this.l.addExtensionsToProfile([[j.local,j.metadata]],this.g),j}async run(){return await this.d.run(),this.c}waitUntilTaskIsFinished(){return this.c}cancel(){return this.d.cancel()}}class de extends t.AbstractExtensionTask{constructor(j,N,M){super(),this.extension=j,this.j=N,this.k=M}async h(j){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ve[139],be([1,0,79,14,15,9,2,8,24,25,80,12,229,287]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let f=class extends C.Disposable{constructor(u,h,v){super(),this.h=u,this.i=h,this.j=v,this.k(),this.B(u.onDidChangeConfiguration(d=>{d.affectsConfiguration("http")&&this.k()}))}k(){const u=this.h.getValue("http");this.a=u?.proxy,this.b=!!u?.proxyStrictSSL,this.f=u?.proxyAuthorization}async request(u,h){this.j.trace("RequestService#request (node) - begin",u.url);const{a:v,b:d}=this;let D;try{D=await(0,T.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(r){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",r))}const A={...process.env,...D},t=u.agent?u.agent:await(0,b.getProxyAgent)(u.url||"",A,{proxyUrl:v,strictSSL:d});u.agent=t,u.strictSSL=d,this.f&&(u.headers={...u.headers||{},"Proxy-Authorization":this.f});try{const r=await this.m(u,h);return this.j.trace("RequestService#request (node) - success",u.url),r}catch(r){throw this.j.trace("RequestService#request (node) - error",u.url,r),r}}async l(u){return((0,E.parse)(u.url).protocol==="https:"?await new Promise((d,D)=>{ae(["https"],d,D)}):await new Promise((d,D)=>{ae(["http"],d,D)})).request}m(u,h){return k.Promises.withAsyncBody(async(v,d)=>{const D=(0,E.parse)(u.url),A=u.getRawRequest?u.getRawRequest(u):await this.l(u),t={hostname:D.hostname,port:D.port?parseInt(D.port):D.protocol==="https:"?443:80,protocol:D.protocol,path:D.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,P.isBoolean)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(t.auth=u.user+":"+u.password);const r=A(t,n=>{const i=(0,P.isNumber)(u.followRedirects)?u.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this.m({...u,url:n.headers.location,followRedirects:i-1},h).then(v,d);else{let o=n;!u.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,g.createGunzip)())),v({res:n,stream:(0,l.streamToBufferReadableStream)(o)})}});r.on("error",d),u.timeout&&r.setTimeout(u.timeout),u.isChromiumNetwork&&r.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&r.write(u.data),r.end(),h.onCancellationRequested(()=>{r.abort(),d(new I.CancellationError)})})}async resolveProxy(u){}};f=Re([Te(0,w.IConfigurationService),Te(1,y.INativeEnvironmentService),Te(2,S.ILogService)],f),e.RequestService=f}),define(ve[275],be([1,0,77,12,62,111,24,53,139,40,29,32,122,138,76,105,51,2,106,64,13,17,26,109,136,43,114,78,115,9,4,7,28,227,75,36,120,61,3,54,126,34,42,65,123,121,108]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v,d,D,A,t,r,n,i,o,c,a,s,m,R,L,$,ie,ne,F,_,z,x,le,Ee,Y,H,U,te,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class de extends h.Disposable{constructor(M,q){super(),this.a=M,this.b=q,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const M=await this.f();await M.invokeFunction(async q=>{const ee=q.get(k.ILogService);try{await this.g(M.createInstance(o.ExtensionManagementCLI))}catch(fe){throw ee.error(fe),console.error((0,s.getErrorMessage)(fe)),fe}})}async f(){const M=new E.ServiceCollection,q={_serviceBrand:void 0,...u.default};M.set(t.IProductService,q);const ee=new i.ServerEnvironmentService(this.a,q);M.set(i.IServerEnvironmentService,ee);const fe=new re.LogService(new r.SpdLogLogger(n.RemoteExtensionLogFileName,(0,R.join)(ee.logsPath,`${n.RemoteExtensionLogFileName}.log`),!0,!1,(0,k.getLogLevel)(ee)));M.set(k.ILogService,fe),fe.trace(`Remote configuration data at ${this.b}`),fe.trace("process arguments:",this.a);const W=this.B(new v.FileService(fe));M.set(A.IFileService,W),W.registerProvider(D.Schemas.file,this.B(new d.DiskFileSystemProvider(fe)));const K=new F.UriIdentityService(W);M.set(ne.IUriIdentityService,K);const Z=this.B(new U.ServerUserDataProfilesService(K,ee,W,fe));M.set(Ee.IUserDataProfilesService,Z);const V=this.B(new I.ConfigurationService(Z.defaultProfile.settingsResource,W,new H.NullPolicyService,fe));return await V.initialize(),M.set(C.IConfigurationService,V),M.set(P.IRequestService,new l.SyncDescriptor(w.RequestService)),M.set(ie.IDownloadService,new l.SyncDescriptor($.DownloadService)),M.set(T.ITelemetryService,y.NullTelemetryService),M.set(S.IExtensionGalleryService,new l.SyncDescriptor(b.ExtensionGalleryServiceWithNoStorageService)),M.set(Y.IExtensionsProfileScannerService,new l.SyncDescriptor(te.ExtensionsProfileScannerService)),M.set(x.IExtensionsScannerService,new l.SyncDescriptor(le.ExtensionsScannerService)),M.set(f.IExtensionSignatureVerificationService,new l.SyncDescriptor(f.ExtensionSignatureVerificationService)),M.set(g.INativeServerExtensionManagementService,new l.SyncDescriptor(g.ExtensionManagementService)),M.set(c.ILanguagePackService,new l.SyncDescriptor(a.NativeLanguagePackService)),new p.InstantiationService(M)}async g(M){if(this.a["list-extensions"])return M.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const q={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return M.installExtensions(this.h(this.a["install-extension"]||[]),this.a["install-builtin-extension"]||[],q,!!this.a.force)}else{if(this.a["uninstall-extension"])return M.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return M.locateExtension(this.a["locate-extension"])}}h(M){return M.map(q=>/\.vsix$/i.test(q)?m.URI.file((0,R.isAbsolute)(q)?q:(0,R.join)((0,L.cwd)(),q)):q)}}function oe(N){setTimeout(()=>process.exit(N),0)}async function j(N,M,q){if(N.help){const fe=u.default.serverApplicationName+(z.isWindows?".cmd":"");console.log((0,_.buildHelpMessage)(u.default.nameLong,fe,u.default.version,q,{noInputFiles:!0,noPipe:!0}));return}if(N.version){console.log((0,_.buildVersionMessage)(u.default.version,u.default.commit));return}const ee=new de(N,M);try{await ee.run(),oe(0)}catch{oe(1)}finally{ee.dispose()}}e.run=j}),define(ve[276],be([1,0,31,6,2,13,7,96,21,41,24,111,74,223,198,75,199,209,218,25,122,32,76,114,210,138,17,106,64,62,105,77,78,115,12,51,26,53,228,139,113,29,40,241,119,248,36,120,268,257,232,239,272,67,43,263,136,273,124,54,126,42,34,65,240,221,4,123,121,108,107,194]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v,d,D,A,t,r,n,i,o,c,a,s,m,R,L,$,ie,ne,F,_,z,x,le,Ee,Y,H,U,te,re,de,oe,j,N,M,q,ee,fe,W,K,Z,V,Q,G,X,ce,pe,Pe,Ae,Fe,$e,me,we,ye,Me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const je="monacoworkbench";async function Ye(ue,Ie,Ce,Le){const Ne=new R.ServiceCollection,ze=new Je,Ve={_serviceBrand:void 0,...ne.default};Ne.set(F.IProductService,Ve);const Xe=new fe.ServerEnvironmentService(Ie,Ve);Ne.set(d.IEnvironmentService,Xe),Ne.set(d.INativeEnvironmentService,Xe);const st=new Ae.LoggerService((0,ie.getLogLevel)(Xe));Ne.set(ie.ILoggerService,st),ze.registerChannel("logger",new ye.LoggerChannel(st,ot=>Ke(ot.remoteAuthority)));const Ze=st.createLogger(Fe.URI.file(C.join(Xe.logsPath,`${K.RemoteExtensionLogFileName}.log`)),{id:"remoteServerLog",name:(0,Me.localize)(0,null)}),rt=new we.LogService(Ze,[new nt((0,ie.getLogLevel)(Xe))]);Ne.set(ie.ILogService,rt),setTimeout(()=>et(Xe.logsPath).then(null,ot=>rt.error(ot)),1e4),rt.trace(`Remote configuration data at ${Ce}`),rt.trace("process arguments:",Xe.args),Array.isArray(Ve.serverGreeting)&&rt.info(`

${Ve.serverGreeting.join(`
`)}

`),ze.registerChannel(f.ExtensionHostDebugBroadcastChannel.ChannelName,new f.ExtensionHostDebugBroadcastChannel);const at=new y.StaticRouter(ot=>ot.clientId==="renderer"),ct=Le.add(new c.FileService(rt));Ne.set(o.IFileService,ct),ct.registerProvider(I.Schemas.file,Le.add(new a.DiskFileSystemProvider(rt)));const bt=new de.UriIdentityService(ct);Ne.set(re.IUriIdentityService,bt);const Nt=new $e.ServerUserDataProfilesService(bt,Xe,ct,rt);Ne.set(ce.IUserDataProfilesService,Nt);const mt=new S.ConfigurationService(Xe.machineSettingsResource,ct,new pe.NullPolicyService,rt);Ne.set(T.IConfigurationService,mt),await mt.initialize();const St=new V.ExtensionHostStatusService;Ne.set(V.IExtensionHostStatusService,St),Ne.set(_.IRequestService,new s.SyncDescriptor(x.RequestService));let It=Y.NullAppender;const At=await(0,P.getMachineId)(),Ct=(0,Y.isInternalTelemetry)(Ve,mt);if((0,Y.supportsTelemetry)(Ve,Xe)){Ve.aiConfig&&Ve.aiConfig.ariaKey&&(It=new Pe.OneDataSystemAppender(Ct,je,null,Ve.aiConfig.ariaKey),Le.add((0,l.toDisposable)(()=>It?.flush())));const ot={appenders:[It],commonProperties:(0,le.resolveCommonProperties)(ct,(0,E.release)(),(0,E.hostname)(),process.arch,Ve.commit,Ve.version+"-remote",At,Ct,Xe.installSourcePath,"remoteAgent"),piiPaths:(0,Y.getPiiPathsFromEnvironment)(Xe)},ht=Xe.args["telemetry-level"];let Se=3;ht==="all"?Se=3:ht==="error"?Se=2:ht==="crash"?Se=1:ht!==void 0&&(Se=0),Ne.set(M.IServerTelemetryService,new s.SyncDescriptor(M.ServerTelemetryService,[ot,Se]))}else Ne.set(M.IServerTelemetryService,M.ServerNullTelemetryService);Ne.set(A.IExtensionGalleryService,new s.SyncDescriptor(D.ExtensionGalleryServiceWithNoStorageService));const Rt=ze.getChannel("download",at);Ne.set(p.IDownloadService,new u.DownloadServiceChannelClient(Rt,()=>Ke("renderer"))),Ne.set(X.IExtensionsProfileScannerService,new s.SyncDescriptor(me.ExtensionsProfileScannerService)),Ne.set(Q.IExtensionsScannerService,new s.SyncDescriptor(G.ExtensionsScannerService)),Ne.set(t.IExtensionSignatureVerificationService,new s.SyncDescriptor(t.ExtensionSignatureVerificationService)),Ne.set(i.INativeServerExtensionManagementService,new s.SyncDescriptor(i.ExtensionManagementService));const gt=new m.InstantiationService(Ne);Ne.set(L.ILanguagePackService,gt.createInstance($.NativeLanguagePackService));const Ft=gt.createInstance(te.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:mt.getValue("terminal.integrated.persistentSessionScrollback")??100},(0,Me.localize)(1,null));return Ne.set(U.IPtyService,Ft),Ne.set(h.IEncryptionMainService,new s.SyncDescriptor(v.EncryptionMainService,[At])),Ne.set(b.ICredentialsMainService,new s.SyncDescriptor(g.CredentialsWebMainService)),gt.invokeFunction(ot=>{const ht=ot.get(i.INativeServerExtensionManagementService),Se=ot.get(Q.IExtensionsScannerService),De=new oe.RemoteAgentEnvironmentChannel(ue,Xe,Nt,gt.createInstance(r.ExtensionManagementCLI),rt,St,Se);ze.registerChannel("remoteextensionsenvironment",De);const he=new N.ServerTelemetryChannel(ot.get(M.IServerTelemetryService),It);ze.registerChannel("telemetry",he),ze.registerChannel(W.REMOTE_TERMINAL_CHANNEL_NAME,new q.RemoteTerminalChannel(Xe,rt,Ft,Ve,ht,mt));const J=new j.RemoteAgentFileSystemProviderChannel(rt,Xe);ze.registerChannel(Z.REMOTE_FILE_SYSTEM_CHANNEL_NAME,J),ze.registerChannel("request",new z.RequestChannel(ot.get(_.IRequestService)));const ke=new n.ExtensionManagementChannel(ht,Be=>Ke(Be.remoteAuthority));ze.registerChannel("extensions",ke);const Oe=y.ProxyChannel.fromService(ot.get(h.IEncryptionMainService));ze.registerChannel("encryption",Oe);const qe=y.ProxyChannel.fromService(ot.get(b.ICredentialsMainService));return ze.registerChannel("credentials",qe),ht.removeUninstalledExtensions(),Le.add(new H.default(ot.get(Ee.ITelemetryService))),{telemetryService:ot.get(Ee.ITelemetryService)}}),{socketServer:ze,instantiationService:gt}}e.setupServerServices=Ye;const He=Object.create(null);function Ke(ue){return He[ue]||(He[ue]=(0,ee.createURITransformer)(ue)),He[ue]}class Je extends y.IPCServer{constructor(){const Ie=new k.Emitter;super(Ie.event),this.b=Ie}acceptConnection(Ie,Ce){this.b.fire({protocol:Ie,onDidClientDisconnect:Ce})}}e.SocketServer=Je;class nt extends ie.AbstractLogger{constructor(Ie=ie.DEFAULT_LOG_LEVEL){super(),this.setLevel(Ie),this.g=Boolean(process.stdout.isTTY)}trace(Ie,...Ce){this.f(ie.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${xe()}]\x1B[0m`,Ie,...Ce):console.log(`[${xe()}]`,Ie,...Ce))}debug(Ie,...Ce){this.f(ie.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${xe()}]\x1B[0m`,Ie,...Ce):console.log(`[${xe()}]`,Ie,...Ce))}info(Ie,...Ce){this.f(ie.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${xe()}]\x1B[0m`,Ie,...Ce):console.log(`[${xe()}]`,Ie,...Ce))}warn(Ie,...Ce){this.f(ie.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${xe()}]\x1B[0m`,Ie,...Ce):console.warn(`[${xe()}]`,Ie,...Ce))}error(Ie,...Ce){this.f(ie.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${xe()}]\x1B[0m`,Ie,...Ce):console.error(`[${xe()}]`,Ie,...Ce))}dispose(){}flush(){}}function xe(){const ue=new Date;return`${Ge(ue.getHours())}:${Ge(ue.getMinutes())}:${Ge(ue.getSeconds())}`}function Ge(ue){return ue<10?`0${ue}`:String(ue)}async function et(ue){const Ie=C.basename(ue),Ce=C.dirname(ue),ze=(await w.Promises.readdir(Ce)).filter(Xe=>/^\d{8}T\d{6}$/.test(Xe)).sort().filter(Xe=>Xe!==Ie),Ve=ze.slice(0,Math.max(0,ze.length-9));await Promise.all(Ve.map(Xe=>w.Promises.rm(C.join(Ce,Xe))))}}),define(ve[277],be([1,0,116,30,91,278,79,140,15,9,38,2,13,7,46,3,16,4,22,149,100,60,5,12,26,66,29,132,252,253,43,276,255]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b,g,f,p,u,h,v,d,D,A,t,r,n,i,o,c,a,s,m,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=void 0;const $=5*60*1e3;let ie=class extends S.Disposable{constructor(z,x,le,Ee,Y,H,U,te){super(),this.k=z,this.l=x,this.m=le,this.n=Y,this.p=H,this.r=U,this.s=te,this.h=F.create(this.p),this.i=(0,i.getRemoteServerRootPath)(H),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=Ee?this.s.createInstance(L.WebClientServer,this.l):null,this.r.info("Extension host agent started."),this.F(!0)}async handleRequest(z,x){if(z.method!=="GET")return(0,L.serveError)(z,x,405,`Unsupported method ${z.method}`);if(!z.url)return(0,L.serveError)(z,x,400,"Bad request.");const le=C.parse(z.url,!0);let Ee=le.pathname;if(!Ee)return(0,L.serveError)(z,x,400,"Bad request.");if(Ee.startsWith(this.i)&&Ee.charCodeAt(this.i.length)===47&&(Ee=Ee.substring(this.i.length)),Ee==="/version")return x.writeHead(200,{"Content-Type":"text/plain"}),void x.end(this.p.commit||"");if(Ee==="/delay-shutdown")return this.H(),x.writeHead(200),void x.end("OK");if(!(0,s.requestHasValidConnectionToken)(this.l,z,le))return(0,L.serveError)(z,x,403,"Forbidden.");if(Ee==="/vscode-remote-resource"){const Y=le.query.path;if(typeof Y!="string")return(0,L.serveError)(z,x,400,"Bad request.");let H;try{H=h.URI.from({scheme:b.Schemas.file,path:Y}).fsPath}catch{return(0,L.serveError)(z,x,400,"Bad request.")}const U=Object.create(null);this.n.isBuilt&&((0,T.isEqualOrParent)(H,this.n.builtinExtensionsPath,!p.isLinux)||(0,T.isEqualOrParent)(H,this.n.extensionsPath,!p.isLinux))&&(U["Cache-Control"]="public, max-age=31536000"),U.Vary="Origin";const te=z.headers.origin;return te&&this.h.matches(te)&&(U["Access-Control-Allow-Origin"]=te),(0,L.serveFile)(H,1,this.r,z,x,U)}if(this.g){this.g.handle(z,x,le);return}return x.writeHead(404,{"Content-Type":"text/plain"}),void x.end("Not found")}handleUpgrade(z,x){let le=(0,v.generateUuid)(),Ee=!1,Y=!1;if(z.url){const oe=C.parse(z.url,!0).query;typeof oe.reconnectionToken=="string"&&(le=oe.reconnectionToken),oe.reconnection==="true"&&(Ee=!0),oe.skipWebSocketFrames==="true"&&(Y=!0)}if(z.headers.upgrade===void 0||z.headers.upgrade.toLowerCase()!=="websocket"){x.end("HTTP/1.1 400 Bad Request");return}const H=z.headers["sec-websocket-key"],U=E.createHash("sha1");U.update(H+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const te=U.digest("base64"),re=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${te}`];let de=!1;if(!Y&&!this.n.args["disable-websocket-compression"]&&z.headers["sec-websocket-extensions"]){const oe=Array.isArray(z.headers["sec-websocket-extensions"])?z.headers["sec-websocket-extensions"]:[z.headers["sec-websocket-extensions"]];for(const j of oe)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(j)){if(/\b(permessage-deflate)\b/.test(j)){de=!0,re.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(j)){de=!0,re.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}x.write(re.join(`\r
`)+`\r
\r
`),x.setTimeout(0),x.setNoDelay(!0),Y?this.v(new A.NodeSocket(x,`server-connection-${le}`),Ee,le):this.v(new A.WebSocketNodeSocket(new A.NodeSocket(x,`server-connection-${le}`),de,null,!0),Ee,le)}handleServerError(z){this.r.error("Error occurred in server"),this.r.error(z)}t(z){let x;return z instanceof A.NodeSocket?x=z.socket:x=z.socket.socket,x.remoteAddress||"<unknown>"}async u(z,x,le){const Ee=x.getSocket();this.r.error(`${z} ${le}.`);const Y={type:"error",reason:le};x.sendControl(w.VSBuffer.fromString(JSON.stringify(Y))),x.dispose(),await Ee.drain(),Ee.dispose()}v(z,x,le){const Ee=this.t(z),Y=`[${Ee}][${le.substr(0,8)}]`,H=new D.PersistentProtocol({socket:z}),U=this.m?new this.m.validator:null,te=this.m?new this.m.signer:null;let re;(function(N){N[N.WaitingForAuth=0]="WaitingForAuth",N[N.WaitingForConnectionType=1]="WaitingForConnectionType",N[N.Done=2]="Done",N[N.Error=3]="Error"})(re||(re={}));let de=0;const oe=N=>{de=3,j.dispose(),this.u(Y,H,N)},j=H.onControlMessage(N=>{if(de===0){let M;try{M=JSON.parse(N.toString())}catch{return oe("Malformed first message")}if(M.type!=="auth")return oe("Invalid first message");if(this.l.type===2&&!this.l.validate(M.auth))return oe("Unauthorized client refused: auth mismatch");let q=(0,v.generateUuid)();if(te)try{q=te.sign(M.data)}catch{}let ee=(0,v.generateUuid)();if(U)try{ee=U.createNewMessage(ee)}catch{}const fe={type:"sign",data:ee,signedData:q};H.sendControl(w.VSBuffer.fromString(JSON.stringify(fe))),de=1}else if(de===1){let M;try{M=JSON.parse(N.toString())}catch{return oe("Malformed second message")}if(M.type!=="connectionType")return oe("Invalid second message");if(typeof M.signedData!="string")return oe("Invalid second message field type");const q=M.commit,ee=this.p.commit;if(q&&ee&&q!==ee)return oe("Client refused: version mismatch");let fe=!1;if(!U)fe=!0;else if(this.l.validate(M.signedData))fe=!0;else try{fe=U.validate(M.signedData)==="ok"}catch{}if(!fe){if(this.n.isBuilt)return oe("Unauthorized client refused");this.r.error(`${Y} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const W in this.b)this.b[W].shortenReconnectionGraceTimeIfNecessary();for(const W in this.a)this.a[W].shortenReconnectionGraceTimeIfNecessary();de=2,j.dispose(),this.w(Ee,Y,H,z,x,le,M)}})}async w(z,x,le,Ee,Y,H,U){const te=U.desiredConnectionType===1?`${x}[ManagementConnection]`:U.desiredConnectionType===2?`${x}[ExtensionHostConnection]`:x;if(U.desiredConnectionType===1)if(Y){if(!this.b[H])return this.f.has(H)?this.u(te,le,"Unknown reconnection token (seen before)"):this.u(te,le,"Unknown reconnection token (never seen)");le.sendControl(w.VSBuffer.fromString(JSON.stringify({type:"ok"})));const re=le.readEntireBuffer();le.dispose(),this.b[H].acceptReconnection(z,Ee,re)}else{if(this.b[H])return this.u(te,le,"Duplicate reconnection token");le.sendControl(w.VSBuffer.fromString(JSON.stringify({type:"ok"})));const re=new a.ManagementConnection(this.r,H,z,le);this.k.acceptConnection(re.protocol,re.onClose),this.b[H]=re,this.f.add(H),re.onClose(()=>{delete this.b[H]})}else if(U.desiredConnectionType===2){const re=U.args||{language:"en"},de=await this.C(re);if(de.port&&this.r.trace(`${te} - startParams debug port ${de.port}`),this.r.trace(`${te} - startParams language: ${de.language}`),this.r.trace(`${te} - startParams env: ${JSON.stringify(de.env)}`),Y){if(!this.a[H])return this.f.has(H)?this.u(te,le,"Unknown reconnection token (seen before)"):this.u(te,le,"Unknown reconnection token (never seen)");le.sendPause(),le.sendControl(w.VSBuffer.fromString(JSON.stringify(de.port?{debugPort:de.port}:{})));const oe=le.readEntireBuffer();le.dispose(),this.a[H].acceptReconnection(z,Ee,oe)}else{if(this.a[H])return this.u(te,le,"Duplicate reconnection token");le.sendPause(),le.sendControl(w.VSBuffer.fromString(JSON.stringify(de.port?{debugPort:de.port}:{})));const oe=le.readEntireBuffer();le.dispose();const j=this.s.createInstance(c.ExtensionHostConnection,H,z,Ee,oe);this.a[H]=j,this.f.add(H),j.onClose(()=>{delete this.a[H],this.D()}),j.start(de)}}else if(U.desiredConnectionType===3){const re=U.args;this.y(le,re)}else return this.u(te,le,"Unknown initial data received")}async y(z,x){const le=z.getSocket().socket,Ee=z.readEntireBuffer();z.dispose(),le.pause();const Y=await this.z(x.host,x.port);Ee.byteLength>0&&Y.write(Ee.buffer),Y.on("end",()=>le.end()),Y.on("close",()=>le.end()),Y.on("error",()=>le.destroy()),le.on("end",()=>Y.end()),le.on("close",()=>Y.end()),le.on("error",()=>Y.destroy()),Y.pipe(le),le.pipe(Y)}z(z,x){return new Promise((le,Ee)=>{const Y=l.createConnection({host:z,port:x},()=>{Y.removeListener("error",Ee),Y.pause(),le(Y)});Y.once("error",Ee)})}C(z){return typeof z.port=="number"?(0,d.findFreePort)(z.port,10,5e3).then(x=>(z.port=x,z)):(z.debugId=void 0,z.port=void 0,z.break=void 0,Promise.resolve(z))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F(z=!1){!this.n.args["enable-remote-auto-shutdown"]||(this.n.args["remote-auto-shutdown-without-delay"]&&!z?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},$))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};ie=Re([Te(4,m.IServerEnvironmentService),Te(5,n.IProductService),Te(6,r.ILogService),Te(7,t.IInstantiationService)],ie);async function ne(_,z,x){const le=await(0,s.determineServerConnectionToken)(z);le instanceof s.ServerConnectionTokenParseError&&(console.warn(le.message),process.exit(1));const Ee=new S.DisposableStore,{socketServer:Y,instantiationService:H}=await(0,R.setupServerServices)(le,z,x,Ee);let U=!1;H.invokeFunction(q=>{const ee=q.get(r.ILogService);(0,y.setUnexpectedErrorHandler)(fe=>{(0,y.isSigPipeError)(fe)&&fe.stack&&/unexpectedErrorHandler/.test(fe.stack)||ee.error(fe)}),process.on("SIGPIPE",()=>{U||(U=!0,(0,y.onUnexpectedError)(new Error("Unexpected SIGPIPE")))})}),H.invokeFunction(q=>{const ee=q.get(r.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const fe=(0,g.join)(process.env.HOMEDRIVE,"node_modules"),W=(0,g.dirname)((0,g.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),K=(0,g.join)(W,"node_modules");if(k.existsSync(fe)||k.existsSync(K)){const Z=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${fe}
* ${K}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;ee.warn(Z),console.warn(Z),process.exit(0)}}});const te=H.invokeFunction(q=>{const ee=q.get(r.ILogService);if(k.existsSync((0,g.join)(b.FileAccess.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(W){ee.error(W)}return null}),re=k.existsSync(b.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(re&&_&&typeof _!="string"){const q=le.type!==0?`?${b.connectionTokenQueryName}=${le.value}`:"";console.log(`Web UI available at http://localhost${_.port===80?"":`:${_.port}`}/${q}`)}const de=H.createInstance(ie,Y,le,te,re);f.mark("code/server/ready");const oe=I.performance.now(),j=global.vscodeServerStartTime,N=global.vscodeServerListenTime,M=global.vscodeServerCodeLoadedTime;if(H.invokeFunction(q=>{q.get(o.ITelemetryService).publicLog2("serverStart",{startTime:j,startedTime:N,codeLoadedTime:M,readyTime:oe})}),z["print-startup-performance"]){const q=P.LoaderStats.get();let ee="";ee+=`

### Load AMD-module
`,ee+=P.LoaderStats.toMarkdownTable(["Module","Duration"],q.amdLoad),ee+=`

### Load commonjs-module
`,ee+=P.LoaderStats.toMarkdownTable(["Module","Duration"],q.nodeRequire),ee+=`

### Invoke AMD-module factory
`,ee+=P.LoaderStats.toMarkdownTable(["Module","Duration"],q.amdInvoke),ee+=`

### Invoke commonjs-module
`,ee+=P.LoaderStats.toMarkdownTable(["Module","Duration"],q.nodeEval),ee+=`Start-up time: ${N-j}
`,ee+=`Code loading time: ${M-j}
`,ee+=`Initialized time: ${oe-j}
`,ee+=`
`,console.log(ee)}return de}e.createServer=ne;class F{static create(z){const x=z.webEndpointUrlTemplate,le=z.commit,Ee=z.quality;if(!x||!le||!Ee)return new F(null);const Y=(0,v.generateUuid)(),U=new URL(x.replace("{{uuid}}",Y).replace("{{commit}}",le).replace("{{quality}}",Ee)).origin,te=(0,u.escapeRegExpCharacters)(U).replace(Y,"[a-zA-Z0-9\\-]+");try{const re=(0,u.createRegExp)(`^${te}$`,!0,{matchCase:!1});return new F(re)}catch{return new F(null)}}constructor(z){this.a=z}matches(z){return this.a?this.a.test(z):!1}}}),define(ve[288],be([1,0,31,30,13,275,277,61,7,278,43,51,46]),function(ae,e,E,k,l,I,C,P,w,y,T,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,b.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=y.performance.now();const g={onMultipleValues:(i,o)=>{console.error(`Option '${i}' can only be defined once. Using value ${o}.`)},onEmptyValue:i=>{console.error(`Ignoring option '${i}': Value must not be empty.`)},onUnknownOption:i=>{console.error(`Ignoring option '${i}': not supported for server.`)},onDeprecatedOption:(i,o)=>{console.warn(`Option '${i}' is deprecated: ${o}`)}},f=(0,P.parseArgs)(process.argv.slice(2),T.serverOptions,g),p=f["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,w.join)(E.homedir(),S.default.serverDataFolderName||".vscode-remote"),u=(0,w.join)(p,"data"),h=(0,w.join)(u,"User"),v=(0,w.join)(h,"globalStorage"),d=(0,w.join)(h,"History"),D=(0,w.join)(u,"Machine");f["user-data-dir"]=u;const A=(0,w.dirname)(l.FileAccess.asFileUri("").fsPath),t=(0,w.join)(A,"extensions");f["builtin-extensions-dir"]=t,f["extensions-dir"]=f["extensions-dir"]||(0,w.join)(p,"extensions"),[p,f["extensions-dir"],u,h,D,v,d].forEach(i=>{try{k.existsSync(i)||k.mkdirSync(i,{mode:448})}catch(o){console.error(o)}});function r(){(0,I.run)(f,p,T.serverOptions)}e.spawnCli=r;function n(i){return(0,C.createServer)(i,f,p)}e.createServer=n})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/441438abd1ac652551dbe4d408dfcec8a499b8bf/core/vs/server/node/server.main.js.map
